import t from "@firebase/app";

import { __spreadArrays as n, __extends as i, __assign as e, __awaiter as r, __generator as u } from "tslib";

import { Logger as s, LogLevel as o } from "@firebase/logger";

import { getUA as h, isMobileCordova as c, isReactNative as a, isElectron as f, isIE as l, isUWP as d, isBrowserExtension as v } from "@firebase/util";

import { Component as w } from "@firebase/component";

import { XhrIo as m, EventType as p, ErrorCode as g, createWebChannelTransport as b, WebChannel as y } from "@firebase/webchannel-wrapper";

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** The semver (www.semver.org) version of the SDK. */ var _, I = t.SDK_VERSION, T = new s("@firebase/firestore");

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Helper methods are needed because variables can't be exported as read/write
function E() {
    return T.logLevel === o.DEBUG ? _.DEBUG : T.logLevel === o.SILENT ? _.SILENT : _.ERROR;
}

function R(t) {
    /**
     * Map the new log level to the associated Firebase Log Level
     */
    switch (t) {
      case _.DEBUG:
        T.logLevel = o.DEBUG;
        break;

      case _.ERROR:
        T.logLevel = o.ERROR;
        break;

      case _.SILENT:
        T.logLevel = o.SILENT;
        break;

      default:
        T.error("Firestore (" + I + "): Invalid value passed to `setLogLevel`");
    }
}

function A(t, i) {
    for (var e = [], r = 2; r < arguments.length; r++) e[r - 2] = arguments[r];
    if (T.logLevel <= o.DEBUG) {
        var u = e.map(P);
        T.debug.apply(T, n([ "Firestore (" + I + ") [" + t + "]: " + i ], u));
    }
}

function D(t) {
    for (var i = [], e = 1; e < arguments.length; e++) i[e - 1] = arguments[e];
    if (T.logLevel <= o.ERROR) {
        var r = i.map(P);
        T.error.apply(T, n([ "Firestore (" + I + "): " + t ], r));
    }
}

/**
 * Converts an additional log parameter to a string representation.
 */ function P(t) {
    if ("string" == typeof t) return t;
    var n = qi.t();
    try {
        return n.i(t);
    } catch (n) {
        // Converting to JSON failed, just log the object directly
        return t;
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Unconditionally fails, throwing an Error with the given message.
 *
 * Returns any so it can be used in expressions:
 * @example
 * let futureVar = fail('not implemented yet');
 */ function S(t) {
    // Log the failure in addition to throw an exception, just in case the
    // exception is swallowed.
    var n = "FIRESTORE (" + I + ") INTERNAL ASSERTION FAILED: " + t;
    // NOTE: We don't use FirestoreError here because these are internal failures
    // that cannot be handled by the user. (Also it would create a circular
    // dependency between the error and assert modules which doesn't work.)
    throw D(n), new Error(n);
}

/**
 * Fails if the given assertion condition is false, throwing an Error with the
 * given message if it did.
 */ function C(t, n) {
    t || S(n);
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ !function(t) {
    t[t.DEBUG = 0] = "DEBUG", t[t.ERROR = 1] = "ERROR", t[t.SILENT = 2] = "SILENT";
}(_ || (_ = {}));

var V = /** @class */ function() {
    function t() {}
    return t.u = function() {
        for (
        // Alphanumeric characters
        var t = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789", n = "", i = 0; i < 20; i++) n += t.charAt(Math.floor(Math.random() * t.length));
        return C(20 === n.length, "Invalid auto ID: " + n), n;
    }, t;
}();

function N(t, n) {
    return t < n ? -1 : t > n ? 1 : 0;
}

/** Helper to compare nullable (or undefined-able) objects using isEqual(). */
/** Helper to compare arrays using isEqual(). */
function k(t, n) {
    if (t.length !== n.length) return !1;
    for (var i = 0; i < t.length; i++) if (!t[i].isEqual(n[i])) return !1;
    return !0;
}

/**
 * Returns the immediate lexicographically-following string. This is useful to
 * construct an inclusive range for indexeddb iterators.
 */ function O(t) {
    // Return the input string, with an additional NUL byte appended.
    return t + "\0";
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ var F = 
/**
     * Constructs a DatabaseInfo using the provided host, databaseId and
     * persistenceKey.
     *
     * @param databaseId The database to use.
     * @param persistenceKey A unique identifier for this Firestore's local
     * storage (used in conjunction with the databaseId).
     * @param host The Firestore backend host to connect to.
     * @param ssl Whether to use SSL when connecting.
     * @param forceLongPolling Whether to use the forceLongPolling option
     * when using WebChannel as the network transport.
     */
function(t, n, i, e, r) {
    this.s = t, this.persistenceKey = n, this.host = i, this.ssl = e, this.forceLongPolling = r;
}, x = "(default)", j = /** @class */ function() {
    function t(t, n) {
        this.projectId = t, this.database = n || x;
    }
    return Object.defineProperty(t.prototype, "o", {
        get: function() {
            return this.database === x;
        },
        enumerable: !0,
        configurable: !0
    }), t.prototype.isEqual = function(n) {
        return n instanceof t && n.projectId === this.projectId && n.database === this.database;
    }, t.prototype.h = function(t) {
        return N(this.projectId, t.projectId) || N(this.database, t.database);
    }, t;
}(), U = /** @class */ function() {
    function t(t) {
        this.uid = t;
    }
    return t.prototype.l = function() {
        return null != this.uid;
    }, 
    /**
     * Returns a key representing this user, suitable for inclusion in a
     * dictionary.
     */
    t.prototype.v = function() {
        return this.l() ? "uid:" + this.uid : "anonymous-user";
    }, t.prototype.isEqual = function(t) {
        return t.uid === this.uid;
    }, 
    /** A user with a null UID. */
    t.UNAUTHENTICATED = new t(null), 
    // TODO(mikelehen): Look into getting a proper uid-equivalent for
    // non-FirebaseAuth providers.
    t.m = new t("google-credentials-uid"), t.p = new t("first-party-uid"), t;
}(), L = {
    // Causes are copied from:
    // https://github.com/grpc/grpc/blob/bceec94ea4fc5f0085d81235d8e1c06798dc341a/include/grpc%2B%2B/impl/codegen/status_code_enum.h
    /** Not an error; returned on success. */
    OK: "ok",
    /** The operation was cancelled (typically by the caller). */
    CANCELLED: "cancelled",
    /** Unknown error or an error from a different error domain. */
    UNKNOWN: "unknown",
    /**
     * Client specified an invalid argument. Note that this differs from
     * FAILED_PRECONDITION. INVALID_ARGUMENT indicates arguments that are
     * problematic regardless of the state of the system (e.g., a malformed file
     * name).
     */
    INVALID_ARGUMENT: "invalid-argument",
    /**
     * Deadline expired before operation could complete. For operations that
     * change the state of the system, this error may be returned even if the
     * operation has completed successfully. For example, a successful response
     * from a server could have been delayed long enough for the deadline to
     * expire.
     */
    DEADLINE_EXCEEDED: "deadline-exceeded",
    /** Some requested entity (e.g., file or directory) was not found. */
    NOT_FOUND: "not-found",
    /**
     * Some entity that we attempted to create (e.g., file or directory) already
     * exists.
     */
    ALREADY_EXISTS: "already-exists",
    /**
     * The caller does not have permission to execute the specified operation.
     * PERMISSION_DENIED must not be used for rejections caused by exhausting
     * some resource (use RESOURCE_EXHAUSTED instead for those errors).
     * PERMISSION_DENIED must not be used if the caller can not be identified
     * (use UNAUTHENTICATED instead for those errors).
     */
    PERMISSION_DENIED: "permission-denied",
    /**
     * The request does not have valid authentication credentials for the
     * operation.
     */
    UNAUTHENTICATED: "unauthenticated",
    /**
     * Some resource has been exhausted, perhaps a per-user quota, or perhaps the
     * entire file system is out of space.
     */
    RESOURCE_EXHAUSTED: "resource-exhausted",
    /**
     * Operation was rejected because the system is not in a state required for
     * the operation's execution. For example, directory to be deleted may be
     * non-empty, an rmdir operation is applied to a non-directory, etc.
     *
     * A litmus test that may help a service implementor in deciding
     * between FAILED_PRECONDITION, ABORTED, and UNAVAILABLE:
     *  (a) Use UNAVAILABLE if the client can retry just the failing call.
     *  (b) Use ABORTED if the client should retry at a higher-level
     *      (e.g., restarting a read-modify-write sequence).
     *  (c) Use FAILED_PRECONDITION if the client should not retry until
     *      the system state has been explicitly fixed. E.g., if an "rmdir"
     *      fails because the directory is non-empty, FAILED_PRECONDITION
     *      should be returned since the client should not retry unless
     *      they have first fixed up the directory by deleting files from it.
     *  (d) Use FAILED_PRECONDITION if the client performs conditional
     *      REST Get/Update/Delete on a resource and the resource on the
     *      server does not match the condition. E.g., conflicting
     *      read-modify-write on the same resource.
     */
    FAILED_PRECONDITION: "failed-precondition",
    /**
     * The operation was aborted, typically due to a concurrency issue like
     * sequencer check failures, transaction aborts, etc.
     *
     * See litmus test above for deciding between FAILED_PRECONDITION, ABORTED,
     * and UNAVAILABLE.
     */
    ABORTED: "aborted",
    /**
     * Operation was attempted past the valid range. E.g., seeking or reading
     * past end of file.
     *
     * Unlike INVALID_ARGUMENT, this error indicates a problem that may be fixed
     * if the system state changes. For example, a 32-bit file system will
     * generate INVALID_ARGUMENT if asked to read at an offset that is not in the
     * range [0,2^32-1], but it will generate OUT_OF_RANGE if asked to read from
     * an offset past the current file size.
     *
     * There is a fair bit of overlap between FAILED_PRECONDITION and
     * OUT_OF_RANGE. We recommend using OUT_OF_RANGE (the more specific error)
     * when it applies so that callers who are iterating through a space can
     * easily look for an OUT_OF_RANGE error to detect when they are done.
     */
    OUT_OF_RANGE: "out-of-range",
    /** Operation is not implemented or not supported/enabled in this service. */
    UNIMPLEMENTED: "unimplemented",
    /**
     * Internal errors. Means some invariants expected by underlying System has
     * been broken. If you see one of these errors, Something is very broken.
     */
    INTERNAL: "internal",
    /**
     * The service is currently unavailable. This is a most likely a transient
     * condition and may be corrected by retrying with a backoff.
     *
     * See litmus test above for deciding between FAILED_PRECONDITION, ABORTED,
     * and UNAVAILABLE.
     */
    UNAVAILABLE: "unavailable",
    /** Unrecoverable data loss or corruption. */
    DATA_LOSS: "data-loss"
}, B = /** @class */ function(t) {
    function n(n, i) {
        var e = t.call(this, i) || this;
        return e.code = n, e.message = i, e.name = "FirebaseError", 
        // HACK: We write a toString property directly because Error is not a real
        // class and so inheritance does not work correctly. We could alternatively
        // do the same "back-door inheritance" trick that FirebaseError does.
        e.toString = function() {
            return e.name + ": [code=" + e.code + "]: " + e.message;
        }, e;
    }
    return i(n, t), n;
}(Error), M = function(t, n) {
    this.user = n, this.type = "OAuth", this.g = {}, 
    // Set the headers using Object Literal notation to avoid minification
    this.g.Authorization = "Bearer " + t;
}, q = /** @class */ function() {
    function t() {
        /**
         * Stores the listener registered with setChangeListener()
         * This isn't actually necessary since the UID never changes, but we use this
         * to verify the listen contract is adhered to in tests.
         */
        this._ = null;
    }
    return t.prototype.getToken = function() {
        return Promise.resolve(null);
    }, t.prototype.I = function() {}, t.prototype.T = function(t) {
        C(!this._, "Can only call setChangeListener() once."), this._ = t, 
        // Fire with initial user.
        t(U.UNAUTHENTICATED);
    }, t.prototype.R = function() {
        C(null !== this._, "removeChangeListener() when no listener registered"), this._ = null;
    }, t;
}(), Q = /** @class */ function() {
    function t(t) {
        var n = this;
        /**
         * The auth token listener registered with FirebaseApp, retained here so we
         * can unregister it.
         */        this.A = null, 
        /** Tracks the current User. */
        this.currentUser = U.UNAUTHENTICATED, this.D = !1, 
        /**
         * Counter used to detect if the token changed while a getToken request was
         * outstanding.
         */
        this.P = 0, 
        /** The listener registered with setChangeListener(). */
        this._ = null, this.forceRefresh = !1, this.A = function() {
            n.P++, n.currentUser = n.S(), n.D = !0, n._ && n._(n.currentUser);
        }, this.P = 0, this.auth = t.getImmediate({
            optional: !0
        }), this.auth ? this.auth.addAuthTokenListener(this.A) : (
        // if auth is not available, invoke tokenListener once with null token
        this.A(null), t.get().then((function(t) {
            n.auth = t, n.A && 
            // tokenListener can be removed by removeChangeListener()
            n.auth.addAuthTokenListener(n.A);
        }), (function() {
            /* this.authProvider.get() never rejects */})));
    }
    return t.prototype.getToken = function() {
        var t = this;
        C(null != this.A, "getToken cannot be called after listener removed.");
        // Take note of the current value of the tokenCounter so that this method
        // can fail (with an ABORTED error) if there is a token change while the
        // request is outstanding.
        var n = this.P, i = this.forceRefresh;
        return this.forceRefresh = !1, this.auth ? this.auth.getToken(i).then((function(i) {
            // Cancel the request since the token changed while the request was
            // outstanding so the response is potentially for a previous user (which
            // user, we can't be sure).
            if (t.P !== n) throw new B(L.ABORTED, "getToken aborted due to token change.");
            return i ? (C("string" == typeof i.accessToken, "Invalid tokenData returned from getToken():" + i), 
            new M(i.accessToken, t.currentUser)) : null;
        })) : Promise.resolve(null);
    }, t.prototype.I = function() {
        this.forceRefresh = !0;
    }, t.prototype.T = function(t) {
        C(!this._, "Can only call setChangeListener() once."), this._ = t, 
        // Fire the initial event
        this.D && t(this.currentUser);
    }, t.prototype.R = function() {
        C(null != this.A, "removeChangeListener() called twice"), C(null !== this._, "removeChangeListener() called when no listener registered"), 
        this.auth && this.auth.removeAuthTokenListener(this.A), this.A = null, this._ = null;
    }, 
    // Auth.getUid() can return null even with a user logged in. It is because
    // getUid() is synchronous, but the auth code populating Uid is asynchronous.
    // This method should only be called in the AuthTokenListener callback
    // to guarantee to get the actual user.
    t.prototype.S = function() {
        var t = this.auth && this.auth.getUid();
        return C(null === t || "string" == typeof t, "Received invalid UID: " + t), new U(t);
    }, t;
}(), G = /** @class */ function() {
    function t(t, n) {
        this.C = t, this.V = n, this.type = "FirstParty", this.user = U.p;
    }
    return Object.defineProperty(t.prototype, "g", {
        get: function() {
            var t = {
                "X-Goog-AuthUser": this.V
            }, n = this.C.auth.N([]);
            return n && (t.Authorization = n), t;
        },
        enumerable: !0,
        configurable: !0
    }), t;
}(), W = /** @class */ function() {
    function t(t, n) {
        this.C = t, this.V = n;
    }
    return t.prototype.getToken = function() {
        return Promise.resolve(new G(this.C, this.V));
    }, t.prototype.T = function(t) {
        // Fire with initial uid.
        t(U.p);
    }, t.prototype.R = function() {}, t.prototype.I = function() {}, t;
}();

/** The default database name for a project. */
/**
 * Builds a CredentialsProvider depending on the type of
 * the credentials passed in.
 */
function z(t) {
    if (!t) return new q;
    switch (t.type) {
      case "gapi":
        var n = t.k;
        // Make sure this really is a Gapi client.
                return C(!("object" != typeof n || null === n || !n.auth || !n.auth.getAuthHeaderValueForFirstParty), "unexpected gapi interface"), 
        new W(n, t.V || "0");

      case "provider":
        return t.k;

      default:
        throw new B(L.INVALID_ARGUMENT, "makeCredentialsProvider failed due to invalid credential type");
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ function K(t, n) {
    return Object.prototype.hasOwnProperty.call(t, n);
}

/** Returns the given value if it's defined or the defaultValue otherwise. */ function H(t, n) {
    return void 0 !== t ? t : n;
}

function J(t, n) {
    for (var i in t) if (Object.prototype.hasOwnProperty.call(t, i)) {
        var e = Number(i);
        isNaN(e) || n(e, t[i]);
    }
}

function Y(t, n) {
    for (var i in t) Object.prototype.hasOwnProperty.call(t, i) && n(i, t[i]);
}

function X(t) {
    for (var n in C(null != t && "object" == typeof t, "isEmpty() expects object parameter."), 
    t) if (Object.prototype.hasOwnProperty.call(t, n)) return !1;
    return !0;
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Validates that no arguments were passed in the invocation of functionName.
 *
 * Forward the magic "arguments" variable as second parameter on which the
 * parameter validation is performed:
 * validateNoArgs('myFunction', arguments);
 */
function $(t, n) {
    if (0 !== n.length) throw new B(L.INVALID_ARGUMENT, "Function " + t + "() does not support arguments, but was called with " + pt(n.length, "argument") + ".");
}

/**
 * Validates the invocation of functionName has the exact number of arguments.
 *
 * Forward the magic "arguments" variable as second parameter on which the
 * parameter validation is performed:
 * validateExactNumberOfArgs('myFunction', arguments, 2);
 */ function Z(t, n, i) {
    if (n.length !== i) throw new B(L.INVALID_ARGUMENT, "Function " + t + "() requires " + pt(i, "argument") + ", but was called with " + pt(n.length, "argument") + ".");
}

/**
 * Validates the invocation of functionName has at least the provided number of
 * arguments (but can have many more).
 *
 * Forward the magic "arguments" variable as second parameter on which the
 * parameter validation is performed:
 * validateAtLeastNumberOfArgs('myFunction', arguments, 2);
 */ function tt(t, n, i) {
    if (n.length < i) throw new B(L.INVALID_ARGUMENT, "Function " + t + "() requires at least " + pt(i, "argument") + ", but was called with " + pt(n.length, "argument") + ".");
}

/**
 * Validates the invocation of functionName has number of arguments between
 * the values provided.
 *
 * Forward the magic "arguments" variable as second parameter on which the
 * parameter validation is performed:
 * validateBetweenNumberOfArgs('myFunction', arguments, 2, 3);
 */ function nt(t, n, i, e) {
    if (n.length < i || n.length > e) throw new B(L.INVALID_ARGUMENT, "Function " + t + "() requires between " + i + " and " + e + " arguments, but was called with " + pt(n.length, "argument") + ".");
}

/**
 * Validates the provided argument is an array and has as least the expected
 * number of elements.
 */
/**
 * Validates the provided positional argument has the native JavaScript type
 * using typeof checks.
 */
function it(t, n, i, e) {
    ct(t, n, mt(i) + " argument", e);
}

/**
 * Validates the provided argument has the native JavaScript type using
 * typeof checks or is undefined.
 */ function et(t, n, i, e) {
    void 0 !== e && it(t, n, i, e);
}

/**
 * Validates the provided named option has the native JavaScript type using
 * typeof checks.
 */ function rt(t, n, i, e) {
    ct(t, n, i + " option", e);
}

/**
 * Validates the provided named option has the native JavaScript type using
 * typeof checks or is undefined.
 */ function ut(t, n, i, e) {
    void 0 !== e && rt(t, n, i, e);
}

function st(t, n, i, e, r) {
    void 0 !== e && function(t, n, i, e, r) {
        if (!(e instanceof Array)) throw new B(L.INVALID_ARGUMENT, "Function " + t + "() requires its " + n + " option to be an array, but it was: " + ft(e));
        for (var u = 0; u < e.length; ++u) if (!r(e[u])) throw new B(L.INVALID_ARGUMENT, "Function " + t + "() requires all " + n + " elements to be " + i + ", but the value at index " + u + " was: " + ft(e[u]));
    }(t, n, i, e, r);
}

/**
 * Validates that the provided named option equals one of the expected values.
 */
/**
 * Validates that the provided named option equals one of the expected values or
 * is undefined.
 */
function ot(t, n, i, e, r) {
    void 0 !== e && function(t, n, i, e, r) {
        for (var u = [], s = 0, o = r; s < o.length; s++) {
            var h = o[s];
            if (h === e) return;
            u.push(ft(h));
        }
        var c = ft(e);
        throw new B(L.INVALID_ARGUMENT, "Invalid value " + c + " provided to function " + t + '() for option "' + i + '". Acceptable values: ' + u.join(", "));
    }(t, 0, i, e, r);
}

/**
 * Validates that the provided argument is a valid enum.
 *
 * @param functionName Function making the validation call.
 * @param enums Array containing all possible values for the enum.
 * @param position Position of the argument in `functionName`.
 * @param argument Arugment to validate.
 */ function ht(t, n, i, e) {
    if (!n.some((function(t) {
        return t === e;
    }))) throw new B(L.INVALID_ARGUMENT, "Invalid value " + ft(e) + " provided to function " + t + "() for its " + mt(i) + " argument. Acceptable values: " + n.join(", "));
}

/** Helper to validate the type of a provided input. */ function ct(t, n, i, e) {
    if (!("object" === n ? at(e) : "non-empty string" === n ? "string" == typeof e && "" !== e : typeof e === n)) {
        var r = ft(e);
        throw new B(L.INVALID_ARGUMENT, "Function " + t + "() requires its " + i + " to be of type " + n + ", but it was: " + r);
    }
}

/**
 * Returns true if it's a non-null object without a custom prototype
 * (i.e. excludes Array, Date, etc.).
 */ function at(t) {
    return "object" == typeof t && null !== t && (Object.getPrototypeOf(t) === Object.prototype || null === Object.getPrototypeOf(t));
}

/** Returns a string describing the type / value of the provided input. */ function ft(t) {
    if (void 0 === t) return "undefined";
    if (null === t) return "null";
    if ("string" == typeof t) return t.length > 20 && (t = t.substring(0, 20) + "..."), 
    JSON.stringify(t);
    if ("number" == typeof t || "boolean" == typeof t) return "" + t;
    if ("object" == typeof t) {
        if (t instanceof Array) return "an array";
        var n = 
        /** Hacky method to try to get the constructor name for an object. */
        function(t) {
            if (t.constructor) {
                var n = /function\s+([^\s(]+)\s*\(/.exec(t.constructor.toString());
                if (n && n.length > 1) return n[1];
            }
            return null;
        }
        /** Validates the provided argument is defined. */ (t);
        return n ? "a custom " + n + " object" : "an object";
    }
    return "function" == typeof t ? "a function" : S("Unknown wrong type: " + typeof t);
}

function lt(t, n, i) {
    if (void 0 === i) throw new B(L.INVALID_ARGUMENT, "Function " + t + "() requires a valid " + mt(n) + " argument, but it was undefined.");
}

/**
 * Validates the provided positional argument is an object, and its keys and
 * values match the expected keys and types provided in optionTypes.
 */ function dt(t, n, i) {
    Y(n, (function(n, e) {
        if (i.indexOf(n) < 0) throw new B(L.INVALID_ARGUMENT, "Unknown option '" + n + "' passed to function " + t + "(). Available options: " + i.join(", "));
    }));
}

/**
 * Helper method to throw an error that the provided argument did not pass
 * an instanceof check.
 */ function vt(t, n, i, e) {
    var r = ft(e);
    return new B(L.INVALID_ARGUMENT, "Function " + t + "() requires its " + mt(i) + " argument to be a " + n + ", but it was: " + r);
}

function wt(t, n, i) {
    if (i <= 0) throw new B(L.INVALID_ARGUMENT, 'Function "' + t + '()" requires its ' + mt(n) + " argument to be a positive number, but it was: " + i + ".");
}

/** Converts a number to its english word representation */ function mt(t) {
    switch (t) {
      case 1:
        return "first";

      case 2:
        return "second";

      case 3:
        return "third";

      default:
        return t + "th";
    }
}

/**
 * Formats the given word as plural conditionally given the preceding number.
 */ function pt(t, n) {
    return t + " " + n + (1 === t ? "" : "s");
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Immutable class representing a geo point as latitude-longitude pair.
 * This class is directly exposed in the public API, including its constructor.
 */ var gt = /** @class */ function() {
    function t(t, n) {
        if (Z("GeoPoint", arguments, 2), it("GeoPoint", "number", 1, t), it("GeoPoint", "number", 2, n), 
        !isFinite(t) || t < -90 || t > 90) throw new B(L.INVALID_ARGUMENT, "Latitude must be a number between -90 and 90, but was: " + t);
        if (!isFinite(n) || n < -180 || n > 180) throw new B(L.INVALID_ARGUMENT, "Longitude must be a number between -180 and 180, but was: " + n);
        this.O = t, this.F = n;
    }
    return Object.defineProperty(t.prototype, "latitude", {
        /**
         * Returns the latitude of this geo point, a number between -90 and 90.
         */
        get: function() {
            return this.O;
        },
        enumerable: !0,
        configurable: !0
    }), Object.defineProperty(t.prototype, "longitude", {
        /**
         * Returns the longitude of this geo point, a number between -180 and 180.
         */
        get: function() {
            return this.F;
        },
        enumerable: !0,
        configurable: !0
    }), t.prototype.isEqual = function(t) {
        return this.O === t.O && this.F === t.F;
    }, 
    /**
     * Actually private to JS consumers of our API, so this function is prefixed
     * with an underscore.
     */
    t.prototype.j = function(t) {
        return N(this.O, t.O) || N(this.F, t.F);
    }, t;
}(), bt = /** @class */ function() {
    function t(t, n) {
        if (this.seconds = t, this.nanoseconds = n, n < 0) throw new B(L.INVALID_ARGUMENT, "Timestamp nanoseconds out of range: " + n);
        if (n >= 1e9) throw new B(L.INVALID_ARGUMENT, "Timestamp nanoseconds out of range: " + n);
        // Midnight at the beginning of 1/1/1 is the earliest Firestore supports.
                if (t < -62135596800) throw new B(L.INVALID_ARGUMENT, "Timestamp seconds out of range: " + t);
        // This will break in the year 10,000.
                if (t >= 253402300800) throw new B(L.INVALID_ARGUMENT, "Timestamp seconds out of range: " + t);
    }
    return t.now = function() {
        return t.fromMillis(Date.now());
    }, t.fromDate = function(n) {
        return t.fromMillis(n.getTime());
    }, t.fromMillis = function(n) {
        var i = Math.floor(n / 1e3);
        return new t(i, 1e6 * (n - 1e3 * i));
    }, t.prototype.toDate = function() {
        return new Date(this.toMillis());
    }, t.prototype.toMillis = function() {
        return 1e3 * this.seconds + this.nanoseconds / 1e6;
    }, t.prototype.j = function(t) {
        return this.seconds === t.seconds ? N(this.nanoseconds, t.nanoseconds) : N(this.seconds, t.seconds);
    }, t.prototype.isEqual = function(t) {
        return t.seconds === this.seconds && t.nanoseconds === this.nanoseconds;
    }, t.prototype.toString = function() {
        return "Timestamp(seconds=" + this.seconds + ", nanoseconds=" + this.nanoseconds + ")";
    }, t;
}(), yt = /** @class */ function() {
    function t(t) {
        this.timestamp = t;
    }
    // TODO(b/34176344): Once we no longer need to use the old alpha protos,
    // delete this constructor and use a timestamp-backed version everywhere.
        return t.U = function(n) {
        var i = Math.floor(n / 1e6);
        return new t(new bt(i, n % 1e6 * 1e3));
    }, t.L = function(n) {
        return new t(n);
    }, t.B = function() {
        return t.MIN;
    }, t.prototype.h = function(t) {
        return this.timestamp.j(t.timestamp);
    }, t.prototype.isEqual = function(t) {
        return this.timestamp.isEqual(t.timestamp);
    }, 
    /** Returns a number representation of the version for use in spec tests. */
    t.prototype.M = function() {
        // Convert to microseconds.
        return 1e6 * this.timestamp.seconds + this.timestamp.nanoseconds / 1e3;
    }, t.prototype.toString = function() {
        return "SnapshotVersion(" + this.timestamp.toString() + ")";
    }, t.prototype.q = function() {
        return this.timestamp;
    }, t.MIN = new t(new bt(0, 0)), t;
}(), _t = /** @class */ function() {
    function t(t, n, i) {
        void 0 === n ? n = 0 : n > t.length && S("offset " + n + " out of range " + t.length), 
        void 0 === i ? i = t.length - n : i > t.length - n && S("length " + i + " out of range " + (t.length - n)), 
        this.segments = t, this.offset = n, this.len = i;
    }
    return Object.defineProperty(t.prototype, "length", {
        get: function() {
            return this.len;
        },
        enumerable: !0,
        configurable: !0
    }), t.prototype.isEqual = function(n) {
        return 0 === t.G(this, n);
    }, t.prototype.child = function(n) {
        var i = this.segments.slice(this.offset, this.limit());
        return n instanceof t ? n.forEach((function(t) {
            i.push(t);
        })) : i.push(n), this.W(i);
    }, 
    /** The index of one past the last segment of the path. */
    t.prototype.limit = function() {
        return this.offset + this.length;
    }, t.prototype.K = function(t) {
        return t = void 0 === t ? 1 : t, C(this.length >= t, "Can't call popFirst() with less segments"), 
        this.W(this.segments, this.offset + t, this.length - t);
    }, t.prototype.H = function() {
        return C(!this.J(), "Can't call popLast() on empty path"), this.W(this.segments, this.offset, this.length - 1);
    }, t.prototype.Y = function() {
        return C(!this.J(), "Can't call firstSegment() on empty path"), this.segments[this.offset];
    }, t.prototype.X = function() {
        return this.get(this.length - 1);
    }, t.prototype.get = function(t) {
        return C(t < this.length, "Index out of range"), this.segments[this.offset + t];
    }, t.prototype.J = function() {
        return 0 === this.length;
    }, t.prototype.$ = function(t) {
        if (t.length < this.length) return !1;
        for (var n = 0; n < this.length; n++) if (this.get(n) !== t.get(n)) return !1;
        return !0;
    }, t.prototype.Z = function(t) {
        if (this.length + 1 !== t.length) return !1;
        for (var n = 0; n < this.length; n++) if (this.get(n) !== t.get(n)) return !1;
        return !0;
    }, t.prototype.forEach = function(t) {
        for (var n = this.offset, i = this.limit(); n < i; n++) t(this.segments[n]);
    }, t.prototype.tt = function() {
        return this.segments.slice(this.offset, this.limit());
    }, t.G = function(t, n) {
        for (var i = Math.min(t.length, n.length), e = 0; e < i; e++) {
            var r = t.get(e), u = n.get(e);
            if (r < u) return -1;
            if (r > u) return 1;
        }
        return t.length < n.length ? -1 : t.length > n.length ? 1 : 0;
    }, t;
}(), It = /** @class */ function(t) {
    function n() {
        return null !== t && t.apply(this, arguments) || this;
    }
    return i(n, t), n.prototype.W = function(t, i, e) {
        return new n(t, i, e);
    }, n.prototype.nt = function() {
        // NOTE: The client is ignorant of any path segments containing escape
        // sequences (e.g. __id123__) and just passes them through raw (they exist
        // for legacy reasons and should not be used frequently).
        return this.tt().join("/");
    }, n.prototype.toString = function() {
        return this.nt();
    }, 
    /**
     * Creates a resource path from the given slash-delimited string.
     */
    n.it = function(t) {
        // NOTE: The client is ignorant of any path segments containing escape
        // sequences (e.g. __id123__) and just passes them through raw (they exist
        // for legacy reasons and should not be used frequently).
        if (t.indexOf("//") >= 0) throw new B(L.INVALID_ARGUMENT, "Invalid path (" + t + "). Paths must not contain // in them.");
        // We may still have an empty segment at the beginning or end if they had a
        // leading or trailing slash (which we allow).
                return new n(t.split("/").filter((function(t) {
            return t.length > 0;
        })));
    }, n.et = new n([]), n;
}(_t), Tt = /^[_a-zA-Z][_a-zA-Z0-9]*$/, Et = /** @class */ function(t) {
    function n() {
        return null !== t && t.apply(this, arguments) || this;
    }
    return i(n, t), n.prototype.W = function(t, i, e) {
        return new n(t, i, e);
    }, 
    /**
     * Returns true if the string could be used as a segment in a field path
     * without escaping.
     */
    n.rt = function(t) {
        return Tt.test(t);
    }, n.prototype.nt = function() {
        return this.tt().map((function(t) {
            return t = t.replace("\\", "\\\\").replace("`", "\\`"), n.rt(t) || (t = "`" + t + "`"), 
            t;
        })).join(".");
    }, n.prototype.toString = function() {
        return this.nt();
    }, 
    /**
     * Returns true if this field references the key of a document.
     */
    n.prototype.ut = function() {
        return 1 === this.length && "__name__" === this.get(0);
    }, 
    /**
     * The field designating the key of a document.
     */
    n.st = function() {
        return new n([ "__name__" ]);
    }, 
    /**
     * Parses a field string from the given server-formatted string.
     *
     * - Splitting the empty string is not allowed (for now at least).
     * - Empty segments within the string (e.g. if there are two consecutive
     *   separators) are not allowed.
     *
     * TODO(b/37244157): we should make this more strict. Right now, it allows
     * non-identifier path components, even if they aren't escaped.
     */
    n.ot = function(t) {
        for (var i = [], e = "", r = 0, u = function() {
            if (0 === e.length) throw new B(L.INVALID_ARGUMENT, "Invalid field path (" + t + "). Paths must not be empty, begin with '.', end with '.', or contain '..'");
            i.push(e), e = "";
        }, s = !1; r < t.length; ) {
            var o = t[r];
            if ("\\" === o) {
                if (r + 1 === t.length) throw new B(L.INVALID_ARGUMENT, "Path has trailing escape character: " + t);
                var h = t[r + 1];
                if ("\\" !== h && "." !== h && "`" !== h) throw new B(L.INVALID_ARGUMENT, "Path has invalid escape sequence: " + t);
                e += h, r += 2;
            } else "`" === o ? (s = !s, r++) : "." !== o || s ? (e += o, r++) : (u(), r++);
        }
        if (u(), s) throw new B(L.INVALID_ARGUMENT, "Unterminated ` in path: " + t);
        return new n(i);
    }, n.et = new n([]), n;
}(_t), Rt = /** @class */ function() {
    function t(n) {
        this.path = n, C(t.ht(n), "Invalid DocumentKey with an odd number of segments: " + n.tt().join("/"));
    }
    /** Returns true if the document is in the specified collectionId. */    return t.prototype.ct = function(t) {
        return this.path.length >= 2 && this.path.get(this.path.length - 2) === t;
    }, t.prototype.isEqual = function(t) {
        return null !== t && 0 === It.G(this.path, t.path);
    }, t.prototype.toString = function() {
        return this.path.toString();
    }, t.G = function(t, n) {
        return It.G(t.path, n.path);
    }, t.ht = function(t) {
        return t.length % 2 == 0;
    }, 
    /**
     * Creates and returns a new document key with the given segments.
     *
     * @param path The segments of the path to the document
     * @return A new instance of DocumentKey
     */
    t.at = function(n) {
        return new t(new It(n.slice()));
    }, 
    /**
     * Creates and returns a new document key using '/' to split the string into
     * segments.
     *
     * @param path The slash-separated path string to the document
     * @return A new instance of DocumentKey
     */
    t.ft = function(n) {
        return new t(It.it(n));
    }, t.EMPTY = new t(new It([])), t;
}(), At = /** @class */ function() {
    function t(t, n) {
        this.G = t, this.root = n || Pt.EMPTY;
    }
    // Returns a copy of the map, with the specified key/value added or replaced.
        return t.prototype.lt = function(n, i) {
        return new t(this.G, this.root.lt(n, i, this.G).copy(null, null, Pt.dt, null, null));
    }, 
    // Returns a copy of the map, with the specified key removed.
    t.prototype.remove = function(n) {
        return new t(this.G, this.root.remove(n, this.G).copy(null, null, Pt.dt, null, null));
    }, 
    // Returns the value of the node with the given key, or null.
    t.prototype.get = function(t) {
        for (var n = this.root; !n.J(); ) {
            var i = this.G(t, n.key);
            if (0 === i) return n.value;
            i < 0 ? n = n.left : i > 0 && (n = n.right);
        }
        return null;
    }, 
    // Returns the index of the element in this sorted map, or -1 if it doesn't
    // exist.
    t.prototype.indexOf = function(t) {
        for (
        // Number of nodes that were pruned when descending right
        var n = 0, i = this.root; !i.J(); ) {
            var e = this.G(t, i.key);
            if (0 === e) return n + i.left.size;
            e < 0 ? i = i.left : (
            // Count all nodes left of the node plus the node itself
            n += i.left.size + 1, i = i.right);
        }
        // Node not found
                return -1;
    }, t.prototype.J = function() {
        return this.root.J();
    }, Object.defineProperty(t.prototype, "size", {
        // Returns the total number of nodes in the map.
        get: function() {
            return this.root.size;
        },
        enumerable: !0,
        configurable: !0
    }), 
    // Returns the minimum key in the map.
    t.prototype.vt = function() {
        return this.root.vt();
    }, 
    // Returns the maximum key in the map.
    t.prototype.wt = function() {
        return this.root.wt();
    }, 
    // Traverses the map in key order and calls the specified action function
    // for each key/value pair. If action returns true, traversal is aborted.
    // Returns the first truthy value returned by action, or the last falsey
    // value returned by action.
    t.prototype.pt = function(t) {
        return this.root.pt(t);
    }, t.prototype.forEach = function(t) {
        this.pt((function(n, i) {
            return t(n, i), !1;
        }));
    }, t.prototype.toString = function() {
        var t = [];
        return this.pt((function(n, i) {
            return t.push(n + ":" + i), !1;
        })), "{" + t.join(", ") + "}";
    }, 
    // Traverses the map in reverse key order and calls the specified action
    // function for each key/value pair. If action returns true, traversal is
    // aborted.
    // Returns the first truthy value returned by action, or the last falsey
    // value returned by action.
    t.prototype.gt = function(t) {
        return this.root.gt(t);
    }, 
    // Returns an iterator over the SortedMap.
    t.prototype.bt = function() {
        return new Dt(this.root, null, this.G, !1);
    }, t.prototype.yt = function(t) {
        return new Dt(this.root, t, this.G, !1);
    }, t.prototype._t = function() {
        return new Dt(this.root, null, this.G, !0);
    }, t.prototype.It = function(t) {
        return new Dt(this.root, t, this.G, !0);
    }, t;
}(), Dt = /** @class */ function() {
    function t(t, n, i, e) {
        this.Tt = e, this.Et = [];
        for (var r = 1; !t.J(); ) if (r = n ? i(t.key, n) : 1, 
        // flip the comparison if we're going in reverse
        e && (r *= -1), r < 0) 
        // This node is less than our start key. ignore it
        t = this.Tt ? t.left : t.right; else {
            if (0 === r) {
                // This node is exactly equal to our start key. Push it on the stack,
                // but stop iterating;
                this.Et.push(t);
                break;
            }
            // This node is greater than our start key, add it to the stack and move
            // to the next one
            this.Et.push(t), t = this.Tt ? t.right : t.left;
        }
    }
    return t.prototype.Rt = function() {
        C(this.Et.length > 0, "getNext() called on iterator when hasNext() is false.");
        var t = this.Et.pop(), n = {
            key: t.key,
            value: t.value
        };
        if (this.Tt) for (t = t.left; !t.J(); ) this.Et.push(t), t = t.right; else for (t = t.right; !t.J(); ) this.Et.push(t), 
        t = t.left;
        return n;
    }, t.prototype.At = function() {
        return this.Et.length > 0;
    }, t.prototype.Dt = function() {
        if (0 === this.Et.length) return null;
        var t = this.Et[this.Et.length - 1];
        return {
            key: t.key,
            value: t.value
        };
    }, t;
}(), Pt = /** @class */ function() {
    function t(n, i, e, r, u) {
        this.key = n, this.value = i, this.color = null != e ? e : t.RED, this.left = null != r ? r : t.EMPTY, 
        this.right = null != u ? u : t.EMPTY, this.size = this.left.size + 1 + this.right.size;
    }
    // Returns a copy of the current node, optionally replacing pieces of it.
        return t.prototype.copy = function(n, i, e, r, u) {
        return new t(null != n ? n : this.key, null != i ? i : this.value, null != e ? e : this.color, null != r ? r : this.left, null != u ? u : this.right);
    }, t.prototype.J = function() {
        return !1;
    }, 
    // Traverses the tree in key order and calls the specified action function
    // for each node. If action returns true, traversal is aborted.
    // Returns the first truthy value returned by action, or the last falsey
    // value returned by action.
    t.prototype.pt = function(t) {
        return this.left.pt(t) || t(this.key, this.value) || this.right.pt(t);
    }, 
    // Traverses the tree in reverse key order and calls the specified action
    // function for each node. If action returns true, traversal is aborted.
    // Returns the first truthy value returned by action, or the last falsey
    // value returned by action.
    t.prototype.gt = function(t) {
        return this.right.gt(t) || t(this.key, this.value) || this.left.gt(t);
    }, 
    // Returns the minimum node in the tree.
    t.prototype.min = function() {
        return this.left.J() ? this : this.left.min();
    }, 
    // Returns the maximum key in the tree.
    t.prototype.vt = function() {
        return this.min().key;
    }, 
    // Returns the maximum key in the tree.
    t.prototype.wt = function() {
        return this.right.J() ? this.key : this.right.wt();
    }, 
    // Returns new tree, with the key/value added.
    t.prototype.lt = function(t, n, i) {
        var e = this, r = i(t, e.key);
        return (e = r < 0 ? e.copy(null, null, null, e.left.lt(t, n, i), null) : 0 === r ? e.copy(null, n, null, null, null) : e.copy(null, null, null, null, e.right.lt(t, n, i))).Pt();
    }, t.prototype.St = function() {
        if (this.left.J()) return t.EMPTY;
        var n = this;
        return n.left.Ct() || n.left.left.Ct() || (n = n.Vt()), (n = n.copy(null, null, null, n.left.St(), null)).Pt();
    }, 
    // Returns new tree, with the specified item removed.
    t.prototype.remove = function(n, i) {
        var e, r = this;
        if (i(n, r.key) < 0) r.left.J() || r.left.Ct() || r.left.left.Ct() || (r = r.Vt()), 
        r = r.copy(null, null, null, r.left.remove(n, i), null); else {
            if (r.left.Ct() && (r = r.Nt()), r.right.J() || r.right.Ct() || r.right.left.Ct() || (r = r.kt()), 
            0 === i(n, r.key)) {
                if (r.right.J()) return t.EMPTY;
                e = r.right.min(), r = r.copy(e.key, e.value, null, null, r.right.St());
            }
            r = r.copy(null, null, null, null, r.right.remove(n, i));
        }
        return r.Pt();
    }, t.prototype.Ct = function() {
        return this.color;
    }, 
    // Returns new tree after performing any needed rotations.
    t.prototype.Pt = function() {
        var t = this;
        return t.right.Ct() && !t.left.Ct() && (t = t.Ot()), t.left.Ct() && t.left.left.Ct() && (t = t.Nt()), 
        t.left.Ct() && t.right.Ct() && (t = t.Ft()), t;
    }, t.prototype.Vt = function() {
        var t = this.Ft();
        return t.right.left.Ct() && (t = (t = (t = t.copy(null, null, null, null, t.right.Nt())).Ot()).Ft()), 
        t;
    }, t.prototype.kt = function() {
        var t = this.Ft();
        return t.left.left.Ct() && (t = (t = t.Nt()).Ft()), t;
    }, t.prototype.Ot = function() {
        var n = this.copy(null, null, t.RED, null, this.right.left);
        return this.right.copy(null, null, this.color, n, null);
    }, t.prototype.Nt = function() {
        var n = this.copy(null, null, t.RED, this.left.right, null);
        return this.left.copy(null, null, this.color, null, n);
    }, t.prototype.Ft = function() {
        var t = this.left.copy(null, null, !this.left.color, null, null), n = this.right.copy(null, null, !this.right.color, null, null);
        return this.copy(null, null, !this.color, t, n);
    }, 
    // For testing.
    t.prototype.xt = function() {
        var t = this.jt();
        return Math.pow(2, t) <= this.size + 1;
    }, 
    // In a balanced RB tree, the black-depth (number of black nodes) from root to
    // leaves is equal on both sides.  This function verifies that or asserts.
    t.prototype.jt = function() {
        if (this.Ct() && this.left.Ct()) throw S("Red node has red child(" + this.key + "," + this.value + ")");
        if (this.right.Ct()) throw S("Right child of (" + this.key + "," + this.value + ") is red");
        var t = this.left.jt();
        if (t !== this.right.jt()) throw S("Black depths differ");
        return t + (this.Ct() ? 0 : 1);
    }, 
    // Empty node is shared between all LLRB trees.
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    t.EMPTY = null, t.RED = !0, t.dt = !1, t;
}(), St = /** @class */ function() {
    function t() {
        this.size = 0;
    }
    return Object.defineProperty(t.prototype, "key", {
        get: function() {
            throw S("LLRBEmptyNode has no key.");
        },
        enumerable: !0,
        configurable: !0
    }), Object.defineProperty(t.prototype, "value", {
        get: function() {
            throw S("LLRBEmptyNode has no value.");
        },
        enumerable: !0,
        configurable: !0
    }), Object.defineProperty(t.prototype, "color", {
        get: function() {
            throw S("LLRBEmptyNode has no color.");
        },
        enumerable: !0,
        configurable: !0
    }), Object.defineProperty(t.prototype, "left", {
        get: function() {
            throw S("LLRBEmptyNode has no left child.");
        },
        enumerable: !0,
        configurable: !0
    }), Object.defineProperty(t.prototype, "right", {
        get: function() {
            throw S("LLRBEmptyNode has no right child.");
        },
        enumerable: !0,
        configurable: !0
    }), 
    // Returns a copy of the current node.
    t.prototype.copy = function(t, n, i, e, r) {
        return this;
    }, 
    // Returns a copy of the tree, with the specified key/value added.
    t.prototype.lt = function(t, n, i) {
        return new Pt(t, n);
    }, 
    // Returns a copy of the tree, with the specified key removed.
    t.prototype.remove = function(t, n) {
        return this;
    }, t.prototype.J = function() {
        return !0;
    }, t.prototype.pt = function(t) {
        return !1;
    }, t.prototype.gt = function(t) {
        return !1;
    }, t.prototype.vt = function() {
        return null;
    }, t.prototype.wt = function() {
        return null;
    }, t.prototype.Ct = function() {
        return !1;
    }, 
    // For testing.
    t.prototype.xt = function() {
        return !0;
    }, t.prototype.jt = function() {
        return 0;
    }, t;
}();

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ // end LLRBEmptyNode
Pt.EMPTY = new St;

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * SortedSet is an immutable (copy-on-write) collection that holds elements
 * in order specified by the provided comparator.
 *
 * NOTE: if provided comparator returns 0 for two elements, we consider them to
 * be equal!
 */
var Ct = /** @class */ function() {
    function t(t) {
        this.G = t, this.data = new At(this.G);
    }
    /**
     * Creates a SortedSet from the keys of the map.
     * This is currently implemented as an O(n) copy.
     */    return t.Ut = function(n) {
        var i = new t(n.G);
        return n.forEach((function(t) {
            i = i.add(t);
        })), i;
    }, t.prototype.has = function(t) {
        return null !== this.data.get(t);
    }, t.prototype.first = function() {
        return this.data.vt();
    }, t.prototype.last = function() {
        return this.data.wt();
    }, Object.defineProperty(t.prototype, "size", {
        get: function() {
            return this.data.size;
        },
        enumerable: !0,
        configurable: !0
    }), t.prototype.indexOf = function(t) {
        return this.data.indexOf(t);
    }, 
    /** Iterates elements in order defined by "comparator" */
    t.prototype.forEach = function(t) {
        this.data.pt((function(n, i) {
            return t(n), !1;
        }));
    }, 
    /** Iterates over `elem`s such that: range[0] <= elem < range[1]. */
    t.prototype.Lt = function(t, n) {
        for (var i = this.data.yt(t[0]); i.At(); ) {
            var e = i.Rt();
            if (this.G(e.key, t[1]) >= 0) return;
            n(e.key);
        }
    }, 
    /**
     * Iterates over `elem`s such that: start <= elem until false is returned.
     */
    t.prototype.Bt = function(t, n) {
        var i;
        for (i = void 0 !== n ? this.data.yt(n) : this.data.bt(); i.At(); ) {
            if (!t(i.Rt().key)) return;
        }
    }, 
    /** Finds the least element greater than or equal to `elem`. */
    t.prototype.Mt = function(t) {
        var n = this.data.yt(t);
        return n.At() ? n.Rt().key : null;
    }, t.prototype.bt = function() {
        return new Vt(this.data.bt());
    }, t.prototype.yt = function(t) {
        return new Vt(this.data.yt(t));
    }, 
    /** Inserts or updates an element */
    t.prototype.add = function(t) {
        return this.copy(this.data.remove(t).lt(t, !0));
    }, 
    /** Deletes an element */
    t.prototype.delete = function(t) {
        return this.has(t) ? this.copy(this.data.remove(t)) : this;
    }, t.prototype.J = function() {
        return this.data.J();
    }, t.prototype.qt = function(t) {
        var n = this;
        // Make sure `result` always refers to the larger one of the two sets.
                return n.size < t.size && (n = t, t = this), t.forEach((function(t) {
            n = n.add(t);
        })), n;
    }, t.prototype.isEqual = function(n) {
        if (!(n instanceof t)) return !1;
        if (this.size !== n.size) return !1;
        for (var i = this.data.bt(), e = n.data.bt(); i.At(); ) {
            var r = i.Rt().key, u = e.Rt().key;
            if (0 !== this.G(r, u)) return !1;
        }
        return !0;
    }, t.prototype.tt = function() {
        var t = [];
        return this.forEach((function(n) {
            t.push(n);
        })), t;
    }, t.prototype.toString = function() {
        var t = [];
        return this.forEach((function(n) {
            return t.push(n);
        })), "SortedSet(" + t.toString() + ")";
    }, t.prototype.copy = function(n) {
        var i = new t(this.G);
        return i.data = n, i;
    }, t;
}(), Vt = /** @class */ function() {
    function t(t) {
        this.Qt = t;
    }
    return t.prototype.Rt = function() {
        return this.Qt.Rt().key;
    }, t.prototype.At = function() {
        return this.Qt.At();
    }, t;
}(), Nt = /** @class */ function() {
    function t() {}
    return t.prototype.Gt = function(t, n) {
        return new an(n, t);
    }, t.prototype.Wt = function(t, n) {
        return n;
    }, t.prototype.zt = function(t) {
        return null;
 // Server timestamps are idempotent and don't require a base value.
        }, t.prototype.isEqual = function(n) {
        return n instanceof t;
    }, t.instance = new t, t;
}(), kt = /** @class */ function() {
    function t(t) {
        this.elements = t;
    }
    return t.prototype.Gt = function(t, n) {
        return this.apply(t);
    }, t.prototype.Wt = function(t, n) {
        // The server just sends null as the transform result for array operations,
        // so we have to calculate a result the same as we do for local
        // applications.
        return this.apply(t);
    }, t.prototype.apply = function(t) {
        for (var n = xt(t), i = function(t) {
            n.find((function(n) {
                return n.isEqual(t);
            })) || n.push(t);
        }, e = 0, r = this.elements; e < r.length; e++) {
            i(r[e]);
        }
        return new wn(n);
    }, t.prototype.zt = function(t) {
        return null;
 // Array transforms are idempotent and don't require a base value.
        }, t.prototype.isEqual = function(n) {
        return n instanceof t && k(n.elements, this.elements);
    }, t;
}(), Ot = /** @class */ function() {
    function t(t) {
        this.elements = t;
    }
    return t.prototype.Gt = function(t, n) {
        return this.apply(t);
    }, t.prototype.Wt = function(t, n) {
        // The server just sends null as the transform result for array operations,
        // so we have to calculate a result the same as we do for local
        // applications.
        return this.apply(t);
    }, t.prototype.apply = function(t) {
        for (var n = xt(t), i = function(t) {
            n = n.filter((function(n) {
                return !n.isEqual(t);
            }));
        }, e = 0, r = this.elements; e < r.length; e++) {
            i(r[e]);
        }
        return new wn(n);
    }, t.prototype.zt = function(t) {
        return null;
 // Array transforms are idempotent and don't require a base value.
        }, t.prototype.isEqual = function(n) {
        return n instanceof t && k(n.elements, this.elements);
    }, t;
}(), Ft = /** @class */ function() {
    function t(t) {
        this.Kt = t;
    }
    return t.prototype.Gt = function(t, n) {
        var i = this.zt(t);
        // PORTING NOTE: Since JavaScript's integer arithmetic is limited to 53 bit
        // precision and resolves overflows by reducing precision, we do not
        // manually cap overflows at 2^63.
        // Return an integer value iff the previous value and the operand is an
        // integer.
                if (i instanceof sn && this.Kt instanceof sn) {
            var e = i.Ht + this.Kt.Ht;
            return new sn(e);
        }
        e = i.Ht + this.Kt.Ht;
        return new on(e);
    }, t.prototype.Wt = function(t, n) {
        return C(null !== n, "Didn't receive transformResult for NUMERIC_ADD transform"), 
        n;
    }, 
    /**
     * Inspects the provided value, returning the provided value if it is already
     * a NumberValue, otherwise returning a coerced IntegerValue of 0.
     */
    t.prototype.zt = function(t) {
        return t instanceof rn ? t : new sn(0);
    }, t.prototype.isEqual = function(n) {
        return n instanceof t && this.Kt.isEqual(n.Kt);
    }, t;
}();

function xt(t) {
    return t instanceof wn ? t.Ht.slice() : [];
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Provides a set of fields that can be used to partially patch a document.
 * FieldMask is used in conjunction with ObjectValue.
 * Examples:
 *   foo - Overwrites foo entirely with the provided value. If foo is not
 *         present in the companion ObjectValue, the field is deleted.
 *   foo.bar - Overwrites only the field bar of the object foo.
 *             If foo is not an object, foo is replaced with an object
 *             containing foo
 */ var jt, Ut, Lt = /** @class */ function() {
    function t(t) {
        this.fields = t;
        // TODO(dimond): validation of FieldMask
        }
    return t.Jt = function(n) {
        return new t(n);
    }, t.Yt = function(n) {
        var i = new Ct(Et.G);
        return n.forEach((function(t) {
            return i = i.add(t);
        })), new t(i);
    }, 
    /**
     * Verifies that `fieldPath` is included by at least one field in this field
     * mask.
     *
     * This is an O(n) operation, where `n` is the size of the field mask.
     */
    t.prototype.Xt = function(t) {
        var n = !1;
        return this.fields.forEach((function(i) {
            i.$(t) && (n = !0);
        })), n;
    }, t.prototype.isEqual = function(t) {
        return this.fields.isEqual(t.fields);
    }, t;
}(), Bt = /** @class */ function() {
    function t(t, n) {
        this.field = t, this.transform = n;
    }
    return t.prototype.isEqual = function(t) {
        return this.field.isEqual(t.field) && this.transform.isEqual(t.transform);
    }, t;
}(), Mt = function(
/**
     * The version at which the mutation was committed:
     *
     * - For most operations, this is the updateTime in the WriteResult.
     * - For deletes, the commitTime of the WriteResponse (because deletes are
     *   not stored and have no updateTime).
     *
     * Note that these versions can be different: No-op writes will not change
     * the updateTime even though the commitTime advances.
     */
t, 
/**
     * The resulting fields returned from the backend after a
     * TransformMutation has been committed. Contains one FieldValue for each
     * FieldTransform that was in the mutation.
     *
     * Will be null if the mutation was not a TransformMutation.
     */
n) {
    this.version = t, this.transformResults = n;
};

/** A field path and the TransformOperation to perform upon it. */ (Ut = jt || (jt = {}))[Ut.Set = 0] = "Set", 
Ut[Ut.$t = 1] = "__PRIVATE_Patch", Ut[Ut.Transform = 2] = "Transform", Ut[Ut.Zt = 3] = "__PRIVATE_Delete", 
Ut[Ut.Verify = 4] = "Verify";

/**
 * Encodes a precondition for a mutation. This follows the model that the
 * backend accepts with the special case of an explicit "empty" precondition
 * (meaning no precondition).
 */
var qt, Qt, Gt, Wt, zt = /** @class */ function() {
    function t(t, n) {
        this.updateTime = t, this.exists = n, C(void 0 === t || void 0 === n, 'Precondition can specify "exists" or "updateTime" but not both');
    }
    /** Creates a new Precondition with an exists flag. */    return t.exists = function(n) {
        return new t(void 0, n);
    }, 
    /** Creates a new Precondition based on a version a document exists at. */
    t.updateTime = function(n) {
        return new t(n);
    }, Object.defineProperty(t.prototype, "tn", {
        /** Returns whether this Precondition is empty. */
        get: function() {
            return void 0 === this.updateTime && void 0 === this.exists;
        },
        enumerable: !0,
        configurable: !0
    }), 
    /**
     * Returns true if the preconditions is valid for the given document
     * (or null if no document is available).
     */
    t.prototype.nn = function(t) {
        return void 0 !== this.updateTime ? t instanceof pn && t.version.isEqual(this.updateTime) : void 0 !== this.exists ? this.exists === t instanceof pn : (C(this.tn, "Precondition should be empty"), 
        !0);
    }, t.prototype.isEqual = function(t) {
        return n = this.updateTime, i = t.updateTime, (null != n ? !(!i || !n.isEqual(i)) : n === i) && this.exists === t.exists;
        var n, i;
    }, t.NONE = new t, t;
}(), Kt = /** @class */ function() {
    function t() {}
    return t.prototype.in = function(t) {
        null != t && C(t.key.isEqual(this.key), "Can only apply a mutation to a document with the same key");
    }, 
    /**
     * Returns the version from the given document for use as the result of a
     * mutation. Mutations are defined to return the version of the base document
     * only if it is an existing document. Deleted and unknown documents have a
     * post-mutation version of SnapshotVersion.MIN.
     */
    t.en = function(t) {
        return t instanceof pn ? t.version : yt.MIN;
    }, t;
}(), Ht = /** @class */ function(t) {
    function n(n, i, e) {
        var r = t.call(this) || this;
        return r.key = n, r.value = i, r.rn = e, r.type = jt.Set, r;
    }
    return i(n, t), n.prototype.Wt = function(t, n) {
        this.in(t), C(null == n.transformResults, "Transform results received by SetMutation.");
        // Unlike applyToLocalView, if we're applying a mutation to a remote
        // document the server has accepted the mutation so the precondition must
        // have held.
        var i = n.version;
        return new pn(this.key, i, {
            hasCommittedMutations: !0
        }, this.value);
    }, n.prototype.Gt = function(t, n, i) {
        if (this.in(t), !this.rn.nn(t)) return t;
        var e = Kt.en(t);
        return new pn(this.key, e, {
            un: !0
        }, this.value);
    }, n.prototype.sn = function(t) {
        return null;
    }, n.prototype.isEqual = function(t) {
        return t instanceof n && this.key.isEqual(t.key) && this.value.isEqual(t.value) && this.rn.isEqual(t.rn);
    }, n;
}(Kt), Jt = /** @class */ function(t) {
    function n(n, i, e, r) {
        var u = t.call(this) || this;
        return u.key = n, u.data = i, u.on = e, u.rn = r, u.type = jt.$t, u;
    }
    return i(n, t), n.prototype.Wt = function(t, n) {
        if (this.in(t), C(null == n.transformResults, "Transform results received by PatchMutation."), 
        !this.rn.nn(t)) 
        // Since the mutation was not rejected, we know that the  precondition
        // matched on the backend. We therefore must not have the expected version
        // of the document in our cache and return an UnknownDocument with the
        // known updateTime.
        return new bn(this.key, n.version);
        var i = this.hn(t);
        return new pn(this.key, n.version, {
            hasCommittedMutations: !0
        }, i);
    }, n.prototype.Gt = function(t, n, i) {
        if (this.in(t), !this.rn.nn(t)) return t;
        var e = Kt.en(t), r = this.hn(t);
        return new pn(this.key, e, {
            un: !0
        }, r);
    }, n.prototype.sn = function(t) {
        return null;
    }, n.prototype.isEqual = function(t) {
        return t instanceof n && this.key.isEqual(t.key) && this.on.isEqual(t.on) && this.rn.isEqual(t.rn);
    }, 
    /**
     * Patches the data of document if available or creates a new document. Note
     * that this does not check whether or not the precondition of this patch
     * holds.
     */
    n.prototype.hn = function(t) {
        var n;
        return n = t instanceof pn ? t.data() : vn.EMPTY, this.cn(n);
    }, n.prototype.cn = function(t) {
        var n = this;
        return this.on.fields.forEach((function(i) {
            if (!i.J()) {
                var e = n.data.field(i);
                t = null !== e ? t.set(i, e) : t.delete(i);
            }
        })), t;
    }, n;
}(Kt), Yt = /** @class */ function(t) {
    function n(n, i) {
        var e = t.call(this) || this;
        return e.key = n, e.fieldTransforms = i, e.type = jt.Transform, 
        // NOTE: We set a precondition of exists: true as a safety-check, since we
        // always combine TransformMutations with a SetMutation or PatchMutation which
        // (if successful) should end up with an existing document.
        e.rn = zt.exists(!0), e;
    }
    return i(n, t), n.prototype.Wt = function(t, n) {
        if (this.in(t), C(null != n.transformResults, "Transform results missing for TransformMutation."), 
        !this.rn.nn(t)) 
        // Since the mutation was not rejected, we know that the  precondition
        // matched on the backend. We therefore must not have the expected version
        // of the document in our cache and return an UnknownDocument with the
        // known updateTime.
        return new bn(this.key, n.version);
        var i = this.an(t), e = this.fn(t, n.transformResults), r = n.version, u = this.ln(i.data(), e);
        return new pn(this.key, r, {
            hasCommittedMutations: !0
        }, u);
    }, n.prototype.Gt = function(t, n, i) {
        if (this.in(t), !this.rn.nn(t)) return t;
        var e = this.an(t), r = this.dn(i, t, n), u = this.ln(e.data(), r);
        return new pn(this.key, e.version, {
            un: !0
        }, u);
    }, n.prototype.sn = function(t) {
        for (var n = null, i = 0, e = this.fieldTransforms; i < e.length; i++) {
            var r = e[i], u = t instanceof pn ? t.field(r.field) : void 0, s = r.transform.zt(u || null);
            null != s && (n = null == n ? vn.EMPTY.set(r.field, s) : n.set(r.field, s));
        }
        return n;
    }, n.prototype.isEqual = function(t) {
        return t instanceof n && this.key.isEqual(t.key) && k(this.fieldTransforms, t.fieldTransforms) && this.rn.isEqual(t.rn);
    }, 
    /**
     * Asserts that the given MaybeDocument is actually a Document and verifies
     * that it matches the key for this mutation. Since we only support
     * transformations with precondition exists this method is guaranteed to be
     * safe.
     */
    n.prototype.an = function(t) {
        return C(t instanceof pn, "Unknown MaybeDocument type " + t), C(t.key.isEqual(this.key), "Can only transform a document with the same key"), 
        t;
    }, 
    /**
     * Creates a list of "transform results" (a transform result is a field value
     * representing the result of applying a transform) for use after a
     * TransformMutation has been acknowledged by the server.
     *
     * @param baseDoc The document prior to applying this mutation batch.
     * @param serverTransformResults The transform results received by the server.
     * @return The transform results list.
     */
    n.prototype.fn = function(t, n) {
        var i = [];
        C(this.fieldTransforms.length === n.length, "server transform result count (" + n.length + ") should match field transform count (" + this.fieldTransforms.length + ")");
        for (var e = 0; e < n.length; e++) {
            var r = this.fieldTransforms[e], u = r.transform, s = null;
            t instanceof pn && (s = t.field(r.field)), i.push(u.Wt(s, n[e]));
        }
        return i;
    }, 
    /**
     * Creates a list of "transform results" (a transform result is a field value
     * representing the result of applying a transform) for use when applying a
     * TransformMutation locally.
     *
     * @param localWriteTime The local time of the transform mutation (used to
     *     generate ServerTimestampValues).
     * @param maybeDoc The current state of the document after applying all
     *     previous mutations.
     * @param baseDoc The document prior to applying this mutation batch.
     * @return The transform results list.
     */
    n.prototype.dn = function(t, n, i) {
        for (var e = [], r = 0, u = this.fieldTransforms; r < u.length; r++) {
            var s = u[r], o = s.transform, h = null;
            n instanceof pn && (h = n.field(s.field)), null === h && i instanceof pn && (
            // If the current document does not contain a value for the mutated
            // field, use the value that existed before applying this mutation
            // batch. This solves an edge case where a PatchMutation clears the
            // values in a nested map before the TransformMutation is applied.
            h = i.field(s.field)), e.push(o.Gt(h, t));
        }
        return e;
    }, n.prototype.ln = function(t, n) {
        C(n.length === this.fieldTransforms.length, "TransformResults length mismatch.");
        for (var i = 0; i < this.fieldTransforms.length; i++) {
            var e = this.fieldTransforms[i].field;
            t = t.set(e, n[i]);
        }
        return t;
    }, n;
}(Kt), Xt = /** @class */ function(t) {
    function n(n, i) {
        var e = t.call(this) || this;
        return e.key = n, e.rn = i, e.type = jt.Zt, e;
    }
    return i(n, t), n.prototype.Wt = function(t, n) {
        // Unlike applyToLocalView, if we're applying a mutation to a remote
        // document the server has accepted the mutation so the precondition must
        // have held.
        return this.in(t), C(null == n.transformResults, "Transform results received by DeleteMutation."), 
        new gn(this.key, n.version, {
            hasCommittedMutations: !0
        });
    }, n.prototype.Gt = function(t, n, i) {
        return this.in(t), this.rn.nn(t) ? (t && C(t.key.isEqual(this.key), "Can only apply mutation to document with same key"), 
        new gn(this.key, yt.B())) : t;
    }, n.prototype.sn = function(t) {
        return null;
    }, n.prototype.isEqual = function(t) {
        return t instanceof n && this.key.isEqual(t.key) && this.rn.isEqual(t.rn);
    }, n;
}(Kt), $t = /** @class */ function(t) {
    function n(n, i) {
        var e = t.call(this) || this;
        return e.key = n, e.rn = i, e.type = jt.Verify, e;
    }
    return i(n, t), n.prototype.Wt = function(t, n) {
        S("VerifyMutation should only be used in Transactions.");
    }, n.prototype.Gt = function(t, n, i) {
        S("VerifyMutation should only be used in Transactions.");
    }, n.prototype.sn = function(t) {
        S("VerifyMutation should only be used in Transactions.");
    }, n.prototype.isEqual = function(t) {
        return t instanceof n && this.key.isEqual(t.key) && this.rn.isEqual(t.rn);
    }, n;
}(Kt);

/**
 * A mutation describes a self-contained change to a document. Mutations can
 * create, replace, delete, and update subsets of documents.
 *
 * Mutations not only act on the value of the document but also its version.
 *
 * For local mutations (mutations that haven't been committed yet), we preserve
 * the existing version for Set, Patch, and Transform mutations. For Delete
 * mutations, we reset the version to 0.
 *
 * Here's the expected transition table.
 *
 * MUTATION           APPLIED TO            RESULTS IN
 *
 * SetMutation        Document(v3)          Document(v3)
 * SetMutation        NoDocument(v3)        Document(v0)
 * SetMutation        null                  Document(v0)
 * PatchMutation      Document(v3)          Document(v3)
 * PatchMutation      NoDocument(v3)        NoDocument(v3)
 * PatchMutation      null                  null
 * TransformMutation  Document(v3)          Document(v3)
 * TransformMutation  NoDocument(v3)        NoDocument(v3)
 * TransformMutation  null                  null
 * DeleteMutation     Document(v3)          NoDocument(v0)
 * DeleteMutation     NoDocument(v3)        NoDocument(v0)
 * DeleteMutation     null                  NoDocument(v0)
 *
 * For acknowledged mutations, we use the updateTime of the WriteResponse as
 * the resulting version for Set, Patch, and Transform mutations. As deletes
 * have no explicit update time, we use the commitTime of the WriteResponse for
 * Delete mutations.
 *
 * If a mutation is acknowledged by the backend but fails the precondition check
 * locally, we return an `UnknownDocument` and rely on Watch to send us the
 * updated version.
 *
 * Note that TransformMutations don't create Documents (in the case of being
 * applied to a NoDocument), even though they would on the backend. This is
 * because the client always combines the TransformMutation with a SetMutation
 * or PatchMutation and we only want to apply the transform if the prior
 * mutation resulted in a Document (always true for a SetMutation, but not
 * necessarily for a PatchMutation).
 *
 * ## Subclassing Notes
 *
 * Subclasses of Mutation need to implement applyToRemoteDocument() and
 * applyToLocalView() to implement the actual behavior of applying the mutation
 * to some source document.
 */
// This order is defined by the backend.
(Qt = qt || (qt = {}))[Qt.vn = 0] = "__PRIVATE_NullValue", Qt[Qt.wn = 1] = "__PRIVATE_BooleanValue", 
Qt[Qt.mn = 2] = "__PRIVATE_NumberValue", Qt[Qt.pn = 3] = "__PRIVATE_TimestampValue", 
Qt[Qt.gn = 4] = "__PRIVATE_StringValue", Qt[Qt.bn = 5] = "__PRIVATE_BlobValue", 
Qt[Qt.yn = 6] = "__PRIVATE_RefValue", Qt[Qt._n = 7] = "__PRIVATE_GeoPointValue", 
Qt[Qt.ArrayValue = 8] = "ArrayValue", Qt[Qt.In = 9] = "__PRIVATE_ObjectValue", (Wt = Gt || (Gt = {}))[Wt.Tn = 0] = "__PRIVATE_Default", 
Wt[Wt.En = 1] = "__PRIVATE_Estimate", Wt[Wt.Rn = 2] = "__PRIVATE_Previous";

/** Holds properties that define field value deserialization options. */
var Zt = /** @class */ function() {
    function t(t, n) {
        this.An = t, this.timestampsInSnapshots = n;
    }
    return t.Dn = function(n, i) {
        switch (n.serverTimestamps) {
          case "estimate":
            return new t(Gt.En, i);

          case "previous":
            return new t(Gt.Rn, i);

          case "none":
 // Fall-through intended.
                      case void 0:
            return new t(Gt.Tn, i);

          default:
            return S("fromSnapshotOptions() called with invalid options.");
        }
    }, t;
}(), tn = /** @class */ function() {
    function t() {}
    return t.prototype.toString = function() {
        var t = this.value();
        return null === t ? "null" : t.toString();
    }, t.prototype.Pn = function(t) {
        return C(this.Sn !== t.Sn, "Default compareTo should not be used for values of same type."), 
        N(this.Sn, t.Sn);
    }, t;
}(), nn = /** @class */ function(t) {
    function n() {
        var n = t.call(this) || this;
        return n.Sn = qt.vn, 
        // internalValue is unused but we add it to work around
        // https://github.com/Microsoft/TypeScript/issues/15585
        n.Ht = null, n;
    }
    return i(n, t), n.prototype.value = function(t) {
        return null;
    }, n.prototype.isEqual = function(t) {
        return t instanceof n;
    }, n.prototype.h = function(t) {
        return t instanceof n ? 0 : this.Pn(t);
    }, n.prototype.Cn = function() {
        return 4;
    }, n.Vn = new n, n;
}(tn), en = /** @class */ function(t) {
    function n(n) {
        var i = t.call(this) || this;
        return i.Ht = n, i.Sn = qt.wn, i;
    }
    return i(n, t), n.prototype.value = function(t) {
        return this.Ht;
    }, n.prototype.isEqual = function(t) {
        return t instanceof n && this.Ht === t.Ht;
    }, n.prototype.h = function(t) {
        return t instanceof n ? N(this, t) : this.Pn(t);
    }, n.prototype.Cn = function() {
        return 4;
    }, n.of = function(t) {
        return t ? n.Nn : n.kn;
    }, n.Nn = new n(!0), n.kn = new n(!1), n;
}(tn), rn = /** @class */ function(t) {
    function n(n) {
        var i = t.call(this) || this;
        return i.Ht = n, i.Sn = qt.mn, i;
    }
    return i(n, t), n.prototype.value = function(t) {
        return this.Ht;
    }, n.prototype.h = function(t) {
        return t instanceof n ? (i = this.Ht, e = t.Ht, i < e ? -1 : i > e ? 1 : i === e ? 0 : 
        // one or both are NaN.
        isNaN(i) ? isNaN(e) ? 0 : -1 : 1) : this.Pn(t);
        /** Utility function to compare doubles (using Firestore semantics for NaN). */
        var i, e;
        /**
 * Utility function to check numbers for equality using Firestore semantics
 * (NaN === NaN, -0.0 !== 0.0).
 */    }, n.prototype.Cn = function() {
        return 8;
    }, n;
}(tn);

/**
 * A field value represents a datatype as stored by Firestore.
 */ function un(t, n) {
    // Implemented based on Object.is() polyfill from
    // https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
    return t === n ? 0 !== t || 1 / t == 1 / n : t != t && n != n;
}

var sn = /** @class */ function(t) {
    function n() {
        return null !== t && t.apply(this, arguments) || this;
    }
    return i(n, t), n.prototype.isEqual = function(t) {
        // NOTE: DoubleValue and IntegerValue instances may compareTo() the same,
        // but that doesn't make them equal via isEqual().
        return t instanceof n && un(this.Ht, t.Ht);
    }, n;
}(rn), on = /** @class */ function(t) {
    function n() {
        return null !== t && t.apply(this, arguments) || this;
    }
    return i(n, t), n.prototype.isEqual = function(t) {
        // NOTE: DoubleValue and IntegerValue instances may compareTo() the same,
        // but that doesn't make them equal via isEqual().
        return t instanceof n && un(this.Ht, t.Ht);
    }, n.On = new n(NaN), n.POSITIVE_INFINITY = new n(1 / 0), n.NEGATIVE_INFINITY = new n(-1 / 0), 
    n;
}(rn), hn = /** @class */ function(t) {
    function n(n) {
        var i = t.call(this) || this;
        return i.Ht = n, i.Sn = qt.gn, i;
    }
    return i(n, t), n.prototype.value = function(t) {
        return this.Ht;
    }, n.prototype.isEqual = function(t) {
        return t instanceof n && this.Ht === t.Ht;
    }, n.prototype.h = function(t) {
        return t instanceof n ? N(this.Ht, t.Ht) : this.Pn(t);
    }, n.prototype.Cn = function() {
        // See https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures:
        // "JavaScript's String type is [...] a set of elements of 16-bit unsigned
        // integer values"
        return 2 * this.Ht.length;
    }, n;
}(tn), cn = /** @class */ function(t) {
    function n(n) {
        var i = t.call(this) || this;
        return i.Ht = n, i.Sn = qt.pn, i;
    }
    return i(n, t), n.prototype.value = function(t) {
        return !t || t.timestampsInSnapshots ? this.Ht : this.Ht.toDate();
    }, n.prototype.isEqual = function(t) {
        return t instanceof n && this.Ht.isEqual(t.Ht);
    }, n.prototype.h = function(t) {
        return t instanceof n ? this.Ht.j(t.Ht) : t instanceof an ? -1 : this.Pn(t);
    }, n.prototype.Cn = function() {
        // Timestamps are made up of two distinct numbers (seconds + nanoseconds)
        return 16;
    }, n;
}(tn), an = /** @class */ function(t) {
    function n(n, i) {
        var e = t.call(this) || this;
        return e.Fn = n, e.previousValue = i, e.Sn = qt.pn, e;
    }
    return i(n, t), n.prototype.value = function(t) {
        return t && t.An === Gt.En ? new cn(this.Fn).value(t) : t && t.An === Gt.Rn && this.previousValue ? this.previousValue.value(t) : null;
    }, n.prototype.isEqual = function(t) {
        return t instanceof n && this.Fn.isEqual(t.Fn);
    }, n.prototype.h = function(t) {
        return t instanceof n ? this.Fn.j(t.Fn) : t instanceof cn ? 1 : this.Pn(t);
    }, n.prototype.toString = function() {
        return "<ServerTimestamp localTime=" + this.Fn.toString() + ">";
    }, n.prototype.Cn = function() {
        /* localWriteTime */
        return 16 + (this.previousValue ? this.previousValue.Cn() : 0);
    }, n;
}(tn), fn = /** @class */ function(t) {
    function n(n) {
        var i = t.call(this) || this;
        return i.Ht = n, i.Sn = qt.bn, i;
    }
    return i(n, t), n.prototype.value = function(t) {
        return this.Ht;
    }, n.prototype.isEqual = function(t) {
        return t instanceof n && this.Ht.isEqual(t.Ht);
    }, n.prototype.h = function(t) {
        return t instanceof n ? this.Ht.j(t.Ht) : this.Pn(t);
    }, n.prototype.Cn = function() {
        return this.Ht.xn();
    }, n;
}(tn), ln = /** @class */ function(t) {
    function n(n, i) {
        var e = t.call(this) || this;
        return e.s = n, e.key = i, e.Sn = qt.yn, e;
    }
    return i(n, t), n.prototype.value = function(t) {
        return this.key;
    }, n.prototype.isEqual = function(t) {
        return t instanceof n && (this.key.isEqual(t.key) && this.s.isEqual(t.s));
    }, n.prototype.h = function(t) {
        if (t instanceof n) {
            var i = this.s.h(t.s);
            return 0 !== i ? i : Rt.G(this.key, t.key);
        }
        return this.Pn(t);
    }, n.prototype.Cn = function() {
        return this.s.projectId.length + this.s.database.length + this.key.toString().length;
    }, n;
}(tn), dn = /** @class */ function(t) {
    function n(n) {
        var i = t.call(this) || this;
        return i.Ht = n, i.Sn = qt._n, i;
    }
    return i(n, t), n.prototype.value = function(t) {
        return this.Ht;
    }, n.prototype.isEqual = function(t) {
        return t instanceof n && this.Ht.isEqual(t.Ht);
    }, n.prototype.h = function(t) {
        return t instanceof n ? this.Ht.j(t.Ht) : this.Pn(t);
    }, n.prototype.Cn = function() {
        // GeoPoints are made up of two distinct numbers (latitude + longitude)
        return 16;
    }, n;
}(tn), vn = /** @class */ function(t) {
    function n(n) {
        var i = t.call(this) || this;
        return i.Ht = n, i.Sn = qt.In, i;
    }
    return i(n, t), n.prototype.value = function(t) {
        var n = {};
        return this.Ht.pt((function(i, e) {
            n[i] = e.value(t);
        })), n;
    }, n.prototype.forEach = function(t) {
        this.Ht.pt(t);
    }, n.prototype.isEqual = function(t) {
        if (t instanceof n) {
            for (var i = this.Ht.bt(), e = t.Ht.bt(); i.At() && e.At(); ) {
                var r = i.Rt(), u = e.Rt();
                if (r.key !== u.key || !r.value.isEqual(u.value)) return !1;
            }
            return !i.At() && !e.At();
        }
        return !1;
    }, n.prototype.h = function(t) {
        if (t instanceof n) {
            for (var i = this.Ht.bt(), e = t.Ht.bt(); i.At() && e.At(); ) {
                var r = i.Rt(), u = e.Rt(), s = N(r.key, u.key) || r.value.h(u.value);
                if (s) return s;
            }
            // Only equal if both iterators are exhausted
                        return N(i.At(), e.At());
        }
        return this.Pn(t);
    }, n.prototype.set = function(t, i) {
        if (C(!t.J(), "Cannot set field for empty path on ObjectValue"), 1 === t.length) return this.jn(t.Y(), i);
        var e = this.child(t.Y());
        e instanceof n || (e = n.EMPTY);
        var r = e.set(t.K(), i);
        return this.jn(t.Y(), r);
    }, n.prototype.delete = function(t) {
        if (C(!t.J(), "Cannot delete field for empty path on ObjectValue"), 1 === t.length) return new n(this.Ht.remove(t.Y()));
        // nested field
        var i = this.child(t.Y());
        if (i instanceof n) {
            var e = i.delete(t.K());
            return new n(this.Ht.lt(t.Y(), e));
        }
        // Don't actually change a primitive value to an object for a delete
        return this;
    }, n.prototype.contains = function(t) {
        return null !== this.field(t);
    }, n.prototype.field = function(t) {
        C(!t.J(), "Can't get field of empty path");
        var i = this;
        return t.forEach((function(t) {
            i = i instanceof n ? i.Ht.get(t) : null;
        })), i;
    }, 
    /**
     * Returns a FieldMask built from all FieldPaths starting from this ObjectValue,
     * including paths from nested objects.
     */
    n.prototype.on = function() {
        var t = new Ct(Et.G);
        return this.Ht.forEach((function(i, e) {
            var r = new Et([ i ]);
            if (e instanceof n) {
                var u = e.on().fields;
                u.J() ? 
                // Preserve the empty map by adding it to the FieldMask.
                t = t.add(r) : 
                // For nested and non-empty ObjectValues, add the FieldPath of the
                // leaf nodes.
                u.forEach((function(n) {
                    t = t.add(r.child(n));
                }));
            } else t = t.add(r);
        })), Lt.Jt(t);
    }, n.prototype.Cn = function() {
        var t = 0;
        return this.Ht.pt((function(n, i) {
            t += n.length + i.Cn();
        })), t;
    }, n.prototype.toString = function() {
        return this.Ht.toString();
    }, n.prototype.child = function(t) {
        return this.Ht.get(t) || void 0;
    }, n.prototype.jn = function(t, i) {
        return new n(this.Ht.lt(t, i));
    }, n.EMPTY = new n(new At(N)), n;
}(tn), wn = /** @class */ function(t) {
    function n(n) {
        var i = t.call(this) || this;
        return i.Ht = n, i.Sn = qt.ArrayValue, i;
    }
    return i(n, t), n.prototype.value = function(t) {
        return this.Ht.map((function(n) {
            return n.value(t);
        }));
    }, 
    /**
     * Returns true if the given value is contained in this array.
     */
    n.prototype.contains = function(t) {
        for (var n = 0, i = this.Ht; n < i.length; n++) {
            if (i[n].isEqual(t)) return !0;
        }
        return !1;
    }, n.prototype.forEach = function(t) {
        this.Ht.forEach(t);
    }, n.prototype.isEqual = function(t) {
        if (t instanceof n) {
            if (this.Ht.length !== t.Ht.length) return !1;
            for (var i = 0; i < this.Ht.length; i++) if (!this.Ht[i].isEqual(t.Ht[i])) return !1;
            return !0;
        }
        return !1;
    }, n.prototype.h = function(t) {
        if (t instanceof n) {
            for (var i = Math.min(this.Ht.length, t.Ht.length), e = 0; e < i; e++) {
                var r = this.Ht[e].h(t.Ht[e]);
                if (r) return r;
            }
            return N(this.Ht.length, t.Ht.length);
        }
        return this.Pn(t);
    }, n.prototype.Cn = function() {
        return this.Ht.reduce((function(t, n) {
            return t + n.Cn();
        }), 0);
    }, n.prototype.toString = function() {
        return "[" + this.Ht.map((function(t) {
            return t.toString();
        })).join(",") + "]";
    }, n;
}(tn), mn = /** @class */ function() {
    function t(t, n) {
        this.key = t, this.version = n;
    }
    return t.Un = function(t, n) {
        return Rt.G(t.key, n.key);
    }, t;
}(), pn = /** @class */ function(t) {
    function n(n, i, e, r, u, s) {
        var o = t.call(this, n, i) || this;
        return o.Ln = r, o.proto = u, o.converter = s, C(void 0 !== o.Ln || void 0 !== o.proto && void 0 !== o.converter, "If objectValue is not defined, proto and converter need to be set."), 
        o.un = !!e.un, o.hasCommittedMutations = !!e.hasCommittedMutations, o;
    }
    return i(n, t), n.prototype.field = function(t) {
        if (this.Ln) return this.Ln.field(t);
        this.Bn || (
        // TODO(b/136090445): Remove the cache when `getField` is no longer
        // called during Query ordering.
        this.Bn = new Map);
        var n = t.nt(), i = this.Bn.get(n);
        if (void 0 === i) {
            // Instead of deserializing the full Document proto, we only
            // deserialize the value at the requested field path. This speeds up
            // Query execution as query filters can discard documents based on a
            // single field.
            var e = this.Mn(t);
            i = void 0 === e ? null : this.converter(e), this.Bn.set(n, i);
        }
        return i;
    }, n.prototype.data = function() {
        var t = this;
        if (!this.Ln) {
            var n = vn.EMPTY;
            Y(this.proto.fields || {}, (function(i, e) {
                n = n.set(new Et([ i ]), t.converter(e));
            })), this.Ln = n, 
            // Once objectValue is computed, values inside the fieldValueCache are no
            // longer accessed.
            this.Bn = void 0;
        }
        return this.Ln;
    }, n.prototype.value = function() {
        return this.data().value();
    }, n.prototype.isEqual = function(t) {
        return t instanceof n && this.key.isEqual(t.key) && this.version.isEqual(t.version) && this.un === t.un && this.hasCommittedMutations === t.hasCommittedMutations && this.data().isEqual(t.data());
    }, n.prototype.toString = function() {
        return "Document(" + this.key + ", " + this.version + ", " + this.data().toString() + ", {hasLocalMutations: " + this.un + "}), {hasCommittedMutations: " + this.hasCommittedMutations + "})";
    }, Object.defineProperty(n.prototype, "hasPendingWrites", {
        get: function() {
            return this.un || this.hasCommittedMutations;
        },
        enumerable: !0,
        configurable: !0
    }), 
    /**
     * Returns the nested Protobuf value for 'path`. Can only be called if
     * `proto` was provided at construction time.
     */
    n.prototype.Mn = function(t) {
        C(void 0 !== this.proto, "Can only call getProtoField() when proto is defined");
        for (var n = this.proto.fields ? this.proto.fields[t.Y()] : void 0, i = 1; i < t.length; ++i) {
            if (!n || !n.mapValue || !n.mapValue.fields) return;
            n = n.mapValue.fields[t.get(i)];
        }
        return n;
    }, n.qn = function(t, n, i) {
        var e = n.field(t), r = i.field(t);
        return null !== e && null !== r ? e.h(r) : S("Trying to compare documents on fields that don't exist");
    }, n;
}(mn), gn = /** @class */ function(t) {
    function n(n, i, e) {
        var r = t.call(this, n, i) || this;
        return r.hasCommittedMutations = !(!e || !e.hasCommittedMutations), r;
    }
    return i(n, t), n.prototype.toString = function() {
        return "NoDocument(" + this.key + ", " + this.version + ")";
    }, Object.defineProperty(n.prototype, "hasPendingWrites", {
        get: function() {
            return this.hasCommittedMutations;
        },
        enumerable: !0,
        configurable: !0
    }), n.prototype.isEqual = function(t) {
        return t instanceof n && t.hasCommittedMutations === this.hasCommittedMutations && t.version.isEqual(this.version) && t.key.isEqual(this.key);
    }, n;
}(mn), bn = /** @class */ function(t) {
    function n() {
        return null !== t && t.apply(this, arguments) || this;
    }
    return i(n, t), n.prototype.toString = function() {
        return "UnknownDocument(" + this.key + ", " + this.version + ")";
    }, Object.defineProperty(n.prototype, "hasPendingWrites", {
        get: function() {
            return !0;
        },
        enumerable: !0,
        configurable: !0
    }), n.prototype.isEqual = function(t) {
        return t instanceof n && t.version.isEqual(this.version) && t.key.isEqual(this.key);
    }, n;
}(mn), yn = Number, _n = yn.MIN_SAFE_INTEGER || -(Math.pow(2, 53) - 1), In = yn.MAX_SAFE_INTEGER || Math.pow(2, 53) - 1, Tn = yn.isInteger || function(t) {
    return "number" == typeof t && isFinite(t) && Math.floor(t) === t;
};

/**
 * Returns whether a variable is either undefined or null.
 */
function En(t) {
    return null == t;
}

/**
 * Returns whether a value is an integer and in the safe integer range
 * @param value The value to test for being an integer and in the safe range
 */ function Rn(t) {
    return Tn(t) && t <= In && t >= _n;
}

/**
 * @license
 * Copyright 2019 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A Target represents the WatchTarget representation of a Query, which is used
 * by the LocalStore and the RemoteStore to keep track of and to execute
 * backend queries. While a Query can represent multiple Targets, each Targets
 * maps to a single WatchTarget in RemoteStore and a single TargetData entry
 * in persistence.
 */ var An, Dn, Pn = /** @class */ function() {
    /**
     * Initializes a Target with a path and optional additional query constraints.
     * Path must currently be empty if this is a collection group query.
     *
     * NOTE: you should always construct `Target` from `Query.toTarget` instead of
     * using this constructor, because `Query` provides an implicit `orderBy`
     * property.
     */
    function t(t, n, i, e, r, u, s) {
        void 0 === n && (n = null), void 0 === i && (i = []), void 0 === e && (e = []), 
        void 0 === r && (r = null), void 0 === u && (u = null), void 0 === s && (s = null), 
        this.path = t, this.collectionGroup = n, this.orderBy = i, this.filters = e, this.limit = r, 
        this.startAt = u, this.endAt = s, this.Qn = null;
    }
    return t.prototype.canonicalId = function() {
        if (null === this.Qn) {
            var t = this.path.nt();
            null !== this.collectionGroup && (t += "|cg:" + this.collectionGroup), t += "|f:";
            for (var n = 0, i = this.filters; n < i.length; n++) {
                t += i[n].canonicalId(), t += ",";
            }
            t += "|ob:";
            // TODO(dimond): make this collision resistant
            for (var e = 0, r = this.orderBy; e < r.length; e++) {
                t += r[e].canonicalId(), t += ",";
            }
            En(this.limit) || (t += "|l:", t += this.limit), this.startAt && (t += "|lb:", t += this.startAt.canonicalId()), 
            this.endAt && (t += "|ub:", t += this.endAt.canonicalId()), this.Qn = t;
        }
        return this.Qn;
    }, t.prototype.toString = function() {
        var t = this.path.nt();
        return null !== this.collectionGroup && (t += " collectionGroup=" + this.collectionGroup), 
        this.filters.length > 0 && (t += ", filters: [" + this.filters.join(", ") + "]"), 
        En(this.limit) || (t += ", limit: " + this.limit), this.orderBy.length > 0 && (t += ", orderBy: [" + this.orderBy.join(", ") + "]"), 
        this.startAt && (t += ", startAt: " + this.startAt.canonicalId()), this.endAt && (t += ", endAt: " + this.endAt.canonicalId()), 
        "Target(" + t + ")";
    }, t.prototype.isEqual = function(t) {
        if (this.limit !== t.limit) return !1;
        if (this.orderBy.length !== t.orderBy.length) return !1;
        for (var n = 0; n < this.orderBy.length; n++) if (!this.orderBy[n].isEqual(t.orderBy[n])) return !1;
        if (this.filters.length !== t.filters.length) return !1;
        for (n = 0; n < this.filters.length; n++) if (!this.filters[n].isEqual(t.filters[n])) return !1;
        return this.collectionGroup === t.collectionGroup && (!!this.path.isEqual(t.path) && (!(null !== this.startAt ? !this.startAt.isEqual(t.startAt) : null !== t.startAt) && (null !== this.endAt ? this.endAt.isEqual(t.endAt) : null === t.endAt)));
    }, t.prototype.Gn = function() {
        return Rt.ht(this.path) && null === this.collectionGroup && 0 === this.filters.length;
    }, t;
}();

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ (Dn = An || (An = {})).Wn = "F", Dn.zn = "L";

/**
 * Query encapsulates all the query attributes we support in the SDK. It can
 * be run against the LocalStore, as well as be converted to a `Target` to
 * query the RemoteStore results.
 */
var Sn, Cn, Vn, Nn, kn = /** @class */ function() {
    /**
     * Initializes a Query with a path and optional additional query constraints.
     * Path must currently be empty if this is a collection group query.
     */
    function t(t, n, i, e, r, u, s, o) {
        void 0 === n && (n = null), void 0 === i && (i = []), void 0 === e && (e = []), 
        void 0 === r && (r = null), void 0 === u && (u = An.Wn), void 0 === s && (s = null), 
        void 0 === o && (o = null), this.path = t, this.collectionGroup = n, this.Kn = i, 
        this.filters = e, this.limit = r, this.Hn = u, this.startAt = s, this.endAt = o, 
        this.Jn = null, 
        // The corresponding `Target` of this `Query` instance.
        this.Yn = null, this.startAt && this.Xn(this.startAt), this.endAt && this.Xn(this.endAt);
    }
    return t.$n = function(n) {
        return new t(n);
    }, Object.defineProperty(t.prototype, "orderBy", {
        get: function() {
            if (null === this.Jn) {
                var t = this.Zn(), n = this.ti();
                if (null !== t && null === n) 
                // In order to implicitly add key ordering, we must also add the
                // inequality filter field for it to be a valid query.
                // Note that the default inequality field and key ordering is ascending.
                t.ut() ? this.Jn = [ Wn ] : this.Jn = [ new Gn(t), Wn ]; else {
                    C(null === t || null !== n && t.isEqual(n), "First orderBy should match inequality field."), 
                    this.Jn = [];
                    for (var i = !1, e = 0, r = this.Kn; e < r.length; e++) {
                        var u = r[e];
                        this.Jn.push(u), u.field.ut() && (i = !0);
                    }
                    if (!i) {
                        // The order of the implicit key ordering always matches the last
                        // explicit order by
                        var s = this.Kn.length > 0 ? this.Kn[this.Kn.length - 1].dir : qn.ASCENDING;
                        this.Jn.push(s === qn.ASCENDING ? Wn : zn);
                    }
                }
            }
            return this.Jn;
        },
        enumerable: !0,
        configurable: !0
    }), t.prototype.ni = function(n) {
        C(null == this.Zn() || !(n instanceof xn) || !n.ii() || n.field.isEqual(this.Zn()), "Query must only have one inequality field."), 
        C(!this.Gn(), "No filtering allowed for document query");
        var i = this.filters.concat([ n ]);
        return new t(this.path, this.collectionGroup, this.Kn.slice(), i, this.limit, this.Hn, this.startAt, this.endAt);
    }, t.prototype.ei = function(n) {
        C(!this.startAt && !this.endAt, "Bounds must be set after orderBy");
        // TODO(dimond): validate that orderBy does not list the same key twice.
        var i = this.Kn.concat([ n ]);
        return new t(this.path, this.collectionGroup, i, this.filters.slice(), this.limit, this.Hn, this.startAt, this.endAt);
    }, t.prototype.ri = function(n) {
        return new t(this.path, this.collectionGroup, this.Kn.slice(), this.filters.slice(), n, An.Wn, this.startAt, this.endAt);
    }, t.prototype.ui = function(n) {
        return new t(this.path, this.collectionGroup, this.Kn.slice(), this.filters.slice(), n, An.zn, this.startAt, this.endAt);
    }, t.prototype.si = function(n) {
        return new t(this.path, this.collectionGroup, this.Kn.slice(), this.filters.slice(), this.limit, this.Hn, n, this.endAt);
    }, t.prototype.oi = function(n) {
        return new t(this.path, this.collectionGroup, this.Kn.slice(), this.filters.slice(), this.limit, this.Hn, this.startAt, n);
    }, 
    /**
     * Helper to convert a collection group query into a collection query at a
     * specific path. This is used when executing collection group queries, since
     * we have to split the query into a set of collection queries at multiple
     * paths.
     */
    t.prototype.hi = function(n) {
        return new t(n, 
        /*collectionGroup=*/ null, this.Kn.slice(), this.filters.slice(), this.limit, this.Hn, this.startAt, this.endAt);
    }, 
    /**
     * Returns true if this query does not specify any query constraints that
     * could remove results.
     */
    t.prototype.ci = function() {
        return 0 === this.filters.length && null === this.limit && null == this.startAt && null == this.endAt && (0 === this.Kn.length || 1 === this.Kn.length && this.Kn[0].field.ut());
    }, 
    // TODO(b/29183165): This is used to get a unique string from a query to, for
    // example, use as a dictionary key, but the implementation is subject to
    // collisions. Make it collision-free.
    t.prototype.canonicalId = function() {
        return this.ai().canonicalId() + "|lt:" + this.Hn;
    }, t.prototype.toString = function() {
        return "Query(target=" + this.ai().toString() + "; limitType=" + this.Hn + ")";
    }, t.prototype.isEqual = function(t) {
        return this.ai().isEqual(t.ai()) && this.Hn === t.Hn;
    }, t.prototype.fi = function(t, n) {
        for (var i = !1, e = 0, r = this.orderBy; e < r.length; e++) {
            var u = r[e], s = u.compare(t, n);
            if (0 !== s) return s;
            i = i || u.field.ut();
        }
        // Assert that we actually compared by key
                return C(i, "orderBy used that doesn't compare on key field"), 0;
    }, t.prototype.matches = function(t) {
        return this.li(t) && this.di(t) && this.vi(t) && this.wi(t);
    }, t.prototype.mi = function() {
        return !En(this.limit) && this.Hn === An.Wn;
    }, t.prototype.pi = function() {
        return !En(this.limit) && this.Hn === An.zn;
    }, t.prototype.ti = function() {
        return this.Kn.length > 0 ? this.Kn[0].field : null;
    }, t.prototype.Zn = function() {
        for (var t = 0, n = this.filters; t < n.length; t++) {
            var i = n[t];
            if (i instanceof xn && i.ii()) return i.field;
        }
        return null;
    }, 
    // Checks if any of the provided Operators are included in the query and
    // returns the first one that is, or null if none are.
    t.prototype.gi = function(t) {
        for (var n = 0, i = this.filters; n < i.length; n++) {
            var e = i[n];
            if (e instanceof xn && t.indexOf(e.op) >= 0) return e.op;
        }
        return null;
    }, t.prototype.Gn = function() {
        return this.ai().Gn();
    }, t.prototype.bi = function() {
        return null !== this.collectionGroup;
    }, 
    /**
     * Converts this `Query` instance to it's corresponding `Target`
     * representation.
     */
    t.prototype.ai = function() {
        if (!this.Yn) if (this.Hn === An.Wn) this.Yn = new Pn(this.path, this.collectionGroup, this.orderBy, this.filters, this.limit, this.startAt, this.endAt); else {
            for (
            // Flip the orderBy directions since we want the last results
            var t = [], n = 0, i = this.orderBy; n < i.length; n++) {
                var e = i[n], r = e.dir === qn.DESCENDING ? qn.ASCENDING : qn.DESCENDING;
                t.push(new Gn(e.field, r));
            }
            // We need to swap the cursors to match the now-flipped query ordering.
                        var u = this.endAt ? new Qn(this.endAt.position, !this.endAt.before) : null, s = this.startAt ? new Qn(this.startAt.position, !this.startAt.before) : null;
            // Now return as a LimitType.First query.
            this.Yn = new Pn(this.path, this.collectionGroup, t, this.filters, this.limit, u, s);
        }
        return this.Yn;
    }, t.prototype.li = function(t) {
        var n = t.key.path;
        return null !== this.collectionGroup ? t.key.ct(this.collectionGroup) && this.path.$(n) : Rt.ht(this.path) ? this.path.isEqual(n) : this.path.Z(n);
    }, 
    /**
     * A document must have a value for every ordering clause in order to show up
     * in the results.
     */
    t.prototype.di = function(t) {
        for (var n = 0, i = this.Kn; n < i.length; n++) {
            var e = i[n];
            // order by key always matches
                        if (!e.field.ut() && null === t.field(e.field)) return !1;
        }
        return !0;
    }, t.prototype.vi = function(t) {
        for (var n = 0, i = this.filters; n < i.length; n++) {
            if (!i[n].matches(t)) return !1;
        }
        return !0;
    }, 
    /**
     * Makes sure a document is within the bounds, if provided.
     */
    t.prototype.wi = function(t) {
        return !(this.startAt && !this.startAt.yi(this.orderBy, t)) && (!this.endAt || !this.endAt.yi(this.orderBy, t));
    }, t.prototype.Xn = function(t) {
        C(t.position.length <= this.orderBy.length, "Bound is longer than orderBy");
    }, t;
}(), On = function() {}, Fn = /** @class */ function() {
    function t(t) {
        this.name = t;
    }
    return t.it = function(n) {
        switch (n) {
          case "<":
            return t.LESS_THAN;

          case "<=":
            return t.LESS_THAN_OR_EQUAL;

          case "==":
            return t.EQUAL;

          case ">=":
            return t.GREATER_THAN_OR_EQUAL;

          case ">":
            return t.GREATER_THAN;

          case "array-contains":
            return t.ARRAY_CONTAINS;

          case "in":
            return t.IN;

          case "array-contains-any":
            return t.ARRAY_CONTAINS_ANY;

          default:
            return S("Unknown FieldFilter operator: " + n);
        }
    }, t.prototype.toString = function() {
        return this.name;
    }, t.prototype.isEqual = function(t) {
        return this.name === t.name;
    }, t.LESS_THAN = new t("<"), t.LESS_THAN_OR_EQUAL = new t("<="), t.EQUAL = new t("=="), 
    t.GREATER_THAN = new t(">"), t.GREATER_THAN_OR_EQUAL = new t(">="), t.ARRAY_CONTAINS = new t("array-contains"), 
    t.IN = new t("in"), t.ARRAY_CONTAINS_ANY = new t("array-contains-any"), t;
}(), xn = /** @class */ function(t) {
    function n(n, i, e) {
        var r = t.call(this) || this;
        return r.field = n, r.op = i, r.value = e, r;
    }
    /**
     * Creates a filter based on the provided arguments.
     */    return i(n, t), n.create = function(t, i, e) {
        if (t.ut()) return i === Fn.IN ? (C(e instanceof wn, "Comparing on key with IN, but filter value not an ArrayValue"), 
        C(e.Ht.every((function(t) {
            return t instanceof ln;
        })), "Comparing on key with IN, but an array value was not a RefValue"), new Un(t, e)) : (C(e instanceof ln, "Comparing on key, but filter value not a RefValue"), 
        C(i !== Fn.ARRAY_CONTAINS && i !== Fn.ARRAY_CONTAINS_ANY, "'" + i.toString() + "' queries don't make sense on document keys."), 
        new jn(t, i, e));
        if (e.isEqual(nn.Vn)) {
            if (i !== Fn.EQUAL) throw new B(L.INVALID_ARGUMENT, "Invalid query. Null supports only equality comparisons.");
            return new n(t, i, e);
        }
        if (e.isEqual(on.On)) {
            if (i !== Fn.EQUAL) throw new B(L.INVALID_ARGUMENT, "Invalid query. NaN supports only equality comparisons.");
            return new n(t, i, e);
        }
        return i === Fn.ARRAY_CONTAINS ? new Ln(t, e) : i === Fn.IN ? (C(e instanceof wn, "IN filter has invalid value: " + e.toString()), 
        new Bn(t, e)) : i === Fn.ARRAY_CONTAINS_ANY ? (C(e instanceof wn, "ARRAY_CONTAINS_ANY filter has invalid value: " + e.toString()), 
        new Mn(t, e)) : new n(t, i, e);
    }, n.prototype.matches = function(t) {
        var n = t.field(this.field);
        // Only compare types with matching backend order (such as double and int).
                return null !== n && this.value.Sn === n.Sn && this._i(n.h(this.value));
    }, n.prototype._i = function(t) {
        switch (this.op) {
          case Fn.LESS_THAN:
            return t < 0;

          case Fn.LESS_THAN_OR_EQUAL:
            return t <= 0;

          case Fn.EQUAL:
            return 0 === t;

          case Fn.GREATER_THAN:
            return t > 0;

          case Fn.GREATER_THAN_OR_EQUAL:
            return t >= 0;

          default:
            return S("Unknown FieldFilter operator: " + this.op);
        }
    }, n.prototype.ii = function() {
        return [ Fn.LESS_THAN, Fn.LESS_THAN_OR_EQUAL, Fn.GREATER_THAN, Fn.GREATER_THAN_OR_EQUAL ].indexOf(this.op) >= 0;
    }, n.prototype.canonicalId = function() {
        // TODO(b/29183165): Technically, this won't be unique if two values have
        // the same description, such as the int 3 and the string "3". So we should
        // add the types in here somehow, too.
        return this.field.nt() + this.op.toString() + this.value.toString();
    }, n.prototype.isEqual = function(t) {
        return t instanceof n && (this.op.isEqual(t.op) && this.field.isEqual(t.field) && this.value.isEqual(t.value));
    }, n.prototype.toString = function() {
        return this.field.nt() + " " + this.op + " " + this.value.value();
    }, n;
}(On), jn = /** @class */ function(t) {
    function n() {
        return null !== t && t.apply(this, arguments) || this;
    }
    return i(n, t), n.prototype.matches = function(t) {
        var n = this.value, i = Rt.G(t.key, n.key);
        return this._i(i);
    }, n;
}(xn), Un = /** @class */ function(t) {
    function n(n, i) {
        var e = t.call(this, n, Fn.IN, i) || this;
        return e.value = i, e;
    }
    return i(n, t), n.prototype.matches = function(t) {
        return this.value.Ht.some((function(n) {
            return t.key.isEqual(n.key);
        }));
    }, n;
}(xn), Ln = /** @class */ function(t) {
    function n(n, i) {
        return t.call(this, n, Fn.ARRAY_CONTAINS, i) || this;
    }
    return i(n, t), n.prototype.matches = function(t) {
        var n = t.field(this.field);
        return n instanceof wn && n.contains(this.value);
    }, n;
}(xn), Bn = /** @class */ function(t) {
    function n(n, i) {
        var e = t.call(this, n, Fn.IN, i) || this;
        return e.value = i, e;
    }
    return i(n, t), n.prototype.matches = function(t) {
        var n = this.value, i = t.field(this.field);
        return null !== i && n.contains(i);
    }, n;
}(xn), Mn = /** @class */ function(t) {
    function n(n, i) {
        var e = t.call(this, n, Fn.ARRAY_CONTAINS_ANY, i) || this;
        return e.value = i, e;
    }
    return i(n, t), n.prototype.matches = function(t) {
        var n = this, i = t.field(this.field);
        return i instanceof wn && i.Ht.some((function(t) {
            return n.value.contains(t);
        }));
    }, n;
}(xn), qn = /** @class */ function() {
    function t(t) {
        this.name = t;
    }
    return t.prototype.toString = function() {
        return this.name;
    }, t.ASCENDING = new t("asc"), t.DESCENDING = new t("desc"), t;
}(), Qn = /** @class */ function() {
    function t(t, n) {
        this.position = t, this.before = n;
    }
    return t.prototype.canonicalId = function() {
        for (
        // TODO(b/29183165): Make this collision robust.
        var t = this.before ? "b:" : "a:", n = 0, i = this.position; n < i.length; n++) {
            t += i[n].toString();
        }
        return t;
    }, 
    /**
     * Returns true if a document sorts before a bound using the provided sort
     * order.
     */
    t.prototype.yi = function(t, n) {
        C(this.position.length <= t.length, "Bound has more components than query's orderBy");
        for (var i = 0, e = 0; e < this.position.length; e++) {
            var r = t[e], u = this.position[e];
            if (r.field.ut()) C(u instanceof ln, "Bound has a non-key value where the key path is being used."), 
            i = Rt.G(u.key, n.key); else {
                var s = n.field(r.field);
                C(null !== s, "Field should exist since document matched the orderBy already."), 
                i = u.h(s);
            }
            if (r.dir === qn.DESCENDING && (i *= -1), 0 !== i) break;
        }
        return this.before ? i <= 0 : i < 0;
    }, t.prototype.isEqual = function(t) {
        if (null === t) return !1;
        if (this.before !== t.before || this.position.length !== t.position.length) return !1;
        for (var n = 0; n < this.position.length; n++) {
            var i = this.position[n], e = t.position[n];
            if (!i.isEqual(e)) return !1;
        }
        return !0;
    }, t;
}(), Gn = /** @class */ function() {
    function t(t, n) {
        this.field = t, void 0 === n && (n = qn.ASCENDING), this.dir = n, this.Ii = t.ut();
    }
    return t.prototype.compare = function(t, n) {
        var i = this.Ii ? pn.Un(t, n) : pn.qn(this.field, t, n);
        switch (this.dir) {
          case qn.ASCENDING:
            return i;

          case qn.DESCENDING:
            return -1 * i;

          default:
            return S("Unknown direction: " + this.dir);
        }
    }, t.prototype.canonicalId = function() {
        // TODO(b/29183165): Make this collision robust.
        return this.field.nt() + this.dir.toString();
    }, t.prototype.toString = function() {
        return this.field.nt() + " (" + this.dir + ")";
    }, t.prototype.isEqual = function(t) {
        return this.dir === t.dir && this.field.isEqual(t.field);
    }, t;
}(), Wn = new Gn(Et.st(), qn.ASCENDING), zn = new Gn(Et.st(), qn.DESCENDING);

/**
     * The Firestore client is in an unknown online state. This means the client
     * is either not actively trying to establish a connection or it is currently
     * trying to establish a connection, but it has not succeeded or failed yet.
     * Higher-level components should not operate in offline mode.
     */
(Cn = Sn || (Sn = {}))[Cn.Ti = 0] = "__PRIVATE_Unknown", 
/**
     * The client is connected and the connections are healthy. This state is
     * reached after a successful connection and there has been at least one
     * successful message received from the backends.
     */
Cn[Cn.Ei = 1] = "__PRIVATE_Online", 
/**
     * The client is either trying to establish a connection but failing, or it
     * has been explicitly marked offline via a call to disableNetwork().
     * Higher-level components should operate in offline mode.
     */
Cn[Cn.Ri = 2] = "__PRIVATE_Offline", (Nn = Vn || (Vn = {}))[Nn.Ai = 0] = "__PRIVATE_RemoteStore", 
Nn[Nn.Di = 1] = "__PRIVATE_SharedClientState";

/**
 * @license
 * Copyright 2020 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Immutable class that represents a "proto" byte string.
 *
 * Proto byte strings can either be Base64-encoded strings or Uint8Arrays when
 * sent on the wire. This class abstracts away this differentiation by holding
 * the proto byte string in a common class that must be converted into a string
 * before being sent as a proto.
 */
var Kn, Hn, Jn = /** @class */ function() {
    function t(t) {
        this.Pi = t;
    }
    return t.fromBase64String = function(n) {
        return new t(qi.t().atob(n));
    }, t.fromUint8Array = function(n) {
        return new t(Yn(n));
    }, t.prototype.toBase64 = function() {
        return qi.t().btoa(this.Pi);
    }, t.prototype.toUint8Array = function() {
        return Xn(this.Pi);
    }, t.prototype.Cn = function() {
        return 2 * this.Pi.length;
    }, t.prototype.isEqual = function(t) {
        return this.Pi === t.Pi;
    }, t.Si = new t(""), t;
}();

/**
 * Helper function to convert an Uint8array to a binary string.
 */ function Yn(t) {
    for (var n = "", i = 0; i < t.length; ++i) n += String.fromCharCode(t[i]);
    return n;
}

/**
 * Helper function to convert a binary string to an Uint8Array.
 */ function Xn(t) {
    for (var n = new Uint8Array(t.length), i = 0; i < t.length; i++) n[i] = t.charCodeAt(i);
    return n;
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** An enumeration of the different purposes we have for targets. */
/** A regular, normal query target. */
(Hn = Kn || (Kn = {}))[Hn.Ci = 0] = "__PRIVATE_Listen", 
/**
     * The query target was used to refill a query after an existence filter mismatch.
     */
Hn[Hn.Vi = 1] = "__PRIVATE_ExistenceFilterMismatch", 
/** The query target was used to resolve a limbo document. */
Hn[Hn.Ni = 2] = "__PRIVATE_LimboResolution";

/**
 * An immutable set of metadata that the local store tracks for each target.
 */
var $n, Zn, ti = /** @class */ function() {
    function t(
    /** The target being listened to. */
    t, 
    /**
     * The target ID to which the target corresponds; Assigned by the
     * LocalStore for user listens and by the SyncEngine for limbo watches.
     */
    n, 
    /** The purpose of the target. */
    i, 
    /**
     * The sequence number of the last transaction during which this target data
     * was modified.
     */
    e, 
    /** The latest snapshot version seen for this target. */
    r, 
    /**
     * The maximum snapshot version at which the associated view
     * contained no limbo documents.
     */
    u, 
    /**
     * An opaque, server-assigned token that allows watching a target to be
     * resumed after disconnecting without retransmitting all the data that
     * matches the target. The resume token essentially identifies a point in
     * time from which the server should resume sending results.
     */
    s) {
        void 0 === r && (r = yt.MIN), void 0 === u && (u = yt.MIN), void 0 === s && (s = Jn.Si), 
        this.target = t, this.targetId = n, this.ki = i, this.sequenceNumber = e, this.Oi = r, 
        this.lastLimboFreeSnapshotVersion = u, this.resumeToken = s;
    }
    /** Creates a new target data instance with an updated sequence number. */    return t.prototype.Fi = function(n) {
        return new t(this.target, this.targetId, this.ki, n, this.Oi, this.lastLimboFreeSnapshotVersion, this.resumeToken);
    }, 
    /**
     * Creates a new target data instance with an updated resume token and
     * snapshot version.
     */
    t.prototype.xi = function(n, i) {
        return new t(this.target, this.targetId, this.ki, this.sequenceNumber, i, this.lastLimboFreeSnapshotVersion, n);
    }, 
    /**
     * Creates a new target data instance with an updated last limbo free
     * snapshot version number.
     */
    t.prototype.ji = function(n) {
        return new t(this.target, this.targetId, this.ki, this.sequenceNumber, this.Oi, n, this.resumeToken);
    }, t.prototype.isEqual = function(t) {
        return this.targetId === t.targetId && this.ki === t.ki && this.sequenceNumber === t.sequenceNumber && this.Oi.isEqual(t.Oi) && this.lastLimboFreeSnapshotVersion.isEqual(t.lastLimboFreeSnapshotVersion) && this.resumeToken.isEqual(t.resumeToken) && this.target.isEqual(t.target);
    }, t;
}(), ni = /** @class */ function() {
    // TODO(b/33078163): just use simplest form of existence filter for now
    function t(t) {
        this.count = t;
    }
    return t.prototype.isEqual = function(t) {
        return t && t.count === this.count;
    }, t;
}();

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Determines whether an error code represents a permanent error when received
 * in response to a non-write operation.
 *
 * See isPermanentWriteError for classifying write errors.
 */
function ii(t) {
    switch (t) {
      case L.OK:
        return S("Treated status OK as error");

      case L.CANCELLED:
      case L.UNKNOWN:
      case L.DEADLINE_EXCEEDED:
      case L.RESOURCE_EXHAUSTED:
      case L.INTERNAL:
      case L.UNAVAILABLE:
 // Unauthenticated means something went wrong with our token and we need
        // to retry with new credentials which will happen automatically.
              case L.UNAUTHENTICATED:
        return !1;

      case L.INVALID_ARGUMENT:
      case L.NOT_FOUND:
      case L.ALREADY_EXISTS:
      case L.PERMISSION_DENIED:
      case L.FAILED_PRECONDITION:
 // Aborted might be retried in some scenarios, but that is dependant on
        // the context and should handled individually by the calling code.
        // See https://cloud.google.com/apis/design/errors.
              case L.ABORTED:
      case L.OUT_OF_RANGE:
      case L.UNIMPLEMENTED:
      case L.DATA_LOSS:
        return !0;

      default:
        return S("Unknown status code: " + t);
    }
}

/**
 * Determines whether an error code represents a permanent error when received
 * in response to a write operation.
 *
 * Write operations must be handled specially because as of b/119437764, ABORTED
 * errors on the write stream should be retried too (even though ABORTED errors
 * are not generally retryable).
 *
 * Note that during the initial handshake on the write stream an ABORTED error
 * signals that we should discard our stream token (i.e. it is permanent). This
 * means a handshake error should be classified with isPermanentError, above.
 */
/**
 * Maps an error Code from GRPC status code number, like 0, 1, or 14. These
 * are not the same as HTTP status codes.
 *
 * @returns The Code equivalent to the given GRPC status code. Fails if there
 *     is no match.
 */
function ei(t) {
    if (void 0 === t) 
    // This shouldn't normally happen, but in certain error cases (like trying
    // to send invalid proto messages) we may get an error with no GRPC code.
    return D("GRPC error has no .code"), L.UNKNOWN;
    switch (t) {
      case $n.OK:
        return L.OK;

      case $n.CANCELLED:
        return L.CANCELLED;

      case $n.UNKNOWN:
        return L.UNKNOWN;

      case $n.DEADLINE_EXCEEDED:
        return L.DEADLINE_EXCEEDED;

      case $n.RESOURCE_EXHAUSTED:
        return L.RESOURCE_EXHAUSTED;

      case $n.INTERNAL:
        return L.INTERNAL;

      case $n.UNAVAILABLE:
        return L.UNAVAILABLE;

      case $n.UNAUTHENTICATED:
        return L.UNAUTHENTICATED;

      case $n.INVALID_ARGUMENT:
        return L.INVALID_ARGUMENT;

      case $n.NOT_FOUND:
        return L.NOT_FOUND;

      case $n.ALREADY_EXISTS:
        return L.ALREADY_EXISTS;

      case $n.PERMISSION_DENIED:
        return L.PERMISSION_DENIED;

      case $n.FAILED_PRECONDITION:
        return L.FAILED_PRECONDITION;

      case $n.ABORTED:
        return L.ABORTED;

      case $n.OUT_OF_RANGE:
        return L.OUT_OF_RANGE;

      case $n.UNIMPLEMENTED:
        return L.UNIMPLEMENTED;

      case $n.DATA_LOSS:
        return L.DATA_LOSS;

      default:
        return S("Unknown status code: " + t);
    }
}

/**
 * Maps an RPC code from a Code. This is the reverse operation from
 * mapCodeFromRpcCode and should really only be used in tests.
 */ function ri(t) {
    if (void 0 === t) return $n.OK;
    switch (t) {
      case L.OK:
        return $n.OK;

      case L.CANCELLED:
        return $n.CANCELLED;

      case L.UNKNOWN:
        return $n.UNKNOWN;

      case L.DEADLINE_EXCEEDED:
        return $n.DEADLINE_EXCEEDED;

      case L.RESOURCE_EXHAUSTED:
        return $n.RESOURCE_EXHAUSTED;

      case L.INTERNAL:
        return $n.INTERNAL;

      case L.UNAVAILABLE:
        return $n.UNAVAILABLE;

      case L.UNAUTHENTICATED:
        return $n.UNAUTHENTICATED;

      case L.INVALID_ARGUMENT:
        return $n.INVALID_ARGUMENT;

      case L.NOT_FOUND:
        return $n.NOT_FOUND;

      case L.ALREADY_EXISTS:
        return $n.ALREADY_EXISTS;

      case L.PERMISSION_DENIED:
        return $n.PERMISSION_DENIED;

      case L.FAILED_PRECONDITION:
        return $n.FAILED_PRECONDITION;

      case L.ABORTED:
        return $n.ABORTED;

      case L.OUT_OF_RANGE:
        return $n.OUT_OF_RANGE;

      case L.UNIMPLEMENTED:
        return $n.UNIMPLEMENTED;

      case L.DATA_LOSS:
        return $n.DATA_LOSS;

      default:
        return S("Unknown status code: " + t);
    }
}

/**
 * Converts an HTTP response's error status to the equivalent error code.
 *
 * @param status An HTTP error response status ("FAILED_PRECONDITION",
 * "UNKNOWN", etc.)
 * @returns The equivalent Code. Non-matching responses are mapped to
 *     Code.UNKNOWN.
 */ (Zn = $n || ($n = {}))[Zn.OK = 0] = "OK", Zn[Zn.CANCELLED = 1] = "CANCELLED", 
Zn[Zn.UNKNOWN = 2] = "UNKNOWN", Zn[Zn.INVALID_ARGUMENT = 3] = "INVALID_ARGUMENT", 
Zn[Zn.DEADLINE_EXCEEDED = 4] = "DEADLINE_EXCEEDED", Zn[Zn.NOT_FOUND = 5] = "NOT_FOUND", 
Zn[Zn.ALREADY_EXISTS = 6] = "ALREADY_EXISTS", Zn[Zn.PERMISSION_DENIED = 7] = "PERMISSION_DENIED", 
Zn[Zn.UNAUTHENTICATED = 16] = "UNAUTHENTICATED", Zn[Zn.RESOURCE_EXHAUSTED = 8] = "RESOURCE_EXHAUSTED", 
Zn[Zn.FAILED_PRECONDITION = 9] = "FAILED_PRECONDITION", Zn[Zn.ABORTED = 10] = "ABORTED", 
Zn[Zn.OUT_OF_RANGE = 11] = "OUT_OF_RANGE", Zn[Zn.UNIMPLEMENTED = 12] = "UNIMPLEMENTED", 
Zn[Zn.INTERNAL = 13] = "INTERNAL", Zn[Zn.UNAVAILABLE = 14] = "UNAVAILABLE", Zn[Zn.DATA_LOSS = 15] = "DATA_LOSS";

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var ui = new At(Rt.G);

function si() {
    return ui;
}

function oi() {
    return si();
}

var hi = new At(Rt.G);

function ci() {
    return hi;
}

var ai = new At(Rt.G);

function fi() {
    return ai;
}

var li = new Ct(Rt.G);

function di() {
    for (var t = [], n = 0; n < arguments.length; n++) t[n] = arguments[n];
    for (var i = li, e = 0, r = t; e < r.length; e++) {
        var u = r[e];
        i = i.add(u);
    }
    return i;
}

var vi = new Ct(N);

function wi() {
    return vi;
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * DocumentSet is an immutable (copy-on-write) collection that holds documents
 * in order specified by the provided comparator. We always add a document key
 * comparator on top of what is provided to guarantee document equality based on
 * the key.
 */ var mi, pi, gi, bi, yi = /** @class */ function() {
    /** The default ordering is by key if the comparator is omitted */
    function t(t) {
        // We are adding document key comparator to the end as it's the only
        // guaranteed unique property of a document.
        this.G = t ? function(n, i) {
            return t(n, i) || Rt.G(n.key, i.key);
        } : function(t, n) {
            return Rt.G(t.key, n.key);
        }, this.Ui = ci(), this.Li = new At(this.G);
    }
    /**
     * Returns an empty copy of the existing DocumentSet, using the same
     * comparator.
     */    return t.Bi = function(n) {
        return new t(n.G);
    }, t.prototype.has = function(t) {
        return null != this.Ui.get(t);
    }, t.prototype.get = function(t) {
        return this.Ui.get(t);
    }, t.prototype.first = function() {
        return this.Li.vt();
    }, t.prototype.last = function() {
        return this.Li.wt();
    }, t.prototype.J = function() {
        return this.Li.J();
    }, 
    /**
     * Returns the index of the provided key in the document set, or -1 if the
     * document key is not present in the set;
     */
    t.prototype.indexOf = function(t) {
        var n = this.Ui.get(t);
        return n ? this.Li.indexOf(n) : -1;
    }, Object.defineProperty(t.prototype, "size", {
        get: function() {
            return this.Li.size;
        },
        enumerable: !0,
        configurable: !0
    }), 
    /** Iterates documents in order defined by "comparator" */
    t.prototype.forEach = function(t) {
        this.Li.pt((function(n, i) {
            return t(n), !1;
        }));
    }, 
    /** Inserts or updates a document with the same key */
    t.prototype.add = function(t) {
        // First remove the element if we have it.
        var n = this.delete(t.key);
        return n.copy(n.Ui.lt(t.key, t), n.Li.lt(t, null));
    }, 
    /** Deletes a document with a given key */
    t.prototype.delete = function(t) {
        var n = this.get(t);
        return n ? this.copy(this.Ui.remove(t), this.Li.remove(n)) : this;
    }, t.prototype.isEqual = function(n) {
        if (!(n instanceof t)) return !1;
        if (this.size !== n.size) return !1;
        for (var i = this.Li.bt(), e = n.Li.bt(); i.At(); ) {
            var r = i.Rt().key, u = e.Rt().key;
            if (!r.isEqual(u)) return !1;
        }
        return !0;
    }, t.prototype.toString = function() {
        var t = [];
        return this.forEach((function(n) {
            t.push(n.toString());
        })), 0 === t.length ? "DocumentSet ()" : "DocumentSet (\n  " + t.join("  \n") + "\n)";
    }, t.prototype.copy = function(n, i) {
        var e = new t;
        return e.G = this.G, e.Ui = n, e.Li = i, e;
    }, t;
}();

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ (pi = mi || (mi = {}))[pi.Mi = 0] = "__PRIVATE_Added", pi[pi.qi = 1] = "__PRIVATE_Removed", 
pi[pi.Qi = 2] = "__PRIVATE_Modified", pi[pi.Gi = 3] = "__PRIVATE_Metadata", (bi = gi || (gi = {}))[bi.Wi = 0] = "__PRIVATE_Local", 
bi[bi.zi = 1] = "__PRIVATE_Synced";

/**
 * DocumentChangeSet keeps track of a set of changes to docs in a query, merging
 * duplicate events for the same doc.
 */
var _i, Ii, Ti = /** @class */ function() {
    function t() {
        this.Ki = new At(Rt.G);
    }
    return t.prototype.track = function(t) {
        var n = t.doc.key, i = this.Ki.get(n);
        i ? 
        // Merge the new change with the existing change.
        t.type !== mi.Mi && i.type === mi.Gi ? this.Ki = this.Ki.lt(n, t) : t.type === mi.Gi && i.type !== mi.qi ? this.Ki = this.Ki.lt(n, {
            type: i.type,
            doc: t.doc
        }) : t.type === mi.Qi && i.type === mi.Qi ? this.Ki = this.Ki.lt(n, {
            type: mi.Qi,
            doc: t.doc
        }) : t.type === mi.Qi && i.type === mi.Mi ? this.Ki = this.Ki.lt(n, {
            type: mi.Mi,
            doc: t.doc
        }) : t.type === mi.qi && i.type === mi.Mi ? this.Ki = this.Ki.remove(n) : t.type === mi.qi && i.type === mi.Qi ? this.Ki = this.Ki.lt(n, {
            type: mi.qi,
            doc: i.doc
        }) : t.type === mi.Mi && i.type === mi.qi ? this.Ki = this.Ki.lt(n, {
            type: mi.Qi,
            doc: t.doc
        }) : 
        // This includes these cases, which don't make sense:
        // Added->Added
        // Removed->Removed
        // Modified->Added
        // Removed->Modified
        // Metadata->Added
        // Removed->Metadata
        S("unsupported combination of changes: " + JSON.stringify(t) + " after " + JSON.stringify(i)) : this.Ki = this.Ki.lt(n, t);
    }, t.prototype.Hi = function() {
        var t = [];
        return this.Ki.pt((function(n, i) {
            t.push(i);
        })), t;
    }, t;
}(), Ei = /** @class */ function() {
    function t(t, n, i, e, r, u, s, o) {
        this.query = t, this.docs = n, this.Ji = i, this.docChanges = e, this.Yi = r, this.fromCache = u, 
        this.Xi = s, this.$i = o;
    }
    /** Returns a view snapshot as if all documents in the snapshot were added. */    return t.Zi = function(n, i, e, r) {
        var u = [];
        return i.forEach((function(t) {
            u.push({
                type: mi.Mi,
                doc: t
            });
        })), new t(n, i, yi.Bi(i), u, e, r, 
        /* syncStateChanged= */ !0, 
        /* excludesMetadataChanges= */ !1);
    }, Object.defineProperty(t.prototype, "hasPendingWrites", {
        get: function() {
            return !this.Yi.J();
        },
        enumerable: !0,
        configurable: !0
    }), t.prototype.isEqual = function(t) {
        if (!(this.fromCache === t.fromCache && this.Xi === t.Xi && this.Yi.isEqual(t.Yi) && this.query.isEqual(t.query) && this.docs.isEqual(t.docs) && this.Ji.isEqual(t.Ji))) return !1;
        var n = this.docChanges, i = t.docChanges;
        if (n.length !== i.length) return !1;
        for (var e = 0; e < n.length; e++) if (n[e].type !== i[e].type || !n[e].doc.isEqual(i[e].doc)) return !1;
        return !0;
    }, t;
}(), Ri = /** @class */ function() {
    function t(
    /**
     * The snapshot version this event brings us up to, or MIN if not set.
     */
    t, 
    /**
     * A map from target to changes to the target. See TargetChange.
     */
    n, 
    /**
     * A set of targets that is known to be inconsistent. Listens for these
     * targets should be re-established without resume tokens.
     */
    i, 
    /**
     * A set of which documents have changed or been deleted, along with the
     * doc's new values (if not deleted).
     */
    e, 
    /**
     * A set of which document updates are due only to limbo resolution targets.
     */
    r) {
        this.Oi = t, this.te = n, this.ne = i, this.ie = e, this.ee = r;
    }
    /**
     * HACK: Views require RemoteEvents in order to determine whether the view is
     * CURRENT, but secondary tabs don't receive remote events. So this method is
     * used to create a synthesized RemoteEvent that can be used to apply a
     * CURRENT status change to a View, for queries executed in a different tab.
     */
    // PORTING NOTE: Multi-tab only
        return t.re = function(n, i) {
        var e, r = ((e = {})[n] = Ai.ue(n, i), e);
        return new t(yt.MIN, r, wi(), si(), di());
    }, t;
}(), Ai = /** @class */ function() {
    function t(
    /**
     * An opaque, server-assigned token that allows watching a query to be resumed
     * after disconnecting without retransmitting all the data that matches the
     * query. The resume token essentially identifies a point in time from which
     * the server should resume sending results.
     */
    t, 
    /**
     * The "current" (synced) status of this target. Note that "current"
     * has special meaning in the RPC protocol that implies that a target is
     * both up-to-date and consistent with the rest of the watch stream.
     */
    n, 
    /**
     * The set of documents that were newly assigned to this target as part of
     * this remote event.
     */
    i, 
    /**
     * The set of documents that were already assigned to this target but received
     * an update during this remote event.
     */
    e, 
    /**
     * The set of documents that were removed from this target as part of this
     * remote event.
     */
    r) {
        this.resumeToken = t, this.se = n, this.oe = i, this.he = e, this.ce = r;
    }
    /**
     * This method is used to create a synthesized TargetChanges that can be used to
     * apply a CURRENT status change to a View (for queries executed in a different
     * tab) or for new queries (to raise snapshots with correct CURRENT status).
     */    return t.ue = function(n, i) {
        return new t(Jn.Si, i, di(), di(), di());
    }, t;
}(), Di = function(
/** The new document applies to all of these targets. */
t, 
/** The new document is removed from all of these targets. */
n, 
/** The key of the document for this change. */
i, 
/**
     * The new document or NoDocument if it was deleted. Is null if the
     * document went out of view without the server sending a new document.
     */
e) {
    this.ae = t, this.removedTargetIds = n, this.key = i, this.fe = e;
}, Pi = function(t, n) {
    this.targetId = t, this.le = n;
};

(Ii = _i || (_i = {}))[Ii.de = 0] = "__PRIVATE_NoChange", Ii[Ii.Mi = 1] = "__PRIVATE_Added", 
Ii[Ii.qi = 2] = "__PRIVATE_Removed", Ii[Ii.ve = 3] = "__PRIVATE_Current", Ii[Ii.we = 4] = "__PRIVATE_Reset";

var Si = function(
/** What kind of change occurred to the watch target. */
t, 
/** The target IDs that were added/removed/set. */
n, 
/**
     * An opaque, server-assigned token that allows watching a target to be
     * resumed after disconnecting without retransmitting all the data that
     * matches the target. The resume token essentially identifies a point in
     * time from which the server should resume sending results.
     */
i, 
/** An RPC error indicating why the watch failed. */
e) {
    void 0 === i && (i = Jn.Si), void 0 === e && (e = null), this.state = t, this.targetIds = n, 
    this.resumeToken = i, this.cause = e;
}, Ci = /** @class */ function() {
    function t() {
        /**
         * The number of pending responses (adds or removes) that we are waiting on.
         * We only consider targets active that have no pending responses.
         */
        this.me = 0, 
        /**
         * Keeps track of the document changes since the last raised snapshot.
         *
         * These changes are continuously updated as we receive document updates and
         * always reflect the current set of changes against the last issued snapshot.
         */
        this.pe = ki(), 
        /** See public getters for explanations of these fields. */
        this.ge = Jn.Si, this.be = !1, 
        /**
         * Whether this target state should be included in the next snapshot. We
         * initialize to true so that newly-added targets are included in the next
         * RemoteEvent.
         */
        this.ye = !0;
    }
    return Object.defineProperty(t.prototype, "se", {
        /**
         * Whether this target has been marked 'current'.
         *
         * 'Current' has special meaning in the RPC protocol: It implies that the
         * Watch backend has sent us all changes up to the point at which the target
         * was added and that the target is consistent with the rest of the watch
         * stream.
         */
        get: function() {
            return this.be;
        },
        enumerable: !0,
        configurable: !0
    }), Object.defineProperty(t.prototype, "resumeToken", {
        /** The last resume token sent to us for this target. */
        get: function() {
            return this.ge;
        },
        enumerable: !0,
        configurable: !0
    }), Object.defineProperty(t.prototype, "_e", {
        /** Whether this target has pending target adds or target removes. */
        get: function() {
            return 0 !== this.me;
        },
        enumerable: !0,
        configurable: !0
    }), Object.defineProperty(t.prototype, "Ie", {
        /** Whether we have modified any state that should trigger a snapshot. */
        get: function() {
            return this.ye;
        },
        enumerable: !0,
        configurable: !0
    }), 
    /**
     * Applies the resume token to the TargetChange, but only when it has a new
     * value. Empty resumeTokens are discarded.
     */
    t.prototype.Te = function(t) {
        t.Cn() > 0 && (this.ye = !0, this.ge = t);
    }, 
    /**
     * Creates a target change from the current set of changes.
     *
     * To reset the document changes after raising this snapshot, call
     * `clearPendingChanges()`.
     */
    t.prototype.Ee = function() {
        var t = di(), n = di(), i = di();
        return this.pe.forEach((function(e, r) {
            switch (r) {
              case mi.Mi:
                t = t.add(e);
                break;

              case mi.Qi:
                n = n.add(e);
                break;

              case mi.qi:
                i = i.add(e);
                break;

              default:
                S("Encountered invalid change type: " + r);
            }
        })), new Ai(this.ge, this.be, t, n, i);
    }, 
    /**
     * Resets the document changes and sets `hasPendingChanges` to false.
     */
    t.prototype.Re = function() {
        this.ye = !1, this.pe = ki();
    }, t.prototype.Ae = function(t, n) {
        this.ye = !0, this.pe = this.pe.lt(t, n);
    }, t.prototype.De = function(t) {
        this.ye = !0, this.pe = this.pe.remove(t);
    }, t.prototype.Pe = function() {
        this.me += 1;
    }, t.prototype.Se = function() {
        this.me -= 1;
    }, t.prototype.Ce = function() {
        this.ye = !0, this.be = !0;
    }, t;
}(), Vi = /** @class */ function() {
    function t(t) {
        this.Ve = t, 
        /** The internal state of all tracked targets. */
        this.Ne = {}, 
        /** Keeps track of the documents to update since the last raised snapshot. */
        this.ke = si(), 
        /** A mapping of document keys to their set of target IDs. */
        this.Oe = Ni(), 
        /**
         * A list of targets with existence filter mismatches. These targets are
         * known to be inconsistent and their listens needs to be re-established by
         * RemoteStore.
         */
        this.Fe = new Ct(N);
    }
    /**
     * Processes and adds the DocumentWatchChange to the current set of changes.
     */    return t.prototype.xe = function(t) {
        for (var n = 0, i = t.ae; n < i.length; n++) {
            var e = i[n];
            t.fe instanceof pn ? this.je(e, t.fe) : t.fe instanceof gn && this.Ue(e, t.key, t.fe);
        }
        for (var r = 0, u = t.removedTargetIds; r < u.length; r++) {
            e = u[r];
            this.Ue(e, t.key, t.fe);
        }
    }, 
    /** Processes and adds the WatchTargetChange to the current set of changes. */
    t.prototype.Le = function(t) {
        var n = this;
        this.Be(t, (function(i) {
            var e = n.Me(i);
            switch (t.state) {
              case _i.de:
                n.qe(i) && e.Te(t.resumeToken);
                break;

              case _i.Mi:
                // We need to decrement the number of pending acks needed from watch
                // for this targetId.
                e.Se(), e._e || 
                // We have a freshly added target, so we need to reset any state
                // that we had previously. This can happen e.g. when remove and add
                // back a target for existence filter mismatches.
                e.Re(), e.Te(t.resumeToken);
                break;

              case _i.qi:
                // We need to keep track of removed targets to we can post-filter and
                // remove any target changes.
                // We need to decrement the number of pending acks needed from watch
                // for this targetId.
                e.Se(), e._e || n.removeTarget(i), C(!t.cause, "WatchChangeAggregator does not handle errored targets");
                break;

              case _i.ve:
                n.qe(i) && (e.Ce(), e.Te(t.resumeToken));
                break;

              case _i.we:
                n.qe(i) && (
                // Reset the target and synthesizes removes for all existing
                // documents. The backend will re-add any documents that still
                // match the target before it sends the next global snapshot.
                n.Qe(i), e.Te(t.resumeToken));
                break;

              default:
                S("Unknown target watch change state: " + t.state);
            }
        }));
    }, 
    /**
     * Iterates over all targetIds that the watch change applies to: either the
     * targetIds explicitly listed in the change or the targetIds of all currently
     * active targets.
     */
    t.prototype.Be = function(t, n) {
        t.targetIds.length > 0 ? t.targetIds.forEach(n) : J(this.Ne, n);
    }, 
    /**
     * Handles existence filters and synthesizes deletes for filter mismatches.
     * Targets that are invalidated by filter mismatches are added to
     * `pendingTargetResets`.
     */
    t.prototype.Ge = function(t) {
        var n = t.targetId, i = t.le.count, e = this.We(n);
        if (e) {
            var r = e.target;
            if (r.Gn()) if (0 === i) {
                // The existence filter told us the document does not exist. We deduce
                // that this document does not exist and apply a deleted document to
                // our updates. Without applying this deleted document there might be
                // another query that will raise this document as part of a snapshot
                // until it is resolved, essentially exposing inconsistency between
                // queries.
                var u = new Rt(r.path);
                this.Ue(n, u, new gn(u, yt.B()));
            } else C(1 === i, "Single document existence filter with count: " + i); else this.ze(n) !== i && (
            // Existence filter mismatch: We reset the mapping and raise a new
            // snapshot with `isFromCache:true`.
            this.Qe(n), this.Fe = this.Fe.add(n));
        }
    }, 
    /**
     * Converts the currently accumulated state into a remote event at the
     * provided snapshot version. Resets the accumulated changes before returning.
     */
    t.prototype.Ke = function(t) {
        var n = this, i = {};
        J(this.Ne, (function(e, r) {
            var u = n.We(e);
            if (u) {
                if (r.se && u.target.Gn()) {
                    // Document queries for document that don't exist can produce an empty
                    // result set. To update our local cache, we synthesize a document
                    // delete if we have not previously received the document. This
                    // resolves the limbo state of the document, removing it from
                    // limboDocumentRefs.
                    //
                    // TODO(dimond): Ideally we would have an explicit lookup target
                    // instead resulting in an explicit delete message and we could
                    // remove this special logic.
                    var s = new Rt(u.target.path);
                    null !== n.ke.get(s) || n.He(e, s) || n.Ue(e, s, new gn(s, t));
                }
                r.Ie && (i[e] = r.Ee(), r.Re());
            }
        }));
        var e = di();
        // We extract the set of limbo-only document updates as the GC logic
        // special-cases documents that do not appear in the target cache.
        //
        // TODO(gsoltis): Expand on this comment once GC is available in the JS
        // client.
                this.Oe.forEach((function(t, i) {
            var r = !0;
            i.Bt((function(t) {
                var i = n.We(t);
                return !i || i.ki === Kn.Ni || (r = !1, !1);
            })), r && (e = e.add(t));
        }));
        var r = new Ri(t, i, this.Fe, this.ke, e);
        return this.ke = si(), this.Oe = Ni(), this.Fe = new Ct(N), r;
    }, 
    /**
     * Adds the provided document to the internal list of document updates and
     * its document key to the given target's mapping.
     */
    // Visible for testing.
    t.prototype.je = function(t, n) {
        if (this.qe(t)) {
            var i = this.He(t, n.key) ? mi.Qi : mi.Mi;
            this.Me(t).Ae(n.key, i), this.ke = this.ke.lt(n.key, n), this.Oe = this.Oe.lt(n.key, this.Je(n.key).add(t));
        }
    }, 
    /**
     * Removes the provided document from the target mapping. If the
     * document no longer matches the target, but the document's state is still
     * known (e.g. we know that the document was deleted or we received the change
     * that caused the filter mismatch), the new document can be provided
     * to update the remote document cache.
     */
    // Visible for testing.
    t.prototype.Ue = function(t, n, i) {
        if (this.qe(t)) {
            var e = this.Me(t);
            this.He(t, n) ? e.Ae(n, mi.qi) : 
            // The document may have entered and left the target before we raised a
            // snapshot, so we can just ignore the change.
            e.De(n), this.Oe = this.Oe.lt(n, this.Je(n).delete(t)), i && (this.ke = this.ke.lt(n, i));
        }
    }, t.prototype.removeTarget = function(t) {
        delete this.Ne[t];
    }, 
    /**
     * Returns the current count of documents in the target. This includes both
     * the number of documents that the LocalStore considers to be part of the
     * target as well as any accumulated changes.
     */
    t.prototype.ze = function(t) {
        var n = this.Me(t).Ee();
        return this.Ve.Ye(t).size + n.oe.size - n.ce.size;
    }, 
    /**
     * Increment the number of acks needed from watch before we can consider the
     * server to be 'in-sync' with the client's active targets.
     */
    t.prototype.Pe = function(t) {
        this.Me(t).Pe();
    }, t.prototype.Me = function(t) {
        return this.Ne[t] || (this.Ne[t] = new Ci), this.Ne[t];
    }, t.prototype.Je = function(t) {
        var n = this.Oe.get(t);
        return n || (n = new Ct(N), this.Oe = this.Oe.lt(t, n)), n;
    }, 
    /**
     * Verifies that the user is still interested in this target (by calling
     * `getTargetDataForTarget()`) and that we are not waiting for pending ADDs
     * from watch.
     */
    t.prototype.qe = function(t) {
        var n = null !== this.We(t);
        return n || A("WatchChangeAggregator", "Detected inactive target", t), n;
    }, 
    /**
     * Returns the TargetData for an active target (i.e. a target that the user
     * is still interested in that has no outstanding target change requests).
     */
    t.prototype.We = function(t) {
        var n = this.Ne[t];
        return n && n._e ? null : this.Ve.Xe(t);
    }, 
    /**
     * Resets the state of a Watch target to its initial state (e.g. sets
     * 'current' to false, clears the resume token and removes its target mapping
     * from all documents).
     */
    t.prototype.Qe = function(t) {
        var n = this;
        C(!this.Ne[t]._e, "Should only reset active targets"), this.Ne[t] = new Ci, this.Ve.Ye(t).forEach((function(i) {
            n.Ue(t, i, /*updatedDocument=*/ null);
        }));
    }, 
    /**
     * Returns whether the LocalStore considers the document to be part of the
     * specified target.
     */
    t.prototype.He = function(t, n) {
        return this.Ve.Ye(t).has(n);
    }, t;
}();

/** Tracks the internal state of a Watch target. */ function Ni() {
    return new At(Rt.G);
}

function ki() {
    return new At(Rt.G);
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ var Oi, Fi, xi = ((Oi = {})[qn.ASCENDING.name] = "ASCENDING", Oi[qn.DESCENDING.name] = "DESCENDING", 
Oi), ji = ((Fi = {})[Fn.LESS_THAN.name] = "LESS_THAN", Fi[Fn.LESS_THAN_OR_EQUAL.name] = "LESS_THAN_OR_EQUAL", 
Fi[Fn.GREATER_THAN.name] = "GREATER_THAN", Fi[Fn.GREATER_THAN_OR_EQUAL.name] = "GREATER_THAN_OR_EQUAL", 
Fi[Fn.EQUAL.name] = "EQUAL", Fi[Fn.ARRAY_CONTAINS.name] = "ARRAY_CONTAINS", Fi[Fn.IN.name] = "IN", 
Fi[Fn.ARRAY_CONTAINS_ANY.name] = "ARRAY_CONTAINS_ANY", Fi), Ui = new RegExp(/^\d{4}-\d\d-\d\dT\d\d:\d\d:\d\d(?:\.(\d+))?Z$/);

function Li(t, n) {
    C(!En(t), n + " is missing");
}

function Bi(t) {
    // TODO(bjornick): Handle int64 greater than 53 bits.
    return "number" == typeof t ? t : "string" == typeof t ? Number(t) : S("can't parse " + t);
}

/**
 * Generates JsonObject values for the Datastore API suitable for sending to
 * either GRPC stub methods or via the JSON/HTTP REST API.
 * TODO(klimt): We can remove the databaseId argument if we keep the full
 * resource name in documents.
 */ var Mi = /** @class */ function() {
    function t(t, n) {
        this.s = t, this.options = n;
    }
    return t.prototype.$e = function(t) {
        var n = void 0 === t.code ? L.UNKNOWN : ei(t.code);
        return new B(n, t.message || "");
    }, 
    /**
     * Returns a value for a number (or null) that's appropriate to put into
     * a google.protobuf.Int32Value proto.
     * DO NOT USE THIS FOR ANYTHING ELSE.
     * This method cheats. It's typed as returning "number" because that's what
     * our generated proto interfaces say Int32Value must be. But GRPC actually
     * expects a { value: <number> } struct.
     */
    t.prototype.Ze = function(t) {
        return this.options.tr || En(t) ? t : {
            value: t
        };
    }, 
    /**
     * Returns a number (or null) from a google.protobuf.Int32Value proto.
     * DO NOT USE THIS FOR ANYTHING ELSE.
     * This method cheats. It's typed as accepting "number" because that's what
     * our generated proto interfaces say Int32Value must be, but it actually
     * accepts { value: number } to match our serialization in toInt32Value().
     */
    t.prototype.nr = function(t) {
        var n;
        return En(
        // Use any because we need to match generated Proto types.
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        n = "object" == typeof t ? t.value : t) ? null : n;
    }, 
    /**
     * Returns a value for a Date that's appropriate to put into a proto.
     * DO NOT USE THIS FOR ANYTHING ELSE.
     * This method cheats. It's typed as returning "string" because that's what
     * our generated proto interfaces say dates must be. But it's easier and safer
     * to actually return a Timestamp proto.
     */
    t.prototype.q = function(t) {
        return this.options.tr ? new Date(1e3 * t.seconds).toISOString().replace(/\.\d*/, "").replace("Z", "") + "." + ("000000000" + t.nanoseconds).slice(-9) + "Z" : {
            seconds: "" + t.seconds,
            nanos: t.nanoseconds
        };
    }, t.prototype.L = function(t) {
        // The json interface (for the browser) will return an iso timestamp string,
        // while the proto js library (for node) will return a
        // google.protobuf.Timestamp instance.
        if ("string" == typeof t) 
        // TODO(b/37282237): Use strings for Proto3 timestamps
        // assert(this.options.useProto3Json,
        //   'The timestamp string format requires Proto3.');
        return this.ir(t);
        C(!!t, "Cannot deserialize null or undefined timestamp.");
        // TODO(b/37282237): Use strings for Proto3 timestamps
        // assert(!this.options.useProto3Json,
        //   'The timestamp instance format requires Proto JS.');
        var n = Bi(t.seconds || "0"), i = t.nanos || 0;
        return new bt(n, i);
    }, t.prototype.ir = function(t) {
        // The date string can have higher precision (nanos) than the Date class
        // (millis), so we do some custom parsing here.
        // Parse the nanos right out of the string.
        var n = 0, i = Ui.exec(t);
        if (C(!!i, "invalid timestamp: " + t), i[1]) {
            // Pad the fraction out to 9 digits (nanos).
            var e = i[1];
            e = (e + "000000000").substr(0, 9), n = Number(e);
        }
        // Parse the date to get the seconds.
                var r = new Date(t), u = Math.floor(r.getTime() / 1e3);
        return new bt(u, n);
    }, 
    /**
     * Returns a value for bytes that's appropriate to put in a proto.
     * DO NOT USE THIS FOR ANYTHING ELSE.
     * This method cheats. It's typed as returning "string" because that's what
     * our generated proto interfaces say bytes must be. But it should return
     * an Uint8Array in Node.
     *
     * Visible for testing.
     */
    t.prototype.er = function(t) {
        return this.options.tr ? t.toBase64() : t.toUint8Array();
    }, 
    /**
     * Returns a ByteString based on the proto string value.
     */
    t.prototype.rr = function(t) {
        return this.options.tr ? (C(void 0 === t || "string" == typeof t, "value must be undefined or a string when using proto3 Json"), 
        Jn.fromBase64String(t || "")) : (C(void 0 === t || t instanceof Uint8Array, "value must be undefined or Uint8Array"), 
        Jn.fromUint8Array(t || new Uint8Array));
    }, 
    /**
     * Parse the blob from the protos into the internal Blob class. Note that the
     * typings assume all blobs are strings, but they are actually Uint8Arrays
     * on Node.
     */
    t.prototype.ur = function(t) {
        return "string" == typeof t ? (C(this.options.tr, "Expected bytes to be passed in as Uint8Array, but got a string instead."), 
        Hi.fromBase64String(t)) : (C(!this.options.tr, "Expected bytes to be passed in as Uint8Array, but got a string instead."), 
        Hi.fromUint8Array(t));
    }, t.prototype.toVersion = function(t) {
        return this.q(t.q());
    }, t.prototype.fromVersion = function(t) {
        return C(!!t, "Trying to deserialize version that isn't set"), yt.L(this.L(t));
    }, t.prototype.sr = function(t, n) {
        return this.or(t).child("documents").child(n).nt();
    }, t.prototype.hr = function(t) {
        var n = It.it(t);
        return C(this.cr(n), "Tried to deserialize invalid key " + n.toString()), n;
    }, t.prototype.ar = function(t) {
        return this.sr(this.s, t.path);
    }, t.prototype.lr = function(t) {
        var n = this.hr(t);
        return C(n.get(1) === this.s.projectId, "Tried to deserialize key from different project: " + n.get(1) + " vs " + this.s.projectId), 
        C(!n.get(3) && !this.s.database || n.get(3) === this.s.database, "Tried to deserialize key from different database: " + n.get(3) + " vs " + this.s.database), 
        new Rt(this.dr(n));
    }, t.prototype.vr = function(t) {
        return this.sr(this.s, t);
    }, t.prototype.wr = function(t) {
        var n = this.hr(t);
        // In v1beta1 queries for collections at the root did not have a trailing
        // "/documents". In v1 all resource paths contain "/documents". Preserve the
        // ability to read the v1beta1 form for compatibility with queries persisted
        // in the local target cache.
                return 4 === n.length ? It.et : this.dr(n);
    }, Object.defineProperty(t.prototype, "mr", {
        get: function() {
            return new It([ "projects", this.s.projectId, "databases", this.s.database ]).nt();
        },
        enumerable: !0,
        configurable: !0
    }), t.prototype.or = function(t) {
        return new It([ "projects", t.projectId, "databases", t.database ]);
    }, t.prototype.dr = function(t) {
        return C(t.length > 4 && "documents" === t.get(4), "tried to deserialize invalid key " + t.toString()), 
        t.K(5);
    }, t.prototype.cr = function(t) {
        // Resource names have at least 4 components (project ID, database ID)
        return t.length >= 4 && "projects" === t.get(0) && "databases" === t.get(2);
    }, t.prototype.pr = function(t) {
        if (t instanceof nn) return {
            nullValue: "NULL_VALUE"
        };
        if (t instanceof en) return {
            booleanValue: t.value()
        };
        if (t instanceof sn) return {
            integerValue: "" + t.value()
        };
        if (t instanceof on) {
            var n = t.value();
            if (this.options.tr) {
                // Proto 3 let's us encode NaN and Infinity as string values as
                // expected by the backend. This is currently not checked by our unit
                // tests because they rely on protobuf.js.
                if (isNaN(n)) return {
                    doubleValue: "NaN"
                };
                if (n === 1 / 0) return {
                    doubleValue: "Infinity"
                };
                if (n === -1 / 0) return {
                    doubleValue: "-Infinity"
                };
            }
            return {
                doubleValue: t.value()
            };
        }
        return t instanceof hn ? {
            stringValue: t.value()
        } : t instanceof vn ? {
            mapValue: this.gr(t)
        } : t instanceof wn ? {
            arrayValue: this.br(t)
        } : t instanceof cn ? {
            timestampValue: this.q(t.Ht)
        } : t instanceof dn ? {
            geoPointValue: {
                latitude: t.value().latitude,
                longitude: t.value().longitude
            }
        } : t instanceof fn ? {
            bytesValue: this.er(t.value())
        } : t instanceof ln ? {
            referenceValue: this.sr(t.s, t.key.path)
        } : S("Unknown FieldValue " + JSON.stringify(t));
    }, t.prototype.yr = function(t) {
        var n = this;
        if ("nullValue" in t) return nn.Vn;
        if ("booleanValue" in t) return en.of(t.booleanValue);
        if ("integerValue" in t) return new sn(Bi(t.integerValue));
        if ("doubleValue" in t) {
            if (this.options.tr) {
                // Proto 3 uses the string values 'NaN' and 'Infinity'.
                if ("NaN" === t.doubleValue) return on.On;
                if ("Infinity" === t.doubleValue) return on.POSITIVE_INFINITY;
                if ("-Infinity" === t.doubleValue) return on.NEGATIVE_INFINITY;
            }
            return new on(t.doubleValue);
        }
        if ("stringValue" in t) return new hn(t.stringValue);
        if ("mapValue" in t) return this._r(t.mapValue.fields || {});
        if ("arrayValue" in t) {
            // "values" is not present if the array is empty
            Li(t.arrayValue, "arrayValue");
            var i = t.arrayValue.values || [];
            return new wn(i.map((function(t) {
                return n.yr(t);
            })));
        }
        if ("timestampValue" in t) return Li(t.timestampValue, "timestampValue"), new cn(this.L(t.timestampValue));
        if ("geoPointValue" in t) {
            Li(t.geoPointValue, "geoPointValue");
            var e = t.geoPointValue.latitude || 0, r = t.geoPointValue.longitude || 0;
            return new dn(new gt(e, r));
        }
        if ("bytesValue" in t) {
            Li(t.bytesValue, "bytesValue");
            var u = this.ur(t.bytesValue);
            return new fn(u);
        }
        if ("referenceValue" in t) {
            Li(t.referenceValue, "referenceValue");
            var s = this.hr(t.referenceValue), o = new j(s.get(1), s.get(3)), h = new Rt(this.dr(s));
            return new ln(o, h);
        }
        return S("Unknown Value proto " + JSON.stringify(t));
    }, 
    /** Creates an api.Document from key and fields (but no create/update time) */
    t.prototype.Ir = function(t, n) {
        return {
            name: this.ar(t),
            fields: this.Tr(n)
        };
    }, t.prototype.Er = function(t) {
        return C(!t.un, "Can't serialize documents with mutations."), {
            name: this.ar(t.key),
            fields: this.Tr(t.data()),
            updateTime: this.q(t.version.q())
        };
    }, t.prototype.Rr = function(t, n) {
        var i = this, e = this.lr(t.name), r = this.fromVersion(t.updateTime);
        return new pn(e, r, {
            hasCommittedMutations: !!n
        }, void 0, t, (function(t) {
            return i.yr(t);
        }));
    }, t.prototype.Tr = function(t) {
        var n = this, i = {};
        return t.forEach((function(t, e) {
            i[t] = n.pr(e);
        })), i;
    }, t.prototype._r = function(t) {
        var n = this, i = t, e = vn.EMPTY;
        // Proto map<string, Value> gets mapped to Object, so cast it.
                return Y(i, (function(t, i) {
            e = e.set(new Et([ t ]), n.yr(i));
        })), e;
    }, t.prototype.gr = function(t) {
        return {
            fields: this.Tr(t)
        };
    }, t.prototype.br = function(t) {
        var n = this, i = [];
        return t.forEach((function(t) {
            i.push(n.pr(t));
        })), {
            values: i
        };
    }, t.prototype.Ar = function(t) {
        var n = this;
        C(!!t.found, "Tried to deserialize a found document from a missing document."), 
        Li(t.found.name, "doc.found.name"), Li(t.found.updateTime, "doc.found.updateTime");
        var i = this.lr(t.found.name), e = this.fromVersion(t.found.updateTime);
        return new pn(i, e, {}, void 0, t.found, (function(t) {
            return n.yr(t);
        }));
    }, t.prototype.Dr = function(t) {
        C(!!t.missing, "Tried to deserialize a missing document from a found document."), 
        C(!!t.readTime, "Tried to deserialize a missing document without a read time.");
        var n = this.lr(t.missing), i = this.fromVersion(t.readTime);
        return new gn(n, i);
    }, t.prototype.Pr = function(t) {
        return "found" in t ? this.Ar(t) : "missing" in t ? this.Dr(t) : S("invalid batch get response: " + JSON.stringify(t));
    }, t.prototype.Sr = function(t) {
        switch (t) {
          case _i.Mi:
            return "ADD";

          case _i.ve:
            return "CURRENT";

          case _i.de:
            return "NO_CHANGE";

          case _i.qi:
            return "REMOVE";

          case _i.we:
            return "RESET";

          default:
            return S("Unknown WatchTargetChangeState: " + t);
        }
    }, t.prototype.Cr = function(t) {
        if (t instanceof Pi) return {
            filter: {
                count: t.le.count,
                targetId: t.targetId
            }
        };
        if (t instanceof Di) {
            if (t.fe instanceof pn) {
                var n = t.fe;
                return {
                    documentChange: {
                        document: {
                            name: this.ar(n.key),
                            fields: this.Tr(n.data()),
                            updateTime: this.toVersion(n.version)
                        },
                        targetIds: t.ae,
                        removedTargetIds: t.removedTargetIds
                    }
                };
            }
            if (t.fe instanceof gn) {
                n = t.fe;
                return {
                    documentDelete: {
                        document: this.ar(n.key),
                        readTime: this.toVersion(n.version),
                        removedTargetIds: t.removedTargetIds
                    }
                };
            }
            if (null === t.fe) return {
                documentRemove: {
                    document: this.ar(t.key),
                    removedTargetIds: t.removedTargetIds
                }
            };
        }
        if (t instanceof Si) {
            var i = void 0;
            return t.cause && (i = {
                code: ri(t.cause.code),
                message: t.cause.message
            }), {
                targetChange: {
                    targetChangeType: this.Sr(t.state),
                    targetIds: t.targetIds,
                    resumeToken: this.er(t.resumeToken),
                    cause: i
                }
            };
        }
        return S("Unrecognized watch change: " + JSON.stringify(t));
    }, t.prototype.Vr = function(t) {
        var n, i = this;
        if ("targetChange" in t) {
            Li(t.targetChange, "targetChange");
            // proto3 default value is unset in JSON (undefined), so use 'NO_CHANGE'
            // if unset
            var e = this.Nr(t.targetChange.targetChangeType || "NO_CHANGE"), r = t.targetChange.targetIds || [], u = this.rr(t.targetChange.resumeToken), s = t.targetChange.cause, o = s && this.$e(s);
            n = new Si(e, r, u, o || null);
        } else if ("documentChange" in t) {
            Li(t.documentChange, "documentChange");
            var h = t.documentChange;
            Li(h.document, "documentChange.name"), Li(h.document.name, "documentChange.document.name"), 
            Li(h.document.updateTime, "documentChange.document.updateTime");
            var c = this.lr(h.document.name), a = this.fromVersion(h.document.updateTime), f = new pn(c, a, {}, void 0, h.document, (function(t) {
                return i.yr(t);
            })), l = h.targetIds || [], d = h.removedTargetIds || [];
            n = new Di(l, d, f.key, f);
        } else if ("documentDelete" in t) {
            Li(t.documentDelete, "documentDelete");
            var v = t.documentDelete;
            Li(v.document, "documentDelete.document");
            c = this.lr(v.document), a = v.readTime ? this.fromVersion(v.readTime) : yt.B(), 
            f = new gn(c, a), d = v.removedTargetIds || [];
            n = new Di([], d, f.key, f);
        } else if ("documentRemove" in t) {
            Li(t.documentRemove, "documentRemove");
            var w = t.documentRemove;
            Li(w.document, "documentRemove");
            c = this.lr(w.document), d = w.removedTargetIds || [];
            n = new Di([], d, c, null);
        } else {
            if (!("filter" in t)) return S("Unknown change type " + JSON.stringify(t));
            // TODO(dimond): implement existence filter parsing with strategy.
            Li(t.filter, "filter");
            var m = t.filter;
            Li(m.targetId, "filter.targetId");
            var p = m.count || 0, g = new ni(p), b = m.targetId;
            n = new Pi(b, g);
        }
        return n;
    }, t.prototype.Nr = function(t) {
        return "NO_CHANGE" === t ? _i.de : "ADD" === t ? _i.Mi : "REMOVE" === t ? _i.qi : "CURRENT" === t ? _i.ve : "RESET" === t ? _i.we : S("Got unexpected TargetChange.state: " + t);
    }, t.prototype.kr = function(t) {
        // We have only reached a consistent snapshot for the entire stream if there
        // is a read_time set and it applies to all targets (i.e. the list of
        // targets is empty). The backend is guaranteed to send such responses.
        if (!("targetChange" in t)) return yt.MIN;
        var n = t.targetChange;
        return n.targetIds && n.targetIds.length ? yt.MIN : n.readTime ? this.fromVersion(n.readTime) : yt.MIN;
    }, t.prototype.Or = function(t) {
        var n, i = this;
        if (t instanceof Ht) n = {
            update: this.Ir(t.key, t.value)
        }; else if (t instanceof Xt) n = {
            delete: this.ar(t.key)
        }; else if (t instanceof Jt) n = {
            update: this.Ir(t.key, t.data),
            updateMask: this.Fr(t.on)
        }; else if (t instanceof Yt) n = {
            transform: {
                document: this.ar(t.key),
                fieldTransforms: t.fieldTransforms.map((function(t) {
                    return i.xr(t);
                }))
            }
        }; else {
            if (!(t instanceof $t)) return S("Unknown mutation type " + t.type);
            n = {
                verify: this.ar(t.key)
            };
        }
        return t.rn.tn || (n.currentDocument = this.jr(t.rn)), n;
    }, t.prototype.Ur = function(t) {
        var n = this, i = t.currentDocument ? this.Lr(t.currentDocument) : zt.NONE;
        if (t.update) {
            Li(t.update.name, "name");
            var e = this.lr(t.update.name), r = this._r(t.update.fields || {});
            if (t.updateMask) {
                var u = this.Br(t.updateMask);
                return new Jt(e, r, u, i);
            }
            return new Ht(e, r, i);
        }
        if (t.delete) {
            e = this.lr(t.delete);
            return new Xt(e, i);
        }
        if (t.transform) {
            e = this.lr(t.transform.document);
            var s = t.transform.fieldTransforms.map((function(t) {
                return n.Mr(t);
            }));
            return C(!0 === i.exists, 'Transforms only support precondition "exists == true"'), 
            new Yt(e, s);
        }
        if (t.verify) {
            e = this.lr(t.verify);
            return new $t(e, i);
        }
        return S("unknown mutation proto: " + JSON.stringify(t));
    }, t.prototype.jr = function(t) {
        return C(!t.tn, "Can't serialize an empty precondition"), void 0 !== t.updateTime ? {
            updateTime: this.toVersion(t.updateTime)
        } : void 0 !== t.exists ? {
            exists: t.exists
        } : S("Unknown precondition");
    }, t.prototype.Lr = function(t) {
        return void 0 !== t.updateTime ? zt.updateTime(this.fromVersion(t.updateTime)) : void 0 !== t.exists ? zt.exists(t.exists) : zt.NONE;
    }, t.prototype.qr = function(t, n) {
        var i = this, e = t.updateTime ? this.fromVersion(t.updateTime) : this.fromVersion(n);
        // NOTE: Deletes don't have an updateTime.
                e.isEqual(yt.MIN) && (
        // The Firestore Emulator currently returns an update time of 0 for
        // deletes of non-existing documents (rather than null). This breaks the
        // test "get deleted doc while offline with source=cache" as NoDocuments
        // with version 0 are filtered by IndexedDb's RemoteDocumentCache.
        // TODO(#2149): Remove this when Emulator is fixed
        e = this.fromVersion(n));
        var r = null;
        return t.transformResults && t.transformResults.length > 0 && (r = t.transformResults.map((function(t) {
            return i.yr(t);
        }))), new Mt(e, r);
    }, t.prototype.Qr = function(t, n) {
        var i = this;
        return t && t.length > 0 ? (C(void 0 !== n, "Received a write result without a commit time"), 
        t.map((function(t) {
            return i.qr(t, n);
        }))) : [];
    }, t.prototype.xr = function(t) {
        var n = this, i = t.transform;
        if (i instanceof Nt) return {
            fieldPath: t.field.nt(),
            setToServerValue: "REQUEST_TIME"
        };
        if (i instanceof kt) return {
            fieldPath: t.field.nt(),
            appendMissingElements: {
                values: i.elements.map((function(t) {
                    return n.pr(t);
                }))
            }
        };
        if (i instanceof Ot) return {
            fieldPath: t.field.nt(),
            removeAllFromArray: {
                values: i.elements.map((function(t) {
                    return n.pr(t);
                }))
            }
        };
        if (i instanceof Ft) return {
            fieldPath: t.field.nt(),
            increment: this.pr(i.Kt)
        };
        throw S("Unknown transform: " + t.transform);
    }, t.prototype.Mr = function(t) {
        var n = this, i = null;
        if ("setToServerValue" in t) C("REQUEST_TIME" === t.setToServerValue, "Unknown server value transform proto: " + JSON.stringify(t)), 
        i = Nt.instance; else if ("appendMissingElements" in t) {
            var e = t.appendMissingElements.values || [];
            i = new kt(e.map((function(t) {
                return n.yr(t);
            })));
        } else if ("removeAllFromArray" in t) {
            e = t.removeAllFromArray.values || [];
            i = new Ot(e.map((function(t) {
                return n.yr(t);
            })));
        } else if ("increment" in t) {
            var r = this.yr(t.increment);
            C(r instanceof rn, "NUMERIC_ADD transform requires a NumberValue"), i = new Ft(r);
        } else S("Unknown transform proto: " + JSON.stringify(t));
        var u = Et.ot(t.fieldPath);
        return new Bt(u, i);
    }, t.prototype.Gr = function(t) {
        return {
            documents: [ this.vr(t.path) ]
        };
    }, t.prototype.Wr = function(t) {
        var n = t.documents.length;
        C(1 === n, "DocumentsTarget contained other than 1 document: " + n);
        var i = t.documents[0];
        return kn.$n(this.wr(i)).ai();
    }, t.prototype.zr = function(t) {
        // Dissect the path into parent, collectionId, and optional key filter.
        var n = {
            structuredQuery: {}
        }, i = t.path;
        null !== t.collectionGroup ? (C(i.length % 2 == 0, "Collection Group queries should be within a document path or root."), 
        n.parent = this.vr(i), n.structuredQuery.from = [ {
            collectionId: t.collectionGroup,
            allDescendants: !0
        } ]) : (C(i.length % 2 != 0, "Document queries with filters are not supported."), 
        n.parent = this.vr(i.H()), n.structuredQuery.from = [ {
            collectionId: i.X()
        } ]);
        var e = this.Kr(t.filters);
        e && (n.structuredQuery.where = e);
        var r = this.Hr(t.orderBy);
        r && (n.structuredQuery.orderBy = r);
        var u = this.Ze(t.limit);
        return null !== u && (n.structuredQuery.limit = u), t.startAt && (n.structuredQuery.startAt = this.Jr(t.startAt)), 
        t.endAt && (n.structuredQuery.endAt = this.Jr(t.endAt)), n;
    }, t.prototype.Yr = function(t) {
        var n = this.wr(t.parent), i = t.structuredQuery, e = i.from ? i.from.length : 0, r = null;
        if (e > 0) {
            C(1 === e, "StructuredQuery.from with more than one collection is not supported.");
            var u = i.from[0];
            u.allDescendants ? r = u.collectionId : n = n.child(u.collectionId);
        }
        var s = [];
        i.where && (s = this.Xr(i.where));
        var o = [];
        i.orderBy && (o = this.$r(i.orderBy));
        var h = null;
        i.limit && (h = this.nr(i.limit));
        var c = null;
        i.startAt && (c = this.Zr(i.startAt));
        var a = null;
        return i.endAt && (a = this.Zr(i.endAt)), new kn(n, r, o, s, h, An.Wn, c, a).ai();
    }, t.prototype.tu = function(t) {
        var n = this.nu(t.ki);
        return null == n ? null : {
            "goog-listen-tags": n
        };
    }, t.prototype.nu = function(t) {
        switch (t) {
          case Kn.Ci:
            return null;

          case Kn.Vi:
            return "existence-filter-mismatch";

          case Kn.Ni:
            return "limbo-document";

          default:
            return S("Unrecognized query purpose: " + t);
        }
    }, t.prototype.ai = function(t) {
        var n, i = t.target;
        return (n = i.Gn() ? {
            documents: this.Gr(i)
        } : {
            query: this.zr(i)
        }).targetId = t.targetId, t.resumeToken.Cn() > 0 && (n.resumeToken = this.er(t.resumeToken)), 
        n;
    }, t.prototype.Kr = function(t) {
        var n = this;
        if (0 !== t.length) {
            var i = t.map((function(t) {
                return t instanceof xn ? n.iu(t) : S("Unrecognized filter: " + JSON.stringify(t));
            }));
            return 1 === i.length ? i[0] : {
                compositeFilter: {
                    op: "AND",
                    filters: i
                }
            };
        }
    }, t.prototype.Xr = function(t) {
        var n = this;
        return t ? void 0 !== t.unaryFilter ? [ this.eu(t) ] : void 0 !== t.fieldFilter ? [ this.ru(t) ] : void 0 !== t.compositeFilter ? t.compositeFilter.filters.map((function(t) {
            return n.Xr(t);
        })).reduce((function(t, n) {
            return t.concat(n);
        })) : S("Unknown filter: " + JSON.stringify(t)) : [];
    }, t.prototype.Hr = function(t) {
        var n = this;
        if (0 !== t.length) return t.map((function(t) {
            return n.uu(t);
        }));
    }, t.prototype.$r = function(t) {
        var n = this;
        return t.map((function(t) {
            return n.su(t);
        }));
    }, t.prototype.Jr = function(t) {
        var n = this;
        return {
            before: t.before,
            values: t.position.map((function(t) {
                return n.pr(t);
            }))
        };
    }, t.prototype.Zr = function(t) {
        var n = this, i = !!t.before, e = t.values.map((function(t) {
            return n.yr(t);
        }));
        return new Qn(e, i);
    }, 
    // visible for testing
    t.prototype.ou = function(t) {
        return xi[t.name];
    }, 
    // visible for testing
    t.prototype.hu = function(t) {
        switch (t) {
          case "ASCENDING":
            return qn.ASCENDING;

          case "DESCENDING":
            return qn.DESCENDING;

          default:
            return;
        }
    }, 
    // visible for testing
    t.prototype.cu = function(t) {
        return ji[t.name];
    }, t.prototype.au = function(t) {
        switch (t) {
          case "EQUAL":
            return Fn.EQUAL;

          case "GREATER_THAN":
            return Fn.GREATER_THAN;

          case "GREATER_THAN_OR_EQUAL":
            return Fn.GREATER_THAN_OR_EQUAL;

          case "LESS_THAN":
            return Fn.LESS_THAN;

          case "LESS_THAN_OR_EQUAL":
            return Fn.LESS_THAN_OR_EQUAL;

          case "ARRAY_CONTAINS":
            return Fn.ARRAY_CONTAINS;

          case "IN":
            return Fn.IN;

          case "ARRAY_CONTAINS_ANY":
            return Fn.ARRAY_CONTAINS_ANY;

          case "OPERATOR_UNSPECIFIED":
            return S("Unspecified operator");

          default:
            return S("Unknown operator");
        }
    }, t.prototype.fu = function(t) {
        return {
            fieldPath: t.nt()
        };
    }, t.prototype.lu = function(t) {
        return Et.ot(t.fieldPath);
    }, 
    // visible for testing
    t.prototype.uu = function(t) {
        return {
            field: this.fu(t.field),
            direction: this.ou(t.dir)
        };
    }, t.prototype.su = function(t) {
        return new Gn(this.lu(t.field), this.hu(t.direction));
    }, t.prototype.ru = function(t) {
        return xn.create(this.lu(t.fieldFilter.field), this.au(t.fieldFilter.op), this.yr(t.fieldFilter.value));
    }, 
    // visible for testing
    t.prototype.iu = function(t) {
        if (t.op === Fn.EQUAL) {
            if (t.value.isEqual(on.On)) return {
                unaryFilter: {
                    field: this.fu(t.field),
                    op: "IS_NAN"
                }
            };
            if (t.value.isEqual(nn.Vn)) return {
                unaryFilter: {
                    field: this.fu(t.field),
                    op: "IS_NULL"
                }
            };
        }
        return {
            fieldFilter: {
                field: this.fu(t.field),
                op: this.cu(t.op),
                value: this.pr(t.value)
            }
        };
    }, t.prototype.eu = function(t) {
        switch (t.unaryFilter.op) {
          case "IS_NAN":
            var n = this.lu(t.unaryFilter.field);
            return xn.create(n, Fn.EQUAL, on.On);

          case "IS_NULL":
            var i = this.lu(t.unaryFilter.field);
            return xn.create(i, Fn.EQUAL, nn.Vn);

          case "OPERATOR_UNSPECIFIED":
            return S("Unspecified filter");

          default:
            return S("Unknown filter");
        }
    }, t.prototype.Fr = function(t) {
        var n = [];
        return t.fields.forEach((function(t) {
            return n.push(t.nt());
        })), {
            fieldPaths: n
        };
    }, t.prototype.Br = function(t) {
        var n = (t.fieldPaths || []).map((function(t) {
            return Et.ot(t);
        }));
        return Lt.Yt(n);
    }, t;
}(), qi = /** @class */ function() {
    function t() {}
    return t.du = function(n) {
        t.platform && S("Platform already defined"), t.platform = n;
    }, t.t = function() {
        return t.platform || S("Platform not set"), t.platform;
    }, t;
}();

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Provides singleton helpers where setup code can inject a platform at runtime.
 * setPlatform needs to be set before Firestore is used and must be set exactly
 * once.
 */
/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Helper function to prevent instantiation through the constructor.
 *
 * This method creates a new constructor that throws when it's invoked.
 * The prototype of that constructor is then set to the prototype of the hidden
 * "class" to expose all the prototype methods and allow for instanceof
 * checks.
 *
 * To also make all the static methods available, all properties of the
 * original constructor are copied to the new constructor.
 */
function Qi(t, n) {
    function i() {
        var t = "This constructor is private.";
        throw n && (t += " ", t += n), new B(L.INVALID_ARGUMENT, t);
    }
    // Make sure instanceof checks work and all methods are exposed on the public
    // constructor
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
    return i.prototype = t.prototype, 
    // Copy any static methods/members
    Object.assign(i, t), i;
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** Helper function to assert Uint8Array is available at runtime. */ function Gi() {
    if ("undefined" == typeof Uint8Array) throw new B(L.UNIMPLEMENTED, "Uint8Arrays are not available in this environment.");
}

/** Helper function to assert Base64 functions are available at runtime. */ function Wi() {
    if (!qi.t().vu) throw new B(L.UNIMPLEMENTED, "Blobs are unavailable in Firestore in this environment.");
}

/**
 * Immutable class holding a blob (binary data).
 * This class is directly exposed in the public API.
 *
 * Note that while you can't hide the constructor in JavaScript code, we are
 * using the hack above to make sure no-one outside this module can call it.
 */ var zi, Ki, Hi = /** @class */ function() {
    function t(t) {
        Wi(), this.Pi = t;
    }
    return t.fromBase64String = function(n) {
        Z("Blob.fromBase64String", arguments, 1), it("Blob.fromBase64String", "string", 1, n), 
        Wi();
        try {
            var i = qi.t().atob(n);
            return new t(i);
        } catch (t) {
            throw new B(L.INVALID_ARGUMENT, "Failed to construct Blob from Base64 string: " + t);
        }
    }, t.fromUint8Array = function(n) {
        if (Z("Blob.fromUint8Array", arguments, 1), Gi(), !(n instanceof Uint8Array)) throw vt("Blob.fromUint8Array", "Uint8Array", 1, n);
        var i = Yn(n);
        return new t(i);
    }, t.prototype.toBase64 = function() {
        return Z("Blob.toBase64", arguments, 0), Wi(), qi.t().btoa(this.Pi);
    }, t.prototype.toUint8Array = function() {
        Z("Blob.toUint8Array", arguments, 0), Gi();
        var t = Xn(this.Pi);
        return t;
    }, t.prototype.toString = function() {
        return "Blob(base64: " + this.toBase64() + ")";
    }, t.prototype.isEqual = function(t) {
        return this.Pi === t.Pi;
    }, t.prototype.xn = function() {
        // Assume UTF-16 encoding in memory (see StringValue.approximateByteSize())
        return 2 * this.Pi.length;
    }, 
    /**
     * Actually private to JS consumers of our API, so this function is prefixed
     * with an underscore.
     */
    t.prototype.j = function(t) {
        return N(this.Pi, t.Pi);
    }, t;
}(), Ji = Qi(Hi, "Use Blob.fromUint8Array() or Blob.fromBase64String() instead."), Yi = /** @class */ function() {
    function t(t, n) {
        var i = this;
        this.previousValue = t, n && (n.wu = function(t) {
            return i.mu(t);
        }, this.pu = function(t) {
            return n.gu(t);
        });
    }
    return t.prototype.mu = function(t) {
        return this.previousValue = Math.max(t, this.previousValue), this.previousValue;
    }, t.prototype.next = function() {
        var t = ++this.previousValue;
        return this.pu && this.pu(t), t;
    }, t.bu = -1, t;
}(), Xi = function() {
    var t = this;
    this.promise = new Promise((function(n, i) {
        t.resolve = n, t.reject = i;
    }));
};

// Public instance that disallows construction at runtime. This constructor is
// used when exporting Blob on firebase.firestore.Blob and will be called Blob
// publicly. Internally we still use Blob which has a type checked private
// constructor. Note that Blob and PublicBlob can be used interchangeably in
// instanceof checks.
// For our internal TypeScript code PublicBlob doesn't exist as a type, and so
// we need to use Blob as type and export it too.
/** All can be used with runDelayedOperationsEarly() to run all timers. */
(Ki = zi || (zi = {})).yu = "all", 
/**
     * The following 4 timers are used in persistent_stream.ts for the listen and
     * write streams. The "Idle" timer is used to close the stream due to
     * inactivity. The "ConnectionBackoff" timer is used to restart a stream once
     * the appropriate backoff delay has elapsed.
     */
Ki._u = "listen_stream_idle", Ki.Iu = "listen_stream_connection_backoff", Ki.Tu = "write_stream_idle", 
Ki.Eu = "write_stream_connection_backoff", 
/**
     * A timer used in online_state_tracker.ts to transition from
     * OnlineState.Unknown to Offline after a set timeout, rather than waiting
     * indefinitely for success or failure.
     */
Ki.Ru = "online_state_timeout", 
/**
     * A timer used to update the client metadata in IndexedDb, which is used
     * to determine the primary leaseholder.
     */
Ki.Au = "client_metadata_refresh", 
/** A timer used to periodically attempt LRU Garbage collection */
Ki.Du = "lru_garbage_collection", 
/**
     * A timer used to retry transactions. Since there can be multiple concurrent
     * transactions, multiple of these may be in the queue at a given time.
     */
Ki.Pu = "retry_transaction";

/**
 * Represents an operation scheduled to be run in the future on an AsyncQueue.
 *
 * It is created via DelayedOperation.createAndSchedule().
 *
 * Supports cancellation (via cancel()) and early execution (via skipDelay()).
 */
var $i = /** @class */ function() {
    function t(t, n, i, e, r) {
        this.Su = t, this.Cu = n, this.Vu = i, this.op = e, this.Nu = r, this.ku = new Xi, 
        this.then = this.ku.promise.then.bind(this.ku.promise), this.catch = this.ku.promise.catch.bind(this.ku.promise), 
        // It's normal for the deferred promise to be canceled (due to cancellation)
        // and so we attach a dummy catch callback to avoid
        // 'UnhandledPromiseRejectionWarning' log spam.
        this.ku.promise.catch((function(t) {}));
    }
    /**
     * Creates and returns a DelayedOperation that has been scheduled to be
     * executed on the provided asyncQueue after the provided delayMs.
     *
     * @param asyncQueue The queue to schedule the operation on.
     * @param id A Timer ID identifying the type of operation this is.
     * @param delayMs The delay (ms) before the operation should be scheduled.
     * @param op The operation to run.
     * @param removalCallback A callback to be called synchronously once the
     *   operation is executed or canceled, notifying the AsyncQueue to remove it
     *   from its delayedOperations list.
     *   PORTING NOTE: This exists to prevent making removeDelayedOperation() and
     *   the DelayedOperation class public.
     */    return t.Ou = function(n, i, e, r, u) {
        var s = new t(n, i, Date.now() + e, r, u);
        return s.start(e), s;
    }, 
    /**
     * Starts the timer. This is called immediately after construction by
     * createAndSchedule().
     */
    t.prototype.start = function(t) {
        var n = this;
        this.Fu = setTimeout((function() {
            return n.xu();
        }), t);
    }, 
    /**
     * Queues the operation to run immediately (if it hasn't already been run or
     * canceled).
     */
    t.prototype.ju = function() {
        return this.xu();
    }, 
    /**
     * Cancels the operation if it hasn't already been executed or canceled. The
     * promise will be rejected.
     *
     * As long as the operation has not yet been run, calling cancel() provides a
     * guarantee that the operation will not be run.
     */
    t.prototype.cancel = function(t) {
        null !== this.Fu && (this.clearTimeout(), this.ku.reject(new B(L.CANCELLED, "Operation cancelled" + (t ? ": " + t : ""))));
    }, t.prototype.xu = function() {
        var t = this;
        this.Su.Uu((function() {
            return null !== t.Fu ? (t.clearTimeout(), t.op().then((function(n) {
                return t.ku.resolve(n);
            }))) : Promise.resolve();
        }));
    }, t.prototype.clearTimeout = function() {
        null !== this.Fu && (this.Nu(this), clearTimeout(this.Fu), this.Fu = null);
    }, t;
}(), Zi = /** @class */ function() {
    function t() {
        // The last promise in the queue.
        this.Lu = Promise.resolve(), 
        // Is this AsyncQueue being shut down? Once it is set to true, it will not
        // be changed again.
        this.Bu = !1, 
        // Operations scheduled to be queued in the future. Operations are
        // automatically removed after they are run or canceled.
        this.Mu = [], 
        // visible for testing
        this.qu = null, 
        // Flag set while there's an outstanding AsyncQueue operation, used for
        // assertion sanity-checks.
        this.Qu = !1, 
        // List of TimerIds to fast-forward delays for.
        this.Gu = [];
    }
    return Object.defineProperty(t.prototype, "Wu", {
        // Is this AsyncQueue being shut down? If true, this instance will not enqueue
        // any new operations, Promises from enqueue requests will not resolve.
        get: function() {
            return this.Bu;
        },
        enumerable: !0,
        configurable: !0
    }), 
    /**
     * Adds a new operation to the queue without waiting for it to complete (i.e.
     * we ignore the Promise result).
     */
    t.prototype.Uu = function(t) {
        // eslint-disable-next-line @typescript-eslint/no-floating-promises
        this.enqueue(t);
    }, 
    /**
     * Regardless if the queue has initialized shutdown, adds a new operation to the
     * queue without waiting for it to complete (i.e. we ignore the Promise result).
     */
    t.prototype.zu = function(t) {
        this.Ku(), 
        // eslint-disable-next-line @typescript-eslint/no-floating-promises
        this.Hu(t);
    }, 
    /**
     * Regardless if the queue has initialized shutdown, adds a new operation to the
     * queue.
     */
    t.prototype.Ju = function(t) {
        return this.Ku(), this.Hu(t);
    }, 
    /**
     * Adds a new operation to the queue and initialize the shut down of this queue.
     * Returns a promise that will be resolved when the promise returned by the new
     * operation is (with its value).
     * Once this method is called, the only possible way to request running an operation
     * is through `enqueueAndForgetEvenAfterShutdown`.
     */
    t.prototype.Yu = function(t) {
        return r(this, void 0, void 0, (function() {
            return u(this, (function(n) {
                switch (n.label) {
                  case 0:
                    return this.Ku(), this.Bu ? [ 3 /*break*/ , 2 ] : (this.Bu = !0, [ 4 /*yield*/ , this.Ju(t) ]);

                  case 1:
                    n.sent(), n.label = 2;

                  case 2:
                    return [ 2 /*return*/ ];
                }
            }));
        }));
    }, 
    /**
     * Adds a new operation to the queue. Returns a promise that will be resolved
     * when the promise returned by the new operation is (with its value).
     */
    t.prototype.enqueue = function(t) {
        return this.Ku(), this.Bu ? new Promise((function(t) {})) : this.Hu(t);
    }, t.prototype.Hu = function(t) {
        var n = this, i = this.Lu.then((function() {
            return n.Qu = !0, t().catch((function(t) {
                n.qu = t, n.Qu = !1;
                var i = t.stack || t.message || "";
                // Re-throw the error so that this.tail becomes a rejected Promise and
                // all further attempts to chain (via .then) will just short-circuit
                // and return the rejected Promise.
                throw D("INTERNAL UNHANDLED ERROR: ", i), 
                // Escape the promise chain and throw the error globally so that
                // e.g. any global crash reporting library detects and reports it.
                // (but not for simulated errors in our tests since this breaks mocha)
                i.indexOf("Firestore Test Simulated Error") < 0 && setTimeout((function() {
                    throw t;
                }), 0), t;
            })).then((function(t) {
                return n.Qu = !1, t;
            }));
        }));
        return this.Lu = i, i;
    }, 
    /**
     * Schedules an operation to be queued on the AsyncQueue once the specified
     * `delayMs` has elapsed. The returned CancelablePromise can be used to cancel
     * the operation prior to its running.
     */
    t.prototype.Xu = function(t, n, i) {
        var e = this;
        this.Ku(), C(n >= 0, "Attempted to schedule an operation with a negative delay of " + n), 
        // Fast-forward delays for timerIds that have been overriden.
        this.Gu.indexOf(t) > -1 && (n = 0);
        var r = $i.Ou(this, t, n, i, (function(t) {
            return e.$u(t);
        }));
        return this.Mu.push(r), r;
    }, t.prototype.Ku = function() {
        this.qu && S("AsyncQueue is already failed: " + (this.qu.stack || this.qu.message));
    }, 
    /**
     * Verifies there's an operation currently in-progress on the AsyncQueue.
     * Unfortunately we can't verify that the running code is in the promise chain
     * of that operation, so this isn't a foolproof check, but it should be enough
     * to catch some bugs.
     */
    t.prototype.Zu = function() {
        C(this.Qu, "verifyOpInProgress() called when no op in progress on this queue.");
    }, 
    /**
     * Waits until all currently queued tasks are finished executing. Delayed
     * operations are not run.
     */
    t.prototype.ts = function() {
        // It should still be possible to drain the queue after it is shutting down.
        return this.Ju((function() {
            return Promise.resolve();
        }));
    }, 
    /**
     * For Tests: Determine if a delayed operation with a particular TimerId
     * exists.
     */
    t.prototype.ns = function(t) {
        for (var n = 0, i = this.Mu; n < i.length; n++) {
            if (i[n].Cu === t) return !0;
        }
        return !1;
    }, 
    /**
     * For Tests: Runs some or all delayed operations early.
     *
     * @param lastTimerId Delayed operations up to and including this TimerId will
     *  be drained. Throws if no such operation exists. Pass TimerId.All to run
     *  all delayed operations.
     * @returns a Promise that resolves once all operations have been run.
     */
    t.prototype.es = function(t) {
        var n = this;
        // Note that draining may generate more delayed ops, so we do that first.
                return this.ts().then((function() {
            C(t === zi.yu || n.ns(t), "Attempted to drain to missing operation " + t), 
            // Run ops in the same order they'd run if they ran naturally.
            n.Mu.sort((function(t, n) {
                return t.Vu - n.Vu;
            }));
            for (var i = 0, e = n.Mu; i < e.length; i++) {
                var r = e[i];
                if (r.ju(), t !== zi.yu && r.Cu === t) break;
            }
            return n.ts();
        }));
    }, 
    /**
     * For Tests: Skip all subsequent delays for a timer id.
     */
    t.prototype.rs = function(t) {
        this.Gu.push(t);
    }, 
    /** Called once a DelayedOperation is run or canceled. */
    t.prototype.$u = function(t) {
        // NOTE: indexOf / slice are O(n), but delayedOperations is expected to be small.
        var n = this.Mu.indexOf(t);
        C(n >= 0, "Delayed operation not found."), this.Mu.splice(n, 1);
    }, t;
}(), te = "", ne = "", ie = "", ee = "";

/**
 * Encodes a resource path into a IndexedDb-compatible string form.
 */
function re(t) {
    for (var n = "", i = 0; i < t.length; i++) n.length > 0 && (n = se(n)), n = ue(t.get(i), n);
    return se(n);
}

/** Encodes a single segment of a resource path into the given result */ function ue(t, n) {
    for (var i = n, e = t.length, r = 0; r < e; r++) {
        var u = t.charAt(r);
        switch (u) {
          case "\0":
            i += te + ie;
            break;

          case te:
            i += te + ee;
            break;

          default:
            i += u;
        }
    }
    return i;
}

/** Encodes a path separator into the given result */ function se(t) {
    return t + te + ne;
}

/**
 * Decodes the given IndexedDb-compatible string form of a resource path into
 * a ResourcePath instance. Note that this method is not suitable for use with
 * decoding resource names from the server; those are One Platform format
 * strings.
 */ function oe(t) {
    // Event the empty path must encode as a path of at least length 2. A path
    // with exactly 2 must be the empty path.
    var n = t.length;
    if (C(n >= 2, "Invalid path " + t), 2 === n) return C(t.charAt(0) === te && t.charAt(1) === ne, "Non-empty path " + t + " had length 2"), 
    It.et;
    // Escape characters cannot exist past the second-to-last position in the
    // source value.
        for (var i = n - 2, e = [], r = "", u = 0; u < n; ) {
        // The last two characters of a valid encoded path must be a separator, so
        // there must be an end to this segment.
        var s = t.indexOf(te, u);
        switch ((s < 0 || s > i) && S('Invalid encoded resource path: "' + t + '"'), t.charAt(s + 1)) {
          case ne:
            var o = t.substring(u, s), h = void 0;
            0 === r.length ? 
            // Avoid copying for the common case of a segment that excludes \0
            // and \001
            h = o : (h = r += o, r = ""), e.push(h);
            break;

          case ie:
            r += t.substring(u, s), r += "\0";
            break;

          case ee:
            // The escape character can be used in the output to encode itself.
            r += t.substring(u, s + 1);
            break;

          default:
            S('Invalid encoded resource path: "' + t + '"');
        }
        u = s + 2;
    }
    return new It(e);
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ var he = /** @class */ function() {
    /**
     * @param batchId The unique ID of this mutation batch.
     * @param localWriteTime The original write time of this mutation.
     * @param baseMutations Mutations that are used to populate the base
     * values when this mutation is applied locally. This can be used to locally
     * overwrite values that are persisted in the remote document cache. Base
     * mutations are never sent to the backend.
     * @param mutations The user-provided mutations in this mutation batch.
     * User-provided mutations are applied both locally and remotely on the
     * backend.
     */
    function t(t, n, i, e) {
        this.batchId = t, this.Fn = n, this.baseMutations = i, this.mutations = e, C(e.length > 0, "Cannot create an empty mutation batch");
    }
    /**
     * Applies all the mutations in this MutationBatch to the specified document
     * to create a new remote document
     *
     * @param docKey The key of the document to apply mutations to.
     * @param maybeDoc The document to apply mutations to.
     * @param batchResult The result of applying the MutationBatch to the
     * backend.
     */    return t.prototype.Wt = function(t, n, i) {
        n && C(n.key.isEqual(t), "applyToRemoteDocument: key " + t + " should match maybeDoc key\n        " + n.key);
        var e = i.us;
        C(e.length === this.mutations.length, "Mismatch between mutations length\n      (" + this.mutations.length + ") and mutation results length\n      (" + e.length + ").");
        for (var r = 0; r < this.mutations.length; r++) {
            var u = this.mutations[r];
            if (u.key.isEqual(t)) {
                var s = e[r];
                n = u.Wt(n, s);
            }
        }
        return n;
    }, 
    /**
     * Computes the local view of a document given all the mutations in this
     * batch.
     *
     * @param docKey The key of the document to apply mutations to.
     * @param maybeDoc The document to apply mutations to.
     */
    t.prototype.Gt = function(t, n) {
        n && C(n.key.isEqual(t), "applyToLocalDocument: key " + t + " should match maybeDoc key\n        " + n.key);
        // First, apply the base state. This allows us to apply non-idempotent
        // transform against a consistent set of values.
                for (var i = 0, e = this.baseMutations; i < e.length; i++) {
            (o = e[i]).key.isEqual(t) && (n = o.Gt(n, n, this.Fn));
        }
        // Second, apply all user-provided mutations.
        for (var r = n, u = 0, s = this.mutations; u < s.length; u++) {
            var o;
            (o = s[u]).key.isEqual(t) && (n = o.Gt(n, r, this.Fn));
        }
        return n;
    }, 
    /**
     * Computes the local view for all provided documents given the mutations in
     * this batch.
     */
    t.prototype.ss = function(t) {
        var n = this, i = t;
        // TODO(mrschmidt): This implementation is O(n^2). If we apply the mutations
        // directly (as done in `applyToLocalView()`), we can reduce the complexity
        // to O(n).
                return this.mutations.forEach((function(e) {
            var r = n.Gt(e.key, t.get(e.key));
            r && (i = i.lt(e.key, r));
        })), i;
    }, t.prototype.keys = function() {
        return this.mutations.reduce((function(t, n) {
            return t.add(n.key);
        }), di());
    }, t.prototype.isEqual = function(t) {
        return this.batchId === t.batchId && k(this.mutations, t.mutations) && k(this.baseMutations, t.baseMutations);
    }, t;
}(), ce = /** @class */ function() {
    function t(t, n, i, e, 
    /**
     * A pre-computed mapping from each mutated document to the resulting
     * version.
     */
    r) {
        this.batch = t, this.os = n, this.us = i, this.streamToken = e, this.hs = r;
    }
    /**
     * Creates a new MutationBatchResult for the given batch and results. There
     * must be one result for each mutation in the batch. This static factory
     * caches a document=>version mapping (docVersions).
     */    return t.from = function(n, i, e, r) {
        C(n.mutations.length === e.length, "Mutations sent " + n.mutations.length + " must equal results received " + e.length);
        for (var u = fi(), s = n.mutations, o = 0; o < s.length; o++) u = u.lt(s[o].key, e[o].version);
        return new t(n, i, e, r, u);
    }, t;
}(), ae = /** @class */ function() {
    function t() {
        // A set of outstanding references to a document sorted by key.
        this.cs = new Ct(fe.Un), 
        // A set of outstanding references to a document sorted by target id.
        this.as = new Ct(fe.fs);
    }
    /** Returns true if the reference set contains no references. */    return t.prototype.J = function() {
        return this.cs.J();
    }, 
    /** Adds a reference to the given document key for the given ID. */
    t.prototype.ls = function(t, n) {
        var i = new fe(t, n);
        this.cs = this.cs.add(i), this.as = this.as.add(i);
    }, 
    /** Add references to the given document keys for the given ID. */
    t.prototype.ds = function(t, n) {
        var i = this;
        t.forEach((function(t) {
            return i.ls(t, n);
        }));
    }, 
    /**
     * Removes a reference to the given document key for the given
     * ID.
     */
    t.prototype.vs = function(t, n) {
        this.ws(new fe(t, n));
    }, t.prototype.ms = function(t, n) {
        var i = this;
        t.forEach((function(t) {
            return i.vs(t, n);
        }));
    }, 
    /**
     * Clears all references with a given ID. Calls removeRef() for each key
     * removed.
     */
    t.prototype.ps = function(t) {
        var n = this, i = Rt.EMPTY, e = new fe(i, t), r = new fe(i, t + 1), u = [];
        return this.as.Lt([ e, r ], (function(t) {
            n.ws(t), u.push(t.key);
        })), u;
    }, t.prototype.gs = function() {
        var t = this;
        this.cs.forEach((function(n) {
            return t.ws(n);
        }));
    }, t.prototype.ws = function(t) {
        this.cs = this.cs.delete(t), this.as = this.as.delete(t);
    }, t.prototype.bs = function(t) {
        var n = Rt.EMPTY, i = new fe(n, t), e = new fe(n, t + 1), r = di();
        return this.as.Lt([ i, e ], (function(t) {
            r = r.add(t.key);
        })), r;
    }, t.prototype.ys = function(t) {
        var n = new fe(t, 0), i = this.cs.Mt(n);
        return null !== i && t.isEqual(i.key);
    }, t;
}(), fe = /** @class */ function() {
    function t(t, n) {
        this.key = t, this._s = n;
    }
    /** Compare by key then by ID */    return t.Un = function(t, n) {
        return Rt.G(t.key, n.key) || N(t._s, n._s);
    }, 
    /** Compare by ID then by key */
    t.fs = function(t, n) {
        return N(t._s, n._s) || Rt.G(t.key, n.key);
    }, t;
}(), le = /** @class */ function() {
    function t(t) {
        this.Is = t, 
        /**
         * The inner map for a key -> value pair. Due to the possibility of
         * collisions we keep a list of entries that we do a linear search through
         * to find an actual match. Note that collisions should be rare, so we still
         * expect near constant time lookups in practice.
         */
        this.Ts = {};
    }
    /** Get a value for this key, or undefined if it does not exist. */    return t.prototype.get = function(t) {
        var n = this.Is(t), i = this.Ts[n];
        if (void 0 !== i) for (var e = 0, r = i; e < r.length; e++) {
            var u = r[e], s = u[0], o = u[1];
            if (s.isEqual(t)) return o;
        }
    }, t.prototype.has = function(t) {
        return void 0 !== this.get(t);
    }, 
    /** Put this key and value in the map. */
    t.prototype.set = function(t, n) {
        var i = this.Is(t), e = this.Ts[i];
        if (void 0 !== e) {
            for (var r = 0; r < e.length; r++) if (e[r][0].isEqual(t)) return void (e[r] = [ t, n ]);
            e.push([ t, n ]);
        } else this.Ts[i] = [ [ t, n ] ];
    }, 
    /**
     * Remove this key from the map. Returns a boolean if anything was deleted.
     */
    t.prototype.delete = function(t) {
        var n = this.Is(t), i = this.Ts[n];
        if (void 0 === i) return !1;
        for (var e = 0; e < i.length; e++) if (i[e][0].isEqual(t)) return 1 === i.length ? delete this.Ts[n] : i.splice(e, 1), 
        !0;
        return !1;
    }, t.prototype.forEach = function(t) {
        Y(this.Ts, (function(n, i) {
            for (var e = 0, r = i; e < r.length; e++) {
                var u = r[e], s = u[0], o = u[1];
                t(s, o);
            }
        }));
    }, t.prototype.J = function() {
        return X(this.Ts);
    }, t;
}(), de = /** @class */ function() {
    function t(t) {
        var n = this;
        // NOTE: next/catchCallback will always point to our own wrapper functions,
        // not the user's raw next() or catch() callbacks.
                this.Es = null, this.Rs = null, 
        // When the operation resolves, we'll set result or error and mark isDone.
        this.result = void 0, this.error = void 0, this.As = !1, 
        // Set to true when .then() or .catch() are called and prevents additional
        // chaining.
        this.Ds = !1, t((function(t) {
            n.As = !0, n.result = t, n.Es && 
            // value should be defined unless T is Void, but we can't express
            // that in the type system.
            n.Es(t);
        }), (function(t) {
            n.As = !0, n.error = t, n.Rs && n.Rs(t);
        }));
    }
    return t.prototype.catch = function(t) {
        return this.next(void 0, t);
    }, t.prototype.next = function(n, i) {
        var e = this;
        return this.Ds && S("Called next() or catch() twice for PersistencePromise"), this.Ds = !0, 
        this.As ? this.error ? this.Ps(i, this.error) : this.Ss(n, this.result) : new t((function(t, r) {
            e.Es = function(i) {
                e.Ss(n, i).next(t, r);
            }, e.Rs = function(n) {
                e.Ps(i, n).next(t, r);
            };
        }));
    }, t.prototype.Cs = function() {
        var t = this;
        return new Promise((function(n, i) {
            t.next(n, i);
        }));
    }, t.prototype.Vs = function(n) {
        try {
            var i = n();
            return i instanceof t ? i : t.resolve(i);
        } catch (n) {
            return t.reject(n);
        }
    }, t.prototype.Ss = function(n, i) {
        return n ? this.Vs((function() {
            return n(i);
        })) : t.resolve(i);
    }, t.prototype.Ps = function(n, i) {
        return n ? this.Vs((function() {
            return n(i);
        })) : t.reject(i);
    }, t.resolve = function(n) {
        return new t((function(t, i) {
            t(n);
        }));
    }, t.reject = function(n) {
        return new t((function(t, i) {
            i(n);
        }));
    }, t.Ns = function(
    // Accept all Promise types in waitFor().
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    n) {
        return new t((function(t, i) {
            var e = 0, r = 0, u = !1;
            n.forEach((function(n) {
                ++e, n.next((function() {
                    ++r, u && r === e && t();
                }), (function(t) {
                    return i(t);
                }));
            })), u = !0, r === e && t();
        }));
    }, 
    /**
     * Given an array of predicate functions that asynchronously evaluate to a
     * boolean, implements a short-circuiting `or` between the results. Predicates
     * will be evaluated until one of them returns `true`, then stop. The final
     * result will be whether any of them returned `true`.
     */
    t.ks = function(n) {
        for (var i = t.resolve(!1), e = function(n) {
            i = i.next((function(i) {
                return i ? t.resolve(i) : n();
            }));
        }, r = 0, u = n; r < u.length; r++) {
            e(u[r]);
        }
        return i;
    }, t.forEach = function(t, n) {
        var i = this, e = [];
        return t.forEach((function(t, r) {
            e.push(n.call(i, t, r));
        })), this.Ns(e);
    }, t;
}(), ve = /** @class */ function() {
    function t() {
        // A mapping of document key to the new cache entry that should be written (or null if any
        // existing cache entry should be removed).
        this.Os = new le((function(t) {
            return t.toString();
        })), this.Fs = !1;
    }
    return Object.defineProperty(t.prototype, "readTime", {
        get: function() {
            return C(void 0 !== this.xs, "Read time is not set. All removeEntry() calls must include a readTime if `trackRemovals` is used."), 
            this.xs;
        },
        set: function(t) {
            // Right now (for simplicity) we just track a single readTime for all the
            // added entries since we expect them to all be the same, but we could
            // rework to store per-entry readTimes if necessary.
            C(void 0 === this.xs || this.xs.isEqual(t), "All changes in a RemoteDocumentChangeBuffer must have the same read time"), 
            this.xs = t;
        },
        enumerable: !0,
        configurable: !0
    }), 
    /**
     * Buffers a `RemoteDocumentCache.addEntry()` call.
     *
     * You can only modify documents that have already been retrieved via
     * `getEntry()/getEntries()` (enforced via IndexedDbs `apply()`).
     */
    t.prototype.js = function(t, n) {
        this.Us(), this.readTime = n, this.Os.set(t.key, t);
    }, 
    /**
     * Buffers a `RemoteDocumentCache.removeEntry()` call.
     *
     * You can only remove documents that have already been retrieved via
     * `getEntry()/getEntries()` (enforced via IndexedDbs `apply()`).
     */
    t.prototype.Ls = function(t, n) {
        this.Us(), n && (this.readTime = n), this.Os.set(t, null);
    }, 
    /**
     * Looks up an entry in the cache. The buffered changes will first be checked,
     * and if no buffered change applies, this will forward to
     * `RemoteDocumentCache.getEntry()`.
     *
     * @param transaction The transaction in which to perform any persistence
     *     operations.
     * @param documentKey The key of the entry to look up.
     * @return The cached Document or NoDocument entry, or null if we have nothing
     * cached.
     */
    t.prototype.Bs = function(t, n) {
        this.Us();
        var i = this.Os.get(n);
        return void 0 !== i ? de.resolve(i) : this.Ms(t, n);
    }, 
    /**
     * Looks up several entries in the cache, forwarding to
     * `RemoteDocumentCache.getEntry()`.
     *
     * @param transaction The transaction in which to perform any persistence
     *     operations.
     * @param documentKeys The keys of the entries to look up.
     * @return A map of cached `Document`s or `NoDocument`s, indexed by key. If an
     *     entry cannot be found, the corresponding key will be mapped to a null
     *     value.
     */
    t.prototype.getEntries = function(t, n) {
        return this.qs(t, n);
    }, 
    /**
     * Applies buffered changes to the underlying RemoteDocumentCache, using
     * the provided transaction.
     */
    t.prototype.apply = function(t) {
        return this.Us(), this.Fs = !0, this.Qs(t);
    }, 
    /** Helper to assert this.changes is not null  */
    t.prototype.Us = function() {
        C(!this.Fs, "Changes have already been applied.");
    }, t;
}(), we = "The current tab is not in the required state to perform this operation. It might be necessary to refresh the browser tab.", me = /** @class */ function() {
    function t() {
        this.Gs = [];
    }
    return t.prototype.Ws = function(t) {
        this.Gs.push(t);
    }, t.prototype.zs = function() {
        this.Gs.forEach((function(t) {
            return t();
        }));
    }, t;
}(), pe = /** @class */ function() {
    function t(n) {
        this.db = n, 
        // NOTE: According to https://bugs.webkit.org/show_bug.cgi?id=197050, the
        // bug we're checking for should exist in iOS >= 12.2 and < 13, but for
        // whatever reason it's much harder to hit after 12.2 so we only proactively
        // log on 12.2.
        12.2 === t.Ks(h()) && D("Firestore persistence suffers from a bug in iOS 12.2 Safari that may cause your app to stop working. See https://stackoverflow.com/q/56496296/110915 for details and a potential workaround.");
    }
    /**
     * Opens the specified database, creating or upgrading it if necessary.
     *
     * Note that `version` must not be a downgrade. IndexedDB does not support downgrading the schema
     * version. We currently do not support any way to do versioning outside of IndexedDB's versioning
     * mechanism, as only version-upgrade transactions are allowed to do things like create
     * objectstores.
     */    return t.Hs = function(n, i, e) {
        return C(t.Js(), "IndexedDB not supported in current environment."), A("SimpleDb", "Opening database:", n), 
        new de((function(r, u) {
            // TODO(mikelehen): Investigate browser compatibility.
            // https://developer.mozilla.org/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB
            // suggests IE9 and older WebKit browsers handle upgrade
            // differently. They expect setVersion, as described here:
            // https://developer.mozilla.org/en-US/docs/Web/API/IDBVersionChangeRequest/setVersion
            var s = window.indexedDB.open(n, i);
            s.onsuccess = function(n) {
                var i = n.target.result;
                r(new t(i));
            }, s.onblocked = function() {
                u(new B(L.FAILED_PRECONDITION, "Cannot upgrade IndexedDB schema while another tab is open. Close all tabs that access Firestore and reload this page to proceed."));
            }, s.onerror = function(t) {
                var n = t.target.error;
                "VersionError" === n.name ? u(new B(L.FAILED_PRECONDITION, "A newer version of the Firestore SDK was previously used and so the persisted data is not compatible with the version of the SDK you are now using. The SDK will operate with persistence disabled. If you need persistence, please re-upgrade to a newer version of the SDK or else clear the persisted IndexedDB data for your app to start fresh.")) : u(n);
            }, s.onupgradeneeded = function(t) {
                A("SimpleDb", 'Database "' + n + '" requires upgrade from version:', t.oldVersion);
                var i = t.target.result;
                e.createOrUpgrade(i, s.transaction, t.oldVersion, er).next((function() {
                    A("SimpleDb", "Database upgrade to version " + er + " complete");
                }));
            };
        })).Cs();
    }, 
    /** Deletes the specified database. */
    t.delete = function(t) {
        return A("SimpleDb", "Removing database:", t), _e(window.indexedDB.deleteDatabase(t)).Cs();
    }, 
    /** Returns true if IndexedDB is available in the current environment. */
    t.Js = function() {
        if ("undefined" == typeof window || null == window.indexedDB) return !1;
        if (t.Ys()) return !0;
        // In some Node environments, `window` is defined, but `window.navigator` is
        // not. We don't support IndexedDB persistence in Node if the
        // isMockPersistence() check above returns false.
                if (void 0 === window.navigator) return !1;
        // We extensively use indexed array values and compound keys,
        // which IE and Edge do not support. However, they still have indexedDB
        // defined on the window, so we need to check for them here and make sure
        // to return that persistence is not enabled for those browsers.
        // For tracking support of this feature, see here:
        // https://developer.microsoft.com/en-us/microsoft-edge/platform/status/indexeddbarraysandmultientrysupport/
        // Check the UA string to find out the browser.
                var n = h(), i = t.Ks(n), e = 0 < i && i < 10, r = t.Xs(n), u = 0 < r && r < 4.5;
        // IE 10
        // ua = 'Mozilla/5.0 (compatible; MSIE 10.0; Windows NT 6.2; Trident/6.0)';
        // IE 11
        // ua = 'Mozilla/5.0 (Windows NT 6.3; Trident/7.0; rv:11.0) like Gecko';
        // Edge
        // ua = 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML,
        // like Gecko) Chrome/39.0.2171.71 Safari/537.36 Edge/12.0';
        // iOS Safari: Disable for users running iOS version < 10.
                return !(n.indexOf("MSIE ") > 0 || n.indexOf("Trident/") > 0 || n.indexOf("Edge/") > 0 || e || u);
    }, 
    /**
     * Returns true if the backing IndexedDB store is the Node IndexedDBShim
     * (see https://github.com/axemclion/IndexedDBShim).
     */
    t.Ys = function() {
        var t;
        return "undefined" != typeof process && "YES" === (null === (t = process.env) || void 0 === t ? void 0 : t.$s);
    }, 
    /** Helper to get a typed SimpleDbStore from a transaction. */
    t.Zs = function(t, n) {
        return t.store(n);
    }, 
    // visible for testing
    /** Parse User Agent to determine iOS version. Returns -1 if not found. */
    t.Ks = function(t) {
        var n = t.match(/i(?:phone|pad|pod) os ([\d_]+)/i), i = n ? n[1].split("_").slice(0, 2).join(".") : "-1";
        return Number(i);
    }, 
    // visible for testing
    /** Parse User Agent to determine Android version. Returns -1 if not found. */
    t.Xs = function(t) {
        var n = t.match(/Android ([\d.]+)/i), i = n ? n[1].split(".").slice(0, 2).join(".") : "-1";
        return Number(i);
    }, t.prototype.to = function(t) {
        this.db.onversionchange = function(n) {
            return t(n);
        };
    }, t.prototype.runTransaction = function(t, n, i) {
        return r(this, void 0, void 0, (function() {
            var e, r, s, o, h, c;
            return u(this, (function(a) {
                switch (a.label) {
                  case 0:
                    e = t.startsWith("readonly"), r = t.endsWith("idempotent"), s = 0, o = function() {
                        var t, o, c, a;
                        return u(this, (function(u) {
                            switch (u.label) {
                              case 0:
                                ++s, t = be.open(h.db, e ? "readonly" : "readwrite", n), u.label = 1;

                              case 1:
                                // Wait for the transaction to complete (i.e. IndexedDb's onsuccess event to
                                // fire), but still return the original transactionFnResult back to the
                                // caller.
                                return u.trys.push([ 1, 3, , 4 ]), 
                                // As noted above, errors are propagated by aborting the transaction. So
                                // we swallow any error here to avoid the browser logging it as unhandled.
                                (o = i(t).catch((function(n) {
                                    // We cannot actually recover, and calling `abort()` will cause the transaction's
                                    // completion promise to be rejected. This in turn means that we won't use
                                    // `transactionFnResult` below. We return a rejection here so that we don't add the
                                    // possibility of returning `void` to the type of `transactionFnResult`.
                                    // Abort the transaction if there was an error.
                                    return t.abort(n), de.reject(n);
                                })).Cs()).catch((function() {})), [ 4 /*yield*/ , t.no ];

                              case 2:
                                // Wait for the transaction to complete (i.e. IndexedDb's onsuccess event to
                                // fire), but still return the original transactionFnResult back to the
                                // caller.
                                return u.sent(), [ 2 /*return*/ , {
                                    value: o
                                } ];

                              case 3:
                                return c = u.sent(), a = r && "FirebaseError" !== c.name && s < 3, A("SimpleDb", "Transaction failed with error: %s. Retrying: %s.", c.message, a), 
                                a ? [ 3 /*break*/ , 4 ] : [ 2 /*return*/ , {
                                    value: Promise.reject(c)
                                } ];

                              case 4:
                                return [ 2 /*return*/ ];
                            }
                        }));
                    }, h = this, a.label = 1;

                  case 1:
                    return [ 5 /*yield**/ , o() ];

                  case 2:
                    return "object" == typeof (c = a.sent()) ? [ 2 /*return*/ , c.value ] : [ 3 /*break*/ , 1 ];

                  case 3:
                    return [ 2 /*return*/ ];
                }
            }));
        }));
    }, t.prototype.close = function() {
        this.db.close();
    }, t;
}(), ge = /** @class */ function() {
    function t(t) {
        this.io = t, this.eo = !1, this.ro = null;
    }
    return Object.defineProperty(t.prototype, "As", {
        get: function() {
            return this.eo;
        },
        enumerable: !0,
        configurable: !0
    }), Object.defineProperty(t.prototype, "uo", {
        get: function() {
            return this.ro;
        },
        enumerable: !0,
        configurable: !0
    }), Object.defineProperty(t.prototype, "cursor", {
        set: function(t) {
            this.io = t;
        },
        enumerable: !0,
        configurable: !0
    }), 
    /**
     * This function can be called to stop iteration at any point.
     */
    t.prototype.done = function() {
        this.eo = !0;
    }, 
    /**
     * This function can be called to skip to that next key, which could be
     * an index or a primary key.
     */
    t.prototype.so = function(t) {
        this.ro = t;
    }, 
    /**
     * Delete the current cursor value from the object store.
     *
     * NOTE: You CANNOT do this with a keysOnly query.
     */
    t.prototype.delete = function() {
        return _e(this.io.delete());
    }, t;
}(), be = /** @class */ function() {
    function t(t) {
        var n = this;
        this.transaction = t, this.aborted = !1, 
        /**
         * A promise that resolves with the result of the IndexedDb transaction.
         */
        this.oo = new Xi, this.transaction.oncomplete = function() {
            n.oo.resolve();
        }, this.transaction.onabort = function() {
            t.error ? n.oo.reject(t.error) : n.oo.resolve();
        }, this.transaction.onerror = function(t) {
            var i = Te(t.target.error);
            n.oo.reject(i);
        };
    }
    return t.open = function(n, i, e) {
        return new t(n.transaction(e, i));
    }, Object.defineProperty(t.prototype, "no", {
        get: function() {
            return this.oo.promise;
        },
        enumerable: !0,
        configurable: !0
    }), t.prototype.abort = function(t) {
        t && this.oo.reject(t), this.aborted || (A("SimpleDb", "Aborting transaction:", t ? t.message : "Client-initiated abort"), 
        this.aborted = !0, this.transaction.abort());
    }, 
    /**
     * Returns a SimpleDbStore<KeyType, ValueType> for the specified store. All
     * operations performed on the SimpleDbStore happen within the context of this
     * transaction and it cannot be used anymore once the transaction is
     * completed.
     *
     * Note that we can't actually enforce that the KeyType and ValueType are
     * correct, but they allow type safety through the rest of the consuming code.
     */
    t.prototype.store = function(t) {
        var n = this.transaction.objectStore(t);
        return C(!!n, "Object store not part of transaction: " + t), new ye(n);
    }, t;
}(), ye = /** @class */ function() {
    function t(t) {
        this.store = t;
    }
    return t.prototype.put = function(t, n) {
        var i;
        return void 0 !== n ? (A("SimpleDb", "PUT", this.store.name, t, n), i = this.store.put(n, t)) : (A("SimpleDb", "PUT", this.store.name, "<auto-key>", t), 
        i = this.store.put(t)), _e(i);
    }, 
    /**
     * Adds a new value into an Object Store and returns the new key. Similar to
     * IndexedDb's `add()`, this method will fail on primary key collisions.
     *
     * @param value The object to write.
     * @return The key of the value to add.
     */
    t.prototype.add = function(t) {
        return A("SimpleDb", "ADD", this.store.name, t, t), _e(this.store.add(t));
    }, 
    /**
     * Gets the object with the specified key from the specified store, or null
     * if no object exists with the specified key.
     *
     * @key The key of the object to get.
     * @return The object with the specified key or null if no object exists.
     */
    t.prototype.get = function(t) {
        var n = this;
        // We're doing an unsafe cast to ValueType.
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        return _e(this.store.get(t)).next((function(i) {
            // Normalize nonexistence to null.
            return void 0 === i && (i = null), A("SimpleDb", "GET", n.store.name, t, i), i;
        }));
    }, t.prototype.delete = function(t) {
        return A("SimpleDb", "DELETE", this.store.name, t), _e(this.store.delete(t));
    }, 
    /**
     * If we ever need more of the count variants, we can add overloads. For now,
     * all we need is to count everything in a store.
     *
     * Returns the number of rows in the store.
     */
    t.prototype.count = function() {
        return A("SimpleDb", "COUNT", this.store.name), _e(this.store.count());
    }, t.prototype.ho = function(t, n) {
        var i = this.cursor(this.options(t, n)), e = [];
        return this.co(i, (function(t, n) {
            e.push(n);
        })).next((function() {
            return e;
        }));
    }, t.prototype.ao = function(t, n) {
        A("SimpleDb", "DELETE ALL", this.store.name);
        var i = this.options(t, n);
        i.fo = !1;
        var e = this.cursor(i);
        return this.co(e, (function(t, n, i) {
            // NOTE: Calling delete() on a cursor is documented as more efficient than
            // calling delete() on an object store with a single key
            // (https://developer.mozilla.org/en-US/docs/Web/API/IDBObjectStore/delete),
            // however, this requires us *not* to use a keysOnly cursor
            // (https://developer.mozilla.org/en-US/docs/Web/API/IDBCursor/delete). We
            // may want to compare the performance of each method.
            return i.delete();
        }));
    }, t.prototype.lo = function(t, n) {
        var i;
        n ? i = t : (i = {}, n = t);
        var e = this.cursor(i);
        return this.co(e, n);
    }, 
    /**
     * Iterates over a store, but waits for the given callback to complete for
     * each entry before iterating the next entry. This allows the callback to do
     * asynchronous work to determine if this iteration should continue.
     *
     * The provided callback should return `true` to continue iteration, and
     * `false` otherwise.
     */
    t.prototype.do = function(t) {
        var n = this.cursor({});
        return new de((function(i, e) {
            n.onerror = function(t) {
                var n = Te(t.target.error);
                e(n);
            }, n.onsuccess = function(n) {
                var e = n.target.result;
                e ? t(e.primaryKey, e.value).next((function(t) {
                    t ? e.continue() : i();
                })) : i();
            };
        }));
    }, t.prototype.co = function(t, n) {
        var i = [];
        return new de((function(e, r) {
            t.onerror = function(t) {
                r(t.target.error);
            }, t.onsuccess = function(t) {
                var r = t.target.result;
                if (r) {
                    var u = new ge(r), s = n(r.primaryKey, r.value, u);
                    if (s instanceof de) {
                        var o = s.catch((function(t) {
                            return u.done(), de.reject(t);
                        }));
                        i.push(o);
                    }
                    u.As ? e() : null === u.uo ? r.continue() : r.continue(u.uo);
                } else e();
            };
        })).next((function() {
            return de.Ns(i);
        }));
    }, t.prototype.options = function(t, n) {
        var i = void 0;
        return void 0 !== t && ("string" == typeof t ? i = t : (C(void 0 === n, "3rd argument must not be defined if 2nd is a range."), 
        n = t)), {
            index: i,
            range: n
        };
    }, t.prototype.cursor = function(t) {
        var n = "next";
        if (t.reverse && (n = "prev"), t.index) {
            var i = this.store.index(t.index);
            return t.fo ? i.openKeyCursor(t.range, n) : i.openCursor(t.range, n);
        }
        return this.store.openCursor(t.range, n);
    }, t;
}();

/**
 * A batch of mutations that will be sent as one unit to the backend.
 */
/**
 * Wraps an IDBRequest in a PersistencePromise, using the onsuccess / onerror
 * handlers to resolve / reject the PersistencePromise as appropriate.
 */
function _e(t) {
    return new de((function(n, i) {
        t.onsuccess = function(t) {
            var i = t.target.result;
            n(i);
        }, t.onerror = function(t) {
            var n = Te(t.target.error);
            i(n);
        };
    }));
}

// Guard so we only report the error once.
var Ie = !1;

function Te(t) {
    var n = pe.Ks(h());
    if (n >= 12.2 && n < 13) {
        var i = "An internal error was encountered in the Indexed Database server";
        if (t.message.indexOf(i) >= 0) {
            // Wrap error in a more descriptive one.
            var e = new B("internal", "IOS_INDEXEDDB_BUG1: IndexedDb has thrown '" + i + "'. This is likely due to an unavoidable bug in iOS. See https://stackoverflow.com/q/56496296/110915 for details and a potential workaround.");
            return Ie || (Ie = !0, 
            // Throw a global exception outside of this promise chain, for the user to
            // potentially catch.
            setTimeout((function() {
                throw e;
            }), 0)), e;
        }
    }
    return t;
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** A mutation queue for a specific user, backed by IndexedDB. */ var Ee = /** @class */ function() {
    function t(
    /**
     * The normalized userId (e.g. null UID => "" userId) used to store /
     * retrieve mutations.
     */
    t, n, i, e) {
        this.userId = t, this.serializer = n, this.vo = i, this.wo = e, 
        /**
         * Caches the document keys for pending mutation batches. If the mutation
         * has been removed from IndexedDb, the cached value may continue to
         * be used to retrieve the batch's document keys. To remove a cached value
         * locally, `removeCachedMutationKeys()` should be invoked either directly
         * or through `removeMutationBatches()`.
         *
         * With multi-tab, when the primary client acknowledges or rejects a mutation,
         * this cache is used by secondary clients to invalidate the local
         * view of the documents that were previously affected by the mutation.
         */
        // PORTING NOTE: Multi-tab only.
        this.mo = {};
    }
    /**
     * Creates a new mutation queue for the given user.
     * @param user The user for which to create a mutation queue.
     * @param serializer The serializer to use when persisting to IndexedDb.
     */    return t.po = function(n, i, e, r) {
        // TODO(mcg): Figure out what constraints there are on userIDs
        // In particular, are there any reserved characters? are empty ids allowed?
        // For the moment store these together in the same mutations table assuming
        // that empty userIDs aren't allowed.
        return C("" !== n.uid, "UserID must not be an empty string."), new t(n.l() ? n.uid : "", i, e, r);
    }, t.prototype.bo = function(t) {
        var n = !0, i = IDBKeyRange.bound([ this.userId, Number.NEGATIVE_INFINITY ], [ this.userId, Number.POSITIVE_INFINITY ]);
        return De(t).lo({
            index: hr.userMutationsIndex,
            range: i
        }, (function(t, i, e) {
            n = !1, e.done();
        })).next((function() {
            return n;
        }));
    }, t.prototype.yo = function(t, n, i) {
        return this._o(t).next((function(n) {
            // We can't store the resumeToken as a ByteString in IndexedDB, so we
            // convert it to a Base64 string for storage.
            return n.lastStreamToken = i.toBase64(), Se(t).put(n);
        }));
    }, t.prototype.Io = function(t) {
        return this._o(t).next((function(t) {
            return Jn.fromBase64String(t.lastStreamToken);
        }));
    }, t.prototype.To = function(t, n) {
        return this._o(t).next((function(i) {
            // We can't store the resumeToken as a ByteString in IndexedDB, so we
            // convert it to a Base64 string for storage.
            return i.lastStreamToken = n.toBase64(), Se(t).put(i);
        }));
    }, t.prototype.Eo = function(t, n, i, e) {
        var r = this, u = Pe(t), s = De(t);
        // The IndexedDb implementation in Chrome (and Firefox) does not handle
        // compound indices that include auto-generated keys correctly. To ensure
        // that the index entry is added correctly in all browsers, we perform two
        // writes: The first write is used to retrieve the next auto-generated Batch
        // ID, and the second write populates the index and stores the actual
        // mutation batch.
        // See: https://bugs.chromium.org/p/chromium/issues/detail?id=701972
        // We write an empty object to obtain key
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        return s.add({}).next((function(o) {
            C("number" == typeof o, "Auto-generated key is not a number");
            for (var h = new he(o, n, i, e), c = r.serializer.Ro(r.userId, h), a = [], f = new Ct((function(t, n) {
                return N(t.nt(), n.nt());
            })), l = 0, d = e; l < d.length; l++) {
                var v = d[l], w = cr.key(r.userId, v.key.path, o);
                f = f.add(v.key.path.H()), a.push(s.put(c)), a.push(u.put(w, cr.PLACEHOLDER));
            }
            return f.forEach((function(n) {
                a.push(r.vo.Ao(t, n));
            })), t.Ws((function() {
                r.mo[o] = h.keys();
            })), de.Ns(a).next((function() {
                return h;
            }));
        }));
    }, t.prototype.Do = function(t, n) {
        var i = this;
        return De(t).get(n).next((function(t) {
            return t ? (C(t.userId === i.userId, "Unexpected user '" + t.userId + "' for mutation batch " + n), 
            i.serializer.Po(t)) : null;
        }));
    }, t.prototype.So = function(t, n) {
        var i = this;
        return this.mo[n] ? de.resolve(this.mo[n]) : this.Do(t, n).next((function(t) {
            if (t) {
                var e = t.keys();
                return i.mo[n] = e, e;
            }
            return null;
        }));
    }, t.prototype.Co = function(t, n) {
        var i = this, e = n + 1, r = IDBKeyRange.lowerBound([ this.userId, e ]), u = null;
        return De(t).lo({
            index: hr.userMutationsIndex,
            range: r
        }, (function(t, n, r) {
            n.userId === i.userId && (C(n.batchId >= e, "Should have found mutation after " + e), 
            u = i.serializer.Po(n)), r.done();
        })).next((function() {
            return u;
        }));
    }, t.prototype.Vo = function(t) {
        var n = IDBKeyRange.upperBound([ this.userId, Number.POSITIVE_INFINITY ]), i = -1;
        return De(t).lo({
            index: hr.userMutationsIndex,
            range: n,
            reverse: !0
        }, (function(t, n, e) {
            i = n.batchId, e.done();
        })).next((function() {
            return i;
        }));
    }, t.prototype.No = function(t) {
        var n = this, i = IDBKeyRange.bound([ this.userId, -1 ], [ this.userId, Number.POSITIVE_INFINITY ]);
        return De(t).ho(hr.userMutationsIndex, i).next((function(t) {
            return t.map((function(t) {
                return n.serializer.Po(t);
            }));
        }));
    }, t.prototype.ko = function(t, n) {
        var i = this, e = cr.prefixForPath(this.userId, n.path), r = IDBKeyRange.lowerBound(e), u = [];
        // Scan the document-mutation index starting with a prefix starting with
        // the given documentKey.
                return Pe(t).lo({
            range: r
        }, (function(e, r, s) {
            var o = e[0], h = e[1], c = e[2], a = oe(h);
            // Only consider rows matching exactly the specific key of
            // interest. Note that because we order by path first, and we
            // order terminators before path separators, we'll encounter all
            // the index rows for documentKey contiguously. In particular, all
            // the rows for documentKey will occur before any rows for
            // documents nested in a subcollection beneath documentKey so we
            // can stop as soon as we hit any such row.
                        if (o === i.userId && n.path.isEqual(a)) 
            // Look up the mutation batch in the store.
            return De(t).get(c).next((function(t) {
                if (!t) throw S("Dangling document-mutation reference found: " + e + " which points to " + c);
                C(t.userId === i.userId, "Unexpected user '" + t.userId + "' for mutation batch " + c), 
                u.push(i.serializer.Po(t));
            }));
            s.done();
        })).next((function() {
            return u;
        }));
    }, t.prototype.Oo = function(t, n) {
        var i = this, e = new Ct(N), r = [];
        return n.forEach((function(n) {
            var u = cr.prefixForPath(i.userId, n.path), s = IDBKeyRange.lowerBound(u), o = Pe(t).lo({
                range: s
            }, (function(t, r, u) {
                var s = t[0], o = t[1], h = t[2], c = oe(o);
                // Only consider rows matching exactly the specific key of
                // interest. Note that because we order by path first, and we
                // order terminators before path separators, we'll encounter all
                // the index rows for documentKey contiguously. In particular, all
                // the rows for documentKey will occur before any rows for
                // documents nested in a subcollection beneath documentKey so we
                // can stop as soon as we hit any such row.
                                s === i.userId && n.path.isEqual(c) ? e = e.add(h) : u.done();
            }));
            r.push(o);
        })), de.Ns(r).next((function() {
            return i.Fo(t, e);
        }));
    }, t.prototype.xo = function(t, n) {
        var i = this;
        C(!n.Gn(), "Document queries shouldn't go down this path"), C(!n.bi(), "CollectionGroup queries should be handled in LocalDocumentsView");
        var e = n.path, r = e.length + 1, u = cr.prefixForPath(this.userId, e), s = IDBKeyRange.lowerBound(u), o = new Ct(N);
        return Pe(t).lo({
            range: s
        }, (function(t, n, u) {
            var s = t[0], h = t[1], c = t[2], a = oe(h);
            s === i.userId && e.$(a) ? 
            // Rows with document keys more than one segment longer than the
            // query path can't be matches. For example, a query on 'rooms'
            // can't match the document /rooms/abc/messages/xyx.
            // TODO(mcg): we'll need a different scanner when we implement
            // ancestor queries.
            a.length === r && (o = o.add(c)) : u.done();
        })).next((function() {
            return i.Fo(t, o);
        }));
    }, t.prototype.Fo = function(t, n) {
        var i = this, e = [], r = [];
        // TODO(rockwood): Implement this using iterate.
        return n.forEach((function(n) {
            r.push(De(t).get(n).next((function(t) {
                if (null === t) throw S("Dangling document-mutation reference found, which points to " + n);
                C(t.userId === i.userId, "Unexpected user '" + t.userId + "' for mutation batch " + n), 
                e.push(i.serializer.Po(t));
            })));
        })), de.Ns(r).next((function() {
            return e;
        }));
    }, t.prototype.jo = function(t, n) {
        var i = this;
        return Ae(t.Uo, this.userId, n).next((function(e) {
            return t.Ws((function() {
                i.Lo(n.batchId);
            })), de.forEach(e, (function(n) {
                return i.wo.Bo(t, n);
            }));
        }));
    }, t.prototype.Lo = function(t) {
        delete this.mo[t];
    }, t.prototype.Mo = function(t) {
        var n = this;
        return this.bo(t).next((function(i) {
            if (!i) return de.resolve();
            // Verify that there are no entries in the documentMutations index if
            // the queue is empty.
                        var e = IDBKeyRange.lowerBound(cr.prefixForUser(n.userId)), r = [];
            return Pe(t).lo({
                range: e
            }, (function(t, i, e) {
                if (t[0] === n.userId) {
                    var u = oe(t[1]);
                    r.push(u);
                } else e.done();
            })).next((function() {
                C(0 === r.length, "Document leak -- detected dangling mutation references when queue is empty. Dangling keys: " + r.map((function(t) {
                    return t.nt();
                })));
            }));
        }));
    }, t.prototype.ys = function(t, n) {
        return Re(t, this.userId, n);
    }, 
    // PORTING NOTE: Multi-tab only (state is held in memory in other clients).
    /** Returns the mutation queue's metadata from IndexedDb. */
    t.prototype._o = function(t) {
        var n = this;
        return Se(t).get(this.userId).next((function(t) {
            return t || new or(n.userId, -1, 
            /*lastStreamToken=*/ "");
        }));
    }, t;
}();

/**
 * @return true if the mutation queue for the given user contains a pending
 *         mutation for the given key.
 */ function Re(t, n, i) {
    var e = cr.prefixForPath(n, i.path), r = e[1], u = IDBKeyRange.lowerBound(e), s = !1;
    return Pe(t).lo({
        range: u,
        fo: !0
    }, (function(t, i, e) {
        var u = t[0], o = t[1];
        t[2];
        u === n && o === r && (s = !0), e.done();
    })).next((function() {
        return s;
    }));
}

/** Returns true if any mutation queue contains the given document. */
/**
 * Delete a mutation batch and the associated document mutations.
 * @return A PersistencePromise of the document mutations that were removed.
 */
function Ae(t, n, i) {
    var e = t.store(hr.store), r = t.store(cr.store), u = [], s = IDBKeyRange.only(i.batchId), o = 0, h = e.lo({
        range: s
    }, (function(t, n, i) {
        return o++, i.delete();
    }));
    u.push(h.next((function() {
        C(1 === o, "Dangling document-mutation reference found: Missing batch " + i.batchId);
    })));
    for (var c = [], a = 0, f = i.mutations; a < f.length; a++) {
        var l = f[a], d = cr.key(n, l.key.path, i.batchId);
        u.push(r.delete(d)), c.push(l.key);
    }
    return de.Ns(u).next((function() {
        return c;
    }));
}

/**
 * Helper to get a typed SimpleDbStore for the mutations object store.
 */ function De(t) {
    return Sr.Zs(t, hr.store);
}

/**
 * Helper to get a typed SimpleDbStore for the mutationQueues object store.
 */ function Pe(t) {
    return Sr.Zs(t, cr.store);
}

/**
 * Helper to get a typed SimpleDbStore for the mutationQueues object store.
 */ function Se(t) {
    return Sr.Zs(t, or.store);
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ var Ce, Ve, Ne = 1;

(Ve = Ce || (Ce = {}))[Ve.qo = 0] = "__PRIVATE_QueryCache", Ve[Ve.Qo = 1] = "__PRIVATE_SyncEngine";

/**
 * Generates monotonically increasing target IDs for sending targets to the
 * watch stream.
 *
 * The client constructs two generators, one for the query cache (via
 * forQueryCache()), and one for limbo documents (via forSyncEngine()). These
 * two generators produce non-overlapping IDs (by using even and odd IDs
 * respectively).
 *
 * By separating the target ID space, the query cache can generate target IDs
 * that persist across client restarts, while sync engine can independently
 * generate in-memory target IDs that are transient and can be reused after a
 * restart.
 */
// TODO(mrschmidt): Explore removing this class in favor of generating these IDs
// directly in SyncEngine and LocalStore.
var ke = /** @class */ function() {
    /**
     * Instantiates a new TargetIdGenerator. If a seed is provided, the generator
     * will use the seed value as the next target ID.
     */
    function t(t, n) {
        this.Go = t, C((t & Ne) === t, "Generator ID " + t + " contains more than " + Ne + " reserved bits"), 
        this.Wo(void 0 !== n ? n : this.Go);
    }
    return t.prototype.next = function() {
        var t = this.zo;
        return this.zo += 1 << Ne, t;
    }, 
    /**
     * Returns the ID that follows the given ID. Subsequent calls to `next()`
     * use the newly returned target ID as their base.
     */
    // PORTING NOTE: Multi-tab only.
    t.prototype.after = function(t) {
        return this.Wo(t + (1 << Ne)), this.next();
    }, t.prototype.Wo = function(t) {
        C((t & Ne) === this.Go, "Cannot supply target ID from different generator ID"), 
        this.zo = t;
    }, t.Ko = function() {
        return new t(Ce.qo, 2);
    }, t.Ho = function() {
        // Sync engine assigns target IDs for limbo document detection.
        return new t(Ce.Qo);
    }, t;
}(), Oe = /** @class */ function() {
    function t(t, n, i) {
        this.Jo = t, this.Yo = n, this.vo = i;
    }
    /**
     * Get the local view of the document identified by `key`.
     *
     * @return Local view of the document or null if we don't have any cached
     * state for it.
     */    return t.prototype.Xo = function(t, n) {
        var i = this;
        return this.Yo.ko(t, n).next((function(e) {
            return i.$o(t, n, e);
        }));
    }, 
    /** Internal version of `getDocument` that allows reusing batches. */
    t.prototype.$o = function(t, n, i) {
        return this.Jo.Bs(t, n).next((function(t) {
            for (var e = 0, r = i; e < r.length; e++) {
                t = r[e].Gt(n, t);
            }
            return t;
        }));
    }, 
    // Returns the view of the given `docs` as they would appear after applying
    // all mutations in the given `batches`.
    t.prototype.Zo = function(t, n, i) {
        var e = oi();
        return n.forEach((function(t, n) {
            for (var r = 0, u = i; r < u.length; r++) {
                n = u[r].Gt(t, n);
            }
            e = e.lt(t, n);
        })), e;
    }, 
    /**
     * Gets the local view of the documents identified by `keys`.
     *
     * If we don't have cached state for a document in `keys`, a NoDocument will
     * be stored for that key in the resulting set.
     */
    t.prototype.th = function(t, n) {
        var i = this;
        return this.Jo.getEntries(t, n).next((function(n) {
            return i.nh(t, n);
        }));
    }, 
    /**
     * Similar to `getDocuments`, but creates the local view from the given
     * `baseDocs` without retrieving documents from the local store.
     */
    t.prototype.nh = function(t, n) {
        var i = this;
        return this.Yo.Oo(t, n).next((function(e) {
            var r = i.Zo(t, n, e), u = si();
            return r.forEach((function(t, n) {
                // TODO(http://b/32275378): Don't conflate missing / deleted.
                n || (n = new gn(t, yt.B())), u = u.lt(t, n);
            })), u;
        }));
    }, 
    /**
     * Performs a query against the local view of all documents.
     *
     * @param transaction The persistence transaction.
     * @param query The query to match documents against.
     * @param sinceReadTime If not set to SnapshotVersion.MIN, return only
     *     documents that have been read since this snapshot version (exclusive).
     */
    t.prototype.ih = function(t, n, i) {
        return n.Gn() ? this.eh(t, n.path) : n.bi() ? this.rh(t, n, i) : this.uh(t, n, i);
    }, t.prototype.eh = function(t, n) {
        // Just do a simple document lookup.
        return this.Xo(t, new Rt(n)).next((function(t) {
            var n = ci();
            return t instanceof pn && (n = n.lt(t.key, t)), n;
        }));
    }, t.prototype.rh = function(t, n, i) {
        var e = this;
        C(n.path.J(), "Currently we only support collection group queries at the root.");
        var r = n.collectionGroup, u = ci();
        return this.vo.sh(t, r).next((function(s) {
            // Perform a collection query against each parent that contains the
            // collectionId and aggregate the results.
            return de.forEach(s, (function(s) {
                var o = n.hi(s.child(r));
                return e.uh(t, o, i).next((function(t) {
                    t.forEach((function(t, n) {
                        u = u.lt(t, n);
                    }));
                }));
            })).next((function() {
                return u;
            }));
        }));
    }, t.prototype.uh = function(t, n, i) {
        var e, r, u = this;
        // Query the remote documents and overlay mutations.
                return this.Jo.ih(t, n, i).next((function(i) {
            return e = i, u.Yo.xo(t, n);
        })).next((function(n) {
            // It is possible that a PatchMutation can make a document match a query, even if
            // the version in the RemoteDocumentCache is not a match yet (waiting for server
            // to ack). To handle this, we find all document keys affected by the PatchMutations
            // that are not in `result` yet, and back fill them via `remoteDocumentCache.getEntries`,
            // otherwise those `PatchMutations` will be ignored because no base document can be found,
            // and lead to missing result for the query.
            return r = n, u.oh(t, r, e).next((function(t) {
                e = t;
                for (var n = 0, i = r; n < i.length; n++) for (var u = i[n], s = 0, o = u.mutations; s < o.length; s++) {
                    var h = o[s], c = h.key, a = e.get(c), f = h.Gt(a, a, u.Fn);
                    e = f instanceof pn ? e.lt(c, f) : e.remove(c);
                }
            }));
        })).next((function() {
            // Finally, filter out any documents that don't actually match
            // the query.
            return e.forEach((function(t, i) {
                n.matches(i) || (e = e.remove(t));
            })), e;
        }));
    }, t.prototype.oh = function(t, n, i) {
        for (var e = di(), r = 0, u = n; r < u.length; r++) for (var s = 0, o = u[r].mutations; s < o.length; s++) {
            var h = o[s];
            h instanceof Jt && null === i.get(h.key) && (e = e.add(h.key));
        }
        var c = i;
        return this.Jo.getEntries(t, e).next((function(t) {
            return t.forEach((function(t, n) {
                null !== n && n instanceof pn && (c = c.lt(t, n));
            })), c;
        }));
    }, t;
}(), Fe = /** @class */ function() {
    function t(t, n, i, e) {
        this.targetId = t, this.fromCache = n, this.hh = i, this.ah = e;
    }
    return t.fh = function(n, i) {
        for (var e = di(), r = di(), u = 0, s = i.docChanges; u < s.length; u++) {
            var o = s[u];
            switch (o.type) {
              case mi.Mi:
                e = e.add(o.doc.key);
                break;

              case mi.qi:
                r = r.add(o.doc.key);
 // do nothing
                        }
        }
        return new t(n, i.fromCache, e, r);
    }, t;
}(), xe = "LocalStore", je = /** @class */ function() {
    function t(
    /** Manages our in-memory or durable persistence. */
    t, n, i) {
        this.persistence = t, this.lh = n, 
        /**
         * The set of document references maintained by any local views.
         */
        this.dh = new ae, 
        /**
         * Maps a targetID to data about its target.
         *
         * PORTING NOTE: We are using an immutable data structure on Web to make re-runs
         * of `applyRemoteEvent()` idempotent.
         */
        this.vh = new At(N), 
        /** Maps a target to its targetID. */
        // TODO(wuandy): Evaluate if TargetId can be part of Target.
        this.wh = new le((function(t) {
            return t.canonicalId();
        })), 
        /**
         * The read time of the last entry processed by `getNewDocumentChanges()`.
         *
         * PORTING NOTE: This is only used for multi-tab synchronization.
         */
        this.mh = yt.MIN, C(t.ph, "LocalStore was passed an unstarted persistence implementation"), 
        this.persistence.wo.gh(this.dh), this.Yo = t.bh(i), this.yh = t._h(), this.Ih = t.Th(), 
        this.Eh = new Oe(this.yh, this.Yo, this.persistence.Rh()), this.lh.Ah(this.Eh);
    }
    /** Starts the LocalStore. */    return t.prototype.start = function() {
        return this.Dh();
    }, 
    /**
     * Tells the LocalStore that the currently authenticated user has changed.
     *
     * In response the local store switches the mutation queue to the new user and
     * returns any resulting document changes.
     */
    // PORTING NOTE: Android and iOS only return the documents affected by the
    // change.
    t.prototype.Ph = function(t) {
        return r(this, void 0, void 0, (function() {
            var n, i, e, r = this;
            return u(this, (function(u) {
                switch (u.label) {
                  case 0:
                    return n = this.Yo, i = this.Eh, [ 4 /*yield*/ , this.persistence.runTransaction("Handle user change", "readonly-idempotent", (function(e) {
                        // Swap out the mutation queue, grabbing the pending mutation batches
                        // before and after.
                        var u;
                        return r.Yo.No(e).next((function(s) {
                            return u = s, n = r.persistence.bh(t), 
                            // Recreate our LocalDocumentsView using the new
                            // MutationQueue.
                            i = new Oe(r.yh, n, r.persistence.Rh()), n.No(e);
                        })).next((function(t) {
                            for (var n = [], r = [], s = di(), o = 0, h = u; o < h.length; o++) {
                                var c = h[o];
                                n.push(c.batchId);
                                for (var a = 0, f = c.mutations; a < f.length; a++) {
                                    var l = f[a];
                                    s = s.add(l.key);
                                }
                            }
                            for (var d = 0, v = t; d < v.length; d++) {
                                c = v[d];
                                r.push(c.batchId);
                                for (var w = 0, m = c.mutations; w < m.length; w++) {
                                    l = m[w];
                                    s = s.add(l.key);
                                }
                            }
                            // Return the set of all (potentially) changed documents and the list
                            // of mutation batch IDs that were affected by change.
                                                        return i.th(e, s).next((function(t) {
                                return {
                                    Sh: t,
                                    Ch: n,
                                    Vh: r
                                };
                            }));
                        }));
                    })) ];

                  case 1:
                    return e = u.sent(), this.Yo = n, this.Eh = i, this.lh.Ah(this.Eh), [ 2 /*return*/ , e ];
                }
            }));
        }));
    }, 
    /* Accept locally generated Mutations and commit them to storage. */
    t.prototype.Nh = function(t) {
        var n, i = this, e = bt.now(), r = t.reduce((function(t, n) {
            return t.add(n.key);
        }), di());
        return this.persistence.runTransaction("Locally write mutations", "readwrite-idempotent", (function(u) {
            // Load and apply all existing mutations. This lets us compute the
            // current base state for all non-idempotent transforms before applying
            // any additional user-provided writes.
            return i.Eh.th(u, r).next((function(r) {
                n = r;
                for (
                // For non-idempotent mutations (such as `FieldValue.increment()`),
                // we record the base state in a separate patch mutation. This is
                // later used to guarantee consistent values and prevents flicker
                // even if the backend sends us an update that already includes our
                // transform.
                var s = [], o = 0, h = t; o < h.length; o++) {
                    var c = h[o], a = c.sn(n.get(c.key));
                    null != a && 
                    // NOTE: The base state should only be applied if there's some
                    // existing document to override, so use a Precondition of
                    // exists=true
                    s.push(new Jt(c.key, a, a.on(), zt.exists(!0)));
                }
                return i.Yo.Eo(u, e, s, t);
            }));
        })).then((function(t) {
            var i = t.ss(n);
            return {
                batchId: t.batchId,
                Os: i
            };
        }));
    }, 
    /** Returns the local view of the documents affected by a mutation batch. */
    // PORTING NOTE: Multi-tab only.
    t.prototype.kh = function(t) {
        var n = this;
        return this.persistence.runTransaction("Lookup mutation documents", "readonly-idempotent", (function(i) {
            return n.Yo.So(i, t).next((function(t) {
                return t ? n.Eh.th(i, t) : de.resolve(null);
            }));
        }));
    }, 
    /**
     * Acknowledge the given batch.
     *
     * On the happy path when a batch is acknowledged, the local store will
     *
     *  + remove the batch from the mutation queue;
     *  + apply the changes to the remote document cache;
     *  + recalculate the latency compensated view implied by those changes (there
     *    may be mutations in the queue that affect the documents but haven't been
     *    acknowledged yet); and
     *  + give the changed documents back the sync engine
     *
     * @returns The resulting (modified) documents.
     */
    t.prototype.yo = function(t) {
        var n = this;
        return this.persistence.runTransaction("Acknowledge batch", "readwrite-primary-idempotent", (function(i) {
            var e = t.batch.keys(), r = n.yh.Oh({
                Fh: !0
            });
            return n.Yo.yo(i, t.batch, t.streamToken).next((function() {
                return n.xh(i, t, r);
            })).next((function() {
                return r.apply(i);
            })).next((function() {
                return n.Yo.Mo(i);
            })).next((function() {
                return n.Eh.th(i, e);
            }));
        }));
    }, 
    /**
     * Remove mutations from the MutationQueue for the specified batch;
     * LocalDocuments will be recalculated.
     *
     * @returns The resulting modified documents.
     */
    t.prototype.jh = function(t) {
        var n = this;
        return this.persistence.runTransaction("Reject batch", "readwrite-primary-idempotent", (function(i) {
            var e;
            return n.Yo.Do(i, t).next((function(t) {
                return C(null !== t, "Attempt to reject nonexistent batch!"), e = t.keys(), n.Yo.jo(i, t);
            })).next((function() {
                return n.Yo.Mo(i);
            })).next((function() {
                return n.Eh.th(i, e);
            }));
        }));
    }, 
    /**
     * Returns the largest (latest) batch id in mutation queue that is pending server response.
     * Returns `BATCHID_UNKNOWN` if the queue is empty.
     */
    t.prototype.Vo = function() {
        var t = this;
        return this.persistence.runTransaction("Get highest unacknowledged batch id", "readonly-idempotent", (function(n) {
            return t.Yo.Vo(n);
        }));
    }, 
    /** Returns the last recorded stream token for the current user. */
    t.prototype.Io = function() {
        var t = this;
        return this.persistence.runTransaction("Get last stream token", "readonly-idempotent", (function(n) {
            return t.Yo.Io(n);
        }));
    }, 
    /**
     * Sets the stream token for the current user without acknowledging any
     * mutation batch. This is usually only useful after a stream handshake or in
     * response to an error that requires clearing the stream token.
     */
    t.prototype.To = function(t) {
        var n = this;
        return this.persistence.runTransaction("Set last stream token", "readwrite-primary-idempotent", (function(i) {
            return n.Yo.To(i, t);
        }));
    }, 
    /**
     * Returns the last consistent snapshot processed (used by the RemoteStore to
     * determine whether to buffer incoming snapshots from the backend).
     */
    t.prototype.Uh = function() {
        var t = this;
        return this.persistence.runTransaction("Get last remote snapshot version", "readonly-idempotent", (function(n) {
            return t.Ih.Uh(n);
        }));
    }, 
    /**
     * Update the "ground-state" (remote) documents. We assume that the remote
     * event reflects any write batches that have been acknowledged or rejected
     * (i.e. we do not re-apply local mutations to updates from this event).
     *
     * LocalDocuments are re-calculated if there are remaining mutations in the
     * queue.
     */
    t.prototype.Lh = function(n) {
        var i = this, e = n.Oi, r = this.vh;
        return this.persistence.runTransaction("Apply remote event", "readwrite-primary-idempotent", (function(u) {
            var s = i.yh.Oh({
                Fh: !0
            });
            // Reset newTargetDataByTargetMap in case this transaction gets re-run.
                        r = i.vh;
            var o = [];
            J(n.te, (function(n, s) {
                var h = r.get(n);
                if (h) {
                    // Only update the remote keys if the target is still active. This
                    // ensures that we can persist the updated target data along with
                    // the updated assignment.
                    o.push(i.Ih.Bh(u, s.ce, n).next((function() {
                        return i.Ih.Mh(u, s.oe, n);
                    })));
                    var c = s.resumeToken;
                    // Update the resume token if the change includes one.
                                        if (c.Cn() > 0) {
                        var a = h.xi(c, e).Fi(u.qh);
                        r = r.lt(n, a), 
                        // Update the target data if there are target changes (or if
                        // sufficient time has passed since the last update).
                        t.Qh(h, a, s) && o.push(i.Ih.Gh(u, a));
                    }
                }
            }));
            var h = si(), c = di();
            // HACK: The only reason we allow a null snapshot version is so that we
            // can synthesize remote events when we get permission denied errors while
            // trying to resolve the state of a locally cached document that is in
            // limbo.
            if (n.ie.forEach((function(t, n) {
                c = c.add(t);
            })), 
            // Each loop iteration only affects its "own" doc, so it's safe to get all the remote
            // documents in advance in a single call.
            o.push(s.getEntries(u, c).next((function(t) {
                n.ie.forEach((function(r, c) {
                    var a = t.get(r);
                    // Note: The order of the steps below is important, since we want
                    // to ensure that rejected limbo resolutions (which fabricate
                    // NoDocuments with SnapshotVersion.MIN) never add documents to
                    // cache.
                                        c instanceof gn && c.version.isEqual(yt.MIN) ? (
                    // NoDocuments with SnapshotVersion.MIN are used in manufactured
                    // events. We remove these documents from cache since we lost
                    // access.
                    s.Ls(r, e), h = h.lt(r, c)) : null == a || c.version.h(a.version) > 0 || 0 === c.version.h(a.version) && a.hasPendingWrites ? (C(!yt.MIN.isEqual(e), "Cannot add a document when the remote version is zero"), 
                    s.js(c, e), h = h.lt(r, c)) : A(xe, "Ignoring outdated watch update for ", r, ". Current version:", a.version, " Watch version:", c.version), 
                    n.ee.has(r) && o.push(i.persistence.wo.Wh(u, r));
                }));
            }))), !e.isEqual(yt.MIN)) {
                var a = i.Ih.Uh(u).next((function(t) {
                    return C(e.h(t) >= 0, "Watch stream reverted to previous snapshot?? " + e + " < " + t), 
                    i.Ih.zh(u, u.qh, e);
                }));
                o.push(a);
            }
            return de.Ns(o).next((function() {
                return s.apply(u);
            })).next((function() {
                return i.Eh.nh(u, h);
            }));
        })).then((function(t) {
            return i.vh = r, t;
        }));
    }, 
    /**
     * Returns true if the newTargetData should be persisted during an update of
     * an active target. TargetData should always be persisted when a target is
     * being released and should not call this function.
     *
     * While the target is active, TargetData updates can be omitted when nothing
     * about the target has changed except metadata like the resume token or
     * snapshot version. Occasionally it's worth the extra write to prevent these
     * values from getting too stale after a crash, but this doesn't have to be
     * too frequent.
     */
    t.Qh = function(t, n, i) {
        // Always persist target data if we don't already have a resume token.
        return C(n.resumeToken.Cn() > 0, "Attempted to persist target data with no resume token"), 
        0 === t.resumeToken.Cn() || (n.Oi.M() - t.Oi.M() >= this.Kh || i.oe.size + i.he.size + i.ce.size > 0);
        // Don't allow resume token changes to be buffered indefinitely. This
        // allows us to be reasonably up-to-date after a crash and avoids needing
        // to loop over all active queries on shutdown. Especially in the browser
        // we may not get time to do anything interesting while the current tab is
        // closing.
        }, 
    /**
     * Notify local store of the changed views to locally pin documents.
     */
    t.prototype.Hh = function(t) {
        for (var n = this, i = 0, e = t; i < e.length; i++) {
            var r = e[i], u = r.targetId;
            if (this.dh.ds(r.hh, u), this.dh.ms(r.ah, u), !r.fromCache) {
                var s = this.vh.get(u);
                C(null !== s, "Can't set limbo-free snapshot version for unknown target: " + u);
                // Advance the last limbo free snapshot version
                var o = s.Oi, h = s.ji(o);
                this.vh = this.vh.lt(u, h);
            }
        }
        return this.persistence.runTransaction("notifyLocalViewChanges", "readwrite-idempotent", (function(i) {
            return de.forEach(t, (function(t) {
                return de.forEach(t.ah, (function(t) {
                    return n.persistence.wo.vs(i, t);
                }));
            }));
        }));
    }, 
    /**
     * Gets the mutation batch after the passed in batchId in the mutation queue
     * or null if empty.
     * @param afterBatchId If provided, the batch to search after.
     * @returns The next mutation or null if there wasn't one.
     */
    t.prototype.Jh = function(t) {
        var n = this;
        return this.persistence.runTransaction("Get next mutation batch", "readonly-idempotent", (function(i) {
            return void 0 === t && (t = -1), n.Yo.Co(i, t);
        }));
    }, 
    /**
     * Read the current value of a Document with a given key or null if not
     * found - used for testing.
     */
    t.prototype.Yh = function(t) {
        var n = this;
        return this.persistence.runTransaction("read document", "readonly-idempotent", (function(i) {
            return n.Eh.Xo(i, t);
        }));
    }, 
    /**
     * Assigns the given target an internal ID so that its results can be pinned so
     * they don't get GC'd. A target must be allocated in the local store before
     * the store can be used to manage its view.
     *
     * Allocating an already allocated `Target` will return the existing `TargetData`
     * for that `Target`.
     */
    t.prototype.Xh = function(t) {
        var n = this;
        return this.persistence.runTransaction("Allocate target", "readwrite-idempotent", (function(i) {
            var e;
            return n.Ih.$h(i, t).next((function(r) {
                return r ? (
                // This target has been listened to previously, so reuse the
                // previous targetID.
                // TODO(mcg): freshen last accessed date?
                e = r, de.resolve(e)) : n.Ih.Zh(i).next((function(r) {
                    return e = new ti(t, r, Kn.Ci, i.qh), n.Ih.tc(i, e).next((function() {
                        return e;
                    }));
                }));
            }));
        })).then((function(i) {
            return null === n.vh.get(i.targetId) && (n.vh = n.vh.lt(i.targetId, i), n.wh.set(t, i.targetId)), 
            i;
        }));
    }, 
    /**
     * Returns the TargetData as seen by the LocalStore, including updates that may
     * have not yet been persisted to the TargetCache.
     */
    // Visible for testing.
    t.prototype.$h = function(t, n) {
        var i = this.wh.get(n);
        return void 0 !== i ? de.resolve(this.vh.get(i)) : this.Ih.$h(t, n);
    }, 
    /**
     * Unpin all the documents associated with the given target. If
     * `keepPersistedTargetData` is set to false and Eager GC enabled, the method
     * directly removes the associated target data from the target cache.
     *
     * Releasing a non-existing `Target` is a no-op.
     */
    // PORTING NOTE: `keepPersistedTargetData` is multi-tab only.
    t.prototype.nc = function(t, n) {
        var i = this, e = this.vh.get(t);
        C(null !== e, "Tried to release nonexistent target: " + t);
        var r = n ? "readwrite-idempotent" : "readwrite-primary-idempotent";
        return this.persistence.runTransaction("Release target", r, (function(r) {
            // References for documents sent via Watch are automatically removed
            // when we delete a target's data from the reference delegate.
            // Since this does not remove references for locally mutated documents,
            // we have to remove the target associations for these documents
            // manually.
            // This operation needs to be run inside the transaction since EagerGC
            // uses the local view references during the transaction's commit.
            // Fortunately, the operation is safe to be re-run in case the
            // transaction fails since there are no side effects if the target has
            // already been removed.
            var u = i.dh.ps(t);
            return n ? de.resolve() : de.forEach(u, (function(t) {
                return i.persistence.wo.vs(r, t);
            })).next((function() {
                i.persistence.wo.removeTarget(r, e);
            }));
        })).then((function() {
            i.vh = i.vh.remove(t), i.wh.delete(e.target);
        }));
    }, 
    /**
     * Runs the specified query against the local store and returns the results,
     * potentially taking advantage of query data from previous executions (such
     * as the set of remote keys).
     *
     * @param usePreviousResults Whether results from previous executions can
     * be used to optimize this query execution.
     */
    t.prototype.ic = function(t, n) {
        var i = this, e = yt.MIN, r = di();
        return this.persistence.runTransaction("Execute query", "readonly-idempotent", (function(u) {
            return i.$h(u, t.ai()).next((function(t) {
                if (t) return e = t.lastLimboFreeSnapshotVersion, i.Ih.ec(u, t.targetId).next((function(t) {
                    r = t;
                }));
            })).next((function() {
                return i.lh.ih(u, t, n ? e : yt.MIN, n ? r : di());
            })).next((function(t) {
                return {
                    documents: t,
                    rc: r
                };
            }));
        }));
    }, 
    /**
     * Returns the keys of the documents that are associated with the given
     * target id in the remote table.
     */
    t.prototype.uc = function(t) {
        var n = this;
        return this.persistence.runTransaction("Remote document keys", "readonly-idempotent", (function(i) {
            return n.Ih.ec(i, t);
        }));
    }, 
    // PORTING NOTE: Multi-tab only.
    t.prototype.sc = function() {
        return this.persistence.sc();
    }, 
    // PORTING NOTE: Multi-tab only.
    t.prototype.oc = function(t) {
        this.Yo.Lo(t);
    }, 
    // PORTING NOTE: Multi-tab only.
    t.prototype.hc = function(t) {
        this.persistence.hc(t);
    }, t.prototype.xh = function(t, n, i) {
        var e = this, r = n.batch, u = r.keys(), s = de.resolve();
        return u.forEach((function(e) {
            s = s.next((function() {
                return i.Bs(t, e);
            })).next((function(t) {
                var u = t, s = n.hs.get(e);
                C(null !== s, "ackVersions should contain every doc in the write."), (!u || u.version.h(s) < 0) && ((u = r.Wt(e, u, n)) ? 
                // We use the commitVersion as the readTime rather than the
                // document's updateTime since the updateTime is not advanced
                // for updates that do not modify the underlying document.
                i.js(u, n.os) : C(!t, "Mutation batch " + r + " applied to document " + t + " resulted in null"));
            }));
        })), s.next((function() {
            return e.Yo.jo(t, r);
        }));
    }, t.prototype.cc = function(t) {
        var n = this;
        return this.persistence.runTransaction("Collect garbage", "readwrite-primary-idempotent", (function(i) {
            return t.ac(i, n.vh);
        }));
    }, 
    // PORTING NOTE: Multi-tab only.
    t.prototype.fc = function(t) {
        var n = this, i = this.vh.get(t);
        return i ? Promise.resolve(i.target) : this.persistence.runTransaction("Get target data", "readonly-idempotent", (function(i) {
            return n.Ih.Xe(i, t).next((function(t) {
                return t ? t.target : null;
            }));
        }));
    }, 
    /**
     * Returns the set of documents that have been updated since the last call.
     * If this is the first call, returns the set of changes since client
     * initialization. Further invocations will return document changes since
     * the point of rejection.
     */
    // PORTING NOTE: Multi-tab only.
    t.prototype.lc = function() {
        var t = this;
        return this.persistence.runTransaction("Get new document changes", "readonly-idempotent", (function(n) {
            return t.yh.lc(n, t.mh);
        })).then((function(n) {
            var i = n.dc, e = n.readTime;
            return t.mh = e, i;
        }));
    }, 
    /**
     * Reads the newest document change from persistence and forwards the internal
     * synchronization marker so that calls to `getNewDocumentChanges()`
     * only return changes that happened after client initialization.
     */
    // PORTING NOTE: Multi-tab only.
    t.prototype.Dh = function() {
        return r(this, void 0, void 0, (function() {
            var t, n = this;
            return u(this, (function(i) {
                switch (i.label) {
                  case 0:
                    return t = this, [ 4 /*yield*/ , this.persistence.runTransaction("Synchronize last document change read time", "readonly-idempotent", (function(t) {
                        return n.yh.vc(t);
                    })) ];

                  case 1:
                    return t.mh = i.sent(), [ 2 /*return*/ ];
                }
            }));
        }));
    }, 
    /**
     * The maximum time to leave a resume token buffered without writing it out.
     * This value is arbitrary: it's long enough to avoid several writes
     * (possibly indefinitely if updates come more frequently than this) but
     * short enough that restarting after crashing will still have a pretty
     * recent resume token.
     */
    t.Kh = 3e8, t;
}();

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A readonly view of the local state of all documents we're tracking (i.e. we
 * have a cached version in remoteDocumentCache or local mutations for the
 * document). The view is computed by applying the mutations in the
 * MutationQueue to the RemoteDocumentCache.
 */
/**
 * Verifies the error thrown by a LocalStore operation. If a LocalStore
 * operation fails because the primary lease has been taken by another client,
 * we ignore the error (the persistence layer will immediately call
 * `applyPrimaryLease` to propagate the primary state change). All other errors
 * are re-thrown.
 *
 * @param err An error returned by a LocalStore operation.
 * @return A Promise that resolves after we recovered, or the original error.
 */
function Ue(t) {
    return r(this, void 0, void 0, (function() {
        return u(this, (function(n) {
            if (t.code !== L.FAILED_PRECONDITION || t.message !== we) throw t;
            return A(xe, "Unexpectedly lost primary lease"), [ 2 /*return*/ ];
        }));
    }));
}

/**
 * @license
 * Copyright 2018 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ function Le(t, n) {
    var i = t[0], e = t[1], r = n[0], u = n[1], s = N(i, r);
    return 0 === s ? N(e, u) : s;
}

/**
 * Used to calculate the nth sequence number. Keeps a rolling buffer of the
 * lowest n values passed to `addElement`, and finally reports the largest of
 * them in `maxValue`.
 */ var Be = /** @class */ function() {
    function t(t) {
        this.wc = t, this.buffer = new Ct(Le), this.mc = 0;
    }
    return t.prototype.pc = function() {
        return ++this.mc;
    }, t.prototype.gc = function(t) {
        var n = [ t, this.pc() ];
        if (this.buffer.size < this.wc) this.buffer = this.buffer.add(n); else {
            var i = this.buffer.last();
            Le(n, i) < 0 && (this.buffer = this.buffer.delete(i).add(n));
        }
    }, Object.defineProperty(t.prototype, "maxValue", {
        get: function() {
            // Guaranteed to be non-empty. If we decide we are not collecting any
            // sequence numbers, nthSequenceNumber below short-circuits. If we have
            // decided that we are collecting n sequence numbers, it's because n is some
            // percentage of the existing sequence numbers. That means we should never
            // be in a situation where we are collecting sequence numbers but don't
            // actually have any.
            return this.buffer.last()[0];
        },
        enumerable: !0,
        configurable: !0
    }), t;
}(), Me = {
    bc: !1,
    yc: 0,
    _c: 0,
    Ic: 0
}, qe = /** @class */ function() {
    function t(
    // When we attempt to collect, we will only do so if the cache size is greater than this
    // threshold. Passing `COLLECTION_DISABLED` here will cause collection to always be skipped.
    t, 
    // The percentage of sequence numbers that we will attempt to collect
    n, 
    // A cap on the total number of sequence numbers that will be collected. This prevents
    // us from collecting a huge number of sequence numbers if the cache has grown very large.
    i) {
        this.Tc = t, this.Ec = n, this.Rc = i;
    }
    return t.Ac = function(n) {
        return new t(n, t.Dc, t.Pc);
    }, t.Sc = -1, t.Cc = 1048576, t.Vc = 41943040, t.Dc = 10, t.Pc = 1e3, t.Nc = new t(t.Vc, t.Dc, t.Pc), 
    t.DISABLED = new t(t.Sc, 0, 0), t;
}(), Qe = /** @class */ function() {
    function t(t, n, i) {
        this.kc = t, this.Su = n, this.Oc = i, this.Fc = !1, this.xc = null;
    }
    return t.prototype.start = function() {
        C(null === this.xc, "Cannot start an already started LruScheduler"), this.kc.params.Tc !== qe.Sc && this.jc();
    }, t.prototype.stop = function() {
        this.xc && (this.xc.cancel(), this.xc = null);
    }, Object.defineProperty(t.prototype, "ph", {
        get: function() {
            return null !== this.xc;
        },
        enumerable: !0,
        configurable: !0
    }), t.prototype.jc = function() {
        var t = this;
        C(null === this.xc, "Cannot schedule GC while a task is pending");
        var n = this.Fc ? 3e5 : 6e4;
        A("LruGarbageCollector", "Garbage collection scheduled in " + n + "ms"), this.xc = this.Su.Xu(zi.Du, n, (function() {
            return t.xc = null, t.Fc = !0, t.Oc.cc(t.kc).then((function() {
                return t.jc();
            })).catch(Ue);
        }));
    }, t;
}(), Ge = /** @class */ function() {
    function t(t, n) {
        this.Uc = t, this.params = n;
    }
    /** Given a percentile of target to collect, returns the number of targets to collect. */    return t.prototype.Lc = function(t, n) {
        return this.Uc.Bc(t).next((function(t) {
            return Math.floor(n / 100 * t);
        }));
    }, 
    /** Returns the nth sequence number, counting in order from the smallest. */
    t.prototype.Mc = function(t, n) {
        var i = this;
        if (0 === n) return de.resolve(Yi.bu);
        var e = new Be(n);
        return this.Uc.Be(t, (function(t) {
            return e.gc(t.sequenceNumber);
        })).next((function() {
            return i.Uc.qc(t, (function(t) {
                return e.gc(t);
            }));
        })).next((function() {
            return e.maxValue;
        }));
    }, 
    /**
     * Removes targets with a sequence number equal to or less than the given upper bound, and removes
     * document associations with those targets.
     */
    t.prototype.Qc = function(t, n, i) {
        return this.Uc.Qc(t, n, i);
    }, 
    /**
     * Removes documents that have a sequence number equal to or less than the upper bound and are not
     * otherwise pinned.
     */
    t.prototype.Gc = function(t, n) {
        return this.Uc.Gc(t, n);
    }, t.prototype.ac = function(t, n) {
        var i = this;
        return this.params.Tc === qe.Sc ? (A("LruGarbageCollector", "Garbage collection skipped; disabled"), 
        de.resolve(Me)) : this.Wc(t).next((function(e) {
            return e < i.params.Tc ? (A("LruGarbageCollector", "Garbage collection skipped; Cache size " + e + " is lower than threshold " + i.params.Tc), 
            Me) : i.zc(t, n);
        }));
    }, t.prototype.Wc = function(t) {
        return this.Uc.Wc(t);
    }, t.prototype.zc = function(t, n) {
        var i, e, r, u, s, o, h, c = this, a = Date.now();
        return this.Lc(t, this.params.Ec).next((function(n) {
            // Cap at the configured max
            return n > c.params.Rc ? (A("LruGarbageCollector", "Capping sequence numbers to collect down to the maximum of " + c.params.Rc + " from " + n), 
            e = c.params.Rc) : e = n, u = Date.now(), c.Mc(t, e);
        })).next((function(e) {
            return i = e, s = Date.now(), c.Qc(t, i, n);
        })).next((function(n) {
            return r = n, o = Date.now(), c.Gc(t, i);
        })).next((function(t) {
            (h = Date.now(), E() <= _.DEBUG) && A("LruGarbageCollector", "LRU Garbage Collection\n\tCounted targets in " + (u - a) + "ms\n\tDetermined least recently used " + e + " in " + (s - u) + "ms\n\tRemoved " + r + " targets in " + (o - s) + "ms\n\tRemoved " + t + " documents in " + (h - o) + "ms\nTotal Duration: " + (h - a) + "ms");
            return de.resolve({
                bc: !0,
                yc: e,
                _c: r,
                Ic: t
            });
        }));
    }, t;
}(), We = /** @class */ function() {
    function t(t, n) {
        this.wo = t, this.serializer = n, 
        // PORTING NOTE: We don't cache global metadata for the target cache, since
        // some of it (in particular `highestTargetId`) can be modified by secondary
        // tabs. We could perhaps be more granular (and e.g. still cache
        // `lastRemoteSnapshotVersion` in memory) but for simplicity we currently go
        // to IndexedDb whenever we need to read metadata. We can revisit if it turns
        // out to have a meaningful performance impact.
        this.Kc = ke.Ko();
    }
    return t.prototype.Zh = function(t) {
        var n = this;
        return this.Hc(t).next((function(i) {
            return i.highestTargetId = n.Kc.after(i.highestTargetId), n.Jc(t, i).next((function() {
                return i.highestTargetId;
            }));
        }));
    }, t.prototype.Uh = function(t) {
        return this.Hc(t).next((function(t) {
            return yt.L(new bt(t.lastRemoteSnapshotVersion.seconds, t.lastRemoteSnapshotVersion.nanoseconds));
        }));
    }, t.prototype.Yc = function(t) {
        return He(t.Uo);
    }, t.prototype.zh = function(t, n, i) {
        var e = this;
        return this.Hc(t).next((function(r) {
            return r.highestListenSequenceNumber = n, i && (r.lastRemoteSnapshotVersion = i.q()), 
            n > r.highestListenSequenceNumber && (r.highestListenSequenceNumber = n), e.Jc(t, r);
        }));
    }, t.prototype.tc = function(t, n) {
        var i = this;
        return this.Xc(t, n).next((function() {
            return i.Hc(t).next((function(e) {
                return e.targetCount += 1, i.$c(n, e), i.Jc(t, e);
            }));
        }));
    }, t.prototype.Gh = function(t, n) {
        return this.Xc(t, n);
    }, t.prototype.Zc = function(t, n) {
        var i = this;
        return this.ta(t, n.targetId).next((function() {
            return ze(t).delete(n.targetId);
        })).next((function() {
            return i.Hc(t);
        })).next((function(n) {
            return C(n.targetCount > 0, "Removing from an empty target cache"), n.targetCount -= 1, 
            i.Jc(t, n);
        }));
    }, 
    /**
     * Drops any targets with sequence number less than or equal to the upper bound, excepting those
     * present in `activeTargetIds`. Document associations for the removed targets are also removed.
     * Returns the number of targets removed.
     */
    t.prototype.Qc = function(t, n, i) {
        var e = this, r = 0, u = [];
        return ze(t).lo((function(s, o) {
            var h = e.serializer.na(o);
            h.sequenceNumber <= n && null === i.get(h.targetId) && (r++, u.push(e.Zc(t, h)));
        })).next((function() {
            return de.Ns(u);
        })).next((function() {
            return r;
        }));
    }, 
    /**
     * Call provided function with each `TargetData` that we have cached.
     */
    t.prototype.Be = function(t, n) {
        var i = this;
        return ze(t).lo((function(t, e) {
            var r = i.serializer.na(e);
            n(r);
        }));
    }, t.prototype.Hc = function(t) {
        return Ke(t.Uo);
    }, t.prototype.Jc = function(t, n) {
        return (i = t, Sr.Zs(i, mr.store)).put(mr.key, n);
        /**
 * Helper to get a typed SimpleDbStore for the target globals object store.
 */
        var i;
    }, t.prototype.Xc = function(t, n) {
        return ze(t).put(this.serializer.ia(n));
    }, 
    /**
     * In-place updates the provided metadata to account for values in the given
     * TargetData. Saving is done separately. Returns true if there were any
     * changes to the metadata.
     */
    t.prototype.$c = function(t, n) {
        var i = !1;
        return t.targetId > n.highestTargetId && (n.highestTargetId = t.targetId, i = !0), 
        t.sequenceNumber > n.highestListenSequenceNumber && (n.highestListenSequenceNumber = t.sequenceNumber, 
        i = !0), i;
    }, t.prototype.ea = function(t) {
        return this.Hc(t).next((function(t) {
            return t.targetCount;
        }));
    }, t.prototype.$h = function(t, n) {
        var i = this, e = n.canonicalId(), r = IDBKeyRange.bound([ e, Number.NEGATIVE_INFINITY ], [ e, Number.POSITIVE_INFINITY ]), u = null;
        // Iterating by the canonicalId may yield more than one result because
        // canonicalId values are not required to be unique per target. This query
        // depends on the queryTargets index to be efficient.
                return ze(t).lo({
            range: r,
            index: vr.queryTargetsIndexName
        }, (function(t, e, r) {
            var s = i.serializer.na(e);
            // After finding a potential match, check that the target is
            // actually equal to the requested target.
                        n.isEqual(s.target) && (u = s, r.done());
        })).next((function() {
            return u;
        }));
    }, t.prototype.Mh = function(t, n, i) {
        var e = this, r = [], u = Je(t);
        // PORTING NOTE: The reverse index (documentsTargets) is maintained by
        // IndexedDb.
                return n.forEach((function(n) {
            var s = re(n.path);
            r.push(u.put(new wr(i, s))), r.push(e.wo.ls(t, n));
        })), de.Ns(r);
    }, t.prototype.Bh = function(t, n, i) {
        var e = this, r = Je(t);
        // PORTING NOTE: The reverse index (documentsTargets) is maintained by
        // IndexedDb.
                return de.forEach(n, (function(n) {
            var u = re(n.path);
            return de.Ns([ r.delete([ i, u ]), e.wo.vs(t, n) ]);
        }));
    }, t.prototype.ta = function(t, n) {
        var i = Je(t), e = IDBKeyRange.bound([ n ], [ n + 1 ], 
        /*lowerOpen=*/ !1, 
        /*upperOpen=*/ !0);
        return i.delete(e);
    }, t.prototype.ec = function(t, n) {
        var i = IDBKeyRange.bound([ n ], [ n + 1 ], 
        /*lowerOpen=*/ !1, 
        /*upperOpen=*/ !0), e = Je(t), r = di();
        return e.lo({
            range: i,
            fo: !0
        }, (function(t, n, i) {
            var e = oe(t[1]), u = new Rt(e);
            r = r.add(u);
        })).next((function() {
            return r;
        }));
    }, t.prototype.ys = function(t, n) {
        var i = re(n.path), e = IDBKeyRange.bound([ i ], [ O(i) ], 
        /*lowerOpen=*/ !1, 
        /*upperOpen=*/ !0), r = 0;
        return Je(t).lo({
            index: wr.documentTargetsIndex,
            fo: !0,
            range: e
        }, (function(t, n, i) {
            var e = t[0];
            // Having a sentinel row for a document does not count as containing that document;
            // For the target cache, containing the document means the document is part of some
            // target.
                        t[1];
            0 !== e && (r++, i.done());
        })).next((function() {
            return r > 0;
        }));
    }, t.prototype.Xe = function(t, n) {
        var i = this;
        return ze(t).get(n).next((function(t) {
            return t ? i.serializer.na(t) : null;
        }));
    }, t;
}();

/**
 * Helper to get a typed SimpleDbStore for the queries object store.
 */
function ze(t) {
    return Sr.Zs(t, vr.store);
}

function Ke(t) {
    return pe.Zs(t, mr.store).get(mr.key).next((function(t) {
        return C(null !== t, "Missing metadata row."), t;
    }));
}

function He(t) {
    return Ke(t).next((function(t) {
        return t.highestListenSequenceNumber;
    }));
}

/**
 * Helper to get a typed SimpleDbStore for the document target object store.
 */ function Je(t) {
    return Sr.Zs(t, wr.store);
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ var Ye = /** @class */ function() {
    /**
     * @param {LocalSerializer} serializer The document serializer.
     * @param {IndexManager} indexManager The query indexes that need to be maintained.
     */
    function t(t, n) {
        this.serializer = t, this.vo = n;
    }
    /**
     * Adds the supplied entries to the cache.
     *
     * All calls of `addEntry` are required to go through the RemoteDocumentChangeBuffer
     * returned by `newChangeBuffer()` to ensure proper accounting of metadata.
     */    return t.prototype.js = function(t, n, i) {
        return $e(t).put(Ze(n), i);
    }, 
    /**
     * Removes a document from the cache.
     *
     * All calls of `removeEntry`  are required to go through the RemoteDocumentChangeBuffer
     * returned by `newChangeBuffer()` to ensure proper accounting of metadata.
     */
    t.prototype.Ls = function(t, n) {
        var i = $e(t), e = Ze(n);
        return i.delete(e);
    }, 
    /**
     * Updates the current cache size.
     *
     * Callers to `addEntry()` and `removeEntry()` *must* call this afterwards to update the
     * cache's metadata.
     */
    t.prototype.updateMetadata = function(t, n) {
        var i = this;
        return this.getMetadata(t).next((function(e) {
            return e.byteSize += n, i.ra(t, e);
        }));
    }, t.prototype.Bs = function(t, n) {
        var i = this;
        return $e(t).get(Ze(n)).next((function(t) {
            return i.ua(t);
        }));
    }, 
    /**
     * Looks up an entry in the cache.
     *
     * @param documentKey The key of the entry to look up.
     * @return The cached MaybeDocument entry and its size, or null if we have nothing cached.
     */
    t.prototype.sa = function(t, n) {
        var i = this;
        return $e(t).get(Ze(n)).next((function(t) {
            var n = i.ua(t);
            return n ? {
                oa: n,
                size: tr(t)
            } : null;
        }));
    }, t.prototype.getEntries = function(t, n) {
        var i = this, e = oi();
        return this.ha(t, n, (function(t, n) {
            var r = i.ua(n);
            e = e.lt(t, r);
        })).next((function() {
            return e;
        }));
    }, 
    /**
     * Looks up several entries in the cache.
     *
     * @param documentKeys The set of keys entries to look up.
     * @return A map of MaybeDocuments indexed by key (if a document cannot be
     *     found, the key will be mapped to null) and a map of sizes indexed by
     *     key (zero if the key cannot be found).
     */
    t.prototype.ca = function(t, n) {
        var i = this, e = oi(), r = new At(Rt.G);
        return this.ha(t, n, (function(t, n) {
            var u = i.ua(n);
            u ? (e = e.lt(t, u), r = r.lt(t, tr(n))) : (e = e.lt(t, null), r = r.lt(t, 0));
        })).next((function() {
            return {
                aa: e,
                fa: r
            };
        }));
    }, t.prototype.ha = function(t, n, i) {
        if (n.J()) return de.resolve();
        var e = IDBKeyRange.bound(n.first().path.tt(), n.last().path.tt()), r = n.bt(), u = r.Rt();
        return $e(t).lo({
            range: e
        }, (function(t, n, e) {
            // Go through keys not found in cache.
            for (var s = Rt.at(t); u && Rt.G(u, s) < 0; ) i(u, null), u = r.Rt();
            u && u.isEqual(s) && (
            // Key found in cache.
            i(u, n), u = r.At() ? r.Rt() : null), 
            // Skip to the next key (if there is one).
            u ? e.so(u.path.tt()) : e.done();
        })).next((function() {
            // The rest of the keys are not in the cache. One case where `iterate`
            // above won't go through them is when the cache is empty.
            for (;u; ) i(u, null), u = r.At() ? r.Rt() : null;
        }));
    }, t.prototype.ih = function(t, n, i) {
        var e = this;
        C(!n.bi(), "CollectionGroup queries should be handled in LocalDocumentsView");
        var r = ci(), u = n.path.length + 1, s = {};
        if (i.isEqual(yt.MIN)) {
            // Documents are ordered by key, so we can use a prefix scan to narrow
            // down the documents we need to match the query against.
            var o = n.path.tt();
            s.range = IDBKeyRange.lowerBound(o);
        } else {
            // Execute an index-free query and filter by read time. This is safe
            // since all document changes to queries that have a
            // lastLimboFreeSnapshotVersion (`sinceReadTime`) have a read time set.
            var h = n.path.tt(), c = this.serializer.la(i);
            s.range = IDBKeyRange.lowerBound([ h, c ], 
            /* open= */ !0), s.index = lr.collectionReadTimeIndex;
        }
        return $e(t).lo(s, (function(t, i, s) {
            // The query is actually returning any path that starts with the query
            // path prefix which may include documents in subcollections. For
            // example, a query on 'rooms' will return rooms/abc/messages/xyx but we
            // shouldn't match it. Fix this by discarding rows with document keys
            // more than one segment longer than the query path.
            if (t.length === u) {
                var o = e.serializer.da(i);
                n.path.$(o.key.path) ? o instanceof pn && n.matches(o) && (r = r.lt(o.key, o)) : s.done();
            }
        })).next((function() {
            return r;
        }));
    }, t.prototype.lc = function(t, n) {
        var i = this, e = si(), r = this.serializer.la(n), u = $e(t), s = IDBKeyRange.lowerBound(r, !0);
        return u.lo({
            index: lr.readTimeIndex,
            range: s
        }, (function(t, n) {
            // Unlike `getEntry()` and others, `getNewDocumentChanges()` parses
            // the documents directly since we want to keep sentinel deletes.
            var u = i.serializer.da(n);
            e = e.lt(u.key, u), r = n.readTime;
        })).next((function() {
            return {
                dc: e,
                readTime: i.serializer.va(r)
            };
        }));
    }, t.prototype.vc = function(t) {
        var n = this, i = $e(t), e = yt.MIN;
        return i.lo({
            index: lr.readTimeIndex,
            reverse: !0
        }, (function(t, i, r) {
            i.readTime && (e = n.serializer.va(i.readTime)), r.done();
        })).next((function() {
            return e;
        }));
    }, t.prototype.Oh = function(n) {
        return new t.wa(this, !!n && n.Fh);
    }, t.prototype.ma = function(t) {
        return this.getMetadata(t).next((function(t) {
            return t.byteSize;
        }));
    }, t.prototype.getMetadata = function(t) {
        return Xe(t).get(dr.key).next((function(t) {
            return C(!!t, "Missing document cache metadata"), t;
        }));
    }, t.prototype.ra = function(t, n) {
        return Xe(t).put(dr.key, n);
    }, 
    /**
     * Decodes `remoteDoc` and returns the document (or null, if the document
     * corresponds to the format used for sentinel deletes).
     */
    t.prototype.ua = function(t) {
        if (t) {
            var n = this.serializer.da(t);
            return n instanceof gn && n.version.isEqual(yt.B()) ? null : n;
        }
        return null;
    }, 
    /**
     * Handles the details of adding and updating documents in the IndexedDbRemoteDocumentCache.
     *
     * Unlike the MemoryRemoteDocumentChangeBuffer, the IndexedDb implementation computes the size
     * delta for all submitted changes. This avoids having to re-read all documents from IndexedDb
     * when we apply the changes.
     */
    t.wa = /** @class */ function(t) {
        /**
         * @param documentCache The IndexedDbRemoteDocumentCache to apply the changes to.
         * @param trackRemovals Whether to create sentinel deletes that can be tracked by
         * `getNewDocumentChanges()`.
         */
        function n(n, i) {
            var e = t.call(this) || this;
            return e.pa = n, e.Fh = i, 
            // A map of document sizes prior to applying the changes in this buffer.
            e.ga = new le((function(t) {
                return t.toString();
            })), e;
        }
        return i(n, t), n.prototype.Qs = function(t) {
            var n = this, i = [], e = 0, r = new Ct((function(t, n) {
                return N(t.nt(), n.nt());
            }));
            return this.Os.forEach((function(u, s) {
                var o = n.ga.get(u);
                if (C(void 0 !== o, "Cannot modify a document that wasn't read (for " + u + ")"), 
                s) {
                    C(!n.readTime.isEqual(yt.MIN), "Cannot add a document with a read time of zero");
                    var h = n.pa.serializer.ba(s, n.readTime);
                    r = r.add(u.path.H());
                    var c = tr(h);
                    e += c - o, i.push(n.pa.js(t, u, h));
                } else if (e -= o, n.Fh) {
                    // In order to track removals, we store a "sentinel delete" in the
                    // RemoteDocumentCache. This entry is represented by a NoDocument
                    // with a version of 0 and ignored by `maybeDecodeDocument()` but
                    // preserved in `getNewDocumentChanges()`.
                    var a = n.pa.serializer.ba(new gn(u, yt.B()), n.readTime);
                    i.push(n.pa.js(t, u, a));
                } else i.push(n.pa.Ls(t, u));
            })), r.forEach((function(e) {
                i.push(n.pa.vo.Ao(t, e));
            })), i.push(this.pa.updateMetadata(t, e)), de.Ns(i);
        }, n.prototype.Ms = function(t, n) {
            var i = this;
            // Record the size of everything we load from the cache so we can compute a delta later.
                        return this.pa.sa(t, n).next((function(t) {
                return null === t ? (i.ga.set(n, 0), null) : (i.ga.set(n, t.size), t.oa);
            }));
        }, n.prototype.qs = function(t, n) {
            var i = this;
            // Record the size of everything we load from the cache so we can compute
            // a delta later.
                        return this.pa.ca(t, n).next((function(t) {
                var n = t.aa;
                // Note: `getAllFromCache` returns two maps instead of a single map from
                // keys to `DocumentSizeEntry`s. This is to allow returning the
                // `NullableMaybeDocumentMap` directly, without a conversion.
                                return t.fa.forEach((function(t, n) {
                    i.ga.set(t, n);
                })), n;
            }));
        }, n;
    }(ve), t;
}();

function Xe(t) {
    return Sr.Zs(t, dr.store);
}

/**
 * Helper to get a typed SimpleDbStore for the remoteDocuments object store.
 */ function $e(t) {
    return Sr.Zs(t, lr.store);
}

function Ze(t) {
    return t.path.tt();
}

/**
 * Retrusn an approximate size for the given document.
 */ function tr(t) {
    var n;
    if (t.document) n = t.document; else if (t.unknownDocument) n = t.unknownDocument; else {
        if (!t.noDocument) throw S("Unknown remote document type");
        n = t.noDocument;
    }
    return JSON.stringify(n).length;
}

/**
 * @license
 * Copyright 2019 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * An in-memory implementation of IndexManager.
 */ var nr = /** @class */ function() {
    function t() {
        this.ya = new ir;
    }
    return t.prototype.Ao = function(t, n) {
        return this.ya.add(n), de.resolve();
    }, t.prototype.sh = function(t, n) {
        return de.resolve(this.ya.getEntries(n));
    }, t;
}(), ir = /** @class */ function() {
    function t() {
        this.index = {};
    }
    // Returns false if the entry already existed.
        return t.prototype.add = function(t) {
        C(t.length % 2 == 1, "Expected a collection path.");
        var n = t.X(), i = t.H(), e = this.index[n] || new Ct(It.G), r = !e.has(i);
        return this.index[n] = e.add(i), r;
    }, t.prototype.has = function(t) {
        var n = t.X(), i = t.H(), e = this.index[n];
        return e && e.has(i);
    }, t.prototype.getEntries = function(t) {
        return (this.index[t] || new Ct(It.G)).tt();
    }, t;
}(), er = 9, rr = /** @class */ function() {
    function t(t) {
        this.serializer = t;
    }
    /**
     * Performs database creation and schema upgrades.
     *
     * Note that in production, this method is only ever used to upgrade the schema
     * to SCHEMA_VERSION. Different values of toVersion are only used for testing
     * and local feature development.
     */    return t.prototype.createOrUpgrade = function(t, n, i, e) {
        var r = this;
        C(i < e && i >= 0 && e <= er, "Unexpected schema upgrade from v" + i + " to v{toVersion}.");
        var u = new be(n);
        i < 1 && e >= 1 && (function(t) {
            t.createObjectStore(sr.store);
        }
        /**
 * An object to be stored in the 'mutationQueues' store in IndexedDb.
 *
 * Each user gets a single queue of MutationBatches to apply to the server.
 * DbMutationQueue tracks the metadata about the queue.
 */ (t), function(t) {
            t.createObjectStore(or.store, {
                keyPath: or.keyPath
            }), t.createObjectStore(hr.store, {
                keyPath: hr.keyPath,
                autoIncrement: !0
            }).createIndex(hr.userMutationsIndex, hr.userMutationsKeyPath, {
                unique: !0
            }), t.createObjectStore(cr.store);
        }
        /**
 * Upgrade function to migrate the 'mutations' store from V1 to V3. Loads
 * and rewrites all data.
 */ (t), gr(t), function(t) {
            t.createObjectStore(lr.store);
        }
        /**
 * Represents the known absence of a document at a particular version.
 * Stored in IndexedDb as part of a DbRemoteDocument object.
 */ (t));
        // Migration 2 to populate the targetGlobal object no longer needed since
        // migration 3 unconditionally clears it.
                var s = de.resolve();
        return i < 3 && e >= 3 && (
        // Brand new clients don't need to drop and recreate--only clients that
        // potentially have corrupt data.
        0 !== i && (!function(t) {
            t.deleteObjectStore(wr.store), t.deleteObjectStore(vr.store), t.deleteObjectStore(mr.store);
        }(t), gr(t)), s = s.next((function() {
            /**
 * Creates the target global singleton row.
 *
 * @param {IDBTransaction} txn The version upgrade transaction for indexeddb
 */ return function(t) {
                var n = t.store(mr.store), i = new mr(
                /*highestTargetId=*/ 0, 
                /*lastListenSequenceNumber=*/ 0, yt.MIN.q(), 
                /*targetCount=*/ 0);
                return n.put(mr.key, i);
            }
            /**
 * Creates indices on the RemoteDocuments store used for both multi-tab
 * and Index-Free queries.
 */ (u);
        }))), i < 4 && e >= 4 && (0 !== i && (
        // Schema version 3 uses auto-generated keys to generate globally unique
        // mutation batch IDs (this was previously ensured internally by the
        // client). To migrate to the new schema, we have to read all mutations
        // and write them back out. We preserve the existing batch IDs to guarantee
        // consistency with other object stores. Any further mutation batch IDs will
        // be auto-generated.
        s = s.next((function() {
            return function(t, n) {
                return n.store(hr.store).ho().next((function(i) {
                    t.deleteObjectStore(hr.store), t.createObjectStore(hr.store, {
                        keyPath: hr.keyPath,
                        autoIncrement: !0
                    }).createIndex(hr.userMutationsIndex, hr.userMutationsKeyPath, {
                        unique: !0
                    });
                    var e = n.store(hr.store), r = i.map((function(t) {
                        return e.put(t);
                    }));
                    return de.Ns(r);
                }));
            }
            /**
 * An object to be stored in the 'documentMutations' store in IndexedDb.
 *
 * A manually maintained index of all the mutation batches that affect a given
 * document key. The rows in this table are references based on the contents of
 * DbMutationBatch.mutations.
 */ (t, u);
        }))), s = s.next((function() {
            !function(t) {
                t.createObjectStore(br.store, {
                    keyPath: br.keyPath
                });
            }
            // Visible for testing
            (t);
        }))), i < 5 && e >= 5 && (s = s.next((function() {
            return r.removeAcknowledgedMutations(u);
        }))), i < 6 && e >= 6 && (s = s.next((function() {
            return function(t) {
                t.createObjectStore(dr.store);
            }
            /**
 * An object to be stored in the 'targets' store in IndexedDb.
 *
 * This is based on and should be kept in sync with the proto used in the iOS
 * client.
 *
 * Each query the client listens to against the server is tracked on disk so
 * that the query can be efficiently resumed on restart.
 */ (t), r.addDocumentGlobal(u);
        }))), i < 7 && e >= 7 && (s = s.next((function() {
            return r.ensureSequenceNumbers(u);
        }))), i < 8 && e >= 8 && (s = s.next((function() {
            return r.createCollectionParentIndex(t, u);
        }))), i < 9 && e >= 9 && (s = s.next((function() {
            // Multi-Tab used to manage its own changelog, but this has been moved
            // to the DbRemoteDocument object store itself. Since the previous change
            // log only contained transient data, we can drop its object store.
            !function(t) {
                t.objectStoreNames.contains("remoteDocumentChanges") && t.deleteObjectStore("remoteDocumentChanges");
            }(t), function(t) {
                var n = t.objectStore(lr.store);
                n.createIndex(lr.readTimeIndex, lr.readTimeIndexPath, {
                    unique: !1
                }), n.createIndex(lr.collectionReadTimeIndex, lr.collectionReadTimeIndexPath, {
                    unique: !1
                });
            }
            /**
 * A record of the metadata state of each client.
 *
 * PORTING NOTE: This is used to synchronize multi-tab state and does not need
 * to be ported to iOS or Android.
 */ (n);
        }))), s;
    }, t.prototype.addDocumentGlobal = function(t) {
        var n = 0;
        return t.store(lr.store).lo((function(t, i) {
            n += tr(i);
        })).next((function() {
            var i = new dr(n);
            return t.store(dr.store).put(dr.key, i);
        }));
    }, t.prototype.removeAcknowledgedMutations = function(t) {
        var n = this, i = t.store(or.store), e = t.store(hr.store);
        return i.ho().next((function(i) {
            return de.forEach(i, (function(i) {
                var r = IDBKeyRange.bound([ i.userId, -1 ], [ i.userId, i.lastAcknowledgedBatchId ]);
                return e.ho(hr.userMutationsIndex, r).next((function(e) {
                    return de.forEach(e, (function(e) {
                        C(e.userId === i.userId, "Cannot process batch " + e.batchId + " from unexpected user");
                        var r = n.serializer.Po(e);
                        return Ae(t, i.userId, r).next((function() {}));
                    }));
                }));
            }));
        }));
    }, 
    /**
     * Ensures that every document in the remote document cache has a corresponding sentinel row
     * with a sequence number. Missing rows are given the most recently used sequence number.
     */
    t.prototype.ensureSequenceNumbers = function(t) {
        var n = t.store(wr.store), i = t.store(lr.store);
        return He(t).next((function(t) {
            var e = [];
            return i.lo((function(i, r) {
                var u = new It(i), s = function(t) {
                    return [ 0, re(t) ];
                }
                /**
 * Wrapper class to store timestamps (seconds and nanos) in IndexedDb objects.
 */ (u);
                e.push(n.get(s).next((function(i) {
                    return i ? de.resolve() : function(i) {
                        return n.put(new wr(0, re(i), t));
                    }(u);
                })));
            })).next((function() {
                return de.Ns(e);
            }));
        }));
    }, t.prototype.createCollectionParentIndex = function(t, n) {
        // Create the index.
        t.createObjectStore(pr.store, {
            keyPath: pr.keyPath
        });
        var i = n.store(pr.store), e = new ir, r = function(t) {
            if (e.add(t)) {
                var n = t.X(), r = t.H();
                return i.put({
                    collectionId: n,
                    parent: re(r)
                });
            }
        };
        // Helper to add an index entry iff we haven't already written it.
                // Index existing remote documents.
        return n.store(lr.store).lo({
            fo: !0
        }, (function(t, n) {
            var i = new It(t);
            return r(i.H());
        })).next((function() {
            // Index existing mutations.
            return n.store(cr.store).lo({
                fo: !0
            }, (function(t, n) {
                t[0];
                var i = t[1], e = (t[2], oe(i));
                return r(e.H());
            }));
        }));
    }, t;
}();

/**
 * Internal implementation of the collection-parent index exposed by MemoryIndexManager.
 * Also used for in-memory caching by IndexedDbIndexManager and initial index population
 * in indexeddb_schema.ts
 */ var ur = function(t, n) {
    this.seconds = t, this.nanoseconds = n;
}, sr = /** @class */ function() {
    function t(t, 
    /** Whether to allow shared access from multiple tabs. */
    n, i) {
        this.ownerId = t, this.allowTabSynchronization = n, this.leaseTimestampMs = i;
    }
    /**
     * Name of the IndexedDb object store.
     *
     * Note that the name 'owner' is chosen to ensure backwards compatibility with
     * older clients that only supported single locked access to the persistence
     * layer.
     */    return t.store = "owner", 
    /**
     * The key string used for the single object that exists in the
     * DbPrimaryClient store.
     */
    t.key = "owner", t;
}();

/**
 * A singleton object to be stored in the 'owner' store in IndexedDb.
 *
 * A given database can have a single primary tab assigned at a given time. That
 * tab must validate that it is still holding the primary lease before every
 * operation that requires locked access. The primary tab should regularly
 * write an updated timestamp to this lease to prevent other tabs from
 * "stealing" the primary lease
 */ var or = /** @class */ function() {
    function t(
    /**
     * The normalized user ID to which this queue belongs.
     */
    t, 
    /**
     * An identifier for the highest numbered batch that has been acknowledged
     * by the server. All MutationBatches in this queue with batchIds less
     * than or equal to this value are considered to have been acknowledged by
     * the server.
     *
     * NOTE: this is deprecated and no longer used by the code.
     */
    n, 
    /**
     * A stream token that was previously sent by the server.
     *
     * See StreamingWriteRequest in datastore.proto for more details about
     * usage.
     *
     * After sending this token, earlier tokens may not be used anymore so
     * only a single stream token is retained.
     */
    i) {
        this.userId = t, this.lastAcknowledgedBatchId = n, this.lastStreamToken = i;
    }
    /** Name of the IndexedDb object store.  */    return t.store = "mutationQueues", 
    /** Keys are automatically assigned via the userId property. */
    t.keyPath = "userId", t;
}(), hr = /** @class */ function() {
    function t(
    /**
     * The normalized user ID to which this batch belongs.
     */
    t, 
    /**
     * An identifier for this batch, allocated using an auto-generated key.
     */
    n, 
    /**
     * The local write time of the batch, stored as milliseconds since the
     * epoch.
     */
    i, 
    /**
     * A list of "mutations" that represent a partial base state from when this
     * write batch was initially created. During local application of the write
     * batch, these baseMutations are applied prior to the real writes in order
     * to override certain document fields from the remote document cache. This
     * is necessary in the case of non-idempotent writes (e.g. `increment()`
     * transforms) to make sure that the local view of the modified documents
     * doesn't flicker if the remote document cache receives the result of the
     * non-idempotent write before the write is removed from the queue.
     *
     * These mutations are never sent to the backend.
     */
    e, 
    /**
     * A list of mutations to apply. All mutations will be applied atomically.
     *
     * Mutations are serialized via JsonProtoSerializer.toMutation().
     */
    r) {
        this.userId = t, this.batchId = n, this.localWriteTimeMs = i, this.baseMutations = e, 
        this.mutations = r;
    }
    /** Name of the IndexedDb object store.  */    return t.store = "mutations", 
    /** Keys are automatically assigned via the userId, batchId properties. */
    t.keyPath = "batchId", 
    /** The index name for lookup of mutations by user. */
    t.userMutationsIndex = "userMutationsIndex", 
    /** The user mutations index is keyed by [userId, batchId] pairs. */
    t.userMutationsKeyPath = [ "userId", "batchId" ], t;
}();

/**
 * An object to be stored in the 'mutations' store in IndexedDb.
 *
 * Represents a batch of user-level mutations intended to be sent to the server
 * in a single write. Each user-level batch gets a separate DbMutationBatch
 * with a new batchId.
 */ var cr = /** @class */ function() {
    function t() {}
    /**
     * Creates a [userId] key for use in the DbDocumentMutations index to iterate
     * over all of a user's document mutations.
     */    return t.prefixForUser = function(t) {
        return [ t ];
    }, 
    /**
     * Creates a [userId, encodedPath] key for use in the DbDocumentMutations
     * index to iterate over all at document mutations for a given path or lower.
     */
    t.prefixForPath = function(t, n) {
        return [ t, re(n) ];
    }, 
    /**
     * Creates a full index key of [userId, encodedPath, batchId] for inserting
     * and deleting into the DbDocumentMutations index.
     */
    t.key = function(t, n, i) {
        return [ t, re(n), i ];
    }, t.store = "documentMutations", 
    /**
     * Because we store all the useful information for this store in the key,
     * there is no useful information to store as the value. The raw (unencoded)
     * path cannot be stored because IndexedDb doesn't store prototype
     * information.
     */
    t.PLACEHOLDER = new t, t;
}();

var ar = function(t, n) {
    this.path = t, this.readTime = n;
}, fr = function(t, n) {
    this.path = t, this.version = n;
}, lr = /** @class */ function() {
    // TODO: We are currently storing full document keys almost three times
    // (once as part of the primary key, once - partly - as `parentPath` and once
    // inside the encoded documents). During our next migration, we should
    // rewrite the primary key as parentPath + document ID which would allow us
    // to drop one value.
    function t(
    /**
     * Set to an instance of DbUnknownDocument if the data for a document is
     * not known, but it is known that a document exists at the specified
     * version (e.g. it had a successful update applied to it)
     */
    t, 
    /**
     * Set to an instance of a DbNoDocument if it is known that no document
     * exists.
     */
    n, 
    /**
     * Set to an instance of a Document if there's a cached version of the
     * document.
     */
    i, 
    /**
     * Documents that were written to the remote document store based on
     * a write acknowledgment are marked with `hasCommittedMutations`. These
     * documents are potentially inconsistent with the backend's copy and use
     * the write's commit version as their document version.
     */
    e, 
    /**
     * When the document was read from the backend. Undefined for data written
     * prior to schema version 9.
     */
    r, 
    /**
     * The path of the collection this document is part of. Undefined for data
     * written prior to schema version 9.
     */
    u) {
        this.unknownDocument = t, this.noDocument = n, this.document = i, this.hasCommittedMutations = e, 
        this.readTime = r, this.parentPath = u;
    }
    return t.store = "remoteDocuments", 
    /**
     * An index that provides access to all entries sorted by read time (which
     * corresponds to the last modification time of each row).
     *
     * This index is used to provide a changelog for Multi-Tab.
     */
    t.readTimeIndex = "readTimeIndex", t.readTimeIndexPath = "readTime", 
    /**
     * An index that provides access to documents in a collection sorted by read
     * time.
     *
     * This index is used to allow the RemoteDocumentCache to fetch newly changed
     * documents in a collection.
     */
    t.collectionReadTimeIndex = "collectionReadTimeIndex", t.collectionReadTimeIndexPath = [ "parentPath", "readTime" ], 
    t;
}(), dr = /** @class */ function() {
    /**
     * @param byteSize Approximately the total size in bytes of all the documents in the document
     * cache.
     */
    function t(t) {
        this.byteSize = t;
    }
    return t.store = "remoteDocumentGlobal", t.key = "remoteDocumentGlobalKey", t;
}();

/**
 * Represents a document that is known to exist but whose data is unknown.
 * Stored in IndexedDb as part of a DbRemoteDocument object.
 */ var vr = /** @class */ function() {
    function t(
    /**
     * An auto-generated sequential numeric identifier for the query.
     *
     * Queries are stored using their canonicalId as the key, but these
     * canonicalIds can be quite long so we additionally assign a unique
     * queryId which can be used by referenced data structures (e.g.
     * indexes) to minimize the on-disk cost.
     */
    t, 
    /**
     * The canonical string representing this query. This is not unique.
     */
    n, 
    /**
     * The last readTime received from the Watch Service for this query.
     *
     * This is the same value as TargetChange.read_time in the protos.
     */
    i, 
    /**
     * An opaque, server-assigned token that allows watching a query to be
     * resumed after disconnecting without retransmitting all the data
     * that matches the query. The resume token essentially identifies a
     * point in time from which the server should resume sending results.
     *
     * This is related to the snapshotVersion in that the resumeToken
     * effectively also encodes that value, but the resumeToken is opaque
     * and sometimes encodes additional information.
     *
     * A consequence of this is that the resumeToken should be used when
     * asking the server to reason about where this client is in the watch
     * stream, but the client should use the snapshotVersion for its own
     * purposes.
     *
     * This is the same value as TargetChange.resume_token in the protos.
     */
    e, 
    /**
     * A sequence number representing the last time this query was
     * listened to, used for garbage collection purposes.
     *
     * Conventionally this would be a timestamp value, but device-local
     * clocks are unreliable and they must be able to create new listens
     * even while disconnected. Instead this should be a monotonically
     * increasing number that's incremented on each listen call.
     *
     * This is different from the queryId since the queryId is an
     * immutable identifier assigned to the Query on first use while
     * lastListenSequenceNumber is updated every time the query is
     * listened to.
     */
    r, 
    /**
     * Denotes the maximum snapshot version at which the associated query view
     * contained no limbo documents.  Undefined for data written prior to
     * schema version 9.
     */
    u, 
    /**
     * The query for this target.
     *
     * Because canonical ids are not unique we must store the actual query. We
     * use the proto to have an object we can persist without having to
     * duplicate translation logic to and from a `Query` object.
     */
    s) {
        this.targetId = t, this.canonicalId = n, this.readTime = i, this.resumeToken = e, 
        this.lastListenSequenceNumber = r, this.lastLimboFreeSnapshotVersion = u, this.query = s;
    }
    return t.store = "targets", 
    /** Keys are automatically assigned via the targetId property. */
    t.keyPath = "targetId", 
    /** The name of the queryTargets index. */
    t.queryTargetsIndexName = "queryTargetsIndex", 
    /**
     * The index of all canonicalIds to the targets that they match. This is not
     * a unique mapping because canonicalId does not promise a unique name for all
     * possible queries, so we append the targetId to make the mapping unique.
     */
    t.queryTargetsKeyPath = [ "canonicalId", "targetId" ], t;
}(), wr = /** @class */ function() {
    function t(
    /**
     * The targetId identifying a target or 0 for a sentinel row.
     */
    t, 
    /**
     * The path to the document, as encoded in the key.
     */
    n, 
    /**
     * If this is a sentinel row, this should be the sequence number of the last
     * time the document specified by `path` was used. Otherwise, it should be
     * `undefined`.
     */
    i) {
        this.targetId = t, this.path = n, this.sequenceNumber = i, C(0 === t == (void 0 !== i), "A target-document row must either have targetId == 0 and a defined sequence number, or a non-zero targetId and no sequence number");
    }
    /** Name of the IndexedDb object store.  */    return t.store = "targetDocuments", 
    /** Keys are automatically assigned via the targetId, path properties. */
    t.keyPath = [ "targetId", "path" ], 
    /** The index name for the reverse index. */
    t.documentTargetsIndex = "documentTargetsIndex", 
    /** We also need to create the reverse index for these properties. */
    t.documentTargetsKeyPath = [ "path", "targetId" ], t;
}(), mr = /** @class */ function() {
    function t(
    /**
     * The highest numbered target id across all targets.
     *
     * See DbTarget.targetId.
     */
    t, 
    /**
     * The highest numbered lastListenSequenceNumber across all targets.
     *
     * See DbTarget.lastListenSequenceNumber.
     */
    n, 
    /**
     * A global snapshot version representing the last consistent snapshot we
     * received from the backend. This is monotonically increasing and any
     * snapshots received from the backend prior to this version (e.g. for
     * targets resumed with a resumeToken) should be suppressed (buffered)
     * until the backend has caught up to this snapshot version again. This
     * prevents our cache from ever going backwards in time.
     */
    i, 
    /**
     * The number of targets persisted.
     */
    e) {
        this.highestTargetId = t, this.highestListenSequenceNumber = n, this.lastRemoteSnapshotVersion = i, 
        this.targetCount = e;
    }
    /**
     * The key string used for the single object that exists in the
     * DbTargetGlobal store.
     */    return t.key = "targetGlobalKey", t.store = "targetGlobal", t;
}(), pr = /** @class */ function() {
    function t(
    /**
     * The collectionId (e.g. 'messages')
     */
    t, 
    /**
     * The path to the parent (either a document location or an empty path for
     * a root-level collection).
     */
    n) {
        this.collectionId = t, this.parent = n;
    }
    /** Name of the IndexedDb object store. */    return t.store = "collectionParents", 
    /** Keys are automatically assigned via the collectionId, parent properties. */
    t.keyPath = [ "collectionId", "parent" ], t;
}();

/**
 * An object representing an association between a target and a document, or a
 * sentinel row marking the last sequence number at which a document was used.
 * Each document cached must have a corresponding sentinel row before lru
 * garbage collection is enabled.
 *
 * The target associations and sentinel rows are co-located so that orphaned
 * documents and their sequence numbers can be identified efficiently via a scan
 * of this store.
 */ function gr(t) {
    t.createObjectStore(wr.store, {
        keyPath: wr.keyPath
    }).createIndex(wr.documentTargetsIndex, wr.documentTargetsKeyPath, {
        unique: !0
    }), 
    // NOTE: This is unique only because the TargetId is the suffix.
    t.createObjectStore(vr.store, {
        keyPath: vr.keyPath
    }).createIndex(vr.queryTargetsIndexName, vr.queryTargetsKeyPath, {
        unique: !0
    }), t.createObjectStore(mr.store);
}

var br = /** @class */ function() {
    function t(
    // Note: Previous schema versions included a field
    // "lastProcessedDocumentChangeId". Don't use anymore.
    /** The auto-generated client id assigned at client startup. */
    t, 
    /** The last time this state was updated. */
    n, 
    /** Whether the client's network connection is enabled. */
    i, 
    /** Whether this client is running in a foreground tab. */
    e) {
        this.clientId = t, this.updateTimeMs = n, this.networkEnabled = i, this.inForeground = e;
    }
    /** Name of the IndexedDb object store. */    return t.store = "clientMetadata", 
    /** Keys are automatically assigned via the clientId properties. */
    t.keyPath = "clientId", t;
}();

var yr = [ or.store, hr.store, cr.store, lr.store, vr.store, sr.store, mr.store, wr.store ], _r = n(yr, [ br.store ]), Ir = n(_r, [ dr.store ]), Tr = n(Ir, [ pr.store ]), Er = /** @class */ function() {
    function t() {
        /**
         * An in-memory copy of the index entries we've already written since the SDK
         * launched. Used to avoid re-writing the same entry repeatedly.
         *
         * This is *NOT* a complete cache of what's in persistence and so can never be used to
         * satisfy reads.
         */
        this._a = new ir;
    }
    /**
     * Adds a new entry to the collection parent index.
     *
     * Repeated calls for the same collectionPath should be avoided within a
     * transaction as IndexedDbIndexManager only caches writes once a transaction
     * has been committed.
     */    return t.prototype.Ao = function(t, n) {
        var i = this;
        if (C(n.length % 2 == 1, "Expected a collection path."), !this._a.has(n)) {
            var e = n.X(), r = n.H();
            t.Ws((function() {
                // Add the collection to the in memory cache only if the transaction was
                // successfully committed.
                i._a.add(n);
            }));
            var u = {
                collectionId: e,
                parent: re(r)
            };
            return Rr(t).put(u);
        }
        return de.resolve();
    }, t.prototype.sh = function(t, n) {
        var i = [], e = IDBKeyRange.bound([ n, "" ], [ O(n), "" ], 
        /*lowerOpen=*/ !1, 
        /*upperOpen=*/ !0);
        return Rr(t).ho(e).next((function(t) {
            for (var e = 0, r = t; e < r.length; e++) {
                var u = r[e];
                // This collectionId guard shouldn't be necessary (and isn't as long
                // as we're running in a real browser), but there's a bug in
                // indexeddbshim that breaks our range in our tests running in node:
                // https://github.com/axemclion/IndexedDBShim/issues/334
                                if (u.collectionId !== n) break;
                i.push(oe(u.parent));
            }
            return i;
        }));
    }, t;
}();

// V2 is no longer usable (see comment at top of file)
// Visible for testing
/**
 * Helper to get a typed SimpleDbStore for the collectionParents
 * document store.
 */
function Rr(t) {
    return Sr.Zs(t, pr.store);
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** Serializer for values stored in the LocalStore. */ var Ar = /** @class */ function() {
    function t(t) {
        this.Ia = t;
    }
    /** Decodes a remote document from storage locally to a Document. */    return t.prototype.da = function(t) {
        if (t.document) return this.Ia.Rr(t.document, !!t.hasCommittedMutations);
        if (t.noDocument) {
            var n = Rt.at(t.noDocument.path), i = this.Ta(t.noDocument.readTime);
            return new gn(n, i, {
                hasCommittedMutations: !!t.hasCommittedMutations
            });
        }
        if (t.unknownDocument) {
            n = Rt.at(t.unknownDocument.path), i = this.Ta(t.unknownDocument.version);
            return new bn(n, i);
        }
        return S("Unexpected DbRemoteDocument");
    }, 
    /** Encodes a document for storage locally. */
    t.prototype.ba = function(t, n) {
        var i = this.la(n), e = t.key.path.H().tt();
        if (t instanceof pn) {
            var r = t.proto ? t.proto : this.Ia.Er(t), u = t.hasCommittedMutations;
            return new lr(
            /* unknownDocument= */ null, 
            /* noDocument= */ null, r, u, i, e);
        }
        if (t instanceof gn) {
            var s = t.key.path.tt(), o = this.Ea(t.version);
            u = t.hasCommittedMutations;
            return new lr(
            /* unknownDocument= */ null, new ar(s, o), 
            /* document= */ null, u, i, e);
        }
        if (t instanceof bn) {
            s = t.key.path.tt();
            var h = this.Ea(t.version);
            return new lr(new fr(s, h), 
            /* noDocument= */ null, 
            /* document= */ null, 
            /* hasCommittedMutations= */ !0, i, e);
        }
        return S("Unexpected MaybeDocument");
    }, t.prototype.la = function(t) {
        var n = t.q();
        return [ n.seconds, n.nanoseconds ];
    }, t.prototype.va = function(t) {
        var n = new bt(t[0], t[1]);
        return yt.L(n);
    }, t.prototype.Ea = function(t) {
        var n = t.q();
        return new ur(n.seconds, n.nanoseconds);
    }, t.prototype.Ta = function(t) {
        var n = new bt(t.seconds, t.nanoseconds);
        return yt.L(n);
    }, 
    /** Encodes a batch of mutations into a DbMutationBatch for local storage. */
    t.prototype.Ro = function(t, n) {
        var i = this, e = n.baseMutations.map((function(t) {
            return i.Ia.Or(t);
        })), r = n.mutations.map((function(t) {
            return i.Ia.Or(t);
        }));
        return new hr(t, n.batchId, n.Fn.toMillis(), e, r);
    }, 
    /** Decodes a DbMutationBatch into a MutationBatch */
    t.prototype.Po = function(t) {
        var n = this, i = (t.baseMutations || []).map((function(t) {
            return n.Ia.Ur(t);
        })), e = t.mutations.map((function(t) {
            return n.Ia.Ur(t);
        })), r = bt.fromMillis(t.localWriteTimeMs);
        return new he(t.batchId, r, i, e);
    }, 
    /*
     * Encodes a set of document keys into an array of EncodedResourcePaths.
     */
    t.prototype.Ra = function(t) {
        var n = [];
        return t.forEach((function(t) {
            n.push(re(t.path));
        })), n;
    }, 
    /** Decodes an array of EncodedResourcePaths into a set of document keys. */
    t.prototype.Aa = function(t) {
        for (var n = di(), i = 0, e = t; i < e.length; i++) {
            var r = e[i];
            n = n.add(new Rt(oe(r)));
        }
        return n;
    }, 
    /** Decodes a DbTarget into TargetData */
    t.prototype.na = function(t) {
        var n, i = this.Ta(t.readTime), e = void 0 !== t.lastLimboFreeSnapshotVersion ? this.Ta(t.lastLimboFreeSnapshotVersion) : yt.MIN;
        return n = void 0 !== t.query.documents ? this.Ia.Wr(t.query) : this.Ia.Yr(t.query), 
        new ti(n, t.targetId, Kn.Ci, t.lastListenSequenceNumber, i, e, Jn.fromBase64String(t.resumeToken));
    }, 
    /** Encodes TargetData into a DbTarget for storage locally. */
    t.prototype.ia = function(t) {
        C(Kn.Ci === t.ki, "Only queries with purpose " + Kn.Ci + " may be stored, got " + t.ki);
        var n, i = this.Ea(t.Oi), e = this.Ea(t.lastLimboFreeSnapshotVersion);
        n = t.target.Gn() ? this.Ia.Gr(t.target) : this.Ia.zr(t.target);
        // We can't store the resumeToken as a ByteString in IndexedDb, so we
        // convert it to a base64 string for storage.
                var r = t.resumeToken.toBase64();
        // lastListenSequenceNumber is always 0 until we do real GC.
                return new vr(t.targetId, t.target.canonicalId(), i, r, t.sequenceNumber, e, n);
    }, t;
}();

/**
 * A helper function for figuring out what kind of query has been stored.
 */
/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Dr = "Another tab has exclusive access to the persistence layer. To allow shared access, make sure to invoke `enablePersistence()` with `synchronizeTabs:true` in all tabs.", Pr = /** @class */ function(t) {
    function n(n, i) {
        var e = t.call(this) || this;
        return e.Uo = n, e.qh = i, e;
    }
    return i(n, t), n;
}(me), Sr = /** @class */ function() {
    function t(n, i, e, r, u, s, o, h) {
        if (this.allowTabSynchronization = n, this.persistenceKey = i, this.clientId = e, 
        this.Da = s, this.Pa = h, this.Sa = !1, this.isPrimary = !1, this.networkEnabled = !0, 
        /** Our window.unload handler, if registered. */
        this.Ca = null, this.inForeground = !1, 
        /** Our 'visibilitychange' listener if registered. */
        this.Va = null, 
        /** The client metadata refresh task. */
        this.Na = null, 
        /** The last time we garbage collected the client metadata object store. */
        this.ka = Number.NEGATIVE_INFINITY, 
        /** A listener to notify on primary state changes. */
        this.Oa = function(t) {
            return Promise.resolve();
        }, this.wo = new Nr(this, u), this.Fa = i + t.xa, this.serializer = new Ar(o), this.document = r.document, 
        this.Ih = new We(this.wo, this.serializer), this.vo = new Er, this.Jo = new Ye(this.serializer, this.vo), 
        !r.window || !r.window.localStorage) throw new B(L.UNIMPLEMENTED, "IndexedDB persistence is only available on platforms that support LocalStorage.");
        this.window = r.window, this.ja = this.window.localStorage;
    }
    return t.Zs = function(t, n) {
        if (t instanceof Pr) return pe.Zs(t.Uo, n);
        throw S("IndexedDbPersistence must use instances of IndexedDbTransaction");
    }, t.Ua = function(n) {
        return r(this, void 0, void 0, (function() {
            var i;
            return u(this, (function(e) {
                switch (e.label) {
                  case 0:
                    if (!t.Js()) throw new B(L.UNIMPLEMENTED, "This platform is either missing IndexedDB or is known to have an incomplete implementation. Offline persistence has been disabled.");
                    return [ 4 /*yield*/ , (i = new t(n.allowTabSynchronization, n.persistenceKey, n.clientId, n.platform, n.La, n.Da, n.serializer, n.Pa)).start() ];

                  case 1:
                    return e.sent(), [ 2 /*return*/ , i ];
                }
            }));
        }));
    }, 
    /**
     * Attempt to start IndexedDb persistence.
     *
     * @return {Promise<void>} Whether persistence was enabled.
     */
    t.prototype.start = function() {
        var t = this;
        return C(!this.ph, "IndexedDbPersistence double-started!"), C(null !== this.window, "Expected 'window' to be defined"), 
        pe.Hs(this.Fa, er, new rr(this.serializer)).then((function(n) {
            // NOTE: This is expected to fail sometimes (in the case of another tab already
            // having the persistence lock), so it's the first thing we should do.
            return t.Ba = n, t.Ma();
        })).then((function() {
            return t.qa(), t.Qa(), t.Ga(), t.Ba.runTransaction("readonly-idempotent", [ mr.store ], (function(t) {
                return He(t);
            }));
        })).then((function(n) {
            t.Wa = new Yi(n, t.Pa);
        })).then((function() {
            t.Sa = !0;
        })).catch((function(n) {
            return t.Ba && t.Ba.close(), Promise.reject(n);
        }));
    }, t.prototype.za = function(t) {
        var n = this;
        return this.Oa = function(i) {
            return r(n, void 0, void 0, (function() {
                return u(this, (function(n) {
                    return this.ph ? [ 2 /*return*/ , t(i) ] : [ 2 /*return*/ ];
                }));
            }));
        }, t(this.isPrimary);
    }, t.prototype.Ka = function(t) {
        var n = this;
        this.Ba.to((function(i) {
            return r(n, void 0, void 0, (function() {
                return u(this, (function(n) {
                    switch (n.label) {
                      case 0:
                        return null !== i.newVersion ? [ 3 /*break*/ , 2 ] : [ 4 /*yield*/ , t() ];

                      case 1:
                        n.sent(), n.label = 2;

                      case 2:
                        return [ 2 /*return*/ ];
                    }
                }));
            }));
        }));
    }, t.prototype.hc = function(t) {
        var n = this;
        this.networkEnabled !== t && (this.networkEnabled = t, 
        // Schedule a primary lease refresh for immediate execution. The eventual
        // lease update will be propagated via `primaryStateListener`.
        this.Da.Uu((function() {
            return r(n, void 0, void 0, (function() {
                return u(this, (function(t) {
                    switch (t.label) {
                      case 0:
                        return this.ph ? [ 4 /*yield*/ , this.Ma() ] : [ 3 /*break*/ , 2 ];

                      case 1:
                        t.sent(), t.label = 2;

                      case 2:
                        return [ 2 /*return*/ ];
                    }
                }));
            }));
        })));
    }, 
    /**
     * Updates the client metadata in IndexedDb and attempts to either obtain or
     * extend the primary lease for the local client. Asynchronously notifies the
     * primary state listener if the client either newly obtained or released its
     * primary lease.
     */
    t.prototype.Ma = function() {
        var t = this;
        return this.Ba.runTransaction("readwrite-idempotent", Tr, (function(n) {
            return Vr(n).put(new br(t.clientId, Date.now(), t.networkEnabled, t.inForeground)).next((function() {
                if (t.isPrimary) return t.Ha(n).next((function(n) {
                    n || (t.isPrimary = !1, t.Da.Uu((function() {
                        return t.Oa(!1);
                    })));
                }));
            })).next((function() {
                return t.Ja(n);
            })).next((function(i) {
                return t.isPrimary && !i ? t.Ya(n).next((function() {
                    return !1;
                })) : !!i && t.Xa(n).next((function() {
                    return !0;
                }));
            }));
        })).catch((function(n) {
            if (!t.allowTabSynchronization) throw n;
            return A("IndexedDbPersistence", "Releasing owner lease after error during lease refresh", n), 
            /* isPrimary= */ !1;
        })).then((function(n) {
            t.isPrimary !== n && t.Da.Uu((function() {
                return t.Oa(n);
            })), t.isPrimary = n;
        }));
    }, t.prototype.Ha = function(t) {
        var n = this;
        return Cr(t).get(sr.key).next((function(t) {
            return de.resolve(n.$a(t));
        }));
    }, t.prototype.Za = function(t) {
        return Vr(t).delete(this.clientId);
    }, 
    /**
     * If the garbage collection threshold has passed, prunes the
     * RemoteDocumentChanges and the ClientMetadata store based on the last update
     * time of all clients.
     */
    t.prototype.tf = function() {
        return r(this, void 0, void 0, (function() {
            var n = this;
            return u(this, (function(i) {
                switch (i.label) {
                  case 0:
                    return !this.isPrimary || this.nf(this.ka, 18e5) ? [ 3 /*break*/ , 2 ] : (this.ka = Date.now(), 
                    [ 4 /*yield*/ , this.runTransaction("maybeGarbageCollectMultiClientState", "readwrite-primary-idempotent", (function(i) {
                        var e = t.Zs(i, br.store);
                        return e.ho().next((function(t) {
                            var i = n.if(t, 18e5), r = t.filter((function(t) {
                                return -1 === i.indexOf(t);
                            }));
                            // Delete metadata for clients that are no longer considered active.
                            return de.forEach(r, (function(t) {
                                return e.delete(t.clientId);
                            })).next((function() {
                                return r;
                            }));
                        }));
                    })).catch((function() {
                        // Ignore primary lease violations or any other type of error. The next
                        // primary will run `maybeGarbageCollectMultiClientState()` again.
                        // We don't use `ignoreIfPrimaryLeaseLoss()` since we don't want to depend
                        // on LocalStore.
                        return [];
                    })) ]);

                  case 1:
                    // Delete potential leftover entries that may continue to mark the
                    // inactive clients as zombied in LocalStorage.
                    // Ideally we'd delete the IndexedDb and LocalStorage zombie entries for
                    // the client atomically, but we can't. So we opt to delete the IndexedDb
                    // entries first to avoid potentially reviving a zombied client.
                    i.sent().forEach((function(t) {
                        n.window.localStorage.removeItem(n.ef(t.clientId));
                    })), i.label = 2;

                  case 2:
                    return [ 2 /*return*/ ];
                }
            }));
        }));
    }, 
    /**
     * Schedules a recurring timer to update the client metadata and to either
     * extend or acquire the primary lease if the client is eligible.
     */
    t.prototype.Ga = function() {
        var t = this;
        this.Na = this.Da.Xu(zi.Au, 4e3, (function() {
            return t.Ma().then((function() {
                return t.tf();
            })).then((function() {
                return t.Ga();
            }));
        }));
    }, 
    /** Checks whether `client` is the local client. */
    t.prototype.$a = function(t) {
        return !!t && t.ownerId === this.clientId;
    }, 
    /**
     * Evaluate the state of all active clients and determine whether the local
     * client is or can act as the holder of the primary lease. Returns whether
     * the client is eligible for the lease, but does not actually acquire it.
     * May return 'false' even if there is no active leaseholder and another
     * (foreground) client should become leaseholder instead.
     */
    t.prototype.Ja = function(t) {
        var n = this;
        return Cr(t).get(sr.key).next((function(i) {
            // A client is eligible for the primary lease if:
            // - its network is enabled and the client's tab is in the foreground.
            // - its network is enabled and no other client's tab is in the
            //   foreground.
            // - every clients network is disabled and the client's tab is in the
            //   foreground.
            // - every clients network is disabled and no other client's tab is in
            //   the foreground.
            if (null !== i && n.nf(i.leaseTimestampMs, 5e3) && !n.rf(i.ownerId)) {
                if (n.$a(i) && n.networkEnabled) return !0;
                if (!n.$a(i)) {
                    if (!i.allowTabSynchronization) 
                    // Fail the `canActAsPrimary` check if the current leaseholder has
                    // not opted into multi-tab synchronization. If this happens at
                    // client startup, we reject the Promise returned by
                    // `enablePersistence()` and the user can continue to use Firestore
                    // with in-memory persistence.
                    // If this fails during a lease refresh, we will instead block the
                    // AsyncQueue from executing further operations. Note that this is
                    // acceptable since mixing & matching different `synchronizeTabs`
                    // settings is not supported.
                    //
                    // TODO(b/114226234): Remove this check when `synchronizeTabs` can
                    // no longer be turned off.
                    throw new B(L.FAILED_PRECONDITION, Dr);
                    return !1;
                }
            }
            return !(!n.networkEnabled || !n.inForeground) || Vr(t).ho().next((function(t) {
                return void 0 === n.if(t, 5e3).find((function(t) {
                    if (n.clientId !== t.clientId) {
                        var i = !n.networkEnabled && t.networkEnabled, e = !n.inForeground && t.inForeground, r = n.networkEnabled === t.networkEnabled;
                        if (i || e && r) return !0;
                    }
                    return !1;
                }));
            }));
        })).next((function(t) {
            return n.isPrimary !== t && A("IndexedDbPersistence", "Client " + (t ? "is" : "is not") + " eligible for a primary lease."), 
            t;
        }));
    }, t.prototype.shutdown = function() {
        return r(this, void 0, void 0, (function() {
            var t = this;
            return u(this, (function(n) {
                switch (n.label) {
                  case 0:
                    // The shutdown() operations are idempotent and can be called even when
                    // start() aborted (e.g. because it couldn't acquire the persistence lease).
                    return this.Sa = !1, this.uf(), this.Na && (this.Na.cancel(), this.Na = null), this.sf(), 
                    this.hf(), [ 4 /*yield*/ , this.Ba.runTransaction("readwrite-idempotent", [ sr.store, br.store ], (function(n) {
                        return t.Ya(n).next((function() {
                            return t.Za(n);
                        }));
                    })) ];

                  case 1:
                    return n.sent(), this.Ba.close(), 
                    // Remove the entry marking the client as zombied from LocalStorage since
                    // we successfully deleted its metadata from IndexedDb.
                    this.cf(), [ 2 /*return*/ ];
                }
            }));
        }));
    }, 
    /**
     * Returns clients that are not zombied and have an updateTime within the
     * provided threshold.
     */
    t.prototype.if = function(t, n) {
        var i = this;
        return t.filter((function(t) {
            return i.nf(t.updateTimeMs, n) && !i.rf(t.clientId);
        }));
    }, t.prototype.sc = function() {
        var t = this;
        return this.Ba.runTransaction("readonly-idempotent", [ br.store ], (function(n) {
            return Vr(n).ho().next((function(n) {
                return t.if(n, 18e5).map((function(t) {
                    return t.clientId;
                }));
            }));
        }));
    }, t.clearPersistence = function(n) {
        return r(this, void 0, void 0, (function() {
            var i;
            return u(this, (function(e) {
                switch (e.label) {
                  case 0:
                    return t.Js() ? (i = n + t.xa, [ 4 /*yield*/ , pe.delete(i) ]) : [ 2 /*return*/ , Promise.resolve() ];

                  case 1:
                    return e.sent(), [ 2 /*return*/ ];
                }
            }));
        }));
    }, Object.defineProperty(t.prototype, "ph", {
        get: function() {
            return this.Sa;
        },
        enumerable: !0,
        configurable: !0
    }), t.prototype.bh = function(t) {
        return C(this.ph, "Cannot initialize MutationQueue before persistence is started."), 
        Ee.po(t, this.serializer, this.vo, this.wo);
    }, t.prototype.Th = function() {
        return C(this.ph, "Cannot initialize TargetCache before persistence is started."), 
        this.Ih;
    }, t.prototype._h = function() {
        return C(this.ph, "Cannot initialize RemoteDocumentCache before persistence is started."), 
        this.Jo;
    }, t.prototype.Rh = function() {
        return C(this.ph, "Cannot initialize IndexManager before persistence is started."), 
        this.vo;
    }, t.prototype.runTransaction = function(t, n, i) {
        var e = this;
        A("IndexedDbPersistence", "Starting transaction:", t);
        // TODO(schmidt-sebastian): Simplify once all transactions are idempotent.
        var r, u = n.endsWith("idempotent"), s = n.startsWith("readonly") ? u ? "readonly-idempotent" : "readonly" : u ? "readwrite-idempotent" : "readwrite";
        // Do all transactions as readwrite against all object stores, since we
        // are the only reader/writer.
        return this.Ba.runTransaction(s, Tr, (function(u) {
            return r = new Pr(u, e.Wa.next()), "readwrite-primary" === n || "readwrite-primary-idempotent" === n ? e.Ha(u).next((function(t) {
                return !!t || e.Ja(u);
            })).next((function(n) {
                if (!n) throw D("Failed to obtain primary lease for action '" + t + "'."), e.isPrimary = !1, 
                e.Da.Uu((function() {
                    return e.Oa(!1);
                })), new B(L.FAILED_PRECONDITION, we);
                return i(r);
            })).next((function(t) {
                return e.Xa(u).next((function() {
                    return t;
                }));
            })) : e.af(u).next((function() {
                return i(r);
            }));
        })).then((function(t) {
            return r.zs(), t;
        }));
    }, 
    /**
     * Verifies that the current tab is the primary leaseholder or alternatively
     * that the leaseholder has opted into multi-tab synchronization.
     */
    // TODO(b/114226234): Remove this check when `synchronizeTabs` can no longer
    // be turned off.
    t.prototype.af = function(t) {
        var n = this;
        return Cr(t).get(sr.key).next((function(t) {
            if (null !== t && n.nf(t.leaseTimestampMs, 5e3) && !n.rf(t.ownerId) && !n.$a(t) && !t.allowTabSynchronization) throw new B(L.FAILED_PRECONDITION, Dr);
        }));
    }, 
    /**
     * Obtains or extends the new primary lease for the local client. This
     * method does not verify that the client is eligible for this lease.
     */
    t.prototype.Xa = function(t) {
        var n = new sr(this.clientId, this.allowTabSynchronization, Date.now());
        return Cr(t).put(sr.key, n);
    }, t.Js = function() {
        return pe.Js();
    }, 
    /**
     * Generates a string used as a prefix when storing data in IndexedDB and
     * LocalStorage.
     */
    t.ff = function(t) {
        // Use two different prefix formats:
        //
        //   * firestore / persistenceKey / projectID . databaseID / ...
        //   * firestore / persistenceKey / projectID / ...
        //
        // projectIDs are DNS-compatible names and cannot contain dots
        // so there's no danger of collisions.
        var n = t.s.projectId;
        return t.s.o || (n += "." + t.s.database), "firestore/" + t.persistenceKey + "/" + n + "/";
    }, 
    /** Checks the primary lease and removes it if we are the current primary. */
    t.prototype.Ya = function(t) {
        var n = this, i = Cr(t);
        return i.get(sr.key).next((function(t) {
            return n.$a(t) ? (A("IndexedDbPersistence", "Releasing primary lease."), i.delete(sr.key)) : de.resolve();
        }));
    }, 
    /** Verifies that `updateTimeMs` is within `maxAgeMs`. */
    t.prototype.nf = function(t, n) {
        var i = Date.now();
        return !(t < i - n) && (!(t > i) || (D("Detected an update time that is in the future: " + t + " > " + i), 
        !1));
    }, t.prototype.qa = function() {
        var t = this;
        null !== this.document && "function" == typeof this.document.addEventListener && (this.Va = function() {
            t.Da.Uu((function() {
                return t.inForeground = "visible" === t.document.visibilityState, t.Ma();
            }));
        }, this.document.addEventListener("visibilitychange", this.Va), this.inForeground = "visible" === this.document.visibilityState);
    }, t.prototype.sf = function() {
        this.Va && (C(null !== this.document && "function" == typeof this.document.addEventListener, "Expected 'document.addEventListener' to be a function"), 
        this.document.removeEventListener("visibilitychange", this.Va), this.Va = null);
    }, 
    /**
     * Attaches a window.unload handler that will synchronously write our
     * clientId to a "zombie client id" location in LocalStorage. This can be used
     * by tabs trying to acquire the primary lease to determine that the lease
     * is no longer valid even if the timestamp is recent. This is particularly
     * important for the refresh case (so the tab correctly re-acquires the
     * primary lease). LocalStorage is used for this rather than IndexedDb because
     * it is a synchronous API and so can be used reliably from  an unload
     * handler.
     */
    t.prototype.Qa = function() {
        var t = this;
        "function" == typeof this.window.addEventListener && (this.Ca = function() {
            // Note: In theory, this should be scheduled on the AsyncQueue since it
            // accesses internal state. We execute this code directly during shutdown
            // to make sure it gets a chance to run.
            t.uf(), t.Da.Uu((function() {
                // Attempt graceful shutdown (including releasing our primary lease),
                // but there's no guarantee it will complete.
                return t.shutdown();
            }));
        }, this.window.addEventListener("unload", this.Ca));
    }, t.prototype.hf = function() {
        this.Ca && (C("function" == typeof this.window.removeEventListener, "Expected 'window.removeEventListener' to be a function"), 
        this.window.removeEventListener("unload", this.Ca), this.Ca = null);
    }, 
    /**
     * Returns whether a client is "zombied" based on its LocalStorage entry.
     * Clients become zombied when their tab closes without running all of the
     * cleanup logic in `shutdown()`.
     */
    t.prototype.rf = function(t) {
        try {
            var n = null !== this.ja.getItem(this.ef(t));
            return A("IndexedDbPersistence", "Client '" + t + "' " + (n ? "is" : "is not") + " zombied in LocalStorage"), 
            n;
        } catch (t) {
            // Gracefully handle if LocalStorage isn't working.
            return D("IndexedDbPersistence", "Failed to get zombied client id.", t), !1;
        }
    }, 
    /**
     * Record client as zombied (a client that had its tab closed). Zombied
     * clients are ignored during primary tab selection.
     */
    t.prototype.uf = function() {
        try {
            this.ja.setItem(this.ef(this.clientId), String(Date.now()));
        } catch (t) {
            // Gracefully handle if LocalStorage isn't available / working.
            D("Failed to set zombie client id.", t);
        }
    }, 
    /** Removes the zombied client entry if it exists. */
    t.prototype.cf = function() {
        try {
            this.ja.removeItem(this.ef(this.clientId));
        } catch (t) {
            // Ignore
        }
    }, t.prototype.ef = function(t) {
        return "firestore_zombie_" + this.persistenceKey + "_" + t;
    }, 
    /**
     * The name of the main (and currently only) IndexedDB database. this name is
     * appended to the prefix provided to the IndexedDbPersistence constructor.
     */
    t.xa = "main", t;
}();

/**
 * Oldest acceptable age in milliseconds for client metadata before the client
 * is considered inactive and its associated data is garbage collected.
 */
/**
 * Helper to get a typed SimpleDbStore for the primary client object store.
 */
function Cr(t) {
    return t.store(sr.store);
}

/**
 * Helper to get a typed SimpleDbStore for the client metadata object store.
 */ function Vr(t) {
    return t.store(br.store);
}

/** Provides LRU functionality for IndexedDB persistence. */ var Nr = /** @class */ function() {
    function t(t, n) {
        this.db = t, this.lf = null, this.kc = new Ge(this, n);
    }
    return t.prototype.Bc = function(t) {
        var n = this.df(t);
        return this.db.Th().ea(t).next((function(t) {
            return n.next((function(n) {
                return t + n;
            }));
        }));
    }, t.prototype.df = function(t) {
        var n = 0;
        return this.qc(t, (function(t) {
            n++;
        })).next((function() {
            return n;
        }));
    }, t.prototype.Be = function(t, n) {
        return this.db.Th().Be(t, n);
    }, t.prototype.qc = function(t, n) {
        return this.vf(t, (function(t, i) {
            return n(i);
        }));
    }, t.prototype.gh = function(t) {
        this.lf = t;
    }, t.prototype.ls = function(t, n) {
        return kr(t, n);
    }, t.prototype.vs = function(t, n) {
        return kr(t, n);
    }, t.prototype.Qc = function(t, n, i) {
        return this.db.Th().Qc(t, n, i);
    }, t.prototype.Bo = function(t, n) {
        return kr(t, n);
    }, 
    /**
     * Returns true if anything would prevent this document from being garbage
     * collected, given that the document in question is not present in any
     * targets and has a sequence number less than or equal to the upper bound for
     * the collection run.
     */
    t.prototype.wf = function(t, n) {
        return this.lf.ys(n) ? de.resolve(!0) : function(t, n) {
            var i = !1;
            return Se(t).do((function(e) {
                return Re(t, e, n).next((function(t) {
                    return t && (i = !0), de.resolve(!t);
                }));
            })).next((function() {
                return i;
            }));
        }(t, n);
    }, t.prototype.Gc = function(t, n) {
        var i = this, e = this.db._h().Oh(), r = [], u = 0;
        return this.vf(t, (function(s, o) {
            if (o <= n) {
                var h = i.wf(t, s).next((function(n) {
                    if (!n) 
                    // Our size accounting requires us to read all documents before
                    // removing them.
                    return u++, e.Bs(t, s).next((function() {
                        return e.Ls(s), Je(t).delete([ 0, re(s.path) ]);
                    }));
                }));
                r.push(h);
            }
        })).next((function() {
            return de.Ns(r);
        })).next((function() {
            return e.apply(t);
        })).next((function() {
            return u;
        }));
    }, t.prototype.removeTarget = function(t, n) {
        var i = n.Fi(t.qh);
        return this.db.Th().Gh(t, i);
    }, t.prototype.Wh = function(t, n) {
        return kr(t, n);
    }, 
    /**
     * Call provided function for each document in the cache that is 'orphaned'. Orphaned
     * means not a part of any target, so the only entry in the target-document index for
     * that document will be the sentinel row (targetId 0), which will also have the sequence
     * number for the last time the document was accessed.
     */
    t.prototype.vf = function(t, n) {
        var i, e = Je(t), r = Yi.bu;
        return e.lo({
            index: wr.documentTargetsIndex
        }, (function(t, e) {
            var u = t[0], s = (t[1], e.path), o = e.sequenceNumber;
            0 === u ? (
            // if nextToReport is valid, report it, this is a new key so the
            // last one must not be a member of any targets.
            r !== Yi.bu && n(new Rt(oe(i)), r), 
            // set nextToReport to be this sequence number. It's the next one we
            // might report, if we don't find any targets for this document.
            // Note that the sequence number must be defined when the targetId
            // is 0.
            r = o, i = s) : 
            // set nextToReport to be invalid, we know we don't need to report
            // this one since we found a target for it.
            r = Yi.bu;
        })).next((function() {
            // Since we report sequence numbers after getting to the next key, we
            // need to check if the last key we iterated over was an orphaned
            // document and report it.
            r !== Yi.bu && n(new Rt(oe(i)), r);
        }));
    }, t.prototype.Wc = function(t) {
        return this.db._h().ma(t);
    }, t;
}();

function kr(t, n) {
    return Je(t).put(
    /**
 * @return A value suitable for writing a sentinel row in the target-document
 * store.
 */
    function(t, n) {
        return new wr(0, re(t.path), n);
    }(n, t.qh));
}

/**
 * @license
 * Copyright 2019 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// TOOD(b/140938512): Drop SimpleQueryEngine and rename IndexFreeQueryEngine.
/**
 * A query engine that takes advantage of the target document mapping in the
 * QueryCache. The IndexFreeQueryEngine optimizes query execution by only
 * reading the documents that previously matched a query plus any documents that were
 * edited after the query was last listened to.
 *
 * There are some cases where Index-Free queries are not guaranteed to produce
 * the same results as full collection scans. In these cases, the
 * IndexFreeQueryEngine falls back to full query processing. These cases are:
 *
 * - Limit queries where a document that matched the query previously no longer
 *   matches the query.
 *
 * - Limit queries where a document edit may cause the document to sort below
 *   another document that is in the local cache.
 *
 * - Queries that have never been CURRENT or free of Limbo documents.
 */ var Or = /** @class */ function() {
    function t() {}
    return t.prototype.Ah = function(t) {
        this.mf = t;
    }, t.prototype.ih = function(t, n, i, e) {
        var r = this;
        // Queries that match all documents don't benefit from using
        // IndexFreeQueries. It is more efficient to scan all documents in a
        // collection, rather than to perform individual lookups.
        return C(void 0 !== this.mf, "setLocalDocumentsView() not called"), n.ci() ? this.pf(t, n) : 
        // Queries that have never seen a snapshot without limbo free documents
        // should also be run as a full collection scan.
        i.isEqual(yt.MIN) ? this.pf(t, n) : this.mf.th(t, e).next((function(u) {
            var s = r.gf(n, u);
            return (n.mi() || n.pi()) && r.bf(n.Hn, s, e, i) ? r.pf(t, n) : (E() <= _.DEBUG && A("IndexFreeQueryEngine", "Re-using previous result from %s to execute query: %s", i.toString(), n.toString()), 
            r.mf.ih(t, n, i).next((function(t) {
                // We merge `previousResults` into `updateResults`, since
                // `updateResults` is already a DocumentMap. If a document is
                // contained in both lists, then its contents are the same.
                return s.forEach((function(n) {
                    t = t.lt(n.key, n);
                })), t;
            })));
        }));
    }, 
    /** Applies the query filter and sorting to the provided documents.  */
    t.prototype.gf = function(t, n) {
        // Sort the documents and re-apply the query filter since previously
        // matching documents do not necessarily still match the query.
        var i = new Ct((function(n, i) {
            return t.fi(n, i);
        }));
        return n.forEach((function(n, e) {
            e instanceof pn && t.matches(e) && (i = i.add(e));
        })), i;
    }, 
    /**
     * Determines if a limit query needs to be refilled from cache, making it
     * ineligible for index-free execution.
     *
     * @param sortedPreviousResults The documents that matched the query when it
     * was last synchronized, sorted by the query's comparator.
     * @param remoteKeys The document keys that matched the query at the last
     * snapshot.
     * @param limboFreeSnapshotVersion The version of the snapshot when the query
     * was last synchronized.
     */
    t.prototype.bf = function(t, n, i, e) {
        // The query needs to be refilled if a previously matching document no
        // longer matches.
        if (i.size !== n.size) return !0;
        // Limit queries are not eligible for index-free query execution if there is
        // a potential that an older document from cache now sorts before a document
        // that was previously part of the limit. This, however, can only happen if
        // the document at the edge of the limit goes out of limit.
        // If a document that is not the limit boundary sorts differently,
        // the boundary of the limit itself did not change and documents from cache
        // will continue to be "rejected" by this boundary. Therefore, we can ignore
        // any modifications that don't affect the last document.
                var r = t === An.Wn ? n.last() : n.first();
        return !!r && (r.hasPendingWrites || r.version.h(e) > 0);
    }, t.prototype.pf = function(t, n) {
        return E() <= _.DEBUG && A("IndexFreeQueryEngine", "Using full collection scan to execute query: %s", n.toString()), 
        this.mf.ih(t, n, yt.MIN);
    }, t;
}(), Fr = /** @class */ function() {
    function t(t, n) {
        this.vo = t, this.wo = n, 
        /**
         * The set of all mutations that have been sent but not yet been applied to
         * the backend.
         */
        this.Yo = [], 
        /** Next value to use when assigning sequential IDs to each mutation batch. */
        this.yf = 1, 
        /** The last received stream token from the server, used to acknowledge which
         * responses the client has processed. Stream tokens are opaque checkpoint
         * markers whose only real value is their inclusion in the next request.
         */
        this.lastStreamToken = Jn.Si, 
        /** An ordered mapping between documents and the mutations batch IDs. */
        this._f = new Ct(fe.Un);
    }
    return t.prototype.bo = function(t) {
        return de.resolve(0 === this.Yo.length);
    }, t.prototype.yo = function(t, n, i) {
        var e = n.batchId, r = this.If(e, "acknowledged");
        C(0 === r, "Can only acknowledge the first batch in the mutation queue");
        // Verify that the batch in the queue is the one to be acknowledged.
        var u = this.Yo[r];
        return C(e === u.batchId, "Queue ordering failure: expected batch " + e + ", got batch " + u.batchId), 
        this.lastStreamToken = i, de.resolve();
    }, t.prototype.Io = function(t) {
        return de.resolve(this.lastStreamToken);
    }, t.prototype.To = function(t, n) {
        return this.lastStreamToken = n, de.resolve();
    }, t.prototype.Eo = function(t, n, i, e) {
        C(0 !== e.length, "Mutation batches should not be empty");
        var r = this.yf;
        (this.yf++, this.Yo.length > 0) && C(this.Yo[this.Yo.length - 1].batchId < r, "Mutation batchIDs must be monotonically increasing order");
        var u = new he(r, n, i, e);
        this.Yo.push(u);
        // Track references by document key and index collection parents.
        for (var s = 0, o = e; s < o.length; s++) {
            var h = o[s];
            this._f = this._f.add(new fe(h.key, r)), this.vo.Ao(t, h.key.path.H());
        }
        return de.resolve(u);
    }, t.prototype.Do = function(t, n) {
        return de.resolve(this.Tf(n));
    }, t.prototype.So = function(t, n) {
        var i = this.Tf(n);
        return C(null != i, "Failed to find local mutation batch."), de.resolve(i.keys());
    }, t.prototype.Co = function(t, n) {
        var i = n + 1, e = this.Ef(i), r = e < 0 ? 0 : e;
        // The requested batchId may still be out of range so normalize it to the
        // start of the queue.
                return de.resolve(this.Yo.length > r ? this.Yo[r] : null);
    }, t.prototype.Vo = function() {
        return de.resolve(0 === this.Yo.length ? -1 : this.yf - 1);
    }, t.prototype.No = function(t) {
        return de.resolve(this.Yo.slice());
    }, t.prototype.ko = function(t, n) {
        var i = this, e = new fe(n, 0), r = new fe(n, Number.POSITIVE_INFINITY), u = [];
        return this._f.Lt([ e, r ], (function(t) {
            C(n.isEqual(t.key), "Should only iterate over a single key's batches");
            var e = i.Tf(t._s);
            C(null !== e, "Batches in the index must exist in the main table"), u.push(e);
        })), de.resolve(u);
    }, t.prototype.Oo = function(t, n) {
        var i = this, e = new Ct(N);
        return n.forEach((function(t) {
            var n = new fe(t, 0), r = new fe(t, Number.POSITIVE_INFINITY);
            i._f.Lt([ n, r ], (function(n) {
                C(t.isEqual(n.key), "For each key, should only iterate over a single key's batches"), 
                e = e.add(n._s);
            }));
        })), de.resolve(this.Rf(e));
    }, t.prototype.xo = function(t, n) {
        C(!n.bi(), "CollectionGroup queries should be handled in LocalDocumentsView");
        // Use the query path as a prefix for testing if a document matches the
        // query.
        var i = n.path, e = i.length + 1, r = i;
        Rt.ht(r) || (r = r.child(""));
        var u = new fe(new Rt(r), 0), s = new Ct(N);
        // Find unique batchIDs referenced by all documents potentially matching the
        // query.
                return this._f.Bt((function(t) {
            var n = t.key.path;
            return !!i.$(n) && (
            // Rows with document keys more than one segment longer than the query
            // path can't be matches. For example, a query on 'rooms' can't match
            // the document /rooms/abc/messages/xyx.
            // TODO(mcg): we'll need a different scanner when we implement
            // ancestor queries.
            n.length === e && (s = s.add(t._s)), !0);
        }), u), de.resolve(this.Rf(s));
    }, t.prototype.Rf = function(t) {
        var n = this, i = [];
        // Construct an array of matching batches, sorted by batchID to ensure that
        // multiple mutations affecting the same document key are applied in order.
                return t.forEach((function(t) {
            var e = n.Tf(t);
            null !== e && i.push(e);
        })), i;
    }, t.prototype.jo = function(t, n) {
        var i = this;
        // Find the position of the first batch for removal. This need not be the
        // first entry in the queue.
                C(0 === this.If(n.batchId, "removed"), "Can only remove the first entry of the mutation queue"), 
        this.Yo.shift();
        var e = this._f;
        return de.forEach(n.mutations, (function(r) {
            var u = new fe(r.key, n.batchId);
            return e = e.delete(u), i.wo.Bo(t, r.key);
        })).next((function() {
            i._f = e;
        }));
    }, t.prototype.Lo = function(t) {
        // No-op since the memory mutation queue does not maintain a separate cache.
    }, t.prototype.ys = function(t, n) {
        var i = new fe(n, 0), e = this._f.Mt(i);
        return de.resolve(n.isEqual(e && e.key));
    }, t.prototype.Mo = function(t) {
        return 0 === this.Yo.length && C(this._f.J(), "Document leak -- detected dangling mutation references when queue is empty."), 
        de.resolve();
    }, 
    /**
     * Finds the index of the given batchId in the mutation queue and asserts that
     * the resulting index is within the bounds of the queue.
     *
     * @param batchId The batchId to search for
     * @param action A description of what the caller is doing, phrased in passive
     * form (e.g. "acknowledged" in a routine that acknowledges batches).
     */
    t.prototype.If = function(t, n) {
        var i = this.Ef(t);
        return C(i >= 0 && i < this.Yo.length, "Batches must exist to be " + n), i;
    }, 
    /**
     * Finds the index of the given batchId in the mutation queue. This operation
     * is O(1).
     *
     * @return The computed index of the batch with the given batchId, based on
     * the state of the queue. Note this index can be negative if the requested
     * batchId has already been remvoed from the queue or past the end of the
     * queue if the batchId is larger than the last added batch.
     */
    t.prototype.Ef = function(t) {
        return 0 === this.Yo.length ? 0 : t - this.Yo[0].batchId;
        // Examine the front of the queue to figure out the difference between the
        // batchId and indexes in the array. Note that since the queue is ordered
        // by batchId, if the first batch has a larger batchId then the requested
        // batchId doesn't exist in the queue.
        }, 
    /**
     * A version of lookupMutationBatch that doesn't return a promise, this makes
     * other functions that uses this code easier to read and more efficent.
     */
    t.prototype.Tf = function(t) {
        var n = this.Ef(t);
        if (n < 0 || n >= this.Yo.length) return null;
        var i = this.Yo[n];
        return C(i.batchId === t, "If found batch must match"), i;
    }, t;
}();

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ var xr, jr, Ur = /** @class */ function() {
    /**
     * @param sizer Used to assess the size of a document. For eager GC, this is expected to just
     * return 0 to avoid unnecessarily doing the work of calculating the size.
     */
    function t(t, n) {
        this.vo = t, this.Af = n, 
        /** Underlying cache of documents and their read times. */
        this.docs = new At(Rt.G), 
        /** Size of all cached documents. */
        this.size = 0;
    }
    /**
     * Adds the supplied entry to the cache and updates the cache size as appropriate.
     *
     * All calls of `addEntry`  are required to go through the RemoteDocumentChangeBuffer
     * returned by `newChangeBuffer()`.
     */    return t.prototype.js = function(t, n, i) {
        C(!i.isEqual(yt.MIN), "Cannot add a document with a read time of zero");
        var e = n.key, r = this.docs.get(e), u = r ? r.size : 0, s = this.Af(n);
        return this.docs = this.docs.lt(e, {
            oa: n,
            size: s,
            readTime: i
        }), this.size += s - u, this.vo.Ao(t, e.path.H());
    }, 
    /**
     * Removes the specified entry from the cache and updates the cache size as appropriate.
     *
     * All calls of `removeEntry` are required to go through the RemoteDocumentChangeBuffer
     * returned by `newChangeBuffer()`.
     */
    t.prototype.Ls = function(t) {
        var n = this.docs.get(t);
        n && (this.docs = this.docs.remove(t), this.size -= n.size);
    }, t.prototype.Bs = function(t, n) {
        var i = this.docs.get(n);
        return de.resolve(i ? i.oa : null);
    }, t.prototype.getEntries = function(t, n) {
        var i = this, e = oi();
        return n.forEach((function(t) {
            var n = i.docs.get(t);
            e = e.lt(t, n ? n.oa : null);
        })), de.resolve(e);
    }, t.prototype.ih = function(t, n, i) {
        C(!n.bi(), "CollectionGroup queries should be handled in LocalDocumentsView");
        for (var e = ci(), r = new Rt(n.path.child("")), u = this.docs.yt(r)
        // Documents are ordered by key, so we can use a prefix scan to narrow down
        // the documents we need to match the query against.
        ; u.At(); ) {
            var s = u.Rt(), o = s.key, h = s.value, c = h.oa, a = h.readTime;
            if (!n.path.$(o.path)) break;
            a.h(i) <= 0 || c instanceof pn && n.matches(c) && (e = e.lt(c.key, c));
        }
        return de.resolve(e);
    }, t.prototype.Df = function(t, n) {
        return de.forEach(this.docs, (function(t) {
            return n(t);
        }));
    }, t.prototype.lc = function(t, n) {
        throw new Error("getNewDocumentChanges() is not supported with MemoryPersistence");
    }, t.prototype.vc = function(t) {
        return de.resolve(yt.MIN);
    }, t.prototype.Oh = function(n) {
        // `trackRemovals` is ignores since the MemoryRemoteDocumentCache keeps
        // a separate changelog and does not need special handling for removals.
        return new t.wa(this);
    }, t.prototype.ma = function(t) {
        return de.resolve(this.size);
    }, 
    /**
     * Handles the details of adding and updating documents in the MemoryRemoteDocumentCache.
     */
    t.wa = /** @class */ function(t) {
        function n(n) {
            var i = t.call(this) || this;
            return i.pa = n, i;
        }
        return i(n, t), n.prototype.Qs = function(t) {
            var n = this, i = [];
            return this.Os.forEach((function(e, r) {
                r ? i.push(n.pa.js(t, r, n.readTime)) : n.pa.Ls(e);
            })), de.Ns(i);
        }, n.prototype.Ms = function(t, n) {
            return this.pa.Bs(t, n);
        }, n.prototype.qs = function(t, n) {
            return this.pa.getEntries(t, n);
        }, n;
    }(ve), t;
}(), Lr = /** @class */ function() {
    function t(t) {
        this.persistence = t, 
        /**
         * Maps a target to the data about that target
         */
        this.Pf = new le((function(t) {
            return t.canonicalId();
        })), 
        /** The last received snapshot version. */
        this.lastRemoteSnapshotVersion = yt.MIN, 
        /** The highest numbered target ID encountered. */
        this.highestTargetId = 0, 
        /** The highest sequence number encountered. */
        this.Sf = 0, 
        /**
         * A ordered bidirectional mapping between documents and the remote target
         * IDs.
         */
        this.Cf = new ae, this.targetCount = 0, this.Kc = ke.Ko();
    }
    return t.prototype.Be = function(t, n) {
        return this.Pf.forEach((function(t, i) {
            return n(i);
        })), de.resolve();
    }, t.prototype.Uh = function(t) {
        return de.resolve(this.lastRemoteSnapshotVersion);
    }, t.prototype.Yc = function(t) {
        return de.resolve(this.Sf);
    }, t.prototype.Zh = function(t) {
        var n = this.Kc.after(this.highestTargetId);
        return this.highestTargetId = n, de.resolve(n);
    }, t.prototype.zh = function(t, n, i) {
        return i && (this.lastRemoteSnapshotVersion = i), n > this.Sf && (this.Sf = n), 
        de.resolve();
    }, t.prototype.Xc = function(t) {
        this.Pf.set(t.target, t);
        var n = t.targetId;
        n > this.highestTargetId && (this.highestTargetId = n), t.sequenceNumber > this.Sf && (this.Sf = t.sequenceNumber);
    }, t.prototype.tc = function(t, n) {
        return C(!this.Pf.has(n.target), "Adding a target that already exists"), this.Xc(n), 
        this.targetCount += 1, de.resolve();
    }, t.prototype.Gh = function(t, n) {
        return C(this.Pf.has(n.target), "Updating a non-existent target"), this.Xc(n), de.resolve();
    }, t.prototype.Zc = function(t, n) {
        return C(this.targetCount > 0, "Removing a target from an empty cache"), C(this.Pf.has(n.target), "Removing a non-existent target from the cache"), 
        this.Pf.delete(n.target), this.Cf.ps(n.targetId), this.targetCount -= 1, de.resolve();
    }, t.prototype.Qc = function(t, n, i) {
        var e = this, r = 0, u = [];
        return this.Pf.forEach((function(s, o) {
            o.sequenceNumber <= n && null === i.get(o.targetId) && (e.Pf.delete(s), u.push(e.ta(t, o.targetId)), 
            r++);
        })), de.Ns(u).next((function() {
            return r;
        }));
    }, t.prototype.ea = function(t) {
        return de.resolve(this.targetCount);
    }, t.prototype.$h = function(t, n) {
        var i = this.Pf.get(n) || null;
        return de.resolve(i);
    }, t.prototype.Xe = function(t, n) {
        // This method is only needed for multi-tab and we can't implement it
        // efficiently without additional data structures.
        return S("Not yet implemented.");
    }, t.prototype.Mh = function(t, n, i) {
        this.Cf.ds(n, i);
        var e = this.persistence.wo, r = [];
        return e && n.forEach((function(n) {
            r.push(e.ls(t, n));
        })), de.Ns(r);
    }, t.prototype.Bh = function(t, n, i) {
        this.Cf.ms(n, i);
        var e = this.persistence.wo, r = [];
        return e && n.forEach((function(n) {
            r.push(e.vs(t, n));
        })), de.Ns(r);
    }, t.prototype.ta = function(t, n) {
        return this.Cf.ps(n), de.resolve();
    }, t.prototype.ec = function(t, n) {
        var i = this.Cf.bs(n);
        return de.resolve(i);
    }, t.prototype.ys = function(t, n) {
        return de.resolve(this.Cf.ys(n));
    }, t;
}(), Br = /** @class */ function() {
    /**
     * The constructor accepts a factory for creating a reference delegate. This
     * allows both the delegate and this instance to have strong references to
     * each other without having nullable fields that would then need to be
     * checked or asserted on every access.
     */
    function t(t, n) {
        var i = this;
        this.clientId = t, this.Vf = {}, this.Wa = new Yi(0), this.Sa = !1, this.Sa = !0, 
        this.wo = n(this), this.Ih = new Lr(this);
        this.vo = new nr, this.Jo = new Ur(this.vo, (function(t) {
            return i.wo.Nf(t);
        }));
    }
    return t.kf = function(n, i) {
        return new t(n, (function(t) {
            return new Qr(t, i);
        }));
    }, t.Of = function(n) {
        return new t(n, (function(t) {
            return new qr(t);
        }));
    }, t.prototype.shutdown = function() {
        // No durable state to ensure is closed on shutdown.
        return this.Sa = !1, Promise.resolve();
    }, Object.defineProperty(t.prototype, "ph", {
        get: function() {
            return this.Sa;
        },
        enumerable: !0,
        configurable: !0
    }), t.prototype.sc = function() {
        return r(this, void 0, void 0, (function() {
            return u(this, (function(t) {
                return [ 2 /*return*/ , [ this.clientId ] ];
            }));
        }));
    }, t.prototype.za = function(t) {
        // All clients using memory persistence act as primary.
        return t(!0);
    }, t.prototype.Ka = function() {
        // No op.
    }, t.prototype.hc = function(t) {
        // No op.
    }, t.prototype.Rh = function() {
        return this.vo;
    }, t.prototype.bh = function(t) {
        var n = this.Vf[t.v()];
        return n || (n = new Fr(this.vo, this.wo), this.Vf[t.v()] = n), n;
    }, t.prototype.Th = function() {
        return this.Ih;
    }, t.prototype._h = function() {
        return this.Jo;
    }, t.prototype.runTransaction = function(t, n, i) {
        var e = this;
        A("MemoryPersistence", "Starting transaction:", t);
        var r = new Mr(this.Wa.next());
        return this.wo.Ff(), i(r).next((function(t) {
            return e.wo.xf(r).next((function() {
                return t;
            }));
        })).Cs().then((function(t) {
            return r.zs(), t;
        }));
    }, t.prototype.jf = function(t, n) {
        return de.ks((i = this.Vf, e = [], Y(i, (function(t, n) {
            return e.push(n);
        })), e).map((function(i) {
            return function() {
                return i.ys(t, n);
            };
        })));
        var i, e;
    }, t;
}(), Mr = /** @class */ function(t) {
    function n(n) {
        var i = t.call(this) || this;
        return i.qh = n, i;
    }
    return i(n, t), n;
}(me), qr = /** @class */ function() {
    function t(t) {
        this.persistence = t, this.lf = null, this.Uf = null;
    }
    return Object.defineProperty(t.prototype, "Lf", {
        get: function() {
            if (this.Uf) return this.Uf;
            throw S("orphanedDocuments is only valid during a transaction.");
        },
        enumerable: !0,
        configurable: !0
    }), t.prototype.gh = function(t) {
        this.lf = t;
    }, t.prototype.ls = function(t, n) {
        return this.Lf.delete(n), de.resolve();
    }, t.prototype.vs = function(t, n) {
        return this.Lf.add(n), de.resolve();
    }, t.prototype.Bo = function(t, n) {
        return this.Lf.add(n), de.resolve();
    }, t.prototype.removeTarget = function(t, n) {
        var i = this, e = this.persistence.Th();
        return e.ec(t, n.targetId).next((function(t) {
            t.forEach((function(t) {
                return i.Lf.add(t);
            }));
        })).next((function() {
            return e.Zc(t, n);
        }));
    }, t.prototype.Ff = function() {
        this.Uf = new Set;
    }, t.prototype.xf = function(t) {
        var n = this, i = this.persistence._h().Oh();
        // Remove newly orphaned documents.
                return de.forEach(this.Lf, (function(e) {
            return n.Bf(t, e).next((function(t) {
                t || i.Ls(e);
            }));
        })).next((function() {
            return n.Uf = null, i.apply(t);
        }));
    }, t.prototype.Wh = function(t, n) {
        var i = this;
        return this.Bf(t, n).next((function(t) {
            t ? i.Lf.delete(n) : i.Lf.add(n);
        }));
    }, t.prototype.Nf = function(t) {
        // For eager GC, we don't care about the document size, there are no size thresholds.
        return 0;
    }, t.prototype.Bf = function(t, n) {
        var i = this;
        return de.ks([ function() {
            return i.persistence.Th().ys(t, n);
        }, function() {
            return i.persistence.jf(t, n);
        }, function() {
            return de.resolve(i.lf.ys(n));
        } ]);
    }, t;
}(), Qr = /** @class */ function() {
    function t(t, n) {
        this.persistence = t, this.lf = null, this.Mf = new le((function(t) {
            return re(t.path);
        })), this.kc = new Ge(this, n);
    }
    // No-ops, present so memory persistence doesn't have to care which delegate
    // it has.
        return t.prototype.Ff = function() {}, t.prototype.xf = function(t) {
        return de.resolve();
    }, t.prototype.Be = function(t, n) {
        return this.persistence.Th().Be(t, n);
    }, t.prototype.Bc = function(t) {
        var n = this.qf(t);
        return this.persistence.Th().ea(t).next((function(t) {
            return n.next((function(n) {
                return t + n;
            }));
        }));
    }, t.prototype.qf = function(t) {
        var n = 0;
        return this.qc(t, (function(t) {
            n++;
        })).next((function() {
            return n;
        }));
    }, t.prototype.qc = function(t, n) {
        var i = this;
        return de.forEach(this.Mf, (function(e, r) {
            // Pass in the exact sequence number as the upper bound so we know it won't be pinned by
            // being too recent.
            return i.wf(t, e, r).next((function(t) {
                return t ? de.resolve() : n(r);
            }));
        }));
    }, t.prototype.gh = function(t) {
        this.lf = t;
    }, t.prototype.Qc = function(t, n, i) {
        return this.persistence.Th().Qc(t, n, i);
    }, t.prototype.Gc = function(t, n) {
        var i = this, e = 0, r = this.persistence._h(), u = r.Oh();
        return r.Df(t, (function(r) {
            return i.wf(t, r, n).next((function(t) {
                t || (e++, u.Ls(r));
            }));
        })).next((function() {
            return u.apply(t);
        })).next((function() {
            return e;
        }));
    }, t.prototype.Bo = function(t, n) {
        return this.Mf.set(n, t.qh), de.resolve();
    }, t.prototype.removeTarget = function(t, n) {
        var i = n.Fi(t.qh);
        return this.persistence.Th().Gh(t, i);
    }, t.prototype.ls = function(t, n) {
        return this.Mf.set(n, t.qh), de.resolve();
    }, t.prototype.vs = function(t, n) {
        return this.Mf.set(n, t.qh), de.resolve();
    }, t.prototype.Wh = function(t, n) {
        return this.Mf.set(n, t.qh), de.resolve();
    }, t.prototype.Nf = function(t) {
        var n = t.key.toString().length;
        return t instanceof pn && (n += t.data().Cn()), n;
    }, t.prototype.wf = function(t, n, i) {
        var e = this;
        return de.ks([ function() {
            return e.persistence.jf(t, n);
        }, function() {
            return de.resolve(e.lf.ys(n));
        }, function() {
            return e.persistence.Th().ys(t, n);
        }, function() {
            var t = e.Mf.get(n);
            return de.resolve(void 0 !== t && t > i);
        } ]);
    }, t.prototype.Wc = function(t) {
        return this.persistence._h().ma(t);
    }, t;
}(), Gr = 1e3, Wr = 1.5, zr = 6e4, Kr = /** @class */ function() {
    function t(
    /**
     * The AsyncQueue to run backoff operations on.
     */
    t, 
    /**
     * The ID to use when scheduling backoff operations on the AsyncQueue.
     */
    n, 
    /**
     * The initial delay (used as the base delay on the first retry attempt).
     * Note that jitter will still be applied, so the actual delay could be as
     * little as 0.5*initialDelayMs.
     */
    i, 
    /**
     * The multiplier to use to determine the extended base delay after each
     * attempt.
     */
    e, 
    /**
     * The maximum base delay after which no further backoff is performed.
     * Note that jitter will still be applied, so the actual delay could be as
     * much as 1.5*maxDelayMs.
     */
    r) {
        void 0 === i && (i = Gr), void 0 === e && (e = Wr), void 0 === r && (r = zr), this.Da = t, 
        this.Cu = n, this.Qf = i, this.Gf = e, this.Wf = r, this.zf = 0, this.Kf = null, 
        /** The last backoff attempt, as epoch milliseconds. */
        this.Hf = Date.now(), this.reset();
    }
    /**
     * Resets the backoff delay.
     *
     * The very next backoffAndWait() will have no delay. If it is called again
     * (i.e. due to an error), initialDelayMs (plus jitter) will be used, and
     * subsequent ones will increase according to the backoffFactor.
     */    return t.prototype.reset = function() {
        this.zf = 0;
    }, 
    /**
     * Resets the backoff delay to the maximum delay (e.g. for use after a
     * RESOURCE_EXHAUSTED error).
     */
    t.prototype.Jf = function() {
        this.zf = this.Wf;
    }, 
    /**
     * Returns a promise that resolves after currentDelayMs, and increases the
     * delay for any subsequent attempts. If there was a pending backoff operation
     * already, it will be canceled.
     */
    t.prototype.Yf = function(t) {
        var n = this;
        // Cancel any pending backoff operation.
                this.cancel();
        // First schedule using the current base (which may be 0 and should be
        // honored as such).
        var i = Math.floor(this.zf + this.Xf()), e = Math.max(0, Date.now() - this.Hf), r = Math.max(0, i - e);
        // Guard against lastAttemptTime being in the future due to a clock change.
                this.zf > 0 && A("ExponentialBackoff", "Backing off for " + r + " ms (base delay: " + this.zf + " ms, delay with jitter: " + i + " ms, last attempt: " + e + " ms ago)"), 
        this.Kf = this.Da.Xu(this.Cu, r, (function() {
            return n.Hf = Date.now(), t();
        })), 
        // Apply backoff factor to determine next delay and ensure it is within
        // bounds.
        this.zf *= this.Gf, this.zf < this.Qf && (this.zf = this.Qf), this.zf > this.Wf && (this.zf = this.Wf);
    }, t.prototype.cancel = function() {
        null !== this.Kf && (this.Kf.cancel(), this.Kf = null);
    }, 
    /** Returns a random value in the range [-currentBaseMs/2, currentBaseMs/2] */
    t.prototype.Xf = function() {
        return (Math.random() - .5) * this.zf;
    }, t;
}();

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
     * The streaming RPC is not yet running and there's no error condition.
     * Calling start() will start the stream immediately without backoff.
     * While in this state isStarted() will return false.
     */
(jr = xr || (xr = {}))[jr.$f = 0] = "__PRIVATE_Initial", 
/**
     * The stream is starting, either waiting for an auth token or for the stream
     * to successfully open. While in this state, isStarted() will return true but
     * isOpen() will return false.
     */
jr[jr.Zf = 1] = "__PRIVATE_Starting", 
/**
     * The streaming RPC is up and running. Requests and responses can flow
     * freely. Both isStarted() and isOpen() will return true.
     */
jr[jr.tl = 2] = "__PRIVATE_Open", 
/**
     * The stream encountered an error. The next start attempt will back off.
     * While in this state isStarted() will return false.
     */
jr[jr.Error = 3] = "Error", 
/**
     * An in-between state after an error where the stream is waiting before
     * re-starting. After waiting is complete, the stream will try to open.
     * While in this state isStarted() will return true but isOpen() will return
     * false.
     */
jr[jr.nl = 4] = "__PRIVATE_Backoff";

/** The time a stream stays open after it is marked idle. */
var Hr = /** @class */ function() {
    function t(t, n, i, e, r, u) {
        this.Da = t, this.il = i, this.connection = e, this.el = r, this.listener = u, this.state = xr.$f, 
        /**
         * A close count that's incremented every time the stream is closed; used by
         * getCloseGuardedDispatcher() to invalidate callbacks that happen after
         * close.
         */
        this.rl = 0, this.ul = null, this.stream = null, this.sl = new Kr(t, n);
    }
    /**
     * Returns true if start() has been called and no error has occurred. True
     * indicates the stream is open or in the process of opening (which
     * encompasses respecting backoff, getting auth tokens, and starting the
     * actual RPC). Use isOpen() to determine if the stream is open and ready for
     * outbound requests.
     */    return t.prototype.ol = function() {
        return this.state === xr.Zf || this.state === xr.tl || this.state === xr.nl;
    }, 
    /**
     * Returns true if the underlying RPC is open (the onOpen() listener has been
     * called) and the stream is ready for outbound requests.
     */
    t.prototype.hl = function() {
        return this.state === xr.tl;
    }, 
    /**
     * Starts the RPC. Only allowed if isStarted() returns false. The stream is
     * not immediately ready for use: onOpen() will be invoked when the RPC is
     * ready for outbound requests, at which point isOpen() will return true.
     *
     * When start returns, isStarted() will return true.
     */
    t.prototype.start = function() {
        this.state !== xr.Error ? (C(this.state === xr.$f, "Already started"), this.auth()) : this.cl();
    }, 
    /**
     * Stops the RPC. This call is idempotent and allowed regardless of the
     * current isStarted() state.
     *
     * When stop returns, isStarted() and isOpen() will both return false.
     */
    t.prototype.stop = function() {
        return r(this, void 0, void 0, (function() {
            return u(this, (function(t) {
                switch (t.label) {
                  case 0:
                    return this.ol() ? [ 4 /*yield*/ , this.close(xr.$f) ] : [ 3 /*break*/ , 2 ];

                  case 1:
                    t.sent(), t.label = 2;

                  case 2:
                    return [ 2 /*return*/ ];
                }
            }));
        }));
    }, 
    /**
     * After an error the stream will usually back off on the next attempt to
     * start it. If the error warrants an immediate restart of the stream, the
     * sender can use this to indicate that the receiver should not back off.
     *
     * Each error will call the onClose() listener. That function can decide to
     * inhibit backoff if required.
     */
    t.prototype.al = function() {
        C(!this.ol(), "Can only inhibit backoff in a stopped state"), this.state = xr.$f, 
        this.sl.reset();
    }, 
    /**
     * Marks this stream as idle. If no further actions are performed on the
     * stream for one minute, the stream will automatically close itself and
     * notify the stream's onClose() handler with Status.OK. The stream will then
     * be in a !isStarted() state, requiring the caller to start the stream again
     * before further use.
     *
     * Only streams that are in state 'Open' can be marked idle, as all other
     * states imply pending network operations.
     */
    t.prototype.fl = function() {
        var t = this;
        // Starts the idle time if we are in state 'Open' and are not yet already
        // running a timer (in which case the previous idle timeout still applies).
                this.hl() && null === this.ul && (this.ul = this.Da.Xu(this.il, 6e4, (function() {
            return t.ll();
        })));
    }, 
    /** Sends a message to the underlying stream. */
    t.prototype.dl = function(t) {
        this.vl(), this.stream.send(t);
    }, 
    /** Called by the idle timer when the stream should close due to inactivity. */
    t.prototype.ll = function() {
        return r(this, void 0, void 0, (function() {
            return u(this, (function(t) {
                return this.hl() ? [ 2 /*return*/ , this.close(xr.$f) ] : [ 2 /*return*/ ];
            }));
        }));
    }, 
    /** Marks the stream as active again. */
    t.prototype.vl = function() {
        this.ul && (this.ul.cancel(), this.ul = null);
    }, 
    /**
     * Closes the stream and cleans up as necessary:
     *
     * * closes the underlying GRPC stream;
     * * calls the onClose handler with the given 'error';
     * * sets internal stream state to 'finalState';
     * * adjusts the backoff timer based on the error
     *
     * A new stream can be opened by calling start().
     *
     * @param finalState the intended state of the stream after closing.
     * @param error the error the connection was closed with.
     */
    t.prototype.close = function(t, n) {
        return r(this, void 0, void 0, (function() {
            return u(this, (function(i) {
                switch (i.label) {
                  case 0:
                    // Notify the listener that the stream closed.
                    return C(this.ol(), "Only started streams should be closed."), C(t === xr.Error || En(n), "Can't provide an error when not in an error state."), 
                    // Cancel any outstanding timers (they're guaranteed not to execute).
                    this.vl(), this.sl.cancel(), 
                    // Invalidates any stream-related callbacks (e.g. from auth or the
                    // underlying stream), guaranteeing they won't execute.
                    this.rl++, t !== xr.Error ? 
                    // If this is an intentional close ensure we don't delay our next connection attempt.
                    this.sl.reset() : n && n.code === L.RESOURCE_EXHAUSTED ? (
                    // Log the error. (Probably either 'quota exceeded' or 'max queue length reached'.)
                    D(n.toString()), D("Using maximum backoff delay to prevent overloading the backend."), 
                    this.sl.Jf()) : n && n.code === L.UNAUTHENTICATED && 
                    // "unauthenticated" error means the token was rejected. Try force refreshing it in case it
                    // just expired.
                    this.el.I(), 
                    // Clean up the underlying stream because we are no longer interested in events.
                    null !== this.stream && (this.wl(), this.stream.close(), this.stream = null), 
                    // This state must be assigned before calling onClose() to allow the callback to
                    // inhibit backoff or otherwise manipulate the state in its non-started state.
                    this.state = t, [ 4 /*yield*/ , this.listener.ml(n) ];

                  case 1:
                    // Notify the listener that the stream closed.
                    return i.sent(), [ 2 /*return*/ ];
                }
            }));
        }));
    }, 
    /**
     * Can be overridden to perform additional cleanup before the stream is closed.
     * Calling super.tearDown() is not required.
     */
    t.prototype.wl = function() {}, t.prototype.auth = function() {
        var t = this;
        C(this.state === xr.$f, "Must be in initial state to auth"), this.state = xr.Zf;
        var n = this.pl(this.rl), i = this.rl;
        // TODO(mikelehen): Just use dispatchIfNotClosed, but see TODO below.
                this.el.getToken().then((function(n) {
            // Stream can be stopped while waiting for authentication.
            // TODO(mikelehen): We really should just use dispatchIfNotClosed
            // and let this dispatch onto the queue, but that opened a spec test can
            // of worms that I don't want to deal with in this PR.
            t.rl === i && 
            // Normally we'd have to schedule the callback on the AsyncQueue.
            // However, the following calls are safe to be called outside the
            // AsyncQueue since they don't chain asynchronous calls
            t.gl(n);
        }), (function(i) {
            n((function() {
                var n = new B(L.UNKNOWN, "Fetching auth token failed: " + i.message);
                return t.bl(n);
            }));
        }));
    }, t.prototype.gl = function(t) {
        var n = this;
        C(this.state === xr.Zf, "Trying to start stream in a non-starting state");
        var i = this.pl(this.rl);
        this.stream = this.yl(t), this.stream._l((function() {
            i((function() {
                return C(n.state === xr.Zf, "Expected stream to be in state Starting, but was " + n.state), 
                n.state = xr.tl, n.listener._l();
            }));
        })), this.stream.ml((function(t) {
            i((function() {
                return n.bl(t);
            }));
        })), this.stream.onMessage((function(t) {
            i((function() {
                return n.onMessage(t);
            }));
        }));
    }, t.prototype.cl = function() {
        var t = this;
        C(this.state === xr.Error, "Should only perform backoff when in Error state"), this.state = xr.nl, 
        this.sl.Yf((function() {
            return r(t, void 0, void 0, (function() {
                return u(this, (function(t) {
                    return C(this.state === xr.nl, "Backoff elapsed but state is now: " + this.state), 
                    this.state = xr.$f, this.start(), C(this.ol(), "PersistentStream should have started"), 
                    [ 2 /*return*/ ];
                }));
            }));
        }));
    }, 
    // Visible for tests
    t.prototype.bl = function(t) {
        // In theory the stream could close cleanly, however, in our current model
        // we never expect this to happen because if we stop a stream ourselves,
        // this callback will never be called. To prevent cases where we retry
        // without a backoff accidentally, we set the stream to error in all cases.
        return C(this.ol(), "Can't handle server close on non-started stream"), A("PersistentStream", "close with error: " + t), 
        this.stream = null, this.close(xr.Error, t);
    }, 
    /**
     * Returns a "dispatcher" function that dispatches operations onto the
     * AsyncQueue but only runs them if closeCount remains unchanged. This allows
     * us to turn auth / stream callbacks into no-ops if the stream is closed /
     * re-opened, etc.
     */
    t.prototype.pl = function(t) {
        var n = this;
        return function(i) {
            n.Da.Uu((function() {
                return n.rl === t ? i() : (A("PersistentStream", "stream callback skipped by getCloseGuardedDispatcher."), 
                Promise.resolve());
            }));
        };
    }, t;
}(), Jr = /** @class */ function(t) {
    function n(n, i, e, r, u) {
        var s = t.call(this, n, zi.Iu, zi._u, i, e, u) || this;
        return s.serializer = r, s;
    }
    return i(n, t), n.prototype.yl = function(t) {
        return this.connection.Il("Listen", t);
    }, n.prototype.onMessage = function(t) {
        // A successful response means the stream is healthy
        this.sl.reset();
        var n = this.serializer.Vr(t), i = this.serializer.kr(t);
        return this.listener.Tl(n, i);
    }, 
    /**
     * Registers interest in the results of the given target. If the target
     * includes a resumeToken it will be included in the request. Results that
     * affect the target will be streamed back as WatchChange messages that
     * reference the targetId.
     */
    n.prototype.watch = function(t) {
        var n = {};
        n.database = this.serializer.mr, n.addTarget = this.serializer.ai(t);
        var i = this.serializer.tu(t);
        i && (n.labels = i), this.dl(n);
    }, 
    /**
     * Unregisters interest in the results of the target associated with the
     * given targetId.
     */
    n.prototype.El = function(t) {
        var n = {};
        n.database = this.serializer.mr, n.removeTarget = t, this.dl(n);
    }, n;
}(Hr), Yr = /** @class */ function(t) {
    function n(n, i, e, r, u) {
        var s = t.call(this, n, zi.Eu, zi.Tu, i, e, u) || this;
        return s.serializer = r, s.Rl = !1, 
        /**
         * The last received stream token from the server, used to acknowledge which
         * responses the client has processed. Stream tokens are opaque checkpoint
         * markers whose only real value is their inclusion in the next request.
         *
         * PersistentWriteStream manages propagating this value from responses to the
         * next request.
         */
        s.lastStreamToken = Jn.Si, s;
    }
    return i(n, t), Object.defineProperty(n.prototype, "Al", {
        /**
         * Tracks whether or not a handshake has been successfully exchanged and
         * the stream is ready to accept mutations.
         */
        get: function() {
            return this.Rl;
        },
        enumerable: !0,
        configurable: !0
    }), 
    // Override of PersistentStream.start
    n.prototype.start = function() {
        this.Rl = !1, t.prototype.start.call(this);
    }, n.prototype.wl = function() {
        this.Rl && this.Dl([]);
    }, n.prototype.yl = function(t) {
        return this.connection.Il("Write", t);
    }, n.prototype.onMessage = function(t) {
        if (
        // Always capture the last stream token.
        C(!!t.streamToken, "Got a write response without a stream token"), this.lastStreamToken = this.serializer.rr(t.streamToken), 
        this.Rl) {
            // A successful first write response means the stream is healthy,
            // Note, that we could consider a successful handshake healthy, however,
            // the write itself might be causing an error we want to back off from.
            this.sl.reset();
            var n = this.serializer.Qr(t.writeResults, t.commitTime), i = this.serializer.fromVersion(t.commitTime);
            return this.listener.Pl(i, n);
        }
        // The first response is always the handshake response
        return C(!t.writeResults || 0 === t.writeResults.length, "Got mutation results for handshake"), 
        this.Rl = !0, this.listener.Sl();
    }, 
    /**
     * Sends an initial streamToken to the server, performing the handshake
     * required to make the StreamingWrite RPC work. Subsequent
     * calls should wait until onHandshakeComplete was called.
     */
    n.prototype.Cl = function() {
        C(this.hl(), "Writing handshake requires an opened stream"), C(!this.Rl, "Handshake already completed");
        // TODO(dimond): Support stream resumption. We intentionally do not set the
        // stream token on the handshake, ignoring any stream token we might have.
        var t = {};
        t.database = this.serializer.mr, this.dl(t);
    }, 
    /** Sends a group of mutations to the Firestore backend to apply. */
    n.prototype.Dl = function(t) {
        var n = this;
        C(this.hl(), "Writing mutations requires an opened stream"), C(this.Rl, "Handshake must be complete before writing mutations"), 
        C(this.lastStreamToken.Cn() > 0, "Trying to write mutation without a token");
        var i = {
            streamToken: this.serializer.er(this.lastStreamToken),
            writes: t.map((function(t) {
                return n.serializer.Or(t);
            }))
        };
        this.dl(i);
    }, n;
}(Hr), Xr = /** @class */ function() {
    function t(t, n, i, e) {
        this.Da = t, this.connection = n, this.credentials = i, this.serializer = e;
    }
    return t.prototype.Vl = function(t) {
        return new Yr(this.Da, this.connection, this.credentials, this.serializer, t);
    }, t.prototype.Nl = function(t) {
        return new Jr(this.Da, this.connection, this.credentials, this.serializer, t);
    }, t.prototype.commit = function(t) {
        var n = this, i = {
            database: this.serializer.mr,
            writes: t.map((function(t) {
                return n.serializer.Or(t);
            }))
        };
        return this.kl("Commit", i).then((function(t) {
            return n.serializer.Qr(t.writeResults, t.commitTime);
        }));
    }, t.prototype.lookup = function(t) {
        var n = this, i = {
            database: this.serializer.mr,
            documents: t.map((function(t) {
                return n.serializer.ar(t);
            }))
        };
        return this.Ol("BatchGetDocuments", i).then((function(i) {
            var e = si();
            i.forEach((function(t) {
                var i = n.serializer.Pr(t);
                e = e.lt(i.key, i);
            }));
            var r = [];
            return t.forEach((function(t) {
                var n = e.get(t);
                C(!!n, "Missing entity in write response for " + t), r.push(n);
            })), r;
        }));
    }, 
    /** Gets an auth token and invokes the provided RPC. */
    t.prototype.kl = function(t, n) {
        var i = this;
        return this.credentials.getToken().then((function(e) {
            return i.connection.kl(t, n, e);
        })).catch((function(t) {
            throw t.code === L.UNAUTHENTICATED && i.credentials.I(), t;
        }));
    }, 
    /** Gets an auth token and invokes the provided RPC with streamed results. */
    t.prototype.Ol = function(t, n) {
        var i = this;
        return this.credentials.getToken().then((function(e) {
            return i.connection.Ol(t, n, e);
        })).catch((function(t) {
            throw t.code === L.UNAUTHENTICATED && i.credentials.I(), t;
        }));
    }, t;
}(), $r = /** @class */ function() {
    /**
     * Creates a FieldPath from the provided field names. If more than one field
     * name is provided, the path will point to a nested field in a document.
     *
     * @param fieldNames A list of field names.
     */
    function t() {
        for (var t = [], n = 0; n < arguments.length; n++) t[n] = arguments[n];
        !function(t, n, i, e) {
            if (!(n instanceof Array) || n.length < e) throw new B(L.INVALID_ARGUMENT, "Function " + t + "() requires its " + i + " argument to be an array with at least " + pt(e, "element") + ".");
        }("FieldPath", t, "fieldNames", 1);
        for (var i = 0; i < t.length; ++i) if (it("FieldPath", "string", i, t[i]), 0 === t[i].length) throw new B(L.INVALID_ARGUMENT, "Invalid field name at argument $(i + 1). Field names must not be empty.");
        this.Fl = new Et(t);
    }
    return t.documentId = function() {
        return t.xl;
    }, t.prototype.isEqual = function(n) {
        if (!(n instanceof t)) throw vt("isEqual", "FieldPath", 1, n);
        return this.Fl.isEqual(n.Fl);
    }, 
    /**
     * Internal Note: The backend doesn't technically support querying by
     * document ID. Instead it queries by the entire document name (full path
     * included), but in the cases we currently support documentId(), the net
     * effect is the same.
     */
    t.xl = new t(Et.st().nt()), t;
}(), Zr = new RegExp("[~\\*/\\[\\]]");

/**
 * A PersistentStream is an abstract base class that represents a streaming RPC
 * to the Firestore backend. It's built on top of the connections own support
 * for streaming RPCs, and adds several critical features for our clients:
 *
 *   - Exponential backoff on failure
 *   - Authentication via CredentialsProvider
 *   - Dispatching all callbacks into the shared worker queue
 *   - Closing idle streams after 60 seconds of inactivity
 *
 * Subclasses of PersistentStream implement serialization of models to and
 * from the JSON representation of the protocol buffers for a specific
 * streaming RPC.
 *
 * ## Starting and Stopping
 *
 * Streaming RPCs are stateful and need to be start()ed before messages can
 * be sent and received. The PersistentStream will call the onOpen() function
 * of the listener once the stream is ready to accept requests.
 *
 * Should a start() fail, PersistentStream will call the registered onClose()
 * listener with a FirestoreError indicating what went wrong.
 *
 * A PersistentStream can be started and stopped repeatedly.
 *
 * Generic types:
 *  SendType: The type of the outgoing message of the underlying
 *    connection stream
 *  ReceiveType: The type of the incoming message of the underlying
 *    connection stream
 *  ListenerType: The type of the listener that will be used for callbacks
 */
/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * An opaque base class for FieldValue sentinel objects in our public API,
 * with public static methods for creating said sentinel objects.
 */
var tu, nu, iu = /** @class */ function() {
    function t(t) {
        this.jl = t;
    }
    return t.delete = function() {
        return $("FieldValue.delete", arguments), eu.instance;
    }, t.serverTimestamp = function() {
        return $("FieldValue.serverTimestamp", arguments), ru.instance;
    }, t.arrayUnion = function() {
        for (var t = [], n = 0; n < arguments.length; n++) t[n] = arguments[n];
        // NOTE: We don't actually parse the data until it's used in set() or
        // update() since we need access to the Firestore instance.
        return tt("FieldValue.arrayUnion", arguments, 1), new uu(t);
    }, t.arrayRemove = function() {
        for (var t = [], n = 0; n < arguments.length; n++) t[n] = arguments[n];
        // NOTE: We don't actually parse the data until it's used in set() or
        // update() since we need access to the Firestore instance.
        return tt("FieldValue.arrayRemove", arguments, 1), new su(t);
    }, t.increment = function(t) {
        return it("FieldValue.increment", "number", 1, t), Z("FieldValue.increment", arguments, 1), 
        new ou(t);
    }, t.prototype.isEqual = function(t) {
        return this === t;
    }, t;
}(), eu = /** @class */ function(t) {
    function n() {
        return t.call(this, "FieldValue.delete") || this;
    }
    /** Singleton instance. */    return i(n, t), n.instance = new n, n;
}(iu), ru = /** @class */ function(t) {
    function n() {
        return t.call(this, "FieldValue.serverTimestamp") || this;
    }
    /** Singleton instance. */    return i(n, t), n.instance = new n, n;
}(iu), uu = /** @class */ function(t) {
    function n(n) {
        var i = t.call(this, "FieldValue.arrayUnion") || this;
        return i.Ul = n, i;
    }
    return i(n, t), n;
}(iu), su = /** @class */ function(t) {
    function n(n) {
        var i = t.call(this, "FieldValue.arrayRemove") || this;
        return i.Ul = n, i;
    }
    return i(n, t), n;
}(iu), ou = /** @class */ function(t) {
    function n(n) {
        var i = t.call(this, "FieldValue.increment") || this;
        return i.Ll = n, i;
    }
    return i(n, t), n;
}(iu), hu = Qi(iu, "Use FieldValue.<field>() instead."), cu = /^__.*__$/, au = /** @class */ function() {
    function t(t, n, i) {
        this.data = t, this.on = n, this.fieldTransforms = i;
    }
    return t.prototype.Bl = function(t, n) {
        var i = [];
        return null !== this.on ? i.push(new Jt(t, this.data, this.on, n)) : i.push(new Ht(t, this.data, n)), 
        this.fieldTransforms.length > 0 && i.push(new Yt(t, this.fieldTransforms)), i;
    }, t;
}(), fu = /** @class */ function() {
    function t(t, n, i) {
        this.data = t, this.on = n, this.fieldTransforms = i;
    }
    return t.prototype.Bl = function(t, n) {
        var i = [ new Jt(t, this.data, this.on, n) ];
        return this.fieldTransforms.length > 0 && i.push(new Yt(t, this.fieldTransforms)), 
        i;
    }, t;
}();

function lu(t) {
    switch (t) {
      case tu.Set:
 // fall through
              case tu.Ml:
 // fall through
              case tu.ql:
        return !0;

      case tu.Ql:
      case tu.Gl:
        return !1;

      default:
        throw S("Unexpected case for UserDataSource: " + t);
    }
}

/** A "context" object passed around while parsing user data. */ (nu = tu || (tu = {}))[nu.Set = 0] = "Set", 
nu[nu.ql = 1] = "__PRIVATE_Update", nu[nu.Ml = 2] = "__PRIVATE_MergeSet", 
/**
     * Indicates the source is a where clause, cursor bound, arrayUnion()
     * element, etc. Of note, isWrite(source) will return false.
     */
nu[nu.Ql = 3] = "__PRIVATE_Argument", 
/**
     * Indicates that the source is an Argument that may directly contain nested
     * arrays (e.g. the operand of an `in` query).
     */
nu[nu.Gl = 4] = "__PRIVATE_ArrayArgument";

var du = /** @class */ function() {
    /**
     * Initializes a ParseContext with the given source and path.
     *
     * @param dataSource Indicates what kind of API method this data came from.
     * @param methodName The name of the method the user called to create this
     *     ParseContext.
     * @param path A path within the object being parsed. This could be an empty
     *     path (in which case the context represents the root of the data being
     *     parsed), or a nonempty path (indicating the context represents a nested
     *     location within the data).
     * @param arrayElement Whether or not this context corresponds to an element
     *     of an array.
     * @param fieldTransforms A mutable list of field transforms encountered while
     *     parsing the data.
     * @param fieldMask A mutable list of field paths encountered while parsing
     *     the data.
     *
     * TODO(b/34871131): We don't support array paths right now, so path can be
     * null to indicate the context represents any location within an array (in
     * which case certain features will not work and errors will be somewhat
     * compromised).
     */
    function t(t, n, i, e, r, u) {
        this.Wl = t, this.methodName = n, this.path = i, this.zl = e, 
        // Minor hack: If fieldTransforms is undefined, we assume this is an
        // external call and we need to validate the entire path.
        void 0 === r && this.Kl(), this.zl = void 0 !== e && e, this.fieldTransforms = r || [], 
        this.on = u || [];
    }
    return t.prototype.Hl = function(n) {
        var i = null == this.path ? null : this.path.child(n), e = new t(this.Wl, this.methodName, i, 
        /*arrayElement=*/ !1, this.fieldTransforms, this.on);
        return e.Jl(n), e;
    }, t.prototype.Yl = function(n) {
        var i = null == this.path ? null : this.path.child(n), e = new t(this.Wl, this.methodName, i, 
        /*arrayElement=*/ !1, this.fieldTransforms, this.on);
        return e.Kl(), e;
    }, t.prototype.Xl = function(n) {
        // TODO(b/34871131): We don't support array paths right now; so make path
        // null.
        return new t(this.Wl, this.methodName, 
        /*path=*/ null, 
        /*arrayElement=*/ !0, this.fieldTransforms, this.on);
    }, t.prototype.$l = function(t) {
        var n = null === this.path || this.path.J() ? "" : " (found in field " + this.path.toString() + ")";
        return new B(L.INVALID_ARGUMENT, "Function " + this.methodName + "() called with invalid data. " + t + n);
    }, 
    /** Returns 'true' if 'fieldPath' was traversed when creating this context. */
    t.prototype.contains = function(t) {
        return void 0 !== this.on.find((function(n) {
            return t.$(n);
        })) || void 0 !== this.fieldTransforms.find((function(n) {
            return t.$(n.field);
        }));
    }, t.prototype.Kl = function() {
        // TODO(b/34871131): Remove null check once we have proper paths for fields
        // within arrays.
        if (null !== this.path) for (var t = 0; t < this.path.length; t++) this.Jl(this.path.get(t));
    }, t.prototype.Jl = function(t) {
        if (0 === t.length) throw this.$l("Document fields must not be empty");
        if (lu(this.Wl) && cu.test(t)) throw this.$l('Document fields cannot begin and end with "__"');
    }, t;
}(), vu = function(t, n) {
    this.s = t, this.key = n;
}, wu = /** @class */ function() {
    function t(t) {
        this.Zl = t;
    }
    /** Parse document data from a non-merge set() call. */    return t.prototype.td = function(t, n) {
        var i = new du(tu.Set, t, Et.et);
        pu("Data must be an object, but it was:", i, n);
        var e = this.nd(n, i);
        return new au(e, 
        /* fieldMask= */ null, i.fieldTransforms);
    }, 
    /** Parse document data from a set() call with '{merge:true}'. */
    t.prototype.ed = function(t, n, i) {
        var e = new du(tu.Ml, t, Et.et);
        pu("Data must be an object, but it was:", e, n);
        var r, u, s = this.nd(n, e);
        if (i) {
            for (var o = new Ct(Et.G), h = 0, c = i; h < c.length; h++) {
                var a = c[h], f = void 0;
                if (a instanceof $r) f = a.Fl; else {
                    if ("string" != typeof a) throw S("Expected stringOrFieldPath to be a string or a FieldPath");
                    f = bu(t, a);
                }
                if (!e.contains(f)) throw new B(L.INVALID_ARGUMENT, "Field '" + f + "' is specified in your field mask but missing from your input data.");
                o = o.add(f);
            }
            r = Lt.Jt(o), u = e.fieldTransforms.filter((function(t) {
                return r.Xt(t.field);
            }));
        } else r = Lt.Yt(e.on), u = e.fieldTransforms;
        return new au(s, r, u);
    }, 
    /** Parse update data from an update() call. */
    t.prototype.rd = function(t, n) {
        var i = this, e = new du(tu.ql, t, Et.et);
        pu("Data must be an object, but it was:", e, n);
        var r = new Ct(Et.G), u = vn.EMPTY;
        Y(n, (function(n, s) {
            var o = bu(t, n), h = e.Yl(o);
            if ((s = i.ud(s, h)) instanceof eu) 
            // Add it to the field mask, but don't add anything to updateData.
            r = r.add(o); else {
                var c = i.nd(s, h);
                null != c && (r = r.add(o), u = u.set(o, c));
            }
        }));
        var s = Lt.Jt(r);
        return new fu(u, s, e.fieldTransforms);
    }, 
    /** Parse update data from a list of field/value arguments. */
    t.prototype.sd = function(t, n, i, e) {
        var r = new du(tu.ql, t, Et.et), u = [ gu(t, n) ], s = [ i ];
        if (e.length % 2 != 0) throw new B(L.INVALID_ARGUMENT, "Function " + t + "() needs to be called with an even number of arguments that alternate between field names and values.");
        for (var o = 0; o < e.length; o += 2) u.push(gu(t, e[o])), s.push(e[o + 1]);
        var h = new Ct(Et.G), c = vn.EMPTY;
        for (o = 0; o < u.length; ++o) {
            var a = u[o], f = r.Yl(a), l = this.ud(s[o], f);
            if (l instanceof eu) 
            // Add it to the field mask, but don't add anything to updateData.
            h = h.add(a); else {
                var d = this.nd(l, f);
                null != d && (h = h.add(a), c = c.set(a, d));
            }
        }
        var v = Lt.Jt(h);
        return new fu(c, v, r.fieldTransforms);
    }, 
    /**
     * Parse a "query value" (e.g. value in a where filter or a value in a cursor
     * bound).
     *
     * @param allowArrays Whether the query value is an array that may directly
     * contain additional arrays (e.g. the operand of an `in` query).
     */
    t.prototype.od = function(t, n, i) {
        void 0 === i && (i = !1);
        var e = new du(i ? tu.Gl : tu.Ql, t, Et.et), r = this.nd(n, e);
        return C(null != r, "Parsed data should not be null."), C(0 === e.fieldTransforms.length, "Field transforms should have been disallowed."), 
        r;
    }, 
    /** Sends data through this.preConverter, handling any thrown errors. */
    t.prototype.ud = function(t, n) {
        try {
            return this.Zl(t);
        } catch (t) {
            var i = yu(t);
            throw n.$l(i);
        }
    }, 
    /**
     * Internal helper for parsing user data.
     *
     * @param input Data to be parsed.
     * @param context A context object representing the current path being parsed,
     * the source of the data being parsed, etc.
     * @return The parsed value, or null if the value was a FieldValue sentinel
     * that should not be included in the resulting parsed data.
     */
    t.prototype.nd = function(t, n) {
        if (mu(t = this.ud(t, n))) return pu("Unsupported field value:", n, t), this.hd(t, n);
        if (t instanceof iu) 
        // FieldValues usually parse into transforms (except FieldValue.delete())
        // in which case we do not want to include this field in our parsed data
        // (as doing so will overwrite the field directly prior to the transform
        // trying to transform it). So we don't add this location to
        // context.fieldMask and we return null as our parsing result.
        return this.ad(t, n), null;
        if (
        // If context.path is null we are inside an array and we don't support
        // field mask paths more granular than the top-level array.
        n.path && n.on.push(n.path), t instanceof Array) {
            // TODO(b/34871131): Include the path containing the array in the error
            // message.
            // In the case of IN queries, the parsed data is an array (representing
            // the set of values to be included for the IN query) that may directly
            // contain additional arrays (each representing an individual field
            // value), so we disable this validation.
            if (n.zl && n.Wl !== tu.Gl) throw n.$l("Nested arrays are not supported");
            return this.fd(t, n);
        }
        return this.ld(t, n);
    }, t.prototype.hd = function(t, n) {
        var i = this, e = new At(N);
        return X(t) ? 
        // If we encounter an empty object, we explicitly add it to the update
        // mask to ensure that the server creates a map entry.
        n.path && n.path.length > 0 && n.on.push(n.path) : Y(t, (function(t, r) {
            var u = i.nd(r, n.Hl(t));
            null != u && (e = e.lt(t, u));
        })), new vn(e);
    }, t.prototype.fd = function(t, n) {
        for (var i = [], e = 0, r = 0, u = t; r < u.length; r++) {
            var s = u[r], o = this.nd(s, n.Xl(e));
            null == o && (
            // Just include nulls in the array for fields being replaced with a
            // sentinel.
            o = nn.Vn), i.push(o), e++;
        }
        return new wn(i);
    }, 
    /**
     * "Parses" the provided FieldValueImpl, adding any necessary transforms to
     * context.fieldTransforms.
     */
    t.prototype.ad = function(t, n) {
        // Sentinels are only supported with writes, and not within arrays.
        if (!lu(n.Wl)) throw n.$l(t.jl + "() can only be used with update() and set()");
        if (null === n.path) throw n.$l(t.jl + "() is not currently supported inside arrays");
        if (t instanceof eu) {
            if (n.Wl !== tu.Ml) throw n.Wl === tu.ql ? (C(n.path.length > 0, "FieldValue.delete() at the top level should have already been handled."), 
            n.$l("FieldValue.delete() can only appear at the top level of your update data")) : n.$l("FieldValue.delete() cannot be used with set() unless you pass {merge:true}");
            // No transform to add for a delete, but we need to add it to our
            // fieldMask so it gets deleted.
            n.on.push(n.path);
        } else if (t instanceof ru) n.fieldTransforms.push(new Bt(n.path, Nt.instance)); else if (t instanceof uu) {
            var i = this.dd(t.jl, t.Ul), e = new kt(i);
            n.fieldTransforms.push(new Bt(n.path, e));
        } else if (t instanceof su) {
            i = this.dd(t.jl, t.Ul);
            var r = new Ot(i);
            n.fieldTransforms.push(new Bt(n.path, r));
        } else if (t instanceof ou) {
            var u = this.od("FieldValue.increment", t.Ll), s = new Ft(u);
            n.fieldTransforms.push(new Bt(n.path, s));
        } else S("Unknown FieldValue type: " + t);
    }, 
    /**
     * Helper to parse a scalar value (i.e. not an Object, Array, or FieldValue)
     *
     * @return The parsed value
     */
    t.prototype.ld = function(t, n) {
        if (null === t) return nn.Vn;
        if ("number" == typeof t) return Rn(t) ? new sn(t) : new on(t);
        if ("boolean" == typeof t) return en.of(t);
        if ("string" == typeof t) return new hn(t);
        if (t instanceof Date) return new cn(bt.fromDate(t));
        if (t instanceof bt) 
        // Firestore backend truncates precision down to microseconds. To ensure
        // offline mode works the same with regards to truncation, perform the
        // truncation immediately without waiting for the backend to do that.
        return new cn(new bt(t.seconds, 1e3 * Math.floor(t.nanoseconds / 1e3)));
        if (t instanceof gt) return new dn(t);
        if (t instanceof Hi) return new fn(t);
        if (t instanceof vu) return new ln(t.s, t.key);
        throw n.$l("Unsupported field value: " + ft(t));
    }, t.prototype.dd = function(t, n) {
        var i = this;
        return n.map((function(n, e) {
            // Although array transforms are used with writes, the actual elements
            // being unioned or removed are not considered writes since they cannot
            // contain any FieldValue sentinels, etc.
            var r = new du(tu.Ql, t, Et.et);
            return i.nd(n, r.Xl(e));
        }));
    }, t;
}();

/**
 * A placeholder object for DocumentReferences in this file, in order to
 * avoid a circular dependency. See the comments for `DataPreConverter` for
 * the full context.
 */
/**
 * Checks whether an object looks like a JSON object that should be converted
 * into a struct. Normal class/prototype instances are considered to look like
 * JSON objects since they should be converted to a struct value. Arrays, Dates,
 * GeoPoints, etc. are not considered to look like JSON objects since they map
 * to specific FieldValue types other than ObjectValue.
 */
function mu(t) {
    return !("object" != typeof t || null === t || t instanceof Array || t instanceof Date || t instanceof bt || t instanceof gt || t instanceof Hi || t instanceof vu || t instanceof iu);
}

function pu(t, n, i) {
    if (!mu(i) || !at(i)) {
        var e = ft(i);
        throw "an object" === e ? n.$l(t + " a custom object") : n.$l(t + " " + e);
    }
}

/**
 * Helper that calls fromDotSeparatedString() but wraps any error thrown.
 */ function gu(t, n) {
    if (n instanceof $r) return n.Fl;
    if ("string" == typeof n) return bu(t, n);
    throw new B(L.INVALID_ARGUMENT, "Function " + t + "() called with invalid data. Field path arguments must be of type string or FieldPath.");
}

/**
 * Wraps fromDotSeparatedString with an error message about the method that
 * was thrown.
 * @param methodName The publicly visible method name
 * @param path The dot-separated string form of a field path which will be split
 * on dots.
 */ function bu(t, i) {
    try {
        /**
 * Parses a field path string into a FieldPath, treating dots as separators.
 */
        return function(t) {
            if (t.search(Zr) >= 0) throw new B(L.INVALID_ARGUMENT, "Invalid field path (" + t + "). Paths must not contain '~', '*', '/', '[', or ']'");
            try {
                return new ($r.bind.apply($r, n([ void 0 ], t.split("."))));
            } catch (n) {
                throw new B(L.INVALID_ARGUMENT, "Invalid field path (" + t + "). Paths must not be empty, begin with '.', end with '.', or contain '..'");
            }
        }(i).Fl;
    } catch (n) {
        var e = yu(n);
        throw new B(L.INVALID_ARGUMENT, "Function " + t + "() called with invalid data. " + e);
    }
}

/**
 * Extracts the message from a caught exception, which should be an Error object
 * though JS doesn't guarantee that.
 */ function yu(t) {
    return t instanceof Error ? t.message : t.toString();
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Internal transaction object responsible for accumulating the mutations to
 * perform and the base versions for any documents read.
 */ var _u = /** @class */ function() {
    function t(t) {
        this.vd = t, 
        // The version of each document that was read during this transaction.
        this.wd = fi(), this.mutations = [], this.md = !1, 
        /**
         * A deferred usage error that occurred previously in this transaction that
         * will cause the transaction to fail once it actually commits.
         */
        this.pd = null, 
        /**
         * Set of documents that have been written in the transaction.
         *
         * When there's more than one write to the same key in a transaction, any
         * writes after the first are handled differently.
         */
        this.gd = new Set;
    }
    return t.prototype.lookup = function(t) {
        return r(this, void 0, void 0, (function() {
            var n, i = this;
            return u(this, (function(e) {
                switch (e.label) {
                  case 0:
                    if (this.bd(), this.mutations.length > 0) throw new B(L.INVALID_ARGUMENT, "Firestore transactions require all reads to be executed before all writes.");
                    return [ 4 /*yield*/ , this.vd.lookup(t) ];

                  case 1:
                    return (n = e.sent()).forEach((function(t) {
                        t instanceof gn || t instanceof pn ? i.yd(t) : S("Document in a transaction was a " + t.constructor.name);
                    })), [ 2 /*return*/ , n ];
                }
            }));
        }));
    }, t.prototype.set = function(t, n) {
        this.write(n.Bl(t, this.rn(t))), this.gd.add(t);
    }, t.prototype.update = function(t, n) {
        try {
            this.write(n.Bl(t, this._d(t)));
        } catch (t) {
            this.pd = t;
        }
        this.gd.add(t);
    }, t.prototype.delete = function(t) {
        this.write([ new Xt(t, this.rn(t)) ]), this.gd.add(t);
    }, t.prototype.commit = function() {
        return r(this, void 0, void 0, (function() {
            var t, n = this;
            return u(this, (function(i) {
                switch (i.label) {
                  case 0:
                    if (this.bd(), this.pd) throw this.pd;
                    return t = this.wd, 
                    // For each mutation, note that the doc was written.
                    this.mutations.forEach((function(n) {
                        t = t.remove(n.key);
                    })), 
                    // For each document that was read but not written to, we want to perform
                    // a `verify` operation.
                    t.forEach((function(t, i) {
                        n.mutations.push(new $t(t, n.rn(t)));
                    })), [ 4 /*yield*/ , this.vd.commit(this.mutations) ];

                  case 1:
                    return i.sent(), this.md = !0, [ 2 /*return*/ ];
                }
            }));
        }));
    }, t.prototype.yd = function(t) {
        var n;
        if (t instanceof pn) n = t.version; else {
            if (!(t instanceof gn)) throw S("Document in a transaction was a " + t.constructor.name);
            // For deleted docs, we must use baseVersion 0 when we overwrite them.
            n = yt.B();
        }
        var i = this.wd.get(t.key);
        if (null !== i) {
            if (!n.isEqual(i)) 
            // This transaction will fail no matter what.
            throw new B(L.ABORTED, "Document version changed between two reads.");
        } else this.wd = this.wd.lt(t.key, n);
    }, 
    /**
     * Returns the version of this document when it was read in this transaction,
     * as a precondition, or no precondition if it was not read.
     */
    t.prototype.rn = function(t) {
        var n = this.wd.get(t);
        return !this.gd.has(t) && n ? zt.updateTime(n) : zt.NONE;
    }, 
    /**
     * Returns the precondition for a document if the operation is an update.
     */
    t.prototype._d = function(t) {
        var n = this.wd.get(t);
        // The first time a document is written, we want to take into account the
        // read time and existence
                if (!this.gd.has(t) && n) {
            if (n.isEqual(yt.B())) 
            // The document doesn't exist, so fail the transaction.
            // This has to be validated locally because you can't send a
            // precondition that a document does not exist without changing the
            // semantics of the backend write to be an insert. This is the reverse
            // of what we want, since we want to assert that the document doesn't
            // exist but then send the update and have it fail. Since we can't
            // express that to the backend, we have to validate locally.
            // Note: this can change once we can send separate verify writes in the
            // transaction.
            throw new B(L.INVALID_ARGUMENT, "Can't update a document that doesn't exist.");
            // Document exists, base precondition on document update time.
                        return zt.updateTime(n);
        }
        // Document was not read, so we just use the preconditions for a blind
        // update.
        return zt.exists(!0);
    }, t.prototype.write = function(t) {
        this.bd(), this.mutations = this.mutations.concat(t);
    }, t.prototype.bd = function() {
        C(!this.md, "A transaction object cannot be used after its update callback has been invoked.");
    }, t;
}(), Iu = /** @class */ function() {
    function t(t, n) {
        this.Su = t, this.Id = n, 
        /** The current OnlineState. */
        this.state = Sn.Ti, 
        /**
         * A count of consecutive failures to open the stream. If it reaches the
         * maximum defined by MAX_WATCH_STREAM_FAILURES, we'll set the OnlineState to
         * Offline.
         */
        this.Td = 0, 
        /**
         * A timer that elapses after ONLINE_STATE_TIMEOUT_MS, at which point we
         * transition from OnlineState.Unknown to OnlineState.Offline without waiting
         * for the stream to actually fail (MAX_WATCH_STREAM_FAILURES times).
         */
        this.Ed = null, 
        /**
         * Whether the client should log a warning message if it fails to connect to
         * the backend (initially true, cleared after a successful stream, or if we've
         * logged the message already).
         */
        this.Rd = !0;
    }
    /**
     * Called by RemoteStore when a watch stream is started (including on each
     * backoff attempt).
     *
     * If this is the first attempt, it sets the OnlineState to Unknown and starts
     * the onlineStateTimer.
     */    return t.prototype.Ad = function() {
        var t = this;
        0 === this.Td && (this.Dd(Sn.Ti), C(null === this.Ed, "onlineStateTimer shouldn't be started yet"), 
        this.Ed = this.Su.Xu(zi.Ru, 1e4, (function() {
            // NOTE: handleWatchStreamFailure() will continue to increment
            // watchStreamFailures even though we are already marked Offline,
            // but this is non-harmful.
            return t.Ed = null, C(t.state === Sn.Ti, "Timer should be canceled if we transitioned to a different state."), 
            t.Pd("Backend didn't respond within 10 seconds."), t.Dd(Sn.Ri), Promise.resolve();
        })));
    }, 
    /**
     * Updates our OnlineState as appropriate after the watch stream reports a
     * failure. The first failure moves us to the 'Unknown' state. We then may
     * allow multiple failures (based on MAX_WATCH_STREAM_FAILURES) before we
     * actually transition to the 'Offline' state.
     */
    t.prototype.Sd = function(t) {
        this.state === Sn.Ei ? (this.Dd(Sn.Ti), 
        // To get to OnlineState.Online, set() must have been called which would
        // have reset our heuristics.
        C(0 === this.Td, "watchStreamFailures must be 0"), C(null === this.Ed, "onlineStateTimer must be null")) : (this.Td++, 
        this.Td >= 1 && (this.Cd(), this.Pd("Connection failed 1 times. Most recent error: " + t.toString()), 
        this.Dd(Sn.Ri)));
    }, 
    /**
     * Explicitly sets the OnlineState to the specified state.
     *
     * Note that this resets our timers / failure counters, etc. used by our
     * Offline heuristics, so must not be used in place of
     * handleWatchStreamStart() and handleWatchStreamFailure().
     */
    t.prototype.set = function(t) {
        this.Cd(), this.Td = 0, t === Sn.Ei && (
        // We've connected to watch at least once. Don't warn the developer
        // about being offline going forward.
        this.Rd = !1), this.Dd(t);
    }, t.prototype.Dd = function(t) {
        t !== this.state && (this.state = t, this.Id(t));
    }, t.prototype.Pd = function(t) {
        var n = "Could not reach Cloud Firestore backend. " + t + "\nThis typically indicates that your device does not have a healthy Internet connection at the moment. The client will operate in offline mode until it is able to successfully connect to the backend.";
        this.Rd ? (D(n), this.Rd = !1) : A("OnlineStateTracker", n);
    }, t.prototype.Cd = function() {
        null !== this.Ed && (this.Ed.cancel(), this.Ed = null);
    }, t;
}(), Tu = "RemoteStore", Eu = /** @class */ function() {
    function t(
    /**
     * The local store, used to fill the write pipeline with outbound mutations.
     */
    t, 
    /** The client-side proxy for interacting with the backend. */
    n, i, e, s) {
        var o = this;
        this.Oc = t, this.vd = n, 
        /**
         * A list of up to MAX_PENDING_WRITES writes that we have fetched from the
         * LocalStore via fillWritePipeline() and have or will send to the write
         * stream.
         *
         * Whenever writePipeline.length > 0 the RemoteStore will attempt to start or
         * restart the write stream. When the stream is established the writes in the
         * pipeline will be sent in order.
         *
         * Writes remain in writePipeline until they are acknowledged by the backend
         * and thus will automatically be re-sent if the stream is interrupted /
         * restarted before they're acknowledged.
         *
         * Write responses from the backend are linked to their originating request
         * purely based on order, and so we can just shift() writes from the front of
         * the writePipeline as we receive responses.
         */
        this.Vd = [], 
        /**
         * A mapping of watched targets that the client cares about tracking and the
         * user has explicitly called a 'listen' for this target.
         *
         * These targets may or may not have been sent to or acknowledged by the
         * server. On re-establishing the listen stream, these targets should be sent
         * to the server. The targets removed with unlistens are removed eagerly
         * without waiting for confirmation from the listen stream.
         */
        this.Nd = {}, this.kd = null, 
        /**
         * Set to true by enableNetwork() and false by disableNetwork() and indicates
         * the user-preferred network state.
         */
        this.networkEnabled = !1, this.isPrimary = !1, this.Od = s, this.Od.Fd((function(t) {
            i.Uu((function() {
                return r(o, void 0, void 0, (function() {
                    return u(this, (function(t) {
                        switch (t.label) {
                          case 0:
                            return this.xd() ? (A(Tu, "Restarting streams for network reachability change."), 
                            [ 4 /*yield*/ , this.jd() ]) : [ 3 /*break*/ , 2 ];

                          case 1:
                            t.sent(), t.label = 2;

                          case 2:
                            return [ 2 /*return*/ ];
                        }
                    }));
                }));
            }));
        })), this.Ud = new Iu(i, e), 
        // Create streams (but note they're not started yet).
        this.Ld = this.vd.Nl({
            _l: this.Bd.bind(this),
            ml: this.Md.bind(this),
            Tl: this.qd.bind(this)
        }), this.Qd = this.vd.Vl({
            _l: this.Gd.bind(this),
            ml: this.Wd.bind(this),
            Sl: this.zd.bind(this),
            Pl: this.Pl.bind(this)
        });
    }
    /**
     * Starts up the remote store, creating streams, restoring state from
     * LocalStore, etc.
     */    return t.prototype.start = function() {
        return this.enableNetwork();
    }, 
    /** Re-enables the network. Idempotent. */
    t.prototype.enableNetwork = function() {
        return r(this, void 0, void 0, (function() {
            var t;
            return u(this, (function(n) {
                switch (n.label) {
                  case 0:
                    return this.networkEnabled = !0, this.xd() ? (t = this.Qd, [ 4 /*yield*/ , this.Oc.Io() ]) : [ 3 /*break*/ , 3 ];

                  case 1:
                    // This will start the write stream if necessary.
                    return t.lastStreamToken = n.sent(), this.Kd() ? this.Hd() : this.Ud.set(Sn.Ti), 
                    [ 4 /*yield*/ , this.Jd() ];

                  case 2:
                    // This will start the write stream if necessary.
                    n.sent(), n.label = 3;

                  case 3:
                    return [ 2 /*return*/ ];
                }
            }));
        }));
    }, 
    /**
     * Temporarily disables the network. The network can be re-enabled using
     * enableNetwork().
     */
    t.prototype.disableNetwork = function() {
        return r(this, void 0, void 0, (function() {
            return u(this, (function(t) {
                switch (t.label) {
                  case 0:
                    return this.networkEnabled = !1, [ 4 /*yield*/ , this.Yd() ];

                  case 1:
                    return t.sent(), 
                    // Set the OnlineState to Offline so get()s return from cache, etc.
                    this.Ud.set(Sn.Ri), [ 2 /*return*/ ];
                }
            }));
        }));
    }, t.prototype.Yd = function() {
        return r(this, void 0, void 0, (function() {
            return u(this, (function(t) {
                switch (t.label) {
                  case 0:
                    return [ 4 /*yield*/ , this.Qd.stop() ];

                  case 1:
                    return t.sent(), [ 4 /*yield*/ , this.Ld.stop() ];

                  case 2:
                    return t.sent(), this.Vd.length > 0 && (A(Tu, "Stopping write stream with " + this.Vd.length + " pending writes"), 
                    this.Vd = []), this.Xd(), [ 2 /*return*/ ];
                }
            }));
        }));
    }, t.prototype.shutdown = function() {
        return r(this, void 0, void 0, (function() {
            return u(this, (function(t) {
                switch (t.label) {
                  case 0:
                    return A(Tu, "RemoteStore shutting down."), this.networkEnabled = !1, [ 4 /*yield*/ , this.Yd() ];

                  case 1:
                    return t.sent(), this.Od.shutdown(), 
                    // Set the OnlineState to Unknown (rather than Offline) to avoid potentially
                    // triggering spurious listener events with cached data, etc.
                    this.Ud.set(Sn.Ti), [ 2 /*return*/ ];
                }
            }));
        }));
    }, 
    /**
     * Starts new listen for the given target. Uses resume token if provided. It
     * is a no-op if the target of given `TargetData` is already being listened to.
     */
    t.prototype.listen = function(t) {
        K(this.Nd, t.targetId) || (
        // Mark this as something the client is currently listening for.
        this.Nd[t.targetId] = t, this.Kd() ? 
        // The listen will be sent in onWatchStreamOpen
        this.Hd() : this.Ld.hl() && this.$d(t));
    }, 
    /**
     * Removes the listen from server. It is a no-op if the given target id is
     * not being listened to.
     */
    t.prototype.Zd = function(t) {
        C(K(this.Nd, t), "unlisten called on target no currently watched: " + t), delete this.Nd[t], 
        this.Ld.hl() && this.tv(t), X(this.Nd) && (this.Ld.hl() ? this.Ld.fl() : this.xd() && 
        // Revert to OnlineState.Unknown if the watch stream is not open and we
        // have no listeners, since without any listens to send we cannot
        // confirm if the stream is healthy and upgrade to OnlineState.Online.
        this.Ud.set(Sn.Ti));
    }, 
    /** {@link TargetMetadataProvider.getTargetDataForTarget} */
    t.prototype.Xe = function(t) {
        return this.Nd[t] || null;
    }, 
    /** {@link TargetMetadataProvider.getRemoteKeysForTarget} */
    t.prototype.Ye = function(t) {
        return this.nv.Ye(t);
    }, 
    /**
     * We need to increment the the expected number of pending responses we're due
     * from watch so we wait for the ack to process any messages from this target.
     */
    t.prototype.$d = function(t) {
        this.kd.Pe(t.targetId), this.Ld.watch(t);
    }, 
    /**
     * We need to increment the expected number of pending responses we're due
     * from watch so we wait for the removal on the server before we process any
     * messages from this target.
     */
    t.prototype.tv = function(t) {
        this.kd.Pe(t), this.Ld.El(t);
    }, t.prototype.Hd = function() {
        C(this.Kd(), "startWatchStream() called when shouldStartWatchStream() is false."), 
        this.kd = new Vi(this), this.Ld.start(), this.Ud.Ad();
    }, 
    /**
     * Returns whether the watch stream should be started because it's necessary
     * and has not yet been started.
     */
    t.prototype.Kd = function() {
        return this.xd() && !this.Ld.ol() && !X(this.Nd);
    }, t.prototype.xd = function() {
        return this.isPrimary && this.networkEnabled;
    }, t.prototype.Xd = function() {
        this.kd = null;
    }, t.prototype.Bd = function() {
        return r(this, void 0, void 0, (function() {
            var t = this;
            return u(this, (function(n) {
                return J(this.Nd, (function(n, i) {
                    t.$d(i);
                })), [ 2 /*return*/ ];
            }));
        }));
    }, t.prototype.Md = function(t) {
        return r(this, void 0, void 0, (function() {
            return u(this, (function(n) {
                return void 0 === t && 
                // Graceful stop (due to stop() or idle timeout). Make sure that's
                // desirable.
                C(!this.Kd(), "Watch stream was stopped gracefully while still needed."), this.Xd(), 
                // If we still need the watch stream, retry the connection.
                this.Kd() ? (this.Ud.Sd(t), this.Hd()) : 
                // No need to restart watch stream because there are no active targets.
                // The online state is set to unknown because there is no active attempt
                // at establishing a connection
                this.Ud.set(Sn.Ti), [ 2 /*return*/ ];
            }));
        }));
    }, t.prototype.qd = function(t, n) {
        return r(this, void 0, void 0, (function() {
            var i;
            return u(this, (function(e) {
                switch (e.label) {
                  case 0:
                    // Mark the client as online since we got a message from the server
                    return this.Ud.set(Sn.Ei), t instanceof Si && t.state === _i.qi && t.cause ? [ 2 /*return*/ , this.iv(t) ] : (t instanceof Di ? this.kd.xe(t) : t instanceof Pi ? this.kd.Ge(t) : (C(t instanceof Si, "Expected watchChange to be an instance of WatchTargetChange"), 
                    this.kd.Le(t)), n.isEqual(yt.MIN) ? [ 3 /*break*/ , 3 ] : [ 4 /*yield*/ , this.Oc.Uh() ]);

                  case 1:
                    return i = e.sent(), n.h(i) >= 0 ? [ 4 /*yield*/ , this.ev(n) ] : [ 3 /*break*/ , 3 ];

                    // We have received a target change with a global snapshot if the snapshot
                    // version is not equal to SnapshotVersion.MIN.
                                      case 2:
                    // We have received a target change with a global snapshot if the snapshot
                    // version is not equal to SnapshotVersion.MIN.
                    e.sent(), e.label = 3;

                  case 3:
                    return [ 2 /*return*/ ];
                }
            }));
        }));
    }, 
    /**
     * Takes a batch of changes from the Datastore, repackages them as a
     * RemoteEvent, and passes that on to the listener, which is typically the
     * SyncEngine.
     */
    t.prototype.ev = function(t) {
        var n = this;
        C(!t.isEqual(yt.MIN), "Can't raise event for unknown SnapshotVersion");
        var i = this.kd.Ke(t);
        // Update in-memory resume tokens. LocalStore will update the
        // persistent view of these when applying the completed RemoteEvent.
                // Finally raise remote event
        return J(i.te, (function(i, e) {
            if (e.resumeToken.Cn() > 0) {
                var r = n.Nd[i];
                // A watched target might have been removed already.
                                r && (n.Nd[i] = r.xi(e.resumeToken, t));
            }
        })), 
        // Re-establish listens for the targets that have been invalidated by
        // existence filter mismatches.
        i.ne.forEach((function(t) {
            var i = n.Nd[t];
            if (i) {
                // Clear the resume token for the target, since we're in a known mismatch
                // state.
                n.Nd[t] = i.xi(Jn.Si, i.Oi), 
                // Cause a hard reset by unwatching and rewatching immediately, but
                // deliberately don't send a resume token so that we get a full update.
                n.tv(t);
                // Mark the target we send as being on behalf of an existence filter
                // mismatch, but don't actually retain that in listenTargets. This ensures
                // that we flag the first re-listen this way without impacting future
                // listens of this target (that might happen e.g. on reconnect).
                var e = new ti(i.target, t, Kn.Vi, i.sequenceNumber);
                n.$d(e);
            }
        })), this.nv.Lh(i);
    }, 
    /** Handles an error on a target */
    t.prototype.iv = function(t) {
        var n = this;
        C(!!t.cause, "Handling target error without a cause");
        var i = t.cause, e = Promise.resolve();
        return t.targetIds.forEach((function(t) {
            e = e.then((function() {
                return r(n, void 0, void 0, (function() {
                    return u(this, (function(n) {
                        // A watched target might have been removed already.
                        return K(this.Nd, t) ? (delete this.Nd[t], this.kd.removeTarget(t), [ 2 /*return*/ , this.nv.rv(t, i) ]) : [ 2 /*return*/ ];
                    }));
                }));
            }));
        })), e;
    }, 
    /**
     * Attempts to fill our write pipeline with writes from the LocalStore.
     *
     * Called internally to bootstrap or refill the write pipeline and by
     * SyncEngine whenever there are new mutations to process.
     *
     * Starts the write stream if necessary.
     */
    t.prototype.Jd = function() {
        return r(this, void 0, void 0, (function() {
            var t, n;
            return u(this, (function(i) {
                switch (i.label) {
                  case 0:
                    return this.uv() ? (t = this.Vd.length > 0 ? this.Vd[this.Vd.length - 1].batchId : -1, 
                    [ 4 /*yield*/ , this.Oc.Jh(t) ]) : [ 3 /*break*/ , 4 ];

                  case 1:
                    return null !== (n = i.sent()) ? [ 3 /*break*/ , 2 ] : (0 === this.Vd.length && this.Qd.fl(), 
                    [ 3 /*break*/ , 4 ]);

                  case 2:
                    return this.sv(n), [ 4 /*yield*/ , this.Jd() ];

                  case 3:
                    i.sent(), i.label = 4;

                  case 4:
                    return this.ov() && this.hv(), [ 2 /*return*/ ];
                }
            }));
        }));
    }, 
    /**
     * Returns true if we can add to the write pipeline (i.e. the network is
     * enabled and the write pipeline is not full).
     */
    t.prototype.uv = function() {
        return this.xd() && this.Vd.length < 10;
    }, 
    // For testing
    t.prototype.cv = function() {
        return this.Vd.length;
    }, 
    /**
     * Queues additional writes to be sent to the write stream, sending them
     * immediately if the write stream is established.
     */
    t.prototype.sv = function(t) {
        C(this.uv(), "addToWritePipeline called when pipeline is full"), this.Vd.push(t), 
        this.Qd.hl() && this.Qd.Al && this.Qd.Dl(t.mutations);
    }, t.prototype.ov = function() {
        return this.xd() && !this.Qd.ol() && this.Vd.length > 0;
    }, t.prototype.hv = function() {
        C(this.ov(), "startWriteStream() called when shouldStartWriteStream() is false."), 
        this.Qd.start();
    }, t.prototype.Gd = function() {
        return r(this, void 0, void 0, (function() {
            return u(this, (function(t) {
                return this.Qd.Cl(), [ 2 /*return*/ ];
            }));
        }));
    }, t.prototype.zd = function() {
        var t = this;
        // Record the stream token.
                return this.Oc.To(this.Qd.lastStreamToken).then((function() {
            // Send the write pipeline now that the stream is established.
            for (var n = 0, i = t.Vd; n < i.length; n++) {
                var e = i[n];
                t.Qd.Dl(e.mutations);
            }
        })).catch(Ue);
    }, t.prototype.Pl = function(t, n) {
        var i = this;
        // This is a response to a write containing mutations and should be
        // correlated to the first write in our write pipeline.
                C(this.Vd.length > 0, "Got result for empty write pipeline");
        var e = this.Vd.shift(), r = ce.from(e, t, n, this.Qd.lastStreamToken);
        return this.nv.av(r).then((function() {
            // It's possible that with the completion of this mutation another
            // slot has freed up.
            return i.Jd();
        }));
    }, t.prototype.Wd = function(t) {
        return r(this, void 0, void 0, (function() {
            var n = this;
            return u(this, (function(i) {
                // If the write stream closed due to an error, invoke the error callbacks if
                // there are pending writes.
                return void 0 === t && 
                // Graceful stop (due to stop() or idle timeout). Make sure that's
                // desirable.
                C(!this.ov(), "Write stream was stopped gracefully while still needed."), t && this.Vd.length > 0 ? (void 0, 
                [ 2 /*return*/ , (this.Qd.Al ? this.fv(t) : this.lv(t)).then((function() {
                    // The write stream might have been started by refilling the write
                    // pipeline for failed writes
                    n.ov() && n.hv();
                })) ]) : [ 2 /*return*/ ];
            }));
        }));
    }, t.prototype.lv = function(t) {
        return r(this, void 0, void 0, (function() {
            return u(this, (function(n) {
                // Reset the token if it's a permanent error, signaling the write stream is
                // no longer valid. Note that the handshake does not count as a write: see
                // comments on isPermanentWriteError for details.
                return ii(t.code) ? (A(Tu, "RemoteStore error before completed handshake; resetting stream token: ", this.Qd.lastStreamToken), 
                this.Qd.lastStreamToken = Jn.Si, [ 2 /*return*/ , this.Oc.To(Jn.Si).catch(Ue) ]) : [ 2 /*return*/ ];
            }));
        }));
    }, t.prototype.fv = function(t) {
        return r(this, void 0, void 0, (function() {
            var n, i = this;
            return u(this, (function(e) {
                // Only handle permanent errors here. If it's transient, just let the retry
                // logic kick in.
                return ii(r = t.code) && r !== L.ABORTED ? (n = this.Vd.shift(), 
                // In this case it's also unlikely that the server itself is melting
                // down -- this was just a bad request so inhibit backoff on the next
                // restart.
                this.Qd.al(), [ 2 /*return*/ , this.nv.dv(n.batchId, t).then((function() {
                    // It's possible that with the completion of this mutation
                    // another slot has freed up.
                    return i.Jd();
                })) ]) : [ 2 /*return*/ ];
                var r;
                /**
 * Maps an error Code from a GRPC status identifier like 'NOT_FOUND'.
 *
 * @returns The Code equivalent to the given status string or undefined if
 *     there is no match.
 */            }));
        }));
    }, t.prototype.vv = function() {
        return new _u(this.vd);
    }, t.prototype.jd = function() {
        return r(this, void 0, void 0, (function() {
            return u(this, (function(t) {
                switch (t.label) {
                  case 0:
                    return this.networkEnabled = !1, [ 4 /*yield*/ , this.Yd() ];

                  case 1:
                    return t.sent(), this.Ud.set(Sn.Ti), [ 4 /*yield*/ , this.enableNetwork() ];

                  case 2:
                    return t.sent(), [ 2 /*return*/ ];
                }
            }));
        }));
    }, t.prototype.wv = function() {
        return r(this, void 0, void 0, (function() {
            return u(this, (function(t) {
                switch (t.label) {
                  case 0:
                    return this.xd() ? (
                    // Tear down and re-create our network streams. This will ensure we get a fresh auth token
                    // for the new user and re-fill the write pipeline with new mutations from the LocalStore
                    // (since mutations are per-user).
                    A(Tu, "RemoteStore restarting streams for new credential"), [ 4 /*yield*/ , this.jd() ]) : [ 3 /*break*/ , 2 ];

                  case 1:
                    t.sent(), t.label = 2;

                  case 2:
                    return [ 2 /*return*/ ];
                }
            }));
        }));
    }, 
    /**
     * Toggles the network state when the client gains or loses its primary lease.
     */
    t.prototype.mv = function(t) {
        return r(this, void 0, void 0, (function() {
            return u(this, (function(n) {
                switch (n.label) {
                  case 0:
                    return this.isPrimary = t, t && this.networkEnabled ? [ 4 /*yield*/ , this.enableNetwork() ] : [ 3 /*break*/ , 2 ];

                  case 1:
                    return n.sent(), [ 3 /*break*/ , 4 ];

                  case 2:
                    return t ? [ 3 /*break*/ , 4 ] : [ 4 /*yield*/ , this.Yd() ];

                  case 3:
                    n.sent(), this.Ud.set(Sn.Ti), n.label = 4;

                  case 4:
                    return [ 2 /*return*/ ];
                }
            }));
        }));
    }, t;
}(), Ru = "firestore_clients";

/**
 * @license
 * Copyright 2018 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** Assembles the key for a client state in WebStorage */
function Au(t, n) {
    return C(-1 === n.indexOf("_"), "Client key cannot contain '_', but was '" + n + "'"), 
    Ru + "_" + t + "_" + n;
}

// The format of the WebStorage key that stores the mutation state is:
//     firestore_mutations_<persistence_prefix>_<batch_id>
//     (for unauthenticated users)
// or: firestore_mutations_<persistence_prefix>_<batch_id>_<user_uid>
//
// 'user_uid' is last to avoid needing to escape '_' characters that it might
// contain.
var Du = "firestore_mutations";

/** Assembles the key for a mutation batch in WebStorage */ function Pu(t, n, i) {
    var e = Du + "_" + t + "_" + i;
    return n.l() && (e += "_" + n.uid), e;
}

// The format of the WebStorage key that stores a query target's metadata is:
//     firestore_targets_<persistence_prefix>_<target_id>
var Su = "firestore_targets";

/** Assembles the key for a query state in WebStorage */ function Cu(t, n) {
    return Su + "_" + t + "_" + n;
}

// The WebStorage prefix that stores the primary tab's online state. The
// format of the key is:
//     firestore_online_state_<persistence_prefix>
var Vu = "firestore_online_state";

/** Assembles the key for the online state of the primary tab. */
// The WebStorage key prefix for the key that stores the last sequence number allocated. The key
// looks like 'firestore_sequence_number_<persistence_prefix>'.
var Nu = "firestore_sequence_number";

/** Assembles the key for the current sequence number. */
/**
 * @license
 * Copyright 2018 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var ku = "SharedClientState", Ou = /** @class */ function() {
    function t(t, n, i, e) {
        this.user = t, this.batchId = n, this.state = i, this.error = e, C(void 0 !== e == ("rejected" === i), "MutationMetadata must contain an error iff state is 'rejected'");
    }
    /**
     * Parses a MutationMetadata from its JSON representation in WebStorage.
     * Logs a warning and returns null if the format of the data is not valid.
     */    return t.pv = function(n, i, e) {
        var r = JSON.parse(e), u = "object" == typeof r && -1 !== [ "pending", "acknowledged", "rejected" ].indexOf(r.state) && (void 0 === r.error || "object" == typeof r.error), s = void 0;
        return u && r.error && (u = "string" == typeof r.error.message && "string" == typeof r.error.code) && (s = new B(r.error.code, r.error.message)), 
        u ? new t(n, i, r.state, s) : (D(ku, "Failed to parse mutation state for ID '" + i + "': " + e), 
        null);
    }, t.prototype.gv = function() {
        var t = {
            state: this.state,
            updateTimeMs: Date.now()
        };
        return this.error && (t.error = {
            code: this.error.code,
            message: this.error.message
        }), JSON.stringify(t);
    }, t;
}(), Fu = /** @class */ function() {
    function t(t, n, i) {
        this.targetId = t, this.state = n, this.error = i, C(void 0 !== i == ("rejected" === n), "QueryTargetMetadata must contain an error iff state is 'rejected'");
    }
    /**
     * Parses a QueryTargetMetadata from its JSON representation in WebStorage.
     * Logs a warning and returns null if the format of the data is not valid.
     */    return t.pv = function(n, i) {
        var e = JSON.parse(i), r = "object" == typeof e && -1 !== [ "not-current", "current", "rejected" ].indexOf(e.state) && (void 0 === e.error || "object" == typeof e.error), u = void 0;
        return r && e.error && (r = "string" == typeof e.error.message && "string" == typeof e.error.code) && (u = new B(e.error.code, e.error.message)), 
        r ? new t(n, e.state, u) : (D(ku, "Failed to parse target state for ID '" + n + "': " + i), 
        null);
    }, t.prototype.gv = function() {
        var t = {
            state: this.state,
            updateTimeMs: Date.now()
        };
        return this.error && (t.error = {
            code: this.error.code,
            message: this.error.message
        }), JSON.stringify(t);
    }, t;
}(), xu = /** @class */ function() {
    function t(t, n) {
        this.clientId = t, this.activeTargetIds = n;
    }
    /**
     * Parses a RemoteClientState from the JSON representation in WebStorage.
     * Logs a warning and returns null if the format of the data is not valid.
     */    return t.pv = function(n, i) {
        for (var e = JSON.parse(i), r = "object" == typeof e && e.activeTargetIds instanceof Array, u = wi(), s = 0; r && s < e.activeTargetIds.length; ++s) r = Rn(e.activeTargetIds[s]), 
        u = u.add(e.activeTargetIds[s]);
        return r ? new t(n, u) : (D(ku, "Failed to parse client data for instance '" + n + "': " + i), 
        null);
    }, t;
}(), ju = /** @class */ function() {
    function t(t, n) {
        this.clientId = t, this.onlineState = n;
    }
    /**
     * Parses a SharedOnlineState from its JSON representation in WebStorage.
     * Logs a warning and returns null if the format of the data is not valid.
     */    return t.pv = function(n) {
        var i = JSON.parse(n);
        return "object" == typeof i && i.onlineState in Sn && "string" == typeof i.clientId ? new t(i.clientId, Sn[i.onlineState]) : (D(ku, "Failed to parse online state: " + n), 
        null);
    }, t;
}(), Uu = /** @class */ function() {
    function t() {
        this.activeTargetIds = wi();
    }
    return t.prototype.bv = function(t) {
        this.activeTargetIds = this.activeTargetIds.add(t);
    }, t.prototype.yv = function(t) {
        this.activeTargetIds = this.activeTargetIds.delete(t);
    }, 
    /**
     * Converts this entry into a JSON-encoded format we can use for WebStorage.
     * Does not encode `clientId` as it is part of the key in WebStorage.
     */
    t.prototype.gv = function() {
        var t = {
            activeTargetIds: this.activeTargetIds.tt(),
            updateTimeMs: Date.now()
        };
        return JSON.stringify(t);
    }, t;
}(), Lu = /** @class */ function() {
    function t(n, i, e, r, u) {
        if (this.Da = n, this.platform = i, this.persistenceKey = e, this._v = r, this.nv = null, 
        this.Id = null, this.wu = null, this.Iv = {}, this.Tv = this.Ev.bind(this), this.ph = !1, 
        /**
         * Captures WebStorage events that occur before `start()` is called. These
         * events are replayed once `WebStorageSharedClientState` is started.
         */
        this.Rv = [], !t.Js(this.platform)) throw new B(L.UNIMPLEMENTED, "LocalStorage is not available on this platform.");
        // Escape the special characters mentioned here:
        // https://developer.mozilla.org/en-US/docs/Web/JavaScript/Guide/Regular_Expressions
                var s = e.replace(/[.*+?^${}()|[\]\\]/g, "\\$&");
        this.storage = this.platform.window.localStorage, this.currentUser = u, this.Av = Au(this.persistenceKey, this._v), 
        this.Dv = function(t) {
            return Nu + "_" + t;
        }(this.persistenceKey), this.Iv[this._v] = new Uu, this.Pv = new RegExp("^" + Ru + "_" + s + "_([^_]*)$"), 
        this.Sv = new RegExp("^" + Du + "_" + s + "_(\\d+)(?:_(.*))?$"), this.Cv = new RegExp("^" + Su + "_" + s + "_(\\d+)$"), 
        this.Vv = function(t) {
            return Vu + "_" + t;
        }(this.persistenceKey), 
        // Rather than adding the storage observer during start(), we add the
        // storage observer during initialization. This ensures that we collect
        // events before other components populate their initial state (during their
        // respective start() calls). Otherwise, we might for example miss a
        // mutation that is added after LocalStore's start() processed the existing
        // mutations but before we observe WebStorage events.
        this.platform.window.addEventListener("storage", this.Tv);
    }
    /** Returns 'true' if WebStorage is available in the current environment. */    return t.Js = function(t) {
        return !(!t.window || null == t.window.localStorage);
    }, t.prototype.start = function() {
        return r(this, void 0, void 0, (function() {
            var t, n, i, e, r, s, o, h, c, a, f, l = this;
            return u(this, (function(u) {
                switch (u.label) {
                  case 0:
                    return C(!this.ph, "WebStorageSharedClientState already started"), C(null !== this.nv, "syncEngine property must be set before calling start()"), 
                    C(null !== this.Id, "onlineStateHandler property must be set before calling start()"), 
                    [ 4 /*yield*/ , this.nv.sc() ];

                  case 1:
                    for (t = u.sent(), n = 0, i = t; n < i.length; n++) (e = i[n]) !== this._v && (r = this.getItem(Au(this.persistenceKey, e))) && (s = xu.pv(e, r)) && (this.Iv[s.clientId] = s);
                    for (this.Nv(), (o = this.storage.getItem(this.Vv)) && (h = this.kv(o)) && this.Ov(h), 
                    c = 0, a = this.Rv; c < a.length; c++) f = a[c], this.Ev(f);
                    return this.Rv = [], 
                    // Register a window unload hook to remove the client metadata entry from
                    // WebStorage even if `shutdown()` was not called.
                    this.platform.window.addEventListener("unload", (function() {
                        return l.shutdown();
                    })), this.ph = !0, [ 2 /*return*/ ];
                }
            }));
        }));
    }, t.prototype.gu = function(t) {
        this.setItem(this.Dv, JSON.stringify(t));
    }, t.prototype.Fv = function() {
        var t = wi();
        return Y(this.Iv, (function(n, i) {
            t = t.qt(i.activeTargetIds);
        })), t;
    }, t.prototype.xv = function(t) {
        // This is not using `obj.forEach` since `forEach` doesn't support early
        // return.
        for (var n in this.Iv) if (this.Iv.hasOwnProperty(n) && this.Iv[n].activeTargetIds.has(t)) return !0;
        return !1;
    }, t.prototype.jv = function(t) {
        this.Uv(t, "pending");
    }, t.prototype.Lv = function(t, n, i) {
        this.Uv(t, n, i), 
        // Once a final mutation result is observed by other clients, they no longer
        // access the mutation's metadata entry. Since WebStorage replays events
        // in order, it is safe to delete the entry right after updating it.
        this.Bv(t);
    }, t.prototype.Mv = function(t) {
        var n = "not-current";
        // Lookup an existing query state if the target ID was already registered
        // by another tab
                if (this.xv(t)) {
            var i = this.storage.getItem(Cu(this.persistenceKey, t));
            if (i) {
                var e = Fu.pv(t, i);
                e && (n = e.state);
            }
        }
        return this.qv.bv(t), this.Nv(), n;
    }, t.prototype.Qv = function(t) {
        this.qv.yv(t), this.Nv();
    }, t.prototype.Gv = function(t) {
        return this.qv.activeTargetIds.has(t);
    }, t.prototype.Wv = function(t) {
        this.removeItem(Cu(this.persistenceKey, t));
    }, t.prototype.zv = function(t, n, i) {
        this.Kv(t, n, i);
    }, t.prototype.Ph = function(t, n, i) {
        var e = this;
        n.forEach((function(t) {
            e.Bv(t);
        })), this.currentUser = t, i.forEach((function(t) {
            e.jv(t);
        }));
    }, t.prototype.Hv = function(t) {
        this.Jv(t);
    }, t.prototype.shutdown = function() {
        this.ph && (this.platform.window.removeEventListener("storage", this.Tv), this.removeItem(this.Av), 
        this.ph = !1);
    }, t.prototype.getItem = function(t) {
        var n = this.storage.getItem(t);
        return A(ku, "READ", t, n), n;
    }, t.prototype.setItem = function(t, n) {
        A(ku, "SET", t, n), this.storage.setItem(t, n);
    }, t.prototype.removeItem = function(t) {
        A(ku, "REMOVE", t), this.storage.removeItem(t);
    }, t.prototype.Ev = function(t) {
        var n = this;
        if (t.storageArea === this.storage) {
            if (A(ku, "EVENT", t.key, t.newValue), t.key === this.Av) return void D("Received WebStorage notification for local change. Another client might have garbage-collected our state");
            this.Da.Uu((function() {
                return r(n, void 0, void 0, (function() {
                    var n, i, e, r, s, o;
                    return u(this, (function(u) {
                        if (!this.ph) return this.Rv.push(t), [ 2 /*return*/ ];
                        if (null === t.key) return [ 2 /*return*/ ];
                        if (this.Pv.test(t.key)) {
                            if (null == t.newValue) return i = this.Yv(t.key), [ 2 /*return*/ , this.Xv(i, null) ];
                            if (n = this.$v(t.key, t.newValue)) return [ 2 /*return*/ , this.Xv(n.clientId, n) ];
                        } else if (this.Sv.test(t.key)) {
                            if (null !== t.newValue && (e = this.Zv(t.key, t.newValue))) return [ 2 /*return*/ , this.tw(e) ];
                        } else if (this.Cv.test(t.key)) {
                            if (null !== t.newValue && (r = this.nw(t.key, t.newValue))) return [ 2 /*return*/ , this.iw(r) ];
                        } else if (t.key === this.Vv) {
                            if (null !== t.newValue && (s = this.kv(t.newValue))) return [ 2 /*return*/ , this.Ov(s) ];
                        } else t.key === this.Dv && (C(!!this.wu, "Missing sequenceNumberHandler"), (o = function(t) {
                            var n = Yi.bu;
                            if (null != t) try {
                                var i = JSON.parse(t);
                                C("number" == typeof i, "Found non-numeric sequence number"), n = i;
                            } catch (t) {
                                D(ku, "Failed to read sequence number from WebStorage", t);
                            }
                            return n;
                        }
                        /**
 * `MemorySharedClientState` is a simple implementation of SharedClientState for
 * clients using memory persistence. The state in this class remains fully
 * isolated and no synchronization is performed.
 */ (t.newValue)) !== Yi.bu && this.wu(o));
                        return [ 2 /*return*/ ];
                    }));
                }));
            }));
        }
    }, Object.defineProperty(t.prototype, "qv", {
        get: function() {
            return this.Iv[this._v];
        },
        enumerable: !0,
        configurable: !0
    }), t.prototype.Nv = function() {
        this.setItem(this.Av, this.qv.gv());
    }, t.prototype.Uv = function(t, n, i) {
        var e = new Ou(this.currentUser, t, n, i), r = Pu(this.persistenceKey, this.currentUser, t);
        this.setItem(r, e.gv());
    }, t.prototype.Bv = function(t) {
        var n = Pu(this.persistenceKey, this.currentUser, t);
        this.removeItem(n);
    }, t.prototype.Jv = function(t) {
        var n = {
            clientId: this._v,
            onlineState: Sn[t]
        };
        this.storage.setItem(this.Vv, JSON.stringify(n));
    }, t.prototype.Kv = function(t, n, i) {
        var e = Cu(this.persistenceKey, t), r = new Fu(t, n, i);
        this.setItem(e, r.gv());
    }, 
    /**
     * Parses a client state key in WebStorage. Returns null if the key does not
     * match the expected key format.
     */
    t.prototype.Yv = function(t) {
        var n = this.Pv.exec(t);
        return n ? n[1] : null;
    }, 
    /**
     * Parses a client state in WebStorage. Returns 'null' if the value could not
     * be parsed.
     */
    t.prototype.$v = function(t, n) {
        var i = this.Yv(t);
        return C(null !== i, "Cannot parse client state key '" + t + "'"), xu.pv(i, n);
    }, 
    /**
     * Parses a mutation batch state in WebStorage. Returns 'null' if the value
     * could not be parsed.
     */
    t.prototype.Zv = function(t, n) {
        var i = this.Sv.exec(t);
        C(null !== i, "Cannot parse mutation batch key '" + t + "'");
        var e = Number(i[1]), r = void 0 !== i[2] ? i[2] : null;
        return Ou.pv(new U(r), e, n);
    }, 
    /**
     * Parses a query target state from WebStorage. Returns 'null' if the value
     * could not be parsed.
     */
    t.prototype.nw = function(t, n) {
        var i = this.Cv.exec(t);
        C(null !== i, "Cannot parse query target key '" + t + "'");
        var e = Number(i[1]);
        return Fu.pv(e, n);
    }, 
    /**
     * Parses an online state from WebStorage. Returns 'null' if the value
     * could not be parsed.
     */
    t.prototype.kv = function(t) {
        return ju.pv(t);
    }, t.prototype.tw = function(t) {
        return r(this, void 0, void 0, (function() {
            return u(this, (function(n) {
                return t.user.uid !== this.currentUser.uid ? (A(ku, "Ignoring mutation for non-active user " + t.user.uid), 
                [ 2 /*return*/ ]) : [ 2 /*return*/ , this.nv.ew(t.batchId, t.state, t.error) ];
            }));
        }));
    }, t.prototype.iw = function(t) {
        return this.nv.rw(t.targetId, t.state, t.error);
    }, t.prototype.Xv = function(t, n) {
        var i = this, e = this.Fv();
        n ? this.Iv[t] = n : delete this.Iv[t];
        var s = this.Fv(), o = [], h = [];
        return s.forEach((function(t) {
            return r(i, void 0, void 0, (function() {
                return u(this, (function(n) {
                    return e.has(t) || o.push(t), [ 2 /*return*/ ];
                }));
            }));
        })), e.forEach((function(t) {
            return r(i, void 0, void 0, (function() {
                return u(this, (function(n) {
                    return s.has(t) || h.push(t), [ 2 /*return*/ ];
                }));
            }));
        })), this.nv.uw(o, h);
    }, t.prototype.Ov = function(t) {
        // We check whether the client that wrote this online state is still active
        // by comparing its client ID to the list of clients kept active in
        // IndexedDb. If a client does not update their IndexedDb client state
        // within 5 seconds, it is considered inactive and we don't emit an online
        // state event.
        this.Iv[t.clientId] && this.Id(t.onlineState);
    }, t;
}();

/**
 * Holds the state of a mutation batch, including its user ID, batch ID and
 * whether the batch is 'pending', 'acknowledged' or 'rejected'.
 */
// Visible for testing
var Bu = /** @class */ function() {
    function t() {
        this.sw = new Uu, this.ow = {}, this.nv = null, this.Id = null, this.wu = null;
    }
    return t.prototype.jv = function(t) {
        // No op.
    }, t.prototype.Lv = function(t, n, i) {
        // No op.
    }, t.prototype.Mv = function(t) {
        return this.sw.bv(t), this.ow[t] || "not-current";
    }, t.prototype.zv = function(t, n, i) {
        this.ow[t] = n;
    }, t.prototype.Qv = function(t) {
        this.sw.yv(t);
    }, t.prototype.Gv = function(t) {
        return this.sw.activeTargetIds.has(t);
    }, t.prototype.Wv = function(t) {
        delete this.ow[t];
    }, t.prototype.Fv = function() {
        return this.sw.activeTargetIds;
    }, t.prototype.xv = function(t) {
        return this.sw.activeTargetIds.has(t);
    }, t.prototype.start = function() {
        return this.sw = new Uu, Promise.resolve();
    }, t.prototype.Ph = function(t, n, i) {
        // No op.
    }, t.prototype.Hv = function(t) {
        // No op.
    }, t.prototype.shutdown = function() {}, t.prototype.gu = function(t) {}, t;
}(), Mu = function(t) {
    this.key = t;
}, qu = function(t) {
    this.key = t;
}, Qu = /** @class */ function() {
    function t(t, 
    /** Documents included in the remote target */
    n) {
        this.query = t, this.hw = n, this.cw = null, 
        /**
         * A flag whether the view is current with the backend. A view is considered
         * current after it has seen the current flag from the backend and did not
         * lose consistency within the watch stream (e.g. because of an existence
         * filter mismatch).
         */
        this.se = !1, 
        /** Documents in the view but not in the remote target */
        this.aw = di(), 
        /** Document Keys that have local changes */
        this.Yi = di(), this.fw = new yi(t.fi.bind(t));
    }
    return Object.defineProperty(t.prototype, "lw", {
        /**
         * The set of remote documents that the server has told us belongs to the target associated with
         * this view.
         */
        get: function() {
            return this.hw;
        },
        enumerable: !0,
        configurable: !0
    }), 
    /**
     * Iterates over a set of doc changes, applies the query limit, and computes
     * what the new results should be, what the changes were, and whether we may
     * need to go back to the local cache for more results. Does not make any
     * changes to the view.
     * @param docChanges The doc changes to apply to this view.
     * @param previousChanges If this is being called with a refill, then start
     *        with this set of docs and changes instead of the current view.
     * @return a new set of docs, changes, and refill flag.
     */
    t.prototype.dw = function(t, n) {
        var i = this, e = n ? n.vw : new Ti, r = n ? n.fw : this.fw, u = n ? n.Yi : this.Yi, s = r, o = !1, h = this.query.mi() && r.size === this.query.limit ? r.last() : null, c = this.query.pi() && r.size === this.query.limit ? r.first() : null;
        // Drop documents out to meet limit/limitToLast requirement.
        if (t.pt((function(t, n) {
            var a = r.get(t), f = n instanceof pn ? n : null;
            f && (C(t.isEqual(f.key), "Mismatching keys found in document changes: " + t + " != " + f.key), 
            f = i.query.matches(f) ? f : null);
            var l = !!a && i.Yi.has(a.key), d = !!f && (f.un || 
            // We only consider committed mutations for documents that were
            // mutated during the lifetime of the view.
            i.Yi.has(f.key) && f.hasCommittedMutations), v = !1;
            // Calculate change
            a && f ? a.data().isEqual(f.data()) ? l !== d && (e.track({
                type: mi.Gi,
                doc: f
            }), v = !0) : i.ww(a, f) || (e.track({
                type: mi.Qi,
                doc: f
            }), v = !0, (h && i.query.fi(f, h) > 0 || c && i.query.fi(f, c) < 0) && (
            // This doc moved from inside the limit to outside the limit.
            // That means there may be some other doc in the local cache
            // that should be included instead.
            o = !0)) : !a && f ? (e.track({
                type: mi.Mi,
                doc: f
            }), v = !0) : a && !f && (e.track({
                type: mi.qi,
                doc: a
            }), v = !0, (h || c) && (
            // A doc was removed from a full limit query. We'll need to
            // requery from the local cache to see if we know about some other
            // doc that should be in the results.
            o = !0));
            v && (f ? (s = s.add(f), u = d ? u.add(t) : u.delete(t)) : (s = s.delete(t), u = u.delete(t)));
        })), this.query.mi() || this.query.pi()) for (;s.size > this.query.limit; ) {
            var a = this.query.mi() ? s.last() : s.first();
            s = s.delete(a.key), u = u.delete(a.key), e.track({
                type: mi.qi,
                doc: a
            });
        }
        return C(!o || !n, "View was refilled using docs that themselves needed refilling."), 
        {
            fw: s,
            vw: e,
            bf: o,
            Yi: u
        };
    }, t.prototype.ww = function(t, n) {
        // We suppress the initial change event for documents that were modified as
        // part of a write acknowledgment (e.g. when the value of a server transform
        // is applied) as Watch will send us the same document again.
        // By suppressing the event, we only raise two user visible events (one with
        // `hasPendingWrites` and the final state of the document) instead of three
        // (one with `hasPendingWrites`, the modified document with
        // `hasPendingWrites` and the final state of the document).
        return t.un && n.hasCommittedMutations && !n.un;
    }, 
    /**
     * Updates the view with the given ViewDocumentChanges and optionally updates
     * limbo docs and sync state from the provided target change.
     * @param docChanges The set of changes to make to the view's docs.
     * @param updateLimboDocuments Whether to update limbo documents based on this
     *        change.
     * @param targetChange A target change to apply for computing limbo docs and
     *        sync state.
     * @return A new ViewChange with the given docs, changes, and sync state.
     */
    // PORTING NOTE: The iOS/Android clients always compute limbo document changes.
    t.prototype.Qs = function(t, n, i) {
        var e = this;
        C(!t.bf, "Cannot apply changes that need a refill");
        var r = this.fw;
        this.fw = t.fw, this.Yi = t.Yi;
        // Sort changes based on type and query comparator
        var u = t.vw.Hi();
        u.sort((function(t, n) {
            return function(t, n) {
                var i = function(t) {
                    switch (t) {
                      case mi.Mi:
                        return 1;

                      case mi.Qi:
                      case mi.Gi:
                        // A metadata change is converted to a modified change at the public
                        // api layer.  Since we sort by document key and then change type,
                        // metadata and modified changes must be sorted equivalently.
                        return 2;

                      case mi.qi:
                        return 0;

                      default:
                        return S("Unknown ChangeType: " + t);
                    }
                };
                return i(t) - i(n);
            }
            /**
 * @license
 * Copyright 2019 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ (t.type, n.type) || e.query.fi(t.doc, n.doc);
        })), this.mw(i);
        var s = n ? this.pw() : [], o = 0 === this.aw.size && this.se ? gi.zi : gi.Wi, h = o !== this.cw;
        return this.cw = o, 0 !== u.length || h ? {
            snapshot: new Ei(this.query, t.fw, r, u, t.Yi, o === gi.Wi, h, 
            /* excludesMetadataChanges= */ !1),
            gw: s
        } : {
            gw: s
        };
    }, 
    /**
     * Applies an OnlineState change to the view, potentially generating a
     * ViewChange if the view's syncState changes as a result.
     */
    t.prototype.bw = function(t) {
        return this.se && t === Sn.Ri ? (
        // If we're offline, set `current` to false and then call applyChanges()
        // to refresh our syncState and generate a ViewChange as appropriate. We
        // are guaranteed to get a new TargetChange that sets `current` back to
        // true once the client is back online.
        this.se = !1, this.Qs({
            fw: this.fw,
            vw: new Ti,
            Yi: this.Yi,
            bf: !1
        }, 
        /* updateLimboDocuments= */ !1)) : {
            gw: []
        };
    }, 
    /**
     * Returns whether the doc for the given key should be in limbo.
     */
    t.prototype.yw = function(t) {
        // If the remote end says it's part of this query, it's not in limbo.
        return !this.hw.has(t) && (
        // The local store doesn't think it's a result, so it shouldn't be in limbo.
        !!this.fw.has(t) && !this.fw.get(t).un);
    }, 
    /**
     * Updates syncedDocuments, current, and limbo docs based on the given change.
     * Returns the list of changes to which docs are in limbo.
     */
    t.prototype.mw = function(t) {
        var n = this;
        t && (t.oe.forEach((function(t) {
            return n.hw = n.hw.add(t);
        })), t.he.forEach((function(t) {
            return C(n.hw.has(t), "Modified document " + t + " not found in view.");
        })), t.ce.forEach((function(t) {
            return n.hw = n.hw.delete(t);
        })), this.se = t.se);
    }, t.prototype.pw = function() {
        var t = this;
        // We can only determine limbo documents when we're in-sync with the server.
                if (!this.se) return [];
        // TODO(klimt): Do this incrementally so that it's not quadratic when
        // updating many documents.
                var n = this.aw;
        this.aw = di(), this.fw.forEach((function(n) {
            t.yw(n.key) && (t.aw = t.aw.add(n.key));
        }));
        // Diff the new limbo docs with the old limbo docs.
        var i = [];
        return n.forEach((function(n) {
            t.aw.has(n) || i.push(new qu(n));
        })), this.aw.forEach((function(t) {
            n.has(t) || i.push(new Mu(t));
        })), i;
    }, 
    /**
     * Update the in-memory state of the current view with the state read from
     * persistence.
     *
     * We update the query view whenever a client's primary status changes:
     * - When a client transitions from primary to secondary, it can miss
     *   LocalStorage updates and its query views may temporarily not be
     *   synchronized with the state on disk.
     * - For secondary to primary transitions, the client needs to update the list
     *   of `syncedDocuments` since secondary clients update their query views
     *   based purely on synthesized RemoteEvents.
     *
     * @param queryResult.documents - The documents that match the query according
     * to the LocalStore.
     * @param queryResult.remoteKeys - The keys of the documents that match the
     * query according to the backend.
     *
     * @return The ViewChange that resulted from this synchronization.
     */
    // PORTING NOTE: Multi-tab only.
    t.prototype._w = function(t) {
        this.hw = t.rc, this.aw = di();
        var n = this.dw(t.documents);
        return this.Qs(n, /*updateLimboDocuments=*/ !0);
    }, 
    /**
     * Returns a view snapshot as if this query was just listened to. Contains
     * a document add for every existing document and the `fromCache` and
     * `hasPendingWrites` status of the already established view.
     */
    // PORTING NOTE: Multi-tab only.
    t.prototype.Iw = function() {
        return Ei.Zi(this.query, this.fw, this.Yi, this.cw === gi.Wi);
    }, t;
}();

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ var Gu = 5, Wu = /** @class */ function() {
    function t(t, n, i, e) {
        this.Su = t, this.Tw = n, this.updateFunction = i, this.ku = e, this.Ew = Gu, this.sl = new Kr(this.Su, zi.Pu);
    }
    /** Runs the transaction and sets the result on deferred. */    return t.prototype.run = function() {
        this.Rw();
    }, t.prototype.Rw = function() {
        var t = this;
        this.sl.Yf((function() {
            return r(t, void 0, void 0, (function() {
                var t, n, i = this;
                return u(this, (function(e) {
                    return t = this.Tw.vv(), (n = this.Aw(t)) && n.then((function(n) {
                        i.Su.Uu((function() {
                            return t.commit().then((function() {
                                i.ku.resolve(n);
                            })).catch((function(t) {
                                i.Dw(t);
                            }));
                        }));
                    })).catch((function(t) {
                        i.Dw(t);
                    })), [ 2 /*return*/ ];
                }));
            }));
        }));
    }, t.prototype.Aw = function(t) {
        try {
            var n = this.updateFunction(t);
            return !En(n) && n.catch && n.then ? n : (this.ku.reject(Error("Transaction callback must return a Promise")), 
            null);
        } catch (t) {
            // Do not retry errors thrown by user provided updateFunction.
            return this.ku.reject(t), null;
        }
    }, t.prototype.Dw = function(t) {
        var n = this;
        this.Ew > 0 && this.Pw(t) ? (this.Ew -= 1, this.Su.Uu((function() {
            return n.Rw(), Promise.resolve();
        }))) : this.ku.reject(t);
    }, t.prototype.Pw = function(t) {
        if ("FirebaseError" === t.name) {
            // In transactions, the backend will fail outdated reads with FAILED_PRECONDITION and
            // non-matching document versions with ABORTED. These errors should be retried.
            var n = t.code;
            return "aborted" === n || "failed-precondition" === n || !ii(n);
        }
        return !1;
    }, t;
}(), zu = function(
/**
     * The query itself.
     */
t, 
/**
     * The target number created by the client that is used in the watch
     * stream to identify this query.
     */
n, 
/**
     * The view is responsible for computing the final merged truth of what
     * docs are in the query. It gets notified of local and remote changes,
     * and applies the query filters and limits to determine the most correct
     * possible results.
     */
i) {
    this.query = t, this.targetId = n, this.view = i;
}, Ku = function(t) {
    this.key = t, 
    /**
         * Set to true once we've received a document. This is used in
         * getRemoteKeysForTarget() and ultimately used by WatchChangeAggregator to
         * decide whether it needs to manufacture a delete event for the target once
         * the target is CURRENT.
         */
    this.Sw = !1;
}, Hu = /** @class */ function() {
    function t(t, n, 
    // PORTING NOTE: Manages state synchronization in multi-tab environments.
    i, e) {
        this.Oc = t, this.Tw = n, this.Cw = i, this.currentUser = e, this.Vw = null, this.Nw = new le((function(t) {
            return t.canonicalId();
        })), this.kw = {}, this.Ow = new At(Rt.G), this.Fw = {}, this.xw = new ae, 
        /** Stores user completion handlers, indexed by User and BatchId. */
        this.jw = {}, 
        /** Stores user callbacks waiting for all pending writes to be acknowledged. */
        this.Uw = new Map, this.Lw = ke.Ho(), 
        // The primary state is set to `true` or `false` immediately after Firestore
        // startup. In the interim, a client should only be considered primary if
        // `isPrimary` is true.
        this.isPrimary = void 0, this.onlineState = Sn.Ti;
    }
    return Object.defineProperty(t.prototype, "Bw", {
        // Only used for testing.
        get: function() {
            return !0 === this.isPrimary;
        },
        enumerable: !0,
        configurable: !0
    }), 
    /** Subscribes to SyncEngine notifications. Has to be called exactly once. */
    t.prototype.subscribe = function(t) {
        C(null !== t, "SyncEngine listener cannot be null"), C(null === this.Vw, "SyncEngine already has a subscriber."), 
        this.Vw = t;
    }, 
    /**
     * Initiates the new listen, resolves promise when listen enqueued to the
     * server. All the subsequent view snapshots or errors are sent to the
     * subscribed handlers. Returns the targetId of the query.
     */
    t.prototype.listen = function(t) {
        return r(this, void 0, void 0, (function() {
            var n, i, e, r, s;
            return u(this, (function(u) {
                switch (u.label) {
                  case 0:
                    return this.Mw("listen()"), (e = this.Nw.get(t)) ? (
                    // PORTING NOTE: With Multi-Tab Web, it is possible that a query view
                    // already exists when EventManager calls us for the first time. This
                    // happens when the primary tab is already listening to this query on
                    // behalf of another tab and the user of the primary also starts listening
                    // to the query. EventManager will not have an assigned target ID in this
                    // case and calls `listen` to obtain this ID.
                    n = e.targetId, this.Cw.Mv(n), i = e.view.Iw(), [ 3 /*break*/ , 4 ]) : [ 3 /*break*/ , 1 ];

                  case 1:
                    return [ 4 /*yield*/ , this.Oc.Xh(t.ai()) ];

                  case 2:
                    return r = u.sent(), s = this.Cw.Mv(r.targetId), n = r.targetId, [ 4 /*yield*/ , this.qw(t, n, "current" === s) ];

                  case 3:
                    i = u.sent(), this.isPrimary && this.Tw.listen(r), u.label = 4;

                  case 4:
                    return this.Vw.Tl([ i ]), [ 2 /*return*/ , n ];
                }
            }));
        }));
    }, 
    /**
     * Registers a view for a previously unknown query and computes its initial
     * snapshot.
     */
    t.prototype.qw = function(t, n, i) {
        return r(this, void 0, void 0, (function() {
            var e, r, s, o, h, c;
            return u(this, (function(u) {
                switch (u.label) {
                  case 0:
                    return [ 4 /*yield*/ , this.Oc.ic(t, 
                    /* usePreviousResults= */ !0) ];

                  case 1:
                    return e = u.sent(), r = new Qu(t, e.rc), s = r.dw(e.documents), o = Ai.ue(n, i && this.onlineState !== Sn.Ri), 
                    C(0 === (h = r.Qs(s, 
                    /* updateLimboDocuments= */ !0 === this.isPrimary, o)).gw.length, "View returned limbo docs before target ack from the server."), 
                    C(!!h.snapshot, "applyChanges for new view should always return a snapshot"), c = new zu(t, n, r), 
                    this.Nw.set(t, c), this.kw[n] || (this.kw[n] = []), this.kw[n].push(t), [ 2 /*return*/ , h.snapshot ];
                }
            }));
        }));
    }, 
    /**
     * Reconcile the list of synced documents in an existing view with those
     * from persistence.
     */
    // PORTING NOTE: Multi-tab only.
    t.prototype.Qw = function(t) {
        return r(this, void 0, void 0, (function() {
            var n, i;
            return u(this, (function(e) {
                switch (e.label) {
                  case 0:
                    return [ 4 /*yield*/ , this.Oc.ic(t.query, 
                    /* usePreviousResults= */ !0) ];

                  case 1:
                    return n = e.sent(), i = t.view._w(n), this.isPrimary && this.Gw(t.targetId, i.gw), 
                    [ 2 /*return*/ , i ];
                }
            }));
        }));
    }, 
    /** Stops listening to the query. */
    t.prototype.Zd = function(t) {
        return r(this, void 0, void 0, (function() {
            var n, i, e = this;
            return u(this, (function(r) {
                switch (r.label) {
                  case 0:
                    return this.Mw("unlisten()"), C(!!(n = this.Nw.get(t)), "Trying to unlisten on query not found:" + t), 
                    (i = this.kw[n.targetId]).length > 1 ? (this.kw[n.targetId] = i.filter((function(n) {
                        return !n.isEqual(t);
                    })), this.Nw.delete(t), [ 2 /*return*/ ]) : this.isPrimary ? (
                    // We need to remove the local query target first to allow us to verify
                    // whether any other client is still interested in this target.
                    this.Cw.Qv(n.targetId), this.Cw.xv(n.targetId) ? [ 3 /*break*/ , 2 ] : [ 4 /*yield*/ , this.Oc.nc(n.targetId, /*keepPersistedTargetData=*/ !1).then((function() {
                        e.Cw.Wv(n.targetId), e.Tw.Zd(n.targetId), e.Ww(n.targetId);
                    })).catch(Ue) ]) : [ 3 /*break*/ , 3 ];

                  case 1:
                    r.sent(), r.label = 2;

                  case 2:
                    return [ 3 /*break*/ , 5 ];

                  case 3:
                    return this.Ww(n.targetId), [ 4 /*yield*/ , this.Oc.nc(n.targetId, 
                    /*keepPersistedTargetData=*/ !0) ];

                  case 4:
                    r.sent(), r.label = 5;

                  case 5:
                    return [ 2 /*return*/ ];
                }
            }));
        }));
    }, 
    /**
     * Initiates the write of local mutation batch which involves adding the
     * writes to the mutation queue, notifying the remote store about new
     * mutations and raising events for any changes this write caused.
     *
     * The promise returned by this call is resolved when the above steps
     * have completed, *not* when the write was acked by the backend. The
     * userCallback is resolved once the write was acked/rejected by the
     * backend (or failed locally for any other reason).
     */
    t.prototype.write = function(t, n) {
        return r(this, void 0, void 0, (function() {
            var i;
            return u(this, (function(e) {
                switch (e.label) {
                  case 0:
                    return this.Mw("write()"), [ 4 /*yield*/ , this.Oc.Nh(t) ];

                  case 1:
                    return i = e.sent(), this.Cw.jv(i.batchId), this.zw(i.batchId, n), [ 4 /*yield*/ , this.Kw(i.Os) ];

                  case 2:
                    return e.sent(), [ 4 /*yield*/ , this.Tw.Jd() ];

                  case 3:
                    return e.sent(), [ 2 /*return*/ ];
                }
            }));
        }));
    }, 
    /**
     * Takes an updateFunction in which a set of reads and writes can be performed
     * atomically. In the updateFunction, the client can read and write values
     * using the supplied transaction object. After the updateFunction, all
     * changes will be committed. If a retryable error occurs (ex: some other
     * client has changed any of the data referenced), then the updateFunction
     * will be called again after a backoff. If the updateFunction still fails
     * after all retries, then the transaction will be rejected.
     *
     * The transaction object passed to the updateFunction contains methods for
     * accessing documents and collections. Unlike other datastore access, data
     * accessed with the transaction will not reflect local changes that have not
     * been committed. For this reason, it is required that all reads are
     * performed before any writes. Transactions must be performed while online.
     *
     * The Deferred input is resolved when the transaction is fully committed.
     */
    t.prototype.runTransaction = function(t, n, i) {
        new Wu(t, this.Tw, n, i).run();
    }, t.prototype.Lh = function(t) {
        return r(this, void 0, void 0, (function() {
            var n, i = this;
            return u(this, (function(e) {
                switch (e.label) {
                  case 0:
                    this.Mw("applyRemoteEvent()"), e.label = 1;

                  case 1:
                    return e.trys.push([ 1, 4, , 6 ]), [ 4 /*yield*/ , this.Oc.Lh(t) ];

                  case 2:
                    return n = e.sent(), 
                    // Update `receivedDocument` as appropriate for any limbo targets.
                    Y(t.te, (function(t, n) {
                        var e = i.Fw[Number(t)];
                        e && (
                        // Since this is a limbo resolution lookup, it's for a single document
                        // and it could be added, modified, or removed, but not a combination.
                        C(n.oe.size + n.he.size + n.ce.size <= 1, "Limbo resolution for single document contains multiple changes."), 
                        n.oe.size > 0 ? e.Sw = !0 : n.he.size > 0 ? C(e.Sw, "Received change for limbo target document without add.") : n.ce.size > 0 && (C(e.Sw, "Received remove for limbo target document without add."), 
                        e.Sw = !1));
                    })), [ 4 /*yield*/ , this.Kw(n, t) ];

                  case 3:
                    return e.sent(), [ 3 /*break*/ , 6 ];

                  case 4:
                    return [ 4 /*yield*/ , Ue(e.sent()) ];

                  case 5:
                    return e.sent(), [ 3 /*break*/ , 6 ];

                  case 6:
                    return [ 2 /*return*/ ];
                }
            }));
        }));
    }, 
    /**
     * Applies an OnlineState change to the sync engine and notifies any views of
     * the change.
     */
    t.prototype.bw = function(t, n) {
        // If we are the secondary client, we explicitly ignore the remote store's
        // online state (the local client may go offline, even though the primary
        // tab remains online) and only apply the primary tab's online state from
        // SharedClientState.
        if (this.isPrimary && n === Vn.Ai || !this.isPrimary && n === Vn.Di) {
            this.Mw("applyOnlineStateChange()");
            var i = [];
            this.Nw.forEach((function(n, e) {
                var r = e.view.bw(t);
                C(0 === r.gw.length, "OnlineState should not affect limbo documents."), r.snapshot && i.push(r.snapshot);
            })), this.Vw.Hw(t), this.Vw.Tl(i), this.onlineState = t, this.isPrimary && this.Cw.Hv(t);
        }
    }, t.prototype.rv = function(t, n) {
        return r(this, void 0, void 0, (function() {
            var i, e, r, s, o, h = this;
            return u(this, (function(u) {
                switch (u.label) {
                  case 0:
                    return this.Mw("rejectListens()"), 
                    // PORTING NOTE: Multi-tab only.
                    this.Cw.zv(t, "rejected", n), i = this.Fw[t], (e = i && i.key) ? (
                    // Since this query failed, we won't want to manually unlisten to it.
                    // So go ahead and remove it from bookkeeping.
                    this.Ow = this.Ow.remove(e), delete this.Fw[t], r = (r = new At(Rt.G)).lt(e, new gn(e, yt.B())), 
                    s = di().add(e), o = new Ri(yt.MIN, 
                    /* targetChanges= */ {}, 
                    /* targetMismatches= */ new Ct(N), r, s), [ 2 /*return*/ , this.Lh(o) ]) : [ 3 /*break*/ , 1 ];

                  case 1:
                    return [ 4 /*yield*/ , this.Oc.nc(t, /* keepPersistedTargetData */ !1).then((function() {
                        return h.Ww(t, n);
                    })).catch(Ue) ];

                  case 2:
                    u.sent(), u.label = 3;

                  case 3:
                    return [ 2 /*return*/ ];
                }
            }));
        }));
    }, 
    // PORTING NOTE: Multi-tab only
    t.prototype.ew = function(t, n, i) {
        return r(this, void 0, void 0, (function() {
            var e;
            return u(this, (function(r) {
                switch (r.label) {
                  case 0:
                    return this.Mw("applyBatchState()"), [ 4 /*yield*/ , this.Oc.kh(t) ];

                  case 1:
                    return null === (e = r.sent()) ? (
                    // A throttled tab may not have seen the mutation before it was completed
                    // and removed from the mutation queue, in which case we won't have cached
                    // the affected documents. In this case we can safely ignore the update
                    // since that means we didn't apply the mutation locally at all (if we
                    // had, we would have cached the affected documents), and so we will just
                    // see any resulting document changes via normal remote document updates
                    // as applicable.
                    A("SyncEngine", "Cannot apply mutation batch with id: " + t), [ 2 /*return*/ ]) : "pending" !== n ? [ 3 /*break*/ , 3 ] : [ 4 /*yield*/ , this.Tw.Jd() ];

                  case 2:
                    // If we are the primary client, we need to send this write to the
                    // backend. Secondary clients will ignore these writes since their remote
                    // connection is disabled.
                    return r.sent(), [ 3 /*break*/ , 4 ];

                  case 3:
                    "acknowledged" === n || "rejected" === n ? (
                    // NOTE: Both these methods are no-ops for batches that originated from
                    // other clients.
                    this.Jw(t, i || null), this.Oc.oc(t)) : S("Unknown batchState: " + n), r.label = 4;

                  case 4:
                    return [ 4 /*yield*/ , this.Kw(e) ];

                  case 5:
                    return r.sent(), [ 2 /*return*/ ];
                }
            }));
        }));
    }, t.prototype.av = function(t) {
        return r(this, void 0, void 0, (function() {
            var n, i;
            return u(this, (function(e) {
                switch (e.label) {
                  case 0:
                    this.Mw("applySuccessfulWrite()"), n = t.batch.batchId, 
                    // The local store may or may not be able to apply the write result and
                    // raise events immediately (depending on whether the watcher is caught
                    // up), so we raise user callbacks first so that they consistently happen
                    // before listen events.
                    this.Jw(n, /*error=*/ null), this.Yw(n), e.label = 1;

                  case 1:
                    return e.trys.push([ 1, 4, , 6 ]), [ 4 /*yield*/ , this.Oc.yo(t) ];

                  case 2:
                    return i = e.sent(), this.Cw.Lv(n, "acknowledged"), [ 4 /*yield*/ , this.Kw(i) ];

                  case 3:
                    return e.sent(), [ 3 /*break*/ , 6 ];

                  case 4:
                    return [ 4 /*yield*/ , Ue(e.sent()) ];

                  case 5:
                    return e.sent(), [ 3 /*break*/ , 6 ];

                  case 6:
                    return [ 2 /*return*/ ];
                }
            }));
        }));
    }, t.prototype.dv = function(t, n) {
        return r(this, void 0, void 0, (function() {
            var i;
            return u(this, (function(e) {
                switch (e.label) {
                  case 0:
                    this.Mw("rejectFailedWrite()"), 
                    // The local store may or may not be able to apply the write result and
                    // raise events immediately (depending on whether the watcher is caught up),
                    // so we raise user callbacks first so that they consistently happen before
                    // listen events.
                    this.Jw(t, n), this.Yw(t), e.label = 1;

                  case 1:
                    return e.trys.push([ 1, 4, , 6 ]), [ 4 /*yield*/ , this.Oc.jh(t) ];

                  case 2:
                    return i = e.sent(), this.Cw.Lv(t, "rejected", n), [ 4 /*yield*/ , this.Kw(i) ];

                  case 3:
                    return e.sent(), [ 3 /*break*/ , 6 ];

                  case 4:
                    return [ 4 /*yield*/ , Ue(e.sent()) ];

                  case 5:
                    return e.sent(), [ 3 /*break*/ , 6 ];

                  case 6:
                    return [ 2 /*return*/ ];
                }
            }));
        }));
    }, 
    /**
     * Registers a user callback that resolves when all pending mutations at the moment of calling
     * are acknowledged .
     */
    t.prototype.Xw = function(t) {
        return r(this, void 0, void 0, (function() {
            var n, i;
            return u(this, (function(e) {
                switch (e.label) {
                  case 0:
                    return this.Tw.xd() || A("SyncEngine", "The network is disabled. The task returned by 'awaitPendingWrites()' will not complete until the network is enabled."), 
                    [ 4 /*yield*/ , this.Oc.Vo() ];

                  case 1:
                    return -1 === (n = e.sent()) ? (
                    // Trigger the callback right away if there is no pending writes at the moment.
                    t.resolve(), [ 2 /*return*/ ]) : ((i = this.Uw.get(n) || []).push(t), this.Uw.set(n, i), 
                    [ 2 /*return*/ ]);
                }
            }));
        }));
    }, 
    /**
     * Triggers the callbacks that are waiting for this batch id to get acknowledged by server,
     * if there are any.
     */
    t.prototype.Yw = function(t) {
        (this.Uw.get(t) || []).forEach((function(t) {
            t.resolve();
        })), this.Uw.delete(t);
    }, 
    /** Reject all outstanding callbacks waiting for pending writes to complete. */
    t.prototype.$w = function(t) {
        this.Uw.forEach((function(n) {
            n.forEach((function(n) {
                n.reject(new B(L.CANCELLED, t));
            }));
        })), this.Uw.clear();
    }, t.prototype.zw = function(t, n) {
        var i = this.jw[this.currentUser.v()];
        i || (i = new At(N)), i = i.lt(t, n), this.jw[this.currentUser.v()] = i;
    }, 
    /**
     * Resolves or rejects the user callback for the given batch and then discards
     * it.
     */
    t.prototype.Jw = function(t, n) {
        var i = this.jw[this.currentUser.v()];
        // NOTE: Mutations restored from persistence won't have callbacks, so it's
        // okay for there to be no callback for this ID.
                if (i) {
            var e = i.get(t);
            e && (C(t === i.vt(), "Mutation callbacks processed out-of-order?"), n ? e.reject(n) : e.resolve(), 
            i = i.remove(t)), this.jw[this.currentUser.v()] = i;
        }
    }, t.prototype.Ww = function(t, n) {
        var i = this;
        void 0 === n && (n = null), this.Cw.Qv(t), C(this.kw[t] && 0 !== this.kw[t].length, "There are no queries mapped to target id " + t);
        for (var e = 0, r = this.kw[t]; e < r.length; e++) {
            var u = r[e];
            this.Nw.delete(u), n && this.Vw.Zw(u, n);
        }
        if (delete this.kw[t], this.isPrimary) {
            var s = this.xw.bs(t);
            this.xw.ps(t), s.forEach((function(t) {
                i.xw.ys(t) || 
                // We removed the last reference for this key
                i.tm(t);
            }));
        }
    }, t.prototype.tm = function(t) {
        // It's possible that the target already got removed because the query failed. In that case,
        // the key won't exist in `limboTargetsByKey`. Only do the cleanup if we still have the target.
        var n = this.Ow.get(t);
        null !== n && (this.Tw.Zd(n), this.Ow = this.Ow.remove(t), delete this.Fw[n]);
    }, t.prototype.Gw = function(t, n) {
        for (var i = 0, e = n; i < e.length; i++) {
            var r = e[i];
            if (r instanceof Mu) this.xw.ls(r.key, t), this.nm(r); else if (r instanceof qu) {
                A("SyncEngine", "Document no longer in limbo: " + r.key), this.xw.vs(r.key, t), 
                this.xw.ys(r.key) || 
                // We removed the last reference for this key
                this.tm(r.key);
            } else S("Unknown limbo change: " + JSON.stringify(r));
        }
    }, t.prototype.nm = function(t) {
        var n = t.key;
        if (!this.Ow.get(n)) {
            A("SyncEngine", "New document in limbo: " + n);
            var i = this.Lw.next(), e = kn.$n(n.path);
            this.Fw[i] = new Ku(n), this.Tw.listen(new ti(e.ai(), i, Kn.Ni, Yi.bu)), this.Ow = this.Ow.lt(n, i);
        }
    }, 
    // Visible for testing
    t.prototype.im = function() {
        return this.Ow;
    }, t.prototype.Kw = function(t, n) {
        return r(this, void 0, void 0, (function() {
            var i, e, r, s = this;
            return u(this, (function(u) {
                switch (u.label) {
                  case 0:
                    return i = [], e = [], r = [], this.Nw.forEach((function(u, o) {
                        r.push(Promise.resolve().then((function() {
                            var n = o.view.dw(t);
                            return n.bf ? s.Oc.ic(o.query, /* usePreviousResults= */ !1).then((function(t) {
                                var i = t.documents;
                                return o.view.dw(i, n);
                            })) : n;
                            // The query has a limit and some docs were removed, so we need
                            // to re-run the query against the local store to make sure we
                            // didn't lose any good docs that had been past the limit.
                                                })).then((function(t) {
                            var r = n && n.te[o.targetId], u = o.view.Qs(t, 
                            /* updateLimboDocuments= */ !0 === s.isPrimary, r);
                            if (s.Gw(o.targetId, u.gw), u.snapshot) {
                                s.isPrimary && s.Cw.zv(o.targetId, u.snapshot.fromCache ? "not-current" : "current"), 
                                i.push(u.snapshot);
                                var h = Fe.fh(o.targetId, u.snapshot);
                                e.push(h);
                            }
                        })));
                    })), [ 4 /*yield*/ , Promise.all(r) ];

                  case 1:
                    return u.sent(), this.Vw.Tl(i), [ 4 /*yield*/ , this.Oc.Hh(e) ];

                  case 2:
                    return u.sent(), [ 2 /*return*/ ];
                }
            }));
        }));
    }, t.prototype.Mw = function(t) {
        C(null !== this.Vw, "Trying to call " + t + " before calling subscribe().");
    }, t.prototype.wv = function(t) {
        return r(this, void 0, void 0, (function() {
            var n, i;
            return u(this, (function(e) {
                switch (e.label) {
                  case 0:
                    return n = !this.currentUser.isEqual(t), this.currentUser = t, n ? (
                    // Fails tasks waiting for pending writes requested by previous user.
                    this.$w("'waitForPendingWrites' promise is rejected due to a user change."), [ 4 /*yield*/ , this.Oc.Ph(t) ]) : [ 3 /*break*/ , 3 ];

                  case 1:
                    return i = e.sent(), 
                    // TODO(b/114226417): Consider calling this only in the primary tab.
                    this.Cw.Ph(t, i.Ch, i.Vh), [ 4 /*yield*/ , this.Kw(i.Sh) ];

                  case 2:
                    e.sent(), e.label = 3;

                  case 3:
                    return [ 4 /*yield*/ , this.Tw.wv() ];

                  case 4:
                    return e.sent(), [ 2 /*return*/ ];
                }
            }));
        }));
    }, 
    // PORTING NOTE: Multi-tab only
    t.prototype.mv = function(t) {
        return r(this, void 0, void 0, (function() {
            var n, i, e, r, s, o, h = this;
            return u(this, (function(u) {
                switch (u.label) {
                  case 0:
                    return !0 !== t || !0 === this.isPrimary ? [ 3 /*break*/ , 3 ] : (this.isPrimary = !0, 
                    [ 4 /*yield*/ , this.Tw.mv(!0) ]);

                  case 1:
                    return u.sent(), s = this.Cw.Fv(), [ 4 /*yield*/ , this.em(s.tt()) ];

                  case 2:
                    for (n = u.sent(), i = 0, e = n; i < e.length; i++) r = e[i], this.Tw.listen(r);
                    return [ 3 /*break*/ , 7 ];

                  case 3:
                    return !1 !== t || !1 === this.isPrimary ? [ 3 /*break*/ , 7 ] : (this.isPrimary = !1, 
                    s = [], o = Promise.resolve(), J(this.kw, (function(t, n) {
                        h.Cw.Gv(t) ? s.push(t) : o = o.then((function() {
                            return h.Ww(t), h.Oc.nc(t, 
                            /*keepPersistedTargetData=*/ !0);
                        })), h.Tw.Zd(t);
                    })), [ 4 /*yield*/ , o ]);

                  case 4:
                    return u.sent(), [ 4 /*yield*/ , this.em(s) ];

                  case 5:
                    return u.sent(), this.rm(), [ 4 /*yield*/ , this.Tw.mv(!1) ];

                  case 6:
                    u.sent(), u.label = 7;

                  case 7:
                    return [ 2 /*return*/ ];
                }
            }));
        }));
    }, 
    // PORTING NOTE: Multi-tab only.
    t.prototype.rm = function() {
        var t = this;
        J(this.Fw, (function(n) {
            t.Tw.Zd(n);
        })), this.xw.gs(), this.Fw = [], this.Ow = new At(Rt.G);
    }, 
    /**
     * Reconcile the query views of the provided query targets with the state from
     * persistence. Raises snapshots for any changes that affect the local
     * client and returns the updated state of all target's query data.
     */
    // PORTING NOTE: Multi-tab only.
    t.prototype.em = function(t) {
        return r(this, void 0, void 0, (function() {
            var n, i, e, r, s, o, h, c, a, f, l, d, v;
            return u(this, (function(u) {
                switch (u.label) {
                  case 0:
                    n = [], i = [], e = 0, r = t, u.label = 1;

                  case 1:
                    return e < r.length ? (s = r[e], o = void 0, (h = this.kw[s]) && 0 !== h.length ? [ 4 /*yield*/ , this.Oc.nc(s, 
                    /*keepPersistedTargetData=*/ !0) ] : [ 3 /*break*/ , 8 ]) : [ 3 /*break*/ , 14 ];

                  case 2:
                    // For queries that have a local View, we need to update their state
                    // in LocalStore (as the resume token and the snapshot version
                    // might have changed) and reconcile their views with the persisted
                    // state (the list of syncedDocuments may have gotten out of sync).
                    return u.sent(), [ 4 /*yield*/ , this.Oc.Xh(h[0].ai()) ];

                  case 3:
                    o = u.sent(), c = 0, a = h, u.label = 4;

                  case 4:
                    return c < a.length ? (f = a[c], C(!!(l = this.Nw.get(f)), "No query view found for " + f), 
                    [ 4 /*yield*/ , this.Qw(l) ]) : [ 3 /*break*/ , 7 ];

                  case 5:
                    (d = u.sent()).snapshot && i.push(d.snapshot), u.label = 6;

                  case 6:
                    return c++, [ 3 /*break*/ , 4 ];

                  case 7:
                    return [ 3 /*break*/ , 12 ];

                  case 8:
                    return C(!0 === this.isPrimary, "A secondary tab should never have an active target without an active query."), 
                    [ 4 /*yield*/ , this.Oc.fc(s) ];

                  case 9:
                    return C(!!(v = u.sent()), "Target for id " + s + " not found"), [ 4 /*yield*/ , this.Oc.Xh(v) ];

                  case 10:
                    return o = u.sent(), [ 4 /*yield*/ , this.qw(this.um(v), s, 
                    /*current=*/ !1) ];

                  case 11:
                    u.sent(), u.label = 12;

                  case 12:
                    n.push(o), u.label = 13;

                  case 13:
                    return e++, [ 3 /*break*/ , 1 ];

                  case 14:
                    return this.Vw.Tl(i), [ 2 /*return*/ , n ];
                }
            }));
        }));
    }, 
    /**
     * Creates a `Query` object from the specified `Target`. There is no way to
     * obtain the original `Query`, so we synthesize a `Query` from the `Target`
     * object.
     *
     * The synthesized result might be different from the original `Query`, but
     * since the synthesized `Query` should return the same results as the
     * original one (only the presentation of results might differ), the potential
     * difference will not cause issues.
     */
    // PORTING NOTE: Multi-tab only
    t.prototype.um = function(t) {
        return new kn(t.path, t.collectionGroup, t.orderBy, t.filters, t.limit, An.Wn, t.startAt, t.endAt);
    }, 
    // PORTING NOTE: Multi-tab only
    t.prototype.sc = function() {
        return this.Oc.sc();
    }, 
    // PORTING NOTE: Multi-tab only
    t.prototype.rw = function(t, n, i) {
        return r(this, void 0, void 0, (function() {
            var e, r;
            return u(this, (function(u) {
                switch (u.label) {
                  case 0:
                    if (this.isPrimary) 
                    // If we receive a target state notification via WebStorage, we are
                    // either already secondary or another tab has taken the primary lease.
                    return A("SyncEngine", "Ignoring unexpected query state notification."), [ 2 /*return*/ ];
                    if (!this.kw[t]) return [ 3 /*break*/ , 7 ];
                    switch (n) {
                      case "current":
                      case "not-current":
                        return [ 3 /*break*/ , 1 ];

                      case "rejected":
                        return [ 3 /*break*/ , 4 ];
                    }
                    return [ 3 /*break*/ , 6 ];

                  case 1:
                    return [ 4 /*yield*/ , this.Oc.lc() ];

                  case 2:
                    return e = u.sent(), r = Ri.re(t, "current" === n), [ 4 /*yield*/ , this.Kw(e, r) ];

                  case 3:
                    return u.sent(), [ 3 /*break*/ , 7 ];

                  case 4:
                    return [ 4 /*yield*/ , this.Oc.nc(t, 
                    /* keepPersistedTargetData */ !0) ];

                  case 5:
                    return u.sent(), this.Ww(t, i), [ 3 /*break*/ , 7 ];

                  case 6:
                    S("Unexpected target state: " + n), u.label = 7;

                  case 7:
                    return [ 2 /*return*/ ];
                }
            }));
        }));
    }, 
    // PORTING NOTE: Multi-tab only
    t.prototype.uw = function(t, n) {
        return r(this, void 0, void 0, (function() {
            var i, e, r, s, o, h, c, a, f, l = this;
            return u(this, (function(d) {
                switch (d.label) {
                  case 0:
                    if (!this.isPrimary) return [ 2 /*return*/ ];
                    i = 0, e = t, d.label = 1;

                  case 1:
                    return i < e.length ? (f = e[i], C(!this.kw[f], "Trying to add an already active target"), 
                    [ 4 /*yield*/ , this.Oc.fc(f) ]) : [ 3 /*break*/ , 6 ];

                  case 2:
                    return C(!!(r = d.sent()), "Query data for active target " + f + " not found"), 
                    [ 4 /*yield*/ , this.Oc.Xh(r) ];

                  case 3:
                    return s = d.sent(), [ 4 /*yield*/ , this.qw(this.um(r), s.targetId, 
                    /*current=*/ !1) ];

                  case 4:
                    d.sent(), this.Tw.listen(s), d.label = 5;

                  case 5:
                    return i++, [ 3 /*break*/ , 1 ];

                  case 6:
                    o = function(t) {
                        return u(this, (function(n) {
                            switch (n.label) {
                              case 0:
                                // Check that the target is still active since the target might have been
                                // removed if it has been rejected by the backend.
                                return h.kw[t] ? [ 4 /*yield*/ , h.Oc.nc(t, /* keepPersistedTargetData */ !1).then((function() {
                                    l.Tw.Zd(t), l.Ww(t);
                                })).catch(Ue) ] : [ 2 /*return*/ , "continue" ];

                                // Release queries that are still active.
                                                              case 1:
                                // Release queries that are still active.
                                return n.sent(), [ 2 /*return*/ ];
                            }
                        }));
                    }, h = this, c = 0, a = n, d.label = 7;

                  case 7:
                    return c < a.length ? (f = a[c], [ 5 /*yield**/ , o(f) ]) : [ 3 /*break*/ , 10 ];

                  case 8:
                    d.sent(), d.label = 9;

                  case 9:
                    return c++, [ 3 /*break*/ , 7 ];

                  case 10:
                    return [ 2 /*return*/ ];
                }
            }));
        }));
    }, 
    // PORTING NOTE: Multi-tab only. In other clients, LocalStore is unaware of
    // the online state.
    t.prototype.enableNetwork = function() {
        return this.Oc.hc(!0), this.Tw.enableNetwork();
    }, 
    // PORTING NOTE: Multi-tab only. In other clients, LocalStore is unaware of
    // the online state.
    t.prototype.disableNetwork = function() {
        return this.Oc.hc(!1), this.Tw.disableNetwork();
    }, t.prototype.Ye = function(t) {
        var n = this.Fw[t];
        if (n && n.Sw) return di().add(n.key);
        var i = di(), e = this.kw[t];
        if (!e) return i;
        for (var r = 0, u = e; r < u.length; r++) {
            var s = u[r], o = this.Nw.get(s);
            C(!!o, "No query view found for " + s), i = i.qt(o.view.lw);
        }
        return i;
    }, t;
}(), Ju = function() {
    this.sm = null, this.targetId = 0, this.listeners = [];
}, Yu = /** @class */ function() {
    function t(t) {
        this.nv = t, this.om = new le((function(t) {
            return t.canonicalId();
        })), this.onlineState = Sn.Ti, this.hm = new Set, this.nv.subscribe(this);
    }
    return t.prototype.listen = function(t) {
        var n = t.query, i = !1, e = this.om.get(n);
        (e || (i = !0, e = new Ju, this.om.set(n, e)), e.listeners.push(t), C(!t.bw(this.onlineState), "applyOnlineStateChange() shouldn't raise an event for brand-new listeners."), 
        e.sm) && (t.cm(e.sm) && this.am());
        return i ? this.nv.listen(n).then((function(t) {
            return e.targetId = t, t;
        })) : Promise.resolve(e.targetId);
    }, t.prototype.Zd = function(t) {
        return r(this, void 0, void 0, (function() {
            var n, i, e, r;
            return u(this, (function(u) {
                return n = t.query, i = !1, (e = this.om.get(n)) && (r = e.listeners.indexOf(t)) >= 0 && (e.listeners.splice(r, 1), 
                i = 0 === e.listeners.length), i ? (this.om.delete(n), [ 2 /*return*/ , this.nv.Zd(n) ]) : [ 2 /*return*/ ];
            }));
        }));
    }, t.prototype.Tl = function(t) {
        for (var n = !1, i = 0, e = t; i < e.length; i++) {
            var r = e[i], u = r.query, s = this.om.get(u);
            if (s) {
                for (var o = 0, h = s.listeners; o < h.length; o++) {
                    h[o].cm(r) && (n = !0);
                }
                s.sm = r;
            }
        }
        n && this.am();
    }, t.prototype.Zw = function(t, n) {
        var i = this.om.get(t);
        if (i) for (var e = 0, r = i.listeners; e < r.length; e++) {
            r[e].onError(n);
        }
        // Remove all listeners. NOTE: We don't need to call syncEngine.unlisten()
        // after an error.
                this.om.delete(t);
    }, t.prototype.Hw = function(t) {
        this.onlineState = t;
        var n = !1;
        this.om.forEach((function(i, e) {
            for (var r = 0, u = e.listeners; r < u.length; r++) {
                // Run global snapshot listeners if a consistent snapshot has been emitted.
                u[r].bw(t) && (n = !0);
            }
        })), n && this.am();
    }, t.prototype.fm = function(t) {
        this.hm.add(t), 
        // Immediately fire an initial event, indicating all existing listeners
        // are in-sync.
        t.next();
    }, t.prototype.lm = function(t) {
        this.hm.delete(t);
    }, 
    // Call all global snapshot listeners that have been set.
    t.prototype.am = function() {
        this.hm.forEach((function(t) {
            t.next();
        }));
    }, t;
}(), Xu = /** @class */ function() {
    function t(t, n, i) {
        this.query = t, this.dm = n, 
        /**
         * Initial snapshots (e.g. from cache) may not be propagated to the wrapped
         * observer. This flag is set to true once we've actually raised an event.
         */
        this.vm = !1, this.wm = null, this.onlineState = Sn.Ti, this.options = i || {};
    }
    /**
     * Applies the new ViewSnapshot to this listener, raising a user-facing event
     * if applicable (depending on what changed, whether the user has opted into
     * metadata-only changes, etc.). Returns true if a user-facing event was
     * indeed raised.
     */    return t.prototype.cm = function(t) {
        if (C(t.docChanges.length > 0 || t.Xi, "We got a new snapshot with no changes?"), 
        !this.options.includeMetadataChanges) {
            for (
            // Remove the metadata only changes.
            var n = [], i = 0, e = t.docChanges; i < e.length; i++) {
                var r = e[i];
                r.type !== mi.Gi && n.push(r);
            }
            t = new Ei(t.query, t.docs, t.Ji, n, t.Yi, t.fromCache, t.Xi, 
            /* excludesMetadataChanges= */ !0);
        }
        var u = !1;
        return this.vm ? this.mm(t) && (this.dm.next(t), u = !0) : this.pm(t, this.onlineState) && (this.gm(t), 
        u = !0), this.wm = t, u;
    }, t.prototype.onError = function(t) {
        this.dm.error(t);
    }, 
    /** Returns whether a snapshot was raised. */
    t.prototype.bw = function(t) {
        this.onlineState = t;
        var n = !1;
        return this.wm && !this.vm && this.pm(this.wm, t) && (this.gm(this.wm), n = !0), 
        n;
    }, t.prototype.pm = function(t, n) {
        // Always raise the first event when we're synced
        if (C(!this.vm, "Determining whether to raise first event but already had first event"), 
        !t.fromCache) return !0;
        // NOTE: We consider OnlineState.Unknown as online (it should become Offline
        // or Online if we wait long enough).
                var i = n !== Sn.Ri;
        // Don't raise the event if we're online, aren't synced yet (checked
        // above) and are waiting for a sync.
                return this.options.bm && i ? (C(t.fromCache, "Waiting for sync, but snapshot is not from cache"), 
        !1) : !t.docs.J() || n === Sn.Ri;
        // Raise data from cache if we have any documents or we are offline
        }, t.prototype.mm = function(t) {
        // We don't need to handle includeDocumentMetadataChanges here because
        // the Metadata only changes have already been stripped out if needed.
        // At this point the only changes we will see are the ones we should
        // propagate.
        if (t.docChanges.length > 0) return !0;
        var n = this.wm && this.wm.hasPendingWrites !== t.hasPendingWrites;
        return !(!t.Xi && !n) && !0 === this.options.includeMetadataChanges;
        // Generally we should have hit one of the cases above, but it's possible
        // to get here if there were only metadata docChanges and they got
        // stripped out.
        }, t.prototype.gm = function(t) {
        C(!this.vm, "Trying to raise initial events for second time"), t = Ei.Zi(t.query, t.docs, t.Yi, t.fromCache), 
        this.vm = !0, this.dm.next(t);
    }, t;
}(), $u = /** @class */ function() {
    function t(t, n) {
        this.cacheSizeBytes = t, this.synchronizeTabs = n;
    }
    return t.prototype.La = function() {
        return qe.Ac(this.cacheSizeBytes);
    }, t;
}(), Zu = function() {}, ts = /** @class */ function() {
    function t(t, n, i, 
    /**
     * Asynchronous queue responsible for all of our internal processing. When
     * we get incoming work from the user (via public API) or the network
     * (incoming GRPC messages), we should always schedule onto this queue.
     * This ensures all of our work is properly serialized (e.g. we don't
     * start processing a new operation while the previous one is waiting for
     * an async I/O to complete).
     */
    e) {
        this.platform = t, this.ym = n, this.credentials = i, this.Su = e, this.clientId = V.u();
    }
    /**
     * Starts up the FirestoreClient, returning only whether or not enabling
     * persistence succeeded.
     *
     * The intent here is to "do the right thing" as far as users are concerned.
     * Namely, in cases where offline persistence is requested and possible,
     * enable it, but otherwise fall back to persistence disabled. For the most
     * part we expect this to succeed one way or the other so we don't expect our
     * users to actually wait on the firestore.enablePersistence Promise since
     * they generally won't care.
     *
     * Of course some users actually do care about whether or not persistence
     * was successfully enabled, so the Promise returned from this method
     * indicates this outcome.
     *
     * This presents a problem though: even before enablePersistence resolves or
     * rejects, users may have made calls to e.g. firestore.collection() which
     * means that the FirestoreClient in there will be available and will be
     * enqueuing actions on the async queue.
     *
     * Meanwhile any failure of an operation on the async queue causes it to
     * panic and reject any further work, on the premise that unhandled errors
     * are fatal.
     *
     * Consequently the fallback is handled internally here in start, and if the
     * fallback succeeds we signal success to the async queue even though the
     * start() itself signals failure.
     *
     * @param persistenceSettings Settings object to configure offline
     *     persistence.
     * @returns A deferred result indicating the user-visible result of enabling
     *     offline persistence. This method will reject this if IndexedDB fails to
     *     start for any reason. If usePersistence is false this is
     *     unconditionally resolved.
     */    return t.prototype.start = function(t) {
        var n = this;
        this._m();
        // We defer our initialization until we get the current user from
        // setChangeListener(). We block the async queue until we got the initial
        // user and the initialization is completed. This will prevent any scheduled
        // work from happening before initialization is completed.
        //
        // If initializationDone resolved then the FirestoreClient is in a usable
        // state.
        var i = new Xi, e = new Xi, r = !1;
        // If usePersistence is true, certain classes of errors while starting are
        // recoverable but only by falling back to persistence disabled.
        //
        // If there's an error in the first case but not in recovery we cannot
        // reject the promise blocking the async queue because this will cause the
        // async queue to panic.
                // Return only the result of enabling persistence. Note that this does not
        // need to await the completion of initializationDone because the result of
        // this method should not reflect any other kind of failure to start.
        return this.credentials.T((function(u) {
            r ? n.Su.Uu((function() {
                return n.wv(u);
            })) : (r = !0, n.Im(t, e, u).then((function(t) {
                return n.Tm(u, t);
            })).then(i.resolve, i.reject));
        })), 
        // Block the async queue until initialization is done
        this.Su.Uu((function() {
            return i.promise;
        })), e.promise;
    }, 
    /** Enables the network connection and requeues all pending operations. */
    t.prototype.enableNetwork = function() {
        var t = this;
        return this._m(), this.Su.enqueue((function() {
            return t.nv.enableNetwork();
        }));
    }, 
    /**
     * Initializes persistent storage, attempting to use IndexedDB if
     * usePersistence is true or memory-only if false.
     *
     * If IndexedDB fails because it's already open in another tab or because the
     * platform can't possibly support our implementation then this method rejects
     * the persistenceResult and falls back on memory-only persistence.
     *
     * @param persistenceSettings Settings object to configure offline persistence
     * @param persistenceResult A deferred result indicating the user-visible
     *     result of enabling offline persistence. This method will reject this if
     *     IndexedDB fails to start for any reason. If usePersistence is false
     *     this is unconditionally resolved.
     * @returns a Promise indicating whether or not initialization should
     *     continue, i.e. that one of the persistence implementations actually
     *     succeeded.
     */
    t.prototype.Im = function(t, n, i) {
        var e = this;
        return t instanceof $u ? this.Em(i, t).then((function(t) {
            return n.resolve(), t;
        })).catch((function(t) {
            // An unknown failure on the first stage shuts everything down.
            if (
            // Regardless of whether or not the retry succeeds, from an user
            // perspective, offline persistence has failed.
            n.reject(t), !e.Rm(t)) throw t;
            return console.warn("Error enabling offline persistence. Falling back to persistence disabled: " + t), 
            e.Am();
        })) : (
        // When usePersistence == false, enabling offline persistence is defined
        // to unconditionally succeed. This allows start() to have the same
        // signature for both cases, despite the fact that the returned promise
        // is only used in the enablePersistence call.
        n.resolve(), this.Am());
    }, 
    /**
     * Decides whether the provided error allows us to gracefully disable
     * persistence (as opposed to crashing the client).
     */
    t.prototype.Rm = function(t) {
        return t instanceof B ? t.code === L.FAILED_PRECONDITION || t.code === L.UNIMPLEMENTED : !("undefined" != typeof DOMException && t instanceof DOMException) || (
        // When the browser is out of quota we could get either quota exceeded
        // or an aborted error depending on whether the error happened during
        // schema migration.
        22 === t.code || 20 === t.code || 
        // Firefox Private Browsing mode disables IndexedDb and returns
        // INVALID_STATE for any usage.
        11 === t.code);
    }, 
    /**
     * Checks that the client has not been terminated. Ensures that other methods on
     * this class cannot be called after the client is terminated.
     */
    t.prototype._m = function() {
        if (this.Su.Wu) throw new B(L.FAILED_PRECONDITION, "The client has already been terminated.");
    }, 
    /**
     * Starts IndexedDB-based persistence.
     *
     * @returns A promise indicating success or failure.
     */
    t.prototype.Em = function(t, n) {
        var i = this, e = Sr.ff(this.ym), s = new Mi(this.ym.s, {
            tr: !0
        });
        // TODO(http://b/33384523): For now we just disable garbage collection
        // when persistence is enabled.
                return Promise.resolve().then((function() {
            return r(i, void 0, void 0, (function() {
                var i, r;
                return u(this, (function(u) {
                    switch (u.label) {
                      case 0:
                        if (n.synchronizeTabs && !Lu.Js(this.platform)) throw new B(L.UNIMPLEMENTED, "IndexedDB persistence is only available on platforms that support LocalStorage.");
                        return i = n.La(), this.Cw = n.synchronizeTabs ? new Lu(this.Su, this.platform, e, this.clientId, t) : new Bu, 
                        [ 4 /*yield*/ , Sr.Ua({
                            allowTabSynchronization: n.synchronizeTabs,
                            persistenceKey: e,
                            clientId: this.clientId,
                            platform: this.platform,
                            Da: this.Su,
                            serializer: s,
                            La: i,
                            Pa: this.Cw
                        }) ];

                      case 1:
                        return r = u.sent(), this.persistence = r, [ 2 /*return*/ , r.wo.kc ];
                    }
                }));
            }));
        }));
    }, 
    /**
     * Starts Memory-backed persistence. In practice this cannot fail.
     *
     * @returns A promise that will successfully resolve.
     */
    t.prototype.Am = function() {
        return this.persistence = Br.Of(this.clientId), this.Cw = new Bu, Promise.resolve(null);
    }, 
    /**
     * Initializes the rest of the FirestoreClient, assuming the initial user
     * has been obtained from the credential provider and some persistence
     * implementation is available in this.persistence.
     */
    t.prototype.Tm = function(t, n) {
        var i = this;
        return A("FirestoreClient", "Initializing. user=", t.uid), this.platform.Dm(this.ym).then((function(e) {
            return r(i, void 0, void 0, (function() {
                var i, s, o, h, c, a, f = this;
                return u(this, (function(l) {
                    switch (l.label) {
                      case 0:
                        return i = new Or, this.Oc = new je(this.persistence, i, t), [ 4 /*yield*/ , this.Oc.start() ];

                      case 1:
                        // PORTING NOTE: LocalStore doesn't need an explicit start() on the Web.
                        return l.sent(), n && (
                        // We're running LRU Garbage collection. Set up the scheduler.
                        this.Pm = new Qe(n, this.Su, this.Oc)), s = this.platform.Sm(), o = this.platform.Cm(this.ym.s), 
                        h = new Xr(this.Su, e, this.credentials, o), c = function(t) {
                            return f.nv.bw(t, Vn.Ai);
                        }, a = function(t) {
                            return f.nv.bw(t, Vn.Di);
                        }, this.Tw = new Eu(this.Oc, h, this.Su, c, s), this.nv = new Hu(this.Oc, this.Tw, this.Cw, t), 
                        this.Cw.Id = a, 
                        // Set up wiring between sync engine and other components
                        this.Tw.nv = this.nv, this.Cw.nv = this.nv, this.Vm = new Yu(this.nv), [ 4 /*yield*/ , this.Cw.start() ];

                      case 2:
                        // PORTING NOTE: LocalStore doesn't need an explicit start() on the Web.
                        return l.sent(), [ 4 /*yield*/ , this.Tw.start() ];

                      case 3:
                        // NOTE: This will immediately call the listener, so we make sure to
                        // set it after localStore / remoteStore are started.
                        return l.sent(), [ 4 /*yield*/ , this.persistence.za((function(t) {
                            return r(f, void 0, void 0, (function() {
                                return u(this, (function(n) {
                                    switch (n.label) {
                                      case 0:
                                        return [ 4 /*yield*/ , this.nv.mv(t) ];

                                      case 1:
                                        return n.sent(), this.Pm && (t && !this.Pm.ph ? this.Pm.start() : t || this.Pm.stop()), 
                                        [ 2 /*return*/ ];
                                    }
                                }));
                            }));
                        })) ];

                      case 4:
                        // When a user calls clearPersistence() in one client, all other clients
                        // need to be terminated to allow the delete to succeed.
                        // NOTE: This will immediately call the listener, so we make sure to
                        // set it after localStore / remoteStore are started.
                        return l.sent(), [ 4 /*yield*/ , this.persistence.Ka((function() {
                            return r(f, void 0, void 0, (function() {
                                return u(this, (function(t) {
                                    switch (t.label) {
                                      case 0:
                                        return [ 4 /*yield*/ , this.terminate() ];

                                      case 1:
                                        return t.sent(), [ 2 /*return*/ ];
                                    }
                                }));
                            }));
                        })) ];

                      case 5:
                        // When a user calls clearPersistence() in one client, all other clients
                        // need to be terminated to allow the delete to succeed.
                        return l.sent(), [ 2 /*return*/ ];
                    }
                }));
            }));
        }));
    }, t.prototype.wv = function(t) {
        return this.Su.Zu(), A("FirestoreClient", "Credential Changed. Current user: " + t.uid), 
        this.nv.wv(t);
    }, 
    /** Disables the network connection. Pending operations will not complete. */
    t.prototype.disableNetwork = function() {
        var t = this;
        return this._m(), this.Su.enqueue((function() {
            return t.nv.disableNetwork();
        }));
    }, t.prototype.terminate = function() {
        var t = this;
        return this.Su.Yu((function() {
            return r(t, void 0, void 0, (function() {
                return u(this, (function(t) {
                    switch (t.label) {
                      case 0:
                        // PORTING NOTE: LocalStore does not need an explicit shutdown on web.
                        return this.Pm && this.Pm.stop(), [ 4 /*yield*/ , this.Tw.shutdown() ];

                      case 1:
                        return t.sent(), [ 4 /*yield*/ , this.Cw.shutdown() ];

                      case 2:
                        return t.sent(), [ 4 /*yield*/ , this.persistence.shutdown() ];

                      case 3:
                        return t.sent(), 
                        // `removeChangeListener` must be called after shutting down the
                        // RemoteStore as it will prevent the RemoteStore from retrieving
                        // auth tokens.
                        this.credentials.R(), [ 2 /*return*/ ];
                    }
                }));
            }));
        }));
    }, 
    /**
     * Returns a Promise that resolves when all writes that were pending at the time this
     * method was called received server acknowledgement. An acknowledgement can be either acceptance
     * or rejection.
     */
    t.prototype.waitForPendingWrites = function() {
        var t = this;
        this._m();
        var n = new Xi;
        return this.Su.Uu((function() {
            return t.nv.Xw(n);
        })), n.promise;
    }, t.prototype.listen = function(t, n, i) {
        var e = this;
        this._m();
        var r = new Xu(t, n, i);
        return this.Su.Uu((function() {
            return e.Vm.listen(r);
        })), r;
    }, t.prototype.Zd = function(t) {
        var n = this;
        // Checks for termination but does not raise error, allowing unlisten after
        // termination to be a no-op.
                this.Nm || this.Su.Uu((function() {
            return n.Vm.Zd(t);
        }));
    }, t.prototype.km = function(t) {
        var n = this;
        return this._m(), this.Su.enqueue((function() {
            return n.Oc.Yh(t);
        })).then((function(t) {
            if (t instanceof pn) return t;
            if (t instanceof gn) return null;
            throw new B(L.UNAVAILABLE, "Failed to get document from cache. (However, this document may exist on the server. Run again without setting 'source' in the GetOptions to attempt to retrieve the document from the server.)");
        }));
    }, t.prototype.Om = function(t) {
        var n = this;
        return this._m(), this.Su.enqueue((function() {
            return r(n, void 0, void 0, (function() {
                var n, i, e;
                return u(this, (function(r) {
                    switch (r.label) {
                      case 0:
                        return [ 4 /*yield*/ , this.Oc.ic(t, 
                        /* usePreviousResults= */ !0) ];

                      case 1:
                        return n = r.sent(), i = new Qu(t, n.rc), e = i.dw(n.documents), [ 2 /*return*/ , i.Qs(e, 
                        /* updateLimboDocuments= */ !1).snapshot ];
                    }
                }));
            }));
        }));
    }, t.prototype.write = function(t) {
        var n = this;
        this._m();
        var i = new Xi;
        return this.Su.Uu((function() {
            return n.nv.write(t, i);
        })), i.promise;
    }, t.prototype.s = function() {
        return this.ym.s;
    }, t.prototype.fm = function(t) {
        var n = this;
        this._m(), this.Su.Uu((function() {
            return n.Vm.fm(t), Promise.resolve();
        }));
    }, t.prototype.lm = function(t) {
        // Checks for shutdown but does not raise error, allowing remove after
        // shutdown to be a no-op.
        this.Nm || this.Vm.lm(t);
    }, Object.defineProperty(t.prototype, "Nm", {
        get: function() {
            // Technically, the asyncQueue is still running, but only accepting operations
            // related to termination or supposed to be run after termination. It is effectively
            // terminated to the eyes of users.
            return this.Su.Wu;
        },
        enumerable: !0,
        configurable: !0
    }), t.prototype.transaction = function(t) {
        var n = this;
        this._m();
        var i = new Xi;
        return this.Su.Uu((function() {
            return n.nv.runTransaction(n.Su, t, i), Promise.resolve();
        })), i.promise;
    }, t;
}(), ns = /** @class */ function() {
    function t(t) {
        this.observer = t, 
        /**
         * When set to true, will not raise future events. Necessary to deal with
         * async detachment of listener.
         */
        this.muted = !1;
    }
    return t.prototype.next = function(t) {
        this.Fm(this.observer.next, t);
    }, t.prototype.error = function(t) {
        this.Fm(this.observer.error, t);
    }, t.prototype.xm = function() {
        this.muted = !0;
    }, t.prototype.Fm = function(t, n) {
        var i = this;
        this.muted || setTimeout((function() {
            i.muted || t(n);
        }), 0);
    }, t;
}();

/**
 * TransactionRunner encapsulates the logic needed to run and retry transactions
 * with backoff.
 */
/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
function is(t) {
    /**
 * Returns true if obj is an object and contains at least one of the specified
 * methods.
 */
    return function(t, n) {
        if ("object" != typeof t || null === t) return !1;
        for (var i = t, e = 0, r = n; e < r.length; e++) {
            var u = r[e];
            if (u in i && "function" == typeof i[u]) return !0;
        }
        return !1;
    }
    /**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
    // settings() defaults:
    (t, [ "next", "error", "complete" ]);
}

var es = "firestore.googleapis.com", rs = !0, us = !0, ss = !1, os = qe.Sc, hs = /** @class */ function() {
    function t(t) {
        if (void 0 === t.host) {
            if (void 0 !== t.ssl) throw new B(L.INVALID_ARGUMENT, "Can't provide ssl option if host option is not set");
            this.host = es, this.ssl = rs;
        } else rt("settings", "non-empty string", "host", t.host), this.host = t.host, ut("settings", "boolean", "ssl", t.ssl), 
        this.ssl = H(t.ssl, rs);
        if (dt("settings", t, [ "host", "ssl", "credentials", "timestampsInSnapshots", "cacheSizeBytes", "experimentalForceLongPolling" ]), 
        ut("settings", "object", "credentials", t.credentials), this.credentials = t.credentials, 
        ut("settings", "boolean", "timestampsInSnapshots", t.timestampsInSnapshots), 
        // Nobody should set timestampsInSnapshots anymore, but the error depends on
        // whether they set it to true or false...
        !0 === t.timestampsInSnapshots ? D("\n  The timestampsInSnapshots setting now defaults to true and you no\n  longer need to explicitly set it. In a future release, the setting\n  will be removed entirely and so it is recommended that you remove it\n  from your firestore.settings() call now.") : !1 === t.timestampsInSnapshots && D("\n  The timestampsInSnapshots setting will soon be removed. YOU MUST UPDATE\n  YOUR CODE.\n\n  To hide this warning, stop using the timestampsInSnapshots setting in your\n  firestore.settings({ ... }) call.\n\n  Once you remove the setting, Timestamps stored in Cloud Firestore will be\n  read back as Firebase Timestamp objects instead of as system Date objects.\n  So you will also need to update code expecting a Date to instead expect a\n  Timestamp. For example:\n\n  // Old:\n  const date = snapshot.get('created_at');\n  // New:\n  const timestamp = snapshot.get('created_at'); const date =\n  timestamp.toDate();\n\n  Please audit all existing usages of Date when you enable the new\n  behavior."), 
        this.timestampsInSnapshots = H(t.timestampsInSnapshots, us), ut("settings", "number", "cacheSizeBytes", t.cacheSizeBytes), 
        void 0 === t.cacheSizeBytes) this.cacheSizeBytes = qe.Vc; else {
            if (t.cacheSizeBytes !== os && t.cacheSizeBytes < qe.Cc) throw new B(L.INVALID_ARGUMENT, "cacheSizeBytes must be at least " + qe.Cc);
            this.cacheSizeBytes = t.cacheSizeBytes;
        }
        ut("settings", "boolean", "experimentalForceLongPolling", t.experimentalForceLongPolling), 
        this.forceLongPolling = void 0 === t.experimentalForceLongPolling ? ss : t.experimentalForceLongPolling;
    }
    return t.prototype.isEqual = function(t) {
        return this.host === t.host && this.ssl === t.ssl && this.timestampsInSnapshots === t.timestampsInSnapshots && this.credentials === t.credentials && this.cacheSizeBytes === t.cacheSizeBytes && this.forceLongPolling === t.forceLongPolling;
    }, t;
}(), cs = /** @class */ function() {
    function t(n, i) {
        var e = this;
        if (this.jm = null, 
        // Public for use in tests.
        // TODO(mikelehen): Use modularized initialization instead.
        this.Um = new Zi, this.INTERNAL = {
            delete: function() {
                return r(e, void 0, void 0, (function() {
                    return u(this, (function(t) {
                        switch (t.label) {
                          case 0:
                            // The client must be initalized to ensure that all subsequent API usage
                            // throws an exception.
                            return this.Lm(), [ 4 /*yield*/ , this.Bm.terminate() ];

                          case 1:
                            return t.sent(), [ 2 /*return*/ ];
                        }
                    }));
                }));
            }
        }, "object" == typeof n.options) {
            // This is very likely a Firebase app object
            // TODO(b/34177605): Can we somehow use instanceof?
            var s = n;
            this.jm = s, this.Mm = t.qm(s), this.Qm = s.name, this.Gm = new Q(i);
        } else {
            var o = n;
            if (!o.projectId) throw new B(L.INVALID_ARGUMENT, "Must provide projectId");
            this.Mm = new j(o.projectId, o.database), 
            // Use a default persistenceKey that lines up with FirebaseApp.
            this.Qm = "[DEFAULT]", this.Gm = new q;
        }
        this.Wm = new hs({}), this.zm = this.Km(this.Mm);
    }
    return t.prototype.settings = function(t) {
        if (Z("Firestore.settings", arguments, 1), it("Firestore.settings", "object", 1, t), 
        K(t, "persistence")) throw new B(L.INVALID_ARGUMENT, '"persistence" is now specified with a separate call to firestore.enablePersistence().');
        var n = new hs(t);
        if (this.Bm && !this.Wm.isEqual(n)) throw new B(L.FAILED_PRECONDITION, "Firestore has already been started and its settings can no longer be changed. You can only call settings() before calling any other methods on a Firestore object.");
        this.Wm = n, void 0 !== n.credentials && (this.Gm = z(n.credentials));
    }, t.prototype.enableNetwork = function() {
        return this.Lm(), this.Bm.enableNetwork();
    }, t.prototype.disableNetwork = function() {
        return this.Lm(), this.Bm.disableNetwork();
    }, t.prototype.enablePersistence = function(t) {
        if (this.Bm) throw new B(L.FAILED_PRECONDITION, "Firestore has already been started and persistence can no longer be enabled. You can only call enablePersistence() before calling any other methods on a Firestore object.");
        var n = !1;
        return t && (void 0 !== t.experimentalTabSynchronization && D("The 'experimentalTabSynchronization' setting has been renamed to 'synchronizeTabs'. In a future release, the setting will be removed and it is recommended that you update your firestore.enablePersistence() call to use 'synchronizeTabs'."), 
        n = H(void 0 !== t.synchronizeTabs ? t.synchronizeTabs : t.experimentalTabSynchronization, !1)), 
        this.Hm(new $u(this.Wm.cacheSizeBytes, n));
    }, t.prototype.clearPersistence = function() {
        var t = this, n = Sr.ff(this.Jm()), i = new Xi;
        return this.Um.zu((function() {
            return r(t, void 0, void 0, (function() {
                var t;
                return u(this, (function(e) {
                    switch (e.label) {
                      case 0:
                        if (e.trys.push([ 0, 2, , 3 ]), void 0 !== this.Bm && !this.Bm.Nm) throw new B(L.FAILED_PRECONDITION, "Persistence cannot be cleared after this Firestore instance is initialized.");
                        return [ 4 /*yield*/ , Sr.clearPersistence(n) ];

                      case 1:
                        return e.sent(), i.resolve(), [ 3 /*break*/ , 3 ];

                      case 2:
                        return t = e.sent(), i.reject(t), [ 3 /*break*/ , 3 ];

                      case 3:
                        return [ 2 /*return*/ ];
                    }
                }));
            }));
        })), i.promise;
    }, t.prototype.terminate = function() {
        return this.app._removeServiceInstance("firestore"), this.INTERNAL.delete();
    }, Object.defineProperty(t.prototype, "Ym", {
        get: function() {
            return this.Lm(), this.Bm.Nm;
        },
        enumerable: !0,
        configurable: !0
    }), t.prototype.waitForPendingWrites = function() {
        return this.Lm(), this.Bm.waitForPendingWrites();
    }, t.prototype.onSnapshotsInSync = function(t) {
        if (this.Lm(), is(t)) return this.Xm(t);
        it("Firestore.onSnapshotsInSync", "function", 1, t);
        var n = {
            next: t
        };
        return this.Xm(n);
    }, t.prototype.Xm = function(t) {
        var n = this, i = new ns({
            next: function() {
                t.next && t.next();
            },
            error: function(t) {
                throw S("Uncaught Error in onSnapshotsInSync");
            }
        });
        return this.Bm.fm(i), function() {
            i.xm(), n.Bm.lm(i);
        };
    }, t.prototype.Lm = function() {
        return this.Bm || 
        // Kick off starting the client but don't actually wait for it.
        // eslint-disable-next-line @typescript-eslint/no-floating-promises
        this.Hm(new Zu), this.Bm;
    }, t.prototype.Jm = function() {
        return new F(this.Mm, this.Qm, this.Wm.host, this.Wm.ssl, this.Wm.forceLongPolling);
    }, t.prototype.Hm = function(t) {
        C(!!this.Wm.host, "FirestoreSettings.host is not set"), C(!this.Bm, "configureClient() called multiple times");
        var n = this.Jm();
        return this.Bm = new ts(qi.t(), n, this.Gm, this.Um), this.Bm.start(t);
    }, t.prototype.Km = function(t) {
        return new wu((function(n) {
            if (n instanceof ls) {
                var i = t, e = n.firestore.Mm;
                if (!e.isEqual(i)) throw new B(L.INVALID_ARGUMENT, "Document reference is for database " + e.projectId + "/" + e.database + " but should be for database " + i.projectId + "/" + i.database);
                return new vu(t, n.$m);
            }
            return n;
        }));
    }, t.qm = function(t) {
        var n = t.options;
        if (!K(n, "projectId")) throw new B(L.INVALID_ARGUMENT, '"projectId" not provided in firebase.initializeApp.');
        var i = n.projectId;
        if (!i || "string" != typeof i) throw new B(L.INVALID_ARGUMENT, "projectId must be a string in FirebaseApp.options");
        return new j(i);
    }, Object.defineProperty(t.prototype, "app", {
        get: function() {
            if (!this.jm) throw new B(L.FAILED_PRECONDITION, "Firestore was not initialized using the Firebase SDK. 'app' is not available");
            return this.jm;
        },
        enumerable: !0,
        configurable: !0
    }), t.prototype.collection = function(t) {
        return Z("Firestore.collection", arguments, 1), it("Firestore.collection", "non-empty string", 1, t), 
        this.Lm(), new gs(It.it(t), this);
    }, t.prototype.doc = function(t) {
        return Z("Firestore.doc", arguments, 1), it("Firestore.doc", "non-empty string", 1, t), 
        this.Lm(), ls.Zm(It.it(t), this);
    }, t.prototype.collectionGroup = function(t) {
        if (Z("Firestore.collectionGroup", arguments, 1), it("Firestore.collectionGroup", "non-empty string", 1, t), 
        t.indexOf("/") >= 0) throw new B(L.INVALID_ARGUMENT, "Invalid collection ID '" + t + "' passed to function Firestore.collectionGroup(). Collection IDs must not contain '/'.");
        return this.Lm(), new ms(new kn(It.et, t), this);
    }, t.prototype.runTransaction = function(t) {
        var n = this;
        return Z("Firestore.runTransaction", arguments, 1), it("Firestore.runTransaction", "function", 1, t), 
        this.Lm().transaction((function(i) {
            return t(new as(n, i));
        }));
    }, t.prototype.batch = function() {
        return this.Lm(), new fs(this);
    }, Object.defineProperty(t, "logLevel", {
        get: function() {
            switch (E()) {
              case _.DEBUG:
                return "debug";

              case _.ERROR:
                return "error";

              case _.SILENT:
                return "silent";

              default:
                return S("Unknown log level: " + E());
            }
        },
        enumerable: !0,
        configurable: !0
    }), t.setLogLevel = function(t) {
        switch (Z("Firestore.setLogLevel", arguments, 1), it("Firestore.setLogLevel", "non-empty string", 1, t), 
        t) {
          case "debug":
            R(_.DEBUG);
            break;

          case "error":
            R(_.ERROR);
            break;

          case "silent":
            R(_.SILENT);
            break;

          default:
            throw new B(L.INVALID_ARGUMENT, "Invalid log level: " + t);
        }
    }, 
    // Note: this is not a property because the minifier can't work correctly with
    // the way TypeScript compiler outputs properties.
    t.prototype.tp = function() {
        return this.Wm.timestampsInSnapshots;
    }, t;
}(), as = /** @class */ function() {
    function t(t, n) {
        this.np = t, this.ip = n;
    }
    return t.prototype.get = function(t) {
        var n = this;
        Z("Transaction.get", arguments, 1);
        var i = Is("Transaction.get", t, this.np);
        return this.ip.lookup([ i.$m ]).then((function(t) {
            if (!t || 1 !== t.length) return S("Mismatch in docs returned from document lookup.");
            var e = t[0];
            if (e instanceof gn) return new vs(n.np, i.$m, null, 
            /* fromCache= */ !1, 
            /* hasPendingWrites= */ !1, i.ep);
            if (e instanceof pn) return new vs(n.np, i.$m, e, 
            /* fromCache= */ !1, 
            /* hasPendingWrites= */ !1, i.ep);
            throw S("BatchGetDocumentsRequest returned unexpected document type: " + e.constructor.name);
        }));
    }, t.prototype.set = function(t, n, i) {
        nt("Transaction.set", arguments, 2, 3);
        var e = Is("Transaction.set", t, this.np);
        i = bs("Transaction.set", i);
        var r = Es(e.ep, n, "Transaction.set"), u = r[0], s = r[1], o = i.merge || i.mergeFields ? this.np.zm.ed(s, u, i.mergeFields) : this.np.zm.td(s, u);
        return this.ip.set(e.$m, o), this;
    }, t.prototype.update = function(t, n, i) {
        for (var e, r, u = [], s = 3; s < arguments.length; s++) u[s - 3] = arguments[s];
        return "string" == typeof n || n instanceof $r ? (tt("Transaction.update", arguments, 3), 
        e = Is("Transaction.update", t, this.np), r = this.np.zm.sd("Transaction.update", n, i, u)) : (Z("Transaction.update", arguments, 2), 
        e = Is("Transaction.update", t, this.np), r = this.np.zm.rd("Transaction.update", n)), 
        this.ip.update(e.$m, r), this;
    }, t.prototype.delete = function(t) {
        Z("Transaction.delete", arguments, 1);
        var n = Is("Transaction.delete", t, this.np);
        return this.ip.delete(n.$m), this;
    }, t;
}(), fs = /** @class */ function() {
    function t(t) {
        this.np = t, this.rp = [], this.up = !1;
    }
    return t.prototype.set = function(t, n, i) {
        nt("WriteBatch.set", arguments, 2, 3), this.sp();
        var e = Is("WriteBatch.set", t, this.np);
        i = bs("WriteBatch.set", i);
        var r = Es(e.ep, n, "WriteBatch.set"), u = r[0], s = r[1], o = i.merge || i.mergeFields ? this.np.zm.ed(s, u, i.mergeFields) : this.np.zm.td(s, u);
        return this.rp = this.rp.concat(o.Bl(e.$m, zt.NONE)), this;
    }, t.prototype.update = function(t, n, i) {
        for (var e, r, u = [], s = 3; s < arguments.length; s++) u[s - 3] = arguments[s];
        return this.sp(), "string" == typeof n || n instanceof $r ? (tt("WriteBatch.update", arguments, 3), 
        e = Is("WriteBatch.update", t, this.np), r = this.np.zm.sd("WriteBatch.update", n, i, u)) : (Z("WriteBatch.update", arguments, 2), 
        e = Is("WriteBatch.update", t, this.np), r = this.np.zm.rd("WriteBatch.update", n)), 
        this.rp = this.rp.concat(r.Bl(e.$m, zt.exists(!0))), this;
    }, t.prototype.delete = function(t) {
        Z("WriteBatch.delete", arguments, 1), this.sp();
        var n = Is("WriteBatch.delete", t, this.np);
        return this.rp = this.rp.concat(new Xt(n.$m, zt.NONE)), this;
    }, t.prototype.commit = function() {
        return r(this, void 0, void 0, (function() {
            return u(this, (function(t) {
                return this.sp(), this.up = !0, this.rp.length > 0 ? [ 2 /*return*/ , this.np.Lm().write(this.rp) ] : [ 2 /*return*/ ];
            }));
        }));
    }, t.prototype.sp = function() {
        if (this.up) throw new B(L.FAILED_PRECONDITION, "A write batch can no longer be used after commit() has been called.");
    }, t;
}(), ls = /** @class */ function() {
    function t(t, n, i) {
        this.$m = t, this.firestore = n, this.ep = i, this.Bm = this.firestore.Lm();
    }
    return t.Zm = function(n, i, e) {
        if (n.length % 2 != 0) throw new B(L.INVALID_ARGUMENT, "Invalid document reference. Document references must have an even number of segments, but " + n.nt() + " has " + n.length);
        return new t(new Rt(n), i, e);
    }, Object.defineProperty(t.prototype, "id", {
        get: function() {
            return this.$m.path.X();
        },
        enumerable: !0,
        configurable: !0
    }), Object.defineProperty(t.prototype, "parent", {
        get: function() {
            return new gs(this.$m.path.H(), this.firestore, this.ep);
        },
        enumerable: !0,
        configurable: !0
    }), Object.defineProperty(t.prototype, "path", {
        get: function() {
            return this.$m.path.nt();
        },
        enumerable: !0,
        configurable: !0
    }), t.prototype.collection = function(t) {
        if (Z("DocumentReference.collection", arguments, 1), it("DocumentReference.collection", "non-empty string", 1, t), 
        !t) throw new B(L.INVALID_ARGUMENT, "Must provide a non-empty collection name to collection()");
        var n = It.it(t);
        return new gs(this.$m.path.child(n), this.firestore);
    }, t.prototype.isEqual = function(n) {
        if (!(n instanceof t)) throw vt("isEqual", "DocumentReference", 1, n);
        return this.firestore === n.firestore && this.$m.isEqual(n.$m) && this.ep === n.ep;
    }, t.prototype.set = function(t, n) {
        nt("DocumentReference.set", arguments, 1, 2), n = bs("DocumentReference.set", n);
        var i = Es(this.ep, t, "DocumentReference.set"), e = i[0], r = i[1], u = n.merge || n.mergeFields ? this.firestore.zm.ed(r, e, n.mergeFields) : this.firestore.zm.td(r, e);
        return this.Bm.write(u.Bl(this.$m, zt.NONE));
    }, t.prototype.update = function(t, n) {
        for (var i, e = [], r = 2; r < arguments.length; r++) e[r - 2] = arguments[r];
        return "string" == typeof t || t instanceof $r ? (tt("DocumentReference.update", arguments, 2), 
        i = this.firestore.zm.sd("DocumentReference.update", t, n, e)) : (Z("DocumentReference.update", arguments, 1), 
        i = this.firestore.zm.rd("DocumentReference.update", t)), this.Bm.write(i.Bl(this.$m, zt.exists(!0)));
    }, t.prototype.delete = function() {
        return Z("DocumentReference.delete", arguments, 0), this.Bm.write([ new Xt(this.$m, zt.NONE) ]);
    }, t.prototype.onSnapshot = function() {
        for (var t = [], n = 0; n < arguments.length; n++) t[n] = arguments[n];
        nt("DocumentReference.onSnapshot", arguments, 1, 4);
        var i, e = {
            includeMetadataChanges: !1
        }, r = 0;
        "object" != typeof t[r] || is(t[r]) || (dt("DocumentReference.onSnapshot", e = t[r], [ "includeMetadataChanges" ]), 
        ut("DocumentReference.onSnapshot", "boolean", "includeMetadataChanges", e.includeMetadataChanges), 
        r++);
        var u = {
            includeMetadataChanges: e.includeMetadataChanges
        };
        return is(t[r]) ? i = t[r] : (it("DocumentReference.onSnapshot", "function", r, t[r]), 
        et("DocumentReference.onSnapshot", "function", r + 1, t[r + 1]), et("DocumentReference.onSnapshot", "function", r + 2, t[r + 2]), 
        i = {
            next: t[r],
            error: t[r + 1],
            complete: t[r + 2]
        }), this.hp(u, i);
    }, t.prototype.hp = function(t, n) {
        var i = this, e = function(t) {
            console.error("Uncaught Error in onSnapshot:", t);
        };
        n.error && (e = n.error.bind(n));
        var r = new ns({
            next: function(t) {
                if (n.next) {
                    C(t.docs.size <= 1, "Too many documents returned on a document query");
                    var e = t.docs.get(i.$m);
                    n.next(new vs(i.firestore, i.$m, e, t.fromCache, t.hasPendingWrites, i.ep));
                }
            },
            error: e
        }), u = this.Bm.listen(kn.$n(this.$m.path), r, t);
        return function() {
            r.xm(), i.Bm.Zd(u);
        };
    }, t.prototype.get = function(t) {
        var n = this;
        return nt("DocumentReference.get", arguments, 0, 1), _s("DocumentReference.get", t), 
        new Promise((function(i, e) {
            t && "cache" === t.source ? n.firestore.Lm().km(n.$m).then((function(t) {
                i(new vs(n.firestore, n.$m, t, 
                /*fromCache=*/ !0, t instanceof pn && t.un, n.ep));
            }), e) : n.cp(i, e, t);
        }));
    }, t.prototype.cp = function(t, n, i) {
        var e = this.hp({
            includeMetadataChanges: !0,
            bm: !0
        }, {
            next: function(r) {
                // Remove query first before passing event to user to avoid
                // user actions affecting the now stale query.
                e(), !r.exists && r.metadata.fromCache ? 
                // TODO(dimond): If we're online and the document doesn't
                // exist then we resolve with a doc.exists set to false. If
                // we're offline however, we reject the Promise in this
                // case. Two options: 1) Cache the negative response from
                // the server so we can deliver that even when you're
                // offline 2) Actually reject the Promise in the online case
                // if the document doesn't exist.
                n(new B(L.UNAVAILABLE, "Failed to get document because the client is offline.")) : r.exists && r.metadata.fromCache && i && "server" === i.source ? n(new B(L.UNAVAILABLE, 'Failed to get document from server. (However, this document does exist in the local cache. Run again without setting source to "server" to retrieve the cached document.)')) : t(r);
            },
            error: n
        });
    }, t.prototype.withConverter = function(n) {
        return new t(this.$m, this.firestore, n);
    }, t;
}(), ds = /** @class */ function() {
    function t(t, n) {
        this.hasPendingWrites = t, this.fromCache = n;
    }
    return t.prototype.isEqual = function(t) {
        return this.hasPendingWrites === t.hasPendingWrites && this.fromCache === t.fromCache;
    }, t;
}(), vs = /** @class */ function() {
    function t(t, n, i, e, r, u) {
        this.np = t, this.$m = n, this.ap = i, this.fp = e, this.lp = r, this.ep = u;
    }
    return t.prototype.data = function(t) {
        if (nt("DocumentSnapshot.data", arguments, 0, 1), t = ys("DocumentSnapshot.data", t), 
        this.ap) {
            // We only want to use the converter and create a new DocumentSnapshot
            // if a converter has been provided.
            if (this.ep) {
                var n = new ws(this.np, this.$m, this.ap, this.fp, this.lp);
                return this.ep.fromFirestore(n, t);
            }
            return this.dp(this.ap.data(), Zt.Dn(t, this.np.tp()));
        }
    }, t.prototype.get = function(t, n) {
        if (nt("DocumentSnapshot.get", arguments, 1, 2), n = ys("DocumentSnapshot.get", n), 
        this.ap) {
            var i = this.ap.data().field(gu("DocumentSnapshot.get", t));
            if (null !== i) return this.vp(i, Zt.Dn(n, this.np.tp()));
        }
    }, Object.defineProperty(t.prototype, "id", {
        get: function() {
            return this.$m.path.X();
        },
        enumerable: !0,
        configurable: !0
    }), Object.defineProperty(t.prototype, "ref", {
        get: function() {
            return new ls(this.$m, this.np, this.ep);
        },
        enumerable: !0,
        configurable: !0
    }), Object.defineProperty(t.prototype, "exists", {
        get: function() {
            return null !== this.ap;
        },
        enumerable: !0,
        configurable: !0
    }), Object.defineProperty(t.prototype, "metadata", {
        get: function() {
            return new ds(this.lp, this.fp);
        },
        enumerable: !0,
        configurable: !0
    }), t.prototype.isEqual = function(n) {
        if (!(n instanceof t)) throw vt("isEqual", "DocumentSnapshot", 1, n);
        return this.np === n.np && this.fp === n.fp && this.$m.isEqual(n.$m) && (null === this.ap ? null === n.ap : this.ap.isEqual(n.ap)) && this.ep === n.ep;
    }, t.prototype.dp = function(t, n) {
        var i = this, e = {};
        return t.forEach((function(t, r) {
            e[t] = i.vp(r, n);
        })), e;
    }, t.prototype.vp = function(t, n) {
        if (t instanceof vn) return this.dp(t, n);
        if (t instanceof wn) return this.wp(t, n);
        if (t instanceof ln) {
            var i = t.value(n), e = this.np.Lm().s();
            return t.s.isEqual(e) || 
            // TODO(b/64130202): Somehow support foreign references.
            D("Document " + this.$m.path + " contains a document reference within a different database (" + t.s.projectId + "/" + t.s.database + ") which is not supported. It will be treated as a reference in the current database (" + e.projectId + "/" + e.database + ") instead."), 
            new ls(i, this.np, this.ep);
        }
        return t.value(n);
    }, t.prototype.wp = function(t, n) {
        var i = this;
        return t.Ht.map((function(t) {
            return i.vp(t, n);
        }));
    }, t;
}(), ws = /** @class */ function(t) {
    function n() {
        return null !== t && t.apply(this, arguments) || this;
    }
    return i(n, t), n.prototype.data = function(n) {
        var i = t.prototype.data.call(this, n);
        return C(void 0 !== i, "Document in a QueryDocumentSnapshot should exist"), i;
    }, n;
}(vs), ms = /** @class */ function() {
    function t(t, n, i) {
        this.mp = t, this.firestore = n, this.ep = i;
    }
    return t.prototype.where = function(n, i, e) {
        Z("Query.where", arguments, 3), lt("Query.where", 3, e);
        // Enumerated from the WhereFilterOp type in index.d.ts.
        var r, u = [ "<", "<=", "==", ">=", ">", "array-contains", "in", "array-contains-any" ];
        ht("Query.where", u, 2, i);
        var s = gu("Query.where", n), o = Fn.it(i);
        if (s.ut()) {
            if (o === Fn.ARRAY_CONTAINS || o === Fn.ARRAY_CONTAINS_ANY) throw new B(L.INVALID_ARGUMENT, "Invalid Query. You can't perform '" + o.toString() + "' queries on FieldPath.documentId().");
            if (o === Fn.IN) {
                this.pp(e, o);
                for (var h = [], c = 0, a = e; c < a.length; c++) {
                    var f = a[c];
                    h.push(this.gp(f));
                }
                r = new wn(h);
            } else r = this.gp(e);
        } else o !== Fn.IN && o !== Fn.ARRAY_CONTAINS_ANY || this.pp(e, o), r = this.firestore.zm.od("Query.where", e, 
        // We only allow nested arrays for IN queries.
        /** allowArrays = */ o === Fn.IN);
        var l = xn.create(s, o, r);
        return this.bp(l), new t(this.mp.ni(l), this.firestore, this.ep);
    }, t.prototype.orderBy = function(n, i) {
        var e;
        if (nt("Query.orderBy", arguments, 1, 2), et("Query.orderBy", "non-empty string", 2, i), 
        void 0 === i || "asc" === i) e = qn.ASCENDING; else {
            if ("desc" !== i) throw new B(L.INVALID_ARGUMENT, "Function Query.orderBy() has unknown direction '" + i + "', expected 'asc' or 'desc'.");
            e = qn.DESCENDING;
        }
        if (null !== this.mp.startAt) throw new B(L.INVALID_ARGUMENT, "Invalid query. You must not call Query.startAt() or Query.startAfter() before calling Query.orderBy().");
        if (null !== this.mp.endAt) throw new B(L.INVALID_ARGUMENT, "Invalid query. You must not call Query.endAt() or Query.endBefore() before calling Query.orderBy().");
        var r = gu("Query.orderBy", n), u = new Gn(r, e);
        return this.yp(u), new t(this.mp.ei(u), this.firestore, this.ep);
    }, t.prototype.limit = function(n) {
        return Z("Query.limit", arguments, 1), it("Query.limit", "number", 1, n), wt("Query.limit", 1, n), 
        new t(this.mp.ri(n), this.firestore, this.ep);
    }, t.prototype.limitToLast = function(n) {
        return Z("Query.limitToLast", arguments, 1), it("Query.limitToLast", "number", 1, n), 
        wt("Query.limitToLast", 1, n), new t(this.mp.ui(n), this.firestore, this.ep);
    }, t.prototype.startAt = function(n) {
        for (var i = [], e = 1; e < arguments.length; e++) i[e - 1] = arguments[e];
        tt("Query.startAt", arguments, 1);
        var r = this._p("Query.startAt", n, i, 
        /*before=*/ !0);
        return new t(this.mp.si(r), this.firestore, this.ep);
    }, t.prototype.startAfter = function(n) {
        for (var i = [], e = 1; e < arguments.length; e++) i[e - 1] = arguments[e];
        tt("Query.startAfter", arguments, 1);
        var r = this._p("Query.startAfter", n, i, 
        /*before=*/ !1);
        return new t(this.mp.si(r), this.firestore, this.ep);
    }, t.prototype.endBefore = function(n) {
        for (var i = [], e = 1; e < arguments.length; e++) i[e - 1] = arguments[e];
        tt("Query.endBefore", arguments, 1);
        var r = this._p("Query.endBefore", n, i, 
        /*before=*/ !0);
        return new t(this.mp.oi(r), this.firestore, this.ep);
    }, t.prototype.endAt = function(n) {
        for (var i = [], e = 1; e < arguments.length; e++) i[e - 1] = arguments[e];
        tt("Query.endAt", arguments, 1);
        var r = this._p("Query.endAt", n, i, 
        /*before=*/ !1);
        return new t(this.mp.oi(r), this.firestore, this.ep);
    }, t.prototype.isEqual = function(n) {
        if (!(n instanceof t)) throw vt("isEqual", "Query", 1, n);
        return this.firestore === n.firestore && this.mp.isEqual(n.mp);
    }, t.prototype.withConverter = function(n) {
        return new t(this.mp, this.firestore, n);
    }, 
    /** Helper function to create a bound from a document or fields */
    t.prototype._p = function(t, n, i, e) {
        if (lt(t, 1, n), n instanceof vs) {
            if (i.length > 0) throw new B(L.INVALID_ARGUMENT, "Too many arguments provided to " + t + "().");
            var r = n;
            if (!r.exists) throw new B(L.NOT_FOUND, "Can't use a DocumentSnapshot that doesn't exist for " + t + "().");
            return this.Ip(t, r.ap, e);
        }
        var u = [ n ].concat(i);
        return this.Tp(t, u, e);
    }, 
    /**
     * Create a Bound from a query and a document.
     *
     * Note that the Bound will always include the key of the document
     * and so only the provided document will compare equal to the returned
     * position.
     *
     * Will throw if the document does not contain all fields of the order by
     * of the query or if any of the fields in the order by are an uncommitted
     * server timestamp.
     */
    t.prototype.Ip = function(t, n, i) {
        // Because people expect to continue/end a query at the exact document
        // provided, we need to use the implicit sort order rather than the explicit
        // sort order, because it's guaranteed to contain the document key. That way
        // the position becomes unambiguous and the query continues/ends exactly at
        // the provided document. Without the key (by using the explicit sort
        // orders), multiple documents could match the position, yielding duplicate
        // results.
        for (var e = [], r = 0, u = this.mp.orderBy; r < u.length; r++) {
            var s = u[r];
            if (s.field.ut()) e.push(new ln(this.firestore.Mm, n.key)); else {
                var o = n.field(s.field);
                if (o instanceof an) throw new B(L.INVALID_ARGUMENT, 'Invalid query. You are trying to start or end a query using a document for which the field "' + s.field + '" is an uncommitted server timestamp. (Since the value of this field is unknown, you cannot start/end a query with it.)');
                if (null === o) {
                    var h = s.field.nt();
                    throw new B(L.INVALID_ARGUMENT, "Invalid query. You are trying to start or end a query using a document for which the field '" + h + "' (used as the orderBy) does not exist.");
                }
                e.push(o);
            }
        }
        return new Qn(e, i);
    }, 
    /**
     * Converts a list of field values to a Bound for the given query.
     */
    t.prototype.Tp = function(t, n, i) {
        // Use explicit order by's because it has to match the query the user made
        var e = this.mp.Kn;
        if (n.length > e.length) throw new B(L.INVALID_ARGUMENT, "Too many arguments provided to " + t + "(). The number of arguments must be less than or equal to the number of Query.orderBy() clauses");
        for (var r = [], u = 0; u < n.length; u++) {
            var s = n[u];
            if (e[u].field.ut()) {
                if ("string" != typeof s) throw new B(L.INVALID_ARGUMENT, "Invalid query. Expected a string for document ID in " + t + "(), but got a " + typeof s);
                if (!this.mp.bi() && -1 !== s.indexOf("/")) throw new B(L.INVALID_ARGUMENT, "Invalid query. When querying a collection and ordering by FieldPath.documentId(), the value passed to " + t + "() must be a plain document ID, but '" + s + "' contains a slash.");
                var o = this.mp.path.child(It.it(s));
                if (!Rt.ht(o)) throw new B(L.INVALID_ARGUMENT, "Invalid query. When querying a collection group and ordering by FieldPath.documentId(), the value passed to " + t + "() must result in a valid document path, but '" + o + "' is not because it contains an odd number of segments.");
                var h = new Rt(o);
                r.push(new ln(this.firestore.Mm, h));
            } else {
                var c = this.firestore.zm.od(t, s);
                r.push(c);
            }
        }
        return new Qn(r, i);
    }, t.prototype.onSnapshot = function() {
        for (var t = [], n = 0; n < arguments.length; n++) t[n] = arguments[n];
        nt("Query.onSnapshot", arguments, 1, 4);
        var i, e = {}, r = 0;
        return "object" != typeof t[r] || is(t[r]) || (dt("Query.onSnapshot", e = t[r], [ "includeMetadataChanges" ]), 
        ut("Query.onSnapshot", "boolean", "includeMetadataChanges", e.includeMetadataChanges), 
        r++), is(t[r]) ? i = t[r] : (it("Query.onSnapshot", "function", r, t[r]), et("Query.onSnapshot", "function", r + 1, t[r + 1]), 
        et("Query.onSnapshot", "function", r + 2, t[r + 2]), i = {
            next: t[r],
            error: t[r + 1],
            complete: t[r + 2]
        }), this.Ep(this.mp), this.hp(e, i);
    }, t.prototype.hp = function(t, n) {
        var i = this, e = function(t) {
            console.error("Uncaught Error in onSnapshot:", t);
        };
        n.error && (e = n.error.bind(n));
        var r = new ns({
            next: function(t) {
                n.next && n.next(new ps(i.firestore, i.mp, t, i.ep));
            },
            error: e
        }), u = this.firestore.Lm(), s = u.listen(this.mp, r, t);
        return function() {
            r.xm(), u.Zd(s);
        };
    }, t.prototype.Ep = function(t) {
        if (t.pi() && 0 === t.Kn.length) throw new B(L.UNIMPLEMENTED, "limitToLast() queries require specifying at least one orderBy() clause");
    }, t.prototype.get = function(t) {
        var n = this;
        return nt("Query.get", arguments, 0, 1), _s("Query.get", t), this.Ep(this.mp), new Promise((function(i, e) {
            t && "cache" === t.source ? n.firestore.Lm().Om(n.mp).then((function(t) {
                i(new ps(n.firestore, n.mp, t, n.ep));
            }), e) : n.cp(i, e, t);
        }));
    }, t.prototype.cp = function(t, n, i) {
        var e = this.hp({
            includeMetadataChanges: !0,
            bm: !0
        }, {
            next: function(r) {
                // Remove query first before passing event to user to avoid
                // user actions affecting the now stale query.
                e(), r.metadata.fromCache && i && "server" === i.source ? n(new B(L.UNAVAILABLE, 'Failed to get documents from server. (However, these documents may exist in the local cache. Run again without setting source to "server" to retrieve the cached documents.)')) : t(r);
            },
            error: n
        });
    }, 
    /**
     * Parses the given documentIdValue into a ReferenceValue, throwing
     * appropriate errors if the value is anything other than a DocumentReference
     * or String, or if the string is malformed.
     */
    t.prototype.gp = function(t) {
        if ("string" == typeof t) {
            if ("" === t) throw new B(L.INVALID_ARGUMENT, "Invalid query. When querying with FieldPath.documentId(), you must provide a valid document ID, but it was an empty string.");
            if (!this.mp.bi() && -1 !== t.indexOf("/")) throw new B(L.INVALID_ARGUMENT, "Invalid query. When querying a collection by FieldPath.documentId(), you must provide a plain document ID, but '" + t + "' contains a '/' character.");
            var n = this.mp.path.child(It.it(t));
            if (!Rt.ht(n)) throw new B(L.INVALID_ARGUMENT, "Invalid query. When querying a collection group by FieldPath.documentId(), the value provided must result in a valid document path, but '" + n + "' is not because it has an odd number of segments (" + n.length + ").");
            return new ln(this.firestore.Mm, new Rt(n));
        }
        if (t instanceof ls) {
            var i = t;
            return new ln(this.firestore.Mm, i.$m);
        }
        throw new B(L.INVALID_ARGUMENT, "Invalid query. When querying with FieldPath.documentId(), you must provide a valid string or a DocumentReference, but it was: " + ft(t) + ".");
    }, 
    /**
     * Validates that the value passed into a disjunctrive filter satisfies all
     * array requirements.
     */
    t.prototype.pp = function(t, n) {
        if (!Array.isArray(t) || 0 === t.length) throw new B(L.INVALID_ARGUMENT, "Invalid Query. A non-empty array is required for '" + n.toString() + "' filters.");
        if (t.length > 10) throw new B(L.INVALID_ARGUMENT, "Invalid Query. '" + n.toString() + "' filters support a maximum of 10 elements in the value array.");
        if (t.indexOf(null) >= 0) throw new B(L.INVALID_ARGUMENT, "Invalid Query. '" + n.toString() + "' filters cannot contain 'null' in the value array.");
        if (t.filter((function(t) {
            return Number.isNaN(t);
        })).length > 0) throw new B(L.INVALID_ARGUMENT, "Invalid Query. '" + n.toString() + "' filters cannot contain 'NaN' in the value array.");
    }, t.prototype.bp = function(t) {
        if (t instanceof xn) {
            var n = [ Fn.ARRAY_CONTAINS, Fn.ARRAY_CONTAINS_ANY ], i = [ Fn.IN, Fn.ARRAY_CONTAINS_ANY ], e = n.indexOf(t.op) >= 0, r = i.indexOf(t.op) >= 0;
            if (t.ii()) {
                var u = this.mp.Zn();
                if (null !== u && !u.isEqual(t.field)) throw new B(L.INVALID_ARGUMENT, "Invalid query. All where filters with an inequality (<, <=, >, or >=) must be on the same field. But you have inequality filters on '" + u.toString() + "' and '" + t.field.toString() + "'");
                var s = this.mp.ti();
                null !== s && this.Rp(t.field, s);
            } else if (r || e) {
                // You can have at most 1 disjunctive filter and 1 array filter. Check if
                // the new filter conflicts with an existing one.
                var o = null;
                if (r && (o = this.mp.gi(i)), null === o && e && (o = this.mp.gi(n)), null != o) 
                // We special case when it's a duplicate op to give a slightly clearer error message.
                throw o === t.op ? new B(L.INVALID_ARGUMENT, "Invalid query. You cannot use more than one '" + t.op.toString() + "' filter.") : new B(L.INVALID_ARGUMENT, "Invalid query. You cannot use '" + t.op.toString() + "' filters with '" + o.toString() + "' filters.");
            }
        }
    }, t.prototype.yp = function(t) {
        if (null === this.mp.ti()) {
            // This is the first order by. It must match any inequality.
            var n = this.mp.Zn();
            null !== n && this.Rp(n, t.field);
        }
    }, t.prototype.Rp = function(t, n) {
        if (!n.isEqual(t)) throw new B(L.INVALID_ARGUMENT, "Invalid query. You have a where filter with an inequality (<, <=, >, or >=) on field '" + t.toString() + "' and so you must also use '" + t.toString() + "' as your first Query.orderBy(), but your first Query.orderBy() is on field '" + n.toString() + "' instead.");
    }, t;
}(), ps = /** @class */ function() {
    function t(t, n, i, e) {
        this.np = t, this.Ap = n, this.Dp = i, this.ep = e, this.Pp = null, this.Sp = null, 
        this.metadata = new ds(i.hasPendingWrites, i.fromCache);
    }
    return Object.defineProperty(t.prototype, "docs", {
        get: function() {
            var t = [];
            return this.forEach((function(n) {
                return t.push(n);
            })), t;
        },
        enumerable: !0,
        configurable: !0
    }), Object.defineProperty(t.prototype, "empty", {
        get: function() {
            return this.Dp.docs.J();
        },
        enumerable: !0,
        configurable: !0
    }), Object.defineProperty(t.prototype, "size", {
        get: function() {
            return this.Dp.docs.size;
        },
        enumerable: !0,
        configurable: !0
    }), t.prototype.forEach = function(t, n) {
        var i = this;
        nt("QuerySnapshot.forEach", arguments, 1, 2), it("QuerySnapshot.forEach", "function", 1, t), 
        this.Dp.docs.forEach((function(e) {
            t.call(n, i.Cp(e));
        }));
    }, Object.defineProperty(t.prototype, "query", {
        get: function() {
            return new ms(this.Ap, this.np, this.ep);
        },
        enumerable: !0,
        configurable: !0
    }), t.prototype.docChanges = function(t) {
        t && (dt("QuerySnapshot.docChanges", t, [ "includeMetadataChanges" ]), ut("QuerySnapshot.docChanges", "boolean", "includeMetadataChanges", t.includeMetadataChanges));
        var n = !(!t || !t.includeMetadataChanges);
        if (n && this.Dp.$i) throw new B(L.INVALID_ARGUMENT, "To include metadata changes with your document changes, you must also pass { includeMetadataChanges:true } to onSnapshot().");
        return this.Pp && this.Sp === n || (this.Pp = 
        /**
 * Calculates the array of firestore.DocumentChange's for a given ViewSnapshot.
 *
 * Exported for testing.
 */
        function(t, n, i, e) {
            if (i.Ji.J()) {
                // Special case the first snapshot because index calculation is easy and
                // fast
                var r, u = 0;
                return i.docChanges.map((function(n) {
                    var s = new ws(t, n.doc.key, n.doc, i.fromCache, i.Yi.has(n.doc.key), e);
                    return C(n.type === mi.Mi, "Invalid event type for first snapshot"), C(!r || i.query.fi(r, n.doc) < 0, "Got added events in wrong order"), 
                    r = n.doc, {
                        type: "added",
                        doc: s,
                        oldIndex: -1,
                        newIndex: u++
                    };
                }));
            }
            // A DocumentSet that is updated incrementally as changes are applied to use
            // to lookup the index of a document.
            var s = i.Ji;
            return i.docChanges.filter((function(t) {
                return n || t.type !== mi.Gi;
            })).map((function(n) {
                var r = new ws(t, n.doc.key, n.doc, i.fromCache, i.Yi.has(n.doc.key), e), u = -1, o = -1;
                return n.type !== mi.Mi && (C((u = s.indexOf(n.doc.key)) >= 0, "Index for document not found"), 
                s = s.delete(n.doc.key)), n.type !== mi.qi && (o = (s = s.add(n.doc)).indexOf(n.doc.key)), 
                {
                    type: Ts(n.type),
                    doc: r,
                    oldIndex: u,
                    newIndex: o
                };
            }));
        }(this.np, n, this.Dp, this.ep), this.Sp = n), this.Pp;
    }, 
    /** Check the equality. The call can be very expensive. */
    t.prototype.isEqual = function(n) {
        if (!(n instanceof t)) throw vt("isEqual", "QuerySnapshot", 1, n);
        return this.np === n.np && this.Ap.isEqual(n.Ap) && this.Dp.isEqual(n.Dp) && this.ep === n.ep;
    }, t.prototype.Cp = function(t) {
        return new ws(this.np, t.key, t, this.metadata.fromCache, this.Dp.Yi.has(t.key), this.ep);
    }, t;
}();

n([ "length", "forEach", "map" ], "undefined" != typeof Symbol ? [ Symbol.iterator ] : []).forEach((function(t) {
    /**
     * We are (re-)defining properties on QuerySnapshot.prototype.docChanges which
     * is a Function. This could fail, in particular in the case of 'length' which
     * already exists on Function.prototype and on IE11 is improperly defined with
     * `{ configurable: false }`. So we wrap this in a try/catch to ensure that we
     * still have a functional SDK.
     */
    try {
        Object.defineProperty(ps.prototype.docChanges, t, {
            get: function() {
                // TODO(2018/11/01): As of 2018/04/17 we're changing docChanges from an array
                // into a method. Because this is a runtime breaking change and somewhat subtle
                // (both Array and Function have a .length, etc.), we'll replace commonly-used
                // properties (including Symbol.iterator) to throw a custom error message. In
                // ~6 months we can delete the custom error as most folks will have hopefully
                // migrated.
                return function() {
                    throw new B(L.INVALID_ARGUMENT, 'QuerySnapshot.docChanges has been changed from a property into a method, so usages like "querySnapshot.docChanges" should become "querySnapshot.docChanges()"');
                }();
            }
        });
    } catch (t) {}
 // Ignore this failure intentionally
}));

var gs = /** @class */ function(t) {
    function n(n, i, e) {
        var r = t.call(this, kn.$n(n), i, e) || this;
        if (r.Vp = n, n.length % 2 != 1) throw new B(L.INVALID_ARGUMENT, "Invalid collection reference. Collection references must have an odd number of segments, but " + n.nt() + " has " + n.length);
        return r;
    }
    return i(n, t), Object.defineProperty(n.prototype, "id", {
        get: function() {
            return this.mp.path.X();
        },
        enumerable: !0,
        configurable: !0
    }), Object.defineProperty(n.prototype, "parent", {
        get: function() {
            var t = this.mp.path.H();
            return t.J() ? null : new ls(new Rt(t), this.firestore);
        },
        enumerable: !0,
        configurable: !0
    }), Object.defineProperty(n.prototype, "path", {
        get: function() {
            return this.mp.path.nt();
        },
        enumerable: !0,
        configurable: !0
    }), n.prototype.doc = function(t) {
        if (nt("CollectionReference.doc", arguments, 0, 1), 
        // We allow omission of 'pathString' but explicitly prohibit passing in both
        // 'undefined' and 'null'.
        0 === arguments.length && (t = V.u()), it("CollectionReference.doc", "non-empty string", 1, t), 
        "" === t) throw new B(L.INVALID_ARGUMENT, "Document path must be a non-empty string");
        var n = It.it(t);
        return ls.Zm(this.mp.path.child(n), this.firestore, this.ep);
    }, n.prototype.add = function(t) {
        Z("CollectionReference.add", arguments, 1);
        var n = this.ep ? this.ep.toFirestore(t) : t;
        it("CollectionReference.add", "object", 1, n);
        var i = this.doc();
        return i.set(t).then((function() {
            return i;
        }));
    }, n.prototype.withConverter = function(t) {
        return new n(this.Vp, this.firestore, t);
    }, n;
}(ms);

function bs(t, n) {
    if (void 0 === n) return {
        merge: !1
    };
    if (dt(t, n, [ "merge", "mergeFields" ]), ut(t, "boolean", "merge", n.merge), st(t, "mergeFields", "a string or a FieldPath", n.mergeFields, (function(t) {
        return "string" == typeof t || t instanceof $r;
    })), void 0 !== n.mergeFields && void 0 !== n.merge) throw new B(L.INVALID_ARGUMENT, "Invalid options passed to function " + t + '(): You cannot specify both "merge" and "mergeFields".');
    return n;
}

function ys(t, n) {
    return void 0 === n ? {} : (dt(t, n, [ "serverTimestamps" ]), ot(t, 0, "serverTimestamps", n.serverTimestamps, [ "estimate", "previous", "none" ]), 
    n);
}

function _s(t, n) {
    et(t, "object", 1, n), n && (dt(t, n, [ "source" ]), ot(t, 0, "source", n.source, [ "default", "server", "cache" ]));
}

function Is(t, n, i) {
    if (n instanceof ls) {
        if (n.firestore !== i) throw new B(L.INVALID_ARGUMENT, "Provided document reference is from a different Firestore instance.");
        return n;
    }
    throw vt(t, "DocumentReference", 1, n);
}

function Ts(t) {
    switch (t) {
      case mi.Mi:
        return "added";

      case mi.Qi:
      case mi.Gi:
        return "modified";

      case mi.qi:
        return "removed";

      default:
        return S("Unknown change type: " + t);
    }
}

/**
 * Converts custom model object of type T into DocumentData by applying the
 * converter if it exists.
 *
 * This function is used when converting user objects to DocumentData
 * because we want to provide the user with a more specific error message if
 * their set() or fails due to invalid data originating from a toFirestore()
 * call.
 */ function Es(t, n, i) {
    var e;
    return t ? (e = t.toFirestore(n), i = "toFirestore() in " + i) : e = n, [ e, i ];
}

// Export the classes with a private constructor (it will fail if invoked
// at runtime). Note that this still allows instanceof checks.
// We're treating the variables as class names, so disable checking for lower
// case variable names.
var Rs = Qi(cs, "Use firebase.firestore() instead."), As = Qi(as, "Use firebase.firestore().runTransaction() instead."), Ds = Qi(fs, "Use firebase.firestore().batch() instead."), Ps = Qi(ls, "Use firebase.firestore().doc() instead."), Ss = Qi(vs), Cs = Qi(ws), Vs = Qi(ms), Ns = Qi(ps), ks = Qi(gs, "Use firebase.firestore().collection() instead."), Os = {
    Firestore: Rs,
    GeoPoint: gt,
    Timestamp: bt,
    Blob: Ji,
    Transaction: As,
    WriteBatch: Ds,
    DocumentReference: Ps,
    DocumentSnapshot: Ss,
    Query: Vs,
    QueryDocumentSnapshot: Cs,
    QuerySnapshot: Ns,
    CollectionReference: ks,
    FieldPath: $r,
    FieldValue: hu,
    setLogLevel: cs.setLogLevel,
    CACHE_SIZE_UNLIMITED: os
};

/**
 * Configures Firestore as part of the Firebase SDK by calling registerService.
 */
function Fs(t) {
    var n;
    t.INTERNAL.registerComponent(new w("firestore", (function(t) {
        var n = t.getProvider("app").getImmediate();
        return new cs(n, t.getProvider("auth-internal"));
    }), "PUBLIC" /* PUBLIC */).setServiceProps((C((n = Os) && "object" == typeof n, "shallowCopy() expects object parameter."), 
    e({}, n))));
}

/**
 * @license
 * Copyright 2019 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ var xs = /** @class */ function() {
    function t() {}
    return t.prototype.Fd = function(t) {
        // No-op.
    }, t.prototype.shutdown = function() {
        // No-op.
    }, t;
}(), js = /** @class */ function() {
    function t() {
        var t = this;
        this.Np = function() {
            return t.kp();
        }, this.Op = function() {
            return t.Fp();
        }, this.xp = [], this.jp();
    }
    return t.prototype.Fd = function(t) {
        this.xp.push(t);
    }, t.prototype.shutdown = function() {
        window.removeEventListener("online", this.Np), window.removeEventListener("offline", this.Op);
    }, t.prototype.jp = function() {
        window.addEventListener("online", this.Np), window.addEventListener("offline", this.Op);
    }, t.prototype.kp = function() {
        A("ConnectivityMonitor", "Network connectivity changed: AVAILABLE");
        for (var t = 0, n = this.xp; t < n.length; t++) {
            (0, n[t])(0 /* AVAILABLE */);
        }
    }, t.prototype.Fp = function() {
        A("ConnectivityMonitor", "Network connectivity changed: UNAVAILABLE");
        for (var t = 0, n = this.xp; t < n.length; t++) {
            (0, n[t])(1 /* UNAVAILABLE */);
        }
    }, 
    // TODO(chenbrian): Consider passing in window either into this component or
    // here for testing via FakeWindow.
    /** Checks that all used attributes of window are available. */
    t.Js = function() {
        return "undefined" != typeof window && void 0 !== window.addEventListener && void 0 !== window.removeEventListener;
    }, t;
}(), Us = /** @class */ function() {
    function t(t) {
        this.Up = t.Up, this.Lp = t.Lp;
    }
    return t.prototype._l = function(t) {
        C(!this.Bp, "Called onOpen on stream twice!"), this.Bp = t;
    }, t.prototype.ml = function(t) {
        C(!this.Mp, "Called onClose on stream twice!"), this.Mp = t;
    }, t.prototype.onMessage = function(t) {
        C(!this.qp, "Called onMessage on stream twice!"), this.qp = t;
    }, t.prototype.close = function() {
        this.Lp();
    }, t.prototype.send = function(t) {
        this.Up(t);
    }, t.prototype.Qp = function() {
        C(void 0 !== this.Bp, "Cannot call onOpen because no callback was set"), this.Bp();
    }, t.prototype.Gp = function(t) {
        C(void 0 !== this.Mp, "Cannot call onClose because no callback was set"), this.Mp(t);
    }, t.prototype.Wp = function(t) {
        C(void 0 !== this.qp, "Cannot call onMessage because no callback was set"), this.qp(t);
    }, t;
}(), Ls = {
    BatchGetDocuments: "batchGet",
    Commit: "commit"
}, Bs = "gl-js/ fire/" + I, Ms = /** @class */ function() {
    function t(t) {
        this.s = t.s;
        var n = t.ssl ? "https" : "http";
        this.zp = n + "://" + t.host, this.forceLongPolling = t.forceLongPolling;
    }
    /**
     * Modifies the headers for a request, adding any authorization token if
     * present and any additional headers for the request.
     */    return t.prototype.Kp = function(t, n) {
        if (n) for (var i in n.g) n.g.hasOwnProperty(i) && (t[i] = n.g[i]);
        t["X-Goog-Api-Client"] = Bs;
    }, t.prototype.kl = function(t, n, i) {
        var r = this, u = this.Hp(t);
        return new Promise((function(s, o) {
            var h = new m;
            h.listenOnce(p.COMPLETE, (function() {
                try {
                    switch (h.getLastErrorCode()) {
                      case g.NO_ERROR:
                        var n = h.getResponseJson();
                        A("Connection", "XHR received:", JSON.stringify(n)), s(n);
                        break;

                      case g.TIMEOUT:
                        A("Connection", 'RPC "' + t + '" timed out'), o(new B(L.DEADLINE_EXCEEDED, "Request time out"));
                        break;

                      case g.HTTP_ERROR:
                        var i = h.getStatus();
                        if (A("Connection", 'RPC "' + t + '" failed with status:', i, "response text:", h.getResponseText()), 
                        i > 0) {
                            var e = h.getResponseJson().error;
                            if (e && e.status && e.message) {
                                var r = (u = e.status, c = u.toLowerCase().replace("_", "-"), Object.values(L).indexOf(c) >= 0 ? c : L.UNKNOWN);
                                o(new B(r, e.message));
                            } else o(new B(L.UNKNOWN, "Server responded with status " + h.getStatus()));
                        } else 
                        // If we received an HTTP_ERROR but there's no status code,
                        // it's most probably a connection issue
                        A("Connection", 'RPC "' + t + '" failed'), o(new B(L.UNAVAILABLE, "Connection failed."));
                        break;

                      default:
                        S('RPC "' + t + '" failed with unanticipated webchannel error ' + h.getLastErrorCode() + ": " + h.getLastError() + ", giving up.");
                    }
                } finally {
                    A("Connection", 'RPC "' + t + '" completed.');
                }
                var u, c;
            }));
            // The database field is already encoded in URL. Specifying it again in
            // the body is not necessary in production, and will cause duplicate field
            // errors in the Firestore Emulator. Let's remove it.
            var c = e({}, n);
            delete c.database;
            var a = JSON.stringify(c);
            A("Connection", "XHR sending: ", u + " " + a);
            // Content-Type: text/plain will avoid preflight requests which might
            // mess with CORS and redirects by proxies. If we add custom headers
            // we will need to change this code to potentially use the
            // $httpOverwrite parameter supported by ESF to avoid
            // triggering preflight requests.
            var f = {
                "Content-Type": "text/plain"
            };
            r.Kp(f, i), h.send(u, "POST", a, f, 15);
        }));
    }, t.prototype.Ol = function(t, n, i) {
        // The REST API automatically aggregates all of the streamed results, so we
        // can just use the normal invoke() method.
        return this.kl(t, n, i);
    }, t.prototype.Il = function(t, n) {
        var i = [ this.zp, "/", "google.firestore.v1.Firestore", "/", t, "/channel" ], e = b(), r = {
            // Background channel test avoids the initial two test calls and decreases
            // initial cold start time.
            // TODO(dimond): wenboz@ mentioned this might affect use with proxies and
            // we should monitor closely for any reports.
            backgroundChannelTest: !0,
            // Required for backend stickiness, routing behavior is based on this
            // parameter.
            httpSessionIdParam: "gsessionid",
            initMessageHeaders: {},
            messageUrlParams: {
                // This param is used to improve routing and project isolation by the
                // backend and must be included in every request.
                database: "projects/" + this.s.projectId + "/databases/" + this.s.database
            },
            sendRawJson: !0,
            supportsCrossDomainXhr: !0,
            internalChannelParams: {
                // Override the default timeout (randomized between 10-20 seconds) since
                // a large write batch on a slow internet connection may take a long
                // time to send to the backend. Rather than have WebChannel impose a
                // tight timeout which could lead to infinite timeouts and retries, we
                // set it very large (5-10 minutes) and rely on the browser's builtin
                // timeouts to kick in if the request isn't working.
                forwardChannelRequestTimeoutMs: 6e5
            },
            forceLongPolling: this.forceLongPolling
        };
        this.Kp(r.initMessageHeaders, n), 
        // Sending the custom headers we just added to request.initMessageHeaders
        // (Authorization, etc.) will trigger the browser to make a CORS preflight
        // request because the XHR will no longer meet the criteria for a "simple"
        // CORS request:
        // https://developer.mozilla.org/en-US/docs/Web/HTTP/CORS#Simple_requests
        //
        // Therefore to avoid the CORS preflight request (an extra network
        // roundtrip), we use the httpHeadersOverwriteParam option to specify that
        // the headers should instead be encoded into a special "$httpHeaders" query
        // parameter, which is recognized by the webchannel backend. This is
        // formally defined here:
        // https://github.com/google/closure-library/blob/b0e1815b13fb92a46d7c9b3c30de5d6a396a3245/closure/goog/net/rpc/httpcors.js#L32
        //
        // TODO(b/145624756): There is a backend bug where $httpHeaders isn't respected if the request
        // doesn't have an Origin header. So we have to exclude a few browser environments that are
        // known to (sometimes) not include an Origin. See
        // https://github.com/firebase/firebase-js-sdk/issues/1491.
        c() || a() || f() || l() || d() || v() || (r.httpHeadersOverwriteParam = "$httpHeaders");
        var u = i.join("");
        A("Connection", "Creating WebChannel: " + u + " " + r);
        var s = e.createWebChannel(u, r), o = !1, h = !1, w = new Us({
            Up: function(t) {
                h ? A("Connection", "Not sending because WebChannel is closed:", t) : (o || (A("Connection", "Opening WebChannel transport."), 
                s.open(), o = !0), A("Connection", "WebChannel sending:", t), s.send(t));
            },
            Lp: function() {
                return s.close();
            }
        }), m = function(t, n) {
            // TODO(dimond): closure typing seems broken because WebChannel does
            // not implement goog.events.Listenable
            s.listen(t, (function(t) {
                try {
                    n(t);
                } catch (t) {
                    setTimeout((function() {
                        throw t;
                    }), 0);
                }
            }));
        };
        // WebChannel supports sending the first message with the handshake - saving
        // a network round trip. However, it will have to call send in the same
        // JS event loop as open. In order to enforce this, we delay actually
        // opening the WebChannel until send is called. Whether we have called
        // open is tracked with this variable.
                return m(y.EventType.OPEN, (function() {
            h || A("Connection", "WebChannel transport opened.");
        })), m(y.EventType.CLOSE, (function() {
            h || (h = !0, A("Connection", "WebChannel transport closed"), w.Gp());
        })), m(y.EventType.ERROR, (function(t) {
            h || (h = !0, A("Connection", "WebChannel transport errored:", t), w.Gp(new B(L.UNAVAILABLE, "The operation could not be completed")));
        })), m(y.EventType.MESSAGE, (function(t) {
            var n;
            if (!h) {
                var i = t.data[0];
                C(!!i, "Got a webchannel message without data.");
                // TODO(b/35143891): There is a bug in One Platform that caused errors
                // (and only errors) to be wrapped in an extra array. To be forward
                // compatible with the bug we need to check either condition. The latter
                // can be removed once the fix has been rolled out.
                // Use any because msgData.error is not typed.
                var e = i, r = e.error || (null === (n = e[0]) || void 0 === n ? void 0 : n.error);
                if (r) {
                    A("Connection", "WebChannel received error:", r);
                    // error.status will be a string like 'OK' or 'NOT_FOUND'.
                    var u = r.status, o = function(t) {
                        // lookup by string
                        // eslint-disable-next-line @typescript-eslint/no-explicit-any
                        var n = $n[t];
                        if (void 0 !== n) return ei(n);
                    }(u), c = r.message;
                    void 0 === o && (o = L.INTERNAL, c = "Unknown error status: " + u + " with message " + r.message), 
                    // Mark closed so no further events are propagated
                    h = !0, w.Gp(new B(o, c)), s.close();
                } else A("Connection", "WebChannel received:", i), w.Wp(i);
            }
        })), setTimeout((function() {
            // Technically we could/should wait for the WebChannel opened event,
            // but because we want to send the first message with the WebChannel
            // handshake we pretend the channel opened here (asynchronously), and
            // then delay the actual open until the first message is sent.
            w.Qp();
        }), 0), w;
    }, 
    // visible for testing
    t.prototype.Hp = function(t) {
        var n = Ls[t];
        return C(void 0 !== n, "Unknown REST mapping for: " + t), this.zp + "/v1/projects/" + this.s.projectId + "/databases/" + this.s.database + "/documents:" + n;
    }, t;
}(), qs = /** @class */ function() {
    function t() {
        this.vu = "undefined" != typeof atob;
    }
    return Object.defineProperty(t.prototype, "document", {
        get: function() {
            return "undefined" != typeof document ? document : null;
        },
        enumerable: !0,
        configurable: !0
    }), Object.defineProperty(t.prototype, "window", {
        get: function() {
            return "undefined" != typeof window ? window : null;
        },
        enumerable: !0,
        configurable: !0
    }), t.prototype.Dm = function(t) {
        return Promise.resolve(new Ms(t));
    }, t.prototype.Sm = function() {
        return js.Js() ? new js : new xs;
    }, t.prototype.Cm = function(t) {
        return new Mi(t, {
            tr: !0
        });
    }, t.prototype.i = function(t) {
        return JSON.stringify(t);
    }, t.prototype.atob = function(t) {
        return atob(t);
    }, t.prototype.btoa = function(t) {
        return btoa(t);
    }, t;
}();

/**
 * @license
 * Copyright 2019 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * This code needs to run before Firestore is used. This can be achieved in
 * several ways:
 *   1) Through the JSCompiler compiling this code and then (automatically)
 *      executing it before exporting the Firestore symbols.
 *   2) Through importing this module first in a Firestore main module
 */
qi.du(new qs);

var Qs = "@firebase/firestore", Gs = "1.11.1";

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
function Ws(t) {
    Fs(t), t.registerVersion(Qs, Gs);
}

Ws(t);

export { Ws as __PRIVATE_registerFirestore };
//# sourceMappingURL=index.esm.js.map
