import t from "@firebase/app";

import { Logger as e, LogLevel as s } from "@firebase/logger";

import { getUA as n, isMobileCordova as i, isReactNative as r, isElectron as o, isIE as h, isUWP as a, isBrowserExtension as u } from "@firebase/util";

import { Component as c } from "@firebase/component";

import { XhrIo as l, EventType as _, ErrorCode as d, createWebChannelTransport as f, WebChannel as m } from "@firebase/webchannel-wrapper";

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** The semver (www.semver.org) version of the SDK. */ const T = t.SDK_VERSION, w = new e("@firebase/firestore");

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ var E;

// Helper methods are needed because variables can't be exported as read/write
function I() {
    return w.logLevel === s.DEBUG ? E.DEBUG : w.logLevel === s.SILENT ? E.SILENT : E.ERROR;
}

function R(t) {
    /**
     * Map the new log level to the associated Firebase Log Level
     */
    switch (t) {
      case E.DEBUG:
        w.logLevel = s.DEBUG;
        break;

      case E.ERROR:
        w.logLevel = s.ERROR;
        break;

      case E.SILENT:
        w.logLevel = s.SILENT;
        break;

      default:
        w.error(`Firestore (${T}): Invalid value passed to \`setLogLevel\``);
    }
}

function A(t, e, ...n) {
    if (w.logLevel <= s.DEBUG) {
        const s = n.map(p);
        w.debug(`Firestore (${T}) [${t}]: ${e}`, ...s);
    }
}

function P(t, ...e) {
    if (w.logLevel <= s.ERROR) {
        const s = e.map(p);
        w.error(`Firestore (${T}): ${t}`, ...s);
    }
}

/**
 * Converts an additional log parameter to a string representation.
 */ function p(t) {
    if ("string" == typeof t) return t;
    {
        const e = Ns.t();
        try {
            return e.s(t);
        } catch (e) {
            // Converting to JSON failed, just log the object directly
            return t;
        }
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Unconditionally fails, throwing an Error with the given message.
 *
 * Returns any so it can be used in expressions:
 * @example
 * let futureVar = fail('not implemented yet');
 */ function V(t) {
    // Log the failure in addition to throw an exception, just in case the
    // exception is swallowed.
    const e = `FIRESTORE (${T}) INTERNAL ASSERTION FAILED: ` + t;
    // NOTE: We don't use FirestoreError here because these are internal failures
    // that cannot be handled by the user. (Also it would create a circular
    // dependency between the error and assert modules which doesn't work.)
    throw P(e), new Error(e);
}

/**
 * Fails if the given assertion condition is false, throwing an Error with the
 * given message if it did.
 */ function g(t, e) {
    t || V(e);
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ !function(t) {
    t[t.DEBUG = 0] = "DEBUG", t[t.ERROR = 1] = "ERROR", t[t.SILENT = 2] = "SILENT";
}(E || (E = {}));

class y {
    static i() {
        // Alphanumeric characters
        const t = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
        let e = "";
        for (let s = 0; s < 20; s++) e += t.charAt(Math.floor(Math.random() * t.length));
        return g(20 === e.length, "Invalid auto ID: " + e), e;
    }
}

function b(t, e) {
    return t < e ? -1 : t > e ? 1 : 0;
}

/** Helper to compare nullable (or undefined-able) objects using isEqual(). */
/** Helper to compare arrays using isEqual(). */
function v(t, e) {
    if (t.length !== e.length) return !1;
    for (let s = 0; s < t.length; s++) if (!t[s].isEqual(e[s])) return !1;
    return !0;
}

/**
 * Returns the immediate lexicographically-following string. This is useful to
 * construct an inclusive range for indexeddb iterators.
 */ function S(t) {
    // Return the input string, with an additional NUL byte appended.
    return t + "\0";
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class D {
    /**
     * Constructs a DatabaseInfo using the provided host, databaseId and
     * persistenceKey.
     *
     * @param databaseId The database to use.
     * @param persistenceKey A unique identifier for this Firestore's local
     * storage (used in conjunction with the databaseId).
     * @param host The Firestore backend host to connect to.
     * @param ssl Whether to use SSL when connecting.
     * @param forceLongPolling Whether to use the forceLongPolling option
     * when using WebChannel as the network transport.
     */
    constructor(t, e, s, n, i) {
        this.o = t, this.persistenceKey = e, this.host = s, this.ssl = n, this.forceLongPolling = i;
    }
}

/** The default database name for a project. */ const C = "(default)";

/** Represents the database ID a Firestore client is associated with. */ class k {
    constructor(t, e) {
        this.projectId = t, this.database = e || C;
    }
    get h() {
        return this.database === C;
    }
    isEqual(t) {
        return t instanceof k && t.projectId === this.projectId && t.database === this.database;
    }
    u(t) {
        return b(this.projectId, t.projectId) || b(this.database, t.database);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Simple wrapper around a nullable UID. Mostly exists to make code more
 * readable.
 */ class N {
    constructor(t) {
        this.uid = t;
    }
    l() {
        return null != this.uid;
    }
    /**
     * Returns a key representing this user, suitable for inclusion in a
     * dictionary.
     */    _() {
        return this.l() ? "uid:" + this.uid : "anonymous-user";
    }
    isEqual(t) {
        return t.uid === this.uid;
    }
}

/** A user with a null UID. */ N.UNAUTHENTICATED = new N(null), 
// TODO(mikelehen): Look into getting a proper uid-equivalent for
// non-FirebaseAuth providers.
N.m = new N("google-credentials-uid"), N.T = new N("first-party-uid");

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const F = {
    // Causes are copied from:
    // https://github.com/grpc/grpc/blob/bceec94ea4fc5f0085d81235d8e1c06798dc341a/include/grpc%2B%2B/impl/codegen/status_code_enum.h
    /** Not an error; returned on success. */
    OK: "ok",
    /** The operation was cancelled (typically by the caller). */
    CANCELLED: "cancelled",
    /** Unknown error or an error from a different error domain. */
    UNKNOWN: "unknown",
    /**
     * Client specified an invalid argument. Note that this differs from
     * FAILED_PRECONDITION. INVALID_ARGUMENT indicates arguments that are
     * problematic regardless of the state of the system (e.g., a malformed file
     * name).
     */
    INVALID_ARGUMENT: "invalid-argument",
    /**
     * Deadline expired before operation could complete. For operations that
     * change the state of the system, this error may be returned even if the
     * operation has completed successfully. For example, a successful response
     * from a server could have been delayed long enough for the deadline to
     * expire.
     */
    DEADLINE_EXCEEDED: "deadline-exceeded",
    /** Some requested entity (e.g., file or directory) was not found. */
    NOT_FOUND: "not-found",
    /**
     * Some entity that we attempted to create (e.g., file or directory) already
     * exists.
     */
    ALREADY_EXISTS: "already-exists",
    /**
     * The caller does not have permission to execute the specified operation.
     * PERMISSION_DENIED must not be used for rejections caused by exhausting
     * some resource (use RESOURCE_EXHAUSTED instead for those errors).
     * PERMISSION_DENIED must not be used if the caller can not be identified
     * (use UNAUTHENTICATED instead for those errors).
     */
    PERMISSION_DENIED: "permission-denied",
    /**
     * The request does not have valid authentication credentials for the
     * operation.
     */
    UNAUTHENTICATED: "unauthenticated",
    /**
     * Some resource has been exhausted, perhaps a per-user quota, or perhaps the
     * entire file system is out of space.
     */
    RESOURCE_EXHAUSTED: "resource-exhausted",
    /**
     * Operation was rejected because the system is not in a state required for
     * the operation's execution. For example, directory to be deleted may be
     * non-empty, an rmdir operation is applied to a non-directory, etc.
     *
     * A litmus test that may help a service implementor in deciding
     * between FAILED_PRECONDITION, ABORTED, and UNAVAILABLE:
     *  (a) Use UNAVAILABLE if the client can retry just the failing call.
     *  (b) Use ABORTED if the client should retry at a higher-level
     *      (e.g., restarting a read-modify-write sequence).
     *  (c) Use FAILED_PRECONDITION if the client should not retry until
     *      the system state has been explicitly fixed. E.g., if an "rmdir"
     *      fails because the directory is non-empty, FAILED_PRECONDITION
     *      should be returned since the client should not retry unless
     *      they have first fixed up the directory by deleting files from it.
     *  (d) Use FAILED_PRECONDITION if the client performs conditional
     *      REST Get/Update/Delete on a resource and the resource on the
     *      server does not match the condition. E.g., conflicting
     *      read-modify-write on the same resource.
     */
    FAILED_PRECONDITION: "failed-precondition",
    /**
     * The operation was aborted, typically due to a concurrency issue like
     * sequencer check failures, transaction aborts, etc.
     *
     * See litmus test above for deciding between FAILED_PRECONDITION, ABORTED,
     * and UNAVAILABLE.
     */
    ABORTED: "aborted",
    /**
     * Operation was attempted past the valid range. E.g., seeking or reading
     * past end of file.
     *
     * Unlike INVALID_ARGUMENT, this error indicates a problem that may be fixed
     * if the system state changes. For example, a 32-bit file system will
     * generate INVALID_ARGUMENT if asked to read at an offset that is not in the
     * range [0,2^32-1], but it will generate OUT_OF_RANGE if asked to read from
     * an offset past the current file size.
     *
     * There is a fair bit of overlap between FAILED_PRECONDITION and
     * OUT_OF_RANGE. We recommend using OUT_OF_RANGE (the more specific error)
     * when it applies so that callers who are iterating through a space can
     * easily look for an OUT_OF_RANGE error to detect when they are done.
     */
    OUT_OF_RANGE: "out-of-range",
    /** Operation is not implemented or not supported/enabled in this service. */
    UNIMPLEMENTED: "unimplemented",
    /**
     * Internal errors. Means some invariants expected by underlying System has
     * been broken. If you see one of these errors, Something is very broken.
     */
    INTERNAL: "internal",
    /**
     * The service is currently unavailable. This is a most likely a transient
     * condition and may be corrected by retrying with a backoff.
     *
     * See litmus test above for deciding between FAILED_PRECONDITION, ABORTED,
     * and UNAVAILABLE.
     */
    UNAVAILABLE: "unavailable",
    /** Unrecoverable data loss or corruption. */
    DATA_LOSS: "data-loss"
};

/**
 * An error class used for Firestore-generated errors. Ideally we should be
 * using FirebaseError, but integrating with it is overly arduous at the moment,
 * so we define our own compatible error class (with a `name` of 'FirebaseError'
 * and compatible `code` and `message` fields.)
 */ class $ extends Error {
    constructor(t, e) {
        super(e), this.code = t, this.message = e, this.name = "FirebaseError", 
        // HACK: We write a toString property directly because Error is not a real
        // class and so inheritance does not work correctly. We could alternatively
        // do the same "back-door inheritance" trick that FirebaseError does.
        this.toString = () => `${this.name}: [code=${this.code}]: ${this.message}`;
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class x {
    constructor(t, e) {
        this.user = e, this.type = "OAuth", this.I = {}, 
        // Set the headers using Object Literal notation to avoid minification
        this.I.Authorization = `Bearer ${t}`;
    }
}

/** A CredentialsProvider that always yields an empty token. */ class M {
    constructor() {
        /**
         * Stores the listener registered with setChangeListener()
         * This isn't actually necessary since the UID never changes, but we use this
         * to verify the listen contract is adhered to in tests.
         */
        this.R = null;
    }
    getToken() {
        return Promise.resolve(null);
    }
    A() {}
    P(t) {
        g(!this.R, "Can only call setChangeListener() once."), this.R = t, 
        // Fire with initial user.
        t(N.UNAUTHENTICATED);
    }
    p() {
        g(null !== this.R, "removeChangeListener() when no listener registered"), this.R = null;
    }
}

class L {
    constructor(t) {
        /**
         * The auth token listener registered with FirebaseApp, retained here so we
         * can unregister it.
         */
        this.V = null, 
        /** Tracks the current User. */
        this.currentUser = N.UNAUTHENTICATED, this.g = !1, 
        /**
         * Counter used to detect if the token changed while a getToken request was
         * outstanding.
         */
        this.v = 0, 
        /** The listener registered with setChangeListener(). */
        this.R = null, this.forceRefresh = !1, this.V = () => {
            this.v++, this.currentUser = this.S(), this.g = !0, this.R && this.R(this.currentUser);
        }, this.v = 0, this.auth = t.getImmediate({
            optional: !0
        }), this.auth ? this.auth.addAuthTokenListener(this.V) : (
        // if auth is not available, invoke tokenListener once with null token
        this.V(null), t.get().then(t => {
            this.auth = t, this.V && 
            // tokenListener can be removed by removeChangeListener()
            this.auth.addAuthTokenListener(this.V);
        }, () => {}));
    }
    getToken() {
        g(null != this.V, "getToken cannot be called after listener removed.");
        // Take note of the current value of the tokenCounter so that this method
        // can fail (with an ABORTED error) if there is a token change while the
        // request is outstanding.
        const t = this.v, e = this.forceRefresh;
        return this.forceRefresh = !1, this.auth ? this.auth.getToken(e).then(e => {
            // Cancel the request since the token changed while the request was
            // outstanding so the response is potentially for a previous user (which
            // user, we can't be sure).
            if (this.v !== t) throw new $(F.ABORTED, "getToken aborted due to token change.");
            return e ? (g("string" == typeof e.accessToken, "Invalid tokenData returned from getToken():" + e), 
            new x(e.accessToken, this.currentUser)) : null;
        }) : Promise.resolve(null);
    }
    A() {
        this.forceRefresh = !0;
    }
    P(t) {
        g(!this.R, "Can only call setChangeListener() once."), this.R = t, 
        // Fire the initial event
        this.g && t(this.currentUser);
    }
    p() {
        g(null != this.V, "removeChangeListener() called twice"), g(null !== this.R, "removeChangeListener() called when no listener registered"), 
        this.auth && this.auth.removeAuthTokenListener(this.V), this.V = null, this.R = null;
    }
    // Auth.getUid() can return null even with a user logged in. It is because
    // getUid() is synchronous, but the auth code populating Uid is asynchronous.
    // This method should only be called in the AuthTokenListener callback
    // to guarantee to get the actual user.
    S() {
        const t = this.auth && this.auth.getUid();
        return g(null === t || "string" == typeof t, "Received invalid UID: " + t), new N(t);
    }
}

/*
 * FirstPartyToken provides a fresh token each time its value
 * is requested, because if the token is too old, requests will be rejected.
 * Technically this may no longer be necessary since the SDK should gracefully
 * recover from unauthenticated errors (see b/33147818 for context), but it's
 * safer to keep the implementation as-is.
 */ class B {
    constructor(t, e) {
        this.D = t, this.C = e, this.type = "FirstParty", this.user = N.T;
    }
    get I() {
        const t = {
            "X-Goog-AuthUser": this.C
        }, e = this.D.auth.k([]);
        return e && (t.Authorization = e), t;
    }
}

/*
 * Provides user credentials required for the Firestore JavaScript SDK
 * to authenticate the user, using technique that is only available
 * to applications hosted by Google.
 */ class q {
    constructor(t, e) {
        this.D = t, this.C = e;
    }
    getToken() {
        return Promise.resolve(new B(this.D, this.C));
    }
    P(t) {
        // Fire with initial uid.
        t(N.T);
    }
    p() {}
    A() {}
}

/**
 * Builds a CredentialsProvider depending on the type of
 * the credentials passed in.
 */
/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
function O(t, e) {
    return Object.prototype.hasOwnProperty.call(t, e);
}

/** Returns the given value if it's defined or the defaultValue otherwise. */ function U(t, e) {
    return void 0 !== t ? t : e;
}

function Q(t, e) {
    for (const s in t) if (Object.prototype.hasOwnProperty.call(t, s)) {
        const n = Number(s);
        isNaN(n) || e(n, t[s]);
    }
}

function W(t, e) {
    for (const s in t) Object.prototype.hasOwnProperty.call(t, s) && e(s, t[s]);
}

function j(t) {
    g(null != t && "object" == typeof t, "isEmpty() expects object parameter.");
    for (const e in t) if (Object.prototype.hasOwnProperty.call(t, e)) return !1;
    return !0;
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Validates that no arguments were passed in the invocation of functionName.
 *
 * Forward the magic "arguments" variable as second parameter on which the
 * parameter validation is performed:
 * validateNoArgs('myFunction', arguments);
 */
function z(t, e) {
    if (0 !== e.length) throw new $(F.INVALID_ARGUMENT, `Function ${t}() does not support arguments, ` + "but was called with " + ct(e.length, "argument") + ".");
}

/**
 * Validates the invocation of functionName has the exact number of arguments.
 *
 * Forward the magic "arguments" variable as second parameter on which the
 * parameter validation is performed:
 * validateExactNumberOfArgs('myFunction', arguments, 2);
 */ function K(t, e, s) {
    if (e.length !== s) throw new $(F.INVALID_ARGUMENT, `Function ${t}() requires ` + ct(s, "argument") + ", but was called with " + ct(e.length, "argument") + ".");
}

/**
 * Validates the invocation of functionName has at least the provided number of
 * arguments (but can have many more).
 *
 * Forward the magic "arguments" variable as second parameter on which the
 * parameter validation is performed:
 * validateAtLeastNumberOfArgs('myFunction', arguments, 2);
 */ function G(t, e, s) {
    if (e.length < s) throw new $(F.INVALID_ARGUMENT, `Function ${t}() requires at least ` + ct(s, "argument") + ", but was called with " + ct(e.length, "argument") + ".");
}

/**
 * Validates the invocation of functionName has number of arguments between
 * the values provided.
 *
 * Forward the magic "arguments" variable as second parameter on which the
 * parameter validation is performed:
 * validateBetweenNumberOfArgs('myFunction', arguments, 2, 3);
 */ function H(t, e, s, n) {
    if (e.length < s || e.length > n) throw new $(F.INVALID_ARGUMENT, `Function ${t}() requires between ${s} and ` + `${n} arguments, but was called with ` + ct(e.length, "argument") + ".");
}

/**
 * Validates the provided argument is an array and has as least the expected
 * number of elements.
 */
/**
 * Validates the provided positional argument has the native JavaScript type
 * using typeof checks.
 */
function J(t, e, s, n) {
    st(t, e, `${ut(s)} argument`, n);
}

/**
 * Validates the provided argument has the native JavaScript type using
 * typeof checks or is undefined.
 */ function Y(t, e, s, n) {
    void 0 !== n && J(t, e, s, n);
}

/**
 * Validates the provided named option has the native JavaScript type using
 * typeof checks.
 */ function X(t, e, s, n) {
    st(t, e, `${s} option`, n);
}

/**
 * Validates the provided named option has the native JavaScript type using
 * typeof checks or is undefined.
 */ function Z(t, e, s, n) {
    void 0 !== n && X(t, e, s, n);
}

function tt(t, e, s, n, i) {
    void 0 !== n && function(t, e, s, n, i) {
        if (!(n instanceof Array)) throw new $(F.INVALID_ARGUMENT, `Function ${t}() requires its ${e} ` + `option to be an array, but it was: ${it(n)}`);
        for (let r = 0; r < n.length; ++r) if (!i(n[r])) throw new $(F.INVALID_ARGUMENT, `Function ${t}() requires all ${e} ` + `elements to be ${s}, but the value at index ${r} ` + `was: ${it(n[r])}`);
    }(t, e, s, n, i);
}

/**
 * Validates that the provided named option equals one of the expected values.
 */
/**
 * Validates that the provided named option equals one of the expected values or
 * is undefined.
 */
function et(t, e, s, n, i) {
    void 0 !== n && function(t, e, s, n, i) {
        const r = [];
        for (const t of i) {
            if (t === n) return;
            r.push(it(t));
        }
        const o = it(n);
        throw new $(F.INVALID_ARGUMENT, `Invalid value ${o} provided to function ${t}() for option ` + `"${s}". Acceptable values: ${r.join(", ")}`);
    }(t, 0, s, n, i);
}

/**
 * Validates that the provided argument is a valid enum.
 *
 * @param functionName Function making the validation call.
 * @param enums Array containing all possible values for the enum.
 * @param position Position of the argument in `functionName`.
 * @param argument Arugment to validate.
 */
/** Helper to validate the type of a provided input. */
function st(t, e, s, n) {
    let i = !1;
    if (!(i = "object" === e ? nt(n) : "non-empty string" === e ? "string" == typeof n && "" !== n : typeof n === e)) {
        const i = it(n);
        throw new $(F.INVALID_ARGUMENT, `Function ${t}() requires its ${s} ` + `to be of type ${e}, but it was: ${i}`);
    }
}

/**
 * Returns true if it's a non-null object without a custom prototype
 * (i.e. excludes Array, Date, etc.).
 */ function nt(t) {
    return "object" == typeof t && null !== t && (Object.getPrototypeOf(t) === Object.prototype || null === Object.getPrototypeOf(t));
}

/** Returns a string describing the type / value of the provided input. */ function it(t) {
    if (void 0 === t) return "undefined";
    if (null === t) return "null";
    if ("string" == typeof t) return t.length > 20 && (t = `${t.substring(0, 20)}...`), 
    JSON.stringify(t);
    if ("number" == typeof t || "boolean" == typeof t) return "" + t;
    if ("object" == typeof t) {
        if (t instanceof Array) return "an array";
        {
            const e = 
            /** Hacky method to try to get the constructor name for an object. */
            function(t) {
                if (t.constructor) {
                    const e = /function\s+([^\s(]+)\s*\(/.exec(t.constructor.toString());
                    if (e && e.length > 1) return e[1];
                }
                return null;
            }
            /** Validates the provided argument is defined. */ (t);
            return e ? `a custom ${e} object` : "an object";
        }
    }
    return "function" == typeof t ? "a function" : V("Unknown wrong type: " + typeof t);
}

function rt(t, e, s) {
    if (void 0 === s) throw new $(F.INVALID_ARGUMENT, `Function ${t}() requires a valid ${ut(e)} ` + "argument, but it was undefined.");
}

/**
 * Validates the provided positional argument is an object, and its keys and
 * values match the expected keys and types provided in optionTypes.
 */ function ot(t, e, s) {
    W(e, (e, n) => {
        if (s.indexOf(e) < 0) throw new $(F.INVALID_ARGUMENT, `Unknown option '${e}' passed to function ${t}(). ` + "Available options: " + s.join(", "));
    });
}

/**
 * Helper method to throw an error that the provided argument did not pass
 * an instanceof check.
 */ function ht(t, e, s, n) {
    const i = it(n);
    return new $(F.INVALID_ARGUMENT, `Function ${t}() requires its ${ut(s)} ` + `argument to be a ${e}, but it was: ${i}`);
}

function at(t, e, s) {
    if (s <= 0) throw new $(F.INVALID_ARGUMENT, `Function "${t}()" requires its ${ut(e)} argument to be a positive number, but it was: ${s}.`);
}

/** Converts a number to its english word representation */ function ut(t) {
    switch (t) {
      case 1:
        return "first";

      case 2:
        return "second";

      case 3:
        return "third";

      default:
        return t + "th";
    }
}

/**
 * Formats the given word as plural conditionally given the preceding number.
 */ function ct(t, e) {
    return `${t} ${e}` + (1 === t ? "" : "s");
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Immutable class representing a geo point as latitude-longitude pair.
 * This class is directly exposed in the public API, including its constructor.
 */ class lt {
    constructor(t, e) {
        if (K("GeoPoint", arguments, 2), J("GeoPoint", "number", 1, t), J("GeoPoint", "number", 2, e), 
        !isFinite(t) || t < -90 || t > 90) throw new $(F.INVALID_ARGUMENT, "Latitude must be a number between -90 and 90, but was: " + t);
        if (!isFinite(e) || e < -180 || e > 180) throw new $(F.INVALID_ARGUMENT, "Longitude must be a number between -180 and 180, but was: " + e);
        this.N = t, this.F = e;
    }
    /**
     * Returns the latitude of this geo point, a number between -90 and 90.
     */    get latitude() {
        return this.N;
    }
    /**
     * Returns the longitude of this geo point, a number between -180 and 180.
     */    get longitude() {
        return this.F;
    }
    isEqual(t) {
        return this.N === t.N && this.F === t.F;
    }
    /**
     * Actually private to JS consumers of our API, so this function is prefixed
     * with an underscore.
     */    $(t) {
        return b(this.N, t.N) || b(this.F, t.F);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class _t {
    constructor(t, e) {
        if (this.seconds = t, this.nanoseconds = e, e < 0) throw new $(F.INVALID_ARGUMENT, "Timestamp nanoseconds out of range: " + e);
        if (e >= 1e9) throw new $(F.INVALID_ARGUMENT, "Timestamp nanoseconds out of range: " + e);
        // Midnight at the beginning of 1/1/1 is the earliest Firestore supports.
                if (t < -62135596800) throw new $(F.INVALID_ARGUMENT, "Timestamp seconds out of range: " + t);
        // This will break in the year 10,000.
                if (t >= 253402300800) throw new $(F.INVALID_ARGUMENT, "Timestamp seconds out of range: " + t);
    }
    static now() {
        return _t.fromMillis(Date.now());
    }
    static fromDate(t) {
        return _t.fromMillis(t.getTime());
    }
    static fromMillis(t) {
        const e = Math.floor(t / 1e3);
        return new _t(e, 1e6 * (t - 1e3 * e));
    }
    toDate() {
        return new Date(this.toMillis());
    }
    toMillis() {
        return 1e3 * this.seconds + this.nanoseconds / 1e6;
    }
    $(t) {
        return this.seconds === t.seconds ? b(this.nanoseconds, t.nanoseconds) : b(this.seconds, t.seconds);
    }
    isEqual(t) {
        return t.seconds === this.seconds && t.nanoseconds === this.nanoseconds;
    }
    toString() {
        return "Timestamp(seconds=" + this.seconds + ", nanoseconds=" + this.nanoseconds + ")";
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A version of a document in Firestore. This corresponds to the version
 * timestamp, such as update_time or read_time.
 */ class dt {
    constructor(t) {
        this.timestamp = t;
    }
    // TODO(b/34176344): Once we no longer need to use the old alpha protos,
    // delete this constructor and use a timestamp-backed version everywhere.
    static M(t) {
        const e = Math.floor(t / 1e6);
        return new dt(new _t(e, t % 1e6 * 1e3));
    }
    static L(t) {
        return new dt(t);
    }
    static B() {
        return dt.MIN;
    }
    u(t) {
        return this.timestamp.$(t.timestamp);
    }
    isEqual(t) {
        return this.timestamp.isEqual(t.timestamp);
    }
    /** Returns a number representation of the version for use in spec tests. */    q() {
        // Convert to microseconds.
        return 1e6 * this.timestamp.seconds + this.timestamp.nanoseconds / 1e3;
    }
    toString() {
        return "SnapshotVersion(" + this.timestamp.toString() + ")";
    }
    O() {
        return this.timestamp;
    }
}

dt.MIN = new dt(new _t(0, 0));

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const ft = "__name__";

/**
 * Path represents an ordered sequence of string segments.
 */ class mt {
    constructor(t, e, s) {
        void 0 === e ? e = 0 : e > t.length && V("offset " + e + " out of range " + t.length), 
        void 0 === s ? s = t.length - e : s > t.length - e && V("length " + s + " out of range " + (t.length - e)), 
        this.segments = t, this.offset = e, this.len = s;
    }
    get length() {
        return this.len;
    }
    isEqual(t) {
        return 0 === mt.U(this, t);
    }
    child(t) {
        const e = this.segments.slice(this.offset, this.limit());
        return t instanceof mt ? t.forEach(t => {
            e.push(t);
        }) : e.push(t), this.W(e);
    }
    /** The index of one past the last segment of the path. */    limit() {
        return this.offset + this.length;
    }
    j(t) {
        return t = void 0 === t ? 1 : t, g(this.length >= t, "Can't call popFirst() with less segments"), 
        this.W(this.segments, this.offset + t, this.length - t);
    }
    K() {
        return g(!this.G(), "Can't call popLast() on empty path"), this.W(this.segments, this.offset, this.length - 1);
    }
    H() {
        return g(!this.G(), "Can't call firstSegment() on empty path"), this.segments[this.offset];
    }
    J() {
        return this.get(this.length - 1);
    }
    get(t) {
        return g(t < this.length, "Index out of range"), this.segments[this.offset + t];
    }
    G() {
        return 0 === this.length;
    }
    Y(t) {
        if (t.length < this.length) return !1;
        for (let e = 0; e < this.length; e++) if (this.get(e) !== t.get(e)) return !1;
        return !0;
    }
    X(t) {
        if (this.length + 1 !== t.length) return !1;
        for (let e = 0; e < this.length; e++) if (this.get(e) !== t.get(e)) return !1;
        return !0;
    }
    forEach(t) {
        for (let e = this.offset, s = this.limit(); e < s; e++) t(this.segments[e]);
    }
    Z() {
        return this.segments.slice(this.offset, this.limit());
    }
    static U(t, e) {
        const s = Math.min(t.length, e.length);
        for (let n = 0; n < s; n++) {
            const s = t.get(n), i = e.get(n);
            if (s < i) return -1;
            if (s > i) return 1;
        }
        return t.length < e.length ? -1 : t.length > e.length ? 1 : 0;
    }
}

/**
 * A slash-separated path for navigating resources (documents and collections)
 * within Firestore.
 */ class Tt extends mt {
    W(t, e, s) {
        return new Tt(t, e, s);
    }
    tt() {
        // NOTE: The client is ignorant of any path segments containing escape
        // sequences (e.g. __id123__) and just passes them through raw (they exist
        // for legacy reasons and should not be used frequently).
        return this.Z().join("/");
    }
    toString() {
        return this.tt();
    }
    /**
     * Creates a resource path from the given slash-delimited string.
     */    static et(t) {
        // NOTE: The client is ignorant of any path segments containing escape
        // sequences (e.g. __id123__) and just passes them through raw (they exist
        // for legacy reasons and should not be used frequently).
        if (t.indexOf("//") >= 0) throw new $(F.INVALID_ARGUMENT, `Invalid path (${t}). Paths must not contain // in them.`);
        // We may still have an empty segment at the beginning or end if they had a
        // leading or trailing slash (which we allow).
                const e = t.split("/").filter(t => t.length > 0);
        return new Tt(e);
    }
}

Tt.st = new Tt([]);

const wt = /^[_a-zA-Z][_a-zA-Z0-9]*$/;

/** A dot-separated path for navigating sub-objects within a document. */ class Et extends mt {
    W(t, e, s) {
        return new Et(t, e, s);
    }
    /**
     * Returns true if the string could be used as a segment in a field path
     * without escaping.
     */    static nt(t) {
        return wt.test(t);
    }
    tt() {
        return this.Z().map(t => (t = t.replace("\\", "\\\\").replace("`", "\\`"), Et.nt(t) || (t = "`" + t + "`"), 
        t)).join(".");
    }
    toString() {
        return this.tt();
    }
    /**
     * Returns true if this field references the key of a document.
     */    it() {
        return 1 === this.length && this.get(0) === ft;
    }
    /**
     * The field designating the key of a document.
     */    static rt() {
        return new Et([ ft ]);
    }
    /**
     * Parses a field string from the given server-formatted string.
     *
     * - Splitting the empty string is not allowed (for now at least).
     * - Empty segments within the string (e.g. if there are two consecutive
     *   separators) are not allowed.
     *
     * TODO(b/37244157): we should make this more strict. Right now, it allows
     * non-identifier path components, even if they aren't escaped.
     */    static ot(t) {
        const e = [];
        let s = "", n = 0;
        const i = () => {
            if (0 === s.length) throw new $(F.INVALID_ARGUMENT, `Invalid field path (${t}). Paths must not be empty, begin ` + "with '.', end with '.', or contain '..'");
            e.push(s), s = "";
        };
        let r = !1;
        for (;n < t.length; ) {
            const e = t[n];
            if ("\\" === e) {
                if (n + 1 === t.length) throw new $(F.INVALID_ARGUMENT, "Path has trailing escape character: " + t);
                const e = t[n + 1];
                if ("\\" !== e && "." !== e && "`" !== e) throw new $(F.INVALID_ARGUMENT, "Path has invalid escape sequence: " + t);
                s += e, n += 2;
            } else "`" === e ? (r = !r, n++) : "." !== e || r ? (s += e, n++) : (i(), n++);
        }
        if (i(), r) throw new $(F.INVALID_ARGUMENT, "Unterminated ` in path: " + t);
        return new Et(e);
    }
}

Et.st = new Et([]);

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class It {
    constructor(t) {
        this.path = t, g(It.ht(t), "Invalid DocumentKey with an odd number of segments: " + t.Z().join("/"));
    }
    /** Returns true if the document is in the specified collectionId. */    at(t) {
        return this.path.length >= 2 && this.path.get(this.path.length - 2) === t;
    }
    isEqual(t) {
        return null !== t && 0 === Tt.U(this.path, t.path);
    }
    toString() {
        return this.path.toString();
    }
    static U(t, e) {
        return Tt.U(t.path, e.path);
    }
    static ht(t) {
        return t.length % 2 == 0;
    }
    /**
     * Creates and returns a new document key with the given segments.
     *
     * @param path The segments of the path to the document
     * @return A new instance of DocumentKey
     */    static ut(t) {
        return new It(new Tt(t.slice()));
    }
    /**
     * Creates and returns a new document key using '/' to split the string into
     * segments.
     *
     * @param path The slash-separated path string to the document
     * @return A new instance of DocumentKey
     */    static ct(t) {
        return new It(Tt.et(t));
    }
}

It.EMPTY = new It(new Tt([]));

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// An immutable sorted map implementation, based on a Left-leaning Red-Black
// tree.
class Rt {
    constructor(t, e) {
        this.U = t, this.root = e || Pt.EMPTY;
    }
    // Returns a copy of the map, with the specified key/value added or replaced.
    lt(t, e) {
        return new Rt(this.U, this.root.lt(t, e, this.U).copy(null, null, Pt._t, null, null));
    }
    // Returns a copy of the map, with the specified key removed.
    remove(t) {
        return new Rt(this.U, this.root.remove(t, this.U).copy(null, null, Pt._t, null, null));
    }
    // Returns the value of the node with the given key, or null.
    get(t) {
        let e = this.root;
        for (;!e.G(); ) {
            const s = this.U(t, e.key);
            if (0 === s) return e.value;
            s < 0 ? e = e.left : s > 0 && (e = e.right);
        }
        return null;
    }
    // Returns the index of the element in this sorted map, or -1 if it doesn't
    // exist.
    indexOf(t) {
        // Number of nodes that were pruned when descending right
        let e = 0, s = this.root;
        for (;!s.G(); ) {
            const n = this.U(t, s.key);
            if (0 === n) return e + s.left.size;
            n < 0 ? s = s.left : (
            // Count all nodes left of the node plus the node itself
            e += s.left.size + 1, s = s.right);
        }
        // Node not found
                return -1;
    }
    G() {
        return this.root.G();
    }
    // Returns the total number of nodes in the map.
    get size() {
        return this.root.size;
    }
    // Returns the minimum key in the map.
    dt() {
        return this.root.dt();
    }
    // Returns the maximum key in the map.
    ft() {
        return this.root.ft();
    }
    // Traverses the map in key order and calls the specified action function
    // for each key/value pair. If action returns true, traversal is aborted.
    // Returns the first truthy value returned by action, or the last falsey
    // value returned by action.
    Tt(t) {
        return this.root.Tt(t);
    }
    forEach(t) {
        this.Tt((e, s) => (t(e, s), !1));
    }
    toString() {
        const t = [];
        return this.Tt((e, s) => (t.push(`${e}:${s}`), !1)), `{${t.join(", ")}}`;
    }
    // Traverses the map in reverse key order and calls the specified action
    // function for each key/value pair. If action returns true, traversal is
    // aborted.
    // Returns the first truthy value returned by action, or the last falsey
    // value returned by action.
    wt(t) {
        return this.root.wt(t);
    }
    // Returns an iterator over the SortedMap.
    Et() {
        return new At(this.root, null, this.U, !1);
    }
    It(t) {
        return new At(this.root, t, this.U, !1);
    }
    Rt() {
        return new At(this.root, null, this.U, !0);
    }
    At(t) {
        return new At(this.root, t, this.U, !0);
    }
}

 // end SortedMap
// An iterator over an LLRBNode.
class At {
    constructor(t, e, s, n) {
        this.Pt = n, this.pt = [];
        let i = 1;
        for (;!t.G(); ) if (i = e ? s(t.key, e) : 1, 
        // flip the comparison if we're going in reverse
        n && (i *= -1), i < 0) 
        // This node is less than our start key. ignore it
        t = this.Pt ? t.left : t.right; else {
            if (0 === i) {
                // This node is exactly equal to our start key. Push it on the stack,
                // but stop iterating;
                this.pt.push(t);
                break;
            }
            // This node is greater than our start key, add it to the stack and move
            // to the next one
            this.pt.push(t), t = this.Pt ? t.right : t.left;
        }
    }
    Vt() {
        g(this.pt.length > 0, "getNext() called on iterator when hasNext() is false.");
        let t = this.pt.pop();
        const e = {
            key: t.key,
            value: t.value
        };
        if (this.Pt) for (t = t.left; !t.G(); ) this.pt.push(t), t = t.right; else for (t = t.right; !t.G(); ) this.pt.push(t), 
        t = t.left;
        return e;
    }
    gt() {
        return this.pt.length > 0;
    }
    yt() {
        if (0 === this.pt.length) return null;
        const t = this.pt[this.pt.length - 1];
        return {
            key: t.key,
            value: t.value
        };
    }
}

 // end SortedMapIterator
// Represents a node in a Left-leaning Red-Black tree.
class Pt {
    constructor(t, e, s, n, i) {
        this.key = t, this.value = e, this.color = null != s ? s : Pt.RED, this.left = null != n ? n : Pt.EMPTY, 
        this.right = null != i ? i : Pt.EMPTY, this.size = this.left.size + 1 + this.right.size;
    }
    // Returns a copy of the current node, optionally replacing pieces of it.
    copy(t, e, s, n, i) {
        return new Pt(null != t ? t : this.key, null != e ? e : this.value, null != s ? s : this.color, null != n ? n : this.left, null != i ? i : this.right);
    }
    G() {
        return !1;
    }
    // Traverses the tree in key order and calls the specified action function
    // for each node. If action returns true, traversal is aborted.
    // Returns the first truthy value returned by action, or the last falsey
    // value returned by action.
    Tt(t) {
        return this.left.Tt(t) || t(this.key, this.value) || this.right.Tt(t);
    }
    // Traverses the tree in reverse key order and calls the specified action
    // function for each node. If action returns true, traversal is aborted.
    // Returns the first truthy value returned by action, or the last falsey
    // value returned by action.
    wt(t) {
        return this.right.wt(t) || t(this.key, this.value) || this.left.wt(t);
    }
    // Returns the minimum node in the tree.
    min() {
        return this.left.G() ? this : this.left.min();
    }
    // Returns the maximum key in the tree.
    dt() {
        return this.min().key;
    }
    // Returns the maximum key in the tree.
    ft() {
        return this.right.G() ? this.key : this.right.ft();
    }
    // Returns new tree, with the key/value added.
    lt(t, e, s) {
        let n = this;
        const i = s(t, n.key);
        return (n = i < 0 ? n.copy(null, null, null, n.left.lt(t, e, s), null) : 0 === i ? n.copy(null, e, null, null, null) : n.copy(null, null, null, null, n.right.lt(t, e, s))).bt();
    }
    vt() {
        if (this.left.G()) return Pt.EMPTY;
        let t = this;
        return t.left.St() || t.left.left.St() || (t = t.Dt()), (t = t.copy(null, null, null, t.left.vt(), null)).bt();
    }
    // Returns new tree, with the specified item removed.
    remove(t, e) {
        let s, n = this;
        if (e(t, n.key) < 0) n.left.G() || n.left.St() || n.left.left.St() || (n = n.Dt()), 
        n = n.copy(null, null, null, n.left.remove(t, e), null); else {
            if (n.left.St() && (n = n.Ct()), n.right.G() || n.right.St() || n.right.left.St() || (n = n.kt()), 
            0 === e(t, n.key)) {
                if (n.right.G()) return Pt.EMPTY;
                s = n.right.min(), n = n.copy(s.key, s.value, null, null, n.right.vt());
            }
            n = n.copy(null, null, null, null, n.right.remove(t, e));
        }
        return n.bt();
    }
    St() {
        return this.color;
    }
    // Returns new tree after performing any needed rotations.
    bt() {
        let t = this;
        return t.right.St() && !t.left.St() && (t = t.Nt()), t.left.St() && t.left.left.St() && (t = t.Ct()), 
        t.left.St() && t.right.St() && (t = t.Ft()), t;
    }
    Dt() {
        let t = this.Ft();
        return t.right.left.St() && (t = (t = (t = t.copy(null, null, null, null, t.right.Ct())).Nt()).Ft()), 
        t;
    }
    kt() {
        let t = this.Ft();
        return t.left.left.St() && (t = (t = t.Ct()).Ft()), t;
    }
    Nt() {
        const t = this.copy(null, null, Pt.RED, null, this.right.left);
        return this.right.copy(null, null, this.color, t, null);
    }
    Ct() {
        const t = this.copy(null, null, Pt.RED, this.left.right, null);
        return this.left.copy(null, null, this.color, null, t);
    }
    Ft() {
        const t = this.left.copy(null, null, !this.left.color, null, null), e = this.right.copy(null, null, !this.right.color, null, null);
        return this.copy(null, null, !this.color, t, e);
    }
    // For testing.
    $t() {
        const t = this.xt();
        return Math.pow(2, t) <= this.size + 1;
    }
    // In a balanced RB tree, the black-depth (number of black nodes) from root to
    // leaves is equal on both sides.  This function verifies that or asserts.
    xt() {
        if (this.St() && this.left.St()) throw V("Red node has red child(" + this.key + "," + this.value + ")");
        if (this.right.St()) throw V("Right child of (" + this.key + "," + this.value + ") is red");
        const t = this.left.xt();
        if (t !== this.right.xt()) throw V("Black depths differ");
        return t + (this.St() ? 0 : 1);
    }
}

 // end LLRBNode
// Empty node is shared between all LLRB trees.
// eslint-disable-next-line @typescript-eslint/no-explicit-any
Pt.EMPTY = null, Pt.RED = !0, Pt._t = !1;

// end LLRBEmptyNode
Pt.EMPTY = new 
// Represents an empty node (a leaf node in the Red-Black Tree).
class {
    constructor() {
        this.size = 0;
    }
    get key() {
        throw V("LLRBEmptyNode has no key.");
    }
    get value() {
        throw V("LLRBEmptyNode has no value.");
    }
    get color() {
        throw V("LLRBEmptyNode has no color.");
    }
    get left() {
        throw V("LLRBEmptyNode has no left child.");
    }
    get right() {
        throw V("LLRBEmptyNode has no right child.");
    }
    // Returns a copy of the current node.
    copy(t, e, s, n, i) {
        return this;
    }
    // Returns a copy of the tree, with the specified key/value added.
    lt(t, e, s) {
        return new Pt(t, e);
    }
    // Returns a copy of the tree, with the specified key removed.
    remove(t, e) {
        return this;
    }
    G() {
        return !0;
    }
    Tt(t) {
        return !1;
    }
    wt(t) {
        return !1;
    }
    dt() {
        return null;
    }
    ft() {
        return null;
    }
    St() {
        return !1;
    }
    // For testing.
    $t() {
        return !0;
    }
    xt() {
        return 0;
    }
};

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * SortedSet is an immutable (copy-on-write) collection that holds elements
 * in order specified by the provided comparator.
 *
 * NOTE: if provided comparator returns 0 for two elements, we consider them to
 * be equal!
 */
class pt {
    constructor(t) {
        this.U = t, this.data = new Rt(this.U);
    }
    /**
     * Creates a SortedSet from the keys of the map.
     * This is currently implemented as an O(n) copy.
     */    static Mt(t) {
        let e = new pt(t.U);
        return t.forEach(t => {
            e = e.add(t);
        }), e;
    }
    has(t) {
        return null !== this.data.get(t);
    }
    first() {
        return this.data.dt();
    }
    last() {
        return this.data.ft();
    }
    get size() {
        return this.data.size;
    }
    indexOf(t) {
        return this.data.indexOf(t);
    }
    /** Iterates elements in order defined by "comparator" */    forEach(t) {
        this.data.Tt((e, s) => (t(e), !1));
    }
    /** Iterates over `elem`s such that: range[0] <= elem < range[1]. */    Lt(t, e) {
        const s = this.data.It(t[0]);
        for (;s.gt(); ) {
            const n = s.Vt();
            if (this.U(n.key, t[1]) >= 0) return;
            e(n.key);
        }
    }
    /**
     * Iterates over `elem`s such that: start <= elem until false is returned.
     */    Bt(t, e) {
        let s;
        for (s = void 0 !== e ? this.data.It(e) : this.data.Et(); s.gt(); ) {
            if (!t(s.Vt().key)) return;
        }
    }
    /** Finds the least element greater than or equal to `elem`. */    qt(t) {
        const e = this.data.It(t);
        return e.gt() ? e.Vt().key : null;
    }
    Et() {
        return new Vt(this.data.Et());
    }
    It(t) {
        return new Vt(this.data.It(t));
    }
    /** Inserts or updates an element */    add(t) {
        return this.copy(this.data.remove(t).lt(t, !0));
    }
    /** Deletes an element */    delete(t) {
        return this.has(t) ? this.copy(this.data.remove(t)) : this;
    }
    G() {
        return this.data.G();
    }
    Ot(t) {
        let e = this;
        // Make sure `result` always refers to the larger one of the two sets.
                return e.size < t.size && (e = t, t = this), t.forEach(t => {
            e = e.add(t);
        }), e;
    }
    isEqual(t) {
        if (!(t instanceof pt)) return !1;
        if (this.size !== t.size) return !1;
        const e = this.data.Et(), s = t.data.Et();
        for (;e.gt(); ) {
            const t = e.Vt().key, n = s.Vt().key;
            if (0 !== this.U(t, n)) return !1;
        }
        return !0;
    }
    Z() {
        const t = [];
        return this.forEach(e => {
            t.push(e);
        }), t;
    }
    toString() {
        const t = [];
        return this.forEach(e => t.push(e)), "SortedSet(" + t.toString() + ")";
    }
    copy(t) {
        const e = new pt(this.U);
        return e.data = t, e;
    }
}

class Vt {
    constructor(t) {
        this.Ut = t;
    }
    Vt() {
        return this.Ut.Vt().key;
    }
    gt() {
        return this.Ut.gt();
    }
}

/**
 * @license
 * Copyright 2018 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** Transforms a value into a server-generated timestamp. */ class gt {
    constructor() {}
    Qt(t, e) {
        return new se(e, t);
    }
    Wt(t, e) {
        return e;
    }
    jt(t) {
        return null;
 // Server timestamps are idempotent and don't require a base value.
        }
    isEqual(t) {
        return t instanceof gt;
    }
}

gt.instance = new gt;

/** Transforms an array value via a union operation. */
class yt {
    constructor(t) {
        this.elements = t;
    }
    Qt(t, e) {
        return this.apply(t);
    }
    Wt(t, e) {
        // The server just sends null as the transform result for array operations,
        // so we have to calculate a result the same as we do for local
        // applications.
        return this.apply(t);
    }
    apply(t) {
        const e = St(t);
        for (const t of this.elements) e.find(e => e.isEqual(t)) || e.push(t);
        return new he(e);
    }
    jt(t) {
        return null;
 // Array transforms are idempotent and don't require a base value.
        }
    isEqual(t) {
        return t instanceof yt && v(t.elements, this.elements);
    }
}

/** Transforms an array value via a remove operation. */ class bt {
    constructor(t) {
        this.elements = t;
    }
    Qt(t, e) {
        return this.apply(t);
    }
    Wt(t, e) {
        // The server just sends null as the transform result for array operations,
        // so we have to calculate a result the same as we do for local
        // applications.
        return this.apply(t);
    }
    apply(t) {
        let e = St(t);
        for (const t of this.elements) e = e.filter(e => !e.isEqual(t));
        return new he(e);
    }
    jt(t) {
        return null;
 // Array transforms are idempotent and don't require a base value.
        }
    isEqual(t) {
        return t instanceof bt && v(t.elements, this.elements);
    }
}

/**
 * Implements the backend semantics for locally computed NUMERIC_ADD (increment)
 * transforms. Converts all field values to integers or doubles, but unlike the
 * backend does not cap integer values at 2^63. Instead, JavaScript number
 * arithmetic is used and precision loss can occur for values greater than 2^53.
 */ class vt {
    constructor(t) {
        this.zt = t;
    }
    Qt(t, e) {
        const s = this.jt(t);
        // PORTING NOTE: Since JavaScript's integer arithmetic is limited to 53 bit
        // precision and resolves overflows by reducing precision, we do not
        // manually cap overflows at 2^63.
        // Return an integer value iff the previous value and the operand is an
        // integer.
                if (s instanceof Xt && this.zt instanceof Xt) {
            const t = s.Kt + this.zt.Kt;
            return new Xt(t);
        }
        {
            const t = s.Kt + this.zt.Kt;
            return new Zt(t);
        }
    }
    Wt(t, e) {
        return g(null !== e, "Didn't receive transformResult for NUMERIC_ADD transform"), 
        e;
    }
    /**
     * Inspects the provided value, returning the provided value if it is already
     * a NumberValue, otherwise returning a coerced IntegerValue of 0.
     */    jt(t) {
        return t instanceof Jt ? t : new Xt(0);
    }
    isEqual(t) {
        return t instanceof vt && this.zt.isEqual(t.zt);
    }
}

function St(t) {
    return t instanceof he ? t.Kt.slice() : [];
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Provides a set of fields that can be used to partially patch a document.
 * FieldMask is used in conjunction with ObjectValue.
 * Examples:
 *   foo - Overwrites foo entirely with the provided value. If foo is not
 *         present in the companion ObjectValue, the field is deleted.
 *   foo.bar - Overwrites only the field bar of the object foo.
 *             If foo is not an object, foo is replaced with an object
 *             containing foo
 */ class Dt {
    constructor(t) {
        this.fields = t;
        // TODO(dimond): validation of FieldMask
        }
    static Gt(t) {
        return new Dt(t);
    }
    static Ht(t) {
        let e = new pt(Et.U);
        return t.forEach(t => e = e.add(t)), new Dt(e);
    }
    /**
     * Verifies that `fieldPath` is included by at least one field in this field
     * mask.
     *
     * This is an O(n) operation, where `n` is the size of the field mask.
     */    Jt(t) {
        let e = !1;
        return this.fields.forEach(s => {
            s.Y(t) && (e = !0);
        }), e;
    }
    isEqual(t) {
        return this.fields.isEqual(t.fields);
    }
}

/** A field path and the TransformOperation to perform upon it. */ class Ct {
    constructor(t, e) {
        this.field = t, this.transform = e;
    }
    isEqual(t) {
        return this.field.isEqual(t.field) && this.transform.isEqual(t.transform);
    }
}

/** The result of successfully applying a mutation to the backend. */ class kt {
    constructor(
    /**
     * The version at which the mutation was committed:
     *
     * - For most operations, this is the updateTime in the WriteResult.
     * - For deletes, the commitTime of the WriteResponse (because deletes are
     *   not stored and have no updateTime).
     *
     * Note that these versions can be different: No-op writes will not change
     * the updateTime even though the commitTime advances.
     */
    t, 
    /**
     * The resulting fields returned from the backend after a
     * TransformMutation has been committed. Contains one FieldValue for each
     * FieldTransform that was in the mutation.
     *
     * Will be null if the mutation was not a TransformMutation.
     */
    e) {
        this.version = t, this.transformResults = e;
    }
}

var Nt, Ft, $t, xt, Mt, Lt;

(Ft = Nt || (Nt = {}))[Ft.Set = 0] = "Set", Ft[Ft.Yt = 1] = "__PRIVATE_Patch", Ft[Ft.Transform = 2] = "Transform", 
Ft[Ft.Xt = 3] = "__PRIVATE_Delete", Ft[Ft.Verify = 4] = "Verify";

/**
 * Encodes a precondition for a mutation. This follows the model that the
 * backend accepts with the special case of an explicit "empty" precondition
 * (meaning no precondition).
 */
class Bt {
    constructor(t, e) {
        this.updateTime = t, this.exists = e, g(void 0 === t || void 0 === e, 'Precondition can specify "exists" or "updateTime" but not both');
    }
    /** Creates a new Precondition with an exists flag. */    static exists(t) {
        return new Bt(void 0, t);
    }
    /** Creates a new Precondition based on a version a document exists at. */    static updateTime(t) {
        return new Bt(t);
    }
    /** Returns whether this Precondition is empty. */    get Zt() {
        return void 0 === this.updateTime && void 0 === this.exists;
    }
    /**
     * Returns true if the preconditions is valid for the given document
     * (or null if no document is available).
     */    te(t) {
        return void 0 !== this.updateTime ? t instanceof ue && t.version.isEqual(this.updateTime) : void 0 !== this.exists ? this.exists === t instanceof ue : (g(this.Zt, "Precondition should be empty"), 
        !0);
    }
    isEqual(t) {
        return e = this.updateTime, s = t.updateTime, (null != e ? !(!s || !e.isEqual(s)) : e === s) && this.exists === t.exists;
        var e, s;
    }
}

Bt.NONE = new Bt;

/**
 * A mutation describes a self-contained change to a document. Mutations can
 * create, replace, delete, and update subsets of documents.
 *
 * Mutations not only act on the value of the document but also its version.
 *
 * For local mutations (mutations that haven't been committed yet), we preserve
 * the existing version for Set, Patch, and Transform mutations. For Delete
 * mutations, we reset the version to 0.
 *
 * Here's the expected transition table.
 *
 * MUTATION           APPLIED TO            RESULTS IN
 *
 * SetMutation        Document(v3)          Document(v3)
 * SetMutation        NoDocument(v3)        Document(v0)
 * SetMutation        null                  Document(v0)
 * PatchMutation      Document(v3)          Document(v3)
 * PatchMutation      NoDocument(v3)        NoDocument(v3)
 * PatchMutation      null                  null
 * TransformMutation  Document(v3)          Document(v3)
 * TransformMutation  NoDocument(v3)        NoDocument(v3)
 * TransformMutation  null                  null
 * DeleteMutation     Document(v3)          NoDocument(v0)
 * DeleteMutation     NoDocument(v3)        NoDocument(v0)
 * DeleteMutation     null                  NoDocument(v0)
 *
 * For acknowledged mutations, we use the updateTime of the WriteResponse as
 * the resulting version for Set, Patch, and Transform mutations. As deletes
 * have no explicit update time, we use the commitTime of the WriteResponse for
 * Delete mutations.
 *
 * If a mutation is acknowledged by the backend but fails the precondition check
 * locally, we return an `UnknownDocument` and rely on Watch to send us the
 * updated version.
 *
 * Note that TransformMutations don't create Documents (in the case of being
 * applied to a NoDocument), even though they would on the backend. This is
 * because the client always combines the TransformMutation with a SetMutation
 * or PatchMutation and we only want to apply the transform if the prior
 * mutation resulted in a Document (always true for a SetMutation, but not
 * necessarily for a PatchMutation).
 *
 * ## Subclassing Notes
 *
 * Subclasses of Mutation need to implement applyToRemoteDocument() and
 * applyToLocalView() to implement the actual behavior of applying the mutation
 * to some source document.
 */
class qt {
    ee(t) {
        null != t && g(t.key.isEqual(this.key), "Can only apply a mutation to a document with the same key");
    }
    /**
     * Returns the version from the given document for use as the result of a
     * mutation. Mutations are defined to return the version of the base document
     * only if it is an existing document. Deleted and unknown documents have a
     * post-mutation version of SnapshotVersion.MIN.
     */    static se(t) {
        return t instanceof ue ? t.version : dt.MIN;
    }
}

/**
 * A mutation that creates or replaces the document at the given key with the
 * object value contents.
 */ class Ot extends qt {
    constructor(t, e, s) {
        super(), this.key = t, this.value = e, this.ne = s, this.type = Nt.Set;
    }
    Wt(t, e) {
        this.ee(t), g(null == e.transformResults, "Transform results received by SetMutation.");
        // Unlike applyToLocalView, if we're applying a mutation to a remote
        // document the server has accepted the mutation so the precondition must
        // have held.
        const s = e.version;
        return new ue(this.key, s, {
            hasCommittedMutations: !0
        }, this.value);
    }
    Qt(t, e, s) {
        if (this.ee(t), !this.ne.te(t)) return t;
        const n = qt.se(t);
        return new ue(this.key, n, {
            ie: !0
        }, this.value);
    }
    re(t) {
        return null;
    }
    isEqual(t) {
        return t instanceof Ot && this.key.isEqual(t.key) && this.value.isEqual(t.value) && this.ne.isEqual(t.ne);
    }
}

/**
 * A mutation that modifies fields of the document at the given key with the
 * given values. The values are applied through a field mask:
 *
 *  * When a field is in both the mask and the values, the corresponding field
 *    is updated.
 *  * When a field is in neither the mask nor the values, the corresponding
 *    field is unmodified.
 *  * When a field is in the mask but not in the values, the corresponding field
 *    is deleted.
 *  * When a field is not in the mask but is in the values, the values map is
 *    ignored.
 */ class Ut extends qt {
    constructor(t, e, s, n) {
        super(), this.key = t, this.data = e, this.oe = s, this.ne = n, this.type = Nt.Yt;
    }
    Wt(t, e) {
        if (this.ee(t), g(null == e.transformResults, "Transform results received by PatchMutation."), 
        !this.ne.te(t)) 
        // Since the mutation was not rejected, we know that the  precondition
        // matched on the backend. We therefore must not have the expected version
        // of the document in our cache and return an UnknownDocument with the
        // known updateTime.
        return new le(this.key, e.version);
        const s = this.he(t);
        return new ue(this.key, e.version, {
            hasCommittedMutations: !0
        }, s);
    }
    Qt(t, e, s) {
        if (this.ee(t), !this.ne.te(t)) return t;
        const n = qt.se(t), i = this.he(t);
        return new ue(this.key, n, {
            ie: !0
        }, i);
    }
    re(t) {
        return null;
    }
    isEqual(t) {
        return t instanceof Ut && this.key.isEqual(t.key) && this.oe.isEqual(t.oe) && this.ne.isEqual(t.ne);
    }
    /**
     * Patches the data of document if available or creates a new document. Note
     * that this does not check whether or not the precondition of this patch
     * holds.
     */    he(t) {
        let e;
        return e = t instanceof ue ? t.data() : oe.EMPTY, this.ae(e);
    }
    ae(t) {
        return this.oe.fields.forEach(e => {
            if (!e.G()) {
                const s = this.data.field(e);
                t = null !== s ? t.set(e, s) : t.delete(e);
            }
        }), t;
    }
}

/**
 * A mutation that modifies specific fields of the document with transform
 * operations. Currently the only supported transform is a server timestamp, but
 * IP Address, increment(n), etc. could be supported in the future.
 *
 * It is somewhat similar to a PatchMutation in that it patches specific fields
 * and has no effect when applied to a null or NoDocument (see comment on
 * Mutation for rationale).
 */ class Qt extends qt {
    constructor(t, e) {
        super(), this.key = t, this.fieldTransforms = e, this.type = Nt.Transform, 
        // NOTE: We set a precondition of exists: true as a safety-check, since we
        // always combine TransformMutations with a SetMutation or PatchMutation which
        // (if successful) should end up with an existing document.
        this.ne = Bt.exists(!0);
    }
    Wt(t, e) {
        if (this.ee(t), g(null != e.transformResults, "Transform results missing for TransformMutation."), 
        !this.ne.te(t)) 
        // Since the mutation was not rejected, we know that the  precondition
        // matched on the backend. We therefore must not have the expected version
        // of the document in our cache and return an UnknownDocument with the
        // known updateTime.
        return new le(this.key, e.version);
        const s = this.ue(t), n = this.ce(t, e.transformResults), i = e.version, r = this.le(s.data(), n);
        return new ue(this.key, i, {
            hasCommittedMutations: !0
        }, r);
    }
    Qt(t, e, s) {
        if (this.ee(t), !this.ne.te(t)) return t;
        const n = this.ue(t), i = this._e(s, t, e), r = this.le(n.data(), i);
        return new ue(this.key, n.version, {
            ie: !0
        }, r);
    }
    re(t) {
        let e = null;
        for (const s of this.fieldTransforms) {
            const n = t instanceof ue ? t.field(s.field) : void 0, i = s.transform.jt(n || null);
            null != i && (e = null == e ? oe.EMPTY.set(s.field, i) : e.set(s.field, i));
        }
        return e;
    }
    isEqual(t) {
        return t instanceof Qt && this.key.isEqual(t.key) && v(this.fieldTransforms, t.fieldTransforms) && this.ne.isEqual(t.ne);
    }
    /**
     * Asserts that the given MaybeDocument is actually a Document and verifies
     * that it matches the key for this mutation. Since we only support
     * transformations with precondition exists this method is guaranteed to be
     * safe.
     */    ue(t) {
        return g(t instanceof ue, "Unknown MaybeDocument type " + t), g(t.key.isEqual(this.key), "Can only transform a document with the same key"), 
        t;
    }
    /**
     * Creates a list of "transform results" (a transform result is a field value
     * representing the result of applying a transform) for use after a
     * TransformMutation has been acknowledged by the server.
     *
     * @param baseDoc The document prior to applying this mutation batch.
     * @param serverTransformResults The transform results received by the server.
     * @return The transform results list.
     */    ce(t, e) {
        const s = [];
        g(this.fieldTransforms.length === e.length, `server transform result count (${e.length}) ` + `should match field transform count (${this.fieldTransforms.length})`);
        for (let n = 0; n < e.length; n++) {
            const i = this.fieldTransforms[n], r = i.transform;
            let o = null;
            t instanceof ue && (o = t.field(i.field)), s.push(r.Wt(o, e[n]));
        }
        return s;
    }
    /**
     * Creates a list of "transform results" (a transform result is a field value
     * representing the result of applying a transform) for use when applying a
     * TransformMutation locally.
     *
     * @param localWriteTime The local time of the transform mutation (used to
     *     generate ServerTimestampValues).
     * @param maybeDoc The current state of the document after applying all
     *     previous mutations.
     * @param baseDoc The document prior to applying this mutation batch.
     * @return The transform results list.
     */    _e(t, e, s) {
        const n = [];
        for (const i of this.fieldTransforms) {
            const r = i.transform;
            let o = null;
            e instanceof ue && (o = e.field(i.field)), null === o && s instanceof ue && (
            // If the current document does not contain a value for the mutated
            // field, use the value that existed before applying this mutation
            // batch. This solves an edge case where a PatchMutation clears the
            // values in a nested map before the TransformMutation is applied.
            o = s.field(i.field)), n.push(r.Qt(o, t));
        }
        return n;
    }
    le(t, e) {
        g(e.length === this.fieldTransforms.length, "TransformResults length mismatch.");
        for (let s = 0; s < this.fieldTransforms.length; s++) {
            const n = this.fieldTransforms[s].field;
            t = t.set(n, e[s]);
        }
        return t;
    }
}

/** A mutation that deletes the document at the given key. */ class Wt extends qt {
    constructor(t, e) {
        super(), this.key = t, this.ne = e, this.type = Nt.Xt;
    }
    Wt(t, e) {
        // Unlike applyToLocalView, if we're applying a mutation to a remote
        // document the server has accepted the mutation so the precondition must
        // have held.
        return this.ee(t), g(null == e.transformResults, "Transform results received by DeleteMutation."), 
        new ce(this.key, e.version, {
            hasCommittedMutations: !0
        });
    }
    Qt(t, e, s) {
        return this.ee(t), this.ne.te(t) ? (t && g(t.key.isEqual(this.key), "Can only apply mutation to document with same key"), 
        new ce(this.key, dt.B())) : t;
    }
    re(t) {
        return null;
    }
    isEqual(t) {
        return t instanceof Wt && this.key.isEqual(t.key) && this.ne.isEqual(t.ne);
    }
}

/**
 * A mutation that verifies the existence of the document at the given key with
 * the provided precondition.
 *
 * The `verify` operation is only used in Transactions, and this class serves
 * primarily to facilitate serialization into protos.
 */ class jt extends qt {
    constructor(t, e) {
        super(), this.key = t, this.ne = e, this.type = Nt.Verify;
    }
    Wt(t, e) {
        V("VerifyMutation should only be used in Transactions.");
    }
    Qt(t, e, s) {
        V("VerifyMutation should only be used in Transactions.");
    }
    re(t) {
        V("VerifyMutation should only be used in Transactions.");
    }
    isEqual(t) {
        return t instanceof jt && this.key.isEqual(t.key) && this.ne.isEqual(t.ne);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// This order is defined by the backend.
(xt = $t || ($t = {}))[xt.de = 0] = "__PRIVATE_NullValue", xt[xt.fe = 1] = "__PRIVATE_BooleanValue", 
xt[xt.me = 2] = "__PRIVATE_NumberValue", xt[xt.Te = 3] = "__PRIVATE_TimestampValue", 
xt[xt.we = 4] = "__PRIVATE_StringValue", xt[xt.Ee = 5] = "__PRIVATE_BlobValue", 
xt[xt.Ie = 6] = "__PRIVATE_RefValue", xt[xt.Re = 7] = "__PRIVATE_GeoPointValue", 
xt[xt.ArrayValue = 8] = "ArrayValue", xt[xt.Ae = 9] = "__PRIVATE_ObjectValue", (Lt = Mt || (Mt = {}))[Lt.Pe = 0] = "__PRIVATE_Default", 
Lt[Lt.pe = 1] = "__PRIVATE_Estimate", Lt[Lt.Ve = 2] = "__PRIVATE_Previous";

/** Holds properties that define field value deserialization options. */
class zt {
    constructor(t, e) {
        this.ge = t, this.timestampsInSnapshots = e;
    }
    static ye(t, e) {
        switch (t.serverTimestamps) {
          case "estimate":
            return new zt(Mt.pe, e);

          case "previous":
            return new zt(Mt.Ve, e);

          case "none":
 // Fall-through intended.
                      case void 0:
            return new zt(Mt.Pe, e);

          default:
            return V("fromSnapshotOptions() called with invalid options.");
        }
    }
}

/**
 * A field value represents a datatype as stored by Firestore.
 */ class Kt {
    toString() {
        const t = this.value();
        return null === t ? "null" : t.toString();
    }
    be(t) {
        return g(this.ve !== t.ve, "Default compareTo should not be used for values of same type."), 
        b(this.ve, t.ve);
    }
}

class Gt extends Kt {
    constructor() {
        super(), this.ve = $t.de, 
        // internalValue is unused but we add it to work around
        // https://github.com/Microsoft/TypeScript/issues/15585
        this.Kt = null;
    }
    value(t) {
        return null;
    }
    isEqual(t) {
        return t instanceof Gt;
    }
    u(t) {
        return t instanceof Gt ? 0 : this.be(t);
    }
    Se() {
        return 4;
    }
}

Gt.De = new Gt;

class Ht extends Kt {
    constructor(t) {
        super(), this.Kt = t, this.ve = $t.fe;
    }
    value(t) {
        return this.Kt;
    }
    isEqual(t) {
        return t instanceof Ht && this.Kt === t.Kt;
    }
    u(t) {
        return t instanceof Ht ? b(this, t) : this.be(t);
    }
    Se() {
        return 4;
    }
    static of(t) {
        return t ? Ht.Ce : Ht.ke;
    }
}

Ht.Ce = new Ht(!0), Ht.ke = new Ht(!1);

/** Base class for IntegerValue and DoubleValue. */
class Jt extends Kt {
    constructor(t) {
        super(), this.Kt = t, this.ve = $t.me;
    }
    value(t) {
        return this.Kt;
    }
    u(t) {
        return t instanceof Jt ? (e = this.Kt, s = t.Kt, e < s ? -1 : e > s ? 1 : e === s ? 0 : 
        // one or both are NaN.
        isNaN(e) ? isNaN(s) ? 0 : -1 : 1) : this.be(t);
        /** Utility function to compare doubles (using Firestore semantics for NaN). */
        var e, s;
        /**
 * Utility function to check numbers for equality using Firestore semantics
 * (NaN === NaN, -0.0 !== 0.0).
 */    }
    Se() {
        return 8;
    }
}

function Yt(t, e) {
    // Implemented based on Object.is() polyfill from
    // https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
    return t === e ? 0 !== t || 1 / t == 1 / e : t != t && e != e;
}

class Xt extends Jt {
    isEqual(t) {
        // NOTE: DoubleValue and IntegerValue instances may compareTo() the same,
        // but that doesn't make them equal via isEqual().
        return t instanceof Xt && Yt(this.Kt, t.Kt);
    }
}

class Zt extends Jt {
    isEqual(t) {
        // NOTE: DoubleValue and IntegerValue instances may compareTo() the same,
        // but that doesn't make them equal via isEqual().
        return t instanceof Zt && Yt(this.Kt, t.Kt);
    }
}

Zt.Ne = new Zt(NaN), Zt.POSITIVE_INFINITY = new Zt(1 / 0), Zt.NEGATIVE_INFINITY = new Zt(-1 / 0);

// TODO(b/37267885): Add truncation support
class te extends Kt {
    constructor(t) {
        super(), this.Kt = t, this.ve = $t.we;
    }
    value(t) {
        return this.Kt;
    }
    isEqual(t) {
        return t instanceof te && this.Kt === t.Kt;
    }
    u(t) {
        return t instanceof te ? b(this.Kt, t.Kt) : this.be(t);
    }
    Se() {
        // See https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures:
        // "JavaScript's String type is [...] a set of elements of 16-bit unsigned
        // integer values"
        return 2 * this.Kt.length;
    }
}

class ee extends Kt {
    constructor(t) {
        super(), this.Kt = t, this.ve = $t.Te;
    }
    value(t) {
        return !t || t.timestampsInSnapshots ? this.Kt : this.Kt.toDate();
    }
    isEqual(t) {
        return t instanceof ee && this.Kt.isEqual(t.Kt);
    }
    u(t) {
        return t instanceof ee ? this.Kt.$(t.Kt) : t instanceof se ? -1 : this.be(t);
    }
    Se() {
        // Timestamps are made up of two distinct numbers (seconds + nanoseconds)
        return 16;
    }
}

/**
 * Represents a locally-applied ServerTimestamp.
 *
 * Notes:
 * - ServerTimestampValue instances are created as the result of applying a
 *   TransformMutation (see TransformMutation.applyTo()). They can only exist in
 *   the local view of a document. Therefore they do not need to be parsed or
 *   serialized.
 * - When evaluated locally (e.g. for snapshot.data()), they by default
 *   evaluate to `null`. This behavior can be configured by passing custom
 *   FieldValueOptions to value().
 * - With respect to other ServerTimestampValues, they sort by their
 *   localWriteTime.
 */ class se extends Kt {
    constructor(t, e) {
        super(), this.Fe = t, this.previousValue = e, this.ve = $t.Te;
    }
    value(t) {
        return t && t.ge === Mt.pe ? new ee(this.Fe).value(t) : t && t.ge === Mt.Ve && this.previousValue ? this.previousValue.value(t) : null;
    }
    isEqual(t) {
        return t instanceof se && this.Fe.isEqual(t.Fe);
    }
    u(t) {
        return t instanceof se ? this.Fe.$(t.Fe) : t instanceof ee ? 1 : this.be(t);
    }
    toString() {
        return "<ServerTimestamp localTime=" + this.Fe.toString() + ">";
    }
    Se() {
        /* localWriteTime */
        return 16 + (this.previousValue ? this.previousValue.Se() : 0);
    }
}

class ne extends Kt {
    constructor(t) {
        super(), this.Kt = t, this.ve = $t.Ee;
    }
    value(t) {
        return this.Kt;
    }
    isEqual(t) {
        return t instanceof ne && this.Kt.isEqual(t.Kt);
    }
    u(t) {
        return t instanceof ne ? this.Kt.$(t.Kt) : this.be(t);
    }
    Se() {
        return this.Kt.$e();
    }
}

class ie extends Kt {
    constructor(t, e) {
        super(), this.o = t, this.key = e, this.ve = $t.Ie;
    }
    value(t) {
        return this.key;
    }
    isEqual(t) {
        return t instanceof ie && (this.key.isEqual(t.key) && this.o.isEqual(t.o));
    }
    u(t) {
        if (t instanceof ie) {
            const e = this.o.u(t.o);
            return 0 !== e ? e : It.U(this.key, t.key);
        }
        return this.be(t);
    }
    Se() {
        return this.o.projectId.length + this.o.database.length + this.key.toString().length;
    }
}

class re extends Kt {
    constructor(t) {
        super(), this.Kt = t, this.ve = $t.Re;
    }
    value(t) {
        return this.Kt;
    }
    isEqual(t) {
        return t instanceof re && this.Kt.isEqual(t.Kt);
    }
    u(t) {
        return t instanceof re ? this.Kt.$(t.Kt) : this.be(t);
    }
    Se() {
        // GeoPoints are made up of two distinct numbers (latitude + longitude)
        return 16;
    }
}

class oe extends Kt {
    constructor(t) {
        super(), this.Kt = t, this.ve = $t.Ae;
    }
    value(t) {
        const e = {};
        return this.Kt.Tt((s, n) => {
            e[s] = n.value(t);
        }), e;
    }
    forEach(t) {
        this.Kt.Tt(t);
    }
    isEqual(t) {
        if (t instanceof oe) {
            const e = this.Kt.Et(), s = t.Kt.Et();
            for (;e.gt() && s.gt(); ) {
                const t = e.Vt(), n = s.Vt();
                if (t.key !== n.key || !t.value.isEqual(n.value)) return !1;
            }
            return !e.gt() && !s.gt();
        }
        return !1;
    }
    u(t) {
        if (t instanceof oe) {
            const e = this.Kt.Et(), s = t.Kt.Et();
            for (;e.gt() && s.gt(); ) {
                const t = e.Vt(), n = s.Vt(), i = b(t.key, n.key) || t.value.u(n.value);
                if (i) return i;
            }
            // Only equal if both iterators are exhausted
                        return b(e.gt(), s.gt());
        }
        return this.be(t);
    }
    set(t, e) {
        if (g(!t.G(), "Cannot set field for empty path on ObjectValue"), 1 === t.length) return this.xe(t.H(), e);
        {
            let s = this.child(t.H());
            s instanceof oe || (s = oe.EMPTY);
            const n = s.set(t.j(), e);
            return this.xe(t.H(), n);
        }
    }
    delete(t) {
        if (g(!t.G(), "Cannot delete field for empty path on ObjectValue"), 1 === t.length) return new oe(this.Kt.remove(t.H()));
        {
            // nested field
            const e = this.child(t.H());
            if (e instanceof oe) {
                const s = e.delete(t.j());
                return new oe(this.Kt.lt(t.H(), s));
            }
            // Don't actually change a primitive value to an object for a delete
            return this;
        }
    }
    contains(t) {
        return null !== this.field(t);
    }
    field(t) {
        g(!t.G(), "Can't get field of empty path");
        let e = this;
        return t.forEach(t => {
            e = e instanceof oe ? e.Kt.get(t) : null;
        }), e;
    }
    /**
     * Returns a FieldMask built from all FieldPaths starting from this ObjectValue,
     * including paths from nested objects.
     */    oe() {
        let t = new pt(Et.U);
        return this.Kt.forEach((e, s) => {
            const n = new Et([ e ]);
            if (s instanceof oe) {
                const e = s.oe().fields;
                e.G() ? 
                // Preserve the empty map by adding it to the FieldMask.
                t = t.add(n) : 
                // For nested and non-empty ObjectValues, add the FieldPath of the
                // leaf nodes.
                e.forEach(e => {
                    t = t.add(n.child(e));
                });
            } else t = t.add(n);
        }), Dt.Gt(t);
    }
    Se() {
        let t = 0;
        return this.Kt.Tt((e, s) => {
            t += e.length + s.Se();
        }), t;
    }
    toString() {
        return this.Kt.toString();
    }
    child(t) {
        return this.Kt.get(t) || void 0;
    }
    xe(t, e) {
        return new oe(this.Kt.lt(t, e));
    }
}

oe.EMPTY = new oe(new Rt(b));

class he extends Kt {
    constructor(t) {
        super(), this.Kt = t, this.ve = $t.ArrayValue;
    }
    value(t) {
        return this.Kt.map(e => e.value(t));
    }
    /**
     * Returns true if the given value is contained in this array.
     */    contains(t) {
        for (const e of this.Kt) if (e.isEqual(t)) return !0;
        return !1;
    }
    forEach(t) {
        this.Kt.forEach(t);
    }
    isEqual(t) {
        if (t instanceof he) {
            if (this.Kt.length !== t.Kt.length) return !1;
            for (let e = 0; e < this.Kt.length; e++) if (!this.Kt[e].isEqual(t.Kt[e])) return !1;
            return !0;
        }
        return !1;
    }
    u(t) {
        if (t instanceof he) {
            const e = Math.min(this.Kt.length, t.Kt.length);
            for (let s = 0; s < e; s++) {
                const e = this.Kt[s].u(t.Kt[s]);
                if (e) return e;
            }
            return b(this.Kt.length, t.Kt.length);
        }
        return this.be(t);
    }
    Se() {
        return this.Kt.reduce((t, e) => t + e.Se(), 0);
    }
    toString() {
        return `[${this.Kt.map(t => t.toString()).join(",")}]`;
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * The result of a lookup for a given path may be an existing document or a
 * marker that this document does not exist at a given version.
 */ class ae {
    constructor(t, e) {
        this.key = t, this.version = e;
    }
    static Me(t, e) {
        return It.U(t.key, e.key);
    }
}

/**
 * Represents a document in Firestore with a key, version, data and whether the
 * data has local mutations applied to it.
 */ class ue extends ae {
    constructor(t, e, s, n, i, r) {
        super(t, e), this.Le = n, this.proto = i, this.converter = r, g(void 0 !== this.Le || void 0 !== this.proto && void 0 !== this.converter, "If objectValue is not defined, proto and converter need to be set."), 
        this.ie = !!s.ie, this.hasCommittedMutations = !!s.hasCommittedMutations;
    }
    field(t) {
        if (this.Le) return this.Le.field(t);
        {
            this.Be || (
            // TODO(b/136090445): Remove the cache when `getField` is no longer
            // called during Query ordering.
            this.Be = new Map);
            const e = t.tt();
            let s = this.Be.get(e);
            if (void 0 === s) {
                // Instead of deserializing the full Document proto, we only
                // deserialize the value at the requested field path. This speeds up
                // Query execution as query filters can discard documents based on a
                // single field.
                const n = this.qe(t);
                s = void 0 === n ? null : this.converter(n), this.Be.set(e, s);
            }
            return s;
        }
    }
    data() {
        if (!this.Le) {
            let t = oe.EMPTY;
            W(this.proto.fields || {}, (e, s) => {
                t = t.set(new Et([ e ]), this.converter(s));
            }), this.Le = t, 
            // Once objectValue is computed, values inside the fieldValueCache are no
            // longer accessed.
            this.Be = void 0;
        }
        return this.Le;
    }
    value() {
        return this.data().value();
    }
    isEqual(t) {
        return t instanceof ue && this.key.isEqual(t.key) && this.version.isEqual(t.version) && this.ie === t.ie && this.hasCommittedMutations === t.hasCommittedMutations && this.data().isEqual(t.data());
    }
    toString() {
        return `Document(${this.key}, ${this.version}, ${this.data().toString()}, ` + `{hasLocalMutations: ${this.ie}}), ` + `{hasCommittedMutations: ${this.hasCommittedMutations}})`;
    }
    get hasPendingWrites() {
        return this.ie || this.hasCommittedMutations;
    }
    /**
     * Returns the nested Protobuf value for 'path`. Can only be called if
     * `proto` was provided at construction time.
     */    qe(t) {
        g(void 0 !== this.proto, "Can only call getProtoField() when proto is defined");
        let e = this.proto.fields ? this.proto.fields[t.H()] : void 0;
        for (let s = 1; s < t.length; ++s) {
            if (!e || !e.mapValue || !e.mapValue.fields) return;
            e = e.mapValue.fields[t.get(s)];
        }
        return e;
    }
    static Oe(t, e, s) {
        const n = e.field(t), i = s.field(t);
        return null !== n && null !== i ? n.u(i) : V("Trying to compare documents on fields that don't exist");
    }
}

/**
 * A class representing a deleted document.
 * Version is set to 0 if we don't point to any specific time, otherwise it
 * denotes time we know it didn't exist at.
 */ class ce extends ae {
    constructor(t, e, s) {
        super(t, e), this.hasCommittedMutations = !(!s || !s.hasCommittedMutations);
    }
    toString() {
        return `NoDocument(${this.key}, ${this.version})`;
    }
    get hasPendingWrites() {
        return this.hasCommittedMutations;
    }
    isEqual(t) {
        return t instanceof ce && t.hasCommittedMutations === this.hasCommittedMutations && t.version.isEqual(this.version) && t.key.isEqual(this.key);
    }
}

/**
 * A class representing an existing document whose data is unknown (e.g. a
 * document that was updated without a known base document).
 */ class le extends ae {
    toString() {
        return `UnknownDocument(${this.key}, ${this.version})`;
    }
    get hasPendingWrites() {
        return !0;
    }
    isEqual(t) {
        return t instanceof le && t.version.isEqual(this.version) && t.key.isEqual(this.key);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Untyped Number alias we can use to check for ES6 methods / properties.
// eslint-disable-next-line @typescript-eslint/no-explicit-any
const _e = Number, de = _e.MIN_SAFE_INTEGER || -(Math.pow(2, 53) - 1), fe = _e.MAX_SAFE_INTEGER || Math.pow(2, 53) - 1, me = _e.isInteger || (t => "number" == typeof t && isFinite(t) && Math.floor(t) === t);

/**
 * Minimum safe integer in Javascript because of floating point precision.
 * Added to not rely on ES6 features.
 */
/**
 * Returns whether a variable is either undefined or null.
 */
function Te(t) {
    return null == t;
}

/**
 * Returns whether a value is an integer and in the safe integer range
 * @param value The value to test for being an integer and in the safe range
 */ function we(t) {
    return me(t) && t <= fe && t >= de;
}

/**
 * @license
 * Copyright 2019 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A Target represents the WatchTarget representation of a Query, which is used
 * by the LocalStore and the RemoteStore to keep track of and to execute
 * backend queries. While a Query can represent multiple Targets, each Targets
 * maps to a single WatchTarget in RemoteStore and a single TargetData entry
 * in persistence.
 */ class Ee {
    /**
     * Initializes a Target with a path and optional additional query constraints.
     * Path must currently be empty if this is a collection group query.
     *
     * NOTE: you should always construct `Target` from `Query.toTarget` instead of
     * using this constructor, because `Query` provides an implicit `orderBy`
     * property.
     */
    constructor(t, e = null, s = [], n = [], i = null, r = null, o = null) {
        this.path = t, this.collectionGroup = e, this.orderBy = s, this.filters = n, this.limit = i, 
        this.startAt = r, this.endAt = o, this.Ue = null;
    }
    canonicalId() {
        if (null === this.Ue) {
            let t = this.path.tt();
            null !== this.collectionGroup && (t += "|cg:" + this.collectionGroup), t += "|f:";
            for (const e of this.filters) t += e.canonicalId(), t += ",";
            t += "|ob:";
            // TODO(dimond): make this collision resistant
            for (const e of this.orderBy) t += e.canonicalId(), t += ",";
            Te(this.limit) || (t += "|l:", t += this.limit), this.startAt && (t += "|lb:", t += this.startAt.canonicalId()), 
            this.endAt && (t += "|ub:", t += this.endAt.canonicalId()), this.Ue = t;
        }
        return this.Ue;
    }
    toString() {
        let t = this.path.tt();
        return null !== this.collectionGroup && (t += " collectionGroup=" + this.collectionGroup), 
        this.filters.length > 0 && (t += `, filters: [${this.filters.join(", ")}]`), Te(this.limit) || (t += ", limit: " + this.limit), 
        this.orderBy.length > 0 && (t += `, orderBy: [${this.orderBy.join(", ")}]`), this.startAt && (t += ", startAt: " + this.startAt.canonicalId()), 
        this.endAt && (t += ", endAt: " + this.endAt.canonicalId()), `Target(${t})`;
    }
    isEqual(t) {
        if (this.limit !== t.limit) return !1;
        if (this.orderBy.length !== t.orderBy.length) return !1;
        for (let e = 0; e < this.orderBy.length; e++) if (!this.orderBy[e].isEqual(t.orderBy[e])) return !1;
        if (this.filters.length !== t.filters.length) return !1;
        for (let e = 0; e < this.filters.length; e++) if (!this.filters[e].isEqual(t.filters[e])) return !1;
        return this.collectionGroup === t.collectionGroup && (!!this.path.isEqual(t.path) && (!(null !== this.startAt ? !this.startAt.isEqual(t.startAt) : null !== t.startAt) && (null !== this.endAt ? this.endAt.isEqual(t.endAt) : null === t.endAt)));
    }
    Qe() {
        return It.ht(this.path) && null === this.collectionGroup && 0 === this.filters.length;
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ var Ie, Re;

(Re = Ie || (Ie = {})).We = "F", Re.je = "L";

/**
 * Query encapsulates all the query attributes we support in the SDK. It can
 * be run against the LocalStore, as well as be converted to a `Target` to
 * query the RemoteStore results.
 */
class Ae {
    /**
     * Initializes a Query with a path and optional additional query constraints.
     * Path must currently be empty if this is a collection group query.
     */
    constructor(t, e = null, s = [], n = [], i = null, r = Ie.We, o = null, h = null) {
        this.path = t, this.collectionGroup = e, this.ze = s, this.filters = n, this.limit = i, 
        this.Ke = r, this.startAt = o, this.endAt = h, this.Ge = null, 
        // The corresponding `Target` of this `Query` instance.
        this.He = null, this.startAt && this.Je(this.startAt), this.endAt && this.Je(this.endAt);
    }
    static Ye(t) {
        return new Ae(t);
    }
    get orderBy() {
        if (null === this.Ge) {
            const t = this.Xe(), e = this.Ze();
            if (null !== t && null === e) 
            // In order to implicitly add key ordering, we must also add the
            // inequality filter field for it to be a valid query.
            // Note that the default inequality field and key ordering is ascending.
            t.it() ? this.Ge = [ Ne ] : this.Ge = [ new ke(t), Ne ]; else {
                g(null === t || null !== e && t.isEqual(e), "First orderBy should match inequality field."), 
                this.Ge = [];
                let s = !1;
                for (const t of this.ze) this.Ge.push(t), t.field.it() && (s = !0);
                if (!s) {
                    // The order of the implicit key ordering always matches the last
                    // explicit order by
                    const t = this.ze.length > 0 ? this.ze[this.ze.length - 1].dir : De.ASCENDING;
                    this.Ge.push(t === De.ASCENDING ? Ne : Fe);
                }
            }
        }
        return this.Ge;
    }
    ts(t) {
        g(null == this.Xe() || !(t instanceof Ve) || !t.es() || t.field.isEqual(this.Xe()), "Query must only have one inequality field."), 
        g(!this.Qe(), "No filtering allowed for document query");
        const e = this.filters.concat([ t ]);
        return new Ae(this.path, this.collectionGroup, this.ze.slice(), e, this.limit, this.Ke, this.startAt, this.endAt);
    }
    ss(t) {
        g(!this.startAt && !this.endAt, "Bounds must be set after orderBy");
        // TODO(dimond): validate that orderBy does not list the same key twice.
        const e = this.ze.concat([ t ]);
        return new Ae(this.path, this.collectionGroup, e, this.filters.slice(), this.limit, this.Ke, this.startAt, this.endAt);
    }
    ns(t) {
        return new Ae(this.path, this.collectionGroup, this.ze.slice(), this.filters.slice(), t, Ie.We, this.startAt, this.endAt);
    }
    rs(t) {
        return new Ae(this.path, this.collectionGroup, this.ze.slice(), this.filters.slice(), t, Ie.je, this.startAt, this.endAt);
    }
    os(t) {
        return new Ae(this.path, this.collectionGroup, this.ze.slice(), this.filters.slice(), this.limit, this.Ke, t, this.endAt);
    }
    hs(t) {
        return new Ae(this.path, this.collectionGroup, this.ze.slice(), this.filters.slice(), this.limit, this.Ke, this.startAt, t);
    }
    /**
     * Helper to convert a collection group query into a collection query at a
     * specific path. This is used when executing collection group queries, since
     * we have to split the query into a set of collection queries at multiple
     * paths.
     */    as(t) {
        return new Ae(t, 
        /*collectionGroup=*/ null, this.ze.slice(), this.filters.slice(), this.limit, this.Ke, this.startAt, this.endAt);
    }
    /**
     * Returns true if this query does not specify any query constraints that
     * could remove results.
     */    us() {
        return 0 === this.filters.length && null === this.limit && null == this.startAt && null == this.endAt && (0 === this.ze.length || 1 === this.ze.length && this.ze[0].field.it());
    }
    // TODO(b/29183165): This is used to get a unique string from a query to, for
    // example, use as a dictionary key, but the implementation is subject to
    // collisions. Make it collision-free.
    canonicalId() {
        return `${this.cs().canonicalId()}|lt:${this.Ke}`;
    }
    toString() {
        return `Query(target=${this.cs().toString()}; limitType=${this.Ke})`;
    }
    isEqual(t) {
        return this.cs().isEqual(t.cs()) && this.Ke === t.Ke;
    }
    ls(t, e) {
        let s = !1;
        for (const n of this.orderBy) {
            const i = n.compare(t, e);
            if (0 !== i) return i;
            s = s || n.field.it();
        }
        // Assert that we actually compared by key
                return g(s, "orderBy used that doesn't compare on key field"), 0;
    }
    matches(t) {
        return this._s(t) && this.ds(t) && this.fs(t) && this.ms(t);
    }
    Ts() {
        return !Te(this.limit) && this.Ke === Ie.We;
    }
    ws() {
        return !Te(this.limit) && this.Ke === Ie.je;
    }
    Ze() {
        return this.ze.length > 0 ? this.ze[0].field : null;
    }
    Xe() {
        for (const t of this.filters) if (t instanceof Ve && t.es()) return t.field;
        return null;
    }
    // Checks if any of the provided Operators are included in the query and
    // returns the first one that is, or null if none are.
    Es(t) {
        for (const e of this.filters) if (e instanceof Ve && t.indexOf(e.op) >= 0) return e.op;
        return null;
    }
    Qe() {
        return this.cs().Qe();
    }
    Is() {
        return null !== this.collectionGroup;
    }
    /**
     * Converts this `Query` instance to it's corresponding `Target`
     * representation.
     */    cs() {
        if (!this.He) if (this.Ke === Ie.We) this.He = new Ee(this.path, this.collectionGroup, this.orderBy, this.filters, this.limit, this.startAt, this.endAt); else {
            // Flip the orderBy directions since we want the last results
            const t = [];
            for (const e of this.orderBy) {
                const s = e.dir === De.DESCENDING ? De.ASCENDING : De.DESCENDING;
                t.push(new ke(e.field, s));
            }
            // We need to swap the cursors to match the now-flipped query ordering.
                        const e = this.endAt ? new Ce(this.endAt.position, !this.endAt.before) : null, s = this.startAt ? new Ce(this.startAt.position, !this.startAt.before) : null;
            // Now return as a LimitType.First query.
            this.He = new Ee(this.path, this.collectionGroup, t, this.filters, this.limit, e, s);
        }
        return this.He;
    }
    _s(t) {
        const e = t.key.path;
        return null !== this.collectionGroup ? t.key.at(this.collectionGroup) && this.path.Y(e) : It.ht(this.path) ? this.path.isEqual(e) : this.path.X(e);
    }
    /**
     * A document must have a value for every ordering clause in order to show up
     * in the results.
     */    ds(t) {
        for (const e of this.ze) 
        // order by key always matches
        if (!e.field.it() && null === t.field(e.field)) return !1;
        return !0;
    }
    fs(t) {
        for (const e of this.filters) if (!e.matches(t)) return !1;
        return !0;
    }
    /**
     * Makes sure a document is within the bounds, if provided.
     */    ms(t) {
        return !(this.startAt && !this.startAt.Rs(this.orderBy, t)) && (!this.endAt || !this.endAt.Rs(this.orderBy, t));
    }
    Je(t) {
        g(t.position.length <= this.orderBy.length, "Bound is longer than orderBy");
    }
}

class Pe {}

class pe {
    constructor(t) {
        this.name = t;
    }
    static et(t) {
        switch (t) {
          case "<":
            return pe.LESS_THAN;

          case "<=":
            return pe.LESS_THAN_OR_EQUAL;

          case "==":
            return pe.EQUAL;

          case ">=":
            return pe.GREATER_THAN_OR_EQUAL;

          case ">":
            return pe.GREATER_THAN;

          case "array-contains":
            return pe.ARRAY_CONTAINS;

          case "in":
            return pe.IN;

          case "array-contains-any":
            return pe.ARRAY_CONTAINS_ANY;

          default:
            return V("Unknown FieldFilter operator: " + t);
        }
    }
    toString() {
        return this.name;
    }
    isEqual(t) {
        return this.name === t.name;
    }
}

pe.LESS_THAN = new pe("<"), pe.LESS_THAN_OR_EQUAL = new pe("<="), pe.EQUAL = new pe("=="), 
pe.GREATER_THAN = new pe(">"), pe.GREATER_THAN_OR_EQUAL = new pe(">="), pe.ARRAY_CONTAINS = new pe("array-contains"), 
pe.IN = new pe("in"), pe.ARRAY_CONTAINS_ANY = new pe("array-contains-any");

class Ve extends Pe {
    constructor(t, e, s) {
        super(), this.field = t, this.op = e, this.value = s;
    }
    /**
     * Creates a filter based on the provided arguments.
     */    static create(t, e, s) {
        if (t.it()) return e === pe.IN ? (g(s instanceof he, "Comparing on key with IN, but filter value not an ArrayValue"), 
        g(s.Kt.every(t => t instanceof ie), "Comparing on key with IN, but an array value was not a RefValue"), 
        new ye(t, s)) : (g(s instanceof ie, "Comparing on key, but filter value not a RefValue"), 
        g(e !== pe.ARRAY_CONTAINS && e !== pe.ARRAY_CONTAINS_ANY, `'${e.toString()}' queries don't make sense on document keys.`), 
        new ge(t, e, s));
        if (s.isEqual(Gt.De)) {
            if (e !== pe.EQUAL) throw new $(F.INVALID_ARGUMENT, "Invalid query. Null supports only equality comparisons.");
            return new Ve(t, e, s);
        }
        if (s.isEqual(Zt.Ne)) {
            if (e !== pe.EQUAL) throw new $(F.INVALID_ARGUMENT, "Invalid query. NaN supports only equality comparisons.");
            return new Ve(t, e, s);
        }
        return e === pe.ARRAY_CONTAINS ? new be(t, s) : e === pe.IN ? (g(s instanceof he, "IN filter has invalid value: " + s.toString()), 
        new ve(t, s)) : e === pe.ARRAY_CONTAINS_ANY ? (g(s instanceof he, "ARRAY_CONTAINS_ANY filter has invalid value: " + s.toString()), 
        new Se(t, s)) : new Ve(t, e, s);
    }
    matches(t) {
        const e = t.field(this.field);
        // Only compare types with matching backend order (such as double and int).
                return null !== e && this.value.ve === e.ve && this.As(e.u(this.value));
    }
    As(t) {
        switch (this.op) {
          case pe.LESS_THAN:
            return t < 0;

          case pe.LESS_THAN_OR_EQUAL:
            return t <= 0;

          case pe.EQUAL:
            return 0 === t;

          case pe.GREATER_THAN:
            return t > 0;

          case pe.GREATER_THAN_OR_EQUAL:
            return t >= 0;

          default:
            return V("Unknown FieldFilter operator: " + this.op);
        }
    }
    es() {
        return [ pe.LESS_THAN, pe.LESS_THAN_OR_EQUAL, pe.GREATER_THAN, pe.GREATER_THAN_OR_EQUAL ].indexOf(this.op) >= 0;
    }
    canonicalId() {
        // TODO(b/29183165): Technically, this won't be unique if two values have
        // the same description, such as the int 3 and the string "3". So we should
        // add the types in here somehow, too.
        return this.field.tt() + this.op.toString() + this.value.toString();
    }
    isEqual(t) {
        return t instanceof Ve && (this.op.isEqual(t.op) && this.field.isEqual(t.field) && this.value.isEqual(t.value));
    }
    toString() {
        return `${this.field.tt()} ${this.op} ${this.value.value()}`;
    }
}

/** Filter that matches on key fields (i.e. '__name__'). */ class ge extends Ve {
    matches(t) {
        const e = this.value, s = It.U(t.key, e.key);
        return this.As(s);
    }
}

/** Filter that matches on key fields within an array. */ class ye extends Ve {
    constructor(t, e) {
        super(t, pe.IN, e), this.value = e;
    }
    matches(t) {
        return this.value.Kt.some(e => t.key.isEqual(e.key));
    }
}

/** A Filter that implements the array-contains operator. */ class be extends Ve {
    constructor(t, e) {
        super(t, pe.ARRAY_CONTAINS, e);
    }
    matches(t) {
        const e = t.field(this.field);
        return e instanceof he && e.contains(this.value);
    }
}

/** A Filter that implements the IN operator. */ class ve extends Ve {
    constructor(t, e) {
        super(t, pe.IN, e), this.value = e;
    }
    matches(t) {
        const e = this.value, s = t.field(this.field);
        return null !== s && e.contains(s);
    }
}

/** A Filter that implements the array-contains-any operator. */ class Se extends Ve {
    constructor(t, e) {
        super(t, pe.ARRAY_CONTAINS_ANY, e), this.value = e;
    }
    matches(t) {
        const e = t.field(this.field);
        return e instanceof he && e.Kt.some(t => this.value.contains(t));
    }
}

/**
 * The direction of sorting in an order by.
 */ class De {
    constructor(t) {
        this.name = t;
    }
    toString() {
        return this.name;
    }
}

De.ASCENDING = new De("asc"), De.DESCENDING = new De("desc");

/**
 * Represents a bound of a query.
 *
 * The bound is specified with the given components representing a position and
 * whether it's just before or just after the position (relative to whatever the
 * query order is).
 *
 * The position represents a logical index position for a query. It's a prefix
 * of values for the (potentially implicit) order by clauses of a query.
 *
 * Bound provides a function to determine whether a document comes before or
 * after a bound. This is influenced by whether the position is just before or
 * just after the provided values.
 */
class Ce {
    constructor(t, e) {
        this.position = t, this.before = e;
    }
    canonicalId() {
        // TODO(b/29183165): Make this collision robust.
        let t = this.before ? "b:" : "a:";
        for (const e of this.position) t += e.toString();
        return t;
    }
    /**
     * Returns true if a document sorts before a bound using the provided sort
     * order.
     */    Rs(t, e) {
        g(this.position.length <= t.length, "Bound has more components than query's orderBy");
        let s = 0;
        for (let n = 0; n < this.position.length; n++) {
            const i = t[n], r = this.position[n];
            if (i.field.it()) g(r instanceof ie, "Bound has a non-key value where the key path is being used."), 
            s = It.U(r.key, e.key); else {
                const t = e.field(i.field);
                g(null !== t, "Field should exist since document matched the orderBy already."), 
                s = r.u(t);
            }
            if (i.dir === De.DESCENDING && (s *= -1), 0 !== s) break;
        }
        return this.before ? s <= 0 : s < 0;
    }
    isEqual(t) {
        if (null === t) return !1;
        if (this.before !== t.before || this.position.length !== t.position.length) return !1;
        for (let e = 0; e < this.position.length; e++) {
            const s = this.position[e], n = t.position[e];
            if (!s.isEqual(n)) return !1;
        }
        return !0;
    }
}

/**
 * An ordering on a field, in some Direction. Direction defaults to ASCENDING.
 */ class ke {
    constructor(t, e) {
        this.field = t, void 0 === e && (e = De.ASCENDING), this.dir = e, this.Ps = t.it();
    }
    compare(t, e) {
        const s = this.Ps ? ue.Me(t, e) : ue.Oe(this.field, t, e);
        switch (this.dir) {
          case De.ASCENDING:
            return s;

          case De.DESCENDING:
            return -1 * s;

          default:
            return V("Unknown direction: " + this.dir);
        }
    }
    canonicalId() {
        // TODO(b/29183165): Make this collision robust.
        return this.field.tt() + this.dir.toString();
    }
    toString() {
        return `${this.field.tt()} (${this.dir})`;
    }
    isEqual(t) {
        return this.dir === t.dir && this.field.isEqual(t.field);
    }
}

const Ne = new ke(Et.rt(), De.ASCENDING), Fe = new ke(Et.rt(), De.DESCENDING);

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Describes the online state of the Firestore client. Note that this does not
 * indicate whether or not the remote store is trying to connect or not. This is
 * primarily used by the View / EventManager code to change their behavior while
 * offline (e.g. get() calls shouldn't wait for data from the server and
 * snapshot events should set metadata.isFromCache=true).
 */
var $e, xe, Me, Le, Be, qe, Oe, Ue;

/**
     * The Firestore client is in an unknown online state. This means the client
     * is either not actively trying to establish a connection or it is currently
     * trying to establish a connection, but it has not succeeded or failed yet.
     * Higher-level components should not operate in offline mode.
     */
(xe = $e || ($e = {}))[xe.ps = 0] = "__PRIVATE_Unknown", 
/**
     * The client is connected and the connections are healthy. This state is
     * reached after a successful connection and there has been at least one
     * successful message received from the backends.
     */
xe[xe.Vs = 1] = "__PRIVATE_Online", 
/**
     * The client is either trying to establish a connection but failing, or it
     * has been explicitly marked offline via a call to disableNetwork().
     * Higher-level components should operate in offline mode.
     */
xe[xe.gs = 2] = "__PRIVATE_Offline", (Le = Me || (Me = {}))[Le.ys = 0] = "__PRIVATE_RemoteStore", 
Le[Le.bs = 1] = "__PRIVATE_SharedClientState";

/**
 * @license
 * Copyright 2020 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Immutable class that represents a "proto" byte string.
 *
 * Proto byte strings can either be Base64-encoded strings or Uint8Arrays when
 * sent on the wire. This class abstracts away this differentiation by holding
 * the proto byte string in a common class that must be converted into a string
 * before being sent as a proto.
 */
class Qe {
    constructor(t) {
        this.vs = t;
    }
    static fromBase64String(t) {
        const e = Ns.t().atob(t);
        return new Qe(e);
    }
    static fromUint8Array(t) {
        const e = We(t);
        return new Qe(e);
    }
    toBase64() {
        return Ns.t().btoa(this.vs);
    }
    toUint8Array() {
        return je(this.vs);
    }
    Se() {
        return 2 * this.vs.length;
    }
    isEqual(t) {
        return this.vs === t.vs;
    }
}

/**
 * Helper function to convert an Uint8array to a binary string.
 */
function We(t) {
    let e = "";
    for (let s = 0; s < t.length; ++s) e += String.fromCharCode(t[s]);
    return e;
}

/**
 * Helper function to convert a binary string to an Uint8Array.
 */ function je(t) {
    const e = new Uint8Array(t.length);
    for (let s = 0; s < t.length; s++) e[s] = t.charCodeAt(s);
    return e;
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** An enumeration of the different purposes we have for targets. */ Qe.Ss = new Qe(""), 
/** A regular, normal query target. */
(qe = Be || (Be = {}))[qe.Ds = 0] = "__PRIVATE_Listen", 
/**
     * The query target was used to refill a query after an existence filter mismatch.
     */
qe[qe.Cs = 1] = "__PRIVATE_ExistenceFilterMismatch", 
/** The query target was used to resolve a limbo document. */
qe[qe.ks = 2] = "__PRIVATE_LimboResolution";

/**
 * An immutable set of metadata that the local store tracks for each target.
 */
class ze {
    constructor(
    /** The target being listened to. */
    t, 
    /**
     * The target ID to which the target corresponds; Assigned by the
     * LocalStore for user listens and by the SyncEngine for limbo watches.
     */
    e, 
    /** The purpose of the target. */
    s, 
    /**
     * The sequence number of the last transaction during which this target data
     * was modified.
     */
    n, 
    /** The latest snapshot version seen for this target. */
    i = dt.MIN
    /**
     * The maximum snapshot version at which the associated view
     * contained no limbo documents.
     */ , r = dt.MIN
    /**
     * An opaque, server-assigned token that allows watching a target to be
     * resumed after disconnecting without retransmitting all the data that
     * matches the target. The resume token essentially identifies a point in
     * time from which the server should resume sending results.
     */ , o = Qe.Ss) {
        this.target = t, this.targetId = e, this.Ns = s, this.sequenceNumber = n, this.Fs = i, 
        this.lastLimboFreeSnapshotVersion = r, this.resumeToken = o;
    }
    /** Creates a new target data instance with an updated sequence number. */    $s(t) {
        return new ze(this.target, this.targetId, this.Ns, t, this.Fs, this.lastLimboFreeSnapshotVersion, this.resumeToken);
    }
    /**
     * Creates a new target data instance with an updated resume token and
     * snapshot version.
     */    xs(t, e) {
        return new ze(this.target, this.targetId, this.Ns, this.sequenceNumber, e, this.lastLimboFreeSnapshotVersion, t);
    }
    /**
     * Creates a new target data instance with an updated last limbo free
     * snapshot version number.
     */    Ms(t) {
        return new ze(this.target, this.targetId, this.Ns, this.sequenceNumber, this.Fs, t, this.resumeToken);
    }
    isEqual(t) {
        return this.targetId === t.targetId && this.Ns === t.Ns && this.sequenceNumber === t.sequenceNumber && this.Fs.isEqual(t.Fs) && this.lastLimboFreeSnapshotVersion.isEqual(t.lastLimboFreeSnapshotVersion) && this.resumeToken.isEqual(t.resumeToken) && this.target.isEqual(t.target);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class Ke {
    // TODO(b/33078163): just use simplest form of existence filter for now
    constructor(t) {
        this.count = t;
    }
    isEqual(t) {
        return t && t.count === this.count;
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Error Codes describing the different ways GRPC can fail. These are copied
 * directly from GRPC's sources here:
 *
 * https://github.com/grpc/grpc/blob/bceec94ea4fc5f0085d81235d8e1c06798dc341a/include/grpc%2B%2B/impl/codegen/status_code_enum.h
 *
 * Important! The names of these identifiers matter because the string forms
 * are used for reverse lookups from the webchannel stream. Do NOT change the
 * names of these identifiers.
 */
/**
 * Determines whether an error code represents a permanent error when received
 * in response to a non-write operation.
 *
 * See isPermanentWriteError for classifying write errors.
 */
function Ge(t) {
    switch (t) {
      case F.OK:
        return V("Treated status OK as error");

      case F.CANCELLED:
      case F.UNKNOWN:
      case F.DEADLINE_EXCEEDED:
      case F.RESOURCE_EXHAUSTED:
      case F.INTERNAL:
      case F.UNAVAILABLE:
 // Unauthenticated means something went wrong with our token and we need
        // to retry with new credentials which will happen automatically.
              case F.UNAUTHENTICATED:
        return !1;

      case F.INVALID_ARGUMENT:
      case F.NOT_FOUND:
      case F.ALREADY_EXISTS:
      case F.PERMISSION_DENIED:
      case F.FAILED_PRECONDITION:
 // Aborted might be retried in some scenarios, but that is dependant on
        // the context and should handled individually by the calling code.
        // See https://cloud.google.com/apis/design/errors.
              case F.ABORTED:
      case F.OUT_OF_RANGE:
      case F.UNIMPLEMENTED:
      case F.DATA_LOSS:
        return !0;

      default:
        return V("Unknown status code: " + t);
    }
}

/**
 * Determines whether an error code represents a permanent error when received
 * in response to a write operation.
 *
 * Write operations must be handled specially because as of b/119437764, ABORTED
 * errors on the write stream should be retried too (even though ABORTED errors
 * are not generally retryable).
 *
 * Note that during the initial handshake on the write stream an ABORTED error
 * signals that we should discard our stream token (i.e. it is permanent). This
 * means a handshake error should be classified with isPermanentError, above.
 */
/**
 * Maps an error Code from GRPC status code number, like 0, 1, or 14. These
 * are not the same as HTTP status codes.
 *
 * @returns The Code equivalent to the given GRPC status code. Fails if there
 *     is no match.
 */
function He(t) {
    if (void 0 === t) 
    // This shouldn't normally happen, but in certain error cases (like trying
    // to send invalid proto messages) we may get an error with no GRPC code.
    return P("GRPC error has no .code"), F.UNKNOWN;
    switch (t) {
      case Oe.OK:
        return F.OK;

      case Oe.CANCELLED:
        return F.CANCELLED;

      case Oe.UNKNOWN:
        return F.UNKNOWN;

      case Oe.DEADLINE_EXCEEDED:
        return F.DEADLINE_EXCEEDED;

      case Oe.RESOURCE_EXHAUSTED:
        return F.RESOURCE_EXHAUSTED;

      case Oe.INTERNAL:
        return F.INTERNAL;

      case Oe.UNAVAILABLE:
        return F.UNAVAILABLE;

      case Oe.UNAUTHENTICATED:
        return F.UNAUTHENTICATED;

      case Oe.INVALID_ARGUMENT:
        return F.INVALID_ARGUMENT;

      case Oe.NOT_FOUND:
        return F.NOT_FOUND;

      case Oe.ALREADY_EXISTS:
        return F.ALREADY_EXISTS;

      case Oe.PERMISSION_DENIED:
        return F.PERMISSION_DENIED;

      case Oe.FAILED_PRECONDITION:
        return F.FAILED_PRECONDITION;

      case Oe.ABORTED:
        return F.ABORTED;

      case Oe.OUT_OF_RANGE:
        return F.OUT_OF_RANGE;

      case Oe.UNIMPLEMENTED:
        return F.UNIMPLEMENTED;

      case Oe.DATA_LOSS:
        return F.DATA_LOSS;

      default:
        return V("Unknown status code: " + t);
    }
}

/**
 * Maps an RPC code from a Code. This is the reverse operation from
 * mapCodeFromRpcCode and should really only be used in tests.
 */ function Je(t) {
    if (void 0 === t) return Oe.OK;
    switch (t) {
      case F.OK:
        return Oe.OK;

      case F.CANCELLED:
        return Oe.CANCELLED;

      case F.UNKNOWN:
        return Oe.UNKNOWN;

      case F.DEADLINE_EXCEEDED:
        return Oe.DEADLINE_EXCEEDED;

      case F.RESOURCE_EXHAUSTED:
        return Oe.RESOURCE_EXHAUSTED;

      case F.INTERNAL:
        return Oe.INTERNAL;

      case F.UNAVAILABLE:
        return Oe.UNAVAILABLE;

      case F.UNAUTHENTICATED:
        return Oe.UNAUTHENTICATED;

      case F.INVALID_ARGUMENT:
        return Oe.INVALID_ARGUMENT;

      case F.NOT_FOUND:
        return Oe.NOT_FOUND;

      case F.ALREADY_EXISTS:
        return Oe.ALREADY_EXISTS;

      case F.PERMISSION_DENIED:
        return Oe.PERMISSION_DENIED;

      case F.FAILED_PRECONDITION:
        return Oe.FAILED_PRECONDITION;

      case F.ABORTED:
        return Oe.ABORTED;

      case F.OUT_OF_RANGE:
        return Oe.OUT_OF_RANGE;

      case F.UNIMPLEMENTED:
        return Oe.UNIMPLEMENTED;

      case F.DATA_LOSS:
        return Oe.DATA_LOSS;

      default:
        return V("Unknown status code: " + t);
    }
}

/**
 * Converts an HTTP response's error status to the equivalent error code.
 *
 * @param status An HTTP error response status ("FAILED_PRECONDITION",
 * "UNKNOWN", etc.)
 * @returns The equivalent Code. Non-matching responses are mapped to
 *     Code.UNKNOWN.
 */ (Ue = Oe || (Oe = {}))[Ue.OK = 0] = "OK", Ue[Ue.CANCELLED = 1] = "CANCELLED", 
Ue[Ue.UNKNOWN = 2] = "UNKNOWN", Ue[Ue.INVALID_ARGUMENT = 3] = "INVALID_ARGUMENT", 
Ue[Ue.DEADLINE_EXCEEDED = 4] = "DEADLINE_EXCEEDED", Ue[Ue.NOT_FOUND = 5] = "NOT_FOUND", 
Ue[Ue.ALREADY_EXISTS = 6] = "ALREADY_EXISTS", Ue[Ue.PERMISSION_DENIED = 7] = "PERMISSION_DENIED", 
Ue[Ue.UNAUTHENTICATED = 16] = "UNAUTHENTICATED", Ue[Ue.RESOURCE_EXHAUSTED = 8] = "RESOURCE_EXHAUSTED", 
Ue[Ue.FAILED_PRECONDITION = 9] = "FAILED_PRECONDITION", Ue[Ue.ABORTED = 10] = "ABORTED", 
Ue[Ue.OUT_OF_RANGE = 11] = "OUT_OF_RANGE", Ue[Ue.UNIMPLEMENTED = 12] = "UNIMPLEMENTED", 
Ue[Ue.INTERNAL = 13] = "INTERNAL", Ue[Ue.UNAVAILABLE = 14] = "UNAVAILABLE", Ue[Ue.DATA_LOSS = 15] = "DATA_LOSS";

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Ye = new Rt(It.U);

function Xe() {
    return Ye;
}

function Ze() {
    return Xe();
}

const ts = new Rt(It.U);

function es() {
    return ts;
}

const ss = new Rt(It.U);

function ns() {
    return ss;
}

const is = new pt(It.U);

function rs(...t) {
    let e = is;
    for (const s of t) e = e.add(s);
    return e;
}

const os = new pt(b);

function hs() {
    return os;
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * DocumentSet is an immutable (copy-on-write) collection that holds documents
 * in order specified by the provided comparator. We always add a document key
 * comparator on top of what is provided to guarantee document equality based on
 * the key.
 */ class as {
    /** The default ordering is by key if the comparator is omitted */
    constructor(t) {
        // We are adding document key comparator to the end as it's the only
        // guaranteed unique property of a document.
        this.U = t ? (e, s) => t(e, s) || It.U(e.key, s.key) : (t, e) => It.U(t.key, e.key), 
        this.Ls = es(), this.Bs = new Rt(this.U);
    }
    /**
     * Returns an empty copy of the existing DocumentSet, using the same
     * comparator.
     */    static qs(t) {
        return new as(t.U);
    }
    has(t) {
        return null != this.Ls.get(t);
    }
    get(t) {
        return this.Ls.get(t);
    }
    first() {
        return this.Bs.dt();
    }
    last() {
        return this.Bs.ft();
    }
    G() {
        return this.Bs.G();
    }
    /**
     * Returns the index of the provided key in the document set, or -1 if the
     * document key is not present in the set;
     */    indexOf(t) {
        const e = this.Ls.get(t);
        return e ? this.Bs.indexOf(e) : -1;
    }
    get size() {
        return this.Bs.size;
    }
    /** Iterates documents in order defined by "comparator" */    forEach(t) {
        this.Bs.Tt((e, s) => (t(e), !1));
    }
    /** Inserts or updates a document with the same key */    add(t) {
        // First remove the element if we have it.
        const e = this.delete(t.key);
        return e.copy(e.Ls.lt(t.key, t), e.Bs.lt(t, null));
    }
    /** Deletes a document with a given key */    delete(t) {
        const e = this.get(t);
        return e ? this.copy(this.Ls.remove(t), this.Bs.remove(e)) : this;
    }
    isEqual(t) {
        if (!(t instanceof as)) return !1;
        if (this.size !== t.size) return !1;
        const e = this.Bs.Et(), s = t.Bs.Et();
        for (;e.gt(); ) {
            const t = e.Vt().key, n = s.Vt().key;
            if (!t.isEqual(n)) return !1;
        }
        return !0;
    }
    toString() {
        const t = [];
        return this.forEach(e => {
            t.push(e.toString());
        }), 0 === t.length ? "DocumentSet ()" : "DocumentSet (\n  " + t.join("  \n") + "\n)";
    }
    copy(t, e) {
        const s = new as;
        return s.U = this.U, s.Ls = t, s.Bs = e, s;
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ var us, cs, ls, _s, ds, fs;

(cs = us || (us = {}))[cs.Os = 0] = "__PRIVATE_Added", cs[cs.Us = 1] = "__PRIVATE_Removed", 
cs[cs.Qs = 2] = "__PRIVATE_Modified", cs[cs.Ws = 3] = "__PRIVATE_Metadata", (_s = ls || (ls = {}))[_s.js = 0] = "__PRIVATE_Local", 
_s[_s.zs = 1] = "__PRIVATE_Synced";

/**
 * DocumentChangeSet keeps track of a set of changes to docs in a query, merging
 * duplicate events for the same doc.
 */
class ms {
    constructor() {
        this.Ks = new Rt(It.U);
    }
    track(t) {
        const e = t.doc.key, s = this.Ks.get(e);
        s ? 
        // Merge the new change with the existing change.
        t.type !== us.Os && s.type === us.Ws ? this.Ks = this.Ks.lt(e, t) : t.type === us.Ws && s.type !== us.Us ? this.Ks = this.Ks.lt(e, {
            type: s.type,
            doc: t.doc
        }) : t.type === us.Qs && s.type === us.Qs ? this.Ks = this.Ks.lt(e, {
            type: us.Qs,
            doc: t.doc
        }) : t.type === us.Qs && s.type === us.Os ? this.Ks = this.Ks.lt(e, {
            type: us.Os,
            doc: t.doc
        }) : t.type === us.Us && s.type === us.Os ? this.Ks = this.Ks.remove(e) : t.type === us.Us && s.type === us.Qs ? this.Ks = this.Ks.lt(e, {
            type: us.Us,
            doc: s.doc
        }) : t.type === us.Os && s.type === us.Us ? this.Ks = this.Ks.lt(e, {
            type: us.Qs,
            doc: t.doc
        }) : 
        // This includes these cases, which don't make sense:
        // Added->Added
        // Removed->Removed
        // Modified->Added
        // Removed->Modified
        // Metadata->Added
        // Removed->Metadata
        V("unsupported combination of changes: " + JSON.stringify(t) + " after " + JSON.stringify(s)) : this.Ks = this.Ks.lt(e, t);
    }
    Gs() {
        const t = [];
        return this.Ks.Tt((e, s) => {
            t.push(s);
        }), t;
    }
}

class Ts {
    constructor(t, e, s, n, i, r, o, h) {
        this.query = t, this.docs = e, this.Hs = s, this.docChanges = n, this.Js = i, this.fromCache = r, 
        this.Ys = o, this.Xs = h;
    }
    /** Returns a view snapshot as if all documents in the snapshot were added. */    static Zs(t, e, s, n) {
        const i = [];
        return e.forEach(t => {
            i.push({
                type: us.Os,
                doc: t
            });
        }), new Ts(t, e, as.qs(e), i, s, n, 
        /* syncStateChanged= */ !0, 
        /* excludesMetadataChanges= */ !1);
    }
    get hasPendingWrites() {
        return !this.Js.G();
    }
    isEqual(t) {
        if (!(this.fromCache === t.fromCache && this.Ys === t.Ys && this.Js.isEqual(t.Js) && this.query.isEqual(t.query) && this.docs.isEqual(t.docs) && this.Hs.isEqual(t.Hs))) return !1;
        const e = this.docChanges, s = t.docChanges;
        if (e.length !== s.length) return !1;
        for (let t = 0; t < e.length; t++) if (e[t].type !== s[t].type || !e[t].doc.isEqual(s[t].doc)) return !1;
        return !0;
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * An event from the RemoteStore. It is split into targetChanges (changes to the
 * state or the set of documents in our watched targets) and documentUpdates
 * (changes to the actual documents).
 */ class ws {
    constructor(
    /**
     * The snapshot version this event brings us up to, or MIN if not set.
     */
    t, 
    /**
     * A map from target to changes to the target. See TargetChange.
     */
    e, 
    /**
     * A set of targets that is known to be inconsistent. Listens for these
     * targets should be re-established without resume tokens.
     */
    s, 
    /**
     * A set of which documents have changed or been deleted, along with the
     * doc's new values (if not deleted).
     */
    n, 
    /**
     * A set of which document updates are due only to limbo resolution targets.
     */
    i) {
        this.Fs = t, this.tn = e, this.en = s, this.sn = n, this.nn = i;
    }
    /**
     * HACK: Views require RemoteEvents in order to determine whether the view is
     * CURRENT, but secondary tabs don't receive remote events. So this method is
     * used to create a synthesized RemoteEvent that can be used to apply a
     * CURRENT status change to a View, for queries executed in a different tab.
     */
    // PORTING NOTE: Multi-tab only
    static in(t, e) {
        const s = {
            [t]: Es.rn(t, e)
        };
        return new ws(dt.MIN, s, hs(), Xe(), rs());
    }
}

/**
 * A TargetChange specifies the set of changes for a specific target as part of
 * a RemoteEvent. These changes track which documents are added, modified or
 * removed, as well as the target's resume token and whether the target is
 * marked CURRENT.
 * The actual changes *to* documents are not part of the TargetChange since
 * documents may be part of multiple targets.
 */ class Es {
    constructor(
    /**
     * An opaque, server-assigned token that allows watching a query to be resumed
     * after disconnecting without retransmitting all the data that matches the
     * query. The resume token essentially identifies a point in time from which
     * the server should resume sending results.
     */
    t, 
    /**
     * The "current" (synced) status of this target. Note that "current"
     * has special meaning in the RPC protocol that implies that a target is
     * both up-to-date and consistent with the rest of the watch stream.
     */
    e, 
    /**
     * The set of documents that were newly assigned to this target as part of
     * this remote event.
     */
    s, 
    /**
     * The set of documents that were already assigned to this target but received
     * an update during this remote event.
     */
    n, 
    /**
     * The set of documents that were removed from this target as part of this
     * remote event.
     */
    i) {
        this.resumeToken = t, this.on = e, this.hn = s, this.an = n, this.un = i;
    }
    /**
     * This method is used to create a synthesized TargetChanges that can be used to
     * apply a CURRENT status change to a View (for queries executed in a different
     * tab) or for new queries (to raise snapshots with correct CURRENT status).
     */    static rn(t, e) {
        return new Es(Qe.Ss, e, rs(), rs(), rs());
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Represents a changed document and a list of target ids to which this change
 * applies.
 *
 * If document has been deleted NoDocument will be provided.
 */ class Is {
    constructor(
    /** The new document applies to all of these targets. */
    t, 
    /** The new document is removed from all of these targets. */
    e, 
    /** The key of the document for this change. */
    s, 
    /**
     * The new document or NoDocument if it was deleted. Is null if the
     * document went out of view without the server sending a new document.
     */
    n) {
        this.cn = t, this.removedTargetIds = e, this.key = s, this.ln = n;
    }
}

class Rs {
    constructor(t, e) {
        this.targetId = t, this._n = e;
    }
}

(fs = ds || (ds = {}))[fs.dn = 0] = "__PRIVATE_NoChange", fs[fs.Os = 1] = "__PRIVATE_Added", 
fs[fs.Us = 2] = "__PRIVATE_Removed", fs[fs.fn = 3] = "__PRIVATE_Current", fs[fs.mn = 4] = "__PRIVATE_Reset";

class As {
    constructor(
    /** What kind of change occurred to the watch target. */
    t, 
    /** The target IDs that were added/removed/set. */
    e, 
    /**
     * An opaque, server-assigned token that allows watching a target to be
     * resumed after disconnecting without retransmitting all the data that
     * matches the target. The resume token essentially identifies a point in
     * time from which the server should resume sending results.
     */
    s = Qe.Ss
    /** An RPC error indicating why the watch failed. */ , n = null) {
        this.state = t, this.targetIds = e, this.resumeToken = s, this.cause = n;
    }
}

/** Tracks the internal state of a Watch target. */ class Ps {
    constructor() {
        /**
         * The number of pending responses (adds or removes) that we are waiting on.
         * We only consider targets active that have no pending responses.
         */
        this.Tn = 0, 
        /**
         * Keeps track of the document changes since the last raised snapshot.
         *
         * These changes are continuously updated as we receive document updates and
         * always reflect the current set of changes against the last issued snapshot.
         */
        this.wn = ys(), 
        /** See public getters for explanations of these fields. */
        this.En = Qe.Ss, this.In = !1, 
        /**
         * Whether this target state should be included in the next snapshot. We
         * initialize to true so that newly-added targets are included in the next
         * RemoteEvent.
         */
        this.Rn = !0;
    }
    /**
     * Whether this target has been marked 'current'.
     *
     * 'Current' has special meaning in the RPC protocol: It implies that the
     * Watch backend has sent us all changes up to the point at which the target
     * was added and that the target is consistent with the rest of the watch
     * stream.
     */    get on() {
        return this.In;
    }
    /** The last resume token sent to us for this target. */    get resumeToken() {
        return this.En;
    }
    /** Whether this target has pending target adds or target removes. */    get An() {
        return 0 !== this.Tn;
    }
    /** Whether we have modified any state that should trigger a snapshot. */    get Pn() {
        return this.Rn;
    }
    /**
     * Applies the resume token to the TargetChange, but only when it has a new
     * value. Empty resumeTokens are discarded.
     */    pn(t) {
        t.Se() > 0 && (this.Rn = !0, this.En = t);
    }
    /**
     * Creates a target change from the current set of changes.
     *
     * To reset the document changes after raising this snapshot, call
     * `clearPendingChanges()`.
     */    Vn() {
        let t = rs(), e = rs(), s = rs();
        return this.wn.forEach((n, i) => {
            switch (i) {
              case us.Os:
                t = t.add(n);
                break;

              case us.Qs:
                e = e.add(n);
                break;

              case us.Us:
                s = s.add(n);
                break;

              default:
                V("Encountered invalid change type: " + i);
            }
        }), new Es(this.En, this.In, t, e, s);
    }
    /**
     * Resets the document changes and sets `hasPendingChanges` to false.
     */    gn() {
        this.Rn = !1, this.wn = ys();
    }
    yn(t, e) {
        this.Rn = !0, this.wn = this.wn.lt(t, e);
    }
    bn(t) {
        this.Rn = !0, this.wn = this.wn.remove(t);
    }
    vn() {
        this.Tn += 1;
    }
    Sn() {
        this.Tn -= 1;
    }
    Dn() {
        this.Rn = !0, this.In = !0;
    }
}

const ps = "WatchChangeAggregator";

/**
 * A helper class to accumulate watch changes into a RemoteEvent.
 */ class Vs {
    constructor(t) {
        this.Cn = t, 
        /** The internal state of all tracked targets. */
        this.kn = {}, 
        /** Keeps track of the documents to update since the last raised snapshot. */
        this.Nn = Xe(), 
        /** A mapping of document keys to their set of target IDs. */
        this.Fn = gs(), 
        /**
         * A list of targets with existence filter mismatches. These targets are
         * known to be inconsistent and their listens needs to be re-established by
         * RemoteStore.
         */
        this.$n = new pt(b);
    }
    /**
     * Processes and adds the DocumentWatchChange to the current set of changes.
     */    xn(t) {
        for (const e of t.cn) t.ln instanceof ue ? this.Mn(e, t.ln) : t.ln instanceof ce && this.Ln(e, t.key, t.ln);
        for (const e of t.removedTargetIds) this.Ln(e, t.key, t.ln);
    }
    /** Processes and adds the WatchTargetChange to the current set of changes. */    Bn(t) {
        this.qn(t, e => {
            const s = this.On(e);
            switch (t.state) {
              case ds.dn:
                this.Un(e) && s.pn(t.resumeToken);
                break;

              case ds.Os:
                // We need to decrement the number of pending acks needed from watch
                // for this targetId.
                s.Sn(), s.An || 
                // We have a freshly added target, so we need to reset any state
                // that we had previously. This can happen e.g. when remove and add
                // back a target for existence filter mismatches.
                s.gn(), s.pn(t.resumeToken);
                break;

              case ds.Us:
                // We need to keep track of removed targets to we can post-filter and
                // remove any target changes.
                // We need to decrement the number of pending acks needed from watch
                // for this targetId.
                s.Sn(), s.An || this.removeTarget(e), g(!t.cause, "WatchChangeAggregator does not handle errored targets");
                break;

              case ds.fn:
                this.Un(e) && (s.Dn(), s.pn(t.resumeToken));
                break;

              case ds.mn:
                this.Un(e) && (
                // Reset the target and synthesizes removes for all existing
                // documents. The backend will re-add any documents that still
                // match the target before it sends the next global snapshot.
                this.Qn(e), s.pn(t.resumeToken));
                break;

              default:
                V("Unknown target watch change state: " + t.state);
            }
        });
    }
    /**
     * Iterates over all targetIds that the watch change applies to: either the
     * targetIds explicitly listed in the change or the targetIds of all currently
     * active targets.
     */    qn(t, e) {
        t.targetIds.length > 0 ? t.targetIds.forEach(e) : Q(this.kn, e);
    }
    /**
     * Handles existence filters and synthesizes deletes for filter mismatches.
     * Targets that are invalidated by filter mismatches are added to
     * `pendingTargetResets`.
     */    Wn(t) {
        const e = t.targetId, s = t._n.count, n = this.jn(e);
        if (n) {
            const t = n.target;
            if (t.Qe()) if (0 === s) {
                // The existence filter told us the document does not exist. We deduce
                // that this document does not exist and apply a deleted document to
                // our updates. Without applying this deleted document there might be
                // another query that will raise this document as part of a snapshot
                // until it is resolved, essentially exposing inconsistency between
                // queries.
                const s = new It(t.path);
                this.Ln(e, s, new ce(s, dt.B()));
            } else g(1 === s, "Single document existence filter with count: " + s); else {
                this.zn(e) !== s && (
                // Existence filter mismatch: We reset the mapping and raise a new
                // snapshot with `isFromCache:true`.
                this.Qn(e), this.$n = this.$n.add(e));
            }
        }
    }
    /**
     * Converts the currently accumulated state into a remote event at the
     * provided snapshot version. Resets the accumulated changes before returning.
     */    Kn(t) {
        const e = {};
        Q(this.kn, (s, n) => {
            const i = this.jn(s);
            if (i) {
                if (n.on && i.target.Qe()) {
                    // Document queries for document that don't exist can produce an empty
                    // result set. To update our local cache, we synthesize a document
                    // delete if we have not previously received the document. This
                    // resolves the limbo state of the document, removing it from
                    // limboDocumentRefs.
                    //
                    // TODO(dimond): Ideally we would have an explicit lookup target
                    // instead resulting in an explicit delete message and we could
                    // remove this special logic.
                    const e = new It(i.target.path);
                    null !== this.Nn.get(e) || this.Gn(s, e) || this.Ln(s, e, new ce(e, t));
                }
                n.Pn && (e[s] = n.Vn(), n.gn());
            }
        });
        let s = rs();
        // We extract the set of limbo-only document updates as the GC logic
        // special-cases documents that do not appear in the target cache.
        //
        // TODO(gsoltis): Expand on this comment once GC is available in the JS
        // client.
                this.Fn.forEach((t, e) => {
            let n = !0;
            e.Bt(t => {
                const e = this.jn(t);
                return !e || e.Ns === Be.ks || (n = !1, !1);
            }), n && (s = s.add(t));
        });
        const n = new ws(t, e, this.$n, this.Nn, s);
        return this.Nn = Xe(), this.Fn = gs(), this.$n = new pt(b), n;
    }
    /**
     * Adds the provided document to the internal list of document updates and
     * its document key to the given target's mapping.
     */
    // Visible for testing.
    Mn(t, e) {
        if (!this.Un(t)) return;
        const s = this.Gn(t, e.key) ? us.Qs : us.Os;
        this.On(t).yn(e.key, s), this.Nn = this.Nn.lt(e.key, e), this.Fn = this.Fn.lt(e.key, this.Hn(e.key).add(t));
    }
    /**
     * Removes the provided document from the target mapping. If the
     * document no longer matches the target, but the document's state is still
     * known (e.g. we know that the document was deleted or we received the change
     * that caused the filter mismatch), the new document can be provided
     * to update the remote document cache.
     */
    // Visible for testing.
    Ln(t, e, s) {
        if (!this.Un(t)) return;
        const n = this.On(t);
        this.Gn(t, e) ? n.yn(e, us.Us) : 
        // The document may have entered and left the target before we raised a
        // snapshot, so we can just ignore the change.
        n.bn(e), this.Fn = this.Fn.lt(e, this.Hn(e).delete(t)), s && (this.Nn = this.Nn.lt(e, s));
    }
    removeTarget(t) {
        delete this.kn[t];
    }
    /**
     * Returns the current count of documents in the target. This includes both
     * the number of documents that the LocalStore considers to be part of the
     * target as well as any accumulated changes.
     */    zn(t) {
        const e = this.On(t).Vn();
        return this.Cn.Jn(t).size + e.hn.size - e.un.size;
    }
    /**
     * Increment the number of acks needed from watch before we can consider the
     * server to be 'in-sync' with the client's active targets.
     */    vn(t) {
        this.On(t).vn();
    }
    On(t) {
        return this.kn[t] || (this.kn[t] = new Ps), this.kn[t];
    }
    Hn(t) {
        let e = this.Fn.get(t);
        return e || (e = new pt(b), this.Fn = this.Fn.lt(t, e)), e;
    }
    /**
     * Verifies that the user is still interested in this target (by calling
     * `getTargetDataForTarget()`) and that we are not waiting for pending ADDs
     * from watch.
     */    Un(t) {
        const e = null !== this.jn(t);
        return e || A(ps, "Detected inactive target", t), e;
    }
    /**
     * Returns the TargetData for an active target (i.e. a target that the user
     * is still interested in that has no outstanding target change requests).
     */    jn(t) {
        const e = this.kn[t];
        return e && e.An ? null : this.Cn.Yn(t);
    }
    /**
     * Resets the state of a Watch target to its initial state (e.g. sets
     * 'current' to false, clears the resume token and removes its target mapping
     * from all documents).
     */    Qn(t) {
        g(!this.kn[t].An, "Should only reset active targets"), this.kn[t] = new Ps, this.Cn.Jn(t).forEach(e => {
            this.Ln(t, e, /*updatedDocument=*/ null);
        });
    }
    /**
     * Returns whether the LocalStore considers the document to be part of the
     * specified target.
     */    Gn(t, e) {
        return this.Cn.Jn(t).has(e);
    }
}

function gs() {
    return new Rt(It.U);
}

function ys() {
    return new Rt(It.U);
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const bs = (() => {
    const t = {};
    return t[De.ASCENDING.name] = "ASCENDING", t[De.DESCENDING.name] = "DESCENDING", 
    t;
})(), vs = (() => {
    const t = {};
    return t[pe.LESS_THAN.name] = "LESS_THAN", t[pe.LESS_THAN_OR_EQUAL.name] = "LESS_THAN_OR_EQUAL", 
    t[pe.GREATER_THAN.name] = "GREATER_THAN", t[pe.GREATER_THAN_OR_EQUAL.name] = "GREATER_THAN_OR_EQUAL", 
    t[pe.EQUAL.name] = "EQUAL", t[pe.ARRAY_CONTAINS.name] = "ARRAY_CONTAINS", t[pe.IN.name] = "IN", 
    t[pe.ARRAY_CONTAINS_ANY.name] = "ARRAY_CONTAINS_ANY", t;
})(), Ss = new RegExp(/^\d{4}-\d\d-\d\dT\d\d:\d\d:\d\d(?:\.(\d+))?Z$/);

function Ds(t, e) {
    g(!Te(t), e + " is missing");
}

function Cs(t) {
    // TODO(bjornick): Handle int64 greater than 53 bits.
    return "number" == typeof t ? t : "string" == typeof t ? Number(t) : V("can't parse " + t);
}

/**
 * Generates JsonObject values for the Datastore API suitable for sending to
 * either GRPC stub methods or via the JSON/HTTP REST API.
 * TODO(klimt): We can remove the databaseId argument if we keep the full
 * resource name in documents.
 */ class ks {
    constructor(t, e) {
        this.o = t, this.options = e;
    }
    Xn(t) {
        const e = void 0 === t.code ? F.UNKNOWN : He(t.code);
        return new $(e, t.message || "");
    }
    /**
     * Returns a value for a number (or null) that's appropriate to put into
     * a google.protobuf.Int32Value proto.
     * DO NOT USE THIS FOR ANYTHING ELSE.
     * This method cheats. It's typed as returning "number" because that's what
     * our generated proto interfaces say Int32Value must be. But GRPC actually
     * expects a { value: <number> } struct.
     */    Zn(t) {
        return this.options.ti || Te(t) ? t : {
            value: t
        };
    }
    /**
     * Returns a number (or null) from a google.protobuf.Int32Value proto.
     * DO NOT USE THIS FOR ANYTHING ELSE.
     * This method cheats. It's typed as accepting "number" because that's what
     * our generated proto interfaces say Int32Value must be, but it actually
     * accepts { value: number } to match our serialization in toInt32Value().
     */    ei(t) {
        let e;
        return Te(
        // Use any because we need to match generated Proto types.
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        e = "object" == typeof t ? t.value : t) ? null : e;
    }
    /**
     * Returns a value for a Date that's appropriate to put into a proto.
     * DO NOT USE THIS FOR ANYTHING ELSE.
     * This method cheats. It's typed as returning "string" because that's what
     * our generated proto interfaces say dates must be. But it's easier and safer
     * to actually return a Timestamp proto.
     */    O(t) {
        if (this.options.ti) {
            return `${new Date(1e3 * t.seconds).toISOString().replace(/\.\d*/, "").replace("Z", "")}.${("000000000" + t.nanoseconds).slice(-9)}Z`;
        }
        return {
            seconds: "" + t.seconds,
            nanos: t.nanoseconds
        };
    }
    L(t) {
        // The json interface (for the browser) will return an iso timestamp string,
        // while the proto js library (for node) will return a
        // google.protobuf.Timestamp instance.
        if ("string" == typeof t) 
        // TODO(b/37282237): Use strings for Proto3 timestamps
        // assert(this.options.useProto3Json,
        //   'The timestamp string format requires Proto3.');
        return this.si(t);
        {
            g(!!t, "Cannot deserialize null or undefined timestamp.");
            // TODO(b/37282237): Use strings for Proto3 timestamps
            // assert(!this.options.useProto3Json,
            //   'The timestamp instance format requires Proto JS.');
            const e = Cs(t.seconds || "0"), s = t.nanos || 0;
            return new _t(e, s);
        }
    }
    si(t) {
        // The date string can have higher precision (nanos) than the Date class
        // (millis), so we do some custom parsing here.
        // Parse the nanos right out of the string.
        let e = 0;
        const s = Ss.exec(t);
        if (g(!!s, "invalid timestamp: " + t), s[1]) {
            // Pad the fraction out to 9 digits (nanos).
            let t = s[1];
            t = (t + "000000000").substr(0, 9), e = Number(t);
        }
        // Parse the date to get the seconds.
                const n = new Date(t), i = Math.floor(n.getTime() / 1e3);
        return new _t(i, e);
    }
    /**
     * Returns a value for bytes that's appropriate to put in a proto.
     * DO NOT USE THIS FOR ANYTHING ELSE.
     * This method cheats. It's typed as returning "string" because that's what
     * our generated proto interfaces say bytes must be. But it should return
     * an Uint8Array in Node.
     *
     * Visible for testing.
     */    ni(t) {
        return this.options.ti ? t.toBase64() : t.toUint8Array();
    }
    /**
     * Returns a ByteString based on the proto string value.
     */    ii(t) {
        return this.options.ti ? (g(void 0 === t || "string" == typeof t, "value must be undefined or a string when using proto3 Json"), 
        Qe.fromBase64String(t || "")) : (g(void 0 === t || t instanceof Uint8Array, "value must be undefined or Uint8Array"), 
        Qe.fromUint8Array(t || new Uint8Array));
    }
    /**
     * Parse the blob from the protos into the internal Blob class. Note that the
     * typings assume all blobs are strings, but they are actually Uint8Arrays
     * on Node.
     */    ri(t) {
        return "string" == typeof t ? (g(this.options.ti, "Expected bytes to be passed in as Uint8Array, but got a string instead."), 
        Ms.fromBase64String(t)) : (g(!this.options.ti, "Expected bytes to be passed in as Uint8Array, but got a string instead."), 
        Ms.fromUint8Array(t));
    }
    toVersion(t) {
        return this.O(t.O());
    }
    fromVersion(t) {
        return g(!!t, "Trying to deserialize version that isn't set"), dt.L(this.L(t));
    }
    oi(t, e) {
        return this.hi(t).child("documents").child(e).tt();
    }
    ai(t) {
        const e = Tt.et(t);
        return g(this.ui(e), "Tried to deserialize invalid key " + e.toString()), e;
    }
    ci(t) {
        return this.oi(this.o, t.path);
    }
    li(t) {
        const e = this.ai(t);
        return g(e.get(1) === this.o.projectId, "Tried to deserialize key from different project: " + e.get(1) + " vs " + this.o.projectId), 
        g(!e.get(3) && !this.o.database || e.get(3) === this.o.database, "Tried to deserialize key from different database: " + e.get(3) + " vs " + this.o.database), 
        new It(this._i(e));
    }
    di(t) {
        return this.oi(this.o, t);
    }
    fi(t) {
        const e = this.ai(t);
        // In v1beta1 queries for collections at the root did not have a trailing
        // "/documents". In v1 all resource paths contain "/documents". Preserve the
        // ability to read the v1beta1 form for compatibility with queries persisted
        // in the local target cache.
                return 4 === e.length ? Tt.st : this._i(e);
    }
    get mi() {
        return new Tt([ "projects", this.o.projectId, "databases", this.o.database ]).tt();
    }
    hi(t) {
        return new Tt([ "projects", t.projectId, "databases", t.database ]);
    }
    _i(t) {
        return g(t.length > 4 && "documents" === t.get(4), "tried to deserialize invalid key " + t.toString()), 
        t.j(5);
    }
    ui(t) {
        // Resource names have at least 4 components (project ID, database ID)
        return t.length >= 4 && "projects" === t.get(0) && "databases" === t.get(2);
    }
    Ti(t) {
        if (t instanceof Gt) return {
            nullValue: "NULL_VALUE"
        };
        if (t instanceof Ht) return {
            booleanValue: t.value()
        };
        if (t instanceof Xt) return {
            integerValue: "" + t.value()
        };
        if (t instanceof Zt) {
            const e = t.value();
            if (this.options.ti) {
                // Proto 3 let's us encode NaN and Infinity as string values as
                // expected by the backend. This is currently not checked by our unit
                // tests because they rely on protobuf.js.
                if (isNaN(e)) return {
                    doubleValue: "NaN"
                };
                if (e === 1 / 0) return {
                    doubleValue: "Infinity"
                };
                if (e === -1 / 0) return {
                    doubleValue: "-Infinity"
                };
            }
            return {
                doubleValue: t.value()
            };
        }
        return t instanceof te ? {
            stringValue: t.value()
        } : t instanceof oe ? {
            mapValue: this.wi(t)
        } : t instanceof he ? {
            arrayValue: this.Ei(t)
        } : t instanceof ee ? {
            timestampValue: this.O(t.Kt)
        } : t instanceof re ? {
            geoPointValue: {
                latitude: t.value().latitude,
                longitude: t.value().longitude
            }
        } : t instanceof ne ? {
            bytesValue: this.ni(t.value())
        } : t instanceof ie ? {
            referenceValue: this.oi(t.o, t.key.path)
        } : V("Unknown FieldValue " + JSON.stringify(t));
    }
    Ii(t) {
        if ("nullValue" in t) return Gt.De;
        if ("booleanValue" in t) return Ht.of(t.booleanValue);
        if ("integerValue" in t) return new Xt(Cs(t.integerValue));
        if ("doubleValue" in t) {
            if (this.options.ti) {
                // Proto 3 uses the string values 'NaN' and 'Infinity'.
                if ("NaN" === t.doubleValue) return Zt.Ne;
                if ("Infinity" === t.doubleValue) return Zt.POSITIVE_INFINITY;
                if ("-Infinity" === t.doubleValue) return Zt.NEGATIVE_INFINITY;
            }
            return new Zt(t.doubleValue);
        }
        if ("stringValue" in t) return new te(t.stringValue);
        if ("mapValue" in t) return this.Ri(t.mapValue.fields || {});
        if ("arrayValue" in t) {
            // "values" is not present if the array is empty
            Ds(t.arrayValue, "arrayValue");
            const e = t.arrayValue.values || [];
            return new he(e.map(t => this.Ii(t)));
        }
        if ("timestampValue" in t) return Ds(t.timestampValue, "timestampValue"), new ee(this.L(t.timestampValue));
        if ("geoPointValue" in t) {
            Ds(t.geoPointValue, "geoPointValue");
            const e = t.geoPointValue.latitude || 0, s = t.geoPointValue.longitude || 0;
            return new re(new lt(e, s));
        }
        if ("bytesValue" in t) {
            Ds(t.bytesValue, "bytesValue");
            const e = this.ri(t.bytesValue);
            return new ne(e);
        }
        if ("referenceValue" in t) {
            Ds(t.referenceValue, "referenceValue");
            const e = this.ai(t.referenceValue), s = new k(e.get(1), e.get(3)), n = new It(this._i(e));
            return new ie(s, n);
        }
        return V("Unknown Value proto " + JSON.stringify(t));
    }
    /** Creates an api.Document from key and fields (but no create/update time) */    Ai(t, e) {
        return {
            name: this.ci(t),
            fields: this.Pi(e)
        };
    }
    pi(t) {
        return g(!t.ie, "Can't serialize documents with mutations."), {
            name: this.ci(t.key),
            fields: this.Pi(t.data()),
            updateTime: this.O(t.version.O())
        };
    }
    Vi(t, e) {
        const s = this.li(t.name), n = this.fromVersion(t.updateTime);
        return new ue(s, n, {
            hasCommittedMutations: !!e
        }, void 0, t, t => this.Ii(t));
    }
    Pi(t) {
        const e = {};
        return t.forEach((t, s) => {
            e[t] = this.Ti(s);
        }), e;
    }
    Ri(t) {
        // Proto map<string, Value> gets mapped to Object, so cast it.
        const e = t;
        let s = oe.EMPTY;
        return W(e, (t, e) => {
            s = s.set(new Et([ t ]), this.Ii(e));
        }), s;
    }
    wi(t) {
        return {
            fields: this.Pi(t)
        };
    }
    Ei(t) {
        const e = [];
        return t.forEach(t => {
            e.push(this.Ti(t));
        }), {
            values: e
        };
    }
    gi(t) {
        g(!!t.found, "Tried to deserialize a found document from a missing document."), 
        Ds(t.found.name, "doc.found.name"), Ds(t.found.updateTime, "doc.found.updateTime");
        const e = this.li(t.found.name), s = this.fromVersion(t.found.updateTime);
        return new ue(e, s, {}, void 0, t.found, t => this.Ii(t));
    }
    yi(t) {
        g(!!t.missing, "Tried to deserialize a missing document from a found document."), 
        g(!!t.readTime, "Tried to deserialize a missing document without a read time.");
        const e = this.li(t.missing), s = this.fromVersion(t.readTime);
        return new ce(e, s);
    }
    bi(t) {
        return "found" in t ? this.gi(t) : "missing" in t ? this.yi(t) : V("invalid batch get response: " + JSON.stringify(t));
    }
    vi(t) {
        switch (t) {
          case ds.Os:
            return "ADD";

          case ds.fn:
            return "CURRENT";

          case ds.dn:
            return "NO_CHANGE";

          case ds.Us:
            return "REMOVE";

          case ds.mn:
            return "RESET";

          default:
            return V("Unknown WatchTargetChangeState: " + t);
        }
    }
    Si(t) {
        if (t instanceof Rs) return {
            filter: {
                count: t._n.count,
                targetId: t.targetId
            }
        };
        if (t instanceof Is) {
            if (t.ln instanceof ue) {
                const e = t.ln;
                return {
                    documentChange: {
                        document: {
                            name: this.ci(e.key),
                            fields: this.Pi(e.data()),
                            updateTime: this.toVersion(e.version)
                        },
                        targetIds: t.cn,
                        removedTargetIds: t.removedTargetIds
                    }
                };
            }
            if (t.ln instanceof ce) {
                const e = t.ln;
                return {
                    documentDelete: {
                        document: this.ci(e.key),
                        readTime: this.toVersion(e.version),
                        removedTargetIds: t.removedTargetIds
                    }
                };
            }
            if (null === t.ln) return {
                documentRemove: {
                    document: this.ci(t.key),
                    removedTargetIds: t.removedTargetIds
                }
            };
        }
        if (t instanceof As) {
            let e = void 0;
            return t.cause && (e = {
                code: Je(t.cause.code),
                message: t.cause.message
            }), {
                targetChange: {
                    targetChangeType: this.vi(t.state),
                    targetIds: t.targetIds,
                    resumeToken: this.ni(t.resumeToken),
                    cause: e
                }
            };
        }
        return V("Unrecognized watch change: " + JSON.stringify(t));
    }
    Di(t) {
        let e;
        if ("targetChange" in t) {
            Ds(t.targetChange, "targetChange");
            // proto3 default value is unset in JSON (undefined), so use 'NO_CHANGE'
            // if unset
            const s = this.Ci(t.targetChange.targetChangeType || "NO_CHANGE"), n = t.targetChange.targetIds || [], i = this.ii(t.targetChange.resumeToken), r = t.targetChange.cause, o = r && this.Xn(r);
            e = new As(s, n, i, o || null);
        } else if ("documentChange" in t) {
            Ds(t.documentChange, "documentChange");
            const s = t.documentChange;
            Ds(s.document, "documentChange.name"), Ds(s.document.name, "documentChange.document.name"), 
            Ds(s.document.updateTime, "documentChange.document.updateTime");
            const n = this.li(s.document.name), i = this.fromVersion(s.document.updateTime), r = new ue(n, i, {}, void 0, s.document, t => this.Ii(t)), o = s.targetIds || [], h = s.removedTargetIds || [];
            e = new Is(o, h, r.key, r);
        } else if ("documentDelete" in t) {
            Ds(t.documentDelete, "documentDelete");
            const s = t.documentDelete;
            Ds(s.document, "documentDelete.document");
            const n = this.li(s.document), i = s.readTime ? this.fromVersion(s.readTime) : dt.B(), r = new ce(n, i), o = s.removedTargetIds || [];
            e = new Is([], o, r.key, r);
        } else if ("documentRemove" in t) {
            Ds(t.documentRemove, "documentRemove");
            const s = t.documentRemove;
            Ds(s.document, "documentRemove");
            const n = this.li(s.document), i = s.removedTargetIds || [];
            e = new Is([], i, n, null);
        } else {
            if (!("filter" in t)) return V("Unknown change type " + JSON.stringify(t));
            {
                // TODO(dimond): implement existence filter parsing with strategy.
                Ds(t.filter, "filter");
                const s = t.filter;
                Ds(s.targetId, "filter.targetId");
                const n = s.count || 0, i = new Ke(n), r = s.targetId;
                e = new Rs(r, i);
            }
        }
        return e;
    }
    Ci(t) {
        return "NO_CHANGE" === t ? ds.dn : "ADD" === t ? ds.Os : "REMOVE" === t ? ds.Us : "CURRENT" === t ? ds.fn : "RESET" === t ? ds.mn : V("Got unexpected TargetChange.state: " + t);
    }
    ki(t) {
        // We have only reached a consistent snapshot for the entire stream if there
        // is a read_time set and it applies to all targets (i.e. the list of
        // targets is empty). The backend is guaranteed to send such responses.
        if (!("targetChange" in t)) return dt.MIN;
        const e = t.targetChange;
        return e.targetIds && e.targetIds.length ? dt.MIN : e.readTime ? this.fromVersion(e.readTime) : dt.MIN;
    }
    Ni(t) {
        let e;
        if (t instanceof Ot) e = {
            update: this.Ai(t.key, t.value)
        }; else if (t instanceof Wt) e = {
            delete: this.ci(t.key)
        }; else if (t instanceof Ut) e = {
            update: this.Ai(t.key, t.data),
            updateMask: this.Fi(t.oe)
        }; else if (t instanceof Qt) e = {
            transform: {
                document: this.ci(t.key),
                fieldTransforms: t.fieldTransforms.map(t => this.$i(t))
            }
        }; else {
            if (!(t instanceof jt)) return V("Unknown mutation type " + t.type);
            e = {
                verify: this.ci(t.key)
            };
        }
        return t.ne.Zt || (e.currentDocument = this.xi(t.ne)), e;
    }
    Mi(t) {
        const e = t.currentDocument ? this.Li(t.currentDocument) : Bt.NONE;
        if (t.update) {
            Ds(t.update.name, "name");
            const s = this.li(t.update.name), n = this.Ri(t.update.fields || {});
            if (t.updateMask) {
                const i = this.Bi(t.updateMask);
                return new Ut(s, n, i, e);
            }
            return new Ot(s, n, e);
        }
        if (t.delete) {
            const s = this.li(t.delete);
            return new Wt(s, e);
        }
        if (t.transform) {
            const s = this.li(t.transform.document), n = t.transform.fieldTransforms.map(t => this.qi(t));
            return g(!0 === e.exists, 'Transforms only support precondition "exists == true"'), 
            new Qt(s, n);
        }
        if (t.verify) {
            const s = this.li(t.verify);
            return new jt(s, e);
        }
        return V("unknown mutation proto: " + JSON.stringify(t));
    }
    xi(t) {
        return g(!t.Zt, "Can't serialize an empty precondition"), void 0 !== t.updateTime ? {
            updateTime: this.toVersion(t.updateTime)
        } : void 0 !== t.exists ? {
            exists: t.exists
        } : V("Unknown precondition");
    }
    Li(t) {
        return void 0 !== t.updateTime ? Bt.updateTime(this.fromVersion(t.updateTime)) : void 0 !== t.exists ? Bt.exists(t.exists) : Bt.NONE;
    }
    Oi(t, e) {
        // NOTE: Deletes don't have an updateTime.
        let s = t.updateTime ? this.fromVersion(t.updateTime) : this.fromVersion(e);
        s.isEqual(dt.MIN) && (
        // The Firestore Emulator currently returns an update time of 0 for
        // deletes of non-existing documents (rather than null). This breaks the
        // test "get deleted doc while offline with source=cache" as NoDocuments
        // with version 0 are filtered by IndexedDb's RemoteDocumentCache.
        // TODO(#2149): Remove this when Emulator is fixed
        s = this.fromVersion(e));
        let n = null;
        return t.transformResults && t.transformResults.length > 0 && (n = t.transformResults.map(t => this.Ii(t))), 
        new kt(s, n);
    }
    Ui(t, e) {
        return t && t.length > 0 ? (g(void 0 !== e, "Received a write result without a commit time"), 
        t.map(t => this.Oi(t, e))) : [];
    }
    $i(t) {
        const e = t.transform;
        if (e instanceof gt) return {
            fieldPath: t.field.tt(),
            setToServerValue: "REQUEST_TIME"
        };
        if (e instanceof yt) return {
            fieldPath: t.field.tt(),
            appendMissingElements: {
                values: e.elements.map(t => this.Ti(t))
            }
        };
        if (e instanceof bt) return {
            fieldPath: t.field.tt(),
            removeAllFromArray: {
                values: e.elements.map(t => this.Ti(t))
            }
        };
        if (e instanceof vt) return {
            fieldPath: t.field.tt(),
            increment: this.Ti(e.zt)
        };
        throw V("Unknown transform: " + t.transform);
    }
    qi(t) {
        let e = null;
        if ("setToServerValue" in t) g("REQUEST_TIME" === t.setToServerValue, "Unknown server value transform proto: " + JSON.stringify(t)), 
        e = gt.instance; else if ("appendMissingElements" in t) {
            const s = t.appendMissingElements.values || [];
            e = new yt(s.map(t => this.Ii(t)));
        } else if ("removeAllFromArray" in t) {
            const s = t.removeAllFromArray.values || [];
            e = new bt(s.map(t => this.Ii(t)));
        } else if ("increment" in t) {
            const s = this.Ii(t.increment);
            g(s instanceof Jt, "NUMERIC_ADD transform requires a NumberValue"), e = new vt(s);
        } else V("Unknown transform proto: " + JSON.stringify(t));
        const s = Et.ot(t.fieldPath);
        return new Ct(s, e);
    }
    Qi(t) {
        return {
            documents: [ this.di(t.path) ]
        };
    }
    Wi(t) {
        const e = t.documents.length;
        g(1 === e, "DocumentsTarget contained other than 1 document: " + e);
        const s = t.documents[0];
        return Ae.Ye(this.fi(s)).cs();
    }
    ji(t) {
        // Dissect the path into parent, collectionId, and optional key filter.
        const e = {
            structuredQuery: {}
        }, s = t.path;
        null !== t.collectionGroup ? (g(s.length % 2 == 0, "Collection Group queries should be within a document path or root."), 
        e.parent = this.di(s), e.structuredQuery.from = [ {
            collectionId: t.collectionGroup,
            allDescendants: !0
        } ]) : (g(s.length % 2 != 0, "Document queries with filters are not supported."), 
        e.parent = this.di(s.K()), e.structuredQuery.from = [ {
            collectionId: s.J()
        } ]);
        const n = this.zi(t.filters);
        n && (e.structuredQuery.where = n);
        const i = this.Ki(t.orderBy);
        i && (e.structuredQuery.orderBy = i);
        const r = this.Zn(t.limit);
        return null !== r && (e.structuredQuery.limit = r), t.startAt && (e.structuredQuery.startAt = this.Gi(t.startAt)), 
        t.endAt && (e.structuredQuery.endAt = this.Gi(t.endAt)), e;
    }
    Hi(t) {
        let e = this.fi(t.parent);
        const s = t.structuredQuery, n = s.from ? s.from.length : 0;
        let i = null;
        if (n > 0) {
            g(1 === n, "StructuredQuery.from with more than one collection is not supported.");
            const t = s.from[0];
            t.allDescendants ? i = t.collectionId : e = e.child(t.collectionId);
        }
        let r = [];
        s.where && (r = this.Ji(s.where));
        let o = [];
        s.orderBy && (o = this.Yi(s.orderBy));
        let h = null;
        s.limit && (h = this.ei(s.limit));
        let a = null;
        s.startAt && (a = this.Xi(s.startAt));
        let u = null;
        return s.endAt && (u = this.Xi(s.endAt)), new Ae(e, i, o, r, h, Ie.We, a, u).cs();
    }
    Zi(t) {
        const e = this.tr(t.Ns);
        return null == e ? null : {
            "goog-listen-tags": e
        };
    }
    tr(t) {
        switch (t) {
          case Be.Ds:
            return null;

          case Be.Cs:
            return "existence-filter-mismatch";

          case Be.ks:
            return "limbo-document";

          default:
            return V("Unrecognized query purpose: " + t);
        }
    }
    cs(t) {
        let e;
        const s = t.target;
        return (e = s.Qe() ? {
            documents: this.Qi(s)
        } : {
            query: this.ji(s)
        }).targetId = t.targetId, t.resumeToken.Se() > 0 && (e.resumeToken = this.ni(t.resumeToken)), 
        e;
    }
    zi(t) {
        if (0 === t.length) return;
        const e = t.map(t => t instanceof Ve ? this.er(t) : V("Unrecognized filter: " + JSON.stringify(t)));
        return 1 === e.length ? e[0] : {
            compositeFilter: {
                op: "AND",
                filters: e
            }
        };
    }
    Ji(t) {
        return t ? void 0 !== t.unaryFilter ? [ this.sr(t) ] : void 0 !== t.fieldFilter ? [ this.nr(t) ] : void 0 !== t.compositeFilter ? t.compositeFilter.filters.map(t => this.Ji(t)).reduce((t, e) => t.concat(e)) : V("Unknown filter: " + JSON.stringify(t)) : [];
    }
    Ki(t) {
        if (0 !== t.length) return t.map(t => this.ir(t));
    }
    Yi(t) {
        return t.map(t => this.rr(t));
    }
    Gi(t) {
        return {
            before: t.before,
            values: t.position.map(t => this.Ti(t))
        };
    }
    Xi(t) {
        const e = !!t.before, s = t.values.map(t => this.Ii(t));
        return new Ce(s, e);
    }
    // visible for testing
    or(t) {
        return bs[t.name];
    }
    // visible for testing
    hr(t) {
        switch (t) {
          case "ASCENDING":
            return De.ASCENDING;

          case "DESCENDING":
            return De.DESCENDING;

          default:
            return;
        }
    }
    // visible for testing
    ar(t) {
        return vs[t.name];
    }
    ur(t) {
        switch (t) {
          case "EQUAL":
            return pe.EQUAL;

          case "GREATER_THAN":
            return pe.GREATER_THAN;

          case "GREATER_THAN_OR_EQUAL":
            return pe.GREATER_THAN_OR_EQUAL;

          case "LESS_THAN":
            return pe.LESS_THAN;

          case "LESS_THAN_OR_EQUAL":
            return pe.LESS_THAN_OR_EQUAL;

          case "ARRAY_CONTAINS":
            return pe.ARRAY_CONTAINS;

          case "IN":
            return pe.IN;

          case "ARRAY_CONTAINS_ANY":
            return pe.ARRAY_CONTAINS_ANY;

          case "OPERATOR_UNSPECIFIED":
            return V("Unspecified operator");

          default:
            return V("Unknown operator");
        }
    }
    cr(t) {
        return {
            fieldPath: t.tt()
        };
    }
    lr(t) {
        return Et.ot(t.fieldPath);
    }
    // visible for testing
    ir(t) {
        return {
            field: this.cr(t.field),
            direction: this.or(t.dir)
        };
    }
    rr(t) {
        return new ke(this.lr(t.field), this.hr(t.direction));
    }
    nr(t) {
        return Ve.create(this.lr(t.fieldFilter.field), this.ur(t.fieldFilter.op), this.Ii(t.fieldFilter.value));
    }
    // visible for testing
    er(t) {
        if (t.op === pe.EQUAL) {
            if (t.value.isEqual(Zt.Ne)) return {
                unaryFilter: {
                    field: this.cr(t.field),
                    op: "IS_NAN"
                }
            };
            if (t.value.isEqual(Gt.De)) return {
                unaryFilter: {
                    field: this.cr(t.field),
                    op: "IS_NULL"
                }
            };
        }
        return {
            fieldFilter: {
                field: this.cr(t.field),
                op: this.ar(t.op),
                value: this.Ti(t.value)
            }
        };
    }
    sr(t) {
        switch (t.unaryFilter.op) {
          case "IS_NAN":
            const e = this.lr(t.unaryFilter.field);
            return Ve.create(e, pe.EQUAL, Zt.Ne);

          case "IS_NULL":
            const s = this.lr(t.unaryFilter.field);
            return Ve.create(s, pe.EQUAL, Gt.De);

          case "OPERATOR_UNSPECIFIED":
            return V("Unspecified filter");

          default:
            return V("Unknown filter");
        }
    }
    Fi(t) {
        const e = [];
        return t.fields.forEach(t => e.push(t.tt())), {
            fieldPaths: e
        };
    }
    Bi(t) {
        const e = (t.fieldPaths || []).map(t => Et.ot(t));
        return Dt.Ht(e);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Provides singleton helpers where setup code can inject a platform at runtime.
 * setPlatform needs to be set before Firestore is used and must be set exactly
 * once.
 */ class Ns {
    static _r(t) {
        Ns.platform && V("Platform already defined"), Ns.platform = t;
    }
    static t() {
        return Ns.platform || V("Platform not set"), Ns.platform;
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Helper function to prevent instantiation through the constructor.
 *
 * This method creates a new constructor that throws when it's invoked.
 * The prototype of that constructor is then set to the prototype of the hidden
 * "class" to expose all the prototype methods and allow for instanceof
 * checks.
 *
 * To also make all the static methods available, all properties of the
 * original constructor are copied to the new constructor.
 */ function Fs(t, e) {
    function s() {
        let t = "This constructor is private.";
        throw e && (t += " ", t += e), new $(F.INVALID_ARGUMENT, t);
    }
    // Make sure instanceof checks work and all methods are exposed on the public
    // constructor
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
    return s.prototype = t.prototype, 
    // Copy any static methods/members
    Object.assign(s, t), s;
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** Helper function to assert Uint8Array is available at runtime. */ function $s() {
    if ("undefined" == typeof Uint8Array) throw new $(F.UNIMPLEMENTED, "Uint8Arrays are not available in this environment.");
}

/** Helper function to assert Base64 functions are available at runtime. */ function xs() {
    if (!Ns.t().dr) throw new $(F.UNIMPLEMENTED, "Blobs are unavailable in Firestore in this environment.");
}

/**
 * Immutable class holding a blob (binary data).
 * This class is directly exposed in the public API.
 *
 * Note that while you can't hide the constructor in JavaScript code, we are
 * using the hack above to make sure no-one outside this module can call it.
 */ class Ms {
    constructor(t) {
        xs(), this.vs = t;
    }
    static fromBase64String(t) {
        K("Blob.fromBase64String", arguments, 1), J("Blob.fromBase64String", "string", 1, t), 
        xs();
        try {
            const e = Ns.t().atob(t);
            return new Ms(e);
        } catch (t) {
            throw new $(F.INVALID_ARGUMENT, "Failed to construct Blob from Base64 string: " + t);
        }
    }
    static fromUint8Array(t) {
        if (K("Blob.fromUint8Array", arguments, 1), $s(), !(t instanceof Uint8Array)) throw ht("Blob.fromUint8Array", "Uint8Array", 1, t);
        const e = We(t);
        return new Ms(e);
    }
    toBase64() {
        return K("Blob.toBase64", arguments, 0), xs(), Ns.t().btoa(this.vs);
    }
    toUint8Array() {
        return K("Blob.toUint8Array", arguments, 0), $s(), je(this.vs);
    }
    toString() {
        return "Blob(base64: " + this.toBase64() + ")";
    }
    isEqual(t) {
        return this.vs === t.vs;
    }
    $e() {
        // Assume UTF-16 encoding in memory (see StringValue.approximateByteSize())
        return 2 * this.vs.length;
    }
    /**
     * Actually private to JS consumers of our API, so this function is prefixed
     * with an underscore.
     */    $(t) {
        return b(this.vs, t.vs);
    }
}

// Public instance that disallows construction at runtime. This constructor is
// used when exporting Blob on firebase.firestore.Blob and will be called Blob
// publicly. Internally we still use Blob which has a type checked private
// constructor. Note that Blob and PublicBlob can be used interchangeably in
// instanceof checks.
// For our internal TypeScript code PublicBlob doesn't exist as a type, and so
// we need to use Blob as type and export it too.
const Ls = Fs(Ms, "Use Blob.fromUint8Array() or Blob.fromBase64String() instead.");

/**
 * @license
 * Copyright 2018 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * `ListenSequence` is a monotonic sequence. It is initialized with a minimum value to
 * exceed. All subsequent calls to next will return increasing values. If provided with a
 * `SequenceNumberSyncer`, it will additionally bump its next value when told of a new value, as
 * well as write out sequence numbers that it produces via `next()`.
 */ class Bs {
    constructor(t, e) {
        this.previousValue = t, e && (e.mr = t => this.Tr(t), this.wr = t => e.Er(t));
    }
    Tr(t) {
        return this.previousValue = Math.max(t, this.previousValue), this.previousValue;
    }
    next() {
        const t = ++this.previousValue;
        return this.wr && this.wr(t), t;
    }
}

Bs.Ir = -1;

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class qs {
    constructor() {
        this.promise = new Promise((t, e) => {
            this.resolve = t, this.reject = e;
        });
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Wellknown "timer" IDs used when scheduling delayed operations on the
 * AsyncQueue. These IDs can then be used from tests to check for the presence
 * of operations or to run them early.
 *
 * The string values are used when encoding these timer IDs in JSON spec tests.
 */ var Os, Us;

/** All can be used with runDelayedOperationsEarly() to run all timers. */
(Us = Os || (Os = {})).Rr = "all", 
/**
     * The following 4 timers are used in persistent_stream.ts for the listen and
     * write streams. The "Idle" timer is used to close the stream due to
     * inactivity. The "ConnectionBackoff" timer is used to restart a stream once
     * the appropriate backoff delay has elapsed.
     */
Us.Ar = "listen_stream_idle", Us.Pr = "listen_stream_connection_backoff", Us.pr = "write_stream_idle", 
Us.Vr = "write_stream_connection_backoff", 
/**
     * A timer used in online_state_tracker.ts to transition from
     * OnlineState.Unknown to Offline after a set timeout, rather than waiting
     * indefinitely for success or failure.
     */
Us.gr = "online_state_timeout", 
/**
     * A timer used to update the client metadata in IndexedDb, which is used
     * to determine the primary leaseholder.
     */
Us.yr = "client_metadata_refresh", 
/** A timer used to periodically attempt LRU Garbage collection */
Us.br = "lru_garbage_collection", 
/**
     * A timer used to retry transactions. Since there can be multiple concurrent
     * transactions, multiple of these may be in the queue at a given time.
     */
Us.vr = "retry_transaction";

/**
 * Represents an operation scheduled to be run in the future on an AsyncQueue.
 *
 * It is created via DelayedOperation.createAndSchedule().
 *
 * Supports cancellation (via cancel()) and early execution (via skipDelay()).
 */
class Qs {
    constructor(t, e, s, n, i) {
        this.Sr = t, this.Dr = e, this.Cr = s, this.op = n, this.kr = i, this.Nr = new qs, 
        this.then = this.Nr.promise.then.bind(this.Nr.promise), this.catch = this.Nr.promise.catch.bind(this.Nr.promise), 
        // It's normal for the deferred promise to be canceled (due to cancellation)
        // and so we attach a dummy catch callback to avoid
        // 'UnhandledPromiseRejectionWarning' log spam.
        this.Nr.promise.catch(t => {});
    }
    /**
     * Creates and returns a DelayedOperation that has been scheduled to be
     * executed on the provided asyncQueue after the provided delayMs.
     *
     * @param asyncQueue The queue to schedule the operation on.
     * @param id A Timer ID identifying the type of operation this is.
     * @param delayMs The delay (ms) before the operation should be scheduled.
     * @param op The operation to run.
     * @param removalCallback A callback to be called synchronously once the
     *   operation is executed or canceled, notifying the AsyncQueue to remove it
     *   from its delayedOperations list.
     *   PORTING NOTE: This exists to prevent making removeDelayedOperation() and
     *   the DelayedOperation class public.
     */    static Fr(t, e, s, n, i) {
        const r = Date.now() + s, o = new Qs(t, e, r, n, i);
        return o.start(s), o;
    }
    /**
     * Starts the timer. This is called immediately after construction by
     * createAndSchedule().
     */    start(t) {
        this.$r = setTimeout(() => this.xr(), t);
    }
    /**
     * Queues the operation to run immediately (if it hasn't already been run or
     * canceled).
     */    Mr() {
        return this.xr();
    }
    /**
     * Cancels the operation if it hasn't already been executed or canceled. The
     * promise will be rejected.
     *
     * As long as the operation has not yet been run, calling cancel() provides a
     * guarantee that the operation will not be run.
     */    cancel(t) {
        null !== this.$r && (this.clearTimeout(), this.Nr.reject(new $(F.CANCELLED, "Operation cancelled" + (t ? ": " + t : ""))));
    }
    xr() {
        this.Sr.Lr(() => null !== this.$r ? (this.clearTimeout(), this.op().then(t => this.Nr.resolve(t))) : Promise.resolve());
    }
    clearTimeout() {
        null !== this.$r && (this.kr(this), clearTimeout(this.$r), this.$r = null);
    }
}

class Ws {
    constructor() {
        // The last promise in the queue.
        this.Br = Promise.resolve(), 
        // Is this AsyncQueue being shut down? Once it is set to true, it will not
        // be changed again.
        this.qr = !1, 
        // Operations scheduled to be queued in the future. Operations are
        // automatically removed after they are run or canceled.
        this.Or = [], 
        // visible for testing
        this.Ur = null, 
        // Flag set while there's an outstanding AsyncQueue operation, used for
        // assertion sanity-checks.
        this.Qr = !1, 
        // List of TimerIds to fast-forward delays for.
        this.Wr = [];
    }
    // Is this AsyncQueue being shut down? If true, this instance will not enqueue
    // any new operations, Promises from enqueue requests will not resolve.
    get jr() {
        return this.qr;
    }
    /**
     * Adds a new operation to the queue without waiting for it to complete (i.e.
     * we ignore the Promise result).
     */    Lr(t) {
        // eslint-disable-next-line @typescript-eslint/no-floating-promises
        this.enqueue(t);
    }
    /**
     * Regardless if the queue has initialized shutdown, adds a new operation to the
     * queue without waiting for it to complete (i.e. we ignore the Promise result).
     */    zr(t) {
        this.Kr(), 
        // eslint-disable-next-line @typescript-eslint/no-floating-promises
        this.Gr(t);
    }
    /**
     * Regardless if the queue has initialized shutdown, adds a new operation to the
     * queue.
     */    Hr(t) {
        return this.Kr(), this.Gr(t);
    }
    /**
     * Adds a new operation to the queue and initialize the shut down of this queue.
     * Returns a promise that will be resolved when the promise returned by the new
     * operation is (with its value).
     * Once this method is called, the only possible way to request running an operation
     * is through `enqueueAndForgetEvenAfterShutdown`.
     */    async Jr(t) {
        this.Kr(), this.qr || (this.qr = !0, await this.Hr(t));
    }
    /**
     * Adds a new operation to the queue. Returns a promise that will be resolved
     * when the promise returned by the new operation is (with its value).
     */    enqueue(t) {
        return this.Kr(), this.qr ? new Promise(t => {}) : this.Gr(t);
    }
    Gr(t) {
        const e = this.Br.then(() => (this.Qr = !0, t().catch(t => {
            this.Ur = t, this.Qr = !1;
            const e = t.stack || t.message || "";
            // Re-throw the error so that this.tail becomes a rejected Promise and
            // all further attempts to chain (via .then) will just short-circuit
            // and return the rejected Promise.
            throw P("INTERNAL UNHANDLED ERROR: ", e), 
            // Escape the promise chain and throw the error globally so that
            // e.g. any global crash reporting library detects and reports it.
            // (but not for simulated errors in our tests since this breaks mocha)
            e.indexOf("Firestore Test Simulated Error") < 0 && setTimeout(() => {
                throw t;
            }, 0), t;
        }).then(t => (this.Qr = !1, t))));
        return this.Br = e, e;
    }
    /**
     * Schedules an operation to be queued on the AsyncQueue once the specified
     * `delayMs` has elapsed. The returned CancelablePromise can be used to cancel
     * the operation prior to its running.
     */    Yr(t, e, s) {
        this.Kr(), g(e >= 0, `Attempted to schedule an operation with a negative delay of ${e}`), 
        // Fast-forward delays for timerIds that have been overriden.
        this.Wr.indexOf(t) > -1 && (e = 0);
        const n = Qs.Fr(this, t, e, s, t => this.Xr(t));
        return this.Or.push(n), n;
    }
    Kr() {
        this.Ur && V("AsyncQueue is already failed: " + (this.Ur.stack || this.Ur.message));
    }
    /**
     * Verifies there's an operation currently in-progress on the AsyncQueue.
     * Unfortunately we can't verify that the running code is in the promise chain
     * of that operation, so this isn't a foolproof check, but it should be enough
     * to catch some bugs.
     */    Zr() {
        g(this.Qr, "verifyOpInProgress() called when no op in progress on this queue.");
    }
    /**
     * Waits until all currently queued tasks are finished executing. Delayed
     * operations are not run.
     */    to() {
        // It should still be possible to drain the queue after it is shutting down.
        return this.Hr(() => Promise.resolve());
    }
    /**
     * For Tests: Determine if a delayed operation with a particular TimerId
     * exists.
     */    eo(t) {
        for (const e of this.Or) if (e.Dr === t) return !0;
        return !1;
    }
    /**
     * For Tests: Runs some or all delayed operations early.
     *
     * @param lastTimerId Delayed operations up to and including this TimerId will
     *  be drained. Throws if no such operation exists. Pass TimerId.All to run
     *  all delayed operations.
     * @returns a Promise that resolves once all operations have been run.
     */    so(t) {
        // Note that draining may generate more delayed ops, so we do that first.
        return this.to().then(() => {
            g(t === Os.Rr || this.eo(t), `Attempted to drain to missing operation ${t}`), 
            // Run ops in the same order they'd run if they ran naturally.
            this.Or.sort((t, e) => t.Cr - e.Cr);
            for (const e of this.Or) if (e.Mr(), t !== Os.Rr && e.Dr === t) break;
            return this.to();
        });
    }
    /**
     * For Tests: Skip all subsequent delays for a timer id.
     */    no(t) {
        this.Wr.push(t);
    }
    /** Called once a DelayedOperation is run or canceled. */    Xr(t) {
        // NOTE: indexOf / slice are O(n), but delayedOperations is expected to be small.
        const e = this.Or.indexOf(t);
        g(e >= 0, "Delayed operation not found."), this.Or.splice(e, 1);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const js = "", zs = "", Ks = "", Gs = "";

/**
 * Encodes a resource path into a IndexedDb-compatible string form.
 */
function Hs(t) {
    let e = "";
    for (let s = 0; s < t.length; s++) e.length > 0 && (e = Ys(e)), e = Js(t.get(s), e);
    return Ys(e);
}

/** Encodes a single segment of a resource path into the given result */ function Js(t, e) {
    let s = e;
    const n = t.length;
    for (let e = 0; e < n; e++) {
        const n = t.charAt(e);
        switch (n) {
          case "\0":
            s += js + Ks;
            break;

          case js:
            s += js + Gs;
            break;

          default:
            s += n;
        }
    }
    return s;
}

/** Encodes a path separator into the given result */ function Ys(t) {
    return t + js + zs;
}

/**
 * Decodes the given IndexedDb-compatible string form of a resource path into
 * a ResourcePath instance. Note that this method is not suitable for use with
 * decoding resource names from the server; those are One Platform format
 * strings.
 */ function Xs(t) {
    // Event the empty path must encode as a path of at least length 2. A path
    // with exactly 2 must be the empty path.
    const e = t.length;
    if (g(e >= 2, "Invalid path " + t), 2 === e) return g(t.charAt(0) === js && t.charAt(1) === zs, "Non-empty path " + t + " had length 2"), 
    Tt.st;
    // Escape characters cannot exist past the second-to-last position in the
    // source value.
        const s = e - 2, n = [];
    let i = "";
    for (let r = 0; r < e; ) {
        // The last two characters of a valid encoded path must be a separator, so
        // there must be an end to this segment.
        const e = t.indexOf(js, r);
        switch ((e < 0 || e > s) && V('Invalid encoded resource path: "' + t + '"'), t.charAt(e + 1)) {
          case zs:
            const s = t.substring(r, e);
            let o;
            0 === i.length ? 
            // Avoid copying for the common case of a segment that excludes \0
            // and \001
            o = s : (o = i += s, i = ""), n.push(o);
            break;

          case Ks:
            i += t.substring(r, e), i += "\0";
            break;

          case Gs:
            // The escape character can be used in the output to encode itself.
            i += t.substring(r, e + 1);
            break;

          default:
            V('Invalid encoded resource path: "' + t + '"');
        }
        r = e + 2;
    }
    return new Tt(n);
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const Zs = -1;

/**
 * A batch of mutations that will be sent as one unit to the backend.
 */ class tn {
    /**
     * @param batchId The unique ID of this mutation batch.
     * @param localWriteTime The original write time of this mutation.
     * @param baseMutations Mutations that are used to populate the base
     * values when this mutation is applied locally. This can be used to locally
     * overwrite values that are persisted in the remote document cache. Base
     * mutations are never sent to the backend.
     * @param mutations The user-provided mutations in this mutation batch.
     * User-provided mutations are applied both locally and remotely on the
     * backend.
     */
    constructor(t, e, s, n) {
        this.batchId = t, this.Fe = e, this.baseMutations = s, this.mutations = n, g(n.length > 0, "Cannot create an empty mutation batch");
    }
    /**
     * Applies all the mutations in this MutationBatch to the specified document
     * to create a new remote document
     *
     * @param docKey The key of the document to apply mutations to.
     * @param maybeDoc The document to apply mutations to.
     * @param batchResult The result of applying the MutationBatch to the
     * backend.
     */    Wt(t, e, s) {
        e && g(e.key.isEqual(t), `applyToRemoteDocument: key ${t} should match maybeDoc key\n        ${e.key}`);
        const n = s.io;
        g(n.length === this.mutations.length, `Mismatch between mutations length\n      (${this.mutations.length}) and mutation results length\n      (${n.length}).`);
        for (let s = 0; s < this.mutations.length; s++) {
            const i = this.mutations[s];
            if (i.key.isEqual(t)) {
                const t = n[s];
                e = i.Wt(e, t);
            }
        }
        return e;
    }
    /**
     * Computes the local view of a document given all the mutations in this
     * batch.
     *
     * @param docKey The key of the document to apply mutations to.
     * @param maybeDoc The document to apply mutations to.
     */    Qt(t, e) {
        e && g(e.key.isEqual(t), `applyToLocalDocument: key ${t} should match maybeDoc key\n        ${e.key}`);
        // First, apply the base state. This allows us to apply non-idempotent
        // transform against a consistent set of values.
                for (const s of this.baseMutations) s.key.isEqual(t) && (e = s.Qt(e, e, this.Fe));
        const s = e;
        // Second, apply all user-provided mutations.
                for (const n of this.mutations) n.key.isEqual(t) && (e = n.Qt(e, s, this.Fe));
        return e;
    }
    /**
     * Computes the local view for all provided documents given the mutations in
     * this batch.
     */    ro(t) {
        // TODO(mrschmidt): This implementation is O(n^2). If we apply the mutations
        // directly (as done in `applyToLocalView()`), we can reduce the complexity
        // to O(n).
        let e = t;
        return this.mutations.forEach(s => {
            const n = this.Qt(s.key, t.get(s.key));
            n && (e = e.lt(s.key, n));
        }), e;
    }
    keys() {
        return this.mutations.reduce((t, e) => t.add(e.key), rs());
    }
    isEqual(t) {
        return this.batchId === t.batchId && v(this.mutations, t.mutations) && v(this.baseMutations, t.baseMutations);
    }
}

/** The result of applying a mutation batch to the backend. */ class en {
    constructor(t, e, s, n, 
    /**
     * A pre-computed mapping from each mutated document to the resulting
     * version.
     */
    i) {
        this.batch = t, this.oo = e, this.io = s, this.streamToken = n, this.ho = i;
    }
    /**
     * Creates a new MutationBatchResult for the given batch and results. There
     * must be one result for each mutation in the batch. This static factory
     * caches a document=>version mapping (docVersions).
     */    static from(t, e, s, n) {
        g(t.mutations.length === s.length, "Mutations sent " + t.mutations.length + " must equal results received " + s.length);
        let i = ns();
        const r = t.mutations;
        for (let t = 0; t < r.length; t++) i = i.lt(r[t].key, s[t].version);
        return new en(t, e, s, n, i);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A collection of references to a document from some kind of numbered entity
 * (either a target ID or batch ID). As references are added to or removed from
 * the set corresponding events are emitted to a registered garbage collector.
 *
 * Each reference is represented by a DocumentReference object. Each of them
 * contains enough information to uniquely identify the reference. They are all
 * stored primarily in a set sorted by key. A document is considered garbage if
 * there's no references in that set (this can be efficiently checked thanks to
 * sorting by key).
 *
 * ReferenceSet also keeps a secondary set that contains references sorted by
 * IDs. This one is used to efficiently implement removal of all references by
 * some target ID.
 */ class sn {
    constructor() {
        // A set of outstanding references to a document sorted by key.
        this.ao = new pt(nn.Me), 
        // A set of outstanding references to a document sorted by target id.
        this.uo = new pt(nn.co);
    }
    /** Returns true if the reference set contains no references. */    G() {
        return this.ao.G();
    }
    /** Adds a reference to the given document key for the given ID. */    lo(t, e) {
        const s = new nn(t, e);
        this.ao = this.ao.add(s), this.uo = this.uo.add(s);
    }
    /** Add references to the given document keys for the given ID. */    _o(t, e) {
        t.forEach(t => this.lo(t, e));
    }
    /**
     * Removes a reference to the given document key for the given
     * ID.
     */    do(t, e) {
        this.fo(new nn(t, e));
    }
    mo(t, e) {
        t.forEach(t => this.do(t, e));
    }
    /**
     * Clears all references with a given ID. Calls removeRef() for each key
     * removed.
     */    To(t) {
        const e = It.EMPTY, s = new nn(e, t), n = new nn(e, t + 1), i = [];
        return this.uo.Lt([ s, n ], t => {
            this.fo(t), i.push(t.key);
        }), i;
    }
    wo() {
        this.ao.forEach(t => this.fo(t));
    }
    fo(t) {
        this.ao = this.ao.delete(t), this.uo = this.uo.delete(t);
    }
    Eo(t) {
        const e = It.EMPTY, s = new nn(e, t), n = new nn(e, t + 1);
        let i = rs();
        return this.uo.Lt([ s, n ], t => {
            i = i.add(t.key);
        }), i;
    }
    Io(t) {
        const e = new nn(t, 0), s = this.ao.qt(e);
        return null !== s && t.isEqual(s.key);
    }
}

class nn {
    constructor(t, e) {
        this.key = t, this.Ro = e;
    }
    /** Compare by key then by ID */    static Me(t, e) {
        return It.U(t.key, e.key) || b(t.Ro, e.Ro);
    }
    /** Compare by ID then by key */    static co(t, e) {
        return b(t.Ro, e.Ro) || It.U(t.key, e.key);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A map implementation that uses objects as keys. Objects must implement the
 * Equatable interface and must be immutable. Entries in the map are stored
 * together with the key being produced from the mapKeyFn. This map
 * automatically handles collisions of keys.
 */ class rn {
    constructor(t) {
        this.Ao = t, 
        /**
         * The inner map for a key -> value pair. Due to the possibility of
         * collisions we keep a list of entries that we do a linear search through
         * to find an actual match. Note that collisions should be rare, so we still
         * expect near constant time lookups in practice.
         */
        this.Po = {};
    }
    /** Get a value for this key, or undefined if it does not exist. */    get(t) {
        const e = this.Ao(t), s = this.Po[e];
        if (void 0 !== s) for (const [e, n] of s) if (e.isEqual(t)) return n;
    }
    has(t) {
        return void 0 !== this.get(t);
    }
    /** Put this key and value in the map. */    set(t, e) {
        const s = this.Ao(t), n = this.Po[s];
        if (void 0 !== n) {
            for (let s = 0; s < n.length; s++) if (n[s][0].isEqual(t)) return void (n[s] = [ t, e ]);
            n.push([ t, e ]);
        } else this.Po[s] = [ [ t, e ] ];
    }
    /**
     * Remove this key from the map. Returns a boolean if anything was deleted.
     */    delete(t) {
        const e = this.Ao(t), s = this.Po[e];
        if (void 0 === s) return !1;
        for (let n = 0; n < s.length; n++) if (s[n][0].isEqual(t)) return 1 === s.length ? delete this.Po[e] : s.splice(n, 1), 
        !0;
        return !1;
    }
    forEach(t) {
        W(this.Po, (e, s) => {
            for (const [e, n] of s) t(e, n);
        });
    }
    G() {
        return j(this.Po);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * PersistencePromise<> is essentially a re-implementation of Promise<> except
 * it has a .next() method instead of .then() and .next() and .catch() callbacks
 * are executed synchronously when a PersistencePromise resolves rather than
 * asynchronously (Promise<> implementations use setImmediate() or similar).
 *
 * This is necessary to interoperate with IndexedDB which will automatically
 * commit transactions if control is returned to the event loop without
 * synchronously initiating another operation on the transaction.
 *
 * NOTE: .then() and .catch() only allow a single consumer, unlike normal
 * Promises.
 */ class on {
    constructor(t) {
        // NOTE: next/catchCallback will always point to our own wrapper functions,
        // not the user's raw next() or catch() callbacks.
        this.po = null, this.Vo = null, 
        // When the operation resolves, we'll set result or error and mark isDone.
        this.result = void 0, this.error = void 0, this.yo = !1, 
        // Set to true when .then() or .catch() are called and prevents additional
        // chaining.
        this.bo = !1, t(t => {
            this.yo = !0, this.result = t, this.po && 
            // value should be defined unless T is Void, but we can't express
            // that in the type system.
            this.po(t);
        }, t => {
            this.yo = !0, this.error = t, this.Vo && this.Vo(t);
        });
    }
    catch(t) {
        return this.next(void 0, t);
    }
    next(t, e) {
        return this.bo && V("Called next() or catch() twice for PersistencePromise"), this.bo = !0, 
        this.yo ? this.error ? this.vo(e, this.error) : this.So(t, this.result) : new on((s, n) => {
            this.po = e => {
                this.So(t, e).next(s, n);
            }, this.Vo = t => {
                this.vo(e, t).next(s, n);
            };
        });
    }
    Do() {
        return new Promise((t, e) => {
            this.next(t, e);
        });
    }
    Co(t) {
        try {
            const e = t();
            return e instanceof on ? e : on.resolve(e);
        } catch (t) {
            return on.reject(t);
        }
    }
    So(t, e) {
        return t ? this.Co(() => t(e)) : on.resolve(e);
    }
    vo(t, e) {
        return t ? this.Co(() => t(e)) : on.reject(e);
    }
    static resolve(t) {
        return new on((e, s) => {
            e(t);
        });
    }
    static reject(t) {
        return new on((e, s) => {
            s(t);
        });
    }
    static ko(
    // Accept all Promise types in waitFor().
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    t) {
        return new on((e, s) => {
            let n = 0, i = 0, r = !1;
            t.forEach(t => {
                ++n, t.next(() => {
                    ++i, r && i === n && e();
                }, t => s(t));
            }), r = !0, i === n && e();
        });
    }
    /**
     * Given an array of predicate functions that asynchronously evaluate to a
     * boolean, implements a short-circuiting `or` between the results. Predicates
     * will be evaluated until one of them returns `true`, then stop. The final
     * result will be whether any of them returned `true`.
     */    static No(t) {
        let e = on.resolve(!1);
        for (const s of t) e = e.next(t => t ? on.resolve(t) : s());
        return e;
    }
    static forEach(t, e) {
        const s = [];
        return t.forEach((t, n) => {
            s.push(e.call(this, t, n));
        }), this.ko(s);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * An in-memory buffer of entries to be written to a RemoteDocumentCache.
 * It can be used to batch up a set of changes to be written to the cache, but
 * additionally supports reading entries back with the `getEntry()` method,
 * falling back to the underlying RemoteDocumentCache if no entry is
 * buffered.
 *
 * Entries added to the cache *must* be read first. This is to facilitate
 * calculating the size delta of the pending changes.
 *
 * PORTING NOTE: This class was implemented then removed from other platforms.
 * If byte-counting ends up being needed on the other platforms, consider
 * porting this class as part of that implementation work.
 */ class hn {
    constructor() {
        // A mapping of document key to the new cache entry that should be written (or null if any
        // existing cache entry should be removed).
        this.Fo = new rn(t => t.toString()), this.$o = !1;
    }
    set readTime(t) {
        // Right now (for simplicity) we just track a single readTime for all the
        // added entries since we expect them to all be the same, but we could
        // rework to store per-entry readTimes if necessary.
        g(void 0 === this.xo || this.xo.isEqual(t), "All changes in a RemoteDocumentChangeBuffer must have the same read time"), 
        this.xo = t;
    }
    get readTime() {
        return g(void 0 !== this.xo, "Read time is not set. All removeEntry() calls must include a readTime if `trackRemovals` is used."), 
        this.xo;
    }
    /**
     * Buffers a `RemoteDocumentCache.addEntry()` call.
     *
     * You can only modify documents that have already been retrieved via
     * `getEntry()/getEntries()` (enforced via IndexedDbs `apply()`).
     */    Mo(t, e) {
        this.Lo(), this.readTime = e, this.Fo.set(t.key, t);
    }
    /**
     * Buffers a `RemoteDocumentCache.removeEntry()` call.
     *
     * You can only remove documents that have already been retrieved via
     * `getEntry()/getEntries()` (enforced via IndexedDbs `apply()`).
     */    Bo(t, e) {
        this.Lo(), e && (this.readTime = e), this.Fo.set(t, null);
    }
    /**
     * Looks up an entry in the cache. The buffered changes will first be checked,
     * and if no buffered change applies, this will forward to
     * `RemoteDocumentCache.getEntry()`.
     *
     * @param transaction The transaction in which to perform any persistence
     *     operations.
     * @param documentKey The key of the entry to look up.
     * @return The cached Document or NoDocument entry, or null if we have nothing
     * cached.
     */    qo(t, e) {
        this.Lo();
        const s = this.Fo.get(e);
        return void 0 !== s ? on.resolve(s) : this.Oo(t, e);
    }
    /**
     * Looks up several entries in the cache, forwarding to
     * `RemoteDocumentCache.getEntry()`.
     *
     * @param transaction The transaction in which to perform any persistence
     *     operations.
     * @param documentKeys The keys of the entries to look up.
     * @return A map of cached `Document`s or `NoDocument`s, indexed by key. If an
     *     entry cannot be found, the corresponding key will be mapped to a null
     *     value.
     */    getEntries(t, e) {
        return this.Uo(t, e);
    }
    /**
     * Applies buffered changes to the underlying RemoteDocumentCache, using
     * the provided transaction.
     */    apply(t) {
        return this.Lo(), this.$o = !0, this.Qo(t);
    }
    /** Helper to assert this.changes is not null  */    Lo() {
        g(!this.$o, "Changes have already been applied.");
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const an = "The current tab is not in the required state to perform this operation. It might be necessary to refresh the browser tab.";

/**
 * A base class representing a persistence transaction, encapsulating both the
 * transaction's sequence numbers as well as a list of onCommitted listeners.
 *
 * When you call Persistence.runTransaction(), it will create a transaction and
 * pass it to your callback. You then pass it to any method that operates
 * on persistence.
 */ class un {
    constructor() {
        this.Wo = [];
    }
    jo(t) {
        this.Wo.push(t);
    }
    zo() {
        this.Wo.forEach(t => t());
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const cn = "SimpleDb", ln = 3;

/**
 * The maximum number of retry attempts for an IndexedDb transaction that fails
 * with a DOMException.
 */
/**
 * Provides a wrapper around IndexedDb with a simplified interface that uses
 * Promise-like return values to chain operations. Real promises cannot be used
 * since .then() continuations are executed asynchronously (e.g. via
 * .setImmediate), which would cause IndexedDB to end the transaction.
 * See PersistencePromise for more details.
 */
class _n {
    constructor(t) {
        this.db = t, 
        // NOTE: According to https://bugs.webkit.org/show_bug.cgi?id=197050, the
        // bug we're checking for should exist in iOS >= 12.2 and < 13, but for
        // whatever reason it's much harder to hit after 12.2 so we only proactively
        // log on 12.2.
        12.2 === _n.Ko(n()) && P("Firestore persistence suffers from a bug in iOS 12.2 Safari that may cause your app to stop working. See https://stackoverflow.com/q/56496296/110915 for details and a potential workaround.");
    }
    /**
     * Opens the specified database, creating or upgrading it if necessary.
     *
     * Note that `version` must not be a downgrade. IndexedDB does not support downgrading the schema
     * version. We currently do not support any way to do versioning outside of IndexedDB's versioning
     * mechanism, as only version-upgrade transactions are allowed to do things like create
     * objectstores.
     */    static Go(t, e, s) {
        return g(_n.Ho(), "IndexedDB not supported in current environment."), A(cn, "Opening database:", t), 
        new on((n, i) => {
            // TODO(mikelehen): Investigate browser compatibility.
            // https://developer.mozilla.org/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB
            // suggests IE9 and older WebKit browsers handle upgrade
            // differently. They expect setVersion, as described here:
            // https://developer.mozilla.org/en-US/docs/Web/API/IDBVersionChangeRequest/setVersion
            const r = window.indexedDB.open(t, e);
            r.onsuccess = t => {
                const e = t.target.result;
                n(new _n(e));
            }, r.onblocked = () => {
                i(new $(F.FAILED_PRECONDITION, "Cannot upgrade IndexedDB schema while another tab is open. Close all tabs that access Firestore and reload this page to proceed."));
            }, r.onerror = t => {
                const e = t.target.error;
                "VersionError" === e.name ? i(new $(F.FAILED_PRECONDITION, "A newer version of the Firestore SDK was previously used and so the persisted data is not compatible with the version of the SDK you are now using. The SDK will operate with persistence disabled. If you need persistence, please re-upgrade to a newer version of the SDK or else clear the persisted IndexedDB data for your app to start fresh.")) : i(e);
            }, r.onupgradeneeded = e => {
                A(cn, 'Database "' + t + '" requires upgrade from version:', e.oldVersion);
                const n = e.target.result;
                s.createOrUpgrade(n, r.transaction, e.oldVersion, ti).next(() => {
                    A(cn, "Database upgrade to version " + ti + " complete");
                });
            };
        }).Do();
    }
    /** Deletes the specified database. */    static delete(t) {
        return A(cn, "Removing database:", t), Tn(window.indexedDB.deleteDatabase(t)).Do();
    }
    /** Returns true if IndexedDB is available in the current environment. */    static Ho() {
        if ("undefined" == typeof window || null == window.indexedDB) return !1;
        if (_n.Jo()) return !0;
        // In some Node environments, `window` is defined, but `window.navigator` is
        // not. We don't support IndexedDB persistence in Node if the
        // isMockPersistence() check above returns false.
                if (void 0 === window.navigator) return !1;
        // We extensively use indexed array values and compound keys,
        // which IE and Edge do not support. However, they still have indexedDB
        // defined on the window, so we need to check for them here and make sure
        // to return that persistence is not enabled for those browsers.
        // For tracking support of this feature, see here:
        // https://developer.microsoft.com/en-us/microsoft-edge/platform/status/indexeddbarraysandmultientrysupport/
        // Check the UA string to find out the browser.
                const t = n(), e = _n.Ko(t), s = 0 < e && e < 10, i = _n.Yo(t), r = 0 < i && i < 4.5;
        // IE 10
        // ua = 'Mozilla/5.0 (compatible; MSIE 10.0; Windows NT 6.2; Trident/6.0)';
        // IE 11
        // ua = 'Mozilla/5.0 (Windows NT 6.3; Trident/7.0; rv:11.0) like Gecko';
        // Edge
        // ua = 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML,
        // like Gecko) Chrome/39.0.2171.71 Safari/537.36 Edge/12.0';
        // iOS Safari: Disable for users running iOS version < 10.
                return !(t.indexOf("MSIE ") > 0 || t.indexOf("Trident/") > 0 || t.indexOf("Edge/") > 0 || s || r);
    }
    /**
     * Returns true if the backing IndexedDB store is the Node IndexedDBShim
     * (see https://github.com/axemclion/IndexedDBShim).
     */    static Jo() {
        var t;
        return "undefined" != typeof process && "YES" === (null === (t = process.env) || void 0 === t ? void 0 : t.Xo);
    }
    /** Helper to get a typed SimpleDbStore from a transaction. */    static Zo(t, e) {
        return t.store(e);
    }
    // visible for testing
    /** Parse User Agent to determine iOS version. Returns -1 if not found. */
    static Ko(t) {
        const e = t.match(/i(?:phone|pad|pod) os ([\d_]+)/i), s = e ? e[1].split("_").slice(0, 2).join(".") : "-1";
        return Number(s);
    }
    // visible for testing
    /** Parse User Agent to determine Android version. Returns -1 if not found. */
    static Yo(t) {
        const e = t.match(/Android ([\d.]+)/i), s = e ? e[1].split(".").slice(0, 2).join(".") : "-1";
        return Number(s);
    }
    th(t) {
        this.db.onversionchange = e => t(e);
    }
    async runTransaction(t, e, s) {
        const n = t.startsWith("readonly"), i = t.endsWith("idempotent");
        let r = 0;
        for (;;) {
            ++r;
            const t = fn.open(this.db, n ? "readonly" : "readwrite", e);
            try {
                const e = s(t).catch(e => (
                // Abort the transaction if there was an error.
                t.abort(e), on.reject(e))).Do();
                // As noted above, errors are propagated by aborting the transaction. So
                // we swallow any error here to avoid the browser logging it as unhandled.
                                return e.catch(() => {}), 
                // Wait for the transaction to complete (i.e. IndexedDb's onsuccess event to
                // fire), but still return the original transactionFnResult back to the
                // caller.
                await t.eh, e;
            } catch (t) {
                // TODO(schmidt-sebastian): We could probably be smarter about this and
                // not retry exceptions that are likely unrecoverable (such as quota
                // exceeded errors).
                // Note: We cannot use an instanceof check for FirestoreException, since the
                // exception is wrapped in a generic error by our async/await handling.
                const e = i && "FirebaseError" !== t.name && r < ln;
                if (A(cn, "Transaction failed with error: %s. Retrying: %s.", t.message, e), !e) return Promise.reject(t);
            }
        }
    }
    close() {
        this.db.close();
    }
}

/**
 * A controller for iterating over a key range or index. It allows an iterate
 * callback to delete the currently-referenced object, or jump to a new key
 * within the key range or index.
 */ class dn {
    constructor(t) {
        this.sh = t, this.nh = !1, this.ih = null;
    }
    get yo() {
        return this.nh;
    }
    get rh() {
        return this.ih;
    }
    set cursor(t) {
        this.sh = t;
    }
    /**
     * This function can be called to stop iteration at any point.
     */    done() {
        this.nh = !0;
    }
    /**
     * This function can be called to skip to that next key, which could be
     * an index or a primary key.
     */    oh(t) {
        this.ih = t;
    }
    /**
     * Delete the current cursor value from the object store.
     *
     * NOTE: You CANNOT do this with a keysOnly query.
     */    delete() {
        return Tn(this.sh.delete());
    }
}

/**
 * Wraps an IDBTransaction and exposes a store() method to get a handle to a
 * specific object store.
 */ class fn {
    constructor(t) {
        this.transaction = t, this.aborted = !1, 
        /**
         * A promise that resolves with the result of the IndexedDb transaction.
         */
        this.hh = new qs, this.transaction.oncomplete = () => {
            this.hh.resolve();
        }, this.transaction.onabort = () => {
            t.error ? this.hh.reject(t.error) : this.hh.resolve();
        }, this.transaction.onerror = t => {
            const e = En(t.target.error);
            this.hh.reject(e);
        };
    }
    static open(t, e, s) {
        return new fn(t.transaction(s, e));
    }
    get eh() {
        return this.hh.promise;
    }
    abort(t) {
        t && this.hh.reject(t), this.aborted || (A(cn, "Aborting transaction:", t ? t.message : "Client-initiated abort"), 
        this.aborted = !0, this.transaction.abort());
    }
    /**
     * Returns a SimpleDbStore<KeyType, ValueType> for the specified store. All
     * operations performed on the SimpleDbStore happen within the context of this
     * transaction and it cannot be used anymore once the transaction is
     * completed.
     *
     * Note that we can't actually enforce that the KeyType and ValueType are
     * correct, but they allow type safety through the rest of the consuming code.
     */    store(t) {
        const e = this.transaction.objectStore(t);
        return g(!!e, "Object store not part of transaction: " + t), new mn(e);
    }
}

/**
 * A wrapper around an IDBObjectStore providing an API that:
 *
 * 1) Has generic KeyType / ValueType parameters to provide strongly-typed
 * methods for acting against the object store.
 * 2) Deals with IndexedDB's onsuccess / onerror event callbacks, making every
 * method return a PersistencePromise instead.
 * 3) Provides a higher-level API to avoid needing to do excessive wrapping of
 * intermediate IndexedDB types (IDBCursorWithValue, etc.)
 */ class mn {
    constructor(t) {
        this.store = t;
    }
    put(t, e) {
        let s;
        return void 0 !== e ? (A(cn, "PUT", this.store.name, t, e), s = this.store.put(e, t)) : (A(cn, "PUT", this.store.name, "<auto-key>", t), 
        s = this.store.put(t)), Tn(s);
    }
    /**
     * Adds a new value into an Object Store and returns the new key. Similar to
     * IndexedDb's `add()`, this method will fail on primary key collisions.
     *
     * @param value The object to write.
     * @return The key of the value to add.
     */    add(t) {
        return A(cn, "ADD", this.store.name, t, t), Tn(this.store.add(t));
    }
    /**
     * Gets the object with the specified key from the specified store, or null
     * if no object exists with the specified key.
     *
     * @key The key of the object to get.
     * @return The object with the specified key or null if no object exists.
     */    get(t) {
        // We're doing an unsafe cast to ValueType.
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        return Tn(this.store.get(t)).next(e => (
        // Normalize nonexistence to null.
        void 0 === e && (e = null), A(cn, "GET", this.store.name, t, e), e));
    }
    delete(t) {
        return A(cn, "DELETE", this.store.name, t), Tn(this.store.delete(t));
    }
    /**
     * If we ever need more of the count variants, we can add overloads. For now,
     * all we need is to count everything in a store.
     *
     * Returns the number of rows in the store.
     */    count() {
        return A(cn, "COUNT", this.store.name), Tn(this.store.count());
    }
    ah(t, e) {
        const s = this.cursor(this.options(t, e)), n = [];
        return this.uh(s, (t, e) => {
            n.push(e);
        }).next(() => n);
    }
    lh(t, e) {
        A(cn, "DELETE ALL", this.store.name);
        const s = this.options(t, e);
        s._h = !1;
        const n = this.cursor(s);
        return this.uh(n, (t, e, s) => s.delete());
    }
    dh(t, e) {
        let s;
        e ? s = t : (s = {}, e = t);
        const n = this.cursor(s);
        return this.uh(n, e);
    }
    /**
     * Iterates over a store, but waits for the given callback to complete for
     * each entry before iterating the next entry. This allows the callback to do
     * asynchronous work to determine if this iteration should continue.
     *
     * The provided callback should return `true` to continue iteration, and
     * `false` otherwise.
     */    fh(t) {
        const e = this.cursor({});
        return new on((s, n) => {
            e.onerror = t => {
                const e = En(t.target.error);
                n(e);
            }, e.onsuccess = e => {
                const n = e.target.result;
                n ? t(n.primaryKey, n.value).next(t => {
                    t ? n.continue() : s();
                }) : s();
            };
        });
    }
    uh(t, e) {
        const s = [];
        return new on((n, i) => {
            t.onerror = t => {
                i(t.target.error);
            }, t.onsuccess = t => {
                const i = t.target.result;
                if (!i) return void n();
                const r = new dn(i), o = e(i.primaryKey, i.value, r);
                if (o instanceof on) {
                    const t = o.catch(t => (r.done(), on.reject(t)));
                    s.push(t);
                }
                r.yo ? n() : null === r.rh ? i.continue() : i.continue(r.rh);
            };
        }).next(() => on.ko(s));
    }
    options(t, e) {
        let s = void 0;
        return void 0 !== t && ("string" == typeof t ? s = t : (g(void 0 === e, "3rd argument must not be defined if 2nd is a range."), 
        e = t)), {
            index: s,
            range: e
        };
    }
    cursor(t) {
        let e = "next";
        if (t.reverse && (e = "prev"), t.index) {
            const s = this.store.index(t.index);
            return t._h ? s.openKeyCursor(t.range, e) : s.openCursor(t.range, e);
        }
        return this.store.openCursor(t.range, e);
    }
}

/**
 * Wraps an IDBRequest in a PersistencePromise, using the onsuccess / onerror
 * handlers to resolve / reject the PersistencePromise as appropriate.
 */ function Tn(t) {
    return new on((e, s) => {
        t.onsuccess = t => {
            const s = t.target.result;
            e(s);
        }, t.onerror = t => {
            const e = En(t.target.error);
            s(e);
        };
    });
}

// Guard so we only report the error once.
let wn = !1;

function En(t) {
    const e = _n.Ko(n());
    if (e >= 12.2 && e < 13) {
        const e = "An internal error was encountered in the Indexed Database server";
        if (t.message.indexOf(e) >= 0) {
            // Wrap error in a more descriptive one.
            const t = new $("internal", `IOS_INDEXEDDB_BUG1: IndexedDb has thrown '${e}'. This is likely ` + "due to an unavoidable bug in iOS. See https://stackoverflow.com/q/56496296/110915 for details and a potential workaround.");
            return wn || (wn = !0, 
            // Throw a global exception outside of this promise chain, for the user to
            // potentially catch.
            setTimeout(() => {
                throw t;
            }, 0)), t;
        }
    }
    return t;
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** A mutation queue for a specific user, backed by IndexedDB. */ class In {
    constructor(
    /**
     * The normalized userId (e.g. null UID => "" userId) used to store /
     * retrieve mutations.
     */
    t, e, s, n) {
        this.userId = t, this.serializer = e, this.mh = s, this.Th = n, 
        /**
         * Caches the document keys for pending mutation batches. If the mutation
         * has been removed from IndexedDb, the cached value may continue to
         * be used to retrieve the batch's document keys. To remove a cached value
         * locally, `removeCachedMutationKeys()` should be invoked either directly
         * or through `removeMutationBatches()`.
         *
         * With multi-tab, when the primary client acknowledges or rejects a mutation,
         * this cache is used by secondary clients to invalidate the local
         * view of the documents that were previously affected by the mutation.
         */
        // PORTING NOTE: Multi-tab only.
        this.wh = {};
    }
    /**
     * Creates a new mutation queue for the given user.
     * @param user The user for which to create a mutation queue.
     * @param serializer The serializer to use when persisting to IndexedDb.
     */    static Eh(t, e, s, n) {
        // TODO(mcg): Figure out what constraints there are on userIDs
        // In particular, are there any reserved characters? are empty ids allowed?
        // For the moment store these together in the same mutations table assuming
        // that empty userIDs aren't allowed.
        g("" !== t.uid, "UserID must not be an empty string.");
        const i = t.l() ? t.uid : "";
        return new In(i, e, s, n);
    }
    Ih(t) {
        let e = !0;
        const s = IDBKeyRange.bound([ this.userId, Number.NEGATIVE_INFINITY ], [ this.userId, Number.POSITIVE_INFINITY ]);
        return Pn(t).dh({
            index: ri.userMutationsIndex,
            range: s
        }, (t, s, n) => {
            e = !1, n.done();
        }).next(() => e);
    }
    Rh(t, e, s) {
        return this.Ah(t).next(e => (
        // We can't store the resumeToken as a ByteString in IndexedDB, so we
        // convert it to a Base64 string for storage.
        e.lastStreamToken = s.toBase64(), Vn(t).put(e)));
    }
    Ph(t) {
        return this.Ah(t).next(t => Qe.fromBase64String(t.lastStreamToken));
    }
    ph(t, e) {
        return this.Ah(t).next(s => (
        // We can't store the resumeToken as a ByteString in IndexedDB, so we
        // convert it to a Base64 string for storage.
        s.lastStreamToken = e.toBase64(), Vn(t).put(s)));
    }
    Vh(t, e, s, n) {
        const i = pn(t), r = Pn(t);
        // The IndexedDb implementation in Chrome (and Firefox) does not handle
        // compound indices that include auto-generated keys correctly. To ensure
        // that the index entry is added correctly in all browsers, we perform two
        // writes: The first write is used to retrieve the next auto-generated Batch
        // ID, and the second write populates the index and stores the actual
        // mutation batch.
        // See: https://bugs.chromium.org/p/chromium/issues/detail?id=701972
        // We write an empty object to obtain key
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        return r.add({}).next(o => {
            g("number" == typeof o, "Auto-generated key is not a number");
            const h = new tn(o, e, s, n), a = this.serializer.gh(this.userId, h), u = [];
            let c = new pt((t, e) => b(t.tt(), e.tt()));
            for (const t of n) {
                const e = oi.key(this.userId, t.key.path, o);
                c = c.add(t.key.path.K()), u.push(r.put(a)), u.push(i.put(e, oi.PLACEHOLDER));
            }
            return c.forEach(e => {
                u.push(this.mh.yh(t, e));
            }), t.jo(() => {
                this.wh[o] = h.keys();
            }), on.ko(u).next(() => h);
        });
    }
    bh(t, e) {
        return Pn(t).get(e).next(t => t ? (g(t.userId === this.userId, `Unexpected user '${t.userId}' for mutation batch ${e}`), 
        this.serializer.vh(t)) : null);
    }
    Sh(t, e) {
        return this.wh[e] ? on.resolve(this.wh[e]) : this.bh(t, e).next(t => {
            if (t) {
                const s = t.keys();
                return this.wh[e] = s, s;
            }
            return null;
        });
    }
    Dh(t, e) {
        const s = e + 1, n = IDBKeyRange.lowerBound([ this.userId, s ]);
        let i = null;
        return Pn(t).dh({
            index: ri.userMutationsIndex,
            range: n
        }, (t, e, n) => {
            e.userId === this.userId && (g(e.batchId >= s, "Should have found mutation after " + s), 
            i = this.serializer.vh(e)), n.done();
        }).next(() => i);
    }
    Ch(t) {
        const e = IDBKeyRange.upperBound([ this.userId, Number.POSITIVE_INFINITY ]);
        let s = Zs;
        return Pn(t).dh({
            index: ri.userMutationsIndex,
            range: e,
            reverse: !0
        }, (t, e, n) => {
            s = e.batchId, n.done();
        }).next(() => s);
    }
    kh(t) {
        const e = IDBKeyRange.bound([ this.userId, Zs ], [ this.userId, Number.POSITIVE_INFINITY ]);
        return Pn(t).ah(ri.userMutationsIndex, e).next(t => t.map(t => this.serializer.vh(t)));
    }
    Nh(t, e) {
        // Scan the document-mutation index starting with a prefix starting with
        // the given documentKey.
        const s = oi.prefixForPath(this.userId, e.path), n = IDBKeyRange.lowerBound(s), i = [];
        return pn(t).dh({
            range: n
        }, (s, n, r) => {
            const [o, h, a] = s, u = Xs(h);
            // Only consider rows matching exactly the specific key of
            // interest. Note that because we order by path first, and we
            // order terminators before path separators, we'll encounter all
            // the index rows for documentKey contiguously. In particular, all
            // the rows for documentKey will occur before any rows for
            // documents nested in a subcollection beneath documentKey so we
            // can stop as soon as we hit any such row.
                        if (o === this.userId && e.path.isEqual(u)) 
            // Look up the mutation batch in the store.
            return Pn(t).get(a).next(t => {
                if (!t) throw V("Dangling document-mutation reference found: " + s + " which points to " + a);
                g(t.userId === this.userId, `Unexpected user '${t.userId}' for mutation batch ${a}`), 
                i.push(this.serializer.vh(t));
            });
            r.done();
        }).next(() => i);
    }
    Fh(t, e) {
        let s = new pt(b);
        const n = [];
        return e.forEach(e => {
            const i = oi.prefixForPath(this.userId, e.path), r = IDBKeyRange.lowerBound(i), o = pn(t).dh({
                range: r
            }, (t, n, i) => {
                const [r, o, h] = t, a = Xs(o);
                // Only consider rows matching exactly the specific key of
                // interest. Note that because we order by path first, and we
                // order terminators before path separators, we'll encounter all
                // the index rows for documentKey contiguously. In particular, all
                // the rows for documentKey will occur before any rows for
                // documents nested in a subcollection beneath documentKey so we
                // can stop as soon as we hit any such row.
                                r === this.userId && e.path.isEqual(a) ? s = s.add(h) : i.done();
            });
            n.push(o);
        }), on.ko(n).next(() => this.$h(t, s));
    }
    xh(t, e) {
        g(!e.Qe(), "Document queries shouldn't go down this path"), g(!e.Is(), "CollectionGroup queries should be handled in LocalDocumentsView");
        const s = e.path, n = s.length + 1, i = oi.prefixForPath(this.userId, s), r = IDBKeyRange.lowerBound(i);
        // Collect up unique batchIDs encountered during a scan of the index. Use a
        // SortedSet to accumulate batch IDs so they can be traversed in order in a
        // scan of the main table.
        let o = new pt(b);
        return pn(t).dh({
            range: r
        }, (t, e, i) => {
            const [r, h, a] = t, u = Xs(h);
            r === this.userId && s.Y(u) ? 
            // Rows with document keys more than one segment longer than the
            // query path can't be matches. For example, a query on 'rooms'
            // can't match the document /rooms/abc/messages/xyx.
            // TODO(mcg): we'll need a different scanner when we implement
            // ancestor queries.
            u.length === n && (o = o.add(a)) : i.done();
        }).next(() => this.$h(t, o));
    }
    $h(t, e) {
        const s = [], n = [];
        // TODO(rockwood): Implement this using iterate.
        return e.forEach(e => {
            n.push(Pn(t).get(e).next(t => {
                if (null === t) throw V("Dangling document-mutation reference found, which points to " + e);
                g(t.userId === this.userId, `Unexpected user '${t.userId}' for mutation batch ${e}`), 
                s.push(this.serializer.vh(t));
            }));
        }), on.ko(n).next(() => s);
    }
    Mh(t, e) {
        return An(t.Lh, this.userId, e).next(s => (t.jo(() => {
            this.Bh(e.batchId);
        }), on.forEach(s, e => this.Th.qh(t, e))));
    }
    Bh(t) {
        delete this.wh[t];
    }
    Oh(t) {
        return this.Ih(t).next(e => {
            if (!e) return on.resolve();
            // Verify that there are no entries in the documentMutations index if
            // the queue is empty.
                        const s = IDBKeyRange.lowerBound(oi.prefixForUser(this.userId)), n = [];
            return pn(t).dh({
                range: s
            }, (t, e, s) => {
                if (t[0] === this.userId) {
                    const e = Xs(t[1]);
                    n.push(e);
                } else s.done();
            }).next(() => {
                g(0 === n.length, "Document leak -- detected dangling mutation references when queue is empty. Dangling keys: " + n.map(t => t.tt()));
            });
        });
    }
    Io(t, e) {
        return Rn(t, this.userId, e);
    }
    // PORTING NOTE: Multi-tab only (state is held in memory in other clients).
    /** Returns the mutation queue's metadata from IndexedDb. */
    Ah(t) {
        return Vn(t).get(this.userId).next(t => t || new ii(this.userId, Zs, 
        /*lastStreamToken=*/ ""));
    }
}

/**
 * @return true if the mutation queue for the given user contains a pending
 *         mutation for the given key.
 */ function Rn(t, e, s) {
    const n = oi.prefixForPath(e, s.path), i = n[1], r = IDBKeyRange.lowerBound(n);
    let o = !1;
    return pn(t).dh({
        range: r,
        _h: !0
    }, (t, s, n) => {
        const [r, h, /*batchID*/ a] = t;
        r === e && h === i && (o = !0), n.done();
    }).next(() => o);
}

/** Returns true if any mutation queue contains the given document. */
/**
 * Delete a mutation batch and the associated document mutations.
 * @return A PersistencePromise of the document mutations that were removed.
 */
function An(t, e, s) {
    const n = t.store(ri.store), i = t.store(oi.store), r = [], o = IDBKeyRange.only(s.batchId);
    let h = 0;
    const a = n.dh({
        range: o
    }, (t, e, s) => (h++, s.delete()));
    r.push(a.next(() => {
        g(1 === h, "Dangling document-mutation reference found: Missing batch " + s.batchId);
    }));
    const u = [];
    for (const t of s.mutations) {
        const n = oi.key(e, t.key.path, s.batchId);
        r.push(i.delete(n)), u.push(t.key);
    }
    return on.ko(r).next(() => u);
}

/**
 * Helper to get a typed SimpleDbStore for the mutations object store.
 */ function Pn(t) {
    return Si.Zo(t, ri.store);
}

/**
 * Helper to get a typed SimpleDbStore for the mutationQueues object store.
 */ function pn(t) {
    return Si.Zo(t, oi.store);
}

/**
 * Helper to get a typed SimpleDbStore for the mutationQueues object store.
 */ function Vn(t) {
    return Si.Zo(t, ii.store);
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const gn = 1;

var yn, bn;

(bn = yn || (yn = {}))[bn.Uh = 0] = "__PRIVATE_QueryCache", bn[bn.Qh = 1] = "__PRIVATE_SyncEngine";

/**
 * Generates monotonically increasing target IDs for sending targets to the
 * watch stream.
 *
 * The client constructs two generators, one for the query cache (via
 * forQueryCache()), and one for limbo documents (via forSyncEngine()). These
 * two generators produce non-overlapping IDs (by using even and odd IDs
 * respectively).
 *
 * By separating the target ID space, the query cache can generate target IDs
 * that persist across client restarts, while sync engine can independently
 * generate in-memory target IDs that are transient and can be reused after a
 * restart.
 */
// TODO(mrschmidt): Explore removing this class in favor of generating these IDs
// directly in SyncEngine and LocalStore.
class vn {
    /**
     * Instantiates a new TargetIdGenerator. If a seed is provided, the generator
     * will use the seed value as the next target ID.
     */
    constructor(t, e) {
        this.Wh = t, g((t & gn) === t, `Generator ID ${t} contains more than ${gn} reserved bits`), 
        this.jh(void 0 !== e ? e : this.Wh);
    }
    next() {
        const t = this.zh;
        return this.zh += 1 << gn, t;
    }
    /**
     * Returns the ID that follows the given ID. Subsequent calls to `next()`
     * use the newly returned target ID as their base.
     */
    // PORTING NOTE: Multi-tab only.
    after(t) {
        return this.jh(t + (1 << gn)), this.next();
    }
    jh(t) {
        g((t & gn) === this.Wh, "Cannot supply target ID from different generator ID"), 
        this.zh = t;
    }
    static Kh() {
        return new vn(yn.Uh, 2);
    }
    static Gh() {
        // Sync engine assigns target IDs for limbo document detection.
        return new vn(yn.Qh);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A readonly view of the local state of all documents we're tracking (i.e. we
 * have a cached version in remoteDocumentCache or local mutations for the
 * document). The view is computed by applying the mutations in the
 * MutationQueue to the RemoteDocumentCache.
 */ class Sn {
    constructor(t, e, s) {
        this.Hh = t, this.Jh = e, this.mh = s;
    }
    /**
     * Get the local view of the document identified by `key`.
     *
     * @return Local view of the document or null if we don't have any cached
     * state for it.
     */    Yh(t, e) {
        return this.Jh.Nh(t, e).next(s => this.Xh(t, e, s));
    }
    /** Internal version of `getDocument` that allows reusing batches. */    Xh(t, e, s) {
        return this.Hh.qo(t, e).next(t => {
            for (const n of s) t = n.Qt(e, t);
            return t;
        });
    }
    // Returns the view of the given `docs` as they would appear after applying
    // all mutations in the given `batches`.
    Zh(t, e, s) {
        let n = Ze();
        return e.forEach((t, e) => {
            for (const n of s) e = n.Qt(t, e);
            n = n.lt(t, e);
        }), n;
    }
    /**
     * Gets the local view of the documents identified by `keys`.
     *
     * If we don't have cached state for a document in `keys`, a NoDocument will
     * be stored for that key in the resulting set.
     */    ta(t, e) {
        return this.Hh.getEntries(t, e).next(e => this.ea(t, e));
    }
    /**
     * Similar to `getDocuments`, but creates the local view from the given
     * `baseDocs` without retrieving documents from the local store.
     */    ea(t, e) {
        return this.Jh.Fh(t, e).next(s => {
            const n = this.Zh(t, e, s);
            let i = Xe();
            return n.forEach((t, e) => {
                // TODO(http://b/32275378): Don't conflate missing / deleted.
                e || (e = new ce(t, dt.B())), i = i.lt(t, e);
            }), i;
        });
    }
    /**
     * Performs a query against the local view of all documents.
     *
     * @param transaction The persistence transaction.
     * @param query The query to match documents against.
     * @param sinceReadTime If not set to SnapshotVersion.MIN, return only
     *     documents that have been read since this snapshot version (exclusive).
     */    sa(t, e, s) {
        return e.Qe() ? this.na(t, e.path) : e.Is() ? this.ia(t, e, s) : this.ra(t, e, s);
    }
    na(t, e) {
        // Just do a simple document lookup.
        return this.Yh(t, new It(e)).next(t => {
            let e = es();
            return t instanceof ue && (e = e.lt(t.key, t)), e;
        });
    }
    ia(t, e, s) {
        g(e.path.G(), "Currently we only support collection group queries at the root.");
        const n = e.collectionGroup;
        let i = es();
        return this.mh.oa(t, n).next(r => on.forEach(r, r => {
            const o = e.as(r.child(n));
            return this.ra(t, o, s).next(t => {
                t.forEach((t, e) => {
                    i = i.lt(t, e);
                });
            });
        }).next(() => i));
    }
    ra(t, e, s) {
        // Query the remote documents and overlay mutations.
        let n, i;
        return this.Hh.sa(t, e, s).next(s => (n = s, this.Jh.xh(t, e))).next(e => (i = e, 
        this.ha(t, i, n).next(t => {
            n = t;
            for (const t of i) for (const e of t.mutations) {
                const s = e.key, i = n.get(s), r = e.Qt(i, i, t.Fe);
                n = r instanceof ue ? n.lt(s, r) : n.remove(s);
            }
        }))).next(() => (
        // Finally, filter out any documents that don't actually match
        // the query.
        n.forEach((t, s) => {
            e.matches(s) || (n = n.remove(t));
        }), n));
    }
    ha(t, e, s) {
        let n = rs();
        for (const t of e) for (const e of t.mutations) e instanceof Ut && null === s.get(e.key) && (n = n.add(e.key));
        let i = s;
        return this.Hh.getEntries(t, n).next(t => (t.forEach((t, e) => {
            null !== e && e instanceof ue && (i = i.lt(t, e));
        }), i));
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A set of changes to what documents are currently in view and out of view for
 * a given query. These changes are sent to the LocalStore by the View (via
 * the SyncEngine) and are used to pin / unpin documents as appropriate.
 */ class Dn {
    constructor(t, e, s, n) {
        this.targetId = t, this.fromCache = e, this.aa = s, this.ua = n;
    }
    static ca(t, e) {
        let s = rs(), n = rs();
        for (const t of e.docChanges) switch (t.type) {
          case us.Os:
            s = s.add(t.doc.key);
            break;

          case us.Us:
            n = n.add(t.doc.key);
 // do nothing
                }
        return new Dn(t, e.fromCache, s, n);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const Cn = "LocalStore";

/**
 * Local storage in the Firestore client. Coordinates persistence components
 * like the mutation queue and remote document cache to present a
 * latency-compensated view of stored data.
 *
 * The LocalStore is responsible for accepting mutations from the Sync Engine.
 * Writes from the client are put into a queue as provisional Mutations until
 * they are processed by the RemoteStore and confirmed as having been written
 * to the server.
 *
 * The local store provides the local version of documents that have been
 * modified locally. It maintains the constraint:
 *
 *   LocalDocument = RemoteDocument + Active(LocalMutations)
 *
 * (Active mutations are those that are enqueued and have not been previously
 * acknowledged or rejected).
 *
 * The RemoteDocument ("ground truth") state is provided via the
 * applyChangeBatch method. It will be some version of a server-provided
 * document OR will be a server-provided document PLUS acknowledged mutations:
 *
 *   RemoteDocument' = RemoteDocument + Acknowledged(LocalMutations)
 *
 * Note that this "dirty" version of a RemoteDocument will not be identical to a
 * server base version, since it has LocalMutations added to it pending getting
 * an authoritative copy from the server.
 *
 * Since LocalMutations can be rejected by the server, we have to be able to
 * revert a LocalMutation that has already been applied to the LocalDocument
 * (typically done by replaying all remaining LocalMutations to the
 * RemoteDocument to re-apply).
 *
 * The LocalStore is responsible for the garbage collection of the documents it
 * contains. For now, it every doc referenced by a view, the mutation queue, or
 * the RemoteStore.
 *
 * It also maintains the persistence of mapping queries to resume tokens and
 * target ids. It needs to know this data about queries to properly know what
 * docs it would be allowed to garbage collect.
 *
 * The LocalStore must be able to efficiently execute queries against its local
 * cache of the documents, to provide the initial set of results before any
 * remote changes have been received.
 *
 * Note: In TypeScript, most methods return Promises since the implementation
 * may rely on fetching data from IndexedDB which is async.
 * These Promises will only be rejected on an I/O error or other internal
 * (unexpected) failure (e.g. failed assert) and always represent an
 * unrecoverable error (should be caught / reported by the async_queue).
 */ class kn {
    constructor(
    /** Manages our in-memory or durable persistence. */
    t, e, s) {
        this.persistence = t, this.la = e, 
        /**
         * The set of document references maintained by any local views.
         */
        this._a = new sn, 
        /**
         * Maps a targetID to data about its target.
         *
         * PORTING NOTE: We are using an immutable data structure on Web to make re-runs
         * of `applyRemoteEvent()` idempotent.
         */
        this.da = new Rt(b), 
        /** Maps a target to its targetID. */
        // TODO(wuandy): Evaluate if TargetId can be part of Target.
        this.fa = new rn(t => t.canonicalId()), 
        /**
         * The read time of the last entry processed by `getNewDocumentChanges()`.
         *
         * PORTING NOTE: This is only used for multi-tab synchronization.
         */
        this.ma = dt.MIN, g(t.Ta, "LocalStore was passed an unstarted persistence implementation"), 
        this.persistence.Th.wa(this._a), this.Jh = t.Ea(s), this.Ia = t.Ra(), this.Aa = t.Pa(), 
        this.pa = new Sn(this.Ia, this.Jh, this.persistence.Va()), this.la.ga(this.pa);
    }
    /** Starts the LocalStore. */    start() {
        return this.ya();
    }
    /**
     * Tells the LocalStore that the currently authenticated user has changed.
     *
     * In response the local store switches the mutation queue to the new user and
     * returns any resulting document changes.
     */
    // PORTING NOTE: Android and iOS only return the documents affected by the
    // change.
    async ba(t) {
        let e = this.Jh, s = this.pa;
        const n = await this.persistence.runTransaction("Handle user change", "readonly-idempotent", n => {
            // Swap out the mutation queue, grabbing the pending mutation batches
            // before and after.
            let i;
            return this.Jh.kh(n).next(r => (i = r, e = this.persistence.Ea(t), 
            // Recreate our LocalDocumentsView using the new
            // MutationQueue.
            s = new Sn(this.Ia, e, this.persistence.Va()), e.kh(n))).next(t => {
                const e = [], r = [];
                // Union the old/new changed keys.
                let o = rs();
                for (const t of i) {
                    e.push(t.batchId);
                    for (const e of t.mutations) o = o.add(e.key);
                }
                for (const e of t) {
                    r.push(e.batchId);
                    for (const t of e.mutations) o = o.add(t.key);
                }
                // Return the set of all (potentially) changed documents and the list
                // of mutation batch IDs that were affected by change.
                                return s.ta(n, o).next(t => ({
                    va: t,
                    Sa: e,
                    Da: r
                }));
            });
        });
        return this.Jh = e, this.pa = s, this.la.ga(this.pa), n;
    }
    /* Accept locally generated Mutations and commit them to storage. */    Ca(t) {
        const e = _t.now(), s = t.reduce((t, e) => t.add(e.key), rs());
        let n;
        return this.persistence.runTransaction("Locally write mutations", "readwrite-idempotent", i => this.pa.ta(i, s).next(s => {
            n = s;
            // For non-idempotent mutations (such as `FieldValue.increment()`),
            // we record the base state in a separate patch mutation. This is
            // later used to guarantee consistent values and prevents flicker
            // even if the backend sends us an update that already includes our
            // transform.
            const r = [];
            for (const e of t) {
                const t = e.re(n.get(e.key));
                null != t && 
                // NOTE: The base state should only be applied if there's some
                // existing document to override, so use a Precondition of
                // exists=true
                r.push(new Ut(e.key, t, t.oe(), Bt.exists(!0)));
            }
            return this.Jh.Vh(i, e, r, t);
        })).then(t => {
            const e = t.ro(n);
            return {
                batchId: t.batchId,
                Fo: e
            };
        });
    }
    /** Returns the local view of the documents affected by a mutation batch. */
    // PORTING NOTE: Multi-tab only.
    ka(t) {
        return this.persistence.runTransaction("Lookup mutation documents", "readonly-idempotent", e => this.Jh.Sh(e, t).next(t => t ? this.pa.ta(e, t) : on.resolve(null)));
    }
    /**
     * Acknowledge the given batch.
     *
     * On the happy path when a batch is acknowledged, the local store will
     *
     *  + remove the batch from the mutation queue;
     *  + apply the changes to the remote document cache;
     *  + recalculate the latency compensated view implied by those changes (there
     *    may be mutations in the queue that affect the documents but haven't been
     *    acknowledged yet); and
     *  + give the changed documents back the sync engine
     *
     * @returns The resulting (modified) documents.
     */    Rh(t) {
        return this.persistence.runTransaction("Acknowledge batch", "readwrite-primary-idempotent", e => {
            const s = t.batch.keys(), n = this.Ia.Na({
                Fa: !0
            });
            return this.Jh.Rh(e, t.batch, t.streamToken).next(() => this.$a(e, t, n)).next(() => n.apply(e)).next(() => this.Jh.Oh(e)).next(() => this.pa.ta(e, s));
        });
    }
    /**
     * Remove mutations from the MutationQueue for the specified batch;
     * LocalDocuments will be recalculated.
     *
     * @returns The resulting modified documents.
     */    xa(t) {
        return this.persistence.runTransaction("Reject batch", "readwrite-primary-idempotent", e => {
            let s;
            return this.Jh.bh(e, t).next(t => (g(null !== t, "Attempt to reject nonexistent batch!"), 
            s = t.keys(), this.Jh.Mh(e, t))).next(() => this.Jh.Oh(e)).next(() => this.pa.ta(e, s));
        });
    }
    /**
     * Returns the largest (latest) batch id in mutation queue that is pending server response.
     * Returns `BATCHID_UNKNOWN` if the queue is empty.
     */    Ch() {
        return this.persistence.runTransaction("Get highest unacknowledged batch id", "readonly-idempotent", t => this.Jh.Ch(t));
    }
    /** Returns the last recorded stream token for the current user. */    Ph() {
        return this.persistence.runTransaction("Get last stream token", "readonly-idempotent", t => this.Jh.Ph(t));
    }
    /**
     * Sets the stream token for the current user without acknowledging any
     * mutation batch. This is usually only useful after a stream handshake or in
     * response to an error that requires clearing the stream token.
     */    ph(t) {
        return this.persistence.runTransaction("Set last stream token", "readwrite-primary-idempotent", e => this.Jh.ph(e, t));
    }
    /**
     * Returns the last consistent snapshot processed (used by the RemoteStore to
     * determine whether to buffer incoming snapshots from the backend).
     */    Ma() {
        return this.persistence.runTransaction("Get last remote snapshot version", "readonly-idempotent", t => this.Aa.Ma(t));
    }
    /**
     * Update the "ground-state" (remote) documents. We assume that the remote
     * event reflects any write batches that have been acknowledged or rejected
     * (i.e. we do not re-apply local mutations to updates from this event).
     *
     * LocalDocuments are re-calculated if there are remaining mutations in the
     * queue.
     */    La(t) {
        const e = t.Fs;
        let s = this.da;
        return this.persistence.runTransaction("Apply remote event", "readwrite-primary-idempotent", n => {
            const i = this.Ia.Na({
                Fa: !0
            });
            // Reset newTargetDataByTargetMap in case this transaction gets re-run.
                        s = this.da;
            const r = [];
            Q(t.tn, (t, i) => {
                const o = s.get(t);
                if (!o) return;
                // Only update the remote keys if the target is still active. This
                // ensures that we can persist the updated target data along with
                // the updated assignment.
                                r.push(this.Aa.Ba(n, i.un, t).next(() => this.Aa.qa(n, i.hn, t)));
                const h = i.resumeToken;
                // Update the resume token if the change includes one.
                                if (h.Se() > 0) {
                    const a = o.xs(h, e).$s(n.Oa);
                    s = s.lt(t, a), 
                    // Update the target data if there are target changes (or if
                    // sufficient time has passed since the last update).
                    kn.Ua(o, a, i) && r.push(this.Aa.Qa(n, a));
                }
            });
            let o = Xe(), h = rs();
            // HACK: The only reason we allow a null snapshot version is so that we
            // can synthesize remote events when we get permission denied errors while
            // trying to resolve the state of a locally cached document that is in
            // limbo.
            if (t.sn.forEach((t, e) => {
                h = h.add(t);
            }), 
            // Each loop iteration only affects its "own" doc, so it's safe to get all the remote
            // documents in advance in a single call.
            r.push(i.getEntries(n, h).next(s => {
                t.sn.forEach((h, a) => {
                    const u = s.get(h);
                    // Note: The order of the steps below is important, since we want
                    // to ensure that rejected limbo resolutions (which fabricate
                    // NoDocuments with SnapshotVersion.MIN) never add documents to
                    // cache.
                                        a instanceof ce && a.version.isEqual(dt.MIN) ? (
                    // NoDocuments with SnapshotVersion.MIN are used in manufactured
                    // events. We remove these documents from cache since we lost
                    // access.
                    i.Bo(h, e), o = o.lt(h, a)) : null == u || a.version.u(u.version) > 0 || 0 === a.version.u(u.version) && u.hasPendingWrites ? (g(!dt.MIN.isEqual(e), "Cannot add a document when the remote version is zero"), 
                    i.Mo(a, e), o = o.lt(h, a)) : A(Cn, "Ignoring outdated watch update for ", h, ". Current version:", u.version, " Watch version:", a.version), 
                    t.nn.has(h) && r.push(this.persistence.Th.Wa(n, h));
                });
            })), !e.isEqual(dt.MIN)) {
                const t = this.Aa.Ma(n).next(t => (g(e.u(t) >= 0, "Watch stream reverted to previous snapshot?? " + e + " < " + t), 
                this.Aa.ja(n, n.Oa, e)));
                r.push(t);
            }
            return on.ko(r).next(() => i.apply(n)).next(() => this.pa.ea(n, o));
        }).then(t => (this.da = s, t));
    }
    /**
     * Returns true if the newTargetData should be persisted during an update of
     * an active target. TargetData should always be persisted when a target is
     * being released and should not call this function.
     *
     * While the target is active, TargetData updates can be omitted when nothing
     * about the target has changed except metadata like the resume token or
     * snapshot version. Occasionally it's worth the extra write to prevent these
     * values from getting too stale after a crash, but this doesn't have to be
     * too frequent.
     */    static Ua(t, e, s) {
        // Always persist target data if we don't already have a resume token.
        if (g(e.resumeToken.Se() > 0, "Attempted to persist target data with no resume token"), 
        0 === t.resumeToken.Se()) return !0;
        // Don't allow resume token changes to be buffered indefinitely. This
        // allows us to be reasonably up-to-date after a crash and avoids needing
        // to loop over all active queries on shutdown. Especially in the browser
        // we may not get time to do anything interesting while the current tab is
        // closing.
                return e.Fs.q() - t.Fs.q() >= this.za || s.hn.size + s.an.size + s.un.size > 0;
        // Otherwise if the only thing that has changed about a target is its resume
        // token it's not worth persisting. Note that the RemoteStore keeps an
        // in-memory view of the currently active targets which includes the current
        // resume token, so stream failure or user changes will still use an
        // up-to-date resume token regardless of what we do here.
        }
    /**
     * Notify local store of the changed views to locally pin documents.
     */    Ka(t) {
        for (const e of t) {
            const t = e.targetId;
            if (this._a._o(e.aa, t), this._a.mo(e.ua, t), !e.fromCache) {
                const e = this.da.get(t);
                g(null !== e, `Can't set limbo-free snapshot version for unknown target: ${t}`);
                // Advance the last limbo free snapshot version
                const s = e.Fs, n = e.Ms(s);
                this.da = this.da.lt(t, n);
            }
        }
        return this.persistence.runTransaction("notifyLocalViewChanges", "readwrite-idempotent", e => on.forEach(t, t => on.forEach(t.ua, t => this.persistence.Th.do(e, t))));
    }
    /**
     * Gets the mutation batch after the passed in batchId in the mutation queue
     * or null if empty.
     * @param afterBatchId If provided, the batch to search after.
     * @returns The next mutation or null if there wasn't one.
     */    Ga(t) {
        return this.persistence.runTransaction("Get next mutation batch", "readonly-idempotent", e => (void 0 === t && (t = Zs), 
        this.Jh.Dh(e, t)));
    }
    /**
     * Read the current value of a Document with a given key or null if not
     * found - used for testing.
     */    Ha(t) {
        return this.persistence.runTransaction("read document", "readonly-idempotent", e => this.pa.Yh(e, t));
    }
    /**
     * Assigns the given target an internal ID so that its results can be pinned so
     * they don't get GC'd. A target must be allocated in the local store before
     * the store can be used to manage its view.
     *
     * Allocating an already allocated `Target` will return the existing `TargetData`
     * for that `Target`.
     */    Ja(t) {
        return this.persistence.runTransaction("Allocate target", "readwrite-idempotent", e => {
            let s;
            return this.Aa.Ya(e, t).next(n => n ? (
            // This target has been listened to previously, so reuse the
            // previous targetID.
            // TODO(mcg): freshen last accessed date?
            s = n, on.resolve(s)) : this.Aa.Xa(e).next(n => (s = new ze(t, n, Be.Ds, e.Oa), 
            this.Aa.Za(e, s).next(() => s))));
        }).then(e => (null === this.da.get(e.targetId) && (this.da = this.da.lt(e.targetId, e), 
        this.fa.set(t, e.targetId)), e));
    }
    /**
     * Returns the TargetData as seen by the LocalStore, including updates that may
     * have not yet been persisted to the TargetCache.
     */
    // Visible for testing.
    Ya(t, e) {
        const s = this.fa.get(e);
        return void 0 !== s ? on.resolve(this.da.get(s)) : this.Aa.Ya(t, e);
    }
    /**
     * Unpin all the documents associated with the given target. If
     * `keepPersistedTargetData` is set to false and Eager GC enabled, the method
     * directly removes the associated target data from the target cache.
     *
     * Releasing a non-existing `Target` is a no-op.
     */
    // PORTING NOTE: `keepPersistedTargetData` is multi-tab only.
    tu(t, e) {
        const s = this.da.get(t);
        g(null !== s, `Tried to release nonexistent target: ${t}`);
        const n = e ? "readwrite-idempotent" : "readwrite-primary-idempotent";
        return this.persistence.runTransaction("Release target", n, n => {
            // References for documents sent via Watch are automatically removed
            // when we delete a target's data from the reference delegate.
            // Since this does not remove references for locally mutated documents,
            // we have to remove the target associations for these documents
            // manually.
            // This operation needs to be run inside the transaction since EagerGC
            // uses the local view references during the transaction's commit.
            // Fortunately, the operation is safe to be re-run in case the
            // transaction fails since there are no side effects if the target has
            // already been removed.
            const i = this._a.To(t);
            return e ? on.resolve() : on.forEach(i, t => this.persistence.Th.do(n, t)).next(() => {
                this.persistence.Th.removeTarget(n, s);
            });
        }).then(() => {
            this.da = this.da.remove(t), this.fa.delete(s.target);
        });
    }
    /**
     * Runs the specified query against the local store and returns the results,
     * potentially taking advantage of query data from previous executions (such
     * as the set of remote keys).
     *
     * @param usePreviousResults Whether results from previous executions can
     * be used to optimize this query execution.
     */    eu(t, e) {
        let s = dt.MIN, n = rs();
        return this.persistence.runTransaction("Execute query", "readonly-idempotent", i => this.Ya(i, t.cs()).next(t => {
            if (t) return s = t.lastLimboFreeSnapshotVersion, this.Aa.su(i, t.targetId).next(t => {
                n = t;
            });
        }).next(() => this.la.sa(i, t, e ? s : dt.MIN, e ? n : rs())).next(t => ({
            documents: t,
            nu: n
        })));
    }
    /**
     * Returns the keys of the documents that are associated with the given
     * target id in the remote table.
     */    iu(t) {
        return this.persistence.runTransaction("Remote document keys", "readonly-idempotent", e => this.Aa.su(e, t));
    }
    // PORTING NOTE: Multi-tab only.
    ru() {
        return this.persistence.ru();
    }
    // PORTING NOTE: Multi-tab only.
    ou(t) {
        this.Jh.Bh(t);
    }
    // PORTING NOTE: Multi-tab only.
    hu(t) {
        this.persistence.hu(t);
    }
    $a(t, e, s) {
        const n = e.batch, i = n.keys();
        let r = on.resolve();
        return i.forEach(i => {
            r = r.next(() => s.qo(t, i)).next(t => {
                let r = t;
                const o = e.ho.get(i);
                g(null !== o, "ackVersions should contain every doc in the write."), (!r || r.version.u(o) < 0) && ((r = n.Wt(i, r, e)) ? 
                // We use the commitVersion as the readTime rather than the
                // document's updateTime since the updateTime is not advanced
                // for updates that do not modify the underlying document.
                s.Mo(r, e.oo) : g(!t, "Mutation batch " + n + " applied to document " + t + " resulted in null"));
            });
        }), r.next(() => this.Jh.Mh(t, n));
    }
    au(t) {
        return this.persistence.runTransaction("Collect garbage", "readwrite-primary-idempotent", e => t.uu(e, this.da));
    }
    // PORTING NOTE: Multi-tab only.
    cu(t) {
        const e = this.da.get(t);
        return e ? Promise.resolve(e.target) : this.persistence.runTransaction("Get target data", "readonly-idempotent", e => this.Aa.Yn(e, t).next(t => t ? t.target : null));
    }
    /**
     * Returns the set of documents that have been updated since the last call.
     * If this is the first call, returns the set of changes since client
     * initialization. Further invocations will return document changes since
     * the point of rejection.
     */
    // PORTING NOTE: Multi-tab only.
    lu() {
        return this.persistence.runTransaction("Get new document changes", "readonly-idempotent", t => this.Ia.lu(t, this.ma)).then(({_u: t, readTime: e}) => (this.ma = e, 
        t));
    }
    /**
     * Reads the newest document change from persistence and forwards the internal
     * synchronization marker so that calls to `getNewDocumentChanges()`
     * only return changes that happened after client initialization.
     */
    // PORTING NOTE: Multi-tab only.
    async ya() {
        this.ma = await this.persistence.runTransaction("Synchronize last document change read time", "readonly-idempotent", t => this.Ia.du(t));
    }
}

/**
 * The maximum time to leave a resume token buffered without writing it out.
 * This value is arbitrary: it's long enough to avoid several writes
 * (possibly indefinitely if updates come more frequently than this) but
 * short enough that restarting after crashing will still have a pretty
 * recent resume token.
 */
/**
 * Verifies the error thrown by a LocalStore operation. If a LocalStore
 * operation fails because the primary lease has been taken by another client,
 * we ignore the error (the persistence layer will immediately call
 * `applyPrimaryLease` to propagate the primary state change). All other errors
 * are re-thrown.
 *
 * @param err An error returned by a LocalStore operation.
 * @return A Promise that resolves after we recovered, or the original error.
 */
async function Nn(t) {
    if (t.code !== F.FAILED_PRECONDITION || t.message !== an) throw t;
    A(Cn, "Unexpectedly lost primary lease");
}

/**
 * @license
 * Copyright 2018 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ function Fn([t, e], [s, n]) {
    const i = b(t, s);
    return 0 === i ? b(e, n) : i;
}

/**
 * Used to calculate the nth sequence number. Keeps a rolling buffer of the
 * lowest n values passed to `addElement`, and finally reports the largest of
 * them in `maxValue`.
 */ kn.za = 3e8;

class $n {
    constructor(t) {
        this.fu = t, this.buffer = new pt(Fn), this.mu = 0;
    }
    Tu() {
        return ++this.mu;
    }
    wu(t) {
        const e = [ t, this.Tu() ];
        if (this.buffer.size < this.fu) this.buffer = this.buffer.add(e); else {
            const t = this.buffer.last();
            Fn(e, t) < 0 && (this.buffer = this.buffer.delete(t).add(e));
        }
    }
    get maxValue() {
        // Guaranteed to be non-empty. If we decide we are not collecting any
        // sequence numbers, nthSequenceNumber below short-circuits. If we have
        // decided that we are collecting n sequence numbers, it's because n is some
        // percentage of the existing sequence numbers. That means we should never
        // be in a situation where we are collecting sequence numbers but don't
        // actually have any.
        return this.buffer.last()[0];
    }
}

const xn = {
    Eu: !1,
    Iu: 0,
    Ru: 0,
    Au: 0
};

class Mn {
    constructor(
    // When we attempt to collect, we will only do so if the cache size is greater than this
    // threshold. Passing `COLLECTION_DISABLED` here will cause collection to always be skipped.
    t, 
    // The percentage of sequence numbers that we will attempt to collect
    e, 
    // A cap on the total number of sequence numbers that will be collected. This prevents
    // us from collecting a huge number of sequence numbers if the cache has grown very large.
    s) {
        this.Pu = t, this.pu = e, this.Vu = s;
    }
    static gu(t) {
        return new Mn(t, Mn.yu, Mn.bu);
    }
}

Mn.vu = -1, Mn.Su = 1048576, Mn.Du = 41943040, Mn.yu = 10, Mn.bu = 1e3, Mn.Cu = new Mn(Mn.Du, Mn.yu, Mn.bu), 
Mn.DISABLED = new Mn(Mn.vu, 0, 0);

/** How long we wait to try running LRU GC after SDK initialization. */
const Ln = 6e4, Bn = 3e5;

/** Minimum amount of time between GC checks, after the first one. */
/**
 * This class is responsible for the scheduling of LRU garbage collection. It handles checking
 * whether or not GC is enabled, as well as which delay to use before the next run.
 */
class qn {
    constructor(t, e, s) {
        this.ku = t, this.Sr = e, this.Nu = s, this.Fu = !1, this.$u = null;
    }
    start() {
        g(null === this.$u, "Cannot start an already started LruScheduler"), this.ku.params.Pu !== Mn.vu && this.xu();
    }
    stop() {
        this.$u && (this.$u.cancel(), this.$u = null);
    }
    get Ta() {
        return null !== this.$u;
    }
    xu() {
        g(null === this.$u, "Cannot schedule GC while a task is pending");
        const t = this.Fu ? Bn : Ln;
        A("LruGarbageCollector", `Garbage collection scheduled in ${t}ms`), this.$u = this.Sr.Yr(Os.br, t, () => (this.$u = null, 
        this.Fu = !0, this.Nu.au(this.ku).then(() => this.xu()).catch(Nn)));
    }
}

/** Implements the steps for LRU garbage collection. */ class On {
    constructor(t, e) {
        this.Mu = t, this.params = e;
    }
    /** Given a percentile of target to collect, returns the number of targets to collect. */    Lu(t, e) {
        return this.Mu.Bu(t).next(t => Math.floor(e / 100 * t));
    }
    /** Returns the nth sequence number, counting in order from the smallest. */    qu(t, e) {
        if (0 === e) return on.resolve(Bs.Ir);
        const s = new $n(e);
        return this.Mu.qn(t, t => s.wu(t.sequenceNumber)).next(() => this.Mu.Ou(t, t => s.wu(t))).next(() => s.maxValue);
    }
    /**
     * Removes targets with a sequence number equal to or less than the given upper bound, and removes
     * document associations with those targets.
     */    Uu(t, e, s) {
        return this.Mu.Uu(t, e, s);
    }
    /**
     * Removes documents that have a sequence number equal to or less than the upper bound and are not
     * otherwise pinned.
     */    Qu(t, e) {
        return this.Mu.Qu(t, e);
    }
    uu(t, e) {
        return this.params.Pu === Mn.vu ? (A("LruGarbageCollector", "Garbage collection skipped; disabled"), 
        on.resolve(xn)) : this.Wu(t).next(s => s < this.params.Pu ? (A("LruGarbageCollector", `Garbage collection skipped; Cache size ${s} ` + `is lower than threshold ${this.params.Pu}`), 
        xn) : this.ju(t, e));
    }
    Wu(t) {
        return this.Mu.Wu(t);
    }
    ju(t, e) {
        let s, n, i, r, o, h, a;
        const u = Date.now();
        return this.Lu(t, this.params.pu).next(e => (
        // Cap at the configured max
        e > this.params.Vu ? (A("LruGarbageCollector", "Capping sequence numbers to collect down " + `to the maximum of ${this.params.Vu} ` + `from ${e}`), 
        n = this.params.Vu) : n = e, r = Date.now(), this.qu(t, n))).next(n => (s = n, o = Date.now(), 
        this.Uu(t, s, e))).next(e => (i = e, h = Date.now(), this.Qu(t, s))).next(t => {
            if (a = Date.now(), I() <= E.DEBUG) {
                A("LruGarbageCollector", "LRU Garbage Collection\n" + `\tCounted targets in ${r - u}ms\n` + `\tDetermined least recently used ${n} in ` + `${o - r}ms\n` + `\tRemoved ${i} targets in ` + `${h - o}ms\n` + `\tRemoved ${t} documents in ` + `${a - h}ms\n` + `Total Duration: ${a - u}ms`);
            }
            return on.resolve({
                Eu: !0,
                Iu: n,
                Ru: i,
                Au: t
            });
        });
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class Un {
    constructor(t, e) {
        this.Th = t, this.serializer = e, 
        // PORTING NOTE: We don't cache global metadata for the target cache, since
        // some of it (in particular `highestTargetId`) can be modified by secondary
        // tabs. We could perhaps be more granular (and e.g. still cache
        // `lastRemoteSnapshotVersion` in memory) but for simplicity we currently go
        // to IndexedDb whenever we need to read metadata. We can revisit if it turns
        // out to have a meaningful performance impact.
        this.zu = vn.Kh();
    }
    Xa(t) {
        return this.Ku(t).next(e => (e.highestTargetId = this.zu.after(e.highestTargetId), 
        this.Gu(t, e).next(() => e.highestTargetId)));
    }
    Ma(t) {
        return this.Ku(t).next(t => dt.L(new _t(t.lastRemoteSnapshotVersion.seconds, t.lastRemoteSnapshotVersion.nanoseconds)));
    }
    Hu(t) {
        return jn(t.Lh);
    }
    ja(t, e, s) {
        return this.Ku(t).next(n => (n.highestListenSequenceNumber = e, s && (n.lastRemoteSnapshotVersion = s.O()), 
        e > n.highestListenSequenceNumber && (n.highestListenSequenceNumber = e), this.Gu(t, n)));
    }
    Za(t, e) {
        return this.Ju(t, e).next(() => this.Ku(t).next(s => (s.targetCount += 1, this.Yu(e, s), 
        this.Gu(t, s))));
    }
    Qa(t, e) {
        return this.Ju(t, e);
    }
    Xu(t, e) {
        return this.Zu(t, e.targetId).next(() => Qn(t).delete(e.targetId)).next(() => this.Ku(t)).next(e => (g(e.targetCount > 0, "Removing from an empty target cache"), 
        e.targetCount -= 1, this.Gu(t, e)));
    }
    /**
     * Drops any targets with sequence number less than or equal to the upper bound, excepting those
     * present in `activeTargetIds`. Document associations for the removed targets are also removed.
     * Returns the number of targets removed.
     */    Uu(t, e, s) {
        let n = 0;
        const i = [];
        return Qn(t).dh((r, o) => {
            const h = this.serializer.tc(o);
            h.sequenceNumber <= e && null === s.get(h.targetId) && (n++, i.push(this.Xu(t, h)));
        }).next(() => on.ko(i)).next(() => n);
    }
    /**
     * Call provided function with each `TargetData` that we have cached.
     */    qn(t, e) {
        return Qn(t).dh((t, s) => {
            const n = this.serializer.tc(s);
            e(n);
        });
    }
    Ku(t) {
        return Wn(t.Lh);
    }
    Gu(t, e) {
        return (s = t, Si.Zo(s, di.store)).put(di.key, e);
        /**
 * Helper to get a typed SimpleDbStore for the target globals object store.
 */
        var s;
    }
    Ju(t, e) {
        return Qn(t).put(this.serializer.ec(e));
    }
    /**
     * In-place updates the provided metadata to account for values in the given
     * TargetData. Saving is done separately. Returns true if there were any
     * changes to the metadata.
     */    Yu(t, e) {
        let s = !1;
        return t.targetId > e.highestTargetId && (e.highestTargetId = t.targetId, s = !0), 
        t.sequenceNumber > e.highestListenSequenceNumber && (e.highestListenSequenceNumber = t.sequenceNumber, 
        s = !0), s;
    }
    sc(t) {
        return this.Ku(t).next(t => t.targetCount);
    }
    Ya(t, e) {
        // Iterating by the canonicalId may yield more than one result because
        // canonicalId values are not required to be unique per target. This query
        // depends on the queryTargets index to be efficient.
        const s = e.canonicalId(), n = IDBKeyRange.bound([ s, Number.NEGATIVE_INFINITY ], [ s, Number.POSITIVE_INFINITY ]);
        let i = null;
        return Qn(t).dh({
            range: n,
            index: li.queryTargetsIndexName
        }, (t, s, n) => {
            const r = this.serializer.tc(s);
            // After finding a potential match, check that the target is
            // actually equal to the requested target.
                        e.isEqual(r.target) && (i = r, n.done());
        }).next(() => i);
    }
    qa(t, e, s) {
        // PORTING NOTE: The reverse index (documentsTargets) is maintained by
        // IndexedDb.
        const n = [], i = zn(t);
        return e.forEach(e => {
            const r = Hs(e.path);
            n.push(i.put(new _i(s, r))), n.push(this.Th.lo(t, e));
        }), on.ko(n);
    }
    Ba(t, e, s) {
        // PORTING NOTE: The reverse index (documentsTargets) is maintained by
        // IndexedDb.
        const n = zn(t);
        return on.forEach(e, e => {
            const i = Hs(e.path);
            return on.ko([ n.delete([ s, i ]), this.Th.do(t, e) ]);
        });
    }
    Zu(t, e) {
        const s = zn(t), n = IDBKeyRange.bound([ e ], [ e + 1 ], 
        /*lowerOpen=*/ !1, 
        /*upperOpen=*/ !0);
        return s.delete(n);
    }
    su(t, e) {
        const s = IDBKeyRange.bound([ e ], [ e + 1 ], 
        /*lowerOpen=*/ !1, 
        /*upperOpen=*/ !0), n = zn(t);
        let i = rs();
        return n.dh({
            range: s,
            _h: !0
        }, (t, e, s) => {
            const n = Xs(t[1]), r = new It(n);
            i = i.add(r);
        }).next(() => i);
    }
    Io(t, e) {
        const s = Hs(e.path), n = IDBKeyRange.bound([ s ], [ S(s) ], 
        /*lowerOpen=*/ !1, 
        /*upperOpen=*/ !0);
        let i = 0;
        return zn(t).dh({
            index: _i.documentTargetsIndex,
            _h: !0,
            range: n
        }, ([t, e], s, n) => {
            // Having a sentinel row for a document does not count as containing that document;
            // For the target cache, containing the document means the document is part of some
            // target.
            0 !== t && (i++, n.done());
        }).next(() => i > 0);
    }
    Yn(t, e) {
        return Qn(t).get(e).next(t => t ? this.serializer.tc(t) : null);
    }
}

/**
 * Helper to get a typed SimpleDbStore for the queries object store.
 */ function Qn(t) {
    return Si.Zo(t, li.store);
}

function Wn(t) {
    return _n.Zo(t, di.store).get(di.key).next(t => (g(null !== t, "Missing metadata row."), 
    t));
}

function jn(t) {
    return Wn(t).next(t => t.highestListenSequenceNumber);
}

/**
 * Helper to get a typed SimpleDbStore for the document target object store.
 */ function zn(t) {
    return Si.Zo(t, _i.store);
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class Kn {
    /**
     * @param {LocalSerializer} serializer The document serializer.
     * @param {IndexManager} indexManager The query indexes that need to be maintained.
     */
    constructor(t, e) {
        this.serializer = t, this.mh = e;
    }
    /**
     * Adds the supplied entries to the cache.
     *
     * All calls of `addEntry` are required to go through the RemoteDocumentChangeBuffer
     * returned by `newChangeBuffer()` to ensure proper accounting of metadata.
     */    Mo(t, e, s) {
        return Hn(t).put(Jn(e), s);
    }
    /**
     * Removes a document from the cache.
     *
     * All calls of `removeEntry`  are required to go through the RemoteDocumentChangeBuffer
     * returned by `newChangeBuffer()` to ensure proper accounting of metadata.
     */    Bo(t, e) {
        const s = Hn(t), n = Jn(e);
        return s.delete(n);
    }
    /**
     * Updates the current cache size.
     *
     * Callers to `addEntry()` and `removeEntry()` *must* call this afterwards to update the
     * cache's metadata.
     */    updateMetadata(t, e) {
        return this.getMetadata(t).next(s => (s.byteSize += e, this.nc(t, s)));
    }
    qo(t, e) {
        return Hn(t).get(Jn(e)).next(t => this.ic(t));
    }
    /**
     * Looks up an entry in the cache.
     *
     * @param documentKey The key of the entry to look up.
     * @return The cached MaybeDocument entry and its size, or null if we have nothing cached.
     */    rc(t, e) {
        return Hn(t).get(Jn(e)).next(t => {
            const e = this.ic(t);
            return e ? {
                oc: e,
                size: Yn(t)
            } : null;
        });
    }
    getEntries(t, e) {
        let s = Ze();
        return this.hc(t, e, (t, e) => {
            const n = this.ic(e);
            s = s.lt(t, n);
        }).next(() => s);
    }
    /**
     * Looks up several entries in the cache.
     *
     * @param documentKeys The set of keys entries to look up.
     * @return A map of MaybeDocuments indexed by key (if a document cannot be
     *     found, the key will be mapped to null) and a map of sizes indexed by
     *     key (zero if the key cannot be found).
     */    ac(t, e) {
        let s = Ze(), n = new Rt(It.U);
        return this.hc(t, e, (t, e) => {
            const i = this.ic(e);
            i ? (s = s.lt(t, i), n = n.lt(t, Yn(e))) : (s = s.lt(t, null), n = n.lt(t, 0));
        }).next(() => ({
            uc: s,
            cc: n
        }));
    }
    hc(t, e, s) {
        if (e.G()) return on.resolve();
        const n = IDBKeyRange.bound(e.first().path.Z(), e.last().path.Z()), i = e.Et();
        let r = i.Vt();
        return Hn(t).dh({
            range: n
        }, (t, e, n) => {
            const o = It.ut(t);
            // Go through keys not found in cache.
                        for (;r && It.U(r, o) < 0; ) s(r, null), r = i.Vt();
            r && r.isEqual(o) && (
            // Key found in cache.
            s(r, e), r = i.gt() ? i.Vt() : null), 
            // Skip to the next key (if there is one).
            r ? n.oh(r.path.Z()) : n.done();
        }).next(() => {
            // The rest of the keys are not in the cache. One case where `iterate`
            // above won't go through them is when the cache is empty.
            for (;r; ) s(r, null), r = i.gt() ? i.Vt() : null;
        });
    }
    sa(t, e, s) {
        g(!e.Is(), "CollectionGroup queries should be handled in LocalDocumentsView");
        let n = es();
        const i = e.path.length + 1, r = {};
        if (s.isEqual(dt.MIN)) {
            // Documents are ordered by key, so we can use a prefix scan to narrow
            // down the documents we need to match the query against.
            const t = e.path.Z();
            r.range = IDBKeyRange.lowerBound(t);
        } else {
            // Execute an index-free query and filter by read time. This is safe
            // since all document changes to queries that have a
            // lastLimboFreeSnapshotVersion (`sinceReadTime`) have a read time set.
            const t = e.path.Z(), n = this.serializer.lc(s);
            r.range = IDBKeyRange.lowerBound([ t, n ], 
            /* open= */ !0), r.index = ui.collectionReadTimeIndex;
        }
        return Hn(t).dh(r, (t, s, r) => {
            // The query is actually returning any path that starts with the query
            // path prefix which may include documents in subcollections. For
            // example, a query on 'rooms' will return rooms/abc/messages/xyx but we
            // shouldn't match it. Fix this by discarding rows with document keys
            // more than one segment longer than the query path.
            if (t.length !== i) return;
            const o = this.serializer._c(s);
            e.path.Y(o.key.path) ? o instanceof ue && e.matches(o) && (n = n.lt(o.key, o)) : r.done();
        }).next(() => n);
    }
    lu(t, e) {
        let s = Xe(), n = this.serializer.lc(e);
        const i = Hn(t), r = IDBKeyRange.lowerBound(n, !0);
        return i.dh({
            index: ui.readTimeIndex,
            range: r
        }, (t, e) => {
            // Unlike `getEntry()` and others, `getNewDocumentChanges()` parses
            // the documents directly since we want to keep sentinel deletes.
            const i = this.serializer._c(e);
            s = s.lt(i.key, i), n = e.readTime;
        }).next(() => ({
            _u: s,
            readTime: this.serializer.dc(n)
        }));
    }
    du(t) {
        const e = Hn(t);
        // If there are no existing entries, we return SnapshotVersion.MIN.
                let s = dt.MIN;
        return e.dh({
            index: ui.readTimeIndex,
            reverse: !0
        }, (t, e, n) => {
            e.readTime && (s = this.serializer.dc(e.readTime)), n.done();
        }).next(() => s);
    }
    Na(t) {
        return new Kn.fc(this, !!t && t.Fa);
    }
    mc(t) {
        return this.getMetadata(t).next(t => t.byteSize);
    }
    getMetadata(t) {
        return Gn(t).get(ci.key).next(t => (g(!!t, "Missing document cache metadata"), t));
    }
    nc(t, e) {
        return Gn(t).put(ci.key, e);
    }
    /**
     * Decodes `remoteDoc` and returns the document (or null, if the document
     * corresponds to the format used for sentinel deletes).
     */    ic(t) {
        if (t) {
            const e = this.serializer._c(t);
            return e instanceof ce && e.version.isEqual(dt.B()) ? null : e;
        }
        return null;
    }
}

/**
 * Handles the details of adding and updating documents in the IndexedDbRemoteDocumentCache.
 *
 * Unlike the MemoryRemoteDocumentChangeBuffer, the IndexedDb implementation computes the size
 * delta for all submitted changes. This avoids having to re-read all documents from IndexedDb
 * when we apply the changes.
 */ function Gn(t) {
    return Si.Zo(t, ci.store);
}

/**
 * Helper to get a typed SimpleDbStore for the remoteDocuments object store.
 */ function Hn(t) {
    return Si.Zo(t, ui.store);
}

function Jn(t) {
    return t.path.Z();
}

/**
 * Retrusn an approximate size for the given document.
 */ function Yn(t) {
    let e;
    if (t.document) e = t.document; else if (t.unknownDocument) e = t.unknownDocument; else {
        if (!t.noDocument) throw V("Unknown remote document type");
        e = t.noDocument;
    }
    return JSON.stringify(e).length;
}

/**
 * @license
 * Copyright 2019 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * An in-memory implementation of IndexManager.
 */ Kn.fc = class extends hn {
    /**
     * @param documentCache The IndexedDbRemoteDocumentCache to apply the changes to.
     * @param trackRemovals Whether to create sentinel deletes that can be tracked by
     * `getNewDocumentChanges()`.
     */
    constructor(t, e) {
        super(), this.Tc = t, this.Fa = e, 
        // A map of document sizes prior to applying the changes in this buffer.
        this.wc = new rn(t => t.toString());
    }
    Qo(t) {
        const e = [];
        let s = 0, n = new pt((t, e) => b(t.tt(), e.tt()));
        return this.Fo.forEach((i, r) => {
            const o = this.wc.get(i);
            if (g(void 0 !== o, `Cannot modify a document that wasn't read (for ${i})`), r) {
                g(!this.readTime.isEqual(dt.MIN), "Cannot add a document with a read time of zero");
                const h = this.Tc.serializer.Ec(r, this.readTime);
                n = n.add(i.path.K());
                const a = Yn(h);
                s += a - o, e.push(this.Tc.Mo(t, i, h));
            } else if (s -= o, this.Fa) {
                // In order to track removals, we store a "sentinel delete" in the
                // RemoteDocumentCache. This entry is represented by a NoDocument
                // with a version of 0 and ignored by `maybeDecodeDocument()` but
                // preserved in `getNewDocumentChanges()`.
                const s = this.Tc.serializer.Ec(new ce(i, dt.B()), this.readTime);
                e.push(this.Tc.Mo(t, i, s));
            } else e.push(this.Tc.Bo(t, i));
        }), n.forEach(s => {
            e.push(this.Tc.mh.yh(t, s));
        }), e.push(this.Tc.updateMetadata(t, s)), on.ko(e);
    }
    Oo(t, e) {
        // Record the size of everything we load from the cache so we can compute a delta later.
        return this.Tc.rc(t, e).next(t => null === t ? (this.wc.set(e, 0), null) : (this.wc.set(e, t.size), 
        t.oc));
    }
    Uo(t, e) {
        // Record the size of everything we load from the cache so we can compute
        // a delta later.
        return this.Tc.ac(t, e).next(({uc: t, cc: e}) => (
        // Note: `getAllFromCache` returns two maps instead of a single map from
        // keys to `DocumentSizeEntry`s. This is to allow returning the
        // `NullableMaybeDocumentMap` directly, without a conversion.
        e.forEach((t, e) => {
            this.wc.set(t, e);
        }), t));
    }
};

class Xn {
    constructor() {
        this.Ic = new Zn;
    }
    yh(t, e) {
        return this.Ic.add(e), on.resolve();
    }
    oa(t, e) {
        return on.resolve(this.Ic.getEntries(e));
    }
}

/**
 * Internal implementation of the collection-parent index exposed by MemoryIndexManager.
 * Also used for in-memory caching by IndexedDbIndexManager and initial index population
 * in indexeddb_schema.ts
 */ class Zn {
    constructor() {
        this.index = {};
    }
    // Returns false if the entry already existed.
    add(t) {
        g(t.length % 2 == 1, "Expected a collection path.");
        const e = t.J(), s = t.K(), n = this.index[e] || new pt(Tt.U), i = !n.has(s);
        return this.index[e] = n.add(s), i;
    }
    has(t) {
        const e = t.J(), s = t.K(), n = this.index[e];
        return n && n.has(s);
    }
    getEntries(t) {
        return (this.index[t] || new pt(Tt.U)).Z();
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Schema Version for the Web client:
 * 1. Initial version including Mutation Queue, Query Cache, and Remote Document
 *    Cache
 * 2. Used to ensure a targetGlobal object exists and add targetCount to it. No
 *    longer required because migration 3 unconditionally clears it.
 * 3. Dropped and re-created Query Cache to deal with cache corruption related
 *    to limbo resolution. Addresses
 *    https://github.com/firebase/firebase-ios-sdk/issues/1548
 * 4. Multi-Tab Support.
 * 5. Removal of held write acks.
 * 6. Create document global for tracking document cache size.
 * 7. Ensure every cached document has a sentinel row with a sequence number.
 * 8. Add collection-parent index for Collection Group queries.
 * 9. Change RemoteDocumentChanges store to be keyed by readTime rather than
 *    an auto-incrementing ID. This is required for Index-Free queries.
 */ const ti = 9;

/** Performs database creation and schema upgrades. */ class ei {
    constructor(t) {
        this.serializer = t;
    }
    /**
     * Performs database creation and schema upgrades.
     *
     * Note that in production, this method is only ever used to upgrade the schema
     * to SCHEMA_VERSION. Different values of toVersion are only used for testing
     * and local feature development.
     */    createOrUpgrade(t, e, s, n) {
        g(s < n && s >= 0 && n <= ti, `Unexpected schema upgrade from v${s} to v{toVersion}.`);
        const i = new fn(e);
        s < 1 && n >= 1 && (function(t) {
            t.createObjectStore(ni.store);
        }
        /**
 * An object to be stored in the 'mutationQueues' store in IndexedDb.
 *
 * Each user gets a single queue of MutationBatches to apply to the server.
 * DbMutationQueue tracks the metadata about the queue.
 */ (t), function(t) {
            t.createObjectStore(ii.store, {
                keyPath: ii.keyPath
            }), t.createObjectStore(ri.store, {
                keyPath: ri.keyPath,
                autoIncrement: !0
            }).createIndex(ri.userMutationsIndex, ri.userMutationsKeyPath, {
                unique: !0
            }), t.createObjectStore(oi.store);
        }
        /**
 * Upgrade function to migrate the 'mutations' store from V1 to V3. Loads
 * and rewrites all data.
 */ (t), mi(t), function(t) {
            t.createObjectStore(ui.store);
        }
        /**
 * Represents the known absence of a document at a particular version.
 * Stored in IndexedDb as part of a DbRemoteDocument object.
 */ (t));
        // Migration 2 to populate the targetGlobal object no longer needed since
        // migration 3 unconditionally clears it.
                let r = on.resolve();
        return s < 3 && n >= 3 && (
        // Brand new clients don't need to drop and recreate--only clients that
        // potentially have corrupt data.
        0 !== s && (!function(t) {
            t.deleteObjectStore(_i.store), t.deleteObjectStore(li.store), t.deleteObjectStore(di.store);
        }(t), mi(t)), r = r.next(() => (
        /**
 * Creates the target global singleton row.
 *
 * @param {IDBTransaction} txn The version upgrade transaction for indexeddb
 */
        function(t) {
            const e = t.store(di.store), s = new di(
            /*highestTargetId=*/ 0, 
            /*lastListenSequenceNumber=*/ 0, dt.MIN.O(), 
            /*targetCount=*/ 0);
            return e.put(di.key, s);
        }
        /**
 * Creates indices on the RemoteDocuments store used for both multi-tab
 * and Index-Free queries.
 */)(i))), s < 4 && n >= 4 && (0 !== s && (
        // Schema version 3 uses auto-generated keys to generate globally unique
        // mutation batch IDs (this was previously ensured internally by the
        // client). To migrate to the new schema, we have to read all mutations
        // and write them back out. We preserve the existing batch IDs to guarantee
        // consistency with other object stores. Any further mutation batch IDs will
        // be auto-generated.
        r = r.next(() => (function(t, e) {
            return e.store(ri.store).ah().next(s => {
                t.deleteObjectStore(ri.store), t.createObjectStore(ri.store, {
                    keyPath: ri.keyPath,
                    autoIncrement: !0
                }).createIndex(ri.userMutationsIndex, ri.userMutationsKeyPath, {
                    unique: !0
                });
                const n = e.store(ri.store), i = s.map(t => n.put(t));
                return on.ko(i);
            });
        }
        /**
 * An object to be stored in the 'documentMutations' store in IndexedDb.
 *
 * A manually maintained index of all the mutation batches that affect a given
 * document key. The rows in this table are references based on the contents of
 * DbMutationBatch.mutations.
 */)(t, i))), r = r.next(() => {
            !function(t) {
                t.createObjectStore(Ti.store, {
                    keyPath: Ti.keyPath
                });
            }
            // Visible for testing
            (t);
        })), s < 5 && n >= 5 && (r = r.next(() => this.removeAcknowledgedMutations(i))), 
        s < 6 && n >= 6 && (r = r.next(() => (function(t) {
            t.createObjectStore(ci.store);
        }
        /**
 * An object to be stored in the 'targets' store in IndexedDb.
 *
 * This is based on and should be kept in sync with the proto used in the iOS
 * client.
 *
 * Each query the client listens to against the server is tracked on disk so
 * that the query can be efficiently resumed on restart.
 */ (t), this.addDocumentGlobal(i)))), s < 7 && n >= 7 && (r = r.next(() => this.ensureSequenceNumbers(i))), 
        s < 8 && n >= 8 && (r = r.next(() => this.createCollectionParentIndex(t, i))), s < 9 && n >= 9 && (r = r.next(() => {
            // Multi-Tab used to manage its own changelog, but this has been moved
            // to the DbRemoteDocument object store itself. Since the previous change
            // log only contained transient data, we can drop its object store.
            !function(t) {
                t.objectStoreNames.contains("remoteDocumentChanges") && t.deleteObjectStore("remoteDocumentChanges");
            }(t), function(t) {
                const e = t.objectStore(ui.store);
                e.createIndex(ui.readTimeIndex, ui.readTimeIndexPath, {
                    unique: !1
                }), e.createIndex(ui.collectionReadTimeIndex, ui.collectionReadTimeIndexPath, {
                    unique: !1
                });
            }
            /**
 * A record of the metadata state of each client.
 *
 * PORTING NOTE: This is used to synchronize multi-tab state and does not need
 * to be ported to iOS or Android.
 */ (e);
        })), r;
    }
    addDocumentGlobal(t) {
        let e = 0;
        return t.store(ui.store).dh((t, s) => {
            e += Yn(s);
        }).next(() => {
            const s = new ci(e);
            return t.store(ci.store).put(ci.key, s);
        });
    }
    removeAcknowledgedMutations(t) {
        const e = t.store(ii.store), s = t.store(ri.store);
        return e.ah().next(e => on.forEach(e, e => {
            const n = IDBKeyRange.bound([ e.userId, Zs ], [ e.userId, e.lastAcknowledgedBatchId ]);
            return s.ah(ri.userMutationsIndex, n).next(s => on.forEach(s, s => {
                g(s.userId === e.userId, `Cannot process batch ${s.batchId} from unexpected user`);
                const n = this.serializer.vh(s);
                return An(t, e.userId, n).next(() => {});
            }));
        }));
    }
    /**
     * Ensures that every document in the remote document cache has a corresponding sentinel row
     * with a sequence number. Missing rows are given the most recently used sequence number.
     */    ensureSequenceNumbers(t) {
        const e = t.store(_i.store), s = t.store(ui.store);
        return jn(t).next(t => {
            const n = [];
            return s.dh((s, i) => {
                const r = new Tt(s), o = function(t) {
                    return [ 0, Hs(t) ];
                }
                /**
 * Wrapper class to store timestamps (seconds and nanos) in IndexedDb objects.
 */ (r);
                n.push(e.get(o).next(s => s ? on.resolve() : (s => e.put(new _i(0, Hs(s), t)))(r)));
            }).next(() => on.ko(n));
        });
    }
    createCollectionParentIndex(t, e) {
        // Create the index.
        t.createObjectStore(fi.store, {
            keyPath: fi.keyPath
        });
        const s = e.store(fi.store), n = new Zn, i = t => {
            if (n.add(t)) {
                const e = t.J(), n = t.K();
                return s.put({
                    collectionId: e,
                    parent: Hs(n)
                });
            }
        };
        // Helper to add an index entry iff we haven't already written it.
                // Index existing remote documents.
        return e.store(ui.store).dh({
            _h: !0
        }, (t, e) => {
            const s = new Tt(t);
            return i(s.K());
        }).next(() => e.store(oi.store).dh({
            _h: !0
        }, ([t, e, s], n) => {
            const r = Xs(e);
            return i(r.K());
        }));
    }
}

class si {
    constructor(t, e) {
        this.seconds = t, this.nanoseconds = e;
    }
}

/**
 * A singleton object to be stored in the 'owner' store in IndexedDb.
 *
 * A given database can have a single primary tab assigned at a given time. That
 * tab must validate that it is still holding the primary lease before every
 * operation that requires locked access. The primary tab should regularly
 * write an updated timestamp to this lease to prevent other tabs from
 * "stealing" the primary lease
 */ class ni {
    constructor(t, 
    /** Whether to allow shared access from multiple tabs. */
    e, s) {
        this.ownerId = t, this.allowTabSynchronization = e, this.leaseTimestampMs = s;
    }
}

/**
 * Name of the IndexedDb object store.
 *
 * Note that the name 'owner' is chosen to ensure backwards compatibility with
 * older clients that only supported single locked access to the persistence
 * layer.
 */ ni.store = "owner", 
/**
 * The key string used for the single object that exists in the
 * DbPrimaryClient store.
 */
ni.key = "owner";

class ii {
    constructor(
    /**
     * The normalized user ID to which this queue belongs.
     */
    t, 
    /**
     * An identifier for the highest numbered batch that has been acknowledged
     * by the server. All MutationBatches in this queue with batchIds less
     * than or equal to this value are considered to have been acknowledged by
     * the server.
     *
     * NOTE: this is deprecated and no longer used by the code.
     */
    e, 
    /**
     * A stream token that was previously sent by the server.
     *
     * See StreamingWriteRequest in datastore.proto for more details about
     * usage.
     *
     * After sending this token, earlier tokens may not be used anymore so
     * only a single stream token is retained.
     */
    s) {
        this.userId = t, this.lastAcknowledgedBatchId = e, this.lastStreamToken = s;
    }
}

/** Name of the IndexedDb object store.  */ ii.store = "mutationQueues", 
/** Keys are automatically assigned via the userId property. */
ii.keyPath = "userId";

/**
 * An object to be stored in the 'mutations' store in IndexedDb.
 *
 * Represents a batch of user-level mutations intended to be sent to the server
 * in a single write. Each user-level batch gets a separate DbMutationBatch
 * with a new batchId.
 */
class ri {
    constructor(
    /**
     * The normalized user ID to which this batch belongs.
     */
    t, 
    /**
     * An identifier for this batch, allocated using an auto-generated key.
     */
    e, 
    /**
     * The local write time of the batch, stored as milliseconds since the
     * epoch.
     */
    s, 
    /**
     * A list of "mutations" that represent a partial base state from when this
     * write batch was initially created. During local application of the write
     * batch, these baseMutations are applied prior to the real writes in order
     * to override certain document fields from the remote document cache. This
     * is necessary in the case of non-idempotent writes (e.g. `increment()`
     * transforms) to make sure that the local view of the modified documents
     * doesn't flicker if the remote document cache receives the result of the
     * non-idempotent write before the write is removed from the queue.
     *
     * These mutations are never sent to the backend.
     */
    n, 
    /**
     * A list of mutations to apply. All mutations will be applied atomically.
     *
     * Mutations are serialized via JsonProtoSerializer.toMutation().
     */
    i) {
        this.userId = t, this.batchId = e, this.localWriteTimeMs = s, this.baseMutations = n, 
        this.mutations = i;
    }
}

/** Name of the IndexedDb object store.  */ ri.store = "mutations", 
/** Keys are automatically assigned via the userId, batchId properties. */
ri.keyPath = "batchId", 
/** The index name for lookup of mutations by user. */
ri.userMutationsIndex = "userMutationsIndex", 
/** The user mutations index is keyed by [userId, batchId] pairs. */
ri.userMutationsKeyPath = [ "userId", "batchId" ];

class oi {
    constructor() {}
    /**
     * Creates a [userId] key for use in the DbDocumentMutations index to iterate
     * over all of a user's document mutations.
     */    static prefixForUser(t) {
        return [ t ];
    }
    /**
     * Creates a [userId, encodedPath] key for use in the DbDocumentMutations
     * index to iterate over all at document mutations for a given path or lower.
     */    static prefixForPath(t, e) {
        return [ t, Hs(e) ];
    }
    /**
     * Creates a full index key of [userId, encodedPath, batchId] for inserting
     * and deleting into the DbDocumentMutations index.
     */    static key(t, e, s) {
        return [ t, Hs(e), s ];
    }
}

oi.store = "documentMutations", 
/**
 * Because we store all the useful information for this store in the key,
 * there is no useful information to store as the value. The raw (unencoded)
 * path cannot be stored because IndexedDb doesn't store prototype
 * information.
 */
oi.PLACEHOLDER = new oi;

class hi {
    constructor(t, e) {
        this.path = t, this.readTime = e;
    }
}

/**
 * Represents a document that is known to exist but whose data is unknown.
 * Stored in IndexedDb as part of a DbRemoteDocument object.
 */ class ai {
    constructor(t, e) {
        this.path = t, this.version = e;
    }
}

/**
 * An object to be stored in the 'remoteDocuments' store in IndexedDb.
 * It represents either:
 *
 * - A complete document.
 * - A "no document" representing a document that is known not to exist (at
 * some version).
 * - An "unknown document" representing a document that is known to exist (at
 * some version) but whose contents are unknown.
 *
 * Note: This is the persisted equivalent of a MaybeDocument and could perhaps
 * be made more general if necessary.
 */ class ui {
    // TODO: We are currently storing full document keys almost three times
    // (once as part of the primary key, once - partly - as `parentPath` and once
    // inside the encoded documents). During our next migration, we should
    // rewrite the primary key as parentPath + document ID which would allow us
    // to drop one value.
    constructor(
    /**
     * Set to an instance of DbUnknownDocument if the data for a document is
     * not known, but it is known that a document exists at the specified
     * version (e.g. it had a successful update applied to it)
     */
    t, 
    /**
     * Set to an instance of a DbNoDocument if it is known that no document
     * exists.
     */
    e, 
    /**
     * Set to an instance of a Document if there's a cached version of the
     * document.
     */
    s, 
    /**
     * Documents that were written to the remote document store based on
     * a write acknowledgment are marked with `hasCommittedMutations`. These
     * documents are potentially inconsistent with the backend's copy and use
     * the write's commit version as their document version.
     */
    n, 
    /**
     * When the document was read from the backend. Undefined for data written
     * prior to schema version 9.
     */
    i, 
    /**
     * The path of the collection this document is part of. Undefined for data
     * written prior to schema version 9.
     */
    r) {
        this.unknownDocument = t, this.noDocument = e, this.document = s, this.hasCommittedMutations = n, 
        this.readTime = i, this.parentPath = r;
    }
}

ui.store = "remoteDocuments", 
/**
 * An index that provides access to all entries sorted by read time (which
 * corresponds to the last modification time of each row).
 *
 * This index is used to provide a changelog for Multi-Tab.
 */
ui.readTimeIndex = "readTimeIndex", ui.readTimeIndexPath = "readTime", 
/**
 * An index that provides access to documents in a collection sorted by read
 * time.
 *
 * This index is used to allow the RemoteDocumentCache to fetch newly changed
 * documents in a collection.
 */
ui.collectionReadTimeIndex = "collectionReadTimeIndex", ui.collectionReadTimeIndexPath = [ "parentPath", "readTime" ];

/**
 * Contains a single entry that has metadata about the remote document cache.
 */
class ci {
    /**
     * @param byteSize Approximately the total size in bytes of all the documents in the document
     * cache.
     */
    constructor(t) {
        this.byteSize = t;
    }
}

ci.store = "remoteDocumentGlobal", ci.key = "remoteDocumentGlobalKey";

class li {
    constructor(
    /**
     * An auto-generated sequential numeric identifier for the query.
     *
     * Queries are stored using their canonicalId as the key, but these
     * canonicalIds can be quite long so we additionally assign a unique
     * queryId which can be used by referenced data structures (e.g.
     * indexes) to minimize the on-disk cost.
     */
    t, 
    /**
     * The canonical string representing this query. This is not unique.
     */
    e, 
    /**
     * The last readTime received from the Watch Service for this query.
     *
     * This is the same value as TargetChange.read_time in the protos.
     */
    s, 
    /**
     * An opaque, server-assigned token that allows watching a query to be
     * resumed after disconnecting without retransmitting all the data
     * that matches the query. The resume token essentially identifies a
     * point in time from which the server should resume sending results.
     *
     * This is related to the snapshotVersion in that the resumeToken
     * effectively also encodes that value, but the resumeToken is opaque
     * and sometimes encodes additional information.
     *
     * A consequence of this is that the resumeToken should be used when
     * asking the server to reason about where this client is in the watch
     * stream, but the client should use the snapshotVersion for its own
     * purposes.
     *
     * This is the same value as TargetChange.resume_token in the protos.
     */
    n, 
    /**
     * A sequence number representing the last time this query was
     * listened to, used for garbage collection purposes.
     *
     * Conventionally this would be a timestamp value, but device-local
     * clocks are unreliable and they must be able to create new listens
     * even while disconnected. Instead this should be a monotonically
     * increasing number that's incremented on each listen call.
     *
     * This is different from the queryId since the queryId is an
     * immutable identifier assigned to the Query on first use while
     * lastListenSequenceNumber is updated every time the query is
     * listened to.
     */
    i, 
    /**
     * Denotes the maximum snapshot version at which the associated query view
     * contained no limbo documents.  Undefined for data written prior to
     * schema version 9.
     */
    r, 
    /**
     * The query for this target.
     *
     * Because canonical ids are not unique we must store the actual query. We
     * use the proto to have an object we can persist without having to
     * duplicate translation logic to and from a `Query` object.
     */
    o) {
        this.targetId = t, this.canonicalId = e, this.readTime = s, this.resumeToken = n, 
        this.lastListenSequenceNumber = i, this.lastLimboFreeSnapshotVersion = r, this.query = o;
    }
}

li.store = "targets", 
/** Keys are automatically assigned via the targetId property. */
li.keyPath = "targetId", 
/** The name of the queryTargets index. */
li.queryTargetsIndexName = "queryTargetsIndex", 
/**
 * The index of all canonicalIds to the targets that they match. This is not
 * a unique mapping because canonicalId does not promise a unique name for all
 * possible queries, so we append the targetId to make the mapping unique.
 */
li.queryTargetsKeyPath = [ "canonicalId", "targetId" ];

/**
 * An object representing an association between a target and a document, or a
 * sentinel row marking the last sequence number at which a document was used.
 * Each document cached must have a corresponding sentinel row before lru
 * garbage collection is enabled.
 *
 * The target associations and sentinel rows are co-located so that orphaned
 * documents and their sequence numbers can be identified efficiently via a scan
 * of this store.
 */
class _i {
    constructor(
    /**
     * The targetId identifying a target or 0 for a sentinel row.
     */
    t, 
    /**
     * The path to the document, as encoded in the key.
     */
    e, 
    /**
     * If this is a sentinel row, this should be the sequence number of the last
     * time the document specified by `path` was used. Otherwise, it should be
     * `undefined`.
     */
    s) {
        this.targetId = t, this.path = e, this.sequenceNumber = s, g(0 === t == (void 0 !== s), "A target-document row must either have targetId == 0 and a defined sequence number, or a non-zero targetId and no sequence number");
    }
}

/** Name of the IndexedDb object store.  */ _i.store = "targetDocuments", 
/** Keys are automatically assigned via the targetId, path properties. */
_i.keyPath = [ "targetId", "path" ], 
/** The index name for the reverse index. */
_i.documentTargetsIndex = "documentTargetsIndex", 
/** We also need to create the reverse index for these properties. */
_i.documentTargetsKeyPath = [ "path", "targetId" ];

/**
 * A record of global state tracked across all Targets, tracked separately
 * to avoid the need for extra indexes.
 *
 * This should be kept in-sync with the proto used in the iOS client.
 */
class di {
    constructor(
    /**
     * The highest numbered target id across all targets.
     *
     * See DbTarget.targetId.
     */
    t, 
    /**
     * The highest numbered lastListenSequenceNumber across all targets.
     *
     * See DbTarget.lastListenSequenceNumber.
     */
    e, 
    /**
     * A global snapshot version representing the last consistent snapshot we
     * received from the backend. This is monotonically increasing and any
     * snapshots received from the backend prior to this version (e.g. for
     * targets resumed with a resumeToken) should be suppressed (buffered)
     * until the backend has caught up to this snapshot version again. This
     * prevents our cache from ever going backwards in time.
     */
    s, 
    /**
     * The number of targets persisted.
     */
    n) {
        this.highestTargetId = t, this.highestListenSequenceNumber = e, this.lastRemoteSnapshotVersion = s, 
        this.targetCount = n;
    }
}

/**
 * The key string used for the single object that exists in the
 * DbTargetGlobal store.
 */ di.key = "targetGlobalKey", di.store = "targetGlobal";

/**
 * An object representing an association between a Collection id (e.g. 'messages')
 * to a parent path (e.g. '/chats/123') that contains it as a (sub)collection.
 * This is used to efficiently find all collections to query when performing
 * a Collection Group query.
 */
class fi {
    constructor(
    /**
     * The collectionId (e.g. 'messages')
     */
    t, 
    /**
     * The path to the parent (either a document location or an empty path for
     * a root-level collection).
     */
    e) {
        this.collectionId = t, this.parent = e;
    }
}

/** Name of the IndexedDb object store. */ function mi(t) {
    t.createObjectStore(_i.store, {
        keyPath: _i.keyPath
    }).createIndex(_i.documentTargetsIndex, _i.documentTargetsKeyPath, {
        unique: !0
    }), 
    // NOTE: This is unique only because the TargetId is the suffix.
    t.createObjectStore(li.store, {
        keyPath: li.keyPath
    }).createIndex(li.queryTargetsIndexName, li.queryTargetsKeyPath, {
        unique: !0
    }), t.createObjectStore(di.store);
}

fi.store = "collectionParents", 
/** Keys are automatically assigned via the collectionId, parent properties. */
fi.keyPath = [ "collectionId", "parent" ];

class Ti {
    constructor(
    // Note: Previous schema versions included a field
    // "lastProcessedDocumentChangeId". Don't use anymore.
    /** The auto-generated client id assigned at client startup. */
    t, 
    /** The last time this state was updated. */
    e, 
    /** Whether the client's network connection is enabled. */
    s, 
    /** Whether this client is running in a foreground tab. */
    n) {
        this.clientId = t, this.updateTimeMs = e, this.networkEnabled = s, this.inForeground = n;
    }
}

/** Name of the IndexedDb object store. */ Ti.store = "clientMetadata", 
/** Keys are automatically assigned via the clientId properties. */
Ti.keyPath = "clientId";

const wi = [ ...[ ...[ ...[ ii.store, ri.store, oi.store, ui.store, li.store, ni.store, di.store, _i.store ], Ti.store ], ci.store ], fi.store ];

// V2 is no longer usable (see comment at top of file)
// Visible for testing
/**
 * @license
 * Copyright 2019 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A persisted implementation of IndexManager.
 */
class Ei {
    constructor() {
        /**
         * An in-memory copy of the index entries we've already written since the SDK
         * launched. Used to avoid re-writing the same entry repeatedly.
         *
         * This is *NOT* a complete cache of what's in persistence and so can never be used to
         * satisfy reads.
         */
        this.Rc = new Zn;
    }
    /**
     * Adds a new entry to the collection parent index.
     *
     * Repeated calls for the same collectionPath should be avoided within a
     * transaction as IndexedDbIndexManager only caches writes once a transaction
     * has been committed.
     */    yh(t, e) {
        if (g(e.length % 2 == 1, "Expected a collection path."), !this.Rc.has(e)) {
            const s = e.J(), n = e.K();
            t.jo(() => {
                // Add the collection to the in memory cache only if the transaction was
                // successfully committed.
                this.Rc.add(e);
            });
            const i = {
                collectionId: s,
                parent: Hs(n)
            };
            return Ii(t).put(i);
        }
        return on.resolve();
    }
    oa(t, e) {
        const s = [], n = IDBKeyRange.bound([ e, "" ], [ S(e), "" ], 
        /*lowerOpen=*/ !1, 
        /*upperOpen=*/ !0);
        return Ii(t).ah(n).next(t => {
            for (const n of t) {
                // This collectionId guard shouldn't be necessary (and isn't as long
                // as we're running in a real browser), but there's a bug in
                // indexeddbshim that breaks our range in our tests running in node:
                // https://github.com/axemclion/IndexedDBShim/issues/334
                if (n.collectionId !== e) break;
                s.push(Xs(n.parent));
            }
            return s;
        });
    }
}

/**
 * Helper to get a typed SimpleDbStore for the collectionParents
 * document store.
 */ function Ii(t) {
    return Si.Zo(t, fi.store);
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** Serializer for values stored in the LocalStore. */ class Ri {
    constructor(t) {
        this.Ac = t;
    }
    /** Decodes a remote document from storage locally to a Document. */    _c(t) {
        if (t.document) return this.Ac.Vi(t.document, !!t.hasCommittedMutations);
        if (t.noDocument) {
            const e = It.ut(t.noDocument.path), s = this.Pc(t.noDocument.readTime);
            return new ce(e, s, {
                hasCommittedMutations: !!t.hasCommittedMutations
            });
        }
        if (t.unknownDocument) {
            const e = It.ut(t.unknownDocument.path), s = this.Pc(t.unknownDocument.version);
            return new le(e, s);
        }
        return V("Unexpected DbRemoteDocument");
    }
    /** Encodes a document for storage locally. */    Ec(t, e) {
        const s = this.lc(e), n = t.key.path.K().Z();
        if (t instanceof ue) {
            const e = t.proto ? t.proto : this.Ac.pi(t), i = t.hasCommittedMutations;
            return new ui(
            /* unknownDocument= */ null, 
            /* noDocument= */ null, e, i, s, n);
        }
        if (t instanceof ce) {
            const e = t.key.path.Z(), i = this.pc(t.version), r = t.hasCommittedMutations;
            return new ui(
            /* unknownDocument= */ null, new hi(e, i), 
            /* document= */ null, r, s, n);
        }
        if (t instanceof le) {
            const e = t.key.path.Z(), i = this.pc(t.version);
            return new ui(new ai(e, i), 
            /* noDocument= */ null, 
            /* document= */ null, 
            /* hasCommittedMutations= */ !0, s, n);
        }
        return V("Unexpected MaybeDocument");
    }
    lc(t) {
        const e = t.O();
        return [ e.seconds, e.nanoseconds ];
    }
    dc(t) {
        const e = new _t(t[0], t[1]);
        return dt.L(e);
    }
    pc(t) {
        const e = t.O();
        return new si(e.seconds, e.nanoseconds);
    }
    Pc(t) {
        const e = new _t(t.seconds, t.nanoseconds);
        return dt.L(e);
    }
    /** Encodes a batch of mutations into a DbMutationBatch for local storage. */    gh(t, e) {
        const s = e.baseMutations.map(t => this.Ac.Ni(t)), n = e.mutations.map(t => this.Ac.Ni(t));
        return new ri(t, e.batchId, e.Fe.toMillis(), s, n);
    }
    /** Decodes a DbMutationBatch into a MutationBatch */    vh(t) {
        const e = (t.baseMutations || []).map(t => this.Ac.Mi(t)), s = t.mutations.map(t => this.Ac.Mi(t)), n = _t.fromMillis(t.localWriteTimeMs);
        return new tn(t.batchId, n, e, s);
    }
    /*
     * Encodes a set of document keys into an array of EncodedResourcePaths.
     */    Vc(t) {
        const e = [];
        return t.forEach(t => {
            e.push(Hs(t.path));
        }), e;
    }
    /** Decodes an array of EncodedResourcePaths into a set of document keys. */    gc(t) {
        let e = rs();
        for (const s of t) e = e.add(new It(Xs(s)));
        return e;
    }
    /** Decodes a DbTarget into TargetData */    tc(t) {
        const e = this.Pc(t.readTime), s = void 0 !== t.lastLimboFreeSnapshotVersion ? this.Pc(t.lastLimboFreeSnapshotVersion) : dt.MIN;
        let n;
        return n = void 0 !== t.query.documents ? this.Ac.Wi(t.query) : this.Ac.Hi(t.query), 
        new ze(n, t.targetId, Be.Ds, t.lastListenSequenceNumber, e, s, Qe.fromBase64String(t.resumeToken));
    }
    /** Encodes TargetData into a DbTarget for storage locally. */    ec(t) {
        g(Be.Ds === t.Ns, "Only queries with purpose " + Be.Ds + " may be stored, got " + t.Ns);
        const e = this.pc(t.Fs), s = this.pc(t.lastLimboFreeSnapshotVersion);
        let n;
        n = t.target.Qe() ? this.Ac.Qi(t.target) : this.Ac.ji(t.target);
        // We can't store the resumeToken as a ByteString in IndexedDb, so we
        // convert it to a base64 string for storage.
                const i = t.resumeToken.toBase64();
        // lastListenSequenceNumber is always 0 until we do real GC.
                return new li(t.targetId, t.target.canonicalId(), e, i, t.sequenceNumber, s, n);
    }
}

/**
 * A helper function for figuring out what kind of query has been stored.
 */
/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Ai = "IndexedDbPersistence", Pi = 18e5, pi = 5e3, Vi = 4e3, gi = "Another tab has exclusive access to the persistence layer. To allow shared access, make sure to invoke `enablePersistence()` with `synchronizeTabs:true` in all tabs.", yi = "This platform is either missing IndexedDB or is known to have an incomplete implementation. Offline persistence has been disabled.", bi = "firestore_zombie";

/**
 * Oldest acceptable age in milliseconds for client metadata before the client
 * is considered inactive and its associated data is garbage collected.
 */ class vi extends un {
    constructor(t, e) {
        super(), this.Lh = t, this.Oa = e;
    }
}

/**
 * An IndexedDB-backed instance of Persistence. Data is stored persistently
 * across sessions.
 *
 * On Web only, the Firestore SDKs support shared access to its persistence
 * layer. This allows multiple browser tabs to read and write to IndexedDb and
 * to synchronize state even without network connectivity. Shared access is
 * currently optional and not enabled unless all clients invoke
 * `enablePersistence()` with `{synchronizeTabs:true}`.
 *
 * In multi-tab mode, if multiple clients are active at the same time, the SDK
 * will designate one client as the “primary client”. An effort is made to pick
 * a visible, network-connected and active client, and this client is
 * responsible for letting other clients know about its presence. The primary
 * client writes a unique client-generated identifier (the client ID) to
 * IndexedDb’s “owner” store every 4 seconds. If the primary client fails to
 * update this entry, another client can acquire the lease and take over as
 * primary.
 *
 * Some persistence operations in the SDK are designated as primary-client only
 * operations. This includes the acknowledgment of mutations and all updates of
 * remote documents. The effects of these operations are written to persistence
 * and then broadcast to other tabs via LocalStorage (see
 * `WebStorageSharedClientState`), which then refresh their state from
 * persistence.
 *
 * Similarly, the primary client listens to notifications sent by secondary
 * clients to discover persistence changes written by secondary clients, such as
 * the addition of new mutations and query targets.
 *
 * If multi-tab is not enabled and another tab already obtained the primary
 * lease, IndexedDbPersistence enters a failed state and all subsequent
 * operations will automatically fail.
 *
 * Additionally, there is an optimization so that when a tab is closed, the
 * primary lease is released immediately (this is especially important to make
 * sure that a refreshed tab is able to immediately re-acquire the primary
 * lease). Unfortunately, IndexedDB cannot be reliably used in window.unload
 * since it is an asynchronous API. So in addition to attempting to give up the
 * lease, the leaseholder writes its client ID to a "zombiedClient" entry in
 * LocalStorage which acts as an indicator that another tab should go ahead and
 * take the primary lease immediately regardless of the current lease timestamp.
 *
 * TODO(b/114226234): Remove `synchronizeTabs` section when multi-tab is no
 * longer optional.
 */ class Si {
    constructor(t, e, s, n, i, r, o, h) {
        if (this.allowTabSynchronization = t, this.persistenceKey = e, this.clientId = s, 
        this.yc = r, this.bc = h, this.vc = !1, this.isPrimary = !1, this.networkEnabled = !0, 
        /** Our window.unload handler, if registered. */
        this.Sc = null, this.inForeground = !1, 
        /** Our 'visibilitychange' listener if registered. */
        this.Dc = null, 
        /** The client metadata refresh task. */
        this.Cc = null, 
        /** The last time we garbage collected the client metadata object store. */
        this.kc = Number.NEGATIVE_INFINITY, 
        /** A listener to notify on primary state changes. */
        this.Nc = t => Promise.resolve(), this.Th = new ki(this, i), this.Fc = e + Si.$c, 
        this.serializer = new Ri(o), this.document = n.document, this.Aa = new Un(this.Th, this.serializer), 
        this.mh = new Ei, this.Hh = new Kn(this.serializer, this.mh), !n.window || !n.window.localStorage) throw new $(F.UNIMPLEMENTED, "IndexedDB persistence is only available on platforms that support LocalStorage.");
        this.window = n.window, this.xc = this.window.localStorage;
    }
    static Zo(t, e) {
        if (t instanceof vi) return _n.Zo(t.Lh, e);
        throw V("IndexedDbPersistence must use instances of IndexedDbTransaction");
    }
    static async Mc(t) {
        if (!Si.Ho()) throw new $(F.UNIMPLEMENTED, yi);
        const e = new Si(t.allowTabSynchronization, t.persistenceKey, t.clientId, t.platform, t.Lc, t.yc, t.serializer, t.bc);
        return await e.start(), e;
    }
    /**
     * Attempt to start IndexedDb persistence.
     *
     * @return {Promise<void>} Whether persistence was enabled.
     */    start() {
        return g(!this.Ta, "IndexedDbPersistence double-started!"), g(null !== this.window, "Expected 'window' to be defined"), 
        _n.Go(this.Fc, ti, new ei(this.serializer)).then(t => (this.Bc = t, this.qc())).then(() => (this.Oc(), 
        this.Uc(), this.Qc(), this.Bc.runTransaction("readonly-idempotent", [ di.store ], t => jn(t)))).then(t => {
            this.Wc = new Bs(t, this.bc);
        }).then(() => {
            this.vc = !0;
        }).catch(t => (this.Bc && this.Bc.close(), Promise.reject(t)));
    }
    jc(t) {
        return this.Nc = async e => {
            if (this.Ta) return t(e);
        }, t(this.isPrimary);
    }
    zc(t) {
        this.Bc.th(async e => {
            // Check if an attempt is made to delete IndexedDB.
            null === e.newVersion && await t();
        });
    }
    hu(t) {
        this.networkEnabled !== t && (this.networkEnabled = t, 
        // Schedule a primary lease refresh for immediate execution. The eventual
        // lease update will be propagated via `primaryStateListener`.
        this.yc.Lr(async () => {
            this.Ta && await this.qc();
        }));
    }
    /**
     * Updates the client metadata in IndexedDb and attempts to either obtain or
     * extend the primary lease for the local client. Asynchronously notifies the
     * primary state listener if the client either newly obtained or released its
     * primary lease.
     */    qc() {
        return this.Bc.runTransaction("readwrite-idempotent", wi, t => {
            return Ci(t).put(new Ti(this.clientId, Date.now(), this.networkEnabled, this.inForeground)).next(() => {
                if (this.isPrimary) return this.Kc(t).next(t => {
                    t || (this.isPrimary = !1, this.yc.Lr(() => this.Nc(!1)));
                });
            }).next(() => this.Gc(t)).next(e => this.isPrimary && !e ? this.Hc(t).next(() => !1) : !!e && this.Jc(t).next(() => !0));
        }).catch(t => {
            if (!this.allowTabSynchronization) throw t;
            return A(Ai, "Releasing owner lease after error during lease refresh", t), /* isPrimary= */ !1;
        }).then(t => {
            this.isPrimary !== t && this.yc.Lr(() => this.Nc(t)), this.isPrimary = t;
        });
    }
    Kc(t) {
        return Di(t).get(ni.key).next(t => on.resolve(this.Yc(t)));
    }
    Xc(t) {
        return Ci(t).delete(this.clientId);
    }
    /**
     * If the garbage collection threshold has passed, prunes the
     * RemoteDocumentChanges and the ClientMetadata store based on the last update
     * time of all clients.
     */    async Zc() {
        if (this.isPrimary && !this.tl(this.kc, Pi)) {
            this.kc = Date.now(), 
            // Delete potential leftover entries that may continue to mark the
            // inactive clients as zombied in LocalStorage.
            // Ideally we'd delete the IndexedDb and LocalStorage zombie entries for
            // the client atomically, but we can't. So we opt to delete the IndexedDb
            // entries first to avoid potentially reviving a zombied client.
            (await this.runTransaction("maybeGarbageCollectMultiClientState", "readwrite-primary-idempotent", t => {
                const e = Si.Zo(t, Ti.store);
                return e.ah().next(t => {
                    const s = this.el(t, Pi), n = t.filter(t => -1 === s.indexOf(t));
                    // Delete metadata for clients that are no longer considered active.
                    return on.forEach(n, t => e.delete(t.clientId)).next(() => n);
                });
            }).catch(() => [])).forEach(t => {
                this.window.localStorage.removeItem(this.sl(t.clientId));
            });
        }
    }
    /**
     * Schedules a recurring timer to update the client metadata and to either
     * extend or acquire the primary lease if the client is eligible.
     */    Qc() {
        this.Cc = this.yc.Yr(Os.yr, Vi, () => this.qc().then(() => this.Zc()).then(() => this.Qc()));
    }
    /** Checks whether `client` is the local client. */    Yc(t) {
        return !!t && t.ownerId === this.clientId;
    }
    /**
     * Evaluate the state of all active clients and determine whether the local
     * client is or can act as the holder of the primary lease. Returns whether
     * the client is eligible for the lease, but does not actually acquire it.
     * May return 'false' even if there is no active leaseholder and another
     * (foreground) client should become leaseholder instead.
     */    Gc(t) {
        return Di(t).get(ni.key).next(e => {
            // A client is eligible for the primary lease if:
            // - its network is enabled and the client's tab is in the foreground.
            // - its network is enabled and no other client's tab is in the
            //   foreground.
            // - every clients network is disabled and the client's tab is in the
            //   foreground.
            // - every clients network is disabled and no other client's tab is in
            //   the foreground.
            if (null !== e && this.tl(e.leaseTimestampMs, pi) && !this.nl(e.ownerId)) {
                if (this.Yc(e) && this.networkEnabled) return !0;
                if (!this.Yc(e)) {
                    if (!e.allowTabSynchronization) 
                    // Fail the `canActAsPrimary` check if the current leaseholder has
                    // not opted into multi-tab synchronization. If this happens at
                    // client startup, we reject the Promise returned by
                    // `enablePersistence()` and the user can continue to use Firestore
                    // with in-memory persistence.
                    // If this fails during a lease refresh, we will instead block the
                    // AsyncQueue from executing further operations. Note that this is
                    // acceptable since mixing & matching different `synchronizeTabs`
                    // settings is not supported.
                    //
                    // TODO(b/114226234): Remove this check when `synchronizeTabs` can
                    // no longer be turned off.
                    throw new $(F.FAILED_PRECONDITION, gi);
                    return !1;
                }
            }
            return !(!this.networkEnabled || !this.inForeground) || Ci(t).ah().next(t => {
                return void 0 === this.el(t, pi).find(t => {
                    if (this.clientId !== t.clientId) {
                        const e = !this.networkEnabled && t.networkEnabled, s = !this.inForeground && t.inForeground, n = this.networkEnabled === t.networkEnabled;
                        if (e || s && n) return !0;
                    }
                    return !1;
                });
            });
        }).next(t => (this.isPrimary !== t && A(Ai, `Client ${t ? "is" : "is not"} eligible for a primary lease.`), 
        t));
    }
    async shutdown() {
        // The shutdown() operations are idempotent and can be called even when
        // start() aborted (e.g. because it couldn't acquire the persistence lease).
        this.vc = !1, this.il(), this.Cc && (this.Cc.cancel(), this.Cc = null), this.rl(), 
        this.ol(), await this.Bc.runTransaction("readwrite-idempotent", [ ni.store, Ti.store ], t => this.Hc(t).next(() => this.Xc(t))), 
        this.Bc.close(), 
        // Remove the entry marking the client as zombied from LocalStorage since
        // we successfully deleted its metadata from IndexedDb.
        this.hl();
    }
    /**
     * Returns clients that are not zombied and have an updateTime within the
     * provided threshold.
     */    el(t, e) {
        return t.filter(t => this.tl(t.updateTimeMs, e) && !this.nl(t.clientId));
    }
    ru() {
        return this.Bc.runTransaction("readonly-idempotent", [ Ti.store ], t => Ci(t).ah().next(t => this.el(t, Pi).map(t => t.clientId)));
    }
    static async clearPersistence(t) {
        if (!Si.Ho()) return Promise.resolve();
        const e = t + Si.$c;
        await _n.delete(e);
    }
    get Ta() {
        return this.vc;
    }
    Ea(t) {
        return g(this.Ta, "Cannot initialize MutationQueue before persistence is started."), 
        In.Eh(t, this.serializer, this.mh, this.Th);
    }
    Pa() {
        return g(this.Ta, "Cannot initialize TargetCache before persistence is started."), 
        this.Aa;
    }
    Ra() {
        return g(this.Ta, "Cannot initialize RemoteDocumentCache before persistence is started."), 
        this.Hh;
    }
    Va() {
        return g(this.Ta, "Cannot initialize IndexManager before persistence is started."), 
        this.mh;
    }
    runTransaction(t, e, s) {
        A(Ai, "Starting transaction:", t);
        // TODO(schmidt-sebastian): Simplify once all transactions are idempotent.
        const n = e.endsWith("idempotent"), i = e.startsWith("readonly") ? n ? "readonly-idempotent" : "readonly" : n ? "readwrite-idempotent" : "readwrite";
        let r;
        // Do all transactions as readwrite against all object stores, since we
        // are the only reader/writer.
                return this.Bc.runTransaction(i, wi, n => (r = new vi(n, this.Wc.next()), 
        "readwrite-primary" === e || "readwrite-primary-idempotent" === e ? this.Kc(n).next(t => !!t || this.Gc(n)).next(e => {
            if (!e) throw P(`Failed to obtain primary lease for action '${t}'.`), this.isPrimary = !1, 
            this.yc.Lr(() => this.Nc(!1)), new $(F.FAILED_PRECONDITION, an);
            return s(r);
        }).next(t => this.Jc(n).next(() => t)) : this.al(n).next(() => s(r)))).then(t => (r.zo(), 
        t));
    }
    /**
     * Verifies that the current tab is the primary leaseholder or alternatively
     * that the leaseholder has opted into multi-tab synchronization.
     */
    // TODO(b/114226234): Remove this check when `synchronizeTabs` can no longer
    // be turned off.
    al(t) {
        return Di(t).get(ni.key).next(t => {
            if (null !== t && this.tl(t.leaseTimestampMs, pi) && !this.nl(t.ownerId) && !this.Yc(t) && !t.allowTabSynchronization) throw new $(F.FAILED_PRECONDITION, gi);
        });
    }
    /**
     * Obtains or extends the new primary lease for the local client. This
     * method does not verify that the client is eligible for this lease.
     */    Jc(t) {
        const e = new ni(this.clientId, this.allowTabSynchronization, Date.now());
        return Di(t).put(ni.key, e);
    }
    static Ho() {
        return _n.Ho();
    }
    /**
     * Generates a string used as a prefix when storing data in IndexedDB and
     * LocalStorage.
     */    static ul(t) {
        // Use two different prefix formats:
        //
        //   * firestore / persistenceKey / projectID . databaseID / ...
        //   * firestore / persistenceKey / projectID / ...
        //
        // projectIDs are DNS-compatible names and cannot contain dots
        // so there's no danger of collisions.
        let e = t.o.projectId;
        return t.o.h || (e += "." + t.o.database), "firestore/" + t.persistenceKey + "/" + e + "/";
    }
    /** Checks the primary lease and removes it if we are the current primary. */    Hc(t) {
        const e = Di(t);
        return e.get(ni.key).next(t => this.Yc(t) ? (A(Ai, "Releasing primary lease."), 
        e.delete(ni.key)) : on.resolve());
    }
    /** Verifies that `updateTimeMs` is within `maxAgeMs`. */    tl(t, e) {
        const s = Date.now();
        return !(t < s - e) && (!(t > s) || (P(`Detected an update time that is in the future: ${t} > ${s}`), 
        !1));
    }
    Oc() {
        null !== this.document && "function" == typeof this.document.addEventListener && (this.Dc = () => {
            this.yc.Lr(() => (this.inForeground = "visible" === this.document.visibilityState, 
            this.qc()));
        }, this.document.addEventListener("visibilitychange", this.Dc), this.inForeground = "visible" === this.document.visibilityState);
    }
    rl() {
        this.Dc && (g(null !== this.document && "function" == typeof this.document.addEventListener, "Expected 'document.addEventListener' to be a function"), 
        this.document.removeEventListener("visibilitychange", this.Dc), this.Dc = null);
    }
    /**
     * Attaches a window.unload handler that will synchronously write our
     * clientId to a "zombie client id" location in LocalStorage. This can be used
     * by tabs trying to acquire the primary lease to determine that the lease
     * is no longer valid even if the timestamp is recent. This is particularly
     * important for the refresh case (so the tab correctly re-acquires the
     * primary lease). LocalStorage is used for this rather than IndexedDb because
     * it is a synchronous API and so can be used reliably from  an unload
     * handler.
     */    Uc() {
        "function" == typeof this.window.addEventListener && (this.Sc = () => {
            // Note: In theory, this should be scheduled on the AsyncQueue since it
            // accesses internal state. We execute this code directly during shutdown
            // to make sure it gets a chance to run.
            this.il(), this.yc.Lr(() => this.shutdown());
        }, this.window.addEventListener("unload", this.Sc));
    }
    ol() {
        this.Sc && (g("function" == typeof this.window.removeEventListener, "Expected 'window.removeEventListener' to be a function"), 
        this.window.removeEventListener("unload", this.Sc), this.Sc = null);
    }
    /**
     * Returns whether a client is "zombied" based on its LocalStorage entry.
     * Clients become zombied when their tab closes without running all of the
     * cleanup logic in `shutdown()`.
     */    nl(t) {
        try {
            const e = null !== this.xc.getItem(this.sl(t));
            return A(Ai, `Client '${t}' ${e ? "is" : "is not"} zombied in LocalStorage`), e;
        } catch (t) {
            // Gracefully handle if LocalStorage isn't working.
            return P(Ai, "Failed to get zombied client id.", t), !1;
        }
    }
    /**
     * Record client as zombied (a client that had its tab closed). Zombied
     * clients are ignored during primary tab selection.
     */    il() {
        try {
            this.xc.setItem(this.sl(this.clientId), String(Date.now()));
        } catch (t) {
            // Gracefully handle if LocalStorage isn't available / working.
            P("Failed to set zombie client id.", t);
        }
    }
    /** Removes the zombied client entry if it exists. */    hl() {
        try {
            this.xc.removeItem(this.sl(this.clientId));
        } catch (t) {
            // Ignore
        }
    }
    sl(t) {
        return `${bi}_${this.persistenceKey}_${t}`;
    }
}

/**
 * The name of the main (and currently only) IndexedDB database. this name is
 * appended to the prefix provided to the IndexedDbPersistence constructor.
 */
/**
 * Helper to get a typed SimpleDbStore for the primary client object store.
 */
function Di(t) {
    return t.store(ni.store);
}

/**
 * Helper to get a typed SimpleDbStore for the client metadata object store.
 */ function Ci(t) {
    return t.store(Ti.store);
}

/** Provides LRU functionality for IndexedDB persistence. */ Si.$c = "main";

class ki {
    constructor(t, e) {
        this.db = t, this.cl = null, this.ku = new On(this, e);
    }
    Bu(t) {
        const e = this.ll(t);
        return this.db.Pa().sc(t).next(t => e.next(e => t + e));
    }
    ll(t) {
        let e = 0;
        return this.Ou(t, t => {
            e++;
        }).next(() => e);
    }
    qn(t, e) {
        return this.db.Pa().qn(t, e);
    }
    Ou(t, e) {
        return this._l(t, (t, s) => e(s));
    }
    wa(t) {
        this.cl = t;
    }
    lo(t, e) {
        return Ni(t, e);
    }
    do(t, e) {
        return Ni(t, e);
    }
    Uu(t, e, s) {
        return this.db.Pa().Uu(t, e, s);
    }
    qh(t, e) {
        return Ni(t, e);
    }
    /**
     * Returns true if anything would prevent this document from being garbage
     * collected, given that the document in question is not present in any
     * targets and has a sequence number less than or equal to the upper bound for
     * the collection run.
     */    dl(t, e) {
        return this.cl.Io(e) ? on.resolve(!0) : function(t, e) {
            let s = !1;
            return Vn(t).fh(n => Rn(t, n, e).next(t => (t && (s = !0), on.resolve(!t)))).next(() => s);
        }(t, e);
    }
    Qu(t, e) {
        const s = this.db.Ra().Na(), n = [];
        let i = 0;
        return this._l(t, (r, o) => {
            if (o <= e) {
                const e = this.dl(t, r).next(e => {
                    if (!e) 
                    // Our size accounting requires us to read all documents before
                    // removing them.
                    return i++, s.qo(t, r).next(() => (s.Bo(r), zn(t).delete(function(t) {
                        return [ 0, Hs(t.path) ];
                    }
                    /**
 * @return A value suitable for writing a sentinel row in the target-document
 * store.
 */ (r))));
                });
                n.push(e);
            }
        }).next(() => on.ko(n)).next(() => s.apply(t)).next(() => i);
    }
    removeTarget(t, e) {
        const s = e.$s(t.Oa);
        return this.db.Pa().Qa(t, s);
    }
    Wa(t, e) {
        return Ni(t, e);
    }
    /**
     * Call provided function for each document in the cache that is 'orphaned'. Orphaned
     * means not a part of any target, so the only entry in the target-document index for
     * that document will be the sentinel row (targetId 0), which will also have the sequence
     * number for the last time the document was accessed.
     */    _l(t, e) {
        const s = zn(t);
        let n, i = Bs.Ir;
        return s.dh({
            index: _i.documentTargetsIndex
        }, ([t, s], {path: r, sequenceNumber: o}) => {
            0 === t ? (
            // if nextToReport is valid, report it, this is a new key so the
            // last one must not be a member of any targets.
            i !== Bs.Ir && e(new It(Xs(n)), i), 
            // set nextToReport to be this sequence number. It's the next one we
            // might report, if we don't find any targets for this document.
            // Note that the sequence number must be defined when the targetId
            // is 0.
            i = o, n = r) : 
            // set nextToReport to be invalid, we know we don't need to report
            // this one since we found a target for it.
            i = Bs.Ir;
        }).next(() => {
            // Since we report sequence numbers after getting to the next key, we
            // need to check if the last key we iterated over was an orphaned
            // document and report it.
            i !== Bs.Ir && e(new It(Xs(n)), i);
        });
    }
    Wu(t) {
        return this.db.Ra().mc(t);
    }
}

function Ni(t, e) {
    return zn(t).put(function(t, e) {
        return new _i(0, Hs(t.path), e);
    }(e, t.Oa));
}

/**
 * @license
 * Copyright 2019 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// TOOD(b/140938512): Drop SimpleQueryEngine and rename IndexFreeQueryEngine.
/**
 * A query engine that takes advantage of the target document mapping in the
 * QueryCache. The IndexFreeQueryEngine optimizes query execution by only
 * reading the documents that previously matched a query plus any documents that were
 * edited after the query was last listened to.
 *
 * There are some cases where Index-Free queries are not guaranteed to produce
 * the same results as full collection scans. In these cases, the
 * IndexFreeQueryEngine falls back to full query processing. These cases are:
 *
 * - Limit queries where a document that matched the query previously no longer
 *   matches the query.
 *
 * - Limit queries where a document edit may cause the document to sort below
 *   another document that is in the local cache.
 *
 * - Queries that have never been CURRENT or free of Limbo documents.
 */ class Fi {
    ga(t) {
        this.fl = t;
    }
    sa(t, e, s, n) {
        // Queries that match all documents don't benefit from using
        // IndexFreeQueries. It is more efficient to scan all documents in a
        // collection, rather than to perform individual lookups.
        return g(void 0 !== this.fl, "setLocalDocumentsView() not called"), e.us() ? this.ml(t, e) : 
        // Queries that have never seen a snapshot without limbo free documents
        // should also be run as a full collection scan.
        s.isEqual(dt.MIN) ? this.ml(t, e) : this.fl.ta(t, n).next(i => {
            const r = this.Tl(e, i);
            return (e.Ts() || e.ws()) && this.wl(e.Ke, r, n, s) ? this.ml(t, e) : (I() <= E.DEBUG && A("IndexFreeQueryEngine", "Re-using previous result from %s to execute query: %s", s.toString(), e.toString()), 
            this.fl.sa(t, e, s).next(t => (
            // We merge `previousResults` into `updateResults`, since
            // `updateResults` is already a DocumentMap. If a document is
            // contained in both lists, then its contents are the same.
            r.forEach(e => {
                t = t.lt(e.key, e);
            }), t)));
        });
    }
    /** Applies the query filter and sorting to the provided documents.  */    Tl(t, e) {
        // Sort the documents and re-apply the query filter since previously
        // matching documents do not necessarily still match the query.
        let s = new pt((e, s) => t.ls(e, s));
        return e.forEach((e, n) => {
            n instanceof ue && t.matches(n) && (s = s.add(n));
        }), s;
    }
    /**
     * Determines if a limit query needs to be refilled from cache, making it
     * ineligible for index-free execution.
     *
     * @param sortedPreviousResults The documents that matched the query when it
     * was last synchronized, sorted by the query's comparator.
     * @param remoteKeys The document keys that matched the query at the last
     * snapshot.
     * @param limboFreeSnapshotVersion The version of the snapshot when the query
     * was last synchronized.
     */    wl(t, e, s, n) {
        // The query needs to be refilled if a previously matching document no
        // longer matches.
        if (s.size !== e.size) return !0;
        // Limit queries are not eligible for index-free query execution if there is
        // a potential that an older document from cache now sorts before a document
        // that was previously part of the limit. This, however, can only happen if
        // the document at the edge of the limit goes out of limit.
        // If a document that is not the limit boundary sorts differently,
        // the boundary of the limit itself did not change and documents from cache
        // will continue to be "rejected" by this boundary. Therefore, we can ignore
        // any modifications that don't affect the last document.
                const i = t === Ie.We ? e.last() : e.first();
        return !!i && (i.hasPendingWrites || i.version.u(n) > 0);
    }
    ml(t, e) {
        return I() <= E.DEBUG && A("IndexFreeQueryEngine", "Using full collection scan to execute query: %s", e.toString()), 
        this.fl.sa(t, e, dt.MIN);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class $i {
    constructor(t, e) {
        this.mh = t, this.Th = e, 
        /**
         * The set of all mutations that have been sent but not yet been applied to
         * the backend.
         */
        this.Jh = [], 
        /** Next value to use when assigning sequential IDs to each mutation batch. */
        this.El = 1, 
        /** The last received stream token from the server, used to acknowledge which
         * responses the client has processed. Stream tokens are opaque checkpoint
         * markers whose only real value is their inclusion in the next request.
         */
        this.lastStreamToken = Qe.Ss, 
        /** An ordered mapping between documents and the mutations batch IDs. */
        this.Il = new pt(nn.Me);
    }
    Ih(t) {
        return on.resolve(0 === this.Jh.length);
    }
    Rh(t, e, s) {
        const n = e.batchId, i = this.Rl(n, "acknowledged");
        g(0 === i, "Can only acknowledge the first batch in the mutation queue");
        // Verify that the batch in the queue is the one to be acknowledged.
        const r = this.Jh[i];
        return g(n === r.batchId, "Queue ordering failure: expected batch " + n + ", got batch " + r.batchId), 
        this.lastStreamToken = s, on.resolve();
    }
    Ph(t) {
        return on.resolve(this.lastStreamToken);
    }
    ph(t, e) {
        return this.lastStreamToken = e, on.resolve();
    }
    Vh(t, e, s, n) {
        g(0 !== n.length, "Mutation batches should not be empty");
        const i = this.El;
        if (this.El++, this.Jh.length > 0) {
            g(this.Jh[this.Jh.length - 1].batchId < i, "Mutation batchIDs must be monotonically increasing order");
        }
        const r = new tn(i, e, s, n);
        this.Jh.push(r);
        // Track references by document key and index collection parents.
        for (const e of n) this.Il = this.Il.add(new nn(e.key, i)), this.mh.yh(t, e.key.path.K());
        return on.resolve(r);
    }
    bh(t, e) {
        return on.resolve(this.Al(e));
    }
    Sh(t, e) {
        const s = this.Al(e);
        return g(null != s, "Failed to find local mutation batch."), on.resolve(s.keys());
    }
    Dh(t, e) {
        const s = e + 1, n = this.Pl(s), i = n < 0 ? 0 : n;
        // The requested batchId may still be out of range so normalize it to the
        // start of the queue.
                return on.resolve(this.Jh.length > i ? this.Jh[i] : null);
    }
    Ch() {
        return on.resolve(0 === this.Jh.length ? Zs : this.El - 1);
    }
    kh(t) {
        return on.resolve(this.Jh.slice());
    }
    Nh(t, e) {
        const s = new nn(e, 0), n = new nn(e, Number.POSITIVE_INFINITY), i = [];
        return this.Il.Lt([ s, n ], t => {
            g(e.isEqual(t.key), "Should only iterate over a single key's batches");
            const s = this.Al(t.Ro);
            g(null !== s, "Batches in the index must exist in the main table"), i.push(s);
        }), on.resolve(i);
    }
    Fh(t, e) {
        let s = new pt(b);
        return e.forEach(t => {
            const e = new nn(t, 0), n = new nn(t, Number.POSITIVE_INFINITY);
            this.Il.Lt([ e, n ], e => {
                g(t.isEqual(e.key), "For each key, should only iterate over a single key's batches"), 
                s = s.add(e.Ro);
            });
        }), on.resolve(this.pl(s));
    }
    xh(t, e) {
        g(!e.Is(), "CollectionGroup queries should be handled in LocalDocumentsView");
        // Use the query path as a prefix for testing if a document matches the
        // query.
        const s = e.path, n = s.length + 1;
        // Construct a document reference for actually scanning the index. Unlike
        // the prefix the document key in this reference must have an even number of
        // segments. The empty segment can be used a suffix of the query path
        // because it precedes all other segments in an ordered traversal.
        let i = s;
        It.ht(i) || (i = i.child(""));
        const r = new nn(new It(i), 0);
        // Find unique batchIDs referenced by all documents potentially matching the
        // query.
                let o = new pt(b);
        return this.Il.Bt(t => {
            const e = t.key.path;
            return !!s.Y(e) && (
            // Rows with document keys more than one segment longer than the query
            // path can't be matches. For example, a query on 'rooms' can't match
            // the document /rooms/abc/messages/xyx.
            // TODO(mcg): we'll need a different scanner when we implement
            // ancestor queries.
            e.length === n && (o = o.add(t.Ro)), !0);
        }, r), on.resolve(this.pl(o));
    }
    pl(t) {
        // Construct an array of matching batches, sorted by batchID to ensure that
        // multiple mutations affecting the same document key are applied in order.
        const e = [];
        return t.forEach(t => {
            const s = this.Al(t);
            null !== s && e.push(s);
        }), e;
    }
    Mh(t, e) {
        g(0 === this.Rl(e.batchId, "removed"), "Can only remove the first entry of the mutation queue"), 
        this.Jh.shift();
        let s = this.Il;
        return on.forEach(e.mutations, n => {
            const i = new nn(n.key, e.batchId);
            return s = s.delete(i), this.Th.qh(t, n.key);
        }).next(() => {
            this.Il = s;
        });
    }
    Bh(t) {
        // No-op since the memory mutation queue does not maintain a separate cache.
    }
    Io(t, e) {
        const s = new nn(e, 0), n = this.Il.qt(s);
        return on.resolve(e.isEqual(n && n.key));
    }
    Oh(t) {
        return 0 === this.Jh.length && g(this.Il.G(), "Document leak -- detected dangling mutation references when queue is empty."), 
        on.resolve();
    }
    /**
     * Finds the index of the given batchId in the mutation queue and asserts that
     * the resulting index is within the bounds of the queue.
     *
     * @param batchId The batchId to search for
     * @param action A description of what the caller is doing, phrased in passive
     * form (e.g. "acknowledged" in a routine that acknowledges batches).
     */    Rl(t, e) {
        const s = this.Pl(t);
        return g(s >= 0 && s < this.Jh.length, "Batches must exist to be " + e), s;
    }
    /**
     * Finds the index of the given batchId in the mutation queue. This operation
     * is O(1).
     *
     * @return The computed index of the batch with the given batchId, based on
     * the state of the queue. Note this index can be negative if the requested
     * batchId has already been remvoed from the queue or past the end of the
     * queue if the batchId is larger than the last added batch.
     */    Pl(t) {
        if (0 === this.Jh.length) 
        // As an index this is past the end of the queue
        return 0;
        // Examine the front of the queue to figure out the difference between the
        // batchId and indexes in the array. Note that since the queue is ordered
        // by batchId, if the first batch has a larger batchId then the requested
        // batchId doesn't exist in the queue.
                return t - this.Jh[0].batchId;
    }
    /**
     * A version of lookupMutationBatch that doesn't return a promise, this makes
     * other functions that uses this code easier to read and more efficent.
     */    Al(t) {
        const e = this.Pl(t);
        if (e < 0 || e >= this.Jh.length) return null;
        const s = this.Jh[e];
        return g(s.batchId === t, "If found batch must match"), s;
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class xi {
    /**
     * @param sizer Used to assess the size of a document. For eager GC, this is expected to just
     * return 0 to avoid unnecessarily doing the work of calculating the size.
     */
    constructor(t, e) {
        this.mh = t, this.Vl = e, 
        /** Underlying cache of documents and their read times. */
        this.docs = new Rt(It.U), 
        /** Size of all cached documents. */
        this.size = 0;
    }
    /**
     * Adds the supplied entry to the cache and updates the cache size as appropriate.
     *
     * All calls of `addEntry`  are required to go through the RemoteDocumentChangeBuffer
     * returned by `newChangeBuffer()`.
     */    Mo(t, e, s) {
        g(!s.isEqual(dt.MIN), "Cannot add a document with a read time of zero");
        const n = e.key, i = this.docs.get(n), r = i ? i.size : 0, o = this.Vl(e);
        return this.docs = this.docs.lt(n, {
            oc: e,
            size: o,
            readTime: s
        }), this.size += o - r, this.mh.yh(t, n.path.K());
    }
    /**
     * Removes the specified entry from the cache and updates the cache size as appropriate.
     *
     * All calls of `removeEntry` are required to go through the RemoteDocumentChangeBuffer
     * returned by `newChangeBuffer()`.
     */    Bo(t) {
        const e = this.docs.get(t);
        e && (this.docs = this.docs.remove(t), this.size -= e.size);
    }
    qo(t, e) {
        const s = this.docs.get(e);
        return on.resolve(s ? s.oc : null);
    }
    getEntries(t, e) {
        let s = Ze();
        return e.forEach(t => {
            const e = this.docs.get(t);
            s = s.lt(t, e ? e.oc : null);
        }), on.resolve(s);
    }
    sa(t, e, s) {
        g(!e.Is(), "CollectionGroup queries should be handled in LocalDocumentsView");
        let n = es();
        // Documents are ordered by key, so we can use a prefix scan to narrow down
        // the documents we need to match the query against.
                const i = new It(e.path.child("")), r = this.docs.It(i);
        for (;r.gt(); ) {
            const {key: t, value: {oc: i, readTime: o}} = r.Vt();
            if (!e.path.Y(t.path)) break;
            o.u(s) <= 0 || i instanceof ue && e.matches(i) && (n = n.lt(i.key, i));
        }
        return on.resolve(n);
    }
    gl(t, e) {
        return on.forEach(this.docs, t => e(t));
    }
    lu(t, e) {
        throw new Error("getNewDocumentChanges() is not supported with MemoryPersistence");
    }
    du(t) {
        return on.resolve(dt.MIN);
    }
    Na(t) {
        // `trackRemovals` is ignores since the MemoryRemoteDocumentCache keeps
        // a separate changelog and does not need special handling for removals.
        return new xi.fc(this);
    }
    mc(t) {
        return on.resolve(this.size);
    }
}

/**
 * Handles the details of adding and updating documents in the MemoryRemoteDocumentCache.
 */ xi.fc = class extends hn {
    constructor(t) {
        super(), this.Tc = t;
    }
    Qo(t) {
        const e = [];
        return this.Fo.forEach((s, n) => {
            n ? e.push(this.Tc.Mo(t, n, this.readTime)) : this.Tc.Bo(s);
        }), on.ko(e);
    }
    Oo(t, e) {
        return this.Tc.qo(t, e);
    }
    Uo(t, e) {
        return this.Tc.getEntries(t, e);
    }
};

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class Mi {
    constructor(t) {
        this.persistence = t, 
        /**
         * Maps a target to the data about that target
         */
        this.yl = new rn(t => t.canonicalId()), 
        /** The last received snapshot version. */
        this.lastRemoteSnapshotVersion = dt.MIN, 
        /** The highest numbered target ID encountered. */
        this.highestTargetId = 0, 
        /** The highest sequence number encountered. */
        this.bl = 0, 
        /**
         * A ordered bidirectional mapping between documents and the remote target
         * IDs.
         */
        this.vl = new sn, this.targetCount = 0, this.zu = vn.Kh();
    }
    qn(t, e) {
        return this.yl.forEach((t, s) => e(s)), on.resolve();
    }
    Ma(t) {
        return on.resolve(this.lastRemoteSnapshotVersion);
    }
    Hu(t) {
        return on.resolve(this.bl);
    }
    Xa(t) {
        const e = this.zu.after(this.highestTargetId);
        return this.highestTargetId = e, on.resolve(e);
    }
    ja(t, e, s) {
        return s && (this.lastRemoteSnapshotVersion = s), e > this.bl && (this.bl = e), 
        on.resolve();
    }
    Ju(t) {
        this.yl.set(t.target, t);
        const e = t.targetId;
        e > this.highestTargetId && (this.highestTargetId = e), t.sequenceNumber > this.bl && (this.bl = t.sequenceNumber);
    }
    Za(t, e) {
        return g(!this.yl.has(e.target), "Adding a target that already exists"), this.Ju(e), 
        this.targetCount += 1, on.resolve();
    }
    Qa(t, e) {
        return g(this.yl.has(e.target), "Updating a non-existent target"), this.Ju(e), on.resolve();
    }
    Xu(t, e) {
        return g(this.targetCount > 0, "Removing a target from an empty cache"), g(this.yl.has(e.target), "Removing a non-existent target from the cache"), 
        this.yl.delete(e.target), this.vl.To(e.targetId), this.targetCount -= 1, on.resolve();
    }
    Uu(t, e, s) {
        let n = 0;
        const i = [];
        return this.yl.forEach((r, o) => {
            o.sequenceNumber <= e && null === s.get(o.targetId) && (this.yl.delete(r), i.push(this.Zu(t, o.targetId)), 
            n++);
        }), on.ko(i).next(() => n);
    }
    sc(t) {
        return on.resolve(this.targetCount);
    }
    Ya(t, e) {
        const s = this.yl.get(e) || null;
        return on.resolve(s);
    }
    Yn(t, e) {
        // This method is only needed for multi-tab and we can't implement it
        // efficiently without additional data structures.
        return V("Not yet implemented.");
    }
    qa(t, e, s) {
        this.vl._o(e, s);
        const n = this.persistence.Th, i = [];
        return n && e.forEach(e => {
            i.push(n.lo(t, e));
        }), on.ko(i);
    }
    Ba(t, e, s) {
        this.vl.mo(e, s);
        const n = this.persistence.Th, i = [];
        return n && e.forEach(e => {
            i.push(n.do(t, e));
        }), on.ko(i);
    }
    Zu(t, e) {
        return this.vl.To(e), on.resolve();
    }
    su(t, e) {
        const s = this.vl.Eo(e);
        return on.resolve(s);
    }
    Io(t, e) {
        return on.resolve(this.vl.Io(e));
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const Li = "MemoryPersistence";

/**
 * A memory-backed instance of Persistence. Data is stored only in RAM and
 * not persisted across sessions.
 */ class Bi {
    /**
     * The constructor accepts a factory for creating a reference delegate. This
     * allows both the delegate and this instance to have strong references to
     * each other without having nullable fields that would then need to be
     * checked or asserted on every access.
     */
    constructor(t, e) {
        this.clientId = t, this.Sl = {}, this.Wc = new Bs(0), this.vc = !1, this.vc = !0, 
        this.Th = e(this), this.Aa = new Mi(this);
        this.mh = new Xn, this.Hh = new xi(this.mh, t => this.Th.Dl(t));
    }
    static Cl(t, e) {
        return new Bi(t, t => new Ui(t, e));
    }
    static kl(t) {
        return new Bi(t, t => new Oi(t));
    }
    shutdown() {
        // No durable state to ensure is closed on shutdown.
        return this.vc = !1, Promise.resolve();
    }
    get Ta() {
        return this.vc;
    }
    async ru() {
        return [ this.clientId ];
    }
    jc(t) {
        // All clients using memory persistence act as primary.
        return t(!0);
    }
    zc() {
        // No op.
    }
    hu(t) {
        // No op.
    }
    Va() {
        return this.mh;
    }
    Ea(t) {
        let e = this.Sl[t._()];
        return e || (e = new $i(this.mh, this.Th), this.Sl[t._()] = e), e;
    }
    Pa() {
        return this.Aa;
    }
    Ra() {
        return this.Hh;
    }
    runTransaction(t, e, s) {
        A(Li, "Starting transaction:", t);
        const n = new qi(this.Wc.next());
        return this.Th.Nl(), s(n).next(t => this.Th.Fl(n).next(() => t)).Do().then(t => (n.zo(), 
        t));
    }
    $l(t, e) {
        return on.No(function(t) {
            const e = [];
            return W(t, (t, s) => e.push(s)), e;
        }(this.Sl).map(s => () => s.Io(t, e)));
    }
}

/**
 * Memory persistence is not actually transactional, but future implementations
 * may have transaction-scoped state.
 */ class qi extends un {
    constructor(t) {
        super(), this.Oa = t;
    }
}

class Oi {
    constructor(t) {
        this.persistence = t, this.cl = null, this.xl = null;
    }
    get Ml() {
        if (this.xl) return this.xl;
        throw V("orphanedDocuments is only valid during a transaction.");
    }
    wa(t) {
        this.cl = t;
    }
    lo(t, e) {
        return this.Ml.delete(e), on.resolve();
    }
    do(t, e) {
        return this.Ml.add(e), on.resolve();
    }
    qh(t, e) {
        return this.Ml.add(e), on.resolve();
    }
    removeTarget(t, e) {
        const s = this.persistence.Pa();
        return s.su(t, e.targetId).next(t => {
            t.forEach(t => this.Ml.add(t));
        }).next(() => s.Xu(t, e));
    }
    Nl() {
        this.xl = new Set;
    }
    Fl(t) {
        // Remove newly orphaned documents.
        const e = this.persistence.Ra().Na();
        return on.forEach(this.Ml, s => this.Ll(t, s).next(t => {
            t || e.Bo(s);
        })).next(() => (this.xl = null, e.apply(t)));
    }
    Wa(t, e) {
        return this.Ll(t, e).next(t => {
            t ? this.Ml.delete(e) : this.Ml.add(e);
        });
    }
    Dl(t) {
        // For eager GC, we don't care about the document size, there are no size thresholds.
        return 0;
    }
    Ll(t, e) {
        return on.No([ () => this.persistence.Pa().Io(t, e), () => this.persistence.$l(t, e), () => on.resolve(this.cl.Io(e)) ]);
    }
}

class Ui {
    constructor(t, e) {
        this.persistence = t, this.cl = null, this.Bl = new rn(t => Hs(t.path)), this.ku = new On(this, e);
    }
    // No-ops, present so memory persistence doesn't have to care which delegate
    // it has.
    Nl() {}
    Fl(t) {
        return on.resolve();
    }
    qn(t, e) {
        return this.persistence.Pa().qn(t, e);
    }
    Bu(t) {
        const e = this.ql(t);
        return this.persistence.Pa().sc(t).next(t => e.next(e => t + e));
    }
    ql(t) {
        let e = 0;
        return this.Ou(t, t => {
            e++;
        }).next(() => e);
    }
    Ou(t, e) {
        return on.forEach(this.Bl, (s, n) => this.dl(t, s, n).next(t => t ? on.resolve() : e(n)));
    }
    wa(t) {
        this.cl = t;
    }
    Uu(t, e, s) {
        return this.persistence.Pa().Uu(t, e, s);
    }
    Qu(t, e) {
        let s = 0;
        const n = this.persistence.Ra(), i = n.Na();
        return n.gl(t, n => this.dl(t, n, e).next(t => {
            t || (s++, i.Bo(n));
        })).next(() => i.apply(t)).next(() => s);
    }
    qh(t, e) {
        return this.Bl.set(e, t.Oa), on.resolve();
    }
    removeTarget(t, e) {
        const s = e.$s(t.Oa);
        return this.persistence.Pa().Qa(t, s);
    }
    lo(t, e) {
        return this.Bl.set(e, t.Oa), on.resolve();
    }
    do(t, e) {
        return this.Bl.set(e, t.Oa), on.resolve();
    }
    Wa(t, e) {
        return this.Bl.set(e, t.Oa), on.resolve();
    }
    Dl(t) {
        let e = t.key.toString().length;
        return t instanceof ue && (e += t.data().Se()), e;
    }
    dl(t, e, s) {
        return on.No([ () => this.persistence.$l(t, e), () => on.resolve(this.cl.Io(e)), () => this.persistence.Pa().Io(t, e), () => {
            const t = this.Bl.get(e);
            return on.resolve(void 0 !== t && t > s);
        } ]);
    }
    Wu(t) {
        return this.persistence.Ra().mc(t);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const Qi = "ExponentialBackoff", Wi = 1e3, ji = 1.5, zi = 6e4;

/**
 * Initial backoff time in milliseconds after an error.
 * Set to 1s according to https://cloud.google.com/apis/design/errors.
 */
/**
 * A helper for running delayed tasks following an exponential backoff curve
 * between attempts.
 *
 * Each delay is made up of a "base" delay which follows the exponential
 * backoff curve, and a +/- 50% "jitter" that is calculated and added to the
 * base delay. This prevents clients from accidentally synchronizing their
 * delays causing spikes of load to the backend.
 */
class Ki {
    constructor(
    /**
     * The AsyncQueue to run backoff operations on.
     */
    t, 
    /**
     * The ID to use when scheduling backoff operations on the AsyncQueue.
     */
    e, 
    /**
     * The initial delay (used as the base delay on the first retry attempt).
     * Note that jitter will still be applied, so the actual delay could be as
     * little as 0.5*initialDelayMs.
     */
    s = Wi
    /**
     * The multiplier to use to determine the extended base delay after each
     * attempt.
     */ , n = ji
    /**
     * The maximum base delay after which no further backoff is performed.
     * Note that jitter will still be applied, so the actual delay could be as
     * much as 1.5*maxDelayMs.
     */ , i = zi) {
        this.yc = t, this.Dr = e, this.Ol = s, this.Ul = n, this.Ql = i, this.Wl = 0, this.jl = null, 
        /** The last backoff attempt, as epoch milliseconds. */
        this.zl = Date.now(), this.reset();
    }
    /**
     * Resets the backoff delay.
     *
     * The very next backoffAndWait() will have no delay. If it is called again
     * (i.e. due to an error), initialDelayMs (plus jitter) will be used, and
     * subsequent ones will increase according to the backoffFactor.
     */    reset() {
        this.Wl = 0;
    }
    /**
     * Resets the backoff delay to the maximum delay (e.g. for use after a
     * RESOURCE_EXHAUSTED error).
     */    Kl() {
        this.Wl = this.Ql;
    }
    /**
     * Returns a promise that resolves after currentDelayMs, and increases the
     * delay for any subsequent attempts. If there was a pending backoff operation
     * already, it will be canceled.
     */    Gl(t) {
        // Cancel any pending backoff operation.
        this.cancel();
        // First schedule using the current base (which may be 0 and should be
        // honored as such).
        const e = Math.floor(this.Wl + this.Hl()), s = Math.max(0, Date.now() - this.zl), n = Math.max(0, e - s);
        // Guard against lastAttemptTime being in the future due to a clock change.
                this.Wl > 0 && A(Qi, `Backing off for ${n} ms ` + `(base delay: ${this.Wl} ms, ` + `delay with jitter: ${e} ms, ` + `last attempt: ${s} ms ago)`), 
        this.jl = this.yc.Yr(this.Dr, n, () => (this.zl = Date.now(), t())), 
        // Apply backoff factor to determine next delay and ensure it is within
        // bounds.
        this.Wl *= this.Ul, this.Wl < this.Ol && (this.Wl = this.Ol), this.Wl > this.Ql && (this.Wl = this.Ql);
    }
    cancel() {
        null !== this.jl && (this.jl.cancel(), this.jl = null);
    }
    /** Returns a random value in the range [-currentBaseMs/2, currentBaseMs/2] */    Hl() {
        return (Math.random() - .5) * this.Wl;
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const Gi = "PersistentStream";

/**
 * PersistentStream can be in one of 5 states (each described in detail below)
 * based on the following state transition diagram:
 *
 *          start() called             auth & connection succeeded
 * INITIAL ----------------> STARTING -----------------------------> OPEN
 *                             ^  |                                   |
 *                             |  |                    error occurred |
 *                             |  \-----------------------------v-----/
 *                             |                                |
 *                    backoff  |                                |
 *                    elapsed  |              start() called    |
 *                             \--- BACKOFF <---------------- ERROR
 *
 * [any state] --------------------------> INITIAL
 *               stop() called or
 *               idle timer expired
 */ var Hi, Ji;

/**
     * The streaming RPC is not yet running and there's no error condition.
     * Calling start() will start the stream immediately without backoff.
     * While in this state isStarted() will return false.
     */
(Ji = Hi || (Hi = {}))[Ji.Jl = 0] = "__PRIVATE_Initial", 
/**
     * The stream is starting, either waiting for an auth token or for the stream
     * to successfully open. While in this state, isStarted() will return true but
     * isOpen() will return false.
     */
Ji[Ji.Yl = 1] = "__PRIVATE_Starting", 
/**
     * The streaming RPC is up and running. Requests and responses can flow
     * freely. Both isStarted() and isOpen() will return true.
     */
Ji[Ji.Xl = 2] = "__PRIVATE_Open", 
/**
     * The stream encountered an error. The next start attempt will back off.
     * While in this state isStarted() will return false.
     */
Ji[Ji.Error = 3] = "Error", 
/**
     * An in-between state after an error where the stream is waiting before
     * re-starting. After waiting is complete, the stream will try to open.
     * While in this state isStarted() will return true but isOpen() will return
     * false.
     */
Ji[Ji.Zl = 4] = "__PRIVATE_Backoff";

/** The time a stream stays open after it is marked idle. */
const Yi = 6e4;

/**
 * A PersistentStream is an abstract base class that represents a streaming RPC
 * to the Firestore backend. It's built on top of the connections own support
 * for streaming RPCs, and adds several critical features for our clients:
 *
 *   - Exponential backoff on failure
 *   - Authentication via CredentialsProvider
 *   - Dispatching all callbacks into the shared worker queue
 *   - Closing idle streams after 60 seconds of inactivity
 *
 * Subclasses of PersistentStream implement serialization of models to and
 * from the JSON representation of the protocol buffers for a specific
 * streaming RPC.
 *
 * ## Starting and Stopping
 *
 * Streaming RPCs are stateful and need to be start()ed before messages can
 * be sent and received. The PersistentStream will call the onOpen() function
 * of the listener once the stream is ready to accept requests.
 *
 * Should a start() fail, PersistentStream will call the registered onClose()
 * listener with a FirestoreError indicating what went wrong.
 *
 * A PersistentStream can be started and stopped repeatedly.
 *
 * Generic types:
 *  SendType: The type of the outgoing message of the underlying
 *    connection stream
 *  ReceiveType: The type of the incoming message of the underlying
 *    connection stream
 *  ListenerType: The type of the listener that will be used for callbacks
 */ class Xi {
    constructor(t, e, s, n, i, r) {
        this.yc = t, this.t_ = s, this.connection = n, this.e_ = i, this.listener = r, this.state = Hi.Jl, 
        /**
         * A close count that's incremented every time the stream is closed; used by
         * getCloseGuardedDispatcher() to invalidate callbacks that happen after
         * close.
         */
        this.s_ = 0, this.n_ = null, this.stream = null, this.i_ = new Ki(t, e);
    }
    /**
     * Returns true if start() has been called and no error has occurred. True
     * indicates the stream is open or in the process of opening (which
     * encompasses respecting backoff, getting auth tokens, and starting the
     * actual RPC). Use isOpen() to determine if the stream is open and ready for
     * outbound requests.
     */    r_() {
        return this.state === Hi.Yl || this.state === Hi.Xl || this.state === Hi.Zl;
    }
    /**
     * Returns true if the underlying RPC is open (the onOpen() listener has been
     * called) and the stream is ready for outbound requests.
     */    o_() {
        return this.state === Hi.Xl;
    }
    /**
     * Starts the RPC. Only allowed if isStarted() returns false. The stream is
     * not immediately ready for use: onOpen() will be invoked when the RPC is
     * ready for outbound requests, at which point isOpen() will return true.
     *
     * When start returns, isStarted() will return true.
     */    start() {
        this.state !== Hi.Error ? (g(this.state === Hi.Jl, "Already started"), this.auth()) : this.h_();
    }
    /**
     * Stops the RPC. This call is idempotent and allowed regardless of the
     * current isStarted() state.
     *
     * When stop returns, isStarted() and isOpen() will both return false.
     */    async stop() {
        this.r_() && await this.close(Hi.Jl);
    }
    /**
     * After an error the stream will usually back off on the next attempt to
     * start it. If the error warrants an immediate restart of the stream, the
     * sender can use this to indicate that the receiver should not back off.
     *
     * Each error will call the onClose() listener. That function can decide to
     * inhibit backoff if required.
     */    a_() {
        g(!this.r_(), "Can only inhibit backoff in a stopped state"), this.state = Hi.Jl, 
        this.i_.reset();
    }
    /**
     * Marks this stream as idle. If no further actions are performed on the
     * stream for one minute, the stream will automatically close itself and
     * notify the stream's onClose() handler with Status.OK. The stream will then
     * be in a !isStarted() state, requiring the caller to start the stream again
     * before further use.
     *
     * Only streams that are in state 'Open' can be marked idle, as all other
     * states imply pending network operations.
     */    u_() {
        // Starts the idle time if we are in state 'Open' and are not yet already
        // running a timer (in which case the previous idle timeout still applies).
        this.o_() && null === this.n_ && (this.n_ = this.yc.Yr(this.t_, Yi, () => this.c_()));
    }
    /** Sends a message to the underlying stream. */    l_(t) {
        this.__(), this.stream.send(t);
    }
    /** Called by the idle timer when the stream should close due to inactivity. */    async c_() {
        if (this.o_()) 
        // When timing out an idle stream there's no reason to force the stream into backoff when
        // it restarts so set the stream state to Initial instead of Error.
        return this.close(Hi.Jl);
    }
    /** Marks the stream as active again. */    __() {
        this.n_ && (this.n_.cancel(), this.n_ = null);
    }
    /**
     * Closes the stream and cleans up as necessary:
     *
     * * closes the underlying GRPC stream;
     * * calls the onClose handler with the given 'error';
     * * sets internal stream state to 'finalState';
     * * adjusts the backoff timer based on the error
     *
     * A new stream can be opened by calling start().
     *
     * @param finalState the intended state of the stream after closing.
     * @param error the error the connection was closed with.
     */    async close(t, e) {
        g(this.r_(), "Only started streams should be closed."), g(t === Hi.Error || Te(e), "Can't provide an error when not in an error state."), 
        // Cancel any outstanding timers (they're guaranteed not to execute).
        this.__(), this.i_.cancel(), 
        // Invalidates any stream-related callbacks (e.g. from auth or the
        // underlying stream), guaranteeing they won't execute.
        this.s_++, t !== Hi.Error ? 
        // If this is an intentional close ensure we don't delay our next connection attempt.
        this.i_.reset() : e && e.code === F.RESOURCE_EXHAUSTED ? (
        // Log the error. (Probably either 'quota exceeded' or 'max queue length reached'.)
        P(e.toString()), P("Using maximum backoff delay to prevent overloading the backend."), 
        this.i_.Kl()) : e && e.code === F.UNAUTHENTICATED && 
        // "unauthenticated" error means the token was rejected. Try force refreshing it in case it
        // just expired.
        this.e_.A(), 
        // Clean up the underlying stream because we are no longer interested in events.
        null !== this.stream && (this.d_(), this.stream.close(), this.stream = null), 
        // This state must be assigned before calling onClose() to allow the callback to
        // inhibit backoff or otherwise manipulate the state in its non-started state.
        this.state = t, 
        // Notify the listener that the stream closed.
        await this.listener.f_(e);
    }
    /**
     * Can be overridden to perform additional cleanup before the stream is closed.
     * Calling super.tearDown() is not required.
     */    d_() {}
    auth() {
        g(this.state === Hi.Jl, "Must be in initial state to auth"), this.state = Hi.Yl;
        const t = this.m_(this.s_), e = this.s_;
        // TODO(mikelehen): Just use dispatchIfNotClosed, but see TODO below.
                this.e_.getToken().then(t => {
            // Stream can be stopped while waiting for authentication.
            // TODO(mikelehen): We really should just use dispatchIfNotClosed
            // and let this dispatch onto the queue, but that opened a spec test can
            // of worms that I don't want to deal with in this PR.
            this.s_ === e && 
            // Normally we'd have to schedule the callback on the AsyncQueue.
            // However, the following calls are safe to be called outside the
            // AsyncQueue since they don't chain asynchronous calls
            this.T_(t);
        }, e => {
            t(() => {
                const t = new $(F.UNKNOWN, "Fetching auth token failed: " + e.message);
                return this.w_(t);
            });
        });
    }
    T_(t) {
        g(this.state === Hi.Yl, "Trying to start stream in a non-starting state");
        const e = this.m_(this.s_);
        this.stream = this.E_(t), this.stream.I_(() => {
            e(() => (g(this.state === Hi.Yl, "Expected stream to be in state Starting, but was " + this.state), 
            this.state = Hi.Xl, this.listener.I_()));
        }), this.stream.f_(t => {
            e(() => this.w_(t));
        }), this.stream.onMessage(t => {
            e(() => this.onMessage(t));
        });
    }
    h_() {
        g(this.state === Hi.Error, "Should only perform backoff when in Error state"), this.state = Hi.Zl, 
        this.i_.Gl(async () => {
            g(this.state === Hi.Zl, "Backoff elapsed but state is now: " + this.state), this.state = Hi.Jl, 
            this.start(), g(this.r_(), "PersistentStream should have started");
        });
    }
    // Visible for tests
    w_(t) {
        // In theory the stream could close cleanly, however, in our current model
        // we never expect this to happen because if we stop a stream ourselves,
        // this callback will never be called. To prevent cases where we retry
        // without a backoff accidentally, we set the stream to error in all cases.
        return g(this.r_(), "Can't handle server close on non-started stream"), A(Gi, `close with error: ${t}`), 
        this.stream = null, this.close(Hi.Error, t);
    }
    /**
     * Returns a "dispatcher" function that dispatches operations onto the
     * AsyncQueue but only runs them if closeCount remains unchanged. This allows
     * us to turn auth / stream callbacks into no-ops if the stream is closed /
     * re-opened, etc.
     */    m_(t) {
        return e => {
            this.yc.Lr(() => this.s_ === t ? e() : (A(Gi, "stream callback skipped by getCloseGuardedDispatcher."), 
            Promise.resolve()));
        };
    }
}

/**
 * A PersistentStream that implements the Listen RPC.
 *
 * Once the Listen stream has called the onOpen() listener, any number of
 * listen() and unlisten() calls can be made to control what changes will be
 * sent from the server for ListenResponses.
 */ class Zi extends Xi {
    constructor(t, e, s, n, i) {
        super(t, Os.Pr, Os.Ar, e, s, i), this.serializer = n;
    }
    E_(t) {
        return this.connection.R_("Listen", t);
    }
    onMessage(t) {
        // A successful response means the stream is healthy
        this.i_.reset();
        const e = this.serializer.Di(t), s = this.serializer.ki(t);
        return this.listener.A_(e, s);
    }
    /**
     * Registers interest in the results of the given target. If the target
     * includes a resumeToken it will be included in the request. Results that
     * affect the target will be streamed back as WatchChange messages that
     * reference the targetId.
     */    watch(t) {
        const e = {};
        e.database = this.serializer.mi, e.addTarget = this.serializer.cs(t);
        const s = this.serializer.Zi(t);
        s && (e.labels = s), this.l_(e);
    }
    /**
     * Unregisters interest in the results of the target associated with the
     * given targetId.
     */    P_(t) {
        const e = {};
        e.database = this.serializer.mi, e.removeTarget = t, this.l_(e);
    }
}

/**
 * A Stream that implements the Write RPC.
 *
 * The Write RPC requires the caller to maintain special streamToken
 * state in between calls, to help the server understand which responses the
 * client has processed by the time the next request is made. Every response
 * will contain a streamToken; this value must be passed to the next
 * request.
 *
 * After calling start() on this stream, the next request must be a handshake,
 * containing whatever streamToken is on hand. Once a response to this
 * request is received, all pending mutations may be submitted. When
 * submitting multiple batches of mutations at the same time, it's
 * okay to use the same streamToken for the calls to writeMutations.
 *
 * TODO(b/33271235): Use proto types
 */ class tr extends Xi {
    constructor(t, e, s, n, i) {
        super(t, Os.Vr, Os.pr, e, s, i), this.serializer = n, this.p_ = !1, 
        /**
         * The last received stream token from the server, used to acknowledge which
         * responses the client has processed. Stream tokens are opaque checkpoint
         * markers whose only real value is their inclusion in the next request.
         *
         * PersistentWriteStream manages propagating this value from responses to the
         * next request.
         */
        this.lastStreamToken = Qe.Ss;
    }
    /**
     * Tracks whether or not a handshake has been successfully exchanged and
     * the stream is ready to accept mutations.
     */    get V_() {
        return this.p_;
    }
    // Override of PersistentStream.start
    start() {
        this.p_ = !1, super.start();
    }
    d_() {
        this.p_ && this.g_([]);
    }
    E_(t) {
        return this.connection.R_("Write", t);
    }
    onMessage(t) {
        if (
        // Always capture the last stream token.
        g(!!t.streamToken, "Got a write response without a stream token"), this.lastStreamToken = this.serializer.ii(t.streamToken), 
        this.p_) {
            // A successful first write response means the stream is healthy,
            // Note, that we could consider a successful handshake healthy, however,
            // the write itself might be causing an error we want to back off from.
            this.i_.reset();
            const e = this.serializer.Ui(t.writeResults, t.commitTime), s = this.serializer.fromVersion(t.commitTime);
            return this.listener.y_(s, e);
        }
        // The first response is always the handshake response
        return g(!t.writeResults || 0 === t.writeResults.length, "Got mutation results for handshake"), 
        this.p_ = !0, this.listener.b_();
    }
    /**
     * Sends an initial streamToken to the server, performing the handshake
     * required to make the StreamingWrite RPC work. Subsequent
     * calls should wait until onHandshakeComplete was called.
     */    v_() {
        g(this.o_(), "Writing handshake requires an opened stream"), g(!this.p_, "Handshake already completed");
        // TODO(dimond): Support stream resumption. We intentionally do not set the
        // stream token on the handshake, ignoring any stream token we might have.
        const t = {};
        t.database = this.serializer.mi, this.l_(t);
    }
    /** Sends a group of mutations to the Firestore backend to apply. */    g_(t) {
        g(this.o_(), "Writing mutations requires an opened stream"), g(this.p_, "Handshake must be complete before writing mutations"), 
        g(this.lastStreamToken.Se() > 0, "Trying to write mutation without a token");
        const e = {
            streamToken: this.serializer.ni(this.lastStreamToken),
            writes: t.map(t => this.serializer.Ni(t))
        };
        this.l_(e);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Datastore is a wrapper around the external Google Cloud Datastore grpc API,
 * which provides an interface that is more convenient for the rest of the
 * client SDK architecture to consume.
 */ class er {
    constructor(t, e, s, n) {
        this.yc = t, this.connection = e, this.credentials = s, this.serializer = n;
    }
    S_(t) {
        return new tr(this.yc, this.connection, this.credentials, this.serializer, t);
    }
    D_(t) {
        return new Zi(this.yc, this.connection, this.credentials, this.serializer, t);
    }
    commit(t) {
        const e = {
            database: this.serializer.mi,
            writes: t.map(t => this.serializer.Ni(t))
        };
        return this.C_("Commit", e).then(t => this.serializer.Ui(t.writeResults, t.commitTime));
    }
    lookup(t) {
        const e = {
            database: this.serializer.mi,
            documents: t.map(t => this.serializer.ci(t))
        };
        return this.k_("BatchGetDocuments", e).then(e => {
            let s = Xe();
            e.forEach(t => {
                const e = this.serializer.bi(t);
                s = s.lt(e.key, e);
            });
            const n = [];
            return t.forEach(t => {
                const e = s.get(t);
                g(!!e, "Missing entity in write response for " + t), n.push(e);
            }), n;
        });
    }
    /** Gets an auth token and invokes the provided RPC. */    C_(t, e) {
        return this.credentials.getToken().then(s => this.connection.C_(t, e, s)).catch(t => {
            throw t.code === F.UNAUTHENTICATED && this.credentials.A(), t;
        });
    }
    /** Gets an auth token and invokes the provided RPC with streamed results. */    k_(t, e) {
        return this.credentials.getToken().then(s => this.connection.k_(t, e, s)).catch(t => {
            throw t.code === F.UNAUTHENTICATED && this.credentials.A(), t;
        });
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// The objects that are a part of this API are exposed to third-parties as
// compiled javascript so we want to flag our private members with a leading
// underscore to discourage their use.
/**
 * A FieldPath refers to a field in a document. The path may consist of a single
 * field name (referring to a top-level field in the document), or a list of
 * field names (referring to a nested field in the document).
 */ class sr {
    /**
     * Creates a FieldPath from the provided field names. If more than one field
     * name is provided, the path will point to a nested field in a document.
     *
     * @param fieldNames A list of field names.
     */
    constructor(...t) {
        !function(t, e, s, n) {
            if (!(e instanceof Array) || e.length < n) throw new $(F.INVALID_ARGUMENT, `Function ${t}() requires its ${s} argument to be an ` + "array with at least " + `${ct(n, "element")}.`);
        }("FieldPath", t, "fieldNames", 1);
        for (let e = 0; e < t.length; ++e) if (J("FieldPath", "string", e, t[e]), 0 === t[e].length) throw new $(F.INVALID_ARGUMENT, "Invalid field name at argument $(i + 1). Field names must not be empty.");
        this.N_ = new Et(t);
    }
    static documentId() {
        return sr.F_;
    }
    isEqual(t) {
        if (!(t instanceof sr)) throw ht("isEqual", "FieldPath", 1, t);
        return this.N_.isEqual(t.N_);
    }
}

/**
 * Internal Note: The backend doesn't technically support querying by
 * document ID. Instead it queries by the entire document name (full path
 * included), but in the cases we currently support documentId(), the net
 * effect is the same.
 */ sr.F_ = new sr(Et.rt().tt());

/**
 * Matches any characters in a field path string that are reserved.
 */
const nr = new RegExp("[~\\*/\\[\\]]");

/**
 * Parses a field path string into a FieldPath, treating dots as separators.
 */
/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * An opaque base class for FieldValue sentinel objects in our public API,
 * with public static methods for creating said sentinel objects.
 */
class ir {
    constructor(t) {
        this.x_ = t;
    }
    static delete() {
        return z("FieldValue.delete", arguments), rr.instance;
    }
    static serverTimestamp() {
        return z("FieldValue.serverTimestamp", arguments), or.instance;
    }
    static arrayUnion(...t) {
        // NOTE: We don't actually parse the data until it's used in set() or
        // update() since we need access to the Firestore instance.
        return G("FieldValue.arrayUnion", arguments, 1), new hr(t);
    }
    static arrayRemove(...t) {
        // NOTE: We don't actually parse the data until it's used in set() or
        // update() since we need access to the Firestore instance.
        return G("FieldValue.arrayRemove", arguments, 1), new ar(t);
    }
    static increment(t) {
        return J("FieldValue.increment", "number", 1, t), K("FieldValue.increment", arguments, 1), 
        new ur(t);
    }
    isEqual(t) {
        return this === t;
    }
}

class rr extends ir {
    constructor() {
        super("FieldValue.delete");
    }
}

/** Singleton instance. */ rr.instance = new rr;

class or extends ir {
    constructor() {
        super("FieldValue.serverTimestamp");
    }
}

/** Singleton instance. */ or.instance = new or;

class hr extends ir {
    constructor(t) {
        super("FieldValue.arrayUnion"), this.M_ = t;
    }
}

class ar extends ir {
    constructor(t) {
        super("FieldValue.arrayRemove"), this.M_ = t;
    }
}

class ur extends ir {
    constructor(t) {
        super("FieldValue.increment"), this.L_ = t;
    }
}

// Public instance that disallows construction at runtime. This constructor is
// used when exporting FieldValueImpl on firebase.firestore.FieldValue and will
// be called FieldValue publicly. Internally we still use FieldValueImpl which
// has a type-checked private constructor. Note that FieldValueImpl and
// PublicFieldValue can be used interchangeably in instanceof checks.
// For our internal TypeScript code PublicFieldValue doesn't exist as a type,
// and so we need to use FieldValueImpl as type and export it too.
const cr = Fs(ir, "Use FieldValue.<field>() instead."), lr = /^__.*__$/;

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** The result of parsing document data (e.g. for a setData call). */
class _r {
    constructor(t, e, s) {
        this.data = t, this.oe = e, this.fieldTransforms = s;
    }
    B_(t, e) {
        const s = [];
        return null !== this.oe ? s.push(new Ut(t, this.data, this.oe, e)) : s.push(new Ot(t, this.data, e)), 
        this.fieldTransforms.length > 0 && s.push(new Qt(t, this.fieldTransforms)), s;
    }
}

/** The result of parsing "update" data (i.e. for an updateData call). */ class dr {
    constructor(t, e, s) {
        this.data = t, this.oe = e, this.fieldTransforms = s;
    }
    B_(t, e) {
        const s = [ new Ut(t, this.data, this.oe, e) ];
        return this.fieldTransforms.length > 0 && s.push(new Qt(t, this.fieldTransforms)), 
        s;
    }
}

/*
 * Represents what type of API method provided the data being parsed; useful
 * for determining which error conditions apply during parsing and providing
 * better error messages.
 */ var fr, mr;

function Tr(t) {
    switch (t) {
      case fr.Set:
 // fall through
              case fr.q_:
 // fall through
              case fr.O_:
        return !0;

      case fr.U_:
      case fr.Q_:
        return !1;

      default:
        throw V(`Unexpected case for UserDataSource: ${t}`);
    }
}

/** A "context" object passed around while parsing user data. */ (mr = fr || (fr = {}))[mr.Set = 0] = "Set", 
mr[mr.O_ = 1] = "__PRIVATE_Update", mr[mr.q_ = 2] = "__PRIVATE_MergeSet", 
/**
     * Indicates the source is a where clause, cursor bound, arrayUnion()
     * element, etc. Of note, isWrite(source) will return false.
     */
mr[mr.U_ = 3] = "__PRIVATE_Argument", 
/**
     * Indicates that the source is an Argument that may directly contain nested
     * arrays (e.g. the operand of an `in` query).
     */
mr[mr.Q_ = 4] = "__PRIVATE_ArrayArgument";

class wr {
    /**
     * Initializes a ParseContext with the given source and path.
     *
     * @param dataSource Indicates what kind of API method this data came from.
     * @param methodName The name of the method the user called to create this
     *     ParseContext.
     * @param path A path within the object being parsed. This could be an empty
     *     path (in which case the context represents the root of the data being
     *     parsed), or a nonempty path (indicating the context represents a nested
     *     location within the data).
     * @param arrayElement Whether or not this context corresponds to an element
     *     of an array.
     * @param fieldTransforms A mutable list of field transforms encountered while
     *     parsing the data.
     * @param fieldMask A mutable list of field paths encountered while parsing
     *     the data.
     *
     * TODO(b/34871131): We don't support array paths right now, so path can be
     * null to indicate the context represents any location within an array (in
     * which case certain features will not work and errors will be somewhat
     * compromised).
     */
    constructor(t, e, s, n, i, r) {
        this.W_ = t, this.methodName = e, this.path = s, this.j_ = n, 
        // Minor hack: If fieldTransforms is undefined, we assume this is an
        // external call and we need to validate the entire path.
        void 0 === i && this.z_(), this.j_ = void 0 !== n && n, this.fieldTransforms = i || [], 
        this.oe = r || [];
    }
    K_(t) {
        const e = null == this.path ? null : this.path.child(t), s = new wr(this.W_, this.methodName, e, 
        /*arrayElement=*/ !1, this.fieldTransforms, this.oe);
        return s.G_(t), s;
    }
    H_(t) {
        const e = null == this.path ? null : this.path.child(t), s = new wr(this.W_, this.methodName, e, 
        /*arrayElement=*/ !1, this.fieldTransforms, this.oe);
        return s.z_(), s;
    }
    J_(t) {
        // TODO(b/34871131): We don't support array paths right now; so make path
        // null.
        return new wr(this.W_, this.methodName, 
        /*path=*/ null, 
        /*arrayElement=*/ !0, this.fieldTransforms, this.oe);
    }
    Y_(t) {
        const e = null === this.path || this.path.G() ? "" : ` (found in field ${this.path.toString()})`;
        return new $(F.INVALID_ARGUMENT, `Function ${this.methodName}() called with invalid data. ` + t + e);
    }
    /** Returns 'true' if 'fieldPath' was traversed when creating this context. */    contains(t) {
        return void 0 !== this.oe.find(e => t.Y(e)) || void 0 !== this.fieldTransforms.find(e => t.Y(e.field));
    }
    z_() {
        // TODO(b/34871131): Remove null check once we have proper paths for fields
        // within arrays.
        if (null !== this.path) for (let t = 0; t < this.path.length; t++) this.G_(this.path.get(t));
    }
    G_(t) {
        if (0 === t.length) throw this.Y_("Document fields must not be empty");
        if (Tr(this.W_) && lr.test(t)) throw this.Y_('Document fields cannot begin and end with "__"');
    }
}

/**
 * A placeholder object for DocumentReferences in this file, in order to
 * avoid a circular dependency. See the comments for `DataPreConverter` for
 * the full context.
 */ class Er {
    constructor(t, e) {
        this.o = t, this.key = e;
    }
}

/**
 * Helper for parsing raw user input (provided via the API) into internal model
 * classes.
 */ class Ir {
    constructor(t) {
        this.X_ = t;
    }
    /** Parse document data from a non-merge set() call. */    Z_(t, e) {
        const s = new wr(fr.Set, t, Et.st);
        Ar("Data must be an object, but it was:", s, e);
        const n = this.td(e, s);
        return new _r(n, 
        /* fieldMask= */ null, s.fieldTransforms);
    }
    /** Parse document data from a set() call with '{merge:true}'. */    ed(t, e, s) {
        const n = new wr(fr.q_, t, Et.st);
        Ar("Data must be an object, but it was:", n, e);
        const i = this.td(e, n);
        let r, o;
        if (s) {
            let e = new pt(Et.U);
            for (const i of s) {
                let s;
                if (i instanceof sr) s = i.N_; else {
                    if ("string" != typeof i) throw V("Expected stringOrFieldPath to be a string or a FieldPath");
                    s = pr(t, i);
                }
                if (!n.contains(s)) throw new $(F.INVALID_ARGUMENT, `Field '${s}' is specified in your field mask but missing from your input data.`);
                e = e.add(s);
            }
            r = Dt.Gt(e), o = n.fieldTransforms.filter(t => r.Jt(t.field));
        } else r = Dt.Ht(n.oe), o = n.fieldTransforms;
        return new _r(i, r, o);
    }
    /** Parse update data from an update() call. */    sd(t, e) {
        const s = new wr(fr.O_, t, Et.st);
        Ar("Data must be an object, but it was:", s, e);
        let n = new pt(Et.U), i = oe.EMPTY;
        W(e, (e, r) => {
            const o = pr(t, e), h = s.H_(o);
            if ((r = this.nd(r, h)) instanceof rr) 
            // Add it to the field mask, but don't add anything to updateData.
            n = n.add(o); else {
                const t = this.td(r, h);
                null != t && (n = n.add(o), i = i.set(o, t));
            }
        });
        const r = Dt.Gt(n);
        return new dr(i, r, s.fieldTransforms);
    }
    /** Parse update data from a list of field/value arguments. */    rd(t, e, s, n) {
        const i = new wr(fr.O_, t, Et.st), r = [ Pr(t, e) ], o = [ s ];
        if (n.length % 2 != 0) throw new $(F.INVALID_ARGUMENT, `Function ${t}() needs to be called with an even number ` + "of arguments that alternate between field names and values.");
        for (let e = 0; e < n.length; e += 2) r.push(Pr(t, n[e])), o.push(n[e + 1]);
        let h = new pt(Et.U), a = oe.EMPTY;
        for (let t = 0; t < r.length; ++t) {
            const e = r[t], s = i.H_(e), n = this.nd(o[t], s);
            if (n instanceof rr) 
            // Add it to the field mask, but don't add anything to updateData.
            h = h.add(e); else {
                const t = this.td(n, s);
                null != t && (h = h.add(e), a = a.set(e, t));
            }
        }
        const u = Dt.Gt(h);
        return new dr(a, u, i.fieldTransforms);
    }
    /**
     * Parse a "query value" (e.g. value in a where filter or a value in a cursor
     * bound).
     *
     * @param allowArrays Whether the query value is an array that may directly
     * contain additional arrays (e.g. the operand of an `in` query).
     */    od(t, e, s = !1) {
        const n = new wr(s ? fr.Q_ : fr.U_, t, Et.st), i = this.td(e, n);
        return g(null != i, "Parsed data should not be null."), g(0 === n.fieldTransforms.length, "Field transforms should have been disallowed."), 
        i;
    }
    /** Sends data through this.preConverter, handling any thrown errors. */    nd(t, e) {
        try {
            return this.X_(t);
        } catch (t) {
            const s = Vr(t);
            throw e.Y_(s);
        }
    }
    /**
     * Internal helper for parsing user data.
     *
     * @param input Data to be parsed.
     * @param context A context object representing the current path being parsed,
     * the source of the data being parsed, etc.
     * @return The parsed value, or null if the value was a FieldValue sentinel
     * that should not be included in the resulting parsed data.
     */    td(t, e) {
        if (Rr(t = this.nd(t, e))) return Ar("Unsupported field value:", e, t), this.hd(t, e);
        if (t instanceof ir) 
        // FieldValues usually parse into transforms (except FieldValue.delete())
        // in which case we do not want to include this field in our parsed data
        // (as doing so will overwrite the field directly prior to the transform
        // trying to transform it). So we don't add this location to
        // context.fieldMask and we return null as our parsing result.
        return this.ad(t, e), null;
        if (
        // If context.path is null we are inside an array and we don't support
        // field mask paths more granular than the top-level array.
        e.path && e.oe.push(e.path), t instanceof Array) {
            // TODO(b/34871131): Include the path containing the array in the error
            // message.
            // In the case of IN queries, the parsed data is an array (representing
            // the set of values to be included for the IN query) that may directly
            // contain additional arrays (each representing an individual field
            // value), so we disable this validation.
            if (e.j_ && e.W_ !== fr.Q_) throw e.Y_("Nested arrays are not supported");
            return this.ud(t, e);
        }
        return this.ld(t, e);
    }
    hd(t, e) {
        let s = new Rt(b);
        return j(t) ? 
        // If we encounter an empty object, we explicitly add it to the update
        // mask to ensure that the server creates a map entry.
        e.path && e.path.length > 0 && e.oe.push(e.path) : W(t, (t, n) => {
            const i = this.td(n, e.K_(t));
            null != i && (s = s.lt(t, i));
        }), new oe(s);
    }
    ud(t, e) {
        const s = [];
        let n = 0;
        for (const i of t) {
            let t = this.td(i, e.J_(n));
            null == t && (
            // Just include nulls in the array for fields being replaced with a
            // sentinel.
            t = Gt.De), s.push(t), n++;
        }
        return new he(s);
    }
    /**
     * "Parses" the provided FieldValueImpl, adding any necessary transforms to
     * context.fieldTransforms.
     */    ad(t, e) {
        // Sentinels are only supported with writes, and not within arrays.
        if (!Tr(e.W_)) throw e.Y_(`${t.x_}() can only be used with update() and set()`);
        if (null === e.path) throw e.Y_(`${t.x_}() is not currently supported inside arrays`);
        if (t instanceof rr) {
            if (e.W_ !== fr.q_) throw e.W_ === fr.O_ ? (g(e.path.length > 0, "FieldValue.delete() at the top level should have already been handled."), 
            e.Y_("FieldValue.delete() can only appear at the top level of your update data")) : e.Y_("FieldValue.delete() cannot be used with set() unless you pass {merge:true}");
            // No transform to add for a delete, but we need to add it to our
            // fieldMask so it gets deleted.
            e.oe.push(e.path);
        } else if (t instanceof or) e.fieldTransforms.push(new Ct(e.path, gt.instance)); else if (t instanceof hr) {
            const s = this._d(t.x_, t.M_), n = new yt(s);
            e.fieldTransforms.push(new Ct(e.path, n));
        } else if (t instanceof ar) {
            const s = this._d(t.x_, t.M_), n = new bt(s);
            e.fieldTransforms.push(new Ct(e.path, n));
        } else if (t instanceof ur) {
            const s = this.od("FieldValue.increment", t.L_), n = new vt(s);
            e.fieldTransforms.push(new Ct(e.path, n));
        } else V("Unknown FieldValue type: " + t);
    }
    /**
     * Helper to parse a scalar value (i.e. not an Object, Array, or FieldValue)
     *
     * @return The parsed value
     */    ld(t, e) {
        if (null === t) return Gt.De;
        if ("number" == typeof t) return we(t) ? new Xt(t) : new Zt(t);
        if ("boolean" == typeof t) return Ht.of(t);
        if ("string" == typeof t) return new te(t);
        if (t instanceof Date) return new ee(_t.fromDate(t));
        if (t instanceof _t) 
        // Firestore backend truncates precision down to microseconds. To ensure
        // offline mode works the same with regards to truncation, perform the
        // truncation immediately without waiting for the backend to do that.
        return new ee(new _t(t.seconds, 1e3 * Math.floor(t.nanoseconds / 1e3)));
        if (t instanceof lt) return new re(t);
        if (t instanceof Ms) return new ne(t);
        if (t instanceof Er) return new ie(t.o, t.key);
        throw e.Y_(`Unsupported field value: ${it(t)}`);
    }
    _d(t, e) {
        return e.map((e, s) => {
            // Although array transforms are used with writes, the actual elements
            // being unioned or removed are not considered writes since they cannot
            // contain any FieldValue sentinels, etc.
            const n = new wr(fr.U_, t, Et.st);
            return this.td(e, n.J_(s));
        });
    }
}

/**
 * Checks whether an object looks like a JSON object that should be converted
 * into a struct. Normal class/prototype instances are considered to look like
 * JSON objects since they should be converted to a struct value. Arrays, Dates,
 * GeoPoints, etc. are not considered to look like JSON objects since they map
 * to specific FieldValue types other than ObjectValue.
 */ function Rr(t) {
    return !("object" != typeof t || null === t || t instanceof Array || t instanceof Date || t instanceof _t || t instanceof lt || t instanceof Ms || t instanceof Er || t instanceof ir);
}

function Ar(t, e, s) {
    if (!Rr(s) || !nt(s)) {
        const n = it(s);
        throw "an object" === n ? e.Y_(t + " a custom object") : e.Y_(t + " " + n);
    }
}

/**
 * Helper that calls fromDotSeparatedString() but wraps any error thrown.
 */ function Pr(t, e) {
    if (e instanceof sr) return e.N_;
    if ("string" == typeof e) return pr(t, e);
    {
        const e = "Field path arguments must be of type string or FieldPath.";
        throw new $(F.INVALID_ARGUMENT, `Function ${t}() called with invalid data. ${e}`);
    }
}

/**
 * Wraps fromDotSeparatedString with an error message about the method that
 * was thrown.
 * @param methodName The publicly visible method name
 * @param path The dot-separated string form of a field path which will be split
 * on dots.
 */ function pr(t, e) {
    try {
        return function(t) {
            if (t.search(nr) >= 0) throw new $(F.INVALID_ARGUMENT, `Invalid field path (${t}). Paths must not contain ` + "'~', '*', '/', '[', or ']'");
            try {
                return new sr(...t.split("."));
            } catch (e) {
                throw new $(F.INVALID_ARGUMENT, `Invalid field path (${t}). Paths must not be empty, ` + "begin with '.', end with '.', or contain '..'");
            }
        }(e).N_;
    } catch (e) {
        const s = Vr(e);
        throw new $(F.INVALID_ARGUMENT, `Function ${t}() called with invalid data. ${s}`);
    }
}

/**
 * Extracts the message from a caught exception, which should be an Error object
 * though JS doesn't guarantee that.
 */ function Vr(t) {
    return t instanceof Error ? t.message : t.toString();
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Internal transaction object responsible for accumulating the mutations to
 * perform and the base versions for any documents read.
 */ class gr {
    constructor(t) {
        this.dd = t, 
        // The version of each document that was read during this transaction.
        this.fd = ns(), this.mutations = [], this.md = !1, 
        /**
         * A deferred usage error that occurred previously in this transaction that
         * will cause the transaction to fail once it actually commits.
         */
        this.Td = null, 
        /**
         * Set of documents that have been written in the transaction.
         *
         * When there's more than one write to the same key in a transaction, any
         * writes after the first are handled differently.
         */
        this.wd = new Set;
    }
    async lookup(t) {
        if (this.Ed(), this.mutations.length > 0) throw new $(F.INVALID_ARGUMENT, "Firestore transactions require all reads to be executed before all writes.");
        const e = await this.dd.lookup(t);
        return e.forEach(t => {
            t instanceof ce || t instanceof ue ? this.Id(t) : V("Document in a transaction was a " + t.constructor.name);
        }), e;
    }
    set(t, e) {
        this.write(e.B_(t, this.ne(t))), this.wd.add(t);
    }
    update(t, e) {
        try {
            this.write(e.B_(t, this.Rd(t)));
        } catch (t) {
            this.Td = t;
        }
        this.wd.add(t);
    }
    delete(t) {
        this.write([ new Wt(t, this.ne(t)) ]), this.wd.add(t);
    }
    async commit() {
        if (this.Ed(), this.Td) throw this.Td;
        let t = this.fd;
        // For each mutation, note that the doc was written.
                this.mutations.forEach(e => {
            t = t.remove(e.key);
        }), 
        // For each document that was read but not written to, we want to perform
        // a `verify` operation.
        t.forEach((t, e) => {
            this.mutations.push(new jt(t, this.ne(t)));
        }), await this.dd.commit(this.mutations), this.md = !0;
    }
    Id(t) {
        let e;
        if (t instanceof ue) e = t.version; else {
            if (!(t instanceof ce)) throw V("Document in a transaction was a " + t.constructor.name);
            // For deleted docs, we must use baseVersion 0 when we overwrite them.
            e = dt.B();
        }
        const s = this.fd.get(t.key);
        if (null !== s) {
            if (!e.isEqual(s)) 
            // This transaction will fail no matter what.
            throw new $(F.ABORTED, "Document version changed between two reads.");
        } else this.fd = this.fd.lt(t.key, e);
    }
    /**
     * Returns the version of this document when it was read in this transaction,
     * as a precondition, or no precondition if it was not read.
     */    ne(t) {
        const e = this.fd.get(t);
        return !this.wd.has(t) && e ? Bt.updateTime(e) : Bt.NONE;
    }
    /**
     * Returns the precondition for a document if the operation is an update.
     */    Rd(t) {
        const e = this.fd.get(t);
        // The first time a document is written, we want to take into account the
        // read time and existence
                if (!this.wd.has(t) && e) {
            if (e.isEqual(dt.B())) 
            // The document doesn't exist, so fail the transaction.
            // This has to be validated locally because you can't send a
            // precondition that a document does not exist without changing the
            // semantics of the backend write to be an insert. This is the reverse
            // of what we want, since we want to assert that the document doesn't
            // exist but then send the update and have it fail. Since we can't
            // express that to the backend, we have to validate locally.
            // Note: this can change once we can send separate verify writes in the
            // transaction.
            throw new $(F.INVALID_ARGUMENT, "Can't update a document that doesn't exist.");
            // Document exists, base precondition on document update time.
                        return Bt.updateTime(e);
        }
        // Document was not read, so we just use the preconditions for a blind
        // update.
        return Bt.exists(!0);
    }
    write(t) {
        this.Ed(), this.mutations = this.mutations.concat(t);
    }
    Ed() {
        g(!this.md, "A transaction object cannot be used after its update callback has been invoked.");
    }
}

/**
 * @license
 * Copyright 2018 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const yr = "OnlineStateTracker", br = 1, vr = 1e4;

// To deal with transient failures, we allow multiple stream attempts before
// giving up and transitioning from OnlineState.Unknown to Offline.
// TODO(mikelehen): This used to be set to 2 as a mitigation for b/66228394.
// @jdimond thinks that bug is sufficiently fixed so that we can set this back
// to 1. If that works okay, we could potentially remove this logic entirely.
/**
 * A component used by the RemoteStore to track the OnlineState (that is,
 * whether or not the client as a whole should be considered to be online or
 * offline), implementing the appropriate heuristics.
 *
 * In particular, when the client is trying to connect to the backend, we
 * allow up to MAX_WATCH_STREAM_FAILURES within ONLINE_STATE_TIMEOUT_MS for
 * a connection to succeed. If we have too many failures or the timeout elapses,
 * then we set the OnlineState to Offline, and the client will behave as if
 * it is offline (get()s will return cached data, etc.).
 */
class Sr {
    constructor(t, e) {
        this.Sr = t, this.Ad = e, 
        /** The current OnlineState. */
        this.state = $e.ps, 
        /**
         * A count of consecutive failures to open the stream. If it reaches the
         * maximum defined by MAX_WATCH_STREAM_FAILURES, we'll set the OnlineState to
         * Offline.
         */
        this.Pd = 0, 
        /**
         * A timer that elapses after ONLINE_STATE_TIMEOUT_MS, at which point we
         * transition from OnlineState.Unknown to OnlineState.Offline without waiting
         * for the stream to actually fail (MAX_WATCH_STREAM_FAILURES times).
         */
        this.pd = null, 
        /**
         * Whether the client should log a warning message if it fails to connect to
         * the backend (initially true, cleared after a successful stream, or if we've
         * logged the message already).
         */
        this.Vd = !0;
    }
    /**
     * Called by RemoteStore when a watch stream is started (including on each
     * backoff attempt).
     *
     * If this is the first attempt, it sets the OnlineState to Unknown and starts
     * the onlineStateTimer.
     */    gd() {
        0 === this.Pd && (this.yd($e.ps), g(null === this.pd, "onlineStateTimer shouldn't be started yet"), 
        this.pd = this.Sr.Yr(Os.gr, vr, () => (this.pd = null, g(this.state === $e.ps, "Timer should be canceled if we transitioned to a different state."), 
        this.bd(`Backend didn't respond within ${vr / 1e3} ` + "seconds."), this.yd($e.gs), 
        Promise.resolve())));
    }
    /**
     * Updates our OnlineState as appropriate after the watch stream reports a
     * failure. The first failure moves us to the 'Unknown' state. We then may
     * allow multiple failures (based on MAX_WATCH_STREAM_FAILURES) before we
     * actually transition to the 'Offline' state.
     */    vd(t) {
        this.state === $e.Vs ? (this.yd($e.ps), 
        // To get to OnlineState.Online, set() must have been called which would
        // have reset our heuristics.
        g(0 === this.Pd, "watchStreamFailures must be 0"), g(null === this.pd, "onlineStateTimer must be null")) : (this.Pd++, 
        this.Pd >= br && (this.Sd(), this.bd(`Connection failed ${br} ` + `times. Most recent error: ${t.toString()}`), 
        this.yd($e.gs)));
    }
    /**
     * Explicitly sets the OnlineState to the specified state.
     *
     * Note that this resets our timers / failure counters, etc. used by our
     * Offline heuristics, so must not be used in place of
     * handleWatchStreamStart() and handleWatchStreamFailure().
     */    set(t) {
        this.Sd(), this.Pd = 0, t === $e.Vs && (
        // We've connected to watch at least once. Don't warn the developer
        // about being offline going forward.
        this.Vd = !1), this.yd(t);
    }
    yd(t) {
        t !== this.state && (this.state = t, this.Ad(t));
    }
    bd(t) {
        const e = `Could not reach Cloud Firestore backend. ${t}\n` + "This typically indicates that your device does not have a healthy Internet connection at the moment. The client will operate in offline mode until it is able to successfully connect to the backend.";
        this.Vd ? (P(e), this.Vd = !1) : A(yr, e);
    }
    Sd() {
        null !== this.pd && (this.pd.cancel(), this.pd = null);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const Dr = "RemoteStore", Cr = 10;

// TODO(b/35853402): Negotiate this with the stream.
/**
 * RemoteStore - An interface to remotely stored data, basically providing a
 * wrapper around the Datastore that is more reliable for the rest of the
 * system.
 *
 * RemoteStore is responsible for maintaining the connection to the server.
 * - maintaining a list of active listens.
 * - reconnecting when the connection is dropped.
 * - resuming all the active listens on reconnect.
 *
 * RemoteStore handles all incoming events from the Datastore.
 * - listening to the watch stream and repackaging the events as RemoteEvents
 * - notifying SyncEngine of any changes to the active listens.
 *
 * RemoteStore takes writes from other components and handles them reliably.
 * - pulling pending mutations from LocalStore and sending them to Datastore.
 * - retrying mutations that failed because of network problems.
 * - acking mutations to the SyncEngine once they are accepted or rejected.
 */
class kr {
    constructor(
    /**
     * The local store, used to fill the write pipeline with outbound mutations.
     */
    t, 
    /** The client-side proxy for interacting with the backend. */
    e, s, n, i) {
        this.Nu = t, this.dd = e, 
        /**
         * A list of up to MAX_PENDING_WRITES writes that we have fetched from the
         * LocalStore via fillWritePipeline() and have or will send to the write
         * stream.
         *
         * Whenever writePipeline.length > 0 the RemoteStore will attempt to start or
         * restart the write stream. When the stream is established the writes in the
         * pipeline will be sent in order.
         *
         * Writes remain in writePipeline until they are acknowledged by the backend
         * and thus will automatically be re-sent if the stream is interrupted /
         * restarted before they're acknowledged.
         *
         * Write responses from the backend are linked to their originating request
         * purely based on order, and so we can just shift() writes from the front of
         * the writePipeline as we receive responses.
         */
        this.Dd = [], 
        /**
         * A mapping of watched targets that the client cares about tracking and the
         * user has explicitly called a 'listen' for this target.
         *
         * These targets may or may not have been sent to or acknowledged by the
         * server. On re-establishing the listen stream, these targets should be sent
         * to the server. The targets removed with unlistens are removed eagerly
         * without waiting for confirmation from the listen stream.
         */
        this.Cd = {}, this.kd = null, 
        /**
         * Set to true by enableNetwork() and false by disableNetwork() and indicates
         * the user-preferred network state.
         */
        this.networkEnabled = !1, this.isPrimary = !1, this.Nd = i, this.Nd.Fd(t => {
            s.Lr(async () => {
                this.$d() && (A(Dr, "Restarting streams for network reachability change."), await this.xd());
            });
        }), this.Md = new Sr(s, n), 
        // Create streams (but note they're not started yet).
        this.Ld = this.dd.D_({
            I_: this.Bd.bind(this),
            f_: this.qd.bind(this),
            A_: this.Od.bind(this)
        }), this.Ud = this.dd.S_({
            I_: this.Qd.bind(this),
            f_: this.Wd.bind(this),
            b_: this.jd.bind(this),
            y_: this.y_.bind(this)
        });
    }
    /**
     * Starts up the remote store, creating streams, restoring state from
     * LocalStore, etc.
     */    start() {
        return this.enableNetwork();
    }
    /** Re-enables the network. Idempotent. */    async enableNetwork() {
        this.networkEnabled = !0, this.$d() && (this.Ud.lastStreamToken = await this.Nu.Ph(), 
        this.zd() ? this.Kd() : this.Md.set($e.ps), 
        // This will start the write stream if necessary.
        await this.Gd());
    }
    /**
     * Temporarily disables the network. The network can be re-enabled using
     * enableNetwork().
     */    async disableNetwork() {
        this.networkEnabled = !1, await this.Hd(), 
        // Set the OnlineState to Offline so get()s return from cache, etc.
        this.Md.set($e.gs);
    }
    async Hd() {
        await this.Ud.stop(), await this.Ld.stop(), this.Dd.length > 0 && (A(Dr, `Stopping write stream with ${this.Dd.length} pending writes`), 
        this.Dd = []), this.Jd();
    }
    async shutdown() {
        A(Dr, "RemoteStore shutting down."), this.networkEnabled = !1, await this.Hd(), 
        this.Nd.shutdown(), 
        // Set the OnlineState to Unknown (rather than Offline) to avoid potentially
        // triggering spurious listener events with cached data, etc.
        this.Md.set($e.ps);
    }
    /**
     * Starts new listen for the given target. Uses resume token if provided. It
     * is a no-op if the target of given `TargetData` is already being listened to.
     */    listen(t) {
        O(this.Cd, t.targetId) || (
        // Mark this as something the client is currently listening for.
        this.Cd[t.targetId] = t, this.zd() ? 
        // The listen will be sent in onWatchStreamOpen
        this.Kd() : this.Ld.o_() && this.Yd(t));
    }
    /**
     * Removes the listen from server. It is a no-op if the given target id is
     * not being listened to.
     */    Xd(t) {
        g(O(this.Cd, t), `unlisten called on target no currently watched: ${t}`), delete this.Cd[t], 
        this.Ld.o_() && this.Zd(t), j(this.Cd) && (this.Ld.o_() ? this.Ld.u_() : this.$d() && 
        // Revert to OnlineState.Unknown if the watch stream is not open and we
        // have no listeners, since without any listens to send we cannot
        // confirm if the stream is healthy and upgrade to OnlineState.Online.
        this.Md.set($e.ps));
    }
    /** {@link TargetMetadataProvider.getTargetDataForTarget} */    Yn(t) {
        return this.Cd[t] || null;
    }
    /** {@link TargetMetadataProvider.getRemoteKeysForTarget} */    Jn(t) {
        return this.tf.Jn(t);
    }
    /**
     * We need to increment the the expected number of pending responses we're due
     * from watch so we wait for the ack to process any messages from this target.
     */    Yd(t) {
        this.kd.vn(t.targetId), this.Ld.watch(t);
    }
    /**
     * We need to increment the expected number of pending responses we're due
     * from watch so we wait for the removal on the server before we process any
     * messages from this target.
     */    Zd(t) {
        this.kd.vn(t), this.Ld.P_(t);
    }
    Kd() {
        g(this.zd(), "startWatchStream() called when shouldStartWatchStream() is false."), 
        this.kd = new Vs(this), this.Ld.start(), this.Md.gd();
    }
    /**
     * Returns whether the watch stream should be started because it's necessary
     * and has not yet been started.
     */    zd() {
        return this.$d() && !this.Ld.r_() && !j(this.Cd);
    }
    $d() {
        return this.isPrimary && this.networkEnabled;
    }
    Jd() {
        this.kd = null;
    }
    async Bd() {
        Q(this.Cd, (t, e) => {
            this.Yd(e);
        });
    }
    async qd(t) {
        void 0 === t && 
        // Graceful stop (due to stop() or idle timeout). Make sure that's
        // desirable.
        g(!this.zd(), "Watch stream was stopped gracefully while still needed."), this.Jd(), 
        // If we still need the watch stream, retry the connection.
        this.zd() ? (this.Md.vd(t), this.Kd()) : 
        // No need to restart watch stream because there are no active targets.
        // The online state is set to unknown because there is no active attempt
        // at establishing a connection
        this.Md.set($e.ps);
    }
    async Od(t, e) {
        if (
        // Mark the client as online since we got a message from the server
        this.Md.set($e.Vs), t instanceof As && t.state === ds.Us && t.cause) 
        // There was an error on a target, don't wait for a consistent snapshot
        // to raise events
        return this.ef(t);
        if (t instanceof Is ? this.kd.xn(t) : t instanceof Rs ? this.kd.Wn(t) : (g(t instanceof As, "Expected watchChange to be an instance of WatchTargetChange"), 
        this.kd.Bn(t)), !e.isEqual(dt.MIN)) {
            const t = await this.Nu.Ma();
            e.u(t) >= 0 && 
            // We have received a target change with a global snapshot if the snapshot
            // version is not equal to SnapshotVersion.MIN.
            await this.sf(e);
        }
    }
    /**
     * Takes a batch of changes from the Datastore, repackages them as a
     * RemoteEvent, and passes that on to the listener, which is typically the
     * SyncEngine.
     */    sf(t) {
        g(!t.isEqual(dt.MIN), "Can't raise event for unknown SnapshotVersion");
        const e = this.kd.Kn(t);
        // Update in-memory resume tokens. LocalStore will update the
        // persistent view of these when applying the completed RemoteEvent.
                // Finally raise remote event
        return Q(e.tn, (e, s) => {
            if (s.resumeToken.Se() > 0) {
                const n = this.Cd[e];
                // A watched target might have been removed already.
                                n && (this.Cd[e] = n.xs(s.resumeToken, t));
            }
        }), 
        // Re-establish listens for the targets that have been invalidated by
        // existence filter mismatches.
        e.en.forEach(t => {
            const e = this.Cd[t];
            if (!e) 
            // A watched target might have been removed already.
            return;
            // Clear the resume token for the target, since we're in a known mismatch
            // state.
                        this.Cd[t] = e.xs(Qe.Ss, e.Fs), 
            // Cause a hard reset by unwatching and rewatching immediately, but
            // deliberately don't send a resume token so that we get a full update.
            this.Zd(t);
            // Mark the target we send as being on behalf of an existence filter
            // mismatch, but don't actually retain that in listenTargets. This ensures
            // that we flag the first re-listen this way without impacting future
            // listens of this target (that might happen e.g. on reconnect).
            const s = new ze(e.target, t, Be.Cs, e.sequenceNumber);
            this.Yd(s);
        }), this.tf.La(e);
    }
    /** Handles an error on a target */    ef(t) {
        g(!!t.cause, "Handling target error without a cause");
        const e = t.cause;
        let s = Promise.resolve();
        return t.targetIds.forEach(t => {
            s = s.then(async () => {
                // A watched target might have been removed already.
                if (O(this.Cd, t)) return delete this.Cd[t], this.kd.removeTarget(t), this.tf.nf(t, e);
            });
        }), s;
    }
    /**
     * Attempts to fill our write pipeline with writes from the LocalStore.
     *
     * Called internally to bootstrap or refill the write pipeline and by
     * SyncEngine whenever there are new mutations to process.
     *
     * Starts the write stream if necessary.
     */    async Gd() {
        if (this.if()) {
            const t = this.Dd.length > 0 ? this.Dd[this.Dd.length - 1].batchId : Zs, e = await this.Nu.Ga(t);
            null === e ? 0 === this.Dd.length && this.Ud.u_() : (this.rf(e), await this.Gd());
        }
        this.hf() && this.af();
    }
    /**
     * Returns true if we can add to the write pipeline (i.e. the network is
     * enabled and the write pipeline is not full).
     */    if() {
        return this.$d() && this.Dd.length < Cr;
    }
    // For testing
    uf() {
        return this.Dd.length;
    }
    /**
     * Queues additional writes to be sent to the write stream, sending them
     * immediately if the write stream is established.
     */    rf(t) {
        g(this.if(), "addToWritePipeline called when pipeline is full"), this.Dd.push(t), 
        this.Ud.o_() && this.Ud.V_ && this.Ud.g_(t.mutations);
    }
    hf() {
        return this.$d() && !this.Ud.r_() && this.Dd.length > 0;
    }
    af() {
        g(this.hf(), "startWriteStream() called when shouldStartWriteStream() is false."), 
        this.Ud.start();
    }
    async Qd() {
        this.Ud.v_();
    }
    jd() {
        // Record the stream token.
        return this.Nu.ph(this.Ud.lastStreamToken).then(() => {
            // Send the write pipeline now that the stream is established.
            for (const t of this.Dd) this.Ud.g_(t.mutations);
        }).catch(Nn);
    }
    y_(t, e) {
        // This is a response to a write containing mutations and should be
        // correlated to the first write in our write pipeline.
        g(this.Dd.length > 0, "Got result for empty write pipeline");
        const s = this.Dd.shift(), n = en.from(s, t, e, this.Ud.lastStreamToken);
        return this.tf.cf(n).then(() => this.Gd());
    }
    async Wd(t) {
        // If the write stream closed due to an error, invoke the error callbacks if
        // there are pending writes.
        if (void 0 === t && 
        // Graceful stop (due to stop() or idle timeout). Make sure that's
        // desirable.
        g(!this.hf(), "Write stream was stopped gracefully while still needed."), t && this.Dd.length > 0) {
            // A promise that is resolved after we processed the error
            let e;
            // This error affects the actual write.
            return (e = this.Ud.V_ ? this.lf(t) : this._f(t)).then(() => {
                // The write stream might have been started by refilling the write
                // pipeline for failed writes
                this.hf() && this.af();
            });
        }
        // No pending writes, nothing to do
        }
    async _f(t) {
        // Reset the token if it's a permanent error, signaling the write stream is
        // no longer valid. Note that the handshake does not count as a write: see
        // comments on isPermanentWriteError for details.
        if (Ge(t.code)) return A(Dr, "RemoteStore error before completed handshake; resetting stream token: ", this.Ud.lastStreamToken), 
        this.Ud.lastStreamToken = Qe.Ss, this.Nu.ph(Qe.Ss).catch(Nn);
    }
    async lf(t) {
        // Only handle permanent errors here. If it's transient, just let the retry
        // logic kick in.
        if (Ge(e = t.code) && e !== F.ABORTED) {
            // This was a permanent error, the request itself was the problem
            // so it's not going to succeed if we resend it.
            const e = this.Dd.shift();
            // In this case it's also unlikely that the server itself is melting
            // down -- this was just a bad request so inhibit backoff on the next
            // restart.
                        return this.Ud.a_(), this.tf.df(e.batchId, t).then(() => this.Gd());
        }
        var e;
        /**
 * Maps an error Code from a GRPC status identifier like 'NOT_FOUND'.
 *
 * @returns The Code equivalent to the given status string or undefined if
 *     there is no match.
 */    }
    ff() {
        return new gr(this.dd);
    }
    async xd() {
        this.networkEnabled = !1, await this.Hd(), this.Md.set($e.ps), await this.enableNetwork();
    }
    async mf() {
        this.$d() && (
        // Tear down and re-create our network streams. This will ensure we get a fresh auth token
        // for the new user and re-fill the write pipeline with new mutations from the LocalStore
        // (since mutations are per-user).
        A(Dr, "RemoteStore restarting streams for new credential"), await this.xd());
    }
    /**
     * Toggles the network state when the client gains or loses its primary lease.
     */    async Tf(t) {
        this.isPrimary = t, t && this.networkEnabled ? await this.enableNetwork() : t || (await this.Hd(), 
        this.Md.set($e.ps));
    }
}

/**
 * @license
 * Copyright 2019 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// The format of the LocalStorage key that stores the client state is:
//     firestore_clients_<persistence_prefix>_<instance_key>
const Nr = "firestore_clients";

/** Assembles the key for a client state in WebStorage */ function Fr(t, e) {
    return g(-1 === e.indexOf("_"), `Client key cannot contain '_', but was '${e}'`), 
    `${Nr}_${t}_${e}`;
}

// The format of the WebStorage key that stores the mutation state is:
//     firestore_mutations_<persistence_prefix>_<batch_id>
//     (for unauthenticated users)
// or: firestore_mutations_<persistence_prefix>_<batch_id>_<user_uid>
//
// 'user_uid' is last to avoid needing to escape '_' characters that it might
// contain.
const $r = "firestore_mutations";

/** Assembles the key for a mutation batch in WebStorage */ function xr(t, e, s) {
    let n = `${$r}_${t}_${s}`;
    return e.l() && (n += `_${e.uid}`), n;
}

// The format of the WebStorage key that stores a query target's metadata is:
//     firestore_targets_<persistence_prefix>_<target_id>
const Mr = "firestore_targets";

/** Assembles the key for a query state in WebStorage */ function Lr(t, e) {
    return `${Mr}_${t}_${e}`;
}

// The WebStorage prefix that stores the primary tab's online state. The
// format of the key is:
//     firestore_online_state_<persistence_prefix>
const Br = "firestore_online_state";

/** Assembles the key for the online state of the primary tab. */
// The WebStorage key prefix for the key that stores the last sequence number allocated. The key
// looks like 'firestore_sequence_number_<persistence_prefix>'.
const qr = "firestore_sequence_number";

/** Assembles the key for the current sequence number. */
/**
 * @license
 * Copyright 2018 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Or = "SharedClientState";

/**
 * Holds the state of a mutation batch, including its user ID, batch ID and
 * whether the batch is 'pending', 'acknowledged' or 'rejected'.
 */
// Visible for testing
class Ur {
    constructor(t, e, s, n) {
        this.user = t, this.batchId = e, this.state = s, this.error = n, g(void 0 !== n == ("rejected" === s), "MutationMetadata must contain an error iff state is 'rejected'");
    }
    /**
     * Parses a MutationMetadata from its JSON representation in WebStorage.
     * Logs a warning and returns null if the format of the data is not valid.
     */    static wf(t, e, s) {
        const n = JSON.parse(s);
        let i = "object" == typeof n && -1 !== [ "pending", "acknowledged", "rejected" ].indexOf(n.state) && (void 0 === n.error || "object" == typeof n.error), r = void 0;
        return i && n.error && (i = "string" == typeof n.error.message && "string" == typeof n.error.code) && (r = new $(n.error.code, n.error.message)), 
        i ? new Ur(t, e, n.state, r) : (P(Or, `Failed to parse mutation state for ID '${e}': ${s}`), 
        null);
    }
    Ef() {
        const t = {
            state: this.state,
            updateTimeMs: Date.now()
        };
        return this.error && (t.error = {
            code: this.error.code,
            message: this.error.message
        }), JSON.stringify(t);
    }
}

/**
 * Holds the state of a query target, including its target ID and whether the
 * target is 'not-current', 'current' or 'rejected'.
 */
// Visible for testing
class Qr {
    constructor(t, e, s) {
        this.targetId = t, this.state = e, this.error = s, g(void 0 !== s == ("rejected" === e), "QueryTargetMetadata must contain an error iff state is 'rejected'");
    }
    /**
     * Parses a QueryTargetMetadata from its JSON representation in WebStorage.
     * Logs a warning and returns null if the format of the data is not valid.
     */    static wf(t, e) {
        const s = JSON.parse(e);
        let n = "object" == typeof s && -1 !== [ "not-current", "current", "rejected" ].indexOf(s.state) && (void 0 === s.error || "object" == typeof s.error), i = void 0;
        return n && s.error && (n = "string" == typeof s.error.message && "string" == typeof s.error.code) && (i = new $(s.error.code, s.error.message)), 
        n ? new Qr(t, s.state, i) : (P(Or, `Failed to parse target state for ID '${t}': ${e}`), 
        null);
    }
    Ef() {
        const t = {
            state: this.state,
            updateTimeMs: Date.now()
        };
        return this.error && (t.error = {
            code: this.error.code,
            message: this.error.message
        }), JSON.stringify(t);
    }
}

/**
 * This class represents the immutable ClientState for a client read from
 * WebStorage, containing the list of active query targets.
 */ class Wr {
    constructor(t, e) {
        this.clientId = t, this.activeTargetIds = e;
    }
    /**
     * Parses a RemoteClientState from the JSON representation in WebStorage.
     * Logs a warning and returns null if the format of the data is not valid.
     */    static wf(t, e) {
        const s = JSON.parse(e);
        let n = "object" == typeof s && s.activeTargetIds instanceof Array, i = hs();
        for (let t = 0; n && t < s.activeTargetIds.length; ++t) n = we(s.activeTargetIds[t]), 
        i = i.add(s.activeTargetIds[t]);
        return n ? new Wr(t, i) : (P(Or, `Failed to parse client data for instance '${t}': ${e}`), 
        null);
    }
}

/**
 * This class represents the online state for all clients participating in
 * multi-tab. The online state is only written to by the primary client, and
 * used in secondary clients to update their query views.
 */ class jr {
    constructor(t, e) {
        this.clientId = t, this.onlineState = e;
    }
    /**
     * Parses a SharedOnlineState from its JSON representation in WebStorage.
     * Logs a warning and returns null if the format of the data is not valid.
     */    static wf(t) {
        const e = JSON.parse(t);
        return "object" == typeof e && e.onlineState in $e && "string" == typeof e.clientId ? new jr(e.clientId, $e[e.onlineState]) : (P(Or, `Failed to parse online state: ${t}`), 
        null);
    }
}

/**
 * Metadata state of the local client. Unlike `RemoteClientState`, this class is
 * mutable and keeps track of all pending mutations, which allows us to
 * update the range of pending mutation batch IDs as new mutations are added or
 * removed.
 *
 * The data in `LocalClientState` is not read from WebStorage and instead
 * updated via its instance methods. The updated state can be serialized via
 * `toWebStorageJSON()`.
 */
// Visible for testing.
class zr {
    constructor() {
        this.activeTargetIds = hs();
    }
    If(t) {
        this.activeTargetIds = this.activeTargetIds.add(t);
    }
    Rf(t) {
        this.activeTargetIds = this.activeTargetIds.delete(t);
    }
    /**
     * Converts this entry into a JSON-encoded format we can use for WebStorage.
     * Does not encode `clientId` as it is part of the key in WebStorage.
     */    Ef() {
        const t = {
            activeTargetIds: this.activeTargetIds.Z(),
            updateTimeMs: Date.now()
        };
        return JSON.stringify(t);
    }
}

/**
 * `WebStorageSharedClientState` uses WebStorage (window.localStorage) as the
 * backing store for the SharedClientState. It keeps track of all active
 * clients and supports modifications of the local client's data.
 */ class Kr {
    constructor(t, e, s, n, i) {
        if (this.yc = t, this.platform = e, this.persistenceKey = s, this.Af = n, this.tf = null, 
        this.Ad = null, this.mr = null, this.Pf = {}, this.pf = this.Vf.bind(this), this.Ta = !1, 
        /**
         * Captures WebStorage events that occur before `start()` is called. These
         * events are replayed once `WebStorageSharedClientState` is started.
         */
        this.gf = [], !Kr.Ho(this.platform)) throw new $(F.UNIMPLEMENTED, "LocalStorage is not available on this platform.");
        // Escape the special characters mentioned here:
        // https://developer.mozilla.org/en-US/docs/Web/JavaScript/Guide/Regular_Expressions
                const r = s.replace(/[.*+?^${}()|[\]\\]/g, "\\$&");
        this.storage = this.platform.window.localStorage, this.currentUser = i, this.yf = Fr(this.persistenceKey, this.Af), 
        this.bf = function(t) {
            return `${qr}_${t}`;
        }(this.persistenceKey), this.Pf[this.Af] = new zr, this.vf = new RegExp(`^${Nr}_${r}_([^_]*)$`), 
        this.Sf = new RegExp(`^${$r}_${r}_(\\d+)(?:_(.*))?$`), this.Df = new RegExp(`^${Mr}_${r}_(\\d+)$`), 
        this.Cf = function(t) {
            return `${Br}_${t}`;
        }(this.persistenceKey), 
        // Rather than adding the storage observer during start(), we add the
        // storage observer during initialization. This ensures that we collect
        // events before other components populate their initial state (during their
        // respective start() calls). Otherwise, we might for example miss a
        // mutation that is added after LocalStore's start() processed the existing
        // mutations but before we observe WebStorage events.
        this.platform.window.addEventListener("storage", this.pf);
    }
    /** Returns 'true' if WebStorage is available in the current environment. */    static Ho(t) {
        return !(!t.window || null == t.window.localStorage);
    }
    async start() {
        g(!this.Ta, "WebStorageSharedClientState already started"), g(null !== this.tf, "syncEngine property must be set before calling start()"), 
        g(null !== this.Ad, "onlineStateHandler property must be set before calling start()");
        // Retrieve the list of existing clients to backfill the data in
        // SharedClientState.
        const t = await this.tf.ru();
        for (const e of t) {
            if (e === this.Af) continue;
            const t = this.getItem(Fr(this.persistenceKey, e));
            if (t) {
                const s = Wr.wf(e, t);
                s && (this.Pf[s.clientId] = s);
            }
        }
        this.kf();
        // Check if there is an existing online state and call the callback handler
        // if applicable.
        const e = this.storage.getItem(this.Cf);
        if (e) {
            const t = this.Nf(e);
            t && this.Ff(t);
        }
        for (const t of this.gf) this.Vf(t);
        this.gf = [], 
        // Register a window unload hook to remove the client metadata entry from
        // WebStorage even if `shutdown()` was not called.
        this.platform.window.addEventListener("unload", () => this.shutdown()), this.Ta = !0;
    }
    Er(t) {
        this.setItem(this.bf, JSON.stringify(t));
    }
    $f() {
        let t = hs();
        return W(this.Pf, (e, s) => {
            t = t.Ot(s.activeTargetIds);
        }), t;
    }
    xf(t) {
        // This is not using `obj.forEach` since `forEach` doesn't support early
        // return.
        for (const e in this.Pf) if (this.Pf.hasOwnProperty(e) && this.Pf[e].activeTargetIds.has(t)) return !0;
        return !1;
    }
    Mf(t) {
        this.Lf(t, "pending");
    }
    Bf(t, e, s) {
        this.Lf(t, e, s), 
        // Once a final mutation result is observed by other clients, they no longer
        // access the mutation's metadata entry. Since WebStorage replays events
        // in order, it is safe to delete the entry right after updating it.
        this.qf(t);
    }
    Of(t) {
        let e = "not-current";
        // Lookup an existing query state if the target ID was already registered
        // by another tab
                if (this.xf(t)) {
            const s = this.storage.getItem(Lr(this.persistenceKey, t));
            if (s) {
                const n = Qr.wf(t, s);
                n && (e = n.state);
            }
        }
        return this.Uf.If(t), this.kf(), e;
    }
    Qf(t) {
        this.Uf.Rf(t), this.kf();
    }
    Wf(t) {
        return this.Uf.activeTargetIds.has(t);
    }
    jf(t) {
        this.removeItem(Lr(this.persistenceKey, t));
    }
    zf(t, e, s) {
        this.Kf(t, e, s);
    }
    ba(t, e, s) {
        e.forEach(t => {
            this.qf(t);
        }), this.currentUser = t, s.forEach(t => {
            this.Mf(t);
        });
    }
    Gf(t) {
        this.Hf(t);
    }
    shutdown() {
        this.Ta && (this.platform.window.removeEventListener("storage", this.pf), this.removeItem(this.yf), 
        this.Ta = !1);
    }
    getItem(t) {
        const e = this.storage.getItem(t);
        return A(Or, "READ", t, e), e;
    }
    setItem(t, e) {
        A(Or, "SET", t, e), this.storage.setItem(t, e);
    }
    removeItem(t) {
        A(Or, "REMOVE", t), this.storage.removeItem(t);
    }
    Vf(t) {
        if (t.storageArea === this.storage) {
            if (A(Or, "EVENT", t.key, t.newValue), t.key === this.yf) return void P("Received WebStorage notification for local change. Another client might have garbage-collected our state");
            this.yc.Lr(async () => {
                if (this.Ta) {
                    if (null !== t.key) if (this.vf.test(t.key)) {
                        if (null == t.newValue) {
                            const e = this.Jf(t.key);
                            return this.Yf(e, null);
                        }
                        {
                            const e = this.Xf(t.key, t.newValue);
                            if (e) return this.Yf(e.clientId, e);
                        }
                    } else if (this.Sf.test(t.key)) {
                        if (null !== t.newValue) {
                            const e = this.Zf(t.key, t.newValue);
                            if (e) return this.tm(e);
                        }
                    } else if (this.Df.test(t.key)) {
                        if (null !== t.newValue) {
                            const e = this.em(t.key, t.newValue);
                            if (e) return this.sm(e);
                        }
                    } else if (t.key === this.Cf) {
                        if (null !== t.newValue) {
                            const e = this.Nf(t.newValue);
                            if (e) return this.Ff(e);
                        }
                    } else if (t.key === this.bf) {
                        g(!!this.mr, "Missing sequenceNumberHandler");
                        const e = function(t) {
                            let e = Bs.Ir;
                            if (null != t) try {
                                const s = JSON.parse(t);
                                g("number" == typeof s, "Found non-numeric sequence number"), e = s;
                            } catch (t) {
                                P(Or, "Failed to read sequence number from WebStorage", t);
                            }
                            return e;
                        }
                        /**
 * `MemorySharedClientState` is a simple implementation of SharedClientState for
 * clients using memory persistence. The state in this class remains fully
 * isolated and no synchronization is performed.
 */ (t.newValue);
                        e !== Bs.Ir && this.mr(e);
                    }
                } else this.gf.push(t);
            });
        }
    }
    get Uf() {
        return this.Pf[this.Af];
    }
    kf() {
        this.setItem(this.yf, this.Uf.Ef());
    }
    Lf(t, e, s) {
        const n = new Ur(this.currentUser, t, e, s), i = xr(this.persistenceKey, this.currentUser, t);
        this.setItem(i, n.Ef());
    }
    qf(t) {
        const e = xr(this.persistenceKey, this.currentUser, t);
        this.removeItem(e);
    }
    Hf(t) {
        const e = {
            clientId: this.Af,
            onlineState: $e[t]
        };
        this.storage.setItem(this.Cf, JSON.stringify(e));
    }
    Kf(t, e, s) {
        const n = Lr(this.persistenceKey, t), i = new Qr(t, e, s);
        this.setItem(n, i.Ef());
    }
    /**
     * Parses a client state key in WebStorage. Returns null if the key does not
     * match the expected key format.
     */    Jf(t) {
        const e = this.vf.exec(t);
        return e ? e[1] : null;
    }
    /**
     * Parses a client state in WebStorage. Returns 'null' if the value could not
     * be parsed.
     */    Xf(t, e) {
        const s = this.Jf(t);
        return g(null !== s, `Cannot parse client state key '${t}'`), Wr.wf(s, e);
    }
    /**
     * Parses a mutation batch state in WebStorage. Returns 'null' if the value
     * could not be parsed.
     */    Zf(t, e) {
        const s = this.Sf.exec(t);
        g(null !== s, `Cannot parse mutation batch key '${t}'`);
        const n = Number(s[1]), i = void 0 !== s[2] ? s[2] : null;
        return Ur.wf(new N(i), n, e);
    }
    /**
     * Parses a query target state from WebStorage. Returns 'null' if the value
     * could not be parsed.
     */    em(t, e) {
        const s = this.Df.exec(t);
        g(null !== s, `Cannot parse query target key '${t}'`);
        const n = Number(s[1]);
        return Qr.wf(n, e);
    }
    /**
     * Parses an online state from WebStorage. Returns 'null' if the value
     * could not be parsed.
     */    Nf(t) {
        return jr.wf(t);
    }
    async tm(t) {
        if (t.user.uid === this.currentUser.uid) return this.tf.nm(t.batchId, t.state, t.error);
        A(Or, `Ignoring mutation for non-active user ${t.user.uid}`);
    }
    sm(t) {
        return this.tf.im(t.targetId, t.state, t.error);
    }
    Yf(t, e) {
        const s = this.$f();
        e ? this.Pf[t] = e : delete this.Pf[t];
        const n = this.$f(), i = [], r = [];
        return n.forEach(async t => {
            s.has(t) || i.push(t);
        }), s.forEach(async t => {
            n.has(t) || r.push(t);
        }), this.tf.rm(i, r);
    }
    Ff(t) {
        // We check whether the client that wrote this online state is still active
        // by comparing its client ID to the list of clients kept active in
        // IndexedDb. If a client does not update their IndexedDb client state
        // within 5 seconds, it is considered inactive and we don't emit an online
        // state event.
        this.Pf[t.clientId] && this.Ad(t.onlineState);
    }
}

class Gr {
    constructor() {
        this.om = new zr, this.hm = {}, this.tf = null, this.Ad = null, this.mr = null;
    }
    Mf(t) {
        // No op.
    }
    Bf(t, e, s) {
        // No op.
    }
    Of(t) {
        return this.om.If(t), this.hm[t] || "not-current";
    }
    zf(t, e, s) {
        this.hm[t] = e;
    }
    Qf(t) {
        this.om.Rf(t);
    }
    Wf(t) {
        return this.om.activeTargetIds.has(t);
    }
    jf(t) {
        delete this.hm[t];
    }
    $f() {
        return this.om.activeTargetIds;
    }
    xf(t) {
        return this.om.activeTargetIds.has(t);
    }
    start() {
        return this.om = new zr, Promise.resolve();
    }
    ba(t, e, s) {
        // No op.
    }
    Gf(t) {
        // No op.
    }
    shutdown() {}
    Er(t) {}
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class Hr {
    constructor(t) {
        this.key = t;
    }
}

class Jr {
    constructor(t) {
        this.key = t;
    }
}

/**
 * View is responsible for computing the final merged truth of what docs are in
 * a query. It gets notified of local and remote changes to docs, and applies
 * the query filters and limits to determine the most correct possible results.
 */ class Yr {
    constructor(t, 
    /** Documents included in the remote target */
    e) {
        this.query = t, this.am = e, this.um = null, 
        /**
         * A flag whether the view is current with the backend. A view is considered
         * current after it has seen the current flag from the backend and did not
         * lose consistency within the watch stream (e.g. because of an existence
         * filter mismatch).
         */
        this.on = !1, 
        /** Documents in the view but not in the remote target */
        this.cm = rs(), 
        /** Document Keys that have local changes */
        this.Js = rs(), this.lm = new as(t.ls.bind(t));
    }
    /**
     * The set of remote documents that the server has told us belongs to the target associated with
     * this view.
     */    get _m() {
        return this.am;
    }
    /**
     * Iterates over a set of doc changes, applies the query limit, and computes
     * what the new results should be, what the changes were, and whether we may
     * need to go back to the local cache for more results. Does not make any
     * changes to the view.
     * @param docChanges The doc changes to apply to this view.
     * @param previousChanges If this is being called with a refill, then start
     *        with this set of docs and changes instead of the current view.
     * @return a new set of docs, changes, and refill flag.
     */    dm(t, e) {
        const s = e ? e.fm : new ms, n = e ? e.lm : this.lm;
        let i = e ? e.Js : this.Js, r = n, o = !1;
        // Track the last doc in a (full) limit. This is necessary, because some
        // update (a delete, or an update moving a doc past the old limit) might
        // mean there is some other document in the local cache that either should
        // come (1) between the old last limit doc and the new last document, in the
        // case of updates, or (2) after the new last document, in the case of
        // deletes. So we keep this doc at the old limit to compare the updates to.
        //
        // Note that this should never get used in a refill (when previousChanges is
        // set), because there will only be adds -- no deletes or updates.
        const h = this.query.Ts() && n.size === this.query.limit ? n.last() : null, a = this.query.ws() && n.size === this.query.limit ? n.first() : null;
        // Drop documents out to meet limit/limitToLast requirement.
        if (t.Tt((t, e) => {
            const u = n.get(t);
            let c = e instanceof ue ? e : null;
            c && (g(t.isEqual(c.key), "Mismatching keys found in document changes: " + t + " != " + c.key), 
            c = this.query.matches(c) ? c : null);
            const l = !!u && this.Js.has(u.key), _ = !!c && (c.ie || 
            // We only consider committed mutations for documents that were
            // mutated during the lifetime of the view.
            this.Js.has(c.key) && c.hasCommittedMutations);
            let d = !1;
            // Calculate change
                        if (u && c) {
                u.data().isEqual(c.data()) ? l !== _ && (s.track({
                    type: us.Ws,
                    doc: c
                }), d = !0) : this.mm(u, c) || (s.track({
                    type: us.Qs,
                    doc: c
                }), d = !0, (h && this.query.ls(c, h) > 0 || a && this.query.ls(c, a) < 0) && (
                // This doc moved from inside the limit to outside the limit.
                // That means there may be some other doc in the local cache
                // that should be included instead.
                o = !0));
            } else !u && c ? (s.track({
                type: us.Os,
                doc: c
            }), d = !0) : u && !c && (s.track({
                type: us.Us,
                doc: u
            }), d = !0, (h || a) && (
            // A doc was removed from a full limit query. We'll need to
            // requery from the local cache to see if we know about some other
            // doc that should be in the results.
            o = !0));
            d && (c ? (r = r.add(c), i = _ ? i.add(t) : i.delete(t)) : (r = r.delete(t), i = i.delete(t)));
        }), this.query.Ts() || this.query.ws()) for (;r.size > this.query.limit; ) {
            const t = this.query.Ts() ? r.last() : r.first();
            r = r.delete(t.key), i = i.delete(t.key), s.track({
                type: us.Us,
                doc: t
            });
        }
        return g(!o || !e, "View was refilled using docs that themselves needed refilling."), 
        {
            lm: r,
            fm: s,
            wl: o,
            Js: i
        };
    }
    mm(t, e) {
        // We suppress the initial change event for documents that were modified as
        // part of a write acknowledgment (e.g. when the value of a server transform
        // is applied) as Watch will send us the same document again.
        // By suppressing the event, we only raise two user visible events (one with
        // `hasPendingWrites` and the final state of the document) instead of three
        // (one with `hasPendingWrites`, the modified document with
        // `hasPendingWrites` and the final state of the document).
        return t.ie && e.hasCommittedMutations && !e.ie;
    }
    /**
     * Updates the view with the given ViewDocumentChanges and optionally updates
     * limbo docs and sync state from the provided target change.
     * @param docChanges The set of changes to make to the view's docs.
     * @param updateLimboDocuments Whether to update limbo documents based on this
     *        change.
     * @param targetChange A target change to apply for computing limbo docs and
     *        sync state.
     * @return A new ViewChange with the given docs, changes, and sync state.
     */
    // PORTING NOTE: The iOS/Android clients always compute limbo document changes.
    Qo(t, e, s) {
        g(!t.wl, "Cannot apply changes that need a refill");
        const n = this.lm;
        this.lm = t.lm, this.Js = t.Js;
        // Sort changes based on type and query comparator
        const i = t.fm.Gs();
        i.sort((t, e) => (function(t, e) {
            const s = t => {
                switch (t) {
                  case us.Os:
                    return 1;

                  case us.Qs:
                  case us.Ws:
                    // A metadata change is converted to a modified change at the public
                    // api layer.  Since we sort by document key and then change type,
                    // metadata and modified changes must be sorted equivalently.
                    return 2;

                  case us.Us:
                    return 0;

                  default:
                    return V("Unknown ChangeType: " + t);
                }
            };
            return s(t) - s(e);
        }
        /**
 * @license
 * Copyright 2019 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */)(t.type, e.type) || this.query.ls(t.doc, e.doc)), this.Tm(s);
        const r = e ? this.wm() : [], o = 0 === this.cm.size && this.on ? ls.zs : ls.js, h = o !== this.um;
        if (this.um = o, 0 !== i.length || h) {
            return {
                snapshot: new Ts(this.query, t.lm, n, i, t.Js, o === ls.js, h, 
                /* excludesMetadataChanges= */ !1),
                Em: r
            };
        }
        // no changes
        return {
            Em: r
        };
    }
    /**
     * Applies an OnlineState change to the view, potentially generating a
     * ViewChange if the view's syncState changes as a result.
     */    Im(t) {
        return this.on && t === $e.gs ? (
        // If we're offline, set `current` to false and then call applyChanges()
        // to refresh our syncState and generate a ViewChange as appropriate. We
        // are guaranteed to get a new TargetChange that sets `current` back to
        // true once the client is back online.
        this.on = !1, this.Qo({
            lm: this.lm,
            fm: new ms,
            Js: this.Js,
            wl: !1
        }, 
        /* updateLimboDocuments= */ !1)) : {
            Em: []
        };
    }
    /**
     * Returns whether the doc for the given key should be in limbo.
     */    Rm(t) {
        // If the remote end says it's part of this query, it's not in limbo.
        return !this.am.has(t) && (
        // The local store doesn't think it's a result, so it shouldn't be in limbo.
        !!this.lm.has(t) && !this.lm.get(t).ie);
    }
    /**
     * Updates syncedDocuments, current, and limbo docs based on the given change.
     * Returns the list of changes to which docs are in limbo.
     */    Tm(t) {
        t && (t.hn.forEach(t => this.am = this.am.add(t)), t.an.forEach(t => g(this.am.has(t), `Modified document ${t} not found in view.`)), 
        t.un.forEach(t => this.am = this.am.delete(t)), this.on = t.on);
    }
    wm() {
        // We can only determine limbo documents when we're in-sync with the server.
        if (!this.on) return [];
        // TODO(klimt): Do this incrementally so that it's not quadratic when
        // updating many documents.
                const t = this.cm;
        this.cm = rs(), this.lm.forEach(t => {
            this.Rm(t.key) && (this.cm = this.cm.add(t.key));
        });
        // Diff the new limbo docs with the old limbo docs.
        const e = [];
        return t.forEach(t => {
            this.cm.has(t) || e.push(new Jr(t));
        }), this.cm.forEach(s => {
            t.has(s) || e.push(new Hr(s));
        }), e;
    }
    /**
     * Update the in-memory state of the current view with the state read from
     * persistence.
     *
     * We update the query view whenever a client's primary status changes:
     * - When a client transitions from primary to secondary, it can miss
     *   LocalStorage updates and its query views may temporarily not be
     *   synchronized with the state on disk.
     * - For secondary to primary transitions, the client needs to update the list
     *   of `syncedDocuments` since secondary clients update their query views
     *   based purely on synthesized RemoteEvents.
     *
     * @param queryResult.documents - The documents that match the query according
     * to the LocalStore.
     * @param queryResult.remoteKeys - The keys of the documents that match the
     * query according to the backend.
     *
     * @return The ViewChange that resulted from this synchronization.
     */
    // PORTING NOTE: Multi-tab only.
    Am(t) {
        this.am = t.nu, this.cm = rs();
        const e = this.dm(t.documents);
        return this.Qo(e, /*updateLimboDocuments=*/ !0);
    }
    /**
     * Returns a view snapshot as if this query was just listened to. Contains
     * a document add for every existing document and the `fromCache` and
     * `hasPendingWrites` status of the already established view.
     */
    // PORTING NOTE: Multi-tab only.
    Pm() {
        return Ts.Zs(this.query, this.lm, this.Js, this.um === ls.js);
    }
}

const Xr = 5;

/**
 * TransactionRunner encapsulates the logic needed to run and retry transactions
 * with backoff.
 */ class Zr {
    constructor(t, e, s, n) {
        this.Sr = t, this.pm = e, this.updateFunction = s, this.Nr = n, this.Vm = Xr, this.i_ = new Ki(this.Sr, Os.vr);
    }
    /** Runs the transaction and sets the result on deferred. */    run() {
        this.gm();
    }
    gm() {
        this.i_.Gl(async () => {
            const t = this.pm.ff(), e = this.ym(t);
            e && e.then(e => {
                this.Sr.Lr(() => t.commit().then(() => {
                    this.Nr.resolve(e);
                }).catch(t => {
                    this.bm(t);
                }));
            }).catch(t => {
                this.bm(t);
            });
        });
    }
    ym(t) {
        try {
            const e = this.updateFunction(t);
            return !Te(e) && e.catch && e.then ? e : (this.Nr.reject(Error("Transaction callback must return a Promise")), 
            null);
        } catch (t) {
            // Do not retry errors thrown by user provided updateFunction.
            return this.Nr.reject(t), null;
        }
    }
    bm(t) {
        this.Vm > 0 && this.vm(t) ? (this.Vm -= 1, this.Sr.Lr(() => (this.gm(), Promise.resolve()))) : this.Nr.reject(t);
    }
    vm(t) {
        if ("FirebaseError" === t.name) {
            // In transactions, the backend will fail outdated reads with FAILED_PRECONDITION and
            // non-matching document versions with ABORTED. These errors should be retried.
            const e = t.code;
            return "aborted" === e || "failed-precondition" === e || !Ge(e);
        }
        return !1;
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const to = "SyncEngine";

/**
 * QueryView contains all of the data that SyncEngine needs to keep track of for
 * a particular query.
 */ class eo {
    constructor(
    /**
     * The query itself.
     */
    t, 
    /**
     * The target number created by the client that is used in the watch
     * stream to identify this query.
     */
    e, 
    /**
     * The view is responsible for computing the final merged truth of what
     * docs are in the query. It gets notified of local and remote changes,
     * and applies the query filters and limits to determine the most correct
     * possible results.
     */
    s) {
        this.query = t, this.targetId = e, this.view = s;
    }
}

/** Tracks a limbo resolution. */ class so {
    constructor(t) {
        this.key = t, 
        /**
         * Set to true once we've received a document. This is used in
         * getRemoteKeysForTarget() and ultimately used by WatchChangeAggregator to
         * decide whether it needs to manufacture a delete event for the target once
         * the target is CURRENT.
         */
        this.Sm = !1;
    }
}

/**
 * SyncEngine is the central controller in the client SDK architecture. It is
 * the glue code between the EventManager, LocalStore, and RemoteStore. Some of
 * SyncEngine's responsibilities include:
 * 1. Coordinating client requests and remote events between the EventManager
 *    and the local and remote data stores.
 * 2. Managing a View object for each query, providing the unified view between
 *    the local and remote data stores.
 * 3. Notifying the RemoteStore when the LocalStore has new mutations in its
 *    queue that need sending to the backend.
 *
 * The SyncEngine’s methods should only ever be called by methods running in the
 * global async queue.
 */ class no {
    constructor(t, e, 
    // PORTING NOTE: Manages state synchronization in multi-tab environments.
    s, n) {
        this.Nu = t, this.pm = e, this.Dm = s, this.currentUser = n, this.Cm = null, this.km = new rn(t => t.canonicalId()), 
        this.Nm = {}, this.Fm = new Rt(It.U), this.$m = {}, this.xm = new sn, 
        /** Stores user completion handlers, indexed by User and BatchId. */
        this.Mm = {}, 
        /** Stores user callbacks waiting for all pending writes to be acknowledged. */
        this.Lm = new Map, this.Bm = vn.Gh(), 
        // The primary state is set to `true` or `false` immediately after Firestore
        // startup. In the interim, a client should only be considered primary if
        // `isPrimary` is true.
        this.isPrimary = void 0, this.onlineState = $e.ps;
    }
    // Only used for testing.
    get qm() {
        return !0 === this.isPrimary;
    }
    /** Subscribes to SyncEngine notifications. Has to be called exactly once. */    subscribe(t) {
        g(null !== t, "SyncEngine listener cannot be null"), g(null === this.Cm, "SyncEngine already has a subscriber."), 
        this.Cm = t;
    }
    /**
     * Initiates the new listen, resolves promise when listen enqueued to the
     * server. All the subsequent view snapshots or errors are sent to the
     * subscribed handlers. Returns the targetId of the query.
     */    async listen(t) {
        let e, s;
        this.Om("listen()");
        const n = this.km.get(t);
        if (n) 
        // PORTING NOTE: With Multi-Tab Web, it is possible that a query view
        // already exists when EventManager calls us for the first time. This
        // happens when the primary tab is already listening to this query on
        // behalf of another tab and the user of the primary also starts listening
        // to the query. EventManager will not have an assigned target ID in this
        // case and calls `listen` to obtain this ID.
        e = n.targetId, this.Dm.Of(e), s = n.view.Pm(); else {
            const n = await this.Nu.Ja(t.cs()), i = this.Dm.Of(n.targetId);
            e = n.targetId, s = await this.Um(t, e, "current" === i), this.isPrimary && this.pm.listen(n);
        }
        return this.Cm.A_([ s ]), e;
    }
    /**
     * Registers a view for a previously unknown query and computes its initial
     * snapshot.
     */    async Um(t, e, s) {
        const n = await this.Nu.eu(t, 
        /* usePreviousResults= */ !0), i = new Yr(t, n.nu), r = i.dm(n.documents), o = Es.rn(e, s && this.onlineState !== $e.gs), h = i.Qo(r, 
        /* updateLimboDocuments= */ !0 === this.isPrimary, o);
        g(0 === h.Em.length, "View returned limbo docs before target ack from the server."), 
        g(!!h.snapshot, "applyChanges for new view should always return a snapshot");
        const a = new eo(t, e, i);
        return this.km.set(t, a), this.Nm[e] || (this.Nm[e] = []), this.Nm[e].push(t), h.snapshot;
    }
    /**
     * Reconcile the list of synced documents in an existing view with those
     * from persistence.
     */
    // PORTING NOTE: Multi-tab only.
    async Qm(t) {
        const e = await this.Nu.eu(t.query, 
        /* usePreviousResults= */ !0), s = t.view.Am(e);
        return this.isPrimary && this.Wm(t.targetId, s.Em), s;
    }
    /** Stops listening to the query. */    async Xd(t) {
        this.Om("unlisten()");
        const e = this.km.get(t);
        g(!!e, "Trying to unlisten on query not found:" + t);
        // Only clean up the query view and target if this is the only query mapped
        // to the target.
        const s = this.Nm[e.targetId];
        if (s.length > 1) return this.Nm[e.targetId] = s.filter(e => !e.isEqual(t)), void this.km.delete(t);
        // No other queries are mapped to the target, clean up the query and the target.
                if (this.isPrimary) {
            // We need to remove the local query target first to allow us to verify
            // whether any other client is still interested in this target.
            this.Dm.Qf(e.targetId), this.Dm.xf(e.targetId) || await this.Nu.tu(e.targetId, /*keepPersistedTargetData=*/ !1).then(() => {
                this.Dm.jf(e.targetId), this.pm.Xd(e.targetId), this.jm(e.targetId);
            }).catch(Nn);
        } else this.jm(e.targetId), await this.Nu.tu(e.targetId, 
        /*keepPersistedTargetData=*/ !0);
    }
    /**
     * Initiates the write of local mutation batch which involves adding the
     * writes to the mutation queue, notifying the remote store about new
     * mutations and raising events for any changes this write caused.
     *
     * The promise returned by this call is resolved when the above steps
     * have completed, *not* when the write was acked by the backend. The
     * userCallback is resolved once the write was acked/rejected by the
     * backend (or failed locally for any other reason).
     */    async write(t, e) {
        this.Om("write()");
        const s = await this.Nu.Ca(t);
        this.Dm.Mf(s.batchId), this.zm(s.batchId, e), await this.Km(s.Fo), await this.pm.Gd();
    }
    /**
     * Takes an updateFunction in which a set of reads and writes can be performed
     * atomically. In the updateFunction, the client can read and write values
     * using the supplied transaction object. After the updateFunction, all
     * changes will be committed. If a retryable error occurs (ex: some other
     * client has changed any of the data referenced), then the updateFunction
     * will be called again after a backoff. If the updateFunction still fails
     * after all retries, then the transaction will be rejected.
     *
     * The transaction object passed to the updateFunction contains methods for
     * accessing documents and collections. Unlike other datastore access, data
     * accessed with the transaction will not reflect local changes that have not
     * been committed. For this reason, it is required that all reads are
     * performed before any writes. Transactions must be performed while online.
     *
     * The Deferred input is resolved when the transaction is fully committed.
     */    runTransaction(t, e, s) {
        new Zr(t, this.pm, e, s).run();
    }
    async La(t) {
        this.Om("applyRemoteEvent()");
        try {
            const e = await this.Nu.La(t);
            // Update `receivedDocument` as appropriate for any limbo targets.
                        W(t.tn, (t, e) => {
                const s = this.$m[Number(t)];
                s && (
                // Since this is a limbo resolution lookup, it's for a single document
                // and it could be added, modified, or removed, but not a combination.
                g(e.hn.size + e.an.size + e.un.size <= 1, "Limbo resolution for single document contains multiple changes."), 
                e.hn.size > 0 ? s.Sm = !0 : e.an.size > 0 ? g(s.Sm, "Received change for limbo target document without add.") : e.un.size > 0 && (g(s.Sm, "Received remove for limbo target document without add."), 
                s.Sm = !1));
            }), await this.Km(e, t);
        } catch (t) {
            await Nn(t);
        }
    }
    /**
     * Applies an OnlineState change to the sync engine and notifies any views of
     * the change.
     */    Im(t, e) {
        // If we are the secondary client, we explicitly ignore the remote store's
        // online state (the local client may go offline, even though the primary
        // tab remains online) and only apply the primary tab's online state from
        // SharedClientState.
        if (this.isPrimary && e === Me.ys || !this.isPrimary && e === Me.bs) {
            this.Om("applyOnlineStateChange()");
            const e = [];
            this.km.forEach((s, n) => {
                const i = n.view.Im(t);
                g(0 === i.Em.length, "OnlineState should not affect limbo documents."), i.snapshot && e.push(i.snapshot);
            }), this.Cm.Gm(t), this.Cm.A_(e), this.onlineState = t, this.isPrimary && this.Dm.Gf(t);
        }
    }
    async nf(t, e) {
        this.Om("rejectListens()"), 
        // PORTING NOTE: Multi-tab only.
        this.Dm.zf(t, "rejected", e);
        const s = this.$m[t], n = s && s.key;
        if (n) {
            // Since this query failed, we won't want to manually unlisten to it.
            // So go ahead and remove it from bookkeeping.
            this.Fm = this.Fm.remove(n), delete this.$m[t];
            // TODO(klimt): We really only should do the following on permission
            // denied errors, but we don't have the cause code here.
            // It's a limbo doc. Create a synthetic event saying it was deleted.
            // This is kind of a hack. Ideally, we would have a method in the local
            // store to purge a document. However, it would be tricky to keep all of
            // the local store's invariants with another method.
            let e = new Rt(It.U);
            e = e.lt(n, new ce(n, dt.B()));
            const s = rs().add(n), i = new ws(dt.MIN, 
            /* targetChanges= */ {}, 
            /* targetMismatches= */ new pt(b), e, s);
            return this.La(i);
        }
        await this.Nu.tu(t, /* keepPersistedTargetData */ !1).then(() => this.jm(t, e)).catch(Nn);
    }
    // PORTING NOTE: Multi-tab only
    async nm(t, e, s) {
        this.Om("applyBatchState()");
        const n = await this.Nu.ka(t);
        null !== n ? ("pending" === e ? 
        // If we are the primary client, we need to send this write to the
        // backend. Secondary clients will ignore these writes since their remote
        // connection is disabled.
        await this.pm.Gd() : "acknowledged" === e || "rejected" === e ? (
        // NOTE: Both these methods are no-ops for batches that originated from
        // other clients.
        this.Hm(t, s || null), this.Nu.ou(t)) : V(`Unknown batchState: ${e}`), await this.Km(n)) : 
        // A throttled tab may not have seen the mutation before it was completed
        // and removed from the mutation queue, in which case we won't have cached
        // the affected documents. In this case we can safely ignore the update
        // since that means we didn't apply the mutation locally at all (if we
        // had, we would have cached the affected documents), and so we will just
        // see any resulting document changes via normal remote document updates
        // as applicable.
        A(to, "Cannot apply mutation batch with id: " + t);
    }
    async cf(t) {
        this.Om("applySuccessfulWrite()");
        const e = t.batch.batchId;
        // The local store may or may not be able to apply the write result and
        // raise events immediately (depending on whether the watcher is caught
        // up), so we raise user callbacks first so that they consistently happen
        // before listen events.
                this.Hm(e, /*error=*/ null), this.Jm(e);
        try {
            const s = await this.Nu.Rh(t);
            this.Dm.Bf(e, "acknowledged"), await this.Km(s);
        } catch (t) {
            await Nn(t);
        }
    }
    async df(t, e) {
        this.Om("rejectFailedWrite()"), 
        // The local store may or may not be able to apply the write result and
        // raise events immediately (depending on whether the watcher is caught up),
        // so we raise user callbacks first so that they consistently happen before
        // listen events.
        this.Hm(t, e), this.Jm(t);
        try {
            const s = await this.Nu.xa(t);
            this.Dm.Bf(t, "rejected", e), await this.Km(s);
        } catch (e) {
            await Nn(e);
        }
    }
    /**
     * Registers a user callback that resolves when all pending mutations at the moment of calling
     * are acknowledged .
     */    async Ym(t) {
        this.pm.$d() || A(to, "The network is disabled. The task returned by 'awaitPendingWrites()' will not complete until the network is enabled.");
        const e = await this.Nu.Ch();
        if (e === Zs) 
        // Trigger the callback right away if there is no pending writes at the moment.
        return void t.resolve();
        const s = this.Lm.get(e) || [];
        s.push(t), this.Lm.set(e, s);
    }
    /**
     * Triggers the callbacks that are waiting for this batch id to get acknowledged by server,
     * if there are any.
     */    Jm(t) {
        (this.Lm.get(t) || []).forEach(t => {
            t.resolve();
        }), this.Lm.delete(t);
    }
    /** Reject all outstanding callbacks waiting for pending writes to complete. */    Xm(t) {
        this.Lm.forEach(e => {
            e.forEach(e => {
                e.reject(new $(F.CANCELLED, t));
            });
        }), this.Lm.clear();
    }
    zm(t, e) {
        let s = this.Mm[this.currentUser._()];
        s || (s = new Rt(b)), s = s.lt(t, e), this.Mm[this.currentUser._()] = s;
    }
    /**
     * Resolves or rejects the user callback for the given batch and then discards
     * it.
     */    Hm(t, e) {
        let s = this.Mm[this.currentUser._()];
        // NOTE: Mutations restored from persistence won't have callbacks, so it's
        // okay for there to be no callback for this ID.
                if (s) {
            const n = s.get(t);
            n && (g(t === s.dt(), "Mutation callbacks processed out-of-order?"), e ? n.reject(e) : n.resolve(), 
            s = s.remove(t)), this.Mm[this.currentUser._()] = s;
        }
    }
    jm(t, e = null) {
        this.Dm.Qf(t), g(this.Nm[t] && 0 !== this.Nm[t].length, `There are no queries mapped to target id ${t}`);
        for (const s of this.Nm[t]) this.km.delete(s), e && this.Cm.Zm(s, e);
        if (delete this.Nm[t], this.isPrimary) {
            const e = this.xm.Eo(t);
            this.xm.To(t), e.forEach(t => {
                this.xm.Io(t) || 
                // We removed the last reference for this key
                this.tT(t);
            });
        }
    }
    tT(t) {
        // It's possible that the target already got removed because the query failed. In that case,
        // the key won't exist in `limboTargetsByKey`. Only do the cleanup if we still have the target.
        const e = this.Fm.get(t);
        null !== e && (this.pm.Xd(e), this.Fm = this.Fm.remove(t), delete this.$m[e]);
    }
    Wm(t, e) {
        for (const s of e) if (s instanceof Hr) this.xm.lo(s.key, t), this.eT(s); else if (s instanceof Jr) {
            A(to, "Document no longer in limbo: " + s.key), this.xm.do(s.key, t), this.xm.Io(s.key) || 
            // We removed the last reference for this key
            this.tT(s.key);
        } else V("Unknown limbo change: " + JSON.stringify(s));
    }
    eT(t) {
        const e = t.key;
        if (!this.Fm.get(e)) {
            A(to, "New document in limbo: " + e);
            const t = this.Bm.next(), s = Ae.Ye(e.path);
            this.$m[t] = new so(e), this.pm.listen(new ze(s.cs(), t, Be.ks, Bs.Ir)), this.Fm = this.Fm.lt(e, t);
        }
    }
    // Visible for testing
    sT() {
        return this.Fm;
    }
    async Km(t, e) {
        const s = [], n = [], i = [];
        this.km.forEach((r, o) => {
            i.push(Promise.resolve().then(() => {
                const e = o.view.dm(t);
                return e.wl ? this.Nu.eu(o.query, /* usePreviousResults= */ !1).then(({documents: t}) => o.view.dm(t, e)) : e;
                // The query has a limit and some docs were removed, so we need
                // to re-run the query against the local store to make sure we
                // didn't lose any good docs that had been past the limit.
                        }).then(t => {
                const i = e && e.tn[o.targetId], r = o.view.Qo(t, 
                /* updateLimboDocuments= */ !0 === this.isPrimary, i);
                if (this.Wm(o.targetId, r.Em), r.snapshot) {
                    this.isPrimary && this.Dm.zf(o.targetId, r.snapshot.fromCache ? "not-current" : "current"), 
                    s.push(r.snapshot);
                    const t = Dn.ca(o.targetId, r.snapshot);
                    n.push(t);
                }
            }));
        }), await Promise.all(i), this.Cm.A_(s), await this.Nu.Ka(n);
    }
    Om(t) {
        g(null !== this.Cm, "Trying to call " + t + " before calling subscribe().");
    }
    async mf(t) {
        const e = !this.currentUser.isEqual(t);
        if (this.currentUser = t, e) {
            // Fails tasks waiting for pending writes requested by previous user.
            this.Xm("'waitForPendingWrites' promise is rejected due to a user change.");
            const e = await this.Nu.ba(t);
            // TODO(b/114226417): Consider calling this only in the primary tab.
                        this.Dm.ba(t, e.Sa, e.Da), await this.Km(e.va);
        }
        await this.pm.mf();
    }
    // PORTING NOTE: Multi-tab only
    async Tf(t) {
        if (!0 === t && !0 !== this.isPrimary) {
            this.isPrimary = !0, await this.pm.Tf(!0);
            // Secondary tabs only maintain Views for their local listeners and the
            // Views internal state may not be 100% populated (in particular
            // secondary tabs don't track syncedDocuments, the set of documents the
            // server considers to be in the target). So when a secondary becomes
            // primary, we need to need to make sure that all views for all targets
            // match the state on disk.
            const t = this.Dm.$f(), e = await this.nT(t.Z());
            for (const t of e) this.pm.listen(t);
        } else if (!1 === t && !1 !== this.isPrimary) {
            this.isPrimary = !1;
            const t = [];
            let e = Promise.resolve();
            Q(this.Nm, (s, n) => {
                this.Dm.Wf(s) ? t.push(s) : e = e.then(() => (this.jm(s), this.Nu.tu(s, 
                /*keepPersistedTargetData=*/ !0))), this.pm.Xd(s);
            }), await e, await this.nT(t), this.iT(), await this.pm.Tf(!1);
        }
    }
    // PORTING NOTE: Multi-tab only.
    iT() {
        Q(this.$m, t => {
            this.pm.Xd(t);
        }), this.xm.wo(), this.$m = [], this.Fm = new Rt(It.U);
    }
    /**
     * Reconcile the query views of the provided query targets with the state from
     * persistence. Raises snapshots for any changes that affect the local
     * client and returns the updated state of all target's query data.
     */
    // PORTING NOTE: Multi-tab only.
    async nT(t) {
        const e = [], s = [];
        for (const n of t) {
            let t;
            const i = this.Nm[n];
            if (i && 0 !== i.length) {
                // For queries that have a local View, we need to update their state
                // in LocalStore (as the resume token and the snapshot version
                // might have changed) and reconcile their views with the persisted
                // state (the list of syncedDocuments may have gotten out of sync).
                await this.Nu.tu(n, 
                /*keepPersistedTargetData=*/ !0), t = await this.Nu.Ja(i[0].cs());
                for (const t of i) {
                    const e = this.km.get(t);
                    g(!!e, `No query view found for ${t}`);
                    const n = await this.Qm(e);
                    n.snapshot && s.push(n.snapshot);
                }
            } else {
                g(!0 === this.isPrimary, "A secondary tab should never have an active target without an active query.");
                // For queries that never executed on this client, we need to
                // allocate the target in LocalStore and initialize a new View.
                const e = await this.Nu.cu(n);
                g(!!e, `Target for id ${n} not found`), t = await this.Nu.Ja(e), await this.Um(this.rT(e), n, 
                /*current=*/ !1);
            }
            e.push(t);
        }
        return this.Cm.A_(s), e;
    }
    /**
     * Creates a `Query` object from the specified `Target`. There is no way to
     * obtain the original `Query`, so we synthesize a `Query` from the `Target`
     * object.
     *
     * The synthesized result might be different from the original `Query`, but
     * since the synthesized `Query` should return the same results as the
     * original one (only the presentation of results might differ), the potential
     * difference will not cause issues.
     */
    // PORTING NOTE: Multi-tab only
    rT(t) {
        return new Ae(t.path, t.collectionGroup, t.orderBy, t.filters, t.limit, Ie.We, t.startAt, t.endAt);
    }
    // PORTING NOTE: Multi-tab only
    ru() {
        return this.Nu.ru();
    }
    // PORTING NOTE: Multi-tab only
    async im(t, e, s) {
        if (this.isPrimary) 
        // If we receive a target state notification via WebStorage, we are
        // either already secondary or another tab has taken the primary lease.
        A(to, "Ignoring unexpected query state notification."); else if (this.Nm[t]) switch (e) {
          case "current":
          case "not-current":
            {
                const s = await this.Nu.lu(), n = ws.in(t, "current" === e);
                await this.Km(s, n);
                break;
            }

          case "rejected":
            await this.Nu.tu(t, 
            /* keepPersistedTargetData */ !0), this.jm(t, s);
            break;

          default:
            V("Unexpected target state: " + e);
        }
    }
    // PORTING NOTE: Multi-tab only
    async rm(t, e) {
        if (this.isPrimary) {
            for (const e of t) {
                g(!this.Nm[e], "Trying to add an already active target");
                const t = await this.Nu.cu(e);
                g(!!t, `Query data for active target ${e} not found`);
                const s = await this.Nu.Ja(t);
                await this.Um(this.rT(t), s.targetId, 
                /*current=*/ !1), this.pm.listen(s);
            }
            for (const t of e) 
            // Check that the target is still active since the target might have been
            // removed if it has been rejected by the backend.
            this.Nm[t] && 
            // Release queries that are still active.
            await this.Nu.tu(t, /* keepPersistedTargetData */ !1).then(() => {
                this.pm.Xd(t), this.jm(t);
            }).catch(Nn);
        }
    }
    // PORTING NOTE: Multi-tab only. In other clients, LocalStore is unaware of
    // the online state.
    enableNetwork() {
        return this.Nu.hu(!0), this.pm.enableNetwork();
    }
    // PORTING NOTE: Multi-tab only. In other clients, LocalStore is unaware of
    // the online state.
    disableNetwork() {
        return this.Nu.hu(!1), this.pm.disableNetwork();
    }
    Jn(t) {
        const e = this.$m[t];
        if (e && e.Sm) return rs().add(e.key);
        {
            let e = rs();
            const s = this.Nm[t];
            if (!s) return e;
            for (const t of s) {
                const s = this.km.get(t);
                g(!!s, `No query view found for ${t}`), e = e.Ot(s.view._m);
            }
            return e;
        }
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Holds the listeners and the last received ViewSnapshot for a query being
 * tracked by EventManager.
 */ class io {
    constructor() {
        this.oT = null, this.targetId = 0, this.listeners = [];
    }
}

/**
 * EventManager is responsible for mapping queries to query event emitters.
 * It handles "fan-out". -- Identical queries will re-use the same watch on the
 * backend.
 */ class ro {
    constructor(t) {
        this.tf = t, this.hT = new rn(t => t.canonicalId()), this.onlineState = $e.ps, this.aT = new Set, 
        this.tf.subscribe(this);
    }
    listen(t) {
        const e = t.query;
        let s = !1, n = this.hT.get(e);
        if (n || (s = !0, n = new io, this.hT.set(e, n)), n.listeners.push(t), g(!t.Im(this.onlineState), "applyOnlineStateChange() shouldn't raise an event for brand-new listeners."), 
        n.oT) {
            t.uT(n.oT) && this.cT();
        }
        return s ? this.tf.listen(e).then(t => (n.targetId = t, t)) : Promise.resolve(n.targetId);
    }
    async Xd(t) {
        const e = t.query;
        let s = !1;
        const n = this.hT.get(e);
        if (n) {
            const e = n.listeners.indexOf(t);
            e >= 0 && (n.listeners.splice(e, 1), s = 0 === n.listeners.length);
        }
        if (s) return this.hT.delete(e), this.tf.Xd(e);
    }
    A_(t) {
        let e = !1;
        for (const s of t) {
            const t = s.query, n = this.hT.get(t);
            if (n) {
                for (const t of n.listeners) t.uT(s) && (e = !0);
                n.oT = s;
            }
        }
        e && this.cT();
    }
    Zm(t, e) {
        const s = this.hT.get(t);
        if (s) for (const t of s.listeners) t.onError(e);
        // Remove all listeners. NOTE: We don't need to call syncEngine.unlisten()
        // after an error.
                this.hT.delete(t);
    }
    Gm(t) {
        this.onlineState = t;
        let e = !1;
        this.hT.forEach((s, n) => {
            for (const s of n.listeners) 
            // Run global snapshot listeners if a consistent snapshot has been emitted.
            s.Im(t) && (e = !0);
        }), e && this.cT();
    }
    lT(t) {
        this.aT.add(t), 
        // Immediately fire an initial event, indicating all existing listeners
        // are in-sync.
        t.next();
    }
    _T(t) {
        this.aT.delete(t);
    }
    // Call all global snapshot listeners that have been set.
    cT() {
        this.aT.forEach(t => {
            t.next();
        });
    }
}

/**
 * QueryListener takes a series of internal view snapshots and determines
 * when to raise the event.
 *
 * It uses an Observer to dispatch events.
 */ class oo {
    constructor(t, e, s) {
        this.query = t, this.dT = e, 
        /**
         * Initial snapshots (e.g. from cache) may not be propagated to the wrapped
         * observer. This flag is set to true once we've actually raised an event.
         */
        this.fT = !1, this.mT = null, this.onlineState = $e.ps, this.options = s || {};
    }
    /**
     * Applies the new ViewSnapshot to this listener, raising a user-facing event
     * if applicable (depending on what changed, whether the user has opted into
     * metadata-only changes, etc.). Returns true if a user-facing event was
     * indeed raised.
     */    uT(t) {
        if (g(t.docChanges.length > 0 || t.Ys, "We got a new snapshot with no changes?"), 
        !this.options.includeMetadataChanges) {
            // Remove the metadata only changes.
            const e = [];
            for (const s of t.docChanges) s.type !== us.Ws && e.push(s);
            t = new Ts(t.query, t.docs, t.Hs, e, t.Js, t.fromCache, t.Ys, 
            /* excludesMetadataChanges= */ !0);
        }
        let e = !1;
        return this.fT ? this.TT(t) && (this.dT.next(t), e = !0) : this.wT(t, this.onlineState) && (this.ET(t), 
        e = !0), this.mT = t, e;
    }
    onError(t) {
        this.dT.error(t);
    }
    /** Returns whether a snapshot was raised. */    Im(t) {
        this.onlineState = t;
        let e = !1;
        return this.mT && !this.fT && this.wT(this.mT, t) && (this.ET(this.mT), e = !0), 
        e;
    }
    wT(t, e) {
        // Always raise the first event when we're synced
        if (g(!this.fT, "Determining whether to raise first event but already had first event"), 
        !t.fromCache) return !0;
        // NOTE: We consider OnlineState.Unknown as online (it should become Offline
        // or Online if we wait long enough).
                const s = e !== $e.gs;
        // Don't raise the event if we're online, aren't synced yet (checked
        // above) and are waiting for a sync.
                return this.options.IT && s ? (g(t.fromCache, "Waiting for sync, but snapshot is not from cache"), 
        !1) : !t.docs.G() || e === $e.gs;
        // Raise data from cache if we have any documents or we are offline
        }
    TT(t) {
        // We don't need to handle includeDocumentMetadataChanges here because
        // the Metadata only changes have already been stripped out if needed.
        // At this point the only changes we will see are the ones we should
        // propagate.
        if (t.docChanges.length > 0) return !0;
        const e = this.mT && this.mT.hasPendingWrites !== t.hasPendingWrites;
        return !(!t.Ys && !e) && !0 === this.options.includeMetadataChanges;
        // Generally we should have hit one of the cases above, but it's possible
        // to get here if there were only metadata docChanges and they got
        // stripped out.
        }
    ET(t) {
        g(!this.fT, "Trying to raise initial events for second time"), t = Ts.Zs(t.query, t.docs, t.Js, t.fromCache), 
        this.fT = !0, this.dT.next(t);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const ho = "FirestoreClient", ao = 11, uo = 20, co = 22;

/** DOMException error code constants. */ class lo {
    constructor(t, e) {
        this.cacheSizeBytes = t, this.synchronizeTabs = e;
    }
    Lc() {
        return Mn.gu(this.cacheSizeBytes);
    }
}

class _o {}

/**
 * FirestoreClient is a top-level class that constructs and owns all of the
 * pieces of the client SDK architecture. It is responsible for creating the
 * async queue that is shared by all of the other components in the system.
 */ class fo {
    constructor(t, e, s, 
    /**
     * Asynchronous queue responsible for all of our internal processing. When
     * we get incoming work from the user (via public API) or the network
     * (incoming GRPC messages), we should always schedule onto this queue.
     * This ensures all of our work is properly serialized (e.g. we don't
     * start processing a new operation while the previous one is waiting for
     * an async I/O to complete).
     */
    n) {
        this.platform = t, this.RT = e, this.credentials = s, this.Sr = n, this.clientId = y.i();
    }
    /**
     * Starts up the FirestoreClient, returning only whether or not enabling
     * persistence succeeded.
     *
     * The intent here is to "do the right thing" as far as users are concerned.
     * Namely, in cases where offline persistence is requested and possible,
     * enable it, but otherwise fall back to persistence disabled. For the most
     * part we expect this to succeed one way or the other so we don't expect our
     * users to actually wait on the firestore.enablePersistence Promise since
     * they generally won't care.
     *
     * Of course some users actually do care about whether or not persistence
     * was successfully enabled, so the Promise returned from this method
     * indicates this outcome.
     *
     * This presents a problem though: even before enablePersistence resolves or
     * rejects, users may have made calls to e.g. firestore.collection() which
     * means that the FirestoreClient in there will be available and will be
     * enqueuing actions on the async queue.
     *
     * Meanwhile any failure of an operation on the async queue causes it to
     * panic and reject any further work, on the premise that unhandled errors
     * are fatal.
     *
     * Consequently the fallback is handled internally here in start, and if the
     * fallback succeeds we signal success to the async queue even though the
     * start() itself signals failure.
     *
     * @param persistenceSettings Settings object to configure offline
     *     persistence.
     * @returns A deferred result indicating the user-visible result of enabling
     *     offline persistence. This method will reject this if IndexedDB fails to
     *     start for any reason. If usePersistence is false this is
     *     unconditionally resolved.
     */    start(t) {
        this.AT();
        // We defer our initialization until we get the current user from
        // setChangeListener(). We block the async queue until we got the initial
        // user and the initialization is completed. This will prevent any scheduled
        // work from happening before initialization is completed.
        //
        // If initializationDone resolved then the FirestoreClient is in a usable
        // state.
        const e = new qs, s = new qs;
        // If usePersistence is true, certain classes of errors while starting are
        // recoverable but only by falling back to persistence disabled.
        //
        // If there's an error in the first case but not in recovery we cannot
        // reject the promise blocking the async queue because this will cause the
        // async queue to panic.
                let n = !1;
        // Return only the result of enabling persistence. Note that this does not
        // need to await the completion of initializationDone because the result of
        // this method should not reflect any other kind of failure to start.
        return this.credentials.P(i => {
            n ? this.Sr.Lr(() => this.mf(i)) : (n = !0, this.PT(t, s, i).then(t => this.pT(i, t)).then(e.resolve, e.reject));
        }), 
        // Block the async queue until initialization is done
        this.Sr.Lr(() => e.promise), s.promise;
    }
    /** Enables the network connection and requeues all pending operations. */    enableNetwork() {
        return this.AT(), this.Sr.enqueue(() => this.tf.enableNetwork());
    }
    /**
     * Initializes persistent storage, attempting to use IndexedDB if
     * usePersistence is true or memory-only if false.
     *
     * If IndexedDB fails because it's already open in another tab or because the
     * platform can't possibly support our implementation then this method rejects
     * the persistenceResult and falls back on memory-only persistence.
     *
     * @param persistenceSettings Settings object to configure offline persistence
     * @param persistenceResult A deferred result indicating the user-visible
     *     result of enabling offline persistence. This method will reject this if
     *     IndexedDB fails to start for any reason. If usePersistence is false
     *     this is unconditionally resolved.
     * @returns a Promise indicating whether or not initialization should
     *     continue, i.e. that one of the persistence implementations actually
     *     succeeded.
     */    PT(t, e, s) {
        return t instanceof lo ? this.VT(s, t).then(t => (e.resolve(), t)).catch(t => {
            // An unknown failure on the first stage shuts everything down.
            if (
            // Regardless of whether or not the retry succeeds, from an user
            // perspective, offline persistence has failed.
            e.reject(t), !this.gT(t)) throw t;
            return console.warn("Error enabling offline persistence. Falling back to persistence disabled: " + t), 
            this.yT();
        }) : (
        // When usePersistence == false, enabling offline persistence is defined
        // to unconditionally succeed. This allows start() to have the same
        // signature for both cases, despite the fact that the returned promise
        // is only used in the enablePersistence call.
        e.resolve(), this.yT());
    }
    /**
     * Decides whether the provided error allows us to gracefully disable
     * persistence (as opposed to crashing the client).
     */    gT(t) {
        return t instanceof $ ? t.code === F.FAILED_PRECONDITION || t.code === F.UNIMPLEMENTED : !("undefined" != typeof DOMException && t instanceof DOMException) || (
        // When the browser is out of quota we could get either quota exceeded
        // or an aborted error depending on whether the error happened during
        // schema migration.
        t.code === co || t.code === uo || 
        // Firefox Private Browsing mode disables IndexedDb and returns
        // INVALID_STATE for any usage.
        t.code === ao);
    }
    /**
     * Checks that the client has not been terminated. Ensures that other methods on
     * this class cannot be called after the client is terminated.
     */    AT() {
        if (this.Sr.jr) throw new $(F.FAILED_PRECONDITION, "The client has already been terminated.");
    }
    /**
     * Starts IndexedDB-based persistence.
     *
     * @returns A promise indicating success or failure.
     */    VT(t, e) {
        // TODO(http://b/33384523): For now we just disable garbage collection
        // when persistence is enabled.
        const s = Si.ul(this.RT), n = new ks(this.RT.o, {
            ti: !0
        });
        // Opt to use proto3 JSON in case the platform doesn't support Uint8Array.
                return Promise.resolve().then(async () => {
            if (e.synchronizeTabs && !Kr.Ho(this.platform)) throw new $(F.UNIMPLEMENTED, "IndexedDB persistence is only available on platforms that support LocalStorage.");
            const i = e.Lc();
            this.Dm = e.synchronizeTabs ? new Kr(this.Sr, this.platform, s, this.clientId, t) : new Gr;
            const r = await Si.Mc({
                allowTabSynchronization: e.synchronizeTabs,
                persistenceKey: s,
                clientId: this.clientId,
                platform: this.platform,
                yc: this.Sr,
                serializer: n,
                Lc: i,
                bc: this.Dm
            });
            return this.persistence = r, r.Th.ku;
        });
    }
    /**
     * Starts Memory-backed persistence. In practice this cannot fail.
     *
     * @returns A promise that will successfully resolve.
     */    yT() {
        return this.persistence = Bi.kl(this.clientId), this.Dm = new Gr, Promise.resolve(null);
    }
    /**
     * Initializes the rest of the FirestoreClient, assuming the initial user
     * has been obtained from the credential provider and some persistence
     * implementation is available in this.persistence.
     */    pT(t, e) {
        return A(ho, "Initializing. user=", t.uid), this.platform.bT(this.RT).then(async s => {
            const n = new Fi;
            this.Nu = new kn(this.persistence, n, t), await this.Nu.start(), e && (
            // We're running LRU Garbage collection. Set up the scheduler.
            this.vT = new qn(e, this.Sr, this.Nu));
            const i = this.platform.ST(), r = this.platform.DT(this.RT.o), o = new er(this.Sr, s, this.credentials, r);
            this.pm = new kr(this.Nu, o, this.Sr, t => this.tf.Im(t, Me.ys), i), this.tf = new no(this.Nu, this.pm, this.Dm, t), 
            this.Dm.Ad = t => this.tf.Im(t, Me.bs), 
            // Set up wiring between sync engine and other components
            this.pm.tf = this.tf, this.Dm.tf = this.tf, this.CT = new ro(this.tf), 
            // PORTING NOTE: LocalStore doesn't need an explicit start() on the Web.
            await this.Dm.start(), await this.pm.start(), 
            // NOTE: This will immediately call the listener, so we make sure to
            // set it after localStore / remoteStore are started.
            await this.persistence.jc(async t => {
                await this.tf.Tf(t), this.vT && (t && !this.vT.Ta ? this.vT.start() : t || this.vT.stop());
            }), 
            // When a user calls clearPersistence() in one client, all other clients
            // need to be terminated to allow the delete to succeed.
            await this.persistence.zc(async () => {
                await this.terminate();
            });
        });
    }
    mf(t) {
        return this.Sr.Zr(), A(ho, "Credential Changed. Current user: " + t.uid), this.tf.mf(t);
    }
    /** Disables the network connection. Pending operations will not complete. */    disableNetwork() {
        return this.AT(), this.Sr.enqueue(() => this.tf.disableNetwork());
    }
    terminate() {
        return this.Sr.Jr(async () => {
            // PORTING NOTE: LocalStore does not need an explicit shutdown on web.
            this.vT && this.vT.stop(), await this.pm.shutdown(), await this.Dm.shutdown(), await this.persistence.shutdown(), 
            // `removeChangeListener` must be called after shutting down the
            // RemoteStore as it will prevent the RemoteStore from retrieving
            // auth tokens.
            this.credentials.p();
        });
    }
    /**
     * Returns a Promise that resolves when all writes that were pending at the time this
     * method was called received server acknowledgement. An acknowledgement can be either acceptance
     * or rejection.
     */    waitForPendingWrites() {
        this.AT();
        const t = new qs;
        return this.Sr.Lr(() => this.tf.Ym(t)), t.promise;
    }
    listen(t, e, s) {
        this.AT();
        const n = new oo(t, e, s);
        return this.Sr.Lr(() => this.CT.listen(n)), n;
    }
    Xd(t) {
        // Checks for termination but does not raise error, allowing unlisten after
        // termination to be a no-op.
        this.kT || this.Sr.Lr(() => this.CT.Xd(t));
    }
    NT(t) {
        return this.AT(), this.Sr.enqueue(() => this.Nu.Ha(t)).then(t => {
            if (t instanceof ue) return t;
            if (t instanceof ce) return null;
            throw new $(F.UNAVAILABLE, "Failed to get document from cache. (However, this document may exist on the server. Run again without setting 'source' in the GetOptions to attempt to retrieve the document from the server.)");
        });
    }
    FT(t) {
        return this.AT(), this.Sr.enqueue(async () => {
            const e = await this.Nu.eu(t, 
            /* usePreviousResults= */ !0), s = new Yr(t, e.nu), n = s.dm(e.documents);
            return s.Qo(n, 
            /* updateLimboDocuments= */ !1).snapshot;
        });
    }
    write(t) {
        this.AT();
        const e = new qs;
        return this.Sr.Lr(() => this.tf.write(t, e)), e.promise;
    }
    o() {
        return this.RT.o;
    }
    lT(t) {
        this.AT(), this.Sr.Lr(() => (this.CT.lT(t), Promise.resolve()));
    }
    _T(t) {
        // Checks for shutdown but does not raise error, allowing remove after
        // shutdown to be a no-op.
        this.kT || this.CT._T(t);
    }
    get kT() {
        // Technically, the asyncQueue is still running, but only accepting operations
        // related to termination or supposed to be run after termination. It is effectively
        // terminated to the eyes of users.
        return this.Sr.jr;
    }
    transaction(t) {
        this.AT();
        const e = new qs;
        return this.Sr.Lr(() => (this.tf.runTransaction(this.Sr, t, e), Promise.resolve())), 
        e.promise;
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * A wrapper implementation of Observer<T> that will dispatch events
 * asynchronously. To allow immediate silencing, a mute call is added which
 * causes events scheduled to no longer be raised.
 */ class mo {
    constructor(t) {
        this.observer = t, 
        /**
         * When set to true, will not raise future events. Necessary to deal with
         * async detachment of listener.
         */
        this.muted = !1;
    }
    next(t) {
        this.$T(this.observer.next, t);
    }
    error(t) {
        this.$T(this.observer.error, t);
    }
    xT() {
        this.muted = !0;
    }
    $T(t, e) {
        this.muted || setTimeout(() => {
            this.muted || t(e);
        }, 0);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ function To(t) {
    /**
 * Returns true if obj is an object and contains at least one of the specified
 * methods.
 */
    return function(t, e) {
        if ("object" != typeof t || null === t) return !1;
        const s = t;
        for (const t of e) if (t in s && "function" == typeof s[t]) return !0;
        return !1;
    }
    /**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
    // settings() defaults:
    (t, [ "next", "error", "complete" ]);
}

const wo = "firestore.googleapis.com", Eo = !0, Io = !0, Ro = !1, Ao = Mn.vu, Po = !1;

/**
 * A concrete type describing all the values that can be applied via a
 * user-supplied firestore.Settings object. This is a separate type so that
 * defaults can be supplied and the value can be checked for equality.
 */
class po {
    constructor(t) {
        if (void 0 === t.host) {
            if (void 0 !== t.ssl) throw new $(F.INVALID_ARGUMENT, "Can't provide ssl option if host option is not set");
            this.host = wo, this.ssl = Eo;
        } else X("settings", "non-empty string", "host", t.host), this.host = t.host, Z("settings", "boolean", "ssl", t.ssl), 
        this.ssl = U(t.ssl, Eo);
        if (ot("settings", t, [ "host", "ssl", "credentials", "timestampsInSnapshots", "cacheSizeBytes", "experimentalForceLongPolling" ]), 
        Z("settings", "object", "credentials", t.credentials), this.credentials = t.credentials, 
        Z("settings", "boolean", "timestampsInSnapshots", t.timestampsInSnapshots), 
        // Nobody should set timestampsInSnapshots anymore, but the error depends on
        // whether they set it to true or false...
        !0 === t.timestampsInSnapshots ? P("\n  The timestampsInSnapshots setting now defaults to true and you no\n  longer need to explicitly set it. In a future release, the setting\n  will be removed entirely and so it is recommended that you remove it\n  from your firestore.settings() call now.") : !1 === t.timestampsInSnapshots && P("\n  The timestampsInSnapshots setting will soon be removed. YOU MUST UPDATE\n  YOUR CODE.\n\n  To hide this warning, stop using the timestampsInSnapshots setting in your\n  firestore.settings({ ... }) call.\n\n  Once you remove the setting, Timestamps stored in Cloud Firestore will be\n  read back as Firebase Timestamp objects instead of as system Date objects.\n  So you will also need to update code expecting a Date to instead expect a\n  Timestamp. For example:\n\n  // Old:\n  const date = snapshot.get('created_at');\n  // New:\n  const timestamp = snapshot.get('created_at'); const date =\n  timestamp.toDate();\n\n  Please audit all existing usages of Date when you enable the new\n  behavior."), 
        this.timestampsInSnapshots = U(t.timestampsInSnapshots, Io), Z("settings", "number", "cacheSizeBytes", t.cacheSizeBytes), 
        void 0 === t.cacheSizeBytes) this.cacheSizeBytes = Mn.Du; else {
            if (t.cacheSizeBytes !== Ao && t.cacheSizeBytes < Mn.Su) throw new $(F.INVALID_ARGUMENT, `cacheSizeBytes must be at least ${Mn.Su}`);
            this.cacheSizeBytes = t.cacheSizeBytes;
        }
        Z("settings", "boolean", "experimentalForceLongPolling", t.experimentalForceLongPolling), 
        this.forceLongPolling = void 0 === t.experimentalForceLongPolling ? Ro : t.experimentalForceLongPolling;
    }
    isEqual(t) {
        return this.host === t.host && this.ssl === t.ssl && this.timestampsInSnapshots === t.timestampsInSnapshots && this.credentials === t.credentials && this.cacheSizeBytes === t.cacheSizeBytes && this.forceLongPolling === t.forceLongPolling;
    }
}

/**
 * The root reference to the database.
 */ class Vo {
    constructor(t, e) {
        if (this.MT = null, 
        // Public for use in tests.
        // TODO(mikelehen): Use modularized initialization instead.
        this.LT = new Ws, this.INTERNAL = {
            delete: async () => {
                // The client must be initalized to ensure that all subsequent API usage
                // throws an exception.
                this.BT(), await this.qT.terminate();
            }
        }, "object" == typeof t.options) {
            // This is very likely a Firebase app object
            // TODO(b/34177605): Can we somehow use instanceof?
            const s = t;
            this.MT = s, this.OT = Vo.UT(s), this.QT = s.name, this.WT = new L(e);
        } else {
            const e = t;
            if (!e.projectId) throw new $(F.INVALID_ARGUMENT, "Must provide projectId");
            this.OT = new k(e.projectId, e.database), 
            // Use a default persistenceKey that lines up with FirebaseApp.
            this.QT = "[DEFAULT]", this.WT = new M;
        }
        this.jT = new po({}), this.zT = this.KT(this.OT);
    }
    settings(t) {
        if (K("Firestore.settings", arguments, 1), J("Firestore.settings", "object", 1, t), 
        O(t, "persistence")) throw new $(F.INVALID_ARGUMENT, '"persistence" is now specified with a separate call to firestore.enablePersistence().');
        const e = new po(t);
        if (this.qT && !this.jT.isEqual(e)) throw new $(F.FAILED_PRECONDITION, "Firestore has already been started and its settings can no longer be changed. You can only call settings() before calling any other methods on a Firestore object.");
        this.jT = e, void 0 !== e.credentials && (this.WT = function(t) {
            if (!t) return new M;
            switch (t.type) {
              case "gapi":
                const e = t.GT;
                // Make sure this really is a Gapi client.
                                return g(!("object" != typeof e || null === e || !e.auth || !e.auth.getAuthHeaderValueForFirstParty), "unexpected gapi interface"), 
                new q(e, t.C || "0");

              case "provider":
                return t.GT;

              default:
                throw new $(F.INVALID_ARGUMENT, "makeCredentialsProvider failed due to invalid credential type");
            }
        }(e.credentials));
    }
    enableNetwork() {
        return this.BT(), this.qT.enableNetwork();
    }
    disableNetwork() {
        return this.BT(), this.qT.disableNetwork();
    }
    enablePersistence(t) {
        if (this.qT) throw new $(F.FAILED_PRECONDITION, "Firestore has already been started and persistence can no longer be enabled. You can only call enablePersistence() before calling any other methods on a Firestore object.");
        let e = !1;
        return t && (void 0 !== t.experimentalTabSynchronization && P("The 'experimentalTabSynchronization' setting has been renamed to 'synchronizeTabs'. In a future release, the setting will be removed and it is recommended that you update your firestore.enablePersistence() call to use 'synchronizeTabs'."), 
        e = U(void 0 !== t.synchronizeTabs ? t.synchronizeTabs : t.experimentalTabSynchronization, Po)), 
        this.HT(new lo(this.jT.cacheSizeBytes, e));
    }
    clearPersistence() {
        const t = Si.ul(this.JT()), e = new qs;
        return this.LT.zr(async () => {
            try {
                if (void 0 !== this.qT && !this.qT.kT) throw new $(F.FAILED_PRECONDITION, "Persistence cannot be cleared after this Firestore instance is initialized.");
                await Si.clearPersistence(t), e.resolve();
            } catch (t) {
                e.reject(t);
            }
        }), e.promise;
    }
    terminate() {
        return this.app._removeServiceInstance("firestore"), this.INTERNAL.delete();
    }
    get YT() {
        return this.BT(), this.qT.kT;
    }
    waitForPendingWrites() {
        return this.BT(), this.qT.waitForPendingWrites();
    }
    onSnapshotsInSync(t) {
        if (this.BT(), To(t)) return this.XT(t);
        {
            J("Firestore.onSnapshotsInSync", "function", 1, t);
            const e = {
                next: t
            };
            return this.XT(e);
        }
    }
    XT(t) {
        const e = new mo({
            next: () => {
                t.next && t.next();
            },
            error: t => {
                throw V("Uncaught Error in onSnapshotsInSync");
            }
        });
        return this.qT.lT(e), () => {
            e.xT(), this.qT._T(e);
        };
    }
    BT() {
        return this.qT || 
        // Kick off starting the client but don't actually wait for it.
        // eslint-disable-next-line @typescript-eslint/no-floating-promises
        this.HT(new _o), this.qT;
    }
    JT() {
        return new D(this.OT, this.QT, this.jT.host, this.jT.ssl, this.jT.forceLongPolling);
    }
    HT(t) {
        g(!!this.jT.host, "FirestoreSettings.host is not set"), g(!this.qT, "configureClient() called multiple times");
        const e = this.JT();
        return this.qT = new fo(Ns.t(), e, this.WT, this.LT), this.qT.start(t);
    }
    KT(t) {
        return new Ir(e => {
            if (e instanceof bo) {
                const s = t, n = e.firestore.OT;
                if (!n.isEqual(s)) throw new $(F.INVALID_ARGUMENT, "Document reference is for database " + `${n.projectId}/${n.database} but should be ` + `for database ${s.projectId}/${s.database}`);
                return new Er(t, e.ZT);
            }
            return e;
        });
    }
    static UT(t) {
        const e = t.options;
        if (!O(e, "projectId")) throw new $(F.INVALID_ARGUMENT, '"projectId" not provided in firebase.initializeApp.');
        const s = e.projectId;
        if (!s || "string" != typeof s) throw new $(F.INVALID_ARGUMENT, "projectId must be a string in FirebaseApp.options");
        return new k(s);
    }
    get app() {
        if (!this.MT) throw new $(F.FAILED_PRECONDITION, "Firestore was not initialized using the Firebase SDK. 'app' is not available");
        return this.MT;
    }
    collection(t) {
        return K("Firestore.collection", arguments, 1), J("Firestore.collection", "non-empty string", 1, t), 
        this.BT(), new No(Tt.et(t), this);
    }
    doc(t) {
        return K("Firestore.doc", arguments, 1), J("Firestore.doc", "non-empty string", 1, t), 
        this.BT(), bo.tw(Tt.et(t), this);
    }
    collectionGroup(t) {
        if (K("Firestore.collectionGroup", arguments, 1), J("Firestore.collectionGroup", "non-empty string", 1, t), 
        t.indexOf("/") >= 0) throw new $(F.INVALID_ARGUMENT, `Invalid collection ID '${t}' passed to function ` + "Firestore.collectionGroup(). Collection IDs must not contain '/'.");
        return this.BT(), new Co(new Ae(Tt.st, t), this);
    }
    runTransaction(t) {
        return K("Firestore.runTransaction", arguments, 1), J("Firestore.runTransaction", "function", 1, t), 
        this.BT().transaction(e => t(new go(this, e)));
    }
    batch() {
        return this.BT(), new yo(this);
    }
    static get logLevel() {
        switch (I()) {
          case E.DEBUG:
            return "debug";

          case E.ERROR:
            return "error";

          case E.SILENT:
            return "silent";

          default:
            return V("Unknown log level: " + I());
        }
    }
    static setLogLevel(t) {
        switch (K("Firestore.setLogLevel", arguments, 1), J("Firestore.setLogLevel", "non-empty string", 1, t), 
        t) {
          case "debug":
            R(E.DEBUG);
            break;

          case "error":
            R(E.ERROR);
            break;

          case "silent":
            R(E.SILENT);
            break;

          default:
            throw new $(F.INVALID_ARGUMENT, "Invalid log level: " + t);
        }
    }
    // Note: this is not a property because the minifier can't work correctly with
    // the way TypeScript compiler outputs properties.
    ew() {
        return this.jT.timestampsInSnapshots;
    }
}

/**
 * A reference to a transaction.
 */ class go {
    constructor(t, e) {
        this.sw = t, this.nw = e;
    }
    get(t) {
        K("Transaction.get", arguments, 1);
        const e = Mo("Transaction.get", t, this.sw);
        return this.nw.lookup([ e.ZT ]).then(t => {
            if (!t || 1 !== t.length) return V("Mismatch in docs returned from document lookup.");
            const s = t[0];
            if (s instanceof ce) return new So(this.sw, e.ZT, null, 
            /* fromCache= */ !1, 
            /* hasPendingWrites= */ !1, e.iw);
            if (s instanceof ue) return new So(this.sw, e.ZT, s, 
            /* fromCache= */ !1, 
            /* hasPendingWrites= */ !1, e.iw);
            throw V(`BatchGetDocumentsRequest returned unexpected document type: ${s.constructor.name}`);
        });
    }
    set(t, e, s) {
        H("Transaction.set", arguments, 2, 3);
        const n = Mo("Transaction.set", t, this.sw);
        s = Fo("Transaction.set", s);
        const [i, r] = Bo(n.iw, e, "Transaction.set"), o = s.merge || s.mergeFields ? this.sw.zT.ed(r, i, s.mergeFields) : this.sw.zT.Z_(r, i);
        return this.nw.set(n.ZT, o), this;
    }
    update(t, e, s, ...n) {
        let i, r;
        return "string" == typeof e || e instanceof sr ? (G("Transaction.update", arguments, 3), 
        i = Mo("Transaction.update", t, this.sw), r = this.sw.zT.rd("Transaction.update", e, s, n)) : (K("Transaction.update", arguments, 2), 
        i = Mo("Transaction.update", t, this.sw), r = this.sw.zT.sd("Transaction.update", e)), 
        this.nw.update(i.ZT, r), this;
    }
    delete(t) {
        K("Transaction.delete", arguments, 1);
        const e = Mo("Transaction.delete", t, this.sw);
        return this.nw.delete(e.ZT), this;
    }
}

class yo {
    constructor(t) {
        this.sw = t, this.rw = [], this.ow = !1;
    }
    set(t, e, s) {
        H("WriteBatch.set", arguments, 2, 3), this.hw();
        const n = Mo("WriteBatch.set", t, this.sw);
        s = Fo("WriteBatch.set", s);
        const [i, r] = Bo(n.iw, e, "WriteBatch.set"), o = s.merge || s.mergeFields ? this.sw.zT.ed(r, i, s.mergeFields) : this.sw.zT.Z_(r, i);
        return this.rw = this.rw.concat(o.B_(n.ZT, Bt.NONE)), this;
    }
    update(t, e, s, ...n) {
        let i, r;
        return this.hw(), "string" == typeof e || e instanceof sr ? (G("WriteBatch.update", arguments, 3), 
        i = Mo("WriteBatch.update", t, this.sw), r = this.sw.zT.rd("WriteBatch.update", e, s, n)) : (K("WriteBatch.update", arguments, 2), 
        i = Mo("WriteBatch.update", t, this.sw), r = this.sw.zT.sd("WriteBatch.update", e)), 
        this.rw = this.rw.concat(r.B_(i.ZT, Bt.exists(!0))), this;
    }
    delete(t) {
        K("WriteBatch.delete", arguments, 1), this.hw();
        const e = Mo("WriteBatch.delete", t, this.sw);
        return this.rw = this.rw.concat(new Wt(e.ZT, Bt.NONE)), this;
    }
    async commit() {
        if (this.hw(), this.ow = !0, this.rw.length > 0) return this.sw.BT().write(this.rw);
    }
    hw() {
        if (this.ow) throw new $(F.FAILED_PRECONDITION, "A write batch can no longer be used after commit() has been called.");
    }
}

/**
 * A reference to a particular document in a collection in the database.
 */ class bo {
    constructor(t, e, s) {
        this.ZT = t, this.firestore = e, this.iw = s, this.qT = this.firestore.BT();
    }
    static tw(t, e, s) {
        if (t.length % 2 != 0) throw new $(F.INVALID_ARGUMENT, "Invalid document reference. Document references must have an even number of segments, but " + `${t.tt()} has ${t.length}`);
        return new bo(new It(t), e, s);
    }
    get id() {
        return this.ZT.path.J();
    }
    get parent() {
        return new No(this.ZT.path.K(), this.firestore, this.iw);
    }
    get path() {
        return this.ZT.path.tt();
    }
    collection(t) {
        if (K("DocumentReference.collection", arguments, 1), J("DocumentReference.collection", "non-empty string", 1, t), 
        !t) throw new $(F.INVALID_ARGUMENT, "Must provide a non-empty collection name to collection()");
        const e = Tt.et(t);
        return new No(this.ZT.path.child(e), this.firestore);
    }
    isEqual(t) {
        if (!(t instanceof bo)) throw ht("isEqual", "DocumentReference", 1, t);
        return this.firestore === t.firestore && this.ZT.isEqual(t.ZT) && this.iw === t.iw;
    }
    set(t, e) {
        H("DocumentReference.set", arguments, 1, 2), e = Fo("DocumentReference.set", e);
        const [s, n] = Bo(this.iw, t, "DocumentReference.set"), i = e.merge || e.mergeFields ? this.firestore.zT.ed(n, s, e.mergeFields) : this.firestore.zT.Z_(n, s);
        return this.qT.write(i.B_(this.ZT, Bt.NONE));
    }
    update(t, e, ...s) {
        let n;
        return "string" == typeof t || t instanceof sr ? (G("DocumentReference.update", arguments, 2), 
        n = this.firestore.zT.rd("DocumentReference.update", t, e, s)) : (K("DocumentReference.update", arguments, 1), 
        n = this.firestore.zT.sd("DocumentReference.update", t)), this.qT.write(n.B_(this.ZT, Bt.exists(!0)));
    }
    delete() {
        return K("DocumentReference.delete", arguments, 0), this.qT.write([ new Wt(this.ZT, Bt.NONE) ]);
    }
    onSnapshot(...t) {
        H("DocumentReference.onSnapshot", arguments, 1, 4);
        let e, s = {
            includeMetadataChanges: !1
        }, n = 0;
        "object" != typeof t[n] || To(t[n]) || (ot("DocumentReference.onSnapshot", s = t[n], [ "includeMetadataChanges" ]), 
        Z("DocumentReference.onSnapshot", "boolean", "includeMetadataChanges", s.includeMetadataChanges), 
        n++);
        const i = {
            includeMetadataChanges: s.includeMetadataChanges
        };
        return To(t[n]) ? e = t[n] : (J("DocumentReference.onSnapshot", "function", n, t[n]), 
        Y("DocumentReference.onSnapshot", "function", n + 1, t[n + 1]), Y("DocumentReference.onSnapshot", "function", n + 2, t[n + 2]), 
        e = {
            next: t[n],
            error: t[n + 1],
            complete: t[n + 2]
        }), this.aw(i, e);
    }
    aw(t, e) {
        let s = t => {
            console.error("Uncaught Error in onSnapshot:", t);
        };
        e.error && (s = e.error.bind(e));
        const n = new mo({
            next: t => {
                if (e.next) {
                    g(t.docs.size <= 1, "Too many documents returned on a document query");
                    const s = t.docs.get(this.ZT);
                    e.next(new So(this.firestore, this.ZT, s, t.fromCache, t.hasPendingWrites, this.iw));
                }
            },
            error: s
        }), i = this.qT.listen(Ae.Ye(this.ZT.path), n, t);
        return () => {
            n.xT(), this.qT.Xd(i);
        };
    }
    get(t) {
        return H("DocumentReference.get", arguments, 0, 1), xo("DocumentReference.get", t), 
        new Promise((e, s) => {
            t && "cache" === t.source ? this.firestore.BT().NT(this.ZT).then(t => {
                e(new So(this.firestore, this.ZT, t, 
                /*fromCache=*/ !0, t instanceof ue && t.ie, this.iw));
            }, s) : this.uw(e, s, t);
        });
    }
    uw(t, e, s) {
        const n = this.aw({
            includeMetadataChanges: !0,
            IT: !0
        }, {
            next: i => {
                // Remove query first before passing event to user to avoid
                // user actions affecting the now stale query.
                n(), !i.exists && i.metadata.fromCache ? 
                // TODO(dimond): If we're online and the document doesn't
                // exist then we resolve with a doc.exists set to false. If
                // we're offline however, we reject the Promise in this
                // case. Two options: 1) Cache the negative response from
                // the server so we can deliver that even when you're
                // offline 2) Actually reject the Promise in the online case
                // if the document doesn't exist.
                e(new $(F.UNAVAILABLE, "Failed to get document because the client is offline.")) : i.exists && i.metadata.fromCache && s && "server" === s.source ? e(new $(F.UNAVAILABLE, 'Failed to get document from server. (However, this document does exist in the local cache. Run again without setting source to "server" to retrieve the cached document.)')) : t(i);
            },
            error: e
        });
    }
    withConverter(t) {
        return new bo(this.ZT, this.firestore, t);
    }
}

class vo {
    constructor(t, e) {
        this.hasPendingWrites = t, this.fromCache = e;
    }
    isEqual(t) {
        return this.hasPendingWrites === t.hasPendingWrites && this.fromCache === t.fromCache;
    }
}

class So {
    constructor(t, e, s, n, i, r) {
        this.sw = t, this.ZT = e, this.cw = s, this.lw = n, this._w = i, this.iw = r;
    }
    data(t) {
        if (H("DocumentSnapshot.data", arguments, 0, 1), t = $o("DocumentSnapshot.data", t), 
        this.cw) {
            // We only want to use the converter and create a new DocumentSnapshot
            // if a converter has been provided.
            if (this.iw) {
                const e = new Do(this.sw, this.ZT, this.cw, this.lw, this._w);
                return this.iw.fromFirestore(e, t);
            }
            return this.dw(this.cw.data(), zt.ye(t, this.sw.ew()));
        }
    }
    get(t, e) {
        if (H("DocumentSnapshot.get", arguments, 1, 2), e = $o("DocumentSnapshot.get", e), 
        this.cw) {
            const s = this.cw.data().field(Pr("DocumentSnapshot.get", t));
            if (null !== s) return this.fw(s, zt.ye(e, this.sw.ew()));
        }
    }
    get id() {
        return this.ZT.path.J();
    }
    get ref() {
        return new bo(this.ZT, this.sw, this.iw);
    }
    get exists() {
        return null !== this.cw;
    }
    get metadata() {
        return new vo(this._w, this.lw);
    }
    isEqual(t) {
        if (!(t instanceof So)) throw ht("isEqual", "DocumentSnapshot", 1, t);
        return this.sw === t.sw && this.lw === t.lw && this.ZT.isEqual(t.ZT) && (null === this.cw ? null === t.cw : this.cw.isEqual(t.cw)) && this.iw === t.iw;
    }
    dw(t, e) {
        const s = {};
        return t.forEach((t, n) => {
            s[t] = this.fw(n, e);
        }), s;
    }
    fw(t, e) {
        if (t instanceof oe) return this.dw(t, e);
        if (t instanceof he) return this.mw(t, e);
        if (t instanceof ie) {
            const s = t.value(e), n = this.sw.BT().o();
            return t.o.isEqual(n) || 
            // TODO(b/64130202): Somehow support foreign references.
            P(`Document ${this.ZT.path} contains a document ` + "reference within a different database (" + `${t.o.projectId}/${t.o.database}) which is not ` + "supported. It will be treated as a reference in the current " + `database (${n.projectId}/${n.database}) ` + "instead."), 
            new bo(s, this.sw, this.iw);
        }
        return t.value(e);
    }
    mw(t, e) {
        return t.Kt.map(t => this.fw(t, e));
    }
}

class Do extends So {
    data(t) {
        const e = super.data(t);
        return g(void 0 !== e, "Document in a QueryDocumentSnapshot should exist"), e;
    }
}

class Co {
    constructor(t, e, s) {
        this.Tw = t, this.firestore = e, this.iw = s;
    }
    where(t, e, s) {
        K("Query.where", arguments, 3), rt("Query.where", 3, s);
        let n;
        !function(t, e, s, n) {
            if (!e.some(t => t === n)) throw new $(F.INVALID_ARGUMENT, `Invalid value ${it(n)} provided to function ` + `${t}() for its ${ut(s)} argument. Acceptable ` + `values: ${e.join(", ")}`);
        }("Query.where", [ "<", "<=", "==", ">=", ">", "array-contains", "in", "array-contains-any" ], 2, e);
        const i = Pr("Query.where", t), r = pe.et(e);
        if (i.it()) {
            if (r === pe.ARRAY_CONTAINS || r === pe.ARRAY_CONTAINS_ANY) throw new $(F.INVALID_ARGUMENT, `Invalid Query. You can't perform '${r.toString()}' ` + "queries on FieldPath.documentId().");
            if (r === pe.IN) {
                this.ww(s, r);
                const t = [];
                for (const e of s) t.push(this.Ew(e));
                n = new he(t);
            } else n = this.Ew(s);
        } else r !== pe.IN && r !== pe.ARRAY_CONTAINS_ANY || this.ww(s, r), n = this.firestore.zT.od("Query.where", s, 
        // We only allow nested arrays for IN queries.
        /** allowArrays = */ r === pe.IN);
        const o = Ve.create(i, r, n);
        return this.Iw(o), new Co(this.Tw.ts(o), this.firestore, this.iw);
    }
    orderBy(t, e) {
        let s;
        if (H("Query.orderBy", arguments, 1, 2), Y("Query.orderBy", "non-empty string", 2, e), 
        void 0 === e || "asc" === e) s = De.ASCENDING; else {
            if ("desc" !== e) throw new $(F.INVALID_ARGUMENT, `Function Query.orderBy() has unknown direction '${e}', ` + "expected 'asc' or 'desc'.");
            s = De.DESCENDING;
        }
        if (null !== this.Tw.startAt) throw new $(F.INVALID_ARGUMENT, "Invalid query. You must not call Query.startAt() or Query.startAfter() before calling Query.orderBy().");
        if (null !== this.Tw.endAt) throw new $(F.INVALID_ARGUMENT, "Invalid query. You must not call Query.endAt() or Query.endBefore() before calling Query.orderBy().");
        const n = Pr("Query.orderBy", t), i = new ke(n, s);
        return this.Rw(i), new Co(this.Tw.ss(i), this.firestore, this.iw);
    }
    limit(t) {
        return K("Query.limit", arguments, 1), J("Query.limit", "number", 1, t), at("Query.limit", 1, t), 
        new Co(this.Tw.ns(t), this.firestore, this.iw);
    }
    limitToLast(t) {
        return K("Query.limitToLast", arguments, 1), J("Query.limitToLast", "number", 1, t), 
        at("Query.limitToLast", 1, t), new Co(this.Tw.rs(t), this.firestore, this.iw);
    }
    startAt(t, ...e) {
        G("Query.startAt", arguments, 1);
        const s = this.Aw("Query.startAt", t, e, 
        /*before=*/ !0);
        return new Co(this.Tw.os(s), this.firestore, this.iw);
    }
    startAfter(t, ...e) {
        G("Query.startAfter", arguments, 1);
        const s = this.Aw("Query.startAfter", t, e, 
        /*before=*/ !1);
        return new Co(this.Tw.os(s), this.firestore, this.iw);
    }
    endBefore(t, ...e) {
        G("Query.endBefore", arguments, 1);
        const s = this.Aw("Query.endBefore", t, e, 
        /*before=*/ !0);
        return new Co(this.Tw.hs(s), this.firestore, this.iw);
    }
    endAt(t, ...e) {
        G("Query.endAt", arguments, 1);
        const s = this.Aw("Query.endAt", t, e, 
        /*before=*/ !1);
        return new Co(this.Tw.hs(s), this.firestore, this.iw);
    }
    isEqual(t) {
        if (!(t instanceof Co)) throw ht("isEqual", "Query", 1, t);
        return this.firestore === t.firestore && this.Tw.isEqual(t.Tw);
    }
    withConverter(t) {
        return new Co(this.Tw, this.firestore, t);
    }
    /** Helper function to create a bound from a document or fields */    Aw(t, e, s, n) {
        if (rt(t, 1, e), e instanceof So) {
            if (s.length > 0) throw new $(F.INVALID_ARGUMENT, `Too many arguments provided to ${t}().`);
            const i = e;
            if (!i.exists) throw new $(F.NOT_FOUND, "Can't use a DocumentSnapshot that doesn't exist for " + `${t}().`);
            return this.Pw(t, i.cw, n);
        }
        {
            const i = [ e ].concat(s);
            return this.pw(t, i, n);
        }
    }
    /**
     * Create a Bound from a query and a document.
     *
     * Note that the Bound will always include the key of the document
     * and so only the provided document will compare equal to the returned
     * position.
     *
     * Will throw if the document does not contain all fields of the order by
     * of the query or if any of the fields in the order by are an uncommitted
     * server timestamp.
     */    Pw(t, e, s) {
        const n = [];
        // Because people expect to continue/end a query at the exact document
        // provided, we need to use the implicit sort order rather than the explicit
        // sort order, because it's guaranteed to contain the document key. That way
        // the position becomes unambiguous and the query continues/ends exactly at
        // the provided document. Without the key (by using the explicit sort
        // orders), multiple documents could match the position, yielding duplicate
        // results.
                for (const t of this.Tw.orderBy) if (t.field.it()) n.push(new ie(this.firestore.OT, e.key)); else {
            const s = e.field(t.field);
            if (s instanceof se) throw new $(F.INVALID_ARGUMENT, 'Invalid query. You are trying to start or end a query using a document for which the field "' + t.field + '" is an uncommitted server timestamp. (Since the value of this field is unknown, you cannot start/end a query with it.)');
            if (null === s) {
                const e = t.field.tt();
                throw new $(F.INVALID_ARGUMENT, "Invalid query. You are trying to start or end a query using a " + `document for which the field '${e}' (used as the ` + "orderBy) does not exist.");
            }
            n.push(s);
        }
        return new Ce(n, s);
    }
    /**
     * Converts a list of field values to a Bound for the given query.
     */    pw(t, e, s) {
        // Use explicit order by's because it has to match the query the user made
        const n = this.Tw.ze;
        if (e.length > n.length) throw new $(F.INVALID_ARGUMENT, `Too many arguments provided to ${t}(). ` + "The number of arguments must be less than or equal to the number of Query.orderBy() clauses");
        const i = [];
        for (let s = 0; s < e.length; s++) {
            const r = e[s];
            if (n[s].field.it()) {
                if ("string" != typeof r) throw new $(F.INVALID_ARGUMENT, "Invalid query. Expected a string for document ID in " + `${t}(), but got a ${typeof r}`);
                if (!this.Tw.Is() && -1 !== r.indexOf("/")) throw new $(F.INVALID_ARGUMENT, "Invalid query. When querying a collection and ordering by FieldPath.documentId(), " + `the value passed to ${t}() must be a plain document ID, but ` + `'${r}' contains a slash.`);
                const e = this.Tw.path.child(Tt.et(r));
                if (!It.ht(e)) throw new $(F.INVALID_ARGUMENT, "Invalid query. When querying a collection group and ordering by " + `FieldPath.documentId(), the value passed to ${t}() must result in a ` + `valid document path, but '${e}' is not because it contains an odd number ` + "of segments.");
                const s = new It(e);
                i.push(new ie(this.firestore.OT, s));
            } else {
                const e = this.firestore.zT.od(t, r);
                i.push(e);
            }
        }
        return new Ce(i, s);
    }
    onSnapshot(...t) {
        H("Query.onSnapshot", arguments, 1, 4);
        let e, s = {}, n = 0;
        return "object" != typeof t[n] || To(t[n]) || (ot("Query.onSnapshot", s = t[n], [ "includeMetadataChanges" ]), 
        Z("Query.onSnapshot", "boolean", "includeMetadataChanges", s.includeMetadataChanges), 
        n++), To(t[n]) ? e = t[n] : (J("Query.onSnapshot", "function", n, t[n]), Y("Query.onSnapshot", "function", n + 1, t[n + 1]), 
        Y("Query.onSnapshot", "function", n + 2, t[n + 2]), e = {
            next: t[n],
            error: t[n + 1],
            complete: t[n + 2]
        }), this.Vw(this.Tw), this.aw(s, e);
    }
    aw(t, e) {
        let s = t => {
            console.error("Uncaught Error in onSnapshot:", t);
        };
        e.error && (s = e.error.bind(e));
        const n = new mo({
            next: t => {
                e.next && e.next(new ko(this.firestore, this.Tw, t, this.iw));
            },
            error: s
        }), i = this.firestore.BT(), r = i.listen(this.Tw, n, t);
        return () => {
            n.xT(), i.Xd(r);
        };
    }
    Vw(t) {
        if (t.ws() && 0 === t.ze.length) throw new $(F.UNIMPLEMENTED, "limitToLast() queries require specifying at least one orderBy() clause");
    }
    get(t) {
        return H("Query.get", arguments, 0, 1), xo("Query.get", t), this.Vw(this.Tw), new Promise((e, s) => {
            t && "cache" === t.source ? this.firestore.BT().FT(this.Tw).then(t => {
                e(new ko(this.firestore, this.Tw, t, this.iw));
            }, s) : this.uw(e, s, t);
        });
    }
    uw(t, e, s) {
        const n = this.aw({
            includeMetadataChanges: !0,
            IT: !0
        }, {
            next: i => {
                // Remove query first before passing event to user to avoid
                // user actions affecting the now stale query.
                n(), i.metadata.fromCache && s && "server" === s.source ? e(new $(F.UNAVAILABLE, 'Failed to get documents from server. (However, these documents may exist in the local cache. Run again without setting source to "server" to retrieve the cached documents.)')) : t(i);
            },
            error: e
        });
    }
    /**
     * Parses the given documentIdValue into a ReferenceValue, throwing
     * appropriate errors if the value is anything other than a DocumentReference
     * or String, or if the string is malformed.
     */    Ew(t) {
        if ("string" == typeof t) {
            if ("" === t) throw new $(F.INVALID_ARGUMENT, "Invalid query. When querying with FieldPath.documentId(), you must provide a valid document ID, but it was an empty string.");
            if (!this.Tw.Is() && -1 !== t.indexOf("/")) throw new $(F.INVALID_ARGUMENT, "Invalid query. When querying a collection by FieldPath.documentId(), you must provide a plain document ID, but " + `'${t}' contains a '/' character.`);
            const e = this.Tw.path.child(Tt.et(t));
            if (!It.ht(e)) throw new $(F.INVALID_ARGUMENT, "Invalid query. When querying a collection group by FieldPath.documentId(), the value provided must result in a valid document path, " + `but '${e}' is not because it has an odd number of segments (${e.length}).`);
            return new ie(this.firestore.OT, new It(e));
        }
        if (t instanceof bo) {
            const e = t;
            return new ie(this.firestore.OT, e.ZT);
        }
        throw new $(F.INVALID_ARGUMENT, "Invalid query. When querying with FieldPath.documentId(), you must provide a valid string or a DocumentReference, but it was: " + `${it(t)}.`);
    }
    /**
     * Validates that the value passed into a disjunctrive filter satisfies all
     * array requirements.
     */    ww(t, e) {
        if (!Array.isArray(t) || 0 === t.length) throw new $(F.INVALID_ARGUMENT, "Invalid Query. A non-empty array is required for " + `'${e.toString()}' filters.`);
        if (t.length > 10) throw new $(F.INVALID_ARGUMENT, `Invalid Query. '${e.toString()}' filters support a ` + "maximum of 10 elements in the value array.");
        if (t.indexOf(null) >= 0) throw new $(F.INVALID_ARGUMENT, `Invalid Query. '${e.toString()}' filters cannot contain 'null' ` + "in the value array.");
        if (t.filter(t => Number.isNaN(t)).length > 0) throw new $(F.INVALID_ARGUMENT, `Invalid Query. '${e.toString()}' filters cannot contain 'NaN' ` + "in the value array.");
    }
    Iw(t) {
        if (t instanceof Ve) {
            const e = [ pe.ARRAY_CONTAINS, pe.ARRAY_CONTAINS_ANY ], s = [ pe.IN, pe.ARRAY_CONTAINS_ANY ], n = e.indexOf(t.op) >= 0, i = s.indexOf(t.op) >= 0;
            if (t.es()) {
                const e = this.Tw.Xe();
                if (null !== e && !e.isEqual(t.field)) throw new $(F.INVALID_ARGUMENT, "Invalid query. All where filters with an inequality (<, <=, >, or >=) must be on the same field. But you have" + ` inequality filters on '${e.toString()}'` + ` and '${t.field.toString()}'`);
                const s = this.Tw.Ze();
                null !== s && this.gw(t.field, s);
            } else if (i || n) {
                // You can have at most 1 disjunctive filter and 1 array filter. Check if
                // the new filter conflicts with an existing one.
                let r = null;
                if (i && (r = this.Tw.Es(s)), null === r && n && (r = this.Tw.Es(e)), null != r) 
                // We special case when it's a duplicate op to give a slightly clearer error message.
                throw r === t.op ? new $(F.INVALID_ARGUMENT, "Invalid query. You cannot use more than one " + `'${t.op.toString()}' filter.`) : new $(F.INVALID_ARGUMENT, `Invalid query. You cannot use '${t.op.toString()}' filters ` + `with '${r.toString()}' filters.`);
            }
        }
    }
    Rw(t) {
        if (null === this.Tw.Ze()) {
            // This is the first order by. It must match any inequality.
            const e = this.Tw.Xe();
            null !== e && this.gw(e, t.field);
        }
    }
    gw(t, e) {
        if (!e.isEqual(t)) throw new $(F.INVALID_ARGUMENT, "Invalid query. You have a where filter with an inequality " + `(<, <=, >, or >=) on field '${t.toString()}' ` + `and so you must also use '${t.toString()}' ` + "as your first Query.orderBy(), but your first Query.orderBy() " + `is on field '${e.toString()}' instead.`);
    }
}

class ko {
    constructor(t, e, s, n) {
        this.sw = t, this.yw = e, this.bw = s, this.iw = n, this.vw = null, this.Sw = null, 
        this.metadata = new vo(s.hasPendingWrites, s.fromCache);
    }
    get docs() {
        const t = [];
        return this.forEach(e => t.push(e)), t;
    }
    get empty() {
        return this.bw.docs.G();
    }
    get size() {
        return this.bw.docs.size;
    }
    forEach(t, e) {
        H("QuerySnapshot.forEach", arguments, 1, 2), J("QuerySnapshot.forEach", "function", 1, t), 
        this.bw.docs.forEach(s => {
            t.call(e, this.Dw(s));
        });
    }
    get query() {
        return new Co(this.yw, this.sw, this.iw);
    }
    docChanges(t) {
        t && (ot("QuerySnapshot.docChanges", t, [ "includeMetadataChanges" ]), Z("QuerySnapshot.docChanges", "boolean", "includeMetadataChanges", t.includeMetadataChanges));
        const e = !(!t || !t.includeMetadataChanges);
        if (e && this.bw.Xs) throw new $(F.INVALID_ARGUMENT, "To include metadata changes with your document changes, you must also pass { includeMetadataChanges:true } to onSnapshot().");
        return this.vw && this.Sw === e || (this.vw = 
        /**
 * Calculates the array of firestore.DocumentChange's for a given ViewSnapshot.
 *
 * Exported for testing.
 */
        function(t, e, s, n) {
            if (s.Hs.G()) {
                // Special case the first snapshot because index calculation is easy and
                // fast
                let e, i = 0;
                return s.docChanges.map(r => {
                    const o = new Do(t, r.doc.key, r.doc, s.fromCache, s.Js.has(r.doc.key), n);
                    return g(r.type === us.Os, "Invalid event type for first snapshot"), g(!e || s.query.ls(e, r.doc) < 0, "Got added events in wrong order"), 
                    e = r.doc, {
                        type: "added",
                        doc: o,
                        oldIndex: -1,
                        newIndex: i++
                    };
                });
            }
            {
                // A DocumentSet that is updated incrementally as changes are applied to use
                // to lookup the index of a document.
                let i = s.Hs;
                return s.docChanges.filter(t => e || t.type !== us.Ws).map(e => {
                    const r = new Do(t, e.doc.key, e.doc, s.fromCache, s.Js.has(e.doc.key), n);
                    let o = -1, h = -1;
                    return e.type !== us.Os && (g((o = i.indexOf(e.doc.key)) >= 0, "Index for document not found"), 
                    i = i.delete(e.doc.key)), e.type !== us.Us && (h = (i = i.add(e.doc)).indexOf(e.doc.key)), 
                    {
                        type: Lo(e.type),
                        doc: r,
                        oldIndex: o,
                        newIndex: h
                    };
                });
            }
        }(this.sw, e, this.bw, this.iw), this.Sw = e), this.vw;
    }
    /** Check the equality. The call can be very expensive. */    isEqual(t) {
        if (!(t instanceof ko)) throw ht("isEqual", "QuerySnapshot", 1, t);
        return this.sw === t.sw && this.yw.isEqual(t.yw) && this.bw.isEqual(t.bw) && this.iw === t.iw;
    }
    Dw(t) {
        return new Do(this.sw, t.key, t, this.metadata.fromCache, this.bw.Js.has(t.key), this.iw);
    }
}

// TODO(2018/11/01): As of 2018/04/17 we're changing docChanges from an array
// into a method. Because this is a runtime breaking change and somewhat subtle
// (both Array and Function have a .length, etc.), we'll replace commonly-used
// properties (including Symbol.iterator) to throw a custom error message. In
// ~6 months we can delete the custom error as most folks will have hopefully
// migrated.
[ "length", "forEach", "map", ..."undefined" != typeof Symbol ? [ Symbol.iterator ] : [] ].forEach(t => {
    /**
     * We are (re-)defining properties on QuerySnapshot.prototype.docChanges which
     * is a Function. This could fail, in particular in the case of 'length' which
     * already exists on Function.prototype and on IE11 is improperly defined with
     * `{ configurable: false }`. So we wrap this in a try/catch to ensure that we
     * still have a functional SDK.
     */
    try {
        Object.defineProperty(ko.prototype.docChanges, t, {
            get: () => (function() {
                throw new $(F.INVALID_ARGUMENT, 'QuerySnapshot.docChanges has been changed from a property into a method, so usages like "querySnapshot.docChanges" should become "querySnapshot.docChanges()"');
            })()
        });
    } catch (t) {}
 // Ignore this failure intentionally
});

class No extends Co {
    constructor(t, e, s) {
        if (super(Ae.Ye(t), e, s), this.Cw = t, t.length % 2 != 1) throw new $(F.INVALID_ARGUMENT, "Invalid collection reference. Collection references must have an odd number of segments, but " + `${t.tt()} has ${t.length}`);
    }
    get id() {
        return this.Tw.path.J();
    }
    get parent() {
        const t = this.Tw.path.K();
        return t.G() ? null : new bo(new It(t), this.firestore);
    }
    get path() {
        return this.Tw.path.tt();
    }
    doc(t) {
        if (H("CollectionReference.doc", arguments, 0, 1), 
        // We allow omission of 'pathString' but explicitly prohibit passing in both
        // 'undefined' and 'null'.
        0 === arguments.length && (t = y.i()), J("CollectionReference.doc", "non-empty string", 1, t), 
        "" === t) throw new $(F.INVALID_ARGUMENT, "Document path must be a non-empty string");
        const e = Tt.et(t);
        return bo.tw(this.Tw.path.child(e), this.firestore, this.iw);
    }
    add(t) {
        K("CollectionReference.add", arguments, 1), J("CollectionReference.add", "object", 1, this.iw ? this.iw.toFirestore(t) : t);
        const e = this.doc();
        return e.set(t).then(() => e);
    }
    withConverter(t) {
        return new No(this.Cw, this.firestore, t);
    }
}

function Fo(t, e) {
    if (void 0 === e) return {
        merge: !1
    };
    if (ot(t, e, [ "merge", "mergeFields" ]), Z(t, "boolean", "merge", e.merge), tt(t, "mergeFields", "a string or a FieldPath", e.mergeFields, t => "string" == typeof t || t instanceof sr), 
    void 0 !== e.mergeFields && void 0 !== e.merge) throw new $(F.INVALID_ARGUMENT, `Invalid options passed to function ${t}(): You cannot specify both "merge" ` + 'and "mergeFields".');
    return e;
}

function $o(t, e) {
    return void 0 === e ? {} : (ot(t, e, [ "serverTimestamps" ]), et(t, 0, "serverTimestamps", e.serverTimestamps, [ "estimate", "previous", "none" ]), 
    e);
}

function xo(t, e) {
    Y(t, "object", 1, e), e && (ot(t, e, [ "source" ]), et(t, 0, "source", e.source, [ "default", "server", "cache" ]));
}

function Mo(t, e, s) {
    if (e instanceof bo) {
        if (e.firestore !== s) throw new $(F.INVALID_ARGUMENT, "Provided document reference is from a different Firestore instance.");
        return e;
    }
    throw ht(t, "DocumentReference", 1, e);
}

function Lo(t) {
    switch (t) {
      case us.Os:
        return "added";

      case us.Qs:
      case us.Ws:
        return "modified";

      case us.Us:
        return "removed";

      default:
        return V("Unknown change type: " + t);
    }
}

/**
 * Converts custom model object of type T into DocumentData by applying the
 * converter if it exists.
 *
 * This function is used when converting user objects to DocumentData
 * because we want to provide the user with a more specific error message if
 * their set() or fails due to invalid data originating from a toFirestore()
 * call.
 */ function Bo(t, e, s) {
    let n;
    return t ? (n = t.toFirestore(e), s = "toFirestore() in " + s) : n = e, [ n, s ];
}

// Export the classes with a private constructor (it will fail if invoked
// at runtime). Note that this still allows instanceof checks.
// We're treating the variables as class names, so disable checking for lower
// case variable names.
const qo = Fs(Vo, "Use firebase.firestore() instead."), Oo = Fs(go, "Use firebase.firestore().runTransaction() instead."), Uo = Fs(yo, "Use firebase.firestore().batch() instead."), Qo = Fs(bo, "Use firebase.firestore().doc() instead."), Wo = Fs(So), jo = Fs(Do), zo = Fs(Co), Ko = Fs(ko), Go = Fs(No, "Use firebase.firestore().collection() instead."), Ho = {
    Firestore: qo,
    GeoPoint: lt,
    Timestamp: _t,
    Blob: Ls,
    Transaction: Oo,
    WriteBatch: Uo,
    DocumentReference: Qo,
    DocumentSnapshot: Wo,
    Query: zo,
    QueryDocumentSnapshot: jo,
    QuerySnapshot: Ko,
    CollectionReference: Go,
    FieldPath: sr,
    FieldValue: cr,
    setLogLevel: Vo.setLogLevel,
    CACHE_SIZE_UNLIMITED: Ao
};

/**
 * Configures Firestore as part of the Firebase SDK by calling registerService.
 */
function Jo(t) {
    var e;
    t.INTERNAL.registerComponent(new c("firestore", t => {
        const e = t.getProvider("app").getImmediate();
        return new Vo(e, t.getProvider("auth-internal"));
    }, "PUBLIC" /* PUBLIC */).setServiceProps((g((e = Ho) && "object" == typeof e, "shallowCopy() expects object parameter."), 
    Object.assign({}, e))));
}

/**
 * @license
 * Copyright 2019 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class Yo {
    Fd(t) {
        // No-op.
    }
    shutdown() {
        // No-op.
    }
}

/**
 * @license
 * Copyright 2019 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const Xo = "ConnectivityMonitor";

/**
 * Browser implementation of ConnectivityMonitor.
 */ class Zo {
    constructor() {
        this.kw = () => this.Nw(), this.Fw = () => this.$w(), this.xw = [], this.Mw();
    }
    Fd(t) {
        this.xw.push(t);
    }
    shutdown() {
        window.removeEventListener("online", this.kw), window.removeEventListener("offline", this.Fw);
    }
    Mw() {
        window.addEventListener("online", this.kw), window.addEventListener("offline", this.Fw);
    }
    Nw() {
        A(Xo, "Network connectivity changed: AVAILABLE");
        for (const t of this.xw) t(0 /* AVAILABLE */);
    }
    $w() {
        A(Xo, "Network connectivity changed: UNAVAILABLE");
        for (const t of this.xw) t(1 /* UNAVAILABLE */);
    }
    // TODO(chenbrian): Consider passing in window either into this component or
    // here for testing via FakeWindow.
    /** Checks that all used attributes of window are available. */
    static Ho() {
        return "undefined" != typeof window && void 0 !== window.addEventListener && void 0 !== window.removeEventListener;
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Provides a simple helper class that implements the Stream interface to
 * bridge to other implementations that are streams but do not implement the
 * interface. The stream callbacks are invoked with the callOn... methods.
 */ class th {
    constructor(t) {
        this.Lw = t.Lw, this.Bw = t.Bw;
    }
    I_(t) {
        g(!this.qw, "Called onOpen on stream twice!"), this.qw = t;
    }
    f_(t) {
        g(!this.Ow, "Called onClose on stream twice!"), this.Ow = t;
    }
    onMessage(t) {
        g(!this.Uw, "Called onMessage on stream twice!"), this.Uw = t;
    }
    close() {
        this.Bw();
    }
    send(t) {
        this.Lw(t);
    }
    Qw() {
        g(void 0 !== this.qw, "Cannot call onOpen because no callback was set"), this.qw();
    }
    Ww(t) {
        g(void 0 !== this.Ow, "Cannot call onClose because no callback was set"), this.Ow(t);
    }
    jw(t) {
        g(void 0 !== this.Uw, "Cannot call onMessage because no callback was set"), this.Uw(t);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const eh = "Connection", sh = "google.firestore.v1.Firestore", nh = "v1", ih = {
    BatchGetDocuments: "batchGet",
    Commit: "commit"
}, rh = "gl-js/ fire/" + T, oh = 15;

class hh {
    constructor(t) {
        this.o = t.o;
        const e = t.ssl ? "https" : "http";
        this.zw = e + "://" + t.host, this.forceLongPolling = t.forceLongPolling;
    }
    /**
     * Modifies the headers for a request, adding any authorization token if
     * present and any additional headers for the request.
     */    Kw(t, e) {
        if (e) for (const s in e.I) e.I.hasOwnProperty(s) && (t[s] = e.I[s]);
        t["X-Goog-Api-Client"] = rh;
    }
    C_(t, e, s) {
        const n = this.Gw(t);
        return new Promise((i, r) => {
            const o = new l;
            o.listenOnce(_.COMPLETE, () => {
                try {
                    switch (o.getLastErrorCode()) {
                      case d.NO_ERROR:
                        const e = o.getResponseJson();
                        A(eh, "XHR received:", JSON.stringify(e)), i(e);
                        break;

                      case d.TIMEOUT:
                        A(eh, 'RPC "' + t + '" timed out'), r(new $(F.DEADLINE_EXCEEDED, "Request time out"));
                        break;

                      case d.HTTP_ERROR:
                        const s = o.getStatus();
                        if (A(eh, 'RPC "' + t + '" failed with status:', s, "response text:", o.getResponseText()), 
                        s > 0) {
                            const t = o.getResponseJson().error;
                            if (t && t.status && t.message) {
                                const e = function(t) {
                                    const e = t.toLowerCase().replace("_", "-");
                                    return Object.values(F).indexOf(e) >= 0 ? e : F.UNKNOWN;
                                }(t.status);
                                r(new $(e, t.message));
                            } else r(new $(F.UNKNOWN, "Server responded with status " + o.getStatus()));
                        } else 
                        // If we received an HTTP_ERROR but there's no status code,
                        // it's most probably a connection issue
                        A(eh, 'RPC "' + t + '" failed'), r(new $(F.UNAVAILABLE, "Connection failed."));
                        break;

                      default:
                        V('RPC "' + t + '" failed with unanticipated webchannel error ' + o.getLastErrorCode() + ": " + o.getLastError() + ", giving up.");
                    }
                } finally {
                    A(eh, 'RPC "' + t + '" completed.');
                }
            });
            // The database field is already encoded in URL. Specifying it again in
            // the body is not necessary in production, and will cause duplicate field
            // errors in the Firestore Emulator. Let's remove it.
            const h = Object.assign({}, e);
            delete h.database;
            const a = JSON.stringify(h);
            A(eh, "XHR sending: ", n + " " + a);
            // Content-Type: text/plain will avoid preflight requests which might
            // mess with CORS and redirects by proxies. If we add custom headers
            // we will need to change this code to potentially use the
            // $httpOverwrite parameter supported by ESF to avoid
            // triggering preflight requests.
            const u = {
                "Content-Type": "text/plain"
            };
            this.Kw(u, s), o.send(n, "POST", a, u, oh);
        });
    }
    k_(t, e, s) {
        // The REST API automatically aggregates all of the streamed results, so we
        // can just use the normal invoke() method.
        return this.C_(t, e, s);
    }
    R_(t, e) {
        const s = [ this.zw, "/", sh, "/", t, "/channel" ], n = f(), c = {
            // Background channel test avoids the initial two test calls and decreases
            // initial cold start time.
            // TODO(dimond): wenboz@ mentioned this might affect use with proxies and
            // we should monitor closely for any reports.
            backgroundChannelTest: !0,
            // Required for backend stickiness, routing behavior is based on this
            // parameter.
            httpSessionIdParam: "gsessionid",
            initMessageHeaders: {},
            messageUrlParams: {
                // This param is used to improve routing and project isolation by the
                // backend and must be included in every request.
                database: `projects/${this.o.projectId}/databases/${this.o.database}`
            },
            sendRawJson: !0,
            supportsCrossDomainXhr: !0,
            internalChannelParams: {
                // Override the default timeout (randomized between 10-20 seconds) since
                // a large write batch on a slow internet connection may take a long
                // time to send to the backend. Rather than have WebChannel impose a
                // tight timeout which could lead to infinite timeouts and retries, we
                // set it very large (5-10 minutes) and rely on the browser's builtin
                // timeouts to kick in if the request isn't working.
                forwardChannelRequestTimeoutMs: 6e5
            },
            forceLongPolling: this.forceLongPolling
        };
        this.Kw(c.initMessageHeaders, e), 
        // Sending the custom headers we just added to request.initMessageHeaders
        // (Authorization, etc.) will trigger the browser to make a CORS preflight
        // request because the XHR will no longer meet the criteria for a "simple"
        // CORS request:
        // https://developer.mozilla.org/en-US/docs/Web/HTTP/CORS#Simple_requests
        //
        // Therefore to avoid the CORS preflight request (an extra network
        // roundtrip), we use the httpHeadersOverwriteParam option to specify that
        // the headers should instead be encoded into a special "$httpHeaders" query
        // parameter, which is recognized by the webchannel backend. This is
        // formally defined here:
        // https://github.com/google/closure-library/blob/b0e1815b13fb92a46d7c9b3c30de5d6a396a3245/closure/goog/net/rpc/httpcors.js#L32
        //
        // TODO(b/145624756): There is a backend bug where $httpHeaders isn't respected if the request
        // doesn't have an Origin header. So we have to exclude a few browser environments that are
        // known to (sometimes) not include an Origin. See
        // https://github.com/firebase/firebase-js-sdk/issues/1491.
        i() || r() || o() || h() || a() || u() || (c.httpHeadersOverwriteParam = "$httpHeaders");
        const l = s.join("");
        A(eh, "Creating WebChannel: " + l + " " + c);
        const _ = n.createWebChannel(l, c);
        // WebChannel supports sending the first message with the handshake - saving
        // a network round trip. However, it will have to call send in the same
        // JS event loop as open. In order to enforce this, we delay actually
        // opening the WebChannel until send is called. Whether we have called
        // open is tracked with this variable.
                let d = !1, T = !1;
        // A flag to determine whether the stream was closed (by us or through an
        // error/close event) to avoid delivering multiple close events or sending
        // on a closed stream
                const w = new th({
            Lw: t => {
                T ? A(eh, "Not sending because WebChannel is closed:", t) : (d || (A(eh, "Opening WebChannel transport."), 
                _.open(), d = !0), A(eh, "WebChannel sending:", t), _.send(t));
            },
            Bw: () => _.close()
        }), E = (t, e) => {
            // TODO(dimond): closure typing seems broken because WebChannel does
            // not implement goog.events.Listenable
            _.listen(t, t => {
                try {
                    e(t);
                } catch (t) {
                    setTimeout(() => {
                        throw t;
                    }, 0);
                }
            });
        };
        // Closure events are guarded and exceptions are swallowed, so catch any
        // exception and rethrow using a setTimeout so they become visible again.
        // Note that eventually this function could go away if we are confident
        // enough the code is exception free.
                return E(m.EventType.OPEN, () => {
            T || A(eh, "WebChannel transport opened.");
        }), E(m.EventType.CLOSE, () => {
            T || (T = !0, A(eh, "WebChannel transport closed"), w.Ww());
        }), E(m.EventType.ERROR, t => {
            T || (T = !0, A(eh, "WebChannel transport errored:", t), w.Ww(new $(F.UNAVAILABLE, "The operation could not be completed")));
        }), E(m.EventType.MESSAGE, t => {
            var e;
            if (!T) {
                const s = t.data[0];
                g(!!s, "Got a webchannel message without data.");
                // TODO(b/35143891): There is a bug in One Platform that caused errors
                // (and only errors) to be wrapped in an extra array. To be forward
                // compatible with the bug we need to check either condition. The latter
                // can be removed once the fix has been rolled out.
                // Use any because msgData.error is not typed.
                const n = s, i = n.error || (null === (e = n[0]) || void 0 === e ? void 0 : e.error);
                if (i) {
                    A(eh, "WebChannel received error:", i);
                    // error.status will be a string like 'OK' or 'NOT_FOUND'.
                    const t = i.status;
                    let e = function(t) {
                        // lookup by string
                        // eslint-disable-next-line @typescript-eslint/no-explicit-any
                        const e = Oe[t];
                        if (void 0 !== e) return He(e);
                    }(t), s = i.message;
                    void 0 === e && (e = F.INTERNAL, s = "Unknown error status: " + t + " with message " + i.message), 
                    // Mark closed so no further events are propagated
                    T = !0, w.Ww(new $(e, s)), _.close();
                } else A(eh, "WebChannel received:", s), w.jw(s);
            }
        }), setTimeout(() => {
            // Technically we could/should wait for the WebChannel opened event,
            // but because we want to send the first message with the WebChannel
            // handshake we pretend the channel opened here (asynchronously), and
            // then delay the actual open until the first message is sent.
            w.Qw();
        }, 0), w;
    }
    // visible for testing
    Gw(t) {
        const e = ih[t];
        return g(void 0 !== e, "Unknown REST mapping for: " + t), this.zw + "/" + nh + "/projects/" + this.o.projectId + "/databases/" + this.o.database + "/documents:" + e;
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * This code needs to run before Firestore is used. This can be achieved in
 * several ways:
 *   1) Through the JSCompiler compiling this code and then (automatically)
 *      executing it before exporting the Firestore symbols.
 *   2) Through importing this module first in a Firestore main module
 */
Ns._r(new class {
    constructor() {
        this.dr = "undefined" != typeof atob;
    }
    get document() {
        return "undefined" != typeof document ? document : null;
    }
    get window() {
        return "undefined" != typeof window ? window : null;
    }
    bT(t) {
        return Promise.resolve(new hh(t));
    }
    ST() {
        return Zo.Ho() ? new Zo : new Yo;
    }
    DT(t) {
        return new ks(t, {
            ti: !0
        });
    }
    s(t) {
        return JSON.stringify(t);
    }
    atob(t) {
        return atob(t);
    }
    btoa(t) {
        return btoa(t);
    }
});

const ah = "@firebase/firestore", uh = "1.11.1";

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
function ch(t) {
    Jo(t), t.registerVersion(ah, uh);
}

ch(t);

export { ch as __PRIVATE_registerFirestore };
//# sourceMappingURL=index.esm2017.js.map
